unit GraphicStrings;

// This file is part of the image library GraphicEx (www.lischke-online.de/Graphics.html).
//
// GraphicStrings contains the strings used in GraphicEx which could be localized.
// Rename the file to GraphicStrings.pas to use it as your favourite language file.
//
// This is the russian version of GraphicStrings.
//
// (c) Copyright 1999, 2000  Dipl. Ing. Mike Lischke (public@lischke-online.de). All rights reserved.
// Translation done by Alexander S. Tereschenko (tereschenko@bigfoot.com)
//
// This package is freeware for non-commercial use only.
// Contact author for licenses (shareware@lischke-online.de) and see License.txt which comes with the package.

interface

{$I GraphicConfiguration.inc}

resourcestring
  // image file descriptions
  gesAllImages = ' ';
  gesRegistration = '  %s  ().';
  
  gesBitmaps = 'Windows  ';
  gesRLEBitmaps = 'Run length    Windows';
  gesDIBs = '  Windows,   ';
  gesIcons = ' Windows';
  gesMetaFiles = ' Windows';
  gesEnhancedMetaFiles = '  Windows';
  gesJPGImages = ' JPG';
  gesJPEGImages = ' JPEG';
  gesTruevision = ' Truevision';
  gesTIFF = '  TIFF';
  gesMacTIFF =  ' TIFF  Macintosh';
  gesPCTIF = 'PC TIF ';
  gesGFIFax = 'GFI fax images';
  gesSGI = ' SGI';
  gesSGITrueColor = '  SGI';
  gesZSoft = ' ZSoft Paintbrush';
  gesZSoftWord = '  Word 5.x';
  gesAliasWaveFront = ' Alias/Wavefront';
  gesSGITrueColorAlpha = '  SGI  -';
  gesSGIMono = '׸-  SGI';
  gesPhotoshop = ' Photoshop';
  gesPortable = ' Portable map';
  gesPortablePixel = ' Portable pixel map';
  gesPortableGray = ' Portable gray map';
  gesPortableMono = ' Portable bitmap';
  gesAutoDesk = ' Autodesk';
  gesKodakPhotoCD = ' Kodak Photo-CD';
  gesCompuserve = ' CompuServe';
  gesHalo = ' Dr. Halo';
  gesPaintShopPro = ' Paintshop Pro';
  gesPortableNetworkGraphic = ' Portable network graphic (PNG)';

  // image specific error messages
  gesInvalidImage = '  .      %s.';
  gesInvalidColorFormat = '     %s.';
  gesStreamReadError = '      %s.';
  gesUnsupportedImage = '  .    %s.';
  gesUnsupportedFeature = '  . %s     %s.';
  gesInvalidCRC = '  .  CRC    %s.';
  gesCompression = '  .     %s.';
  gesExtraCompressedData = '  .      %s.';
  gesInvalidPalette = '  .     %s.';

  // features (usually used together with unsupported feature string)
  gesCompressionScheme = '  ';
  gesPCDImageSize = ' ,   Base16, Base4 or Base ';
  gesRLAPixelFormat = ' ,   RGB and RGBA ';
  gesPSPFileType = '  ,   3  4 ';

  // errors which apply only to specific image types
  gesUnknownCriticalChunk = '   PNG.  ,   .';

  // color manager error messages
  gesIndexedNotSupported = '    -    .';
  gesConversionUnsupported = '   .     .';
  gesInvalidSampleDepth = '  .    : 1, 2, 4, 8, or 16.';
  gesInvalidPixelDepth = '         .';

//----------------------------------------------------------------------------------------------------------------------

implementation

//----------------------------------------------------------------------------------------------------------------------

end.
