{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_arbre;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, dxorgchr, contnrs, Ibquery, Menus, db,
  TFlatRadioButtonUnit, StdCtrls, ExtCtrls, ComCtrls, TFlatCheckBoxUnit,
  dxCntner, dxEditor, dxExEdtr, dxEdLib, u_comp_TYLanguage, IBCustomDataSet;

type
  TMyPopupMenu = class(TPopupMenu)

  public
    property PopupPoint;
  end;


  TIndividu = class
  private
    fCleFiche: integer;
    fLevel: integer;
    fChilds: TObjectList;
    fNom: string;
    fPrenom: string;
    fCleMere: integer;
    fClePere: integer;
    fDeces: string;
    fNaissance: string;
    fProf: string;
    fSexe: integer;
    // fPhoto: tblobfield;
    procedure OrdreHommeFemme;

  protected

  public

    constructor Create;
    destructor Destroy; override;
    procedure Clear;

    procedure AddToArbre(aArbre: TdxOrgChart; aNodePere: TdxOcNode);

    property CleFiche: integer read fCleFiche write fCleFiche;
    property Nom: string read fNom write fNom;
    property Prenom: string read fPrenom write fPrenom;
    property Prof: string read fProf write fProf;
    property Naissance: string read fNaissance write fNaissance;
    property Deces: string read fDeces write fDeces;

    property Sexe: integer read fSexe write fSexe;

    property Level: integer read fLevel write fLevel;
    property Childs: TObjectList read fChilds write fChilds;

    property ClePere: integer read fClePere write fClePere;
    property CleMere: integer read fCleMere write fCleMere;
    //property Photo: TBlobField read fPhoto write fPhoto;
  end;

  TFArbre = class(TSuperForm)
    oc: TdxOrgChart;
    pmArbre: TPopupMenu;
    Panel10: TPanel;
    frbHorizontal: TFlatRadioButton;
    FlatRadioButton2: TFlatRadioButton;
    cbZoom: TFlatCheckBox;
    lNom: TLabel;
    dxsGenerations: TdxSpinEdit;
    Label1: TLabel;
    frbVertical: TFlatRadioButton;
    option_OpenFiche: TMenuItem;
    option_OpenFicheInBox: TMenuItem;
    Label8: TLabel;
    N1: TMenuItem;
    option_StartWithThisIndi: TMenuItem;
    Language: TYLanguage;
    IBQEnfants: TIBQuery;
    IBQEnfantsCLE_FICHE: TIntegerField;
    IBQEnfantsNOM: TIBStringField;
    IBQEnfantsPRENOM: TIBStringField;
    IBQEnfantsSEXE: TIntegerField;
    IBQEnfantsDATE_NAISSANCE: TIBStringField;
    IBQEnfantsDATE_DECES: TIBStringField;
    IBQEnfantsKLE_DOSSIER: TIntegerField;
    IBQEnfantsSOSA: TFloatField;
    IBQEnfantsPHOTO: TBlobField;
    IBQEnfantsVILLE_NAISS: TIBStringField;
    IBQEnfantsVILLE_DECES: TIBStringField;
    IBQEnfantsANNEE: TIntegerField;
    lHint: TLabel;
    cbDescendance: TFlatCheckBox;
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure ocDrawNode(Sender: TObject; Node: TdxOcNode; ACanvas: TCanvas; Rect: TRect);
    procedure frbHorizontalClick(Sender: TObject);
    procedure cbZoomClick(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure dxsGenerationsChange(Sender: TObject);
    procedure frbVerticalClick(Sender: TObject);
    procedure pmArbrePopup(Sender: TObject);
    procedure option_OpenFicheClick(Sender: TObject);
    procedure option_OpenFicheInBoxClick(Sender: TObject);
    procedure SuperFormActivate(Sender: TObject);
    procedure option_StartWithThisIndiClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure cbDescendanceClick(Sender: TObject);
    procedure ocMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  private
    fStartIndividu: TIndividu;
    fAll: TObjectList;
    fCleIndiDepart: integer;

    fFormIndividu: TForm;
    procedure SetFormIndividu(const Value: TForm);
    function GetIndividuByClePere(ClePere: integer): TIndividu;
    function GetIndividuByCleMere(CleMere: integer): TIndividu;
    function GetPere(Clef: integer): TIndividu;
    procedure CreationArbre;

    procedure Charge_Arbre;
    procedure doTellToOpenIndividuAndClose;
    procedure OnSelectIndividu(Sender: TObject);
    procedure doDescedance;

  public
    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;
    property CleIndiDepart: integer read fCleIndiDepart write fCleIndiDepart;
    procedure Init_Arbre;
    procedure doInitialize;


    function GetCleFicheSelected: integer;
    function GetNomFicheSelected: string;
  end;

implementation

uses u_dm, u_common_var, u_form_individu, u_common_func, u_common_const,
  u_objet_TContext;

{$R *.DFM}

procedure TFArbre.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;
end;

procedure TFArbre.Init_Arbre;
begin

  if fFormIndividu = nil then
    begin
      fCleIndiDepart := dm.FicheActive;
      dxsGenerations.Value := _Context.ArbreReduit;
      frbVertical.Checked := True;
    end
  else
    begin
      fCleIndiDepart := TFIndividu(fFormIndividu).CleFiche;
      dxsGenerations.Value := _Context.ArbreReduit;
      frbHorizontal.Checked := True;
    end;

  //cbDescendance.Checked := False;
  frbHorizontal.Checked := True;
  Charge_Arbre;
end;

procedure TFArbre.Charge_Arbre;
var
  n, level, CleFiche: integer;
  indi, indiParent: TIndividu;
  Q: TIBQuery;
begin

  fAll.Clear;
  fStartIndividu.Clear;

  //celui de dpart
  fAll.Add(fStartIndividu);

  //On charge les individus
  Q := TIBQuery.Create(nil);
  try
    Q.DisableControls;
    Q.Database := dm.ibd_BASE;
    Q.SQL.Clear;

    Q.SQL.Add('select * from PROC_ARBRE_EXPORT(:INDI, :GENE, :DOSSIER, 0)');

    Q.Params[0].AsInteger := fCleIndiDepart;
    Q.Params[1].AsString := dxsGenerations.Text;
    Q.Params[2].AsInteger := dm.NumDossier;

    Q.Open;
    Q.last;
    Q.first;

    for n := 1 to Q.RecordCount do
      begin
        Level := Q.FieldByName('NIVEAU').AsInteger;
        CleFiche := Q.FieldByName('CLE_FICHE').AsInteger;

        if level = 0 then
          begin
            indi := fStartIndividu;
            indiParent := nil;
          end
        else
          begin
            //le sexe ne peut-tre que 1 ou 2
            if Q.FieldByName('SEXE').AsInteger = 1
              then indiParent := GetIndividuByClePere(CleFiche)
            else indiParent := GetIndividuByCleMere(CleFiche);

            if indiParent <> nil then
              begin
                indi := TIndividu.create;
                fAll.Add(indi);
              end
            else indi := nil;

          end;

        if indi <> nil then
          begin
            //1=Homme, 2=Femme
            indi.Sexe := Q.FieldByName('SEXE').AsInteger;

            indi.CleFiche := CleFiche;
            indi.level := level;
            indi.ClePere := Q.FieldByName('CLE_PERE').AsInteger;
            indi.CleMere := Q.FieldByName('CLE_MERE').AsInteger;
            indi.Nom := Q.FieldByName('NOM').AsString;
            indi.Prof := Q.FieldByName('OCCUPATION').AsString;
            indi.Prenom := Q.FieldByName('PRENOM').AsString;
            indi.Naissance := Q.FieldByName('DATE_NAISSANCE').AsString;
            indi.Deces := Q.FieldByName('DATE_DECES').AsString;

            if indiParent <> nil then
              begin
                indiParent.Childs.Add(indi);
              end;
          end;

        Q.next;
      end;

  finally
    Q.EnableControls;
    Q.Free;
  end;

  //on s'assure que les hommes sont  droite, et les femmes  gauche
  fStartIndividu.OrdreHommeFemme;

  //Create
  CreationArbre;

  if fFormIndividu = nil
    then lNom.Caption := CoupeChaine(AssembleString([fStartIndividu.Nom, fStartIndividu.Prenom]), lNom);
end;

procedure TFArbre.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fCleIndiDepart := -1;

  fStartIndividu := TIndividu.create;
  fAll := TObjectList.create(false);

  if _Context.ArbreHorizontal then
    begin
      frbHorizontal.Checked := true;
      oc.Rotated := True;
    end
  else
    begin
      frbVertical.Checked := true;
      oc.Rotated := False;
    end;
end;

procedure TFArbre.SuperFormDestroy(Sender: TObject);
begin
  fStartIndividu.free;
  fAll.free;
end;

procedure TIndividu.Clear;
begin
  fCleFiche := -1;
  fLevel := 0;
  fNom := '';
  fPrenom := '';
  fProf := '';
  fDeces := '';
  fNaissance := '';
  fSexe := -1;
  //fPhoto := nil;

  fCleMere := -1;
  fClePere := -1;

  fChilds.Clear;
end;

constructor TIndividu.Create;
begin
  fChilds := TObjectList.create(true);
  Clear;
end;

destructor TIndividu.Destroy;
begin
  fChilds.Free;

  inherited Destroy;
end;

procedure TIndividu.OrdreHommeFemme;
var
  n: integer;
begin
  case fChilds.count of
    2: begin
        if TIndividu(fChilds[0]).Sexe = 2 then //homme
          begin
            //invertion
            fChilds.Exchange(0, 1);
          end;
      end;
  end;

  //on ordonne les suivants
  for n := 0 to fChilds.count - 1 do TIndividu(fChilds[n]).OrdreHommeFemme;
end;


function TFArbre.GetIndividuByClePere(ClePere: integer): TIndividu;
var
  n: integer;
begin
  result := nil;
  for n := 0 to fAll.count - 1 do
    begin
      if TIndividu(fAll[n]).ClePere = ClePere then
        begin
          result := TIndividu(fAll[n]);
          break;
        end;
    end;
end;

function TFArbre.GetPere(Clef: integer): TIndividu;
var
  n: integer;
begin
  result := nil;
  for n := 0 to fAll.count - 1 do
    begin
      if TIndividu(fAll[n]).CleFiche = Clef then
        begin
          result := TIndividu(fAll[n]);
          break;
        end;
    end;
end;

function TFArbre.GetIndividuByCleMere(CleMere: integer): TIndividu;
var
  n: integer;
begin
  result := nil;
  for n := 0 to fAll.count - 1 do
    begin
      if TIndividu(fAll[n]).CleMere = CleMere then
        begin
          result := TIndividu(fAll[n]);
          break;
        end;
    end;
end;

procedure TFArbre.CreationArbre;
begin
  if _Context.ColorHomme <> clWhite and _Context.ColorFemme then
    oc.Font.Color := clWhite;

  oc.Font.Color := clBlack;

  oc.Clear;
  fStartIndividu.AddToArbre(oc, nil);
  oc.FullExpand;

end;

procedure TIndividu.AddToArbre(aArbre: TdxOrgChart; aNodePere: TdxOcNode);
var
  n: integer;
  node: TdxOcNode;
begin
  node := aArbre.AddChild(aNodePere, self);
  node.Text := fPrenom;

  if fSexe = 1 then
    node.Color := $00F6CA92 //_Context.ColorHomme
  else
    begin
      node.Color := $00B5A7F2; //_Context.ColorFemme;
      //node.Shape := shRoundRect;
    end;

  for n := 0 to fChilds.count - 1 do TIndividu(fChilds[n]).AddToArbre(aArbre, node);

end;

procedure TFArbre.ocDrawNode(Sender: TObject; Node: TdxOcNode; ACanvas: TCanvas; Rect: TRect);
var
  R: TRect;
  s, sPrenom: string;
  y: integer;
begin
  if Node.Data <> nil then
    begin
      R := Rect;
      aCanvas.Brush.Style := bsClear;
      aCanvas.TextRect(Rect, Rect.left + 2, Rect.top, TIndividu(Node.Data).Nom);

      sPrenom := TIndividu(Node.Data).PreNom;
      if Length(sPrenom) > 0 then
        begin
          if Length(sPrenom) > 25 then
            sPrenom := Copy(sPrenom, 0, 25) + '...';
        end;

      aCanvas.TextRect(Rect, Rect.left + 2, Rect.top + 15, sPrenom);
      y := Rect.Top + 30;

      s := trim(TIndividu(Node.Data).Naissance);
      if s <> '' then
        begin
          s := ' ' + s;
          aCanvas.TextRect(Rect, Rect.left + 2, y, s);
          y := y + 15;
        end;

      s := trim(TIndividu(Node.Data).Deces);
      if s <> '' then
        begin
          s := '+ ' + s;
          aCanvas.TextRect(Rect, Rect.left + 2, y, s);
        end;
    end;

  //  Node.ChildAlign := caright;
end;

procedure TFArbre.frbHorizontalClick(Sender: TObject);
begin
  oc.Rotated := True;
end;

procedure TFArbre.cbZoomClick(Sender: TObject);
begin
  Oc.Zoom := not cbZoom.Checked;
end;

procedure TFArbre.doInitialize;
begin
  oc.Clear;
  fAll.Clear;
  fStartIndividu.Clear;
end;


function TFArbre.GetCleFicheSelected: integer;
var
  indi: TIndividu;
begin
  result := -1;

  //on rcupre le node slectionn
  if oc.selected <> nil then
    begin
      indi := TIndividu(oc.selected.data);
      result := indi.CleFiche;
    end;
end;


function TFArbre.GetNomFicheSelected: string;
var
  indi: TIndividu;
begin
  result := '';

  //on rcupre le node slectionn
  if oc.selected <> nil then
    begin
      indi := TIndividu(oc.selected.data);
      result := AssembleString([Indi.Nom, Indi.Prenom])
    end;
end;

procedure TFArbre.SuperFormShowFirstTime(Sender: TObject);
begin
  if fFormIndividu = nil then oc.Options := oc.Options - [ocSelect]
  else oc.Options := oc.Options + [ocSelect];

  doRefreshControls;
end;

procedure TFArbre.dxsGenerationsChange(Sender: TObject);
begin
  if (dxsGenerations.Text = '') or (StrToInt(dxsGenerations.Text) = 0) then dxsGenerations.Value := 1;
  if StrToInt(dxsGenerations.Text) > 30 then dxsGenerations.Value := 30;

  if cbDescendance.Checked then
    doDescedance
  else
    Charge_Arbre;

end;

procedure TFArbre.frbVerticalClick(Sender: TObject);
begin
  oc.Rotated := False;
end;

procedure TFArbre.pmArbrePopup(Sender: TObject);
var
  Node: TdxOcNode;
  indi: TIndividu;
  P: Tpoint;
  NewItem: TMenuItem;
  n, i_Count: Integer;
  sNom: string;
begin
  pmArbre.Items.Clear;

  NewItem := TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Name := 'option_StartWithThisIndi';
  NewItem.Caption := 'Dmarrer l''arbre  partir de cet individu';
  NewItem.Onclick := option_StartWithThisIndiClick;

  NewItem := TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Caption := '-';

  NewItem := TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Name := 'option_OpenFiche';
  NewItem.Caption := 'Ouvrir la fiche';
  NewItem.ImageIndex := 49;
  NewItem.Onclick := option_OpenFicheClick;

  NewItem := TMenuItem.create(self);
  pmArbre.Items.Add(NewItem);
  NewItem.Name := 'option_OpenFicheInBox';
  NewItem.Caption := 'Ouvrir la fiche dans une autre fentre ...';
  NewItem.Onclick := option_OpenFicheInBoxClick;

  option_OpenFiche.visible := false;
  option_OpenFicheInBox.visible := false;

  P := oc.ScreenToClient(TMyPopupMenu(pmArbre).PopupPoint);

  if (htOnRect in oc.GetHitTestsAt(P.X, P.Y)) then
    begin
      Node := oc.GetNodeAt(P.X, P.Y);
      if Node <> nil then
        begin
          indi := TIndividu(Node.Data);

          option_StartWithThisIndi.Tag := indi.CleFiche;
          option_OpenFiche.Tag := indi.CleFiche;
          option_OpenFicheInBox.Tag := indi.CleFiche;

          option_StartWithThisIndi.enabled := indi.CleFiche <> fCleIndiDepart;
          option_OpenFiche.visible := true;
          option_OpenFicheInBox.visible := true;

          begin
            with IBQEnfants do
              begin
                DisableControls;
                Close;
                //passage des parametres ---
                if indi.Sexe = 1 then
                  begin
                    Params[0].AsInteger := indi.CleFiche;
                    Params[1].AsInteger := 0;
                  end
                else
                  begin
                    Params[0].AsInteger := 0;
                    Params[1].AsInteger := indi.CleFiche;
                  end;

                Params[2].AsInteger := dm.NumDossier;
                Open;

                //{oblig de faire ca pour compter les enregs ---
                Last;
                //{----------------------------------------------

                i_Count := RecordCount;

                //si rien , on sort -------
                if i_Count <= 0 then
                  begin
                    close;
                    exit;
                  end;

                First;

                for n := 1 to i_Count do
                  begin
                    if n = 1 then
                      begin
                        NewItem := TMenuItem.create(self);
                        pmArbre.Items.Add(NewItem);
                        NewItem.Caption := '-';
                      end;

                    sNom := AssembleString([
                      FieldByName('NOM').AsString,
                        FieldByName('PRENOM').AsString]);

                    NewItem := TMenuItem.create(self);
                    pmArbre.Items.Add(NewItem);
                    NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                    NewItem.Caption := sNom;
                    NewItem.Onclick := OnSelectIndividu;

                    if FieldByName('SEXE').AsInteger = 1 then
                      NewItem.ImageIndex := 39
                    else
                      NewItem.ImageIndex := 38;

                    Next
                  end;
                Close;
                EnableControls; ;
              end;
          end;
        end;
    end;
end;

procedure TFArbre.option_OpenFicheClick(Sender: TObject);
begin
  if fFormIndividu <> nil then
    begin
      TFIndividu(fFormindividu).doOpenFiche(TMenuItem(Sender).Tag);
    end
  else
    begin
      dm.FicheActive := TMenuItem(Sender).Tag;
      doTellToOpenIndividuAndClose;
    end;
end;

procedure TFArbre.option_OpenFicheInBoxClick(Sender: TObject);
begin
  OpenFicheIndividuInBox(TMenuItem(Sender).Tag);
end;

procedure TFArbre.SuperFormActivate(Sender: TObject);
begin
  if _Context.AnimArbre
    then oc.Options := oc.Options + [ocAnimate]
  else oc.Options := oc.Options - [ocAnimate];


end;

procedure TFArbre.doTellToOpenIndividuAndClose;
begin
  AutoFreeOnClose := true;
  DoSendMessage(Owner, 'OPEN_FICHE_INDIVIDU_FROM_ARBRE');
  Close;
end;


procedure TFArbre.option_StartWithThisIndiClick(Sender: TObject);
begin
  fCleIndiDepart := TMenuItem(Sender).Tag;
  Charge_Arbre;
end;

procedure TFArbre.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    _KEY_HELP: dm.ShowHelp(_ID_ANNIVERSAIRE);
  end;
end;

procedure TFArbre.OnSelectIndividu(Sender: TObject);
{
Action a faire lors d'un click sur un des
boutons ou menu popup
}
begin
  if fFormIndividu <> nil then
    begin
      TFIndividu(fFormindividu).doOpenFiche(TMenuItem(Sender).Tag);
    end
  else
    begin
      dm.FicheActive := TMenuItem(Sender).Tag;
      doTellToOpenIndividuAndClose;
    end;
end;


procedure TFArbre.SuperFormRefreshControls(Sender: TObject);
begin
  oc.Options := [ocButtons, ocDblClick, ocRect3D];

  with IBQEnfants do
    begin

      Close;
      //passage des parametres ---
      Params[0].AsInteger := fCleIndiDepart;
      Params[1].AsInteger := 0;
      Params[2].AsInteger := dm.NumDossier;
      Open;

      //{oblig de faire ca pour compter les enregs ---
      Last;
      //{----------------------------------------------

      //cbDescendance.Enabled := RecordCount > 0;
      Close;
    end;
end;

procedure TFArbre.doDescedance;
var
  n, level, CleFiche: integer;
  indi, indiParent: TIndividu;
  Q: TIBQuery;
begin

  fAll.Clear;
  fStartIndividu.Clear;

  //celui de dpart
  fAll.Add(fStartIndividu);

  //On charge les individus
  Q := TIBQuery.Create(nil);
  try
    Q.DisableControls;
    Q.Database := dm.ibd_BASE;
    Q.SQL.Clear;

    Q.SQL.Add('select * from PROC_DESCENDANCE(:INDI, :GENE, :DOSSIER) ORDER BY NIVEAU, SOSA');

    Q.Params[0].AsInteger := fCleIndiDepart;
    Q.Params[1].AsString := dxsGenerations.Text;
    Q.Params[2].AsInteger := dm.NumDossier;

    Q.Open;
    Q.last;
    Q.first;

    for n := 1 to Q.RecordCount do
      begin
        Level := Q.FieldByName('NIVEAU').AsInteger;
        CleFiche := Q.FieldByName('CLE_FICHE').AsInteger;

        if level = 1 then
          begin
            indi := fStartIndividu;
            indiParent := nil;
          end
        else
          begin
            //le sexe ne peut-tre que 1 ou 2

            indiParent := GetPere(Q.FieldByName('CLE_PERE').AsInteger);
            if indiparent = nil then indiParent := GetPere(Q.FieldByName('CLE_MERE').AsInteger);

            if Level <> 0 then
              begin
                indi := TIndividu.create;
                fAll.Add(indi);
              end
            else indi := nil;

          end;

        if indi <> nil then
          begin
            //1=Homme, 2=Femme
            indi.Sexe := Q.FieldByName('SEXE').AsInteger;

            indi.CleFiche := CleFiche;
            indi.level := level;
            indi.ClePere := Q.FieldByName('CLE_PERE').AsInteger;
            indi.CleMere := Q.FieldByName('CLE_MERE').AsInteger;
            indi.Nom := Q.FieldByName('NOM').AsString;
            indi.Prenom := Q.FieldByName('PRENOM').AsString;
            indi.Naissance := Q.FieldByName('DATE_NAISSANCE').AsString;
            indi.Deces := Q.FieldByName('DATE_DECES').AsString;

            if indiParent <> nil then
              begin
                indiParent.Childs.Add(indi);
              end;
          end;

        Q.next;
      end;

  finally
    Q.EnableControls;
    Q.Free;
  end;

  //on s'assure que les hommes sont  droite, et les femmes  gauche
  fStartIndividu.OrdreHommeFemme;

  //Create
  CreationArbre;

  if fFormIndividu = nil
    then lNom.Caption := CoupeChaine(AssembleString([fStartIndividu.Nom, fStartIndividu.Prenom]), lNom);
end;

procedure TFArbre.cbDescendanceClick(Sender: TObject);
begin

  if cbDescendance.Checked then
    begin
      oc.Rotated := False;
      frbVertical.Checked := True;
      dxsGenerations.Value := 6;
      doDescedance;
    end
  else
    begin
      oc.Rotated := True;
      frbHorizontal.Checked := True;
      dxsGenerations.Value := _Context.ArbreReduit;
      Charge_Arbre;
    end;

end;

procedure TFArbre.ocMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Node: TdxOcNode;
  indi: TIndividu;
begin

  if (htOnRect in oc.GetHitTestsAt(X, Y)) then
    begin
      Node := oc.GetNodeAt(X, Y);
      if Node <> nil then
        begin
          indi := TIndividu(Node.Data);
          if lHint.Caption <> indi.Nom + ', ' + indi.Prenom then
            begin
              if indi.Sexe = 1 then
                lHint.Font.Color := _Context.ColorHomme
              else
                lHint.Font.Color := _Context.ColorFemme;

              lHint.Caption := indi.Nom + ', ' + indi.Prenom;
            end;
        end;
    end
  else
    lHint.Caption := '';

end;

end.

