{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_navigation;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, Buttons, StdCtrls, TFlatSpeedButtonUnit,
  Menus, Db, IBCustomDataSet, IBQuery, RVScroll, RichView, RVStyle,
  u_objet_TIntegerList, ImgList, u_comp_TYLanguage,
  DynamicSkinForm;

type
  TFNavigation = class(TSuperForm)
    pBorder: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    btnFreresSoeurs: TFlatSpeedButton;
    btnOnclesTantes: TFlatSpeedButton;
    btnFils: TFlatSpeedButton;
    btnFilles: TFlatSpeedButton;
    btnCousinsCousines: TFlatSpeedButton;
    btnPere: TFlatSpeedButton;
    btnMere: TFlatSpeedButton;
    btnGrandPere_Paternel: TFlatSpeedButton;
    btnGrandPere_Maternel: TFlatSpeedButton;
    btnGrandMere_Paternel: TFlatSpeedButton;
    btnGrandMere_Maternel: TFlatSpeedButton;
    popup_OnclesTantes: TPopupMenu;
    popup_CousinsCousines: TPopupMenu;
    popup_FreresSoeurs: TPopupMenu;
    popup_Fils: TPopupMenu;
    popup_Filles: TPopupMenu;
    DSAscendant: TDataSource;
    IBQAscendant: TIBQuery;
    btnConjoints: TFlatSpeedButton;
    popup_Conjoints: TPopupMenu;
    btnFemme: TImage;
    btnHomme: TImage;
    imgDoExpandForm: TImage;
    imgDoColapseForm: TImage;
    Panel5: TPanel;
    rv: TRichView;
    RVStyle1: TRVStyle;
    ImageList1: TImageList;
    Language: TYLanguage;
    lEnfants: TLabel;
    Image1: TImage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SuperFormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SuperFormShow(Sender: TObject);
    procedure btnOnclesTantesClick(Sender: TObject);
    procedure btnIndividuClick(Sender: TObject);
    procedure btnCousinsCousinesClick(Sender: TObject);
    procedure btnFreresSoeursClick(Sender: TObject);
    procedure btnFilsClick(Sender: TObject);
    procedure btnFillesClick(Sender: TObject);
    procedure btnConjointsClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure imgDoExpandFormClick(Sender: TObject);
    procedure imgDoColapseFormClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure rvJump(Sender: TObject; id: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fFirstShow: boolean;
    fHeightFormNotExpanded: integer;
    fLastHeightFormExpanded: integer;
    fFormExpanded: boolean;

    //
    fIndiNom: TStringList;
    fIndiPrenom: TStringList;
    fIndiSexe: TIntegerList;
    fIndiDateNaissance: TStringList;
    fIndiDateDeces: TStringList;
    fIndiSosa: TIntegerList;
    fIndiNiveau: TIntegerList;
    fIndiCle: TIntegerList;
    fIndiJumpTag: TIntegerList;
    fCallingOpenFicheFromMe: boolean;

    procedure OnSelectIndividu(Sender: TObject);
    procedure ShowIndividu(aTag: integer);
    procedure SetFormExpanded(const Value: boolean);
    procedure PrepareMemoIndividu;

  public

    procedure LoadPeopleArroundIndividu(aCLE_FICHE_INDIVIDU: integer);
    property FirstShow: boolean read fFirstShow write fFirstShow;
    property FormExpanded: boolean read fFormExpanded write SetFormExpanded;
    property CallingOpenFicheFromMe: boolean read fCallingOpenFicheFromMe write fCallingOpenFicheFromMe;
  end;

implementation

uses u_dm, u_form_main, u_common_func, u_common_var, u_common_const;

{$R *.DFM}

procedure TFNavigation.pTopMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFNavigation.SuperFormCreate(Sender: TObject);
begin

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fCallingOpenFicheFromMe := false;

  fFirstShow := true;
  fFormExpanded := false;
  fLastHeightFormExpanded := 405;

  btnGrandPere_Paternel.color := $00E1EAEB;
  btnGrandMere_Paternel.color := $00E1EAEB;
  btnGrandPere_Maternel.color := $00E1EAEB;
  btnGrandMere_Maternel.color := $00E1EAEB;
  btnPere.color := $00E1EAEB;
  btnMere.color := $00E1EAEB;
  btnFils.color := $00E1EAEB;
  btnFilles.color := $00E1EAEB;

  btnFemme.Visible := False;
  btnHomme.Visible := False;


  fIndiNom := TStringList.create;
  fIndiPrenom := TStringList.create;
  fIndiSexe := TIntegerList.create;
  fIndiDateNaissance := TStringList.create;
  fIndiDateDeces := TStringList.create;
  fIndiSosa := TIntegerList.create;
  fIndiNiveau := TIntegerList.create;
  fIndiCle := TIntegerList.create;
  fIndiJumpTag := TIntegerList.create;

  DoRefreshControls;
end;

procedure TFNavigation.SpeedButton2Click(Sender: TObject);
begin
  IBQAscendant.Close;
  Hide;
end;

procedure TFNavigation.SuperFormShow(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 209;
      ClientWidth := 368;
    end;

  if fFirstShow then
    begin
      fHeightFormNotExpanded := Height;
    end;

  //btnCousinsCousines.Visible := dm.NbInd <= _Context.MaxIndPourNaviguer;
  //btnOnclesTantes.Visible := dm.NbInd <= _Context.MaxIndPourNaviguer;
  btnCousinsCousines.Visible := _Context.RefreshCousins;
  btnOnclesTantes.Visible := _Context.RefreshCousins;

  fFirstShow := false;

end;

procedure TFNavigation.btnIndividuClick(Sender: TObject);
begin
  OnSelectIndividu(Sender);
end;

procedure TFNavigation.btnOnclesTantesClick(Sender: TObject);
var
  p: tpoint;
begin
  p.x := 0; p.y := 0;
  p := TControl(Sender).clienttoscreen(p);
  popup_OnclesTantes.popup(p.x, p.y + btnOnclesTantes.height);
end;

procedure TFNavigation.btnCousinsCousinesClick(Sender: TObject);
var
  p: tpoint;
begin
  p.x := 0; p.y := 0;
  p := TControl(Sender).clienttoscreen(p);
  popup_CousinsCousines.popup(p.x, p.y + btnCousinsCousines.height);
end;

procedure TFNavigation.btnFreresSoeursClick(Sender: TObject);
var
  p: tpoint;
begin
  p.x := 0; p.y := 0;
  p := TControl(Sender).clienttoscreen(p);
  popup_FreresSoeurs.popup(p.x, p.y + btnFreresSoeurs.height);
end;

procedure TFNavigation.btnConjointsClick(Sender: TObject);
var
  p: tpoint;
begin
  p.x := 0; p.y := 0;
  p := TControl(Sender).clienttoscreen(p);
  popup_Conjoints.popup(p.x, p.y + btnConjoints.height);
end;

procedure TFNavigation.btnFilsClick(Sender: TObject);
var
  p: tpoint;
begin
  p.x := 0; p.y := 0;
  p := TControl(Sender).clienttoscreen(p);
  popup_Fils.popup(p.x, p.y + btnFils.height);
end;

procedure TFNavigation.btnFillesClick(Sender: TObject);
var
  p: tpoint;
begin
  p.x := 0; p.y := 0;
  p := TControl(Sender).clienttoscreen(p);
  popup_Filles.popup(p.x, p.y + btnFilles.height);
end;

procedure TFNavigation.LoadPeopleArroundIndividu(aCLE_FICHE_INDIVIDU: integer);
var
  n: integer;
  NewItem: TMenuItem;
  i_Count: SmallInt;
  i_Niveau: SmallInt;
  s_Nom, s_Hint: string;
  s_Naiss, s_Deces: string;

const
  crlr = #13#10;
begin
  btnFemme.Visible := False;
  btnHomme.Visible := False;

  btnPere.Enabled := False;
  btnMere.Enabled := False;
  btnGrandPere_Paternel.Enabled := False;
  btnGrandMere_Paternel.Enabled := False;
  btnGrandPere_Maternel.Enabled := False;
  btnGrandMere_Maternel.Enabled := False;
  btnOnclesTantes.Enabled := False;
  btnFreresSoeurs.Enabled := False;
  btnFils.Enabled := False;
  btnFilles.Enabled := False;
  btnCousinsCousines.Enabled := False;
  btnConjoints.Enabled := False;

  //branchement des grand-parents paternel
  btnGrandPere_Paternel.Tag := -1;
  btnGrandMere_Paternel.Tag := -1;
  btnGrandPere_Paternel.Hint := '';
  btnGrandMere_Paternel.Hint := '';

  //branchement des grands-parents maternels
  btnGrandPere_Maternel.Tag := -1;
  btnGrandMere_Maternel.Tag := -1;
  btnGrandPere_Maternel.Hint := '';
  btnGrandMere_Maternel.Hint := '';

  //Le pre
  btnPere.Tag := -1;

  //La mre
  btnMere.Tag := -1;

  popup_OnclesTantes.Items.Clear;
  popup_FreresSoeurs.Items.Clear;
  popup_Fils.Items.Clear;
  popup_Filles.Items.Clear;
  popup_CousinsCousines.Items.Clear;
  popup_Conjoints.Items.Clear;

  rv.Clear;
  fIndiNom.Clear;
  fIndiPrenom.Clear;
  fIndiSexe.Clear;
  fIndiDateNaissance.Clear;
  fIndiDateDeces.Clear;
  fIndiSosa.Clear;
  fIndiNiveau.Clear;
  fIndiCle.Clear;
  fIndiJumpTag.Clear;

  with IBQAscendant do begin
      DisableControls;
      Close;
      //passage des parametres ---
      Params[0].AsInteger := aCLE_FICHE_INDIVIDU; //Cle de l'individu
      Params[1].AsInteger := dm.NumDossier;
      Params[2].AsInteger := _Context.MaxIndPourNaviguer;
      Open;

      //{oblig de faire ca pour compter les enregs ---
      Last;
      //{----------------------------------------------

      i_Count := RecordCount;

      //si rien , on sort -------
      if i_Count <= 0 then
        begin
          close;
          exit;
        end;

      First;

      Caption := ' ' + AssembleString([
        FMain.aFIndividu.QueryIndividuNOM.AsString,
          FMain.aFIndividu.QueryIndividuPRENOM.AsString]);

      for n := 1 to i_Count do
        begin
          //on fabrique la chaine de caracteres -------
          s_Naiss := trim(FieldByName('DATE_NAISSANCE').AsString);
          if Length(s_Naiss) > 0 then s_Naiss := ' ' + s_Naiss;
          s_Deces := trim(FieldByName('DATE_DECES').AsString);
          if Length(s_Deces) > 0 then s_Deces := '+ ' + s_Deces;

          s_Nom := AssembleString([
            FieldByName('NOM').AsString,
              FieldByName('PRENOM').AsString,
              s_Naiss,
              s_Deces]);

          s_Naiss := trim(FieldByName('DATE_NAISSANCE').AsString);
          if Length(s_Naiss) > 0 then s_Naiss := ' ' + s_Naiss;
          s_Deces := trim(FieldByName('DATE_DECES').AsString);
          if Length(s_Deces) > 0 then s_Deces := Char(10) + Char(13) + '+ ' + s_Deces;

          s_Hint := AssembleString([
            FieldByName('NOM').AsString,
              FieldByName('PRENOM').AsString]) + Char(10) + Char(13) +
            s_Naiss +
            s_Deces;

          //On recupere le niveau de parente ----------
          i_Niveau := FieldByName('NIVEAU').AsInteger;

          fIndiNom.Add(FieldByName('NOM').AsString);
          fIndiPrenom.Add(FieldByName('PRENOM').AsString);
          fIndiSexe.Add(FieldByName('SEXE').AsInteger);
          fIndiDateNaissance.Add(FieldByName('DATE_NAISSANCE').AsString);
          fIndiDateDeces.Add(FieldByName('DATE_DECES').AsString);
          fIndiSosa.Add(FieldByName('SOSA').AsInteger);
          fIndiNiveau.Add(i_Niveau);
          fIndiCle.Add(FieldByName('CLE_FICHE').AsInteger);
          fIndiJumpTag.Add(-1);

          case i_Niveau of
            0: // Lui Meme
              begin
                if FieldByName('SEXE').AsInteger = 1 then
                  begin
                    btnHomme.Hint := s_Hint;
                    btnHomme.Visible := True;
                  end
                else
                  begin
                    btnFemme.Hint := s_Hint;
                    btnFemme.Visible := True;
                  end;
              end;

            1: // Parents
              begin
                case FieldByName('SOSA').AsInteger of
                  2: // Pere
                    begin
                      btnPere.Tag := FieldByName('CLE_FICHE').AsInteger;
                      btnPere.Hint := s_Hint;
                      btnPere.Enabled := True;
                    end;
                  3: // Mere
                    begin
                      btnMere.Tag := FieldByName('CLE_FICHE').AsInteger;
                      btnMere.Hint := s_Hint;
                      btnMere.Enabled := True;
                    end;
                end;
              end;

            2: // Grands parents
              begin
                case FieldByName('SOSA').AsInteger of
                  4: // GP Paternel
                    begin
                      btnGrandPere_Paternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                      btnGrandPere_Paternel.Hint := s_Hint;
                      btnGrandPere_Paternel.Enabled := True;
                    end;
                  5: // GM Paternelle
                    begin
                      btnGrandMere_Paternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                      btnGrandMere_Paternel.Hint := s_Hint;
                      btnGrandMere_Paternel.Enabled := True;
                    end;
                  6: // GP Maternel
                    begin
                      btnGrandPere_Maternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                      btnGrandPere_Maternel.Hint := s_Hint;
                      btnGrandPere_Maternel.Enabled := True;
                    end;
                  7: // GM Maternelle
                    begin
                      btnGrandMere_Maternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                      btnGrandMere_Maternel.Hint := s_Hint;
                      btnGrandMere_Maternel.Enabled := True;
                    end;
                end;
              end;

            3: // Oncles et tantes
              begin
                if _Context.RefreshCousins then begin
                    btnOnclesTantes.Enabled := True;
                    NewItem := TMenuItem.create(self);
                    popup_OnclesTantes.Items.Add(NewItem);
                    NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                    NewItem.Caption := s_Nom;
                    NewItem.Onclick := OnSelectIndividu;

                    if FieldByName('SEXE').AsInteger = 1 then
                      NewItem.ImageIndex := 1
                    else
                      NewItem.ImageIndex := 0;
                  end;
              end;

            4: // Freres et soeurs
              begin
                btnFreresSoeurs.Enabled := True;
                NewItem := TMenuItem.create(self);
                popup_FreresSoeurs.Items.Add(NewItem);
                NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                NewItem.Caption := s_Nom;
                NewItem.Onclick := OnSelectIndividu;

                if FieldByName('SEXE').AsInteger = 1 then
                  NewItem.ImageIndex := 1
                else
                  NewItem.ImageIndex := 0;

              end;

            5: // Enfants
              begin
                if FieldByName('SEXE').AsInteger = 1 then
                  // Fils
                  begin
                    btnFils.Enabled := True;
                    NewItem := TMenuItem.create(self);
                    popup_Fils.Items.Add(NewItem);
                    NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                    NewItem.Caption := s_Nom;
                    NewItem.Onclick := OnSelectIndividu;
                    NewItem.ImageIndex := 1
                  end
                else
                  // Filles
                  begin
                    btnFilles.Enabled := True;
                    NewItem := TMenuItem.create(self);
                    popup_Filles.Items.Add(NewItem);
                    NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                    NewItem.Caption := s_Nom;
                    NewItem.Onclick := OnSelectIndividu;
                    NewItem.ImageIndex := 0;
                  end;

              end;

            6: // Cousins Cousines
              begin
                if _Context.RefreshCousins then begin
                    btnCousinsCousines.Enabled := True;
                    NewItem := TMenuItem.create(self);
                    popup_CousinsCousines.Items.Add(NewItem);
                    NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                    NewItem.Caption := s_Nom;
                    NewItem.Onclick := OnSelectIndividu;

                    if FieldByName('SEXE').AsInteger = 1 then
                      NewItem.ImageIndex := 1
                    else
                      NewItem.ImageIndex := 0;
                  end;
              end;

            7: // Conjoints
              begin
                btnConjoints.Enabled := True;
                NewItem := TMenuItem.create(self);
                popup_Conjoints.Items.Add(NewItem);
                NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                NewItem.Caption := s_Nom;
                NewItem.Onclick := OnSelectIndividu;

                if FieldByName('SEXE').AsInteger = 1 then
                  NewItem.ImageIndex := 1
                else
                  NewItem.ImageIndex := 0;
              end;

          end;

          next;
        end;
      EnableControls;
    end;

  PrepareMemoIndividu;

end;

procedure TFNavigation.OnSelectIndividu(Sender: TObject);
{
Action a faire lors d'un click sur un des
boutons ou menu popup
}
begin
  ShowIndividu(TComponent(Sender).Tag);
end;

procedure TFNavigation.SuperFormRefreshControls(Sender: TObject);
begin
  imgDoColapseForm.visible := fFormExpanded;
  imgDoExpandForm.visible := not fFormExpanded;
end;

procedure TFNavigation.SetFormExpanded(const Value: boolean);
begin
  fFormExpanded := Value;

  //on agrandie
  if Value then
    begin
      Height := fLastHeightFormExpanded;
    end
  else
    //on diminue
    begin
      fLastHeightFormExpanded := Height;
      Height := fHeightFormNotExpanded;
    end;

  DoRefreshControls;
end;

procedure TFNavigation.imgDoExpandFormClick(Sender: TObject);
begin
  FormExpanded := true;
end;

procedure TFNavigation.imgDoColapseFormClick(Sender: TObject);
begin
  FormExpanded := false;
end;

procedure TFNavigation.PrepareMemoIndividu;
const
  crlf: string = chr(13) + chr(10);
  //crlf = #13#10;
var
  k: integer;
  JumpTag: integer;
begin
  rv.Clear;
  rv.FirstJumpNo := 0;
  JumpTag := 0;

  //lui-mme
  k := fIndiNiveau.IndexOf(0);
  if k <> -1 then
    begin
      case fIndiSexe[k] of
        1: begin rv.AddBullet(1, ImageList1, True); rv.Add(' ', rvsNormal); end;
        2: begin rv.AddBullet(0, ImageList1, True); rv.Add(' ', rvsNormal); end;
      end;

      rv.Add(AssembleString([fIndiNom[k], fIndiPrenom[k]]), rvsHeading);
      rv.AddTextFromNewLine(' ', rvsNormal);
    end;

  //Pres
  for k := 0 to fIndiNiveau.count - 1 do
    if (fIndiNiveau[k] = 1) and (fIndiSosa[k] = 2) then
      begin
        rv.AddTextFromNewLine(btnPere.Caption + ' :', rvsHeading);
        //   rv.AddTextFromNewLine(' ', rvsNormal);
        //   rv.AddTextFromNewLine('    ', rvsNormal);
        rv.Add('  ', rvsNormal);
        rv.Add(AssembleString([fIndiNom[k], fIndiPrenom[k]]), rvsJump1);
        fIndiJumpTag[k] := JumpTag; inc(JumpTag);
      end;

  //Mre
  for k := 0 to fIndiNiveau.count - 1 do
    if (fIndiNiveau[k] = 1) and (fIndiSosa[k] = 3) then
      begin
        rv.AddTextFromNewLine(btnMere.Caption + ' :', rvsHeading);
        // rv.AddTextFromNewLine(' ', rvsNormal);
  // rv.AddTextFromNewLine('    ', rvsNormal);
        rv.Add('  ', rvsNormal);
        rv.Add(AssembleString([fIndiNom[k], fIndiPrenom[k]]), rvsJump1);
        fIndiJumpTag[k] := JumpTag; inc(JumpTag);
      end;


  //Conjoints
  k := fIndiNiveau.IndexOf(7);
  if k <> -1 then
    begin
      rv.AddTextFromNewLine(' ', rvsNormal);
      rv.AddTextFromNewLine(btnConjoints.Caption + ' :', rvsHeading);
      rv.AddTextFromNewLine(' ', rvsNormal);

      for k := 0 to fIndiNiveau.count - 1 do
        begin
          if fIndiNiveau[k] = 7 then
            begin
              rv.AddTextFromNewLine('    ', rvsNormal);
              rv.Add(AssembleString([fIndiNom[k], fIndiPrenom[k]]), rvsJump1);
              fIndiJumpTag[k] := JumpTag; inc(JumpTag);
            end;
        end;
    end;


  //Enfants
  k := fIndiNiveau.IndexOf(5);
  if k <> -1 then
    begin
      rv.AddTextFromNewLine(' ', rvsNormal);
      rv.AddTextFromNewLine(lEnfants.Caption, rvsHeading);
      rv.AddTextFromNewLine(' ', rvsNormal);

      for k := 0 to fIndiNiveau.count - 1 do
        begin
          if fIndiNiveau[k] = 5 then
            begin
              rv.AddTextFromNewLine('    ', rvsNormal);
              rv.Add(AssembleString([fIndiNom[k], fIndiPrenom[k]]), rvsJump1);
              fIndiJumpTag[k] := JumpTag; inc(JumpTag);
            end;
        end;
    end;



  rv.format;
  rv.Paint;
end;


procedure TFNavigation.SuperFormDestroy(Sender: TObject);
begin
  fIndiNom.free;
  fIndiPrenom.free;
  fIndiSexe.free;
  fIndiDateNaissance.free;
  fIndiDateDeces.free;
  fIndiSosa.free;
  fIndiNiveau.free;
  fIndiCle.free;
  fIndiJumpTag.free;
end;

procedure TFNavigation.rvJump(Sender: TObject; id: Integer);
var
  k: integer;
begin
  //     showmessage(inttostr(id));
  k := fIndiJumpTag.IndexOf(id);
  if k <> -1 then ShowIndividu(fIndiCle[k]);
end;


procedure TFNavigation.ShowIndividu(aTag: integer);
begin
  if aTag <> -1 then
    begin
      fCallingOpenFicheFromMe := true;
      try
        //on ouvre la fiche individu
        if FMain.aFIndividu.ChangeFicheActive(aTag) then
          begin
            // On recharge l'arbre en fonction de l'individu actif
            LoadPeopleArroundIndividu(aTag);
          end;
      finally
        fCallingOpenFicheFromMe := false;
      end;
    end;
end;

procedure TFNavigation.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    // VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_NAVIGATEUR_INDI);
  end;
end;

end.

