unit u_form_calendriers;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, Buttons, TFlatRadioButtonUnit, TFlatButtonUnit,
  StdCtrls, u_comp_TGoodBtn, TFlatEditUnit, TFlatPanelUnit, DateUtils,
  TFlatGroupBoxUnit, TFlatComboBoxUnit, TFlatMemoUnit, u_comp_TYLanguage,
  TFlatTabControlUnit, jpeg, dxCntner, dxEditor, dxEdLib, DynamicSkinForm;

type
  TFCalendriers = class(TSuperForm)
    pBorder: TPanel;
    Panel3: TPanel;
    btnCalculer1: TGoodBtn;
    FlatGroupBox1: TFlatGroupBox;
    radGregorien: TFlatRadioButton;
    radJulien: TFlatRadioButton;
    radMusulman: TFlatRadioButton;
    radRepublicain: TFlatRadioButton;
    radIsraelien: TFlatRadioButton;
    radCopte: TFlatRadioButton;
    FlatGroupBox2: TFlatGroupBox;
    Label7: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    FlatGroupBox3: TFlatGroupBox;
    lemois: TFlatComboBox;
    Label1: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Language: TYLanguage;
    FlatPanel1: TFlatPanel;
    btnContribution: TGoodBtn;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    Panel9: TPanel;
    Image2: TImage;
    Panel10: TPanel;
    btnInfoGre: TGoodBtn;
    btnInfoJul: TGoodBtn;
    btnInfoIsr: TGoodBtn;
    btnInfoCop: TGoodBtn;
    btnInfoRep: TGoodBtn;
    btnInfoMus: TGoodBtn;
    dateCop: TdxEdit;
    dateIsr: TdxEdit;
    dateMus: TdxEdit;
    dateRep: TdxEdit;
    dateJul: TdxEdit;
    dateGreg: TdxEdit;
    lan: TdxEdit;
    lejour: TdxEdit;
    Erreur: TLabel;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure radGregorienClick(Sender: TObject);
    procedure radRepublicainClick(Sender: TObject);
    procedure radIsraelienClick(Sender: TObject);
    procedure radMusulmanClick(Sender: TObject);
    procedure radCopteClick(Sender: TObject);
    procedure radJulienClick(Sender: TObject);
    procedure btnCalculer1Click(Sender: TObject);
    procedure refreshCalendriers;
    procedure bsfbSelectionClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnContributionClick(Sender: TObject);
    procedure btnInfoGreClick(Sender: TObject);
    procedure btnInfoRepClick(Sender: TObject);
    procedure btnInfoJulClick(Sender: TObject);
    procedure btnInfoIsrClick(Sender: TObject);
    procedure btnInfoMusClick(Sender: TObject);
    procedure btnInfoCopClick(Sender: TObject);
  private
    { Dclarations prives }
    fCanSelect: boolean;
    fDialogMode: boolean;
    fDate: string;
  public
    { Dclarations publiques }

    //En entre
    property CanSelect: boolean read fCanSelect write fCanSelect;
    //en retour
    property ladate: string read fDate write fDate;

    procedure doInit(sDate: string);
    procedure initCalendriers;
  end;

implementation

uses u_common_var, u_common_const, u_form_calendriers_func, u_form_calendriers_gregorien,
  u_Form_Contributions, u_form_calendriers_infos, u_dm, u_form_main;

var radio: integer;
  moisGre, moisJul, moisRep, moisMus, moisIsr, moisCop: TStringList;
  j, m, a: word;

{$R *.dfm}

procedure TFCalendriers.initCalendriers;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fCanSelect := true;
  fDialogMode := true;

  moisGre := TStringList.Create;
  moisGre.Add('Janvier');
  moisGre.Add('Fvrier');
  moisGre.Add('Mars');
  moisGre.Add('Avril');
  moisGre.Add('Mai');
  moisGre.Add('Juin');
  moisGre.Add('Juillet');
  moisGre.Add('Aot');
  moisGre.Add('Septembre');
  moisGre.Add('Octobre');
  moisGre.Add('Novembre');
  moisGre.Add('Dcembre');

  moisJul := TStringList.Create;
  moisJul.Add('Janvier');
  moisJul.Add('Fvrier');
  moisJul.Add('Mars');
  moisJul.Add('Avril');
  moisJul.Add('Mai');
  moisJul.Add('Juin');
  moisJul.Add('Juillet');
  moisJul.Add('Aot');
  moisJul.Add('Septembre');
  moisJul.Add('Octobre');
  moisJul.Add('Novembre');
  moisJul.Add('Dcembre');

  moisRep := TStringList.Create;
  moisRep.Add('vendmiaire');
  moisRep.Add('brumaire');
  moisRep.Add('frimaire');
  moisRep.Add('nivse');
  moisRep.Add('pluvise');
  moisRep.Add('ventse');
  moisRep.Add('germinal');
  moisRep.Add('floral');
  moisRep.Add('prairial');
  moisRep.Add('messidor');
  moisRep.Add('thermidor');
  moisRep.Add('fructidor');
  moisRep.Add('sanculottides');

  moisMus := TStringList.Create;
  moisMus.Add('Mouharram');
  moisMus.Add('Safar');
  moisMus.Add('Rabi''-oul-Aououal');
  moisMus.Add('Rabi''-out-Tani');
  moisMus.Add('Djoumada-l-Oula');
  moisMus.Add('Djoumada-t-Tania');
  moisMus.Add('Radjab');
  moisMus.Add('Cha''ban');
  moisMus.Add('Ramadan');
  moisMus.Add('Chaououal');
  moisMus.Add('Dou-l-Qa''da');
  moisMus.Add('Dou-l-Hidjja');

  moisIsr := TStringList.Create;
  moisIsr.Add('Tisseri');
  moisIsr.Add('Hesvan');
  moisIsr.Add('Kislev');
  moisIsr.Add('Tbeth');
  moisIsr.Add('Schbat');
  moisIsr.Add('Adar');
  moisIsr.Add('Nissan');
  moisIsr.Add('Iyar');
  moisIsr.Add('Sivan');
  moisIsr.Add('Tamouz');
  moisIsr.Add('Ab');
  moisIsr.Add('Elloul');

  moisCop := TStringList.Create;
  moisCop.Add('Tout');
  moisCop.Add('Babah');
  moisCop.Add('Htour');
  moisCop.Add('Keihak');
  moisCop.Add('Toubah');
  moisCop.Add('Amchir');
  moisCop.Add('Barmahat');
  moisCop.Add('Barmoudah');
  moisCop.Add('Bachnas');
  moisCop.Add('Bou''nah');
  moisCop.Add('Abib');
  moisCop.Add('Masari');
  moisCop.Add('Jours pagomnes');
end;

procedure TFCalendriers.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 464;
      ClientWidth := 374;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  initCalendriers;

  DecodeDate(now, a, m, j);
  lan.Text := IntToStr(a);
  lemois.ItemIndex := m - 1;
  lejour.Text := IntToStr(j);

  doRefreshControls;
end;

procedure TFCalendriers.SuperFormRefreshControls(Sender: TObject);
begin
  bsfbSelection.visible := fCanSelect;
end;

procedure TFCalendriers.SuperFormDestroy(Sender: TObject);
begin
  moisGre.Free;
  moisJul.Free;
  moisRep.Free;
  moisIsr.Free;
  moisMus.Free;
  moisCop.Free;
end;

procedure TFCalendriers.SuperFormShowFirstTime(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFCalendriers.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFCalendriers.radGregorienClick(Sender: TObject);
begin
  radio := 0;
  lemois.Clear;
  lemois.items.addStrings(moisGre);
  lan.Text := IntToStr(dateCal.anGre);
  lemois.ItemIndex := dateCal.moisGre - 1;
  lejour.Text := IntToStr(dateCal.jourGre);
  doRefreshControls;
end;

procedure TFCalendriers.radRepublicainClick(Sender: TObject);
begin
  radio := 2;
  lemois.Clear;
  lemois.items.addStrings(moisRep);
  lan.Text := IntToStr(dateCal.anRep);
  lemois.ItemIndex := dateCal.moisRep - 1;
  lejour.Text := IntToStr(dateCal.jourRep);
  doRefreshControls;
end;

procedure TFCalendriers.radIsraelienClick(Sender: TObject);
begin
  radio := 4;
  lemois.Clear;
  lemois.items.addStrings(moisIsr);
  lan.Text := IntToStr(dateCal.anIsr);
  lemois.ItemIndex := dateCal.moisIsr - 1;
  lejour.Text := IntToStr(dateCal.jourIsr);
  doRefreshControls;
end;

procedure TFCalendriers.radMusulmanClick(Sender: TObject);
begin
  radio := 3;
  lemois.Clear;
  lemois.items.addStrings(moisMus);
  lan.Text := IntToStr(dateCal.anMus);
  lemois.ItemIndex := dateCal.moisMus - 1;
  lejour.Text := IntToStr(dateCal.jourMus);
  doRefreshControls;
end;

procedure TFCalendriers.radCopteClick(Sender: TObject);
begin
  radio := 5;
  lemois.Clear;
  lemois.items.addStrings(moisCop);
  lan.Text := IntToStr(dateCal.anCop);
  lemois.ItemIndex := dateCal.moisCop - 1;
  lejour.Text := IntToStr(dateCal.jourCop);
  doRefreshControls;
end;

procedure TFCalendriers.radJulienClick(Sender: TObject);
begin
  radio := 1;
  lemois.Clear;
  lemois.items.addStrings(moisJul);
  lan.Text := IntToStr(dateCal.anJul);
  lemois.ItemIndex := dateCal.moisJul - 1;
  lejour.Text := IntToStr(dateCal.jourJul);
  doRefreshControls;
end;

procedure TFCalendriers.refreshCalendriers;
begin
  Erreur.Caption := dateCal.erreur;
  if (dateCal.erreur <> '') then
    begin
      dateGreg.Text := '';
      dateRep.Text := '';
      dateJul.Text := '';
      dateMus.Text := '';
      dateIsr.Text := '';
      dateCop.Text := '';
    end
  else begin
      dateGreg.Text := dateCal.valeurGre;
      dateRep.Text := dateCal.valeurRep;
      dateJul.Text := dateCal.valeurJul;
      dateMus.Text := dateCal.valeurMus;
      dateIsr.Text := dateCal.valeurIsr;
      dateCop.Text := dateCal.valeurCop;
    end;
end;

procedure TFCalendriers.btnCalculer1Click(Sender: TObject);
begin
  dateCal.an := StrToInt(lan.Text);
  dateCal.mois := lemois.ItemIndex + 1;
  dateCal.jour := StrToInt(lejour.Text);
  dateCal.erreur := '';
  case radio of
    0: // grgorien
      calculerGregorien;
    1: // julien
      calculerJulien;
    2: // rpublicain
      calculerRepublicain;
    3: // musulman
      calculerMusulman;
    4: //isralien
      calculerIsraelien;
    5: //copte
      calculerCopte;
  end;
  refreshCalendriers;
end;

procedure TFCalendriers.bsfbSelectionClick(Sender: TObject);
begin
  if fCanSelect then
    begin
      fDate := dateCal.valeurExport;
      if fDialogMode = false then fDate := ''
      else ModalResult := mrOk;
    end;

end;

procedure TFCalendriers.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFCalendriers.btnContributionClick(Sender: TObject);
var
  aFContributions: TFContributions;
begin
  aFContributions := TFContributions.create(self);
  try
    aFContributions.DoInit('Thierry Colier');
    aFContributions.ShowModal;
  finally
    aFContributions.Free;
  end;
end;

procedure TFCalendriers.doInit(sDate: string);
begin
  {
  ici on recoit la date de l individu, il faut donc la traiter et lancer aussi automatiquement
  la conversion
  }
  initCalendriers;

  // On verifie que la date passee est bonne, si c est une annee ou vers 1978 on mets la date du jour
  try
    StrToDateTime(sDate);
  except
    on E: EConvertError do
      sDate := DateTimeToStr(now);
  end;

  if (CompareDateTime(EncodeDate(1582, 12, 20), StrToDateTime(sDate)) = -1) then
    // on active la conversion depuis le calendrier grgorien
    radGregorien.Checked := true
  else
    // on active la conversion depuis le calendrier julien
    radJulien.Checked := true;

  DecodeDate(StrToDateTime(sDate), a, m, j);
  lan.Text := IntToStr(a);
  lemois.ItemIndex := m - 1;
  lejour.Text := IntToStr(j);

  doRefreshControls;

  //   ShowMessage(sDate);
end;

procedure TFCalendriers.btnInfoGreClick(Sender: TObject);
var
  aFCalendriers_infos: TFCalendriers_infos;
begin
  aFCalendriers_infos := TFCalendriers_infos.create(self);
  try
    aFCalendriers_infos.leTexteGre.Visible := True;
    aFCalendriers_infos.leTexteJul.Visible := False;
    aFCalendriers_infos.leTexteMus.Visible := False;
    aFCalendriers_infos.leTexteIsr.Visible := False;
    aFCalendriers_infos.leTexteCop.Visible := False;
    aFCalendriers_infos.leTexteRep.Visible := False;
    aFCalendriers_infos.ShowModal;
  finally
    aFCalendriers_infos.Free;
  end;
end;

procedure TFCalendriers.btnInfoJulClick(Sender: TObject);
var
  aFCalendriers_infos: TFCalendriers_infos;
begin
  aFCalendriers_infos := TFCalendriers_infos.create(self);
  try
    aFCalendriers_infos.leTexteGre.Visible := False;
    aFCalendriers_infos.leTexteJul.Visible := True;
    aFCalendriers_infos.leTexteMus.Visible := False;
    aFCalendriers_infos.leTexteIsr.Visible := False;
    aFCalendriers_infos.leTexteCop.Visible := False;
    aFCalendriers_infos.leTexteRep.Visible := False;
    aFCalendriers_infos.ShowModal;
  finally
    aFCalendriers_infos.Free;
  end;
end;

procedure TFCalendriers.btnInfoRepClick(Sender: TObject);
var
  aFCalendriers_infos: TFCalendriers_infos;
begin
  aFCalendriers_infos := TFCalendriers_infos.create(self);
  try
    aFCalendriers_infos.leTexteGre.Visible := False;
    aFCalendriers_infos.leTexteJul.Visible := False;
    aFCalendriers_infos.leTexteMus.Visible := False;
    aFCalendriers_infos.leTexteIsr.Visible := False;
    aFCalendriers_infos.leTexteCop.Visible := False;
    aFCalendriers_infos.leTexteRep.Visible := True;
    aFCalendriers_infos.ShowModal;
  finally
    aFCalendriers_infos.Free;
  end;
end;

procedure TFCalendriers.btnInfoMusClick(Sender: TObject);
var
  aFCalendriers_infos: TFCalendriers_infos;
begin
  aFCalendriers_infos := TFCalendriers_infos.create(self);
  try
    aFCalendriers_infos.leTexteGre.Visible := False;
    aFCalendriers_infos.leTexteJul.Visible := False;
    aFCalendriers_infos.leTexteMus.Visible := True;
    aFCalendriers_infos.leTexteIsr.Visible := False;
    aFCalendriers_infos.leTexteCop.Visible := False;
    aFCalendriers_infos.leTexteRep.Visible := False;
    aFCalendriers_infos.ShowModal;
  finally
    aFCalendriers_infos.Free;
  end;
end;

procedure TFCalendriers.btnInfoCopClick(Sender: TObject);
var
  aFCalendriers_infos: TFCalendriers_infos;
begin
  aFCalendriers_infos := TFCalendriers_infos.create(self);
  try
    aFCalendriers_infos.leTexteGre.Visible := False;
    aFCalendriers_infos.leTexteJul.Visible := False;
    aFCalendriers_infos.leTexteMus.Visible := False;
    aFCalendriers_infos.leTexteIsr.Visible := False;
    aFCalendriers_infos.leTexteCop.Visible := True;
    aFCalendriers_infos.leTexteRep.Visible := False;
    aFCalendriers_infos.ShowModal;
  finally
    aFCalendriers_infos.Free;
  end;
end;

procedure TFCalendriers.btnInfoIsrClick(Sender: TObject);
var
  aFCalendriers_infos: TFCalendriers_infos;
begin
  aFCalendriers_infos := TFCalendriers_infos.create(self);
  try
    aFCalendriers_infos.leTexteGre.Visible := False;
    aFCalendriers_infos.leTexteJul.Visible := False;
    aFCalendriers_infos.leTexteMus.Visible := False;
    aFCalendriers_infos.leTexteIsr.Visible := True;
    aFCalendriers_infos.leTexteCop.Visible := False;
    aFCalendriers_infos.leTexteRep.Visible := False;
    aFCalendriers_infos.ShowModal;
  finally
    aFCalendriers_infos.Free;
  end;
end;

end.
