unit u_form_calendriers_func;

interface

uses Math;

type
  TDateCal = record
    jour, mois, an,
      jourGre, moisGre, anGre,
      jourJul, moisJul, anJul,
      jourRep, moisRep, anRep,
      jourMus, moisMus, anMus,
      jourIsr, moisIsr, anIsr,
      jourCop, moisCop, anCop,
      nbmois,
      typea,
      nbjrs,
      code6,
      jsem,
      anc,
      espea: integer;
    cycle,
      jjd: real;
    valeurExport,
      valeurGre,
      valeurJul,
      valeurRep,
      valeurMus,
      valeurIsr,
      valeurCop, erreur: string;
  end;

var dateCal: TDateCal;

function _ceil(nb: real): integer;
function _floor(nb: real): integer;
function _trunc(nb: real): integer;
function _round(nb: real): integer;
function _mod(nb1, nb2: real): real;

implementation

function _ceil(nb: real): integer;
begin
  if (Frac(nb) = 0) then
    Result := trunc(nb)
  else
    if (nb > 0.0) then
      Result := trunc(nb) + 1
    else
      Result := trunc(nb);
end;

function _floor(nb: real): integer;
begin
  if (Frac(nb) = 0) then
    Result := trunc(nb)
  else
    if (nb > 0.0) then
      Result := trunc(nb)
    else
      Result := trunc(nb) - 1;
end;

function _trunc(nb: real): integer;
begin
  if (nb > 0.0) then
    Result := _floor(nb)
  else
    Result := _ceil(nb);
end;

function _round(nb: real): integer;
begin
  if (nb > 0.0) then
    Result := _floor(nb + 0.5)
  else
    Result := _ceil(nb - 0.5);
end;

function _mod(nb1, nb2: real): real;
begin
  Result := nb1 - (_trunc(nb1 / nb2) * nb2);
end;

end.
