unit u_form_calendriers_gregorien;

interface

uses SysUtils, Dialogs;

procedure julien;
procedure julienj;
procedure JCOPTE;
procedure COPTEJ;
procedure JMUSUL;
procedure MUSULJ;
procedure JISR;
procedure ISRJ;
procedure jjdatej;
procedure jjdate;
procedure bisg;
procedure bisr;
procedure BISJ;
procedure BISC;
procedure BISM;
procedure BISI;
function debanr(an: integer): real;
function DEBANJ(an: integer): real;
procedure jrepu;
procedure repuj;
procedure nomjour;
procedure nbjrs;
procedure nbjrsj;
procedure nbjrsm;
procedure nbjrsc;
procedure nbjrsr;
procedure affcc;
procedure calculerGregorien;
procedure calculerJulien;
procedure calculerRepublicain;
procedure calculerIsraelien;
procedure calculerMusulman;
procedure calculerCopte;

implementation

uses u_form_calendriers_func;

procedure julien;
var D, M, Y: integer;
  A: real;
begin
  D := dateCal.jour;
  Y := dateCal.an;
  M := dateCal.mois;
  A := Y + M / 100 + D / 10000;
  if (dateCal.mois <= 2) then
    begin
      Y := Y - 1;
      M := M + 12;
    end;
  if (Y < 0) then
    dateCal.jjd := _ceil(365.25 * Y - 0.75)
  else
    dateCal.jjd := _floor(365.25 * Y);
  dateCal.jjd := dateCal.jjd + _trunc(30.6001 * (M + 1)) + D + 1720994.5;
  if (A > 1582.1014) then
    dateCal.jjd := dateCal.jjd + 2 - _trunc(Y / 100) + _trunc(_trunc(Y / 100) / 4);
end;

procedure JULIENJ();
var D, M, Y: integer;
begin
  D := dateCal.JOUR;
  Y := dateCal.AN;
  M := dateCal.MOIS;
  if (dateCal.MOIS <= 2) then
    begin
      Y := Y - 1;
      M := M + 12;
    end;
  if (Y < 0) then
    dateCal.JJD := _ceil(365.25 * Y - 0.75)
  else
    dateCal.JJD := _floor(365.25 * Y);
  dateCal.JJD := dateCal.JJD + _trunc(30.6001 * (M + 1)) + D + 1720994.5;
end;

procedure JCOPTE();
const BORNE: array[0..4] of integer = (0, 365, 730, 1096, 1461);
var dt, aan, dj: real;
  i, jan: integer;
begin
  DT := dateCal.JJD - 1825029.5;
  AAN := DT / 1461;
  dateCal.AN := _trunc(AAN);
  DT := DT - (_floor(AAN) * 1461) + 1;
  dateCal.AN := dateCal.AN * 4;
  for I := 0 to 3 do
    begin
      if ((BORNE[I] < DT) and (DT <= BORNE[I + 1])) then
        begin
          JAN := I + 1;
          DT := DT - BORNE[I];
        end;
    end;
  dateCal.AN := dateCal.AN + JAN;
  if (JAN = 3) then
    dateCal.TYPEA := 1
  else
    dateCal.TYPEA := 0;
  DJ := (DT - 1) / 30;
  dateCal.MOIS := _trunc(DJ) + 1;
  dateCal.JOUR := _trunc(DT - (_trunc(DJ) * 30));
end;

procedure COPTEJ;
var dt: real;
  dan, jan: integer;
begin
  DT := dateCal.AN;
  DT := (DT - 1) / 4;
  JAN := _trunc(DT);
  DT := _trunc(DT);
  dateCal.JJD := DT * 1461;
  DAN := dateCal.AN - (JAN * 4);
  dateCal.JJD := 1825028.5E0 + dateCal.JJD + (DAN - 1) * 365 + 30 * (dateCal.MOIS - 1) + dateCal.JOUR;
  if ((DAN / 4) = 1) then dateCal.JJD := dateCal.JJD + 1;
end;

procedure JMUSUL();
const BORNE: array[0..30] of integer = (0, 354, 709, 1063, 1417, 1772, 2126,
    2481, 2835, 3189, 3544, 3898, 4252, 4607, 4961, 5315, 5670, 6024, 6379,
    6733, 7087, 7442, 7796, 8150, 8505, 8859, 9214, 9568, 9922, 10277, 10631);
  CMOIS: array[0..12] of integer = (0, 30, 59, 89, 118, 148, 177,
    207, 236, 266, 295, 325, 354);
var i, ndt, jan: integer;
  dt: real;
  BMOIS: array[0..12] of integer;
begin
  for I := 0 to 12 do
    begin
      BMOIS[I] := CMOIS[I];
    end;
  DT := dateCal.JJD - 1948438.5;
  NDT := _trunc(DT / 10631);
  dateCal.AN := NDT * 30;
  dateCal.CYCLE := NDT + 1;
  DT := DT - _trunc(DT / 10631) * 10631;
  if (DT = 0) then
    begin
      JAN := 0;
      dateCal.ANC := 30;
      dateCal.CYCLE := NDT;
    end
  else begin
      for I := 0 to 29 do
        begin
          if ((BORNE[I] < DT) and (DT <= BORNE[I + 1])) then
            begin
              JAN := I + 1;
              dateCal.ANC := JAN;
              DT := DT - BORNE[I];
            end;
        end;
    end;
  dateCal.AN := dateCal.AN + JAN;
  if ((dateCal.ANC = 2) or (dateCal.ANC = 5) or (dateCal.ANC = 7) or (dateCal.ANC = 10) or
    (dateCal.ANC = 13) or (dateCal.ANC = 16) or (dateCal.ANC = 18) or (dateCal.ANC = 21) or
    (dateCal.ANC = 24) or (dateCal.ANC = 26) or (dateCal.ANC = 29)) then
    begin
      dateCal.TYPEA := 1;
      BMOIS[12] := 355;
    end
  else
    dateCal.TYPEA := 0;
  if (DT = 0) then
    begin
      dateCal.MOIS := 12;
      dateCal.JOUR := 29;
    end
  else begin
      for I := 0 to 11 do
        begin
          if ((BMOIS[I] < DT) and (DT <= BMOIS[I + 1])) then
            begin
              dateCal.MOIS := I + 1;
              dateCal.JOUR := _trunc(DT) - BMOIS[I];
            end;
        end;
    end;
end;

procedure MUSULJ;
const
  BORNE: array[0..30] of integer = (0, 354, 709, 1063, 1417, 1772, 2126,
    2481, 2835, 3189, 3544, 3898, 4252, 4607, 4961, 5315, 5670, 6024, 6379,
    6733, 7087, 7442, 7796, 8150, 8505, 8859, 9214, 9568, 9922, 10277, 10631);
  CMOIS: array[0..12] of integer = (0, 30, 59, 89, 118, 148, 177,
    207, 236, 266, 295, 325, 354);
var BMOIS: array[0..12] of integer;
  i, jan: integer;
  dt: real;
begin
  for I := 0 to 12 do
    BMOIS[I] := CMOIS[I];
  DT := (dateCal.AN - 1) / 30;
  dateCal.CYCLE := _trunc(DT) + 1;
  dateCal.ANC := dateCal.AN - _trunc(DT) * 30;
  DT := _trunc(DT);
  JAN := _trunc(DT);
  dateCal.JJD := _trunc(DT * 10631);
  JAN := dateCal.AN - JAN * 30;
  if ((JAN = 2) or (JAN = 5) or (JAN = 7) or (JAN = 10) or
    (JAN = 13) or (JAN = 16) or (JAN = 18) or (JAN = 21) or
    (JAN = 24) or (JAN = 26) or (JAN = 29)) then
    begin
      dateCal.TYPEA := 1;
      BMOIS[12] := 355;
    end
  else
    dateCal.TYPEA := 0;
  dateCal.JJD := dateCal.JJD + BORNE[JAN - 1] + BMOIS[dateCal.MOIS - 1] + dateCal.JOUR + 1948438.5;
end;

procedure JISR();
const MOISC: array[0..35] of integer = (
    1, 31, 60, 89, 118, 148, 177, 207, 236, 266, 295, 325,
    1, 31, 60, 90, 119, 149, 178, 208, 237, 267, 296, 326,
    1, 31, 61, 91, 120, 150, 179, 209, 238, 268, 297, 327);
  MOISE: array[0..38] of integer = (
    1, 31, 60, 89, 118, 148, 178, 207, 237, 266, 296, 325, 355,
    1, 31, 60, 90, 119, 149, 179, 208, 238, 267, 297, 326, 356,
    1, 31, 61, 91, 120, 150, 180, 209, 239, 268, 298, 327, 357);
var
  Z1, jjd1, jjdeb, dt: real;
  Z, AA, AAN, B, C, D, E, ALPHA, type1, argc, arge, a, i: integer;
begin
  Z1 := dateCal.JJD + 0.5;
  Z := _trunc(Z1);
  if (Z < 2299161) then
    AA := Z
  else begin
      ALPHA := _trunc((Z - 1867216.25) / 36524.25);
      AA := Z + 1 + ALPHA - _trunc(ALPHA / 4);
    end;
  B := AA + 1524;
  C := _trunc((B - 122.1) / 365.25);
  D := _trunc(365.25 * C);
  E := _trunc((B - D) / 30.6001);
  dateCal.JOUR := _trunc(B - D - _trunc(30.6001 * E));
  if (E < 13.5) then
    dateCal.MOIS := _trunc(E - 1)
  else
    dateCal.MOIS := _trunc(E - 13);
  if (dateCal.MOIS >= 3) then
    dateCal.AN := _trunc(C - 4716)
  else
    dateCal.AN := _trunc(C - 4715);
  AAN := dateCal.AN + 3761;
  JJD1 := DEBANJ(AAN);
  if (dateCal.JJD < JJD1) then
    begin
      dateCal.AN := AAN - 1;
      JJDEB := DEBANJ(dateCal.AN);
    end
  else begin
      dateCal.AN := AAN;
      JJDEB := JJD1;
      AAN := AAN + 1;
      JJD1 := DEBANJ(AAN);
    end;
  dateCal.CYCLE := (dateCal.AN - 1) / 19 + 1;
  dateCal.ANC := 1 + (dateCal.AN - 1) mod 19;
  AA := dateCal.AN;
  AA := 12 * AA + 5;
  A := AA mod 19;
  if (A > 6) then
    begin
      TYPE1 := 0;
      dateCal.TYPEA := 0;
    end
  else begin
      TYPE1 := 1;
      dateCal.TYPEA := 1;
    end;
  DT := JJD1 - JJDEB;
  if (TYPE1 = 1) then
    dateCal.ESPEA := _round(DT - 382)
  else
    dateCal.ESPEA := _round(DT - 352);
  DT := dateCal.JJD - JJDEB + 1;
  ARGC := 12 * (dateCal.ESPEA - 1);
  ARGE := 13 * (dateCal.ESPEA - 1);
  if (TYPE1 = 1) then
    begin
      if (DT >= MOISE[ARGE + 12]) then
        begin
          dateCal.MOIS := 13;
          dateCal.JOUR := _round(DT) - MOISE[ARGE + 12] + 1;
        end
      else
        for I := 0 to 11 do
          begin
            if ((DT >= MOISE[ARGE + I]) and (DT < MOISE[ARGE + I + 1])) then
              begin
                dateCal.JOUR := _round(DT) - MOISE[ARGE + I] + 1;
                dateCal.MOIS := I + 1;
              end;
          end;
    end
  else begin
      if (DT >= MOISC[ARGC + 11]) then
        begin
          dateCal.MOIS := 12;
          dateCal.JOUR := _round(DT) - MOISC[ARGC + 11] + 1;
        end
      else
        for I := 0 to 10 do
          begin
            if ((DT >= MOISC[ARGC + I]) and (DT < MOISC[ARGC + I + 1])) then
              begin
                dateCal.MOIS := I + 1;
                dateCal.JOUR := _round(DT) - MOISC[ARGC + I] + 1;
              end;
          end;
    end;
end;

procedure ISRJ;
const
  MOISC: array[0..35] of integer = (
    1, 31, 60, 89, 118, 148, 177, 207, 236, 266, 295, 325,
    1, 31, 60, 90, 119, 149, 178, 208, 237, 267, 296, 326,
    1, 31, 61, 91, 120, 150, 179, 209, 238, 268, 297, 327);
  MOISE: array[0..38] of integer = (
    1, 31, 60, 89, 118, 148, 178, 207, 237, 266, 296, 325, 355,
    1, 31, 60, 90, 119, 149, 179, 208, 238, 267, 297, 326, 356,
    1, 31, 61, 91, 120, 150, 180, 209, 239, 268, 298, 327, 357);
var
  jjd, jjd1, dt: real;
  AA, a: integer;
begin
  dateCal.CYCLE := (dateCal.AN - 1) / 19 + 1;
  dateCal.ANC := 1 + (dateCal.AN - 1) mod 19;
  AA := dateCal.AN;
  AA := 12 * AA + 5;
  A := AA mod 19;
  jjd1 := DEBANJ(dateCal.AN + 1);
  jjd := DEBANJ(dateCal.AN);
  DT := jjd1 - jjd;
  if (A <= 6) then
    begin
      dateCal.ESPEA := _trunc(DT - 382);
      dateCal.JJD := jjd + MOISE[13 * (dateCal.ESPEA - 1) + (dateCal.MOIS - 1)] - 2 + dateCal.JOUR;
      dateCal.NBMOIS := 13;
      dateCal.TYPEA := 1;
    end
  else begin
      dateCal.ESPEA := _trunc(DT - 352);
      dateCal.JJD := jjd + MOISC[12 * (dateCal.ESPEA - 1) + (dateCal.MOIS - 1)] - 2 + dateCal.JOUR;
      dateCal.NBMOIS := 12;
      dateCal.TYPEA := 0;
    end;
end;

procedure jjdatej;
var Z1: real;
  Z, A, B, C, D, E: integer;
begin
  Z1 := dateCal.jjd + 0.5;
  Z := _trunc(Z1);
  A := Z;
  B := A + 1524;
  C := _trunc((B - 122.1) / 365.25);
  D := _trunc(365.25 * C);
  E := _trunc((B - D) / 30.6001);
  dateCal.jour := _trunc(B - D - _trunc(30.6001 * E));
  if (E < 13.5) then
    dateCal.mois := _trunc(E - 1)
  else
    dateCal.mois := _trunc(E - 13);
  if (dateCal.mois >= 3) then
    dateCal.an := _trunc(C - 4716)
  else
    dateCal.an := _trunc(C - 4715);
end;

procedure jjdate;
var Z1: real;
  Z, A, B, C, D, E, ALPHA: integer;
begin
  Z1 := dateCal.jjd + 0.5;
  Z := _trunc(Z1);
  if (Z < 2299161) then
    A := Z
  else begin
      ALPHA := _trunc((Z - 1867216.25) / 36524.25);
      A := Z + 1 + ALPHA - _trunc(ALPHA / 4);
    end;
  B := A + 1524;
  C := _trunc((B - 122.1) / 365.25);
  D := _trunc(365.25 * C);
  E := _trunc((B - D) / 30.6001);
  dateCal.jour := _trunc(B - D - _trunc(30.6001 * E));
  if (E < 13.5) then
    dateCal.mois := _trunc(E - 1)
  else
    dateCal.mois := _trunc(E - 13);
  if (dateCal.mois >= 3) then
    dateCal.an := _trunc(C - 4716)
  else
    dateCal.an := _trunc(C - 4715);
end;

procedure bisg;
begin
  dateCal.nbmois := 12;
  dateCal.typea := 0;
  if ((dateCal.an mod 4) = 0) then
    dateCal.typea := 1;
  if (((dateCal.an mod 100) = 0) and ((dateCal.an mod 400) <> 0)) then
    dateCal.typea := 0;
end;

procedure bisr;
begin
  dateCal.nbmois := 13;
  if (((dateCal.an + 1) mod 4) = 0) then
    dateCal.typea := 1
  else
    dateCal.typea := 0;
end;

procedure BISJ;
begin
  dateCal.nbmois := 12;
  if ((dateCal.an mod 4) = 0) then
    dateCal.typea := 1
  else
    dateCal.typea := 0;
end;

procedure BISC;
begin
  dateCal.nbmois := 13;
  if (((dateCal.an + 1) mod 4) = 0) then
    dateCal.typea := 1
  else
    dateCal.typea := 0;
end;

procedure BISM;
var dt: real;
begin
  dateCal.nbmois := 12;
  dt := (dateCal.an - 1) / 30;
  dateCal.cycle := _trunc(dt) + 1;
  dateCal.ANC := dateCal.AN - (_trunc(dt) * 30);
  if ((dateCal.ANC = 2) or (dateCal.ANC = 5) or (dateCal.ANC = 7) or (dateCal.ANC = 10) or
    (dateCal.ANC = 13) or (dateCal.ANC = 16) or (dateCal.ANC = 18) or (dateCal.ANC = 21) or
    (dateCal.ANC = 24) or (dateCal.ANC = 26) or (dateCal.ANC = 29)) then
    dateCal.TYPEA := 1
  else
    dateCal.TYPEA := 0;
end;

procedure BISI;
var a, aa: integer; // ???????? jjd, jjd1 ??????
  jjd, jjd1, dt: real;
begin
  dateCal.CYCLE := 1 + (dateCal.AN - 1) / 19;
  dateCal.ANC := 1 + (dateCal.AN - 1) mod 19;
  aa := dateCal.AN;
  aa := 12 * aa + 5;
  a := aa mod 19;
  jjd := DEBANJ(dateCal.AN);
  jjd1 := DEBANJ(dateCal.AN + 1);
  dt := jjd1 - jjd;
  if (a > 6) then
    begin
      dateCal.ESPEA := _trunc(dt - 352);
      dateCal.TYPEA := 0;
      dateCal.NBMOIS := 12;
    end
  else begin
      dateCal.ESPEA := _trunc(dt - 382);
      dateCal.TYPEA := 1;
      dateCal.NBMOIS := 13;
    end;
end;

function debanr(an: integer): real;
var dt, dj: real;
  jan, dan: integer;
begin
  dt := an;
  dt := (dt - 1) / 4;
  jan := _trunc(dt);
  dt := _trunc(dt);
  dj := dt * 1461;
  dan := an - (jan * 4);
  dj := 2375838.5 + dj + (dan - 1) * 365 + 1;
  if ((dan / 4) = 1) then
    dj := dj + 1;
  Result := dj;
end;

function DEBANJ(an: integer): real;
var x1, x2, x3, x4, x5, x6, aa, a, jj, j: integer;
  t, pjjd, dt: real;
begin
  x1 := 392640; x2 := 121555; x3 := 272953;
  x4 := 492480; x5 := 347605; x6 := 365;
  aa := an;
  aa := 12 * aa + 5;
  a := aa mod 19;
  t := (x1 + x2 * an + x3 * a) / x4;
  t := t + x5 + x6 * an + a;
  jj := _trunc(t);
  dt := t - jj;
  t := jj + 1;
  t := t - _trunc(t / 7) * 7;
  j := _round(t);
  pjjd := jj + 0.5;
  if ((j = 2) or (j = 4) or (j = 6)) then pjjd := jj + 1.5;
  if ((j = 1) and (a > 6) and (dt >= 0.632870)) then pjjd := jj + 2.5;
  if ((j = 0) and (a > 11) and (dt >= 0.897724)) then pjjd := jj + 1.5;
  Result := pjjd;
end;

procedure jrepu;
const BORNE: array[0..4] of Integer = (0, 365, 730, 1096, 1461);
var DT, DJ, AAN: real;
  I, JAN: Integer;
begin
  DT := dateCal.jjd - 2375839.5;
  AAN := DT / 1461;
  dateCal.an := _trunc(AAN);
  DT := DT - (_floor(AAN) * 1461) + 1;
  dateCal.an := dateCal.an * 4;
  for I := 0 to 3 do
    begin
      if ((BORNE[I] < DT) and (DT <= BORNE[I + 1])) then
        begin
          JAN := I + 1;
          DT := DT - BORNE[I];
        end;
    end;
  dateCal.an := dateCal.an + JAN;
  if (JAN = 3) then
    dateCal.typea := 1
  else
    dateCal.typea := 0;
  DJ := (DT - 1) / 30;
  dateCal.mois := _trunc(DJ) + 1;
  dateCal.jour := _trunc(DT - (_trunc(DJ) * 30));
  DT := dateCal.jour;
  while (DT > 10) do DT := DT - 10;
  DT := DT - 1;
  dateCal.code6 := _round(DT);
end;

procedure repuj;
var DT: real;
  DAN, JAN: Integer;
begin
  DT := dateCal.an;
  DT := (DT - 1) / 4;
  JAN := _trunc(DT);
  DT := _trunc(DT);
  dateCal.jjd := DT * 1461;
  DAN := dateCal.an - (JAN * 4);
  dateCal.jjd := 2375838.5 + dateCal.jjd + (DAN - 1) * 365 + 30 * (dateCal.mois - 1) + dateCal.jour;
  if ((DAN / 4) = 1) then
    dateCal.jjd := dateCal.jjd + 1;
  DT := dateCal.jour;
  while (DT > 10) do DT := DT - 10;
  DT := DT - 1;
  dateCal.code6 := _round(DT);
end;

procedure nomjour;
begin
  dateCal.jsem := _round(_mod(((dateCal.jjd + 2.5) / 7), 1.0) * 7);
end;

// Calcul du nb de jours pour les mois du calendrier Grgorien et Julien

procedure nbjrs;
begin
  if (dateCal.mois = 2) then
    begin
      if (dateCal.typea = 0) then
        dateCal.nbjrs := 28
      else
        dateCal.nbjrs := 29;
    end
  else begin
      if (dateCal.mois < 8) then
        begin
          if ((dateCal.mois and 1) <> 0) then
            dateCal.nbjrs := 31
          else
            dateCal.nbjrs := 30;
        end
      else
        begin
          if ((dateCal.mois and 1) <> 0) then
            dateCal.nbjrs := 30
          else
            dateCal.nbjrs := 31;
        end;
    end;
end;

// Calcul du nb de jours pour les mois du calendrier Rpublicain

procedure nbjrsr;
begin
  if (dateCal.mois = 13) then
    begin
      if (dateCal.typea = 0) then
        dateCal.nbjrs := 5
      else
        dateCal.nbjrs := 6;
    end
  else
    dateCal.nbjrs := 30;
end;

// Calcul du nb de jours pour les mois du calendrier Isralien

procedure nbjrsj;
const
  tabmois: array[0..77] of integer = (
    30, 29, 29, 29, 30, 29, 30, 29, 30, 29, 30, 29, 0,
    30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 0,
    30, 30, 30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 0,
    30, 29, 29, 29, 30, 30, 29, 30, 29, 30, 29, 30, 29,
    30, 29, 30, 29, 30, 30, 29, 30, 29, 30, 29, 30, 29,
    30, 30, 30, 29, 30, 30, 29, 30, 29, 30, 29, 30, 29);
var NOLIG, NOCOL: Integer;
begin
  NOLIG := 3 * dateCal.typea + dateCal.espea - 1;
  NOCOL := dateCal.mois - 1;
  dateCal.nbjrs := tabmois[13 * (NOLIG) + NOCOL];
end;

// Calcul du nb de jours pour les mois du calendrier Musulman

procedure nbjrsm;
begin
  if (dateCal.mois = 12) then
    begin
      if (dateCal.typea = 0) then
        dateCal.nbjrs := 29
      else
        dateCal.nbjrs := 30;
    end
  else begin
      if ((dateCal.mois and 1) <> 0) then
        dateCal.nbjrs := 30
      else
        dateCal.nbjrs := 29;
    end;
end;

// Calcul du nb de jours pour les mois du calendrier Copte

procedure nbjrsc;
begin
  if (dateCal.mois = 13) then
    begin
      if (dateCal.typea = 0) then
        dateCal.nbjrs := 5
      else
        dateCal.nbjrs := 6;
    end
  else
    dateCal.nbjrs := 30;
end;

procedure affcc();
const
  ljour: array[0..6] of string = ('samedi', 'dimanche', 'lundi', 'mardi',
    'mercredi', 'jeudi', 'vendredi');
  rjour: array[0..9] of string = ('primidi', 'duodi', 'tridi', 'quatidi',
    'quintidi', 'sextidi', 'septidi', 'octidi',
    'nonidi', 'dcadi');
  lmoisc: array[0..13] of string = ('null', 'Tout', 'Babah', 'Htour', 'Keihak', 'Toubah',
    'Amchir', 'Barmahat', 'Barmoudah', 'Bachnas',
    'Bou''nah', 'Abib', 'Masari', 'Jours pagomnes');
  lmoisg: array[0..12] of string = ('null', 'janvier', 'fvrier', 'mars', 'avril', 'mai', 'juin',
    'juillet', 'aot', 'septembre', 'octobre', 'novembre', 'dcembre');
  lmoisr: array[0..13] of string = ('null', 'vendmiaire', 'brumaire', 'frimaire', 'nivse',
    'pluvise', 'ventse', 'germinal',
    'floral', 'prairial', 'messidor', 'thermidor',
    'fructidor', 'sanculottides');
  lmoism: array[0..12] of string = ('null', 'Mouharram', 'Safar', 'Rabi''-oul-Aououal',
    'Rabi''-out-Tani', 'Djoumada-l-Oula', 'Djoumada-t-Tania',
    'Radjab', 'Cha''ban', 'Ramadan', 'Chaououal',
    'Dou-l-Qa''da', 'Dou-l-Hidjja');
  lmoisic: array[0..12] of string = ('null', 'Tisseri', 'Hesvan', 'Kislev', 'Tbeth',
    'Schbat', 'Adar', 'Nissan', 'Iyar', 'Sivan',
    'Tamouz', 'Ab', 'Elloul');
  lmoisie: array[0..13] of string = ('null', 'Tisseri', 'Hesvan', 'Kislev', 'Tbeth',
    'Schbat', 'Adar', 'Vadar', 'Nissan', 'Iyar', 'Sivan',
    'Tamouz', 'Ab', 'Elloul');
  tean: array[0..10] of string = ('anne commune', 'anne bissextile',
    'anne abondante', 'anne embolismique',
    'et dfective', 'et rgulire',
    'et abondante',
    'anne de 365 jours', 'anne de 366 jours',
    'anne ordinaire', 'anne sextile');
begin
  NOMJOUR();

  dateCal.valeurExport := '';

  //julien
  if ((dateCal.JJD - 1) <= 0.5) then
    dateCal.valeurJul := ' -- pas en usage  cette date --'
  else begin
      JJDATEJ();
      BISJ();
      dateCal.jourJul := dateCal.jour;
      dateCal.moisJul := dateCal.mois;
      dateCal.anJul := dateCal.an;
      dateCal.valeurJul := ' ' + ljour[dateCal.JSEM] + ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoisg[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN);

      dateCal.valeurExport := ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoisg[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN);

      if (dateCal.TYPEA = 0) then dateCal.valeurJul := dateCal.valeurJul + '   ' + tean[0];
      if (dateCal.TYPEA = 1) then dateCal.valeurJul := dateCal.valeurJul + '   ' + tean[1];
    end;

  //rpublicain
  if ((dateCal.an < 1792) or (dateCal.an > 1805)) then
    dateCal.valeurRep := ' -- pas en usage  cette date --'
  else begin
      JREPU;
      BISR;
      dateCal.jourRep := dateCal.jour;
      dateCal.moisRep := dateCal.mois;
      dateCal.anRep := dateCal.an;
      dateCal.valeurRep := ' ' + rjour[dateCal.code6] + ' ' + IntToStr(dateCal.jour) + ' ' +
        lmoisr[dateCal.mois] + ' an ' + IntToStr(dateCal.an);

      //        dateCal.valeurExport := ' ' + IntToStr(dateCal.jour) + ' ' +
      //            lmoisr[dateCal.mois] + ' an ' + IntToStr(dateCal.an);

      if (dateCal.typea = 0) then dateCal.valeurRep := dateCal.valeurRep + '   ' + tean[9];
      if (dateCal.typea = 1) then dateCal.valeurRep := dateCal.valeurRep + '   ' + tean[10];
    end;

  //grgorien
  if (dateCal.JJD < 2299160.5) then
    dateCal.valeurGre := ' -- pas en usage  cette date -- '
  else begin
      JJDATE();
      BISG();
      // on sauve pour pouvoir afficher les bonnes valeurs dans la
      // date de rfrence en fonction du calendrier si on change de
      // calendrier
      dateCal.jourGre := dateCal.jour;
      dateCal.moisGre := dateCal.mois;
      dateCal.anGre := dateCal.an;
      //
      dateCal.valeurGre := ' ' + ljour[dateCal.JSEM] + ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoisg[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN);

      dateCal.valeurExport := ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoisg[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN);

      if (dateCal.TYPEA = 0) then dateCal.valeurGre := dateCal.valeurGre + '   ' + tean[0];
      if (dateCal.TYPEA = 1) then dateCal.valeurGre := dateCal.valeurGre + '   ' + tean[1];
    end;

  //copte
  if (dateCal.JJD < 1825029.5) then
    dateCal.valeurCop := ' -- pas en usage  cette date -- '
  else begin
      JCOPTE();
      BISC();
      dateCal.jourCop := dateCal.jour;
      dateCal.moisCop := dateCal.mois;
      dateCal.anCop := dateCal.an;
      dateCal.valeurCop := ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoisc[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN);
      if (dateCal.TYPEA = 0) then dateCal.valeurCop := dateCal.valeurCop + '   ' + tean[7];
      if (dateCal.TYPEA = 1) then dateCal.valeurCop := dateCal.valeurCop + '   ' + tean[8];
    end;

  //musulman
  if (dateCal.JJD < 1948439.5) then
    dateCal.valeurMus := ' -- pas en usage  cette date -- '
  else begin
      JMUSUL();
      BISM();
      dateCal.jourMus := dateCal.jour;
      dateCal.moisMus := dateCal.mois;
      dateCal.anMus := dateCal.an;
      dateCal.valeurMus := ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoism[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN);
      if (dateCal.TYPEA = 0) then dateCal.valeurMus := dateCal.valeurMus + '   ' + tean[0];
      if (dateCal.TYPEA = 1) then dateCal.valeurMus := dateCal.valeurMus + '   ' + tean[2];
    end;

  //isralite
  if (dateCal.JJD < 347997.5) then
    dateCal.valeurIsr := ' -- pas en usage  cette date -- '
  else begin
      JISR();
      //BISI();
      dateCal.jourIsr := dateCal.jour;
      dateCal.moisIsr := dateCal.mois;
      dateCal.anIsr := dateCal.an;
      if (dateCal.TYPEA = 0) then dateCal.valeurIsr := ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoisic[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN) + '  ' + tean[0];
      if (dateCal.TYPEA = 1) then dateCal.valeurIsr := ' ' + IntToStr(dateCal.JOUR) + ' ' +
        lmoisie[dateCal.MOIS] + ' ' + IntToStr(dateCal.AN) + '  ' + tean[3];
      if (dateCal.ESPEA = 1) then dateCal.valeurIsr := dateCal.valeurIsr + ' ' + tean[4];
      if (dateCal.ESPEA = 2) then dateCal.valeurIsr := dateCal.valeurIsr + ' ' + tean[5];
      if (dateCal.ESPEA = 3) then dateCal.valeurIsr := dateCal.valeurIsr + ' ' + tean[6];
    end;
end;

procedure calculerGregorien;
begin
  //       if (dateCal.jjd<2375839.5 or dateCal.jjd>2380686.5) {alert("hors limites"); return;}
  bisg;
  nbjrs;
  if ((dateCal.jour < 1) or (dateCal.jour > dateCal.nbjrs)) then
    //ShowMessage('Date saisie incorrecte')
    dateCal.erreur := 'Date saisie incorrecte'
  else begin
      julien; // calcul du JJD
      affcc;
    end;
end;

procedure calculerJulien;
begin
  bisj;
  nbjrs;
  if ((dateCal.jour < 1) or (dateCal.jour > dateCal.nbjrs)) then
    //ShowMessage('Date saisie incorrecte')
    dateCal.erreur := 'Date saisie incorrecte'
  else begin
      julienj;
      affcc;
    end;
end;

procedure calculerRepublicain;
begin
  bisr;
  nbjrsr;

  if ((dateCal.jour < 1) or (dateCal.jour > dateCal.nbjrs)) then
    //ShowMessage('Date saisie incorrecte')
    dateCal.erreur := 'Date saisie incorrecte'
  else begin
      repuj;
      affcc;
    end;
end;

procedure calculerIsraelien;
begin
  //if (date.AN<1 || date.AN>6260) {alert('hors limites');return;}
  BISI;

  if ((dateCal.jour < 1) or (dateCal.jour > dateCal.nbjrs)) then
    //ShowMessage('Date saisie incorrecte')
    dateCal.erreur := 'Date saisie incorrecte'
  else begin
      ISRJ; // calcul du JJD
      affcc;
    end;
end;

procedure calculerMusulman;
begin
  //if (date.AN<1 || date.AN>1936) {alert('hors limites');return;}
  BISM;
  nbjrsm;

  if ((dateCal.jour < 1) or (dateCal.jour > dateCal.nbjrs)) then
    //ShowMessage('Date saisie incorrecte')
    dateCal.erreur := 'Date saisie incorrecte'
  else begin
      MUSULJ; // calcul du JJD
      affcc;
    end;
end;

procedure calculerCopte;
begin
  //if (date.AN<1 || date.AN>2216) {alert('hors limites');return;}
  BISC;
  nbjrsc;

  if ((dateCal.jour < 1) or (dateCal.jour > dateCal.nbjrs)) then
    //ShowMessage('Date saisie incorrecte')
    dateCal.erreur := 'Date saisie incorrecte'
  else begin
      COPTEJ;
      affcc;
    end;
end;

end.
