{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Import_textfile_2_table;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, u_comp_TBlueFlatSpeedButton, Buttons,
  ExtCtrls, TFlatPanelUnit, TFlatCheckBoxUnit,
  TFlatRadioButtonUnit,
  u_objet_TIntegerList, ComCtrls, CheckLst, Db, DBTables,
  TFlatGroupBoxUnit, IBCustomDataSet, IBQuery, dxEditor, dxExEdtr,
  dxEdLib, dxCntner, TFlatSpeedButtonUnit, u_comp_TGoodBtn,
  u_comp_TYLanguage, DynamicSkinForm;

type
  TFImportTextFile2Table = class(TSuperForm)
    pBorder: TPanel;
    Panel5: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Label1: TLabel;
    BlueFlatSpeedButton1: TBlueFlatSpeedButton;
    panEtape1: TPanel;
    Label3: TLabel;
    Label6: TLabel;
    panEtape2: TPanel;
    Label5: TLabel;
    Label7: TLabel;
    FlatGroupBox2: TFlatGroupBox;
    Label10: TLabel;
    cbIncludeEntete: TFlatCheckBox;
    edStringDelimitor: TdxPickEdit;
    FlatPanel1: TFlatPanel;
    btnEqual: TBlueFlatSpeedButton;
    btnNot: TBlueFlatSpeedButton;
    Label13: TLabel;
    Panel1: TPanel;
    Label4: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    DstList: TListView;
    SrcList: TListView;
    panEtape3: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    FlatGroupBox1: TFlatGroupBox;
    Panel6: TPanel;
    rbPV: TFlatRadioButton;
    rbV: TFlatRadioButton;
    rbTab: TFlatRadioButton;
    rbAutre: TFlatRadioButton;
    edAutreSep: TdxEdit;
    edFileName: TdxEdit;
    OpenDialog: TOpenDialog;
    QueryAdd: TIBQuery;
    QueryTest: TIBQuery;
    btnImport: TGoodBtn;
    btnCancel: TGoodBtn;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure BlueFlatSpeedButton1Click(Sender: TObject);
    procedure FormatFichierChange(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure btnEqualClick(Sender: TObject);
    procedure btnNotClick(Sender: TObject);
    procedure DstListClick(Sender: TObject);
    procedure SrcListDblClick(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private

    fNumColumnsSource: TIntegerList;
    fColumnsTestdoublon: TstringList;
    fTableName: string;
    fParamsTable: TParams;
    fUsePrimaryIndex: boolean;
    fNamePrimaryIndex: string;
    fNameGeneratorPrimaryIndex: string;
    fOnBeforeInsertRecord: TDataSetNotifyEvent;
    fInvisibleParamNames: TStringList;

    procedure DetectColonnes;
    function LoadFirstLine(var line: string): boolean;
    //          function Importation: boolean;
    procedure DoRefreshDstList;
    procedure DoMakeEquivalence;
    procedure DoMakeDoublonList;
    procedure UploadInDatabase;



  public
    property TableName: string read fTableName write fTableName;
    property ParamsTable: TParams read fParamsTable write fParamsTable;
    property UsePrimaryIndex: boolean read fUsePrimaryIndex write fUsePrimaryIndex;
    property NamePrimaryIndex: string read fNamePrimaryIndex write fNamePrimaryIndex;
    property NameGeneratorPrimaryIndex: string read fNameGeneratorPrimaryIndex write fNameGeneratorPrimaryIndex;
    property InvisibleParamNames: TStringList read fInvisibleParamNames write fInvisibleParamNames;
    property OnBeforeInsertRecord: TDataSetNotifyEvent read fOnBeforeInsertRecord write fOnBeforeInsertRecord;
  end;

const
  ColorOn = $007DCBE6;
  ColorOff = $00A918E7;

implementation

uses
  u_objet_TCut, u_dm, u_common_var, u_common_const, u_form_main;

{$R *.DFM}

procedure TFImportTextFile2Table.SuperFormCreate(Sender: TObject);
begin

  if _Context.Skin then
    begin
      ClientHeight := 517;
      ClientWidth := 493;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fOnBeforeInsertRecord := nil;
  fParamsTable := TParams.create;
  fNumColumnsSource := TIntegerList.create;
  fColumnsTestdoublon := TstringList.create;
  fInvisibleParamNames := TStringList.create;

  fTableName := '';
  fUsePrimaryIndex := false;
  fNamePrimaryIndex := '';
  fNameGeneratorPrimaryIndex := '';
  OpenDialog.InitialDir := _Context.PathDocs;
end;

procedure TFImportTextFile2Table.BlueFlatSpeedButton1Click(Sender: TObject);
begin
  if OpenDialog.Execute then
    begin
      edFileName.Text := OpenDialog.FileName;
      DetectColonnes;
      DoRefreshControls;
    end;
end;

function TFImportTextFile2Table.LoadFirstLine(var line: string): boolean;
var
  F: TextFile;
begin
  result := false;
  try
    try
      AssignFile(F, edFileName.Text);
      Reset(F);
      Readln(F, Line);
    finally
      CloseFile(F);
    end;
    result := true;
  except
  end;
end;

procedure TFImportTextFile2Table.DetectColonnes;
var
  s, m: string;
  fCut: TCut;
  n: integer;
  aItem: TListItem;
begin
  try
    SrcList.Items.Clear;

    if LoadFirstLine(s) then
      begin

        fCut := TCut.create;
        try
          //Chane  dcouper
          fCut.Line := s;

          //Sparateur de colonne
          if rbPV.checked then fCut.ParamSeparator := ';'
          else
            if rbV.checked then fCut.ParamSeparator := ','
            else
              if rbTab.checked then fCut.ParamSeparator := #9
              else
                if rbAutre.checked then fCut.ParamSeparator := edAutreSep.text;

          //Dlimiteur de chane de caractte
          fCut.StringDelimitor := edStringDelimitor.Text;

          fCut.SetParamCountAsInLine;
          fCut.StrToParams;

          for n := 0 to fCut.Params.Count - 1 do
            begin
              m := fCut.Params[n].AsString;
              if not cbIncludeEntete.checked then m := 'Colonne ' + inttostr(n + 1) + ' (' + m + ')';
              aItem := SrcList.Items.Add;
              aItem.Caption := m;
            end;

        finally
          fCut.Free;
        end;
      end;
  except
  end;

  DoRefreshControls;
end;

procedure TFImportTextFile2Table.FormatFichierChange(Sender: TObject);
begin
  DetectColonnes;
end;

procedure TFImportTextFile2Table.SuperFormRefreshControls(Sender: TObject);
var
  n: integer;
  ok: boolean;
begin
  Ok := (trim(edFileName.Text) <> '');
  panEtape1.Color := ColorOn;

  if Ok then panEtape2.Color := ColorOn else panEtape2.Color := ColorOff;

  Ok := (trim(edFileName.Text) <> '') and (SrcList.Items.Count > 0);
  if Ok then panEtape3.Color := ColorOn else panEtape3.Color := ColorOff;
  btnEqual.enabled := (DstList.Selected <> nil) and (SrcList.Selected <> nil);
  btnNot.enabled := (DstList.Selected <> nil);

  ok := false;
  for n := 0 to fNumColumnsSource.Count - 1 do if fNumColumnsSource[n] <> -1 then ok := true;
  btnImport.enabled := ok;
end;


procedure TFImportTextFile2Table.SuperFormDestroy(Sender: TObject);
begin
  fParamsTable.Free;
  fNumColumnsSource.Free;
  fColumnsTestdoublon.Free;
  fInvisibleParamNames.Free;
end;

procedure TFImportTextFile2Table.SuperFormShowFirstTime(Sender: TObject);
var
  n: integer;
begin

  //Correspondance avec les numros de colonne du fichier texte
  fNumColumnsSource.Clear;
  for n := 0 to fParamsTable.Count - 1 do
    //  if fInvisibleParamNames.IndexOf(fParamsTable[n].Name) = -1 then ///////// avant comment
    begin
      fNumColumnsSource.Add(-1);
    end;

  DoRefreshDstList;
  DoRefreshControls;
end;

procedure TFImportTextFile2Table.DoRefreshDstList;
var
  n: integer;
  s: string;
  aItem: TListItem;
begin
  DstList.Items.Clear;

  for n := 0 to fParamsTable.Count - 1 do
    begin
      aItem := DstList.Items.Add;

      if fNumColumnsSource[n] = -1
        then s := ''
      else s := '= ' + SrcList.Selected.Caption;

      aItem.Caption := fParamsTable[n].Name;
      aItem.SubItems.Add(s);
    end;

  //     if DstList.Items.Count > 0 then DstList.Selected := 0;
end;


procedure TFImportTextFile2Table.DoMakeEquivalence;
var
  k, p: integer;
  aItem, aItemSrc: TListItem;
begin
  aItem := DstList.Selected;
  k := aItem.Index;
  aItemSrc := SrcList.Selected;
  p := aItemSrc.Index;

  fNumColumnsSource[k] := p;
  aItem.SubItems[0] := aItemSrc.Caption;

  //On slectionne les lignes suivantes, si possible
  if k < DstList.Items.Count - 1 then DstList.Selected := DstList.Items[k + 1];
  if p < SrcList.Items.Count - 1 then SrcList.Selected := SrcList.Items[p + 1];
end;

procedure TFImportTextFile2Table.DoMakeDoublonList;
begin
  //     DoublonList.Clear;

       {
       for n := 0 to fParamsTable.Count - 1 do
       begin
       DoublonList.Items.Add(fParamsTable[n].Name);
       end;
       }

   //    for n := 0 to fNumColumnsSource.Count - 1 do
     //  begin
       //     if fNumColumnsSource[n] <> -1 then DoublonList.Items.Add(SrcList.Items[fNumColumnsSource[n]].Caption);
      // end;
end;

procedure TFImportTextFile2Table.btnEqualClick(Sender: TObject);
begin
  DoMakeEquivalence;
  DoMakeDoublonList;
  DoRefreshControls;
end;

procedure TFImportTextFile2Table.btnNotClick(Sender: TObject);
var
  k: integer;
  aItem: TListItem;
begin
  aItem := DstList.Selected;
  k := aItem.Index;
  //	aItemSrc:=SrcList.Selected;
  //	p := aItemSrc.Index;

  fNumColumnsSource[k] := -1;
  aItem.SubItems[0] := '';


  DoMakeDoublonList;
  DoRefreshControls;
end;


procedure TFImportTextFile2Table.DstListClick(Sender: TObject);
begin
  DoRefreshControls;
end;

procedure TFImportTextFile2Table.SrcListDblClick(Sender: TObject);
begin
  if (DstList.Selected <> nil) and (SrcList.Selected <> nil) then
    begin
      DoMakeEquivalence;
      DoMakeDoublonList;
      DoRefreshControls;
    end;
end;

procedure TFImportTextFile2Table.UploadInDatabase;
var
  NewID: integer;
  n, tot: integer;
  s: string;
  F: TextFile;
  iCompteur: integer;
  fCut: TCut;
  NothingToUpload: boolean;
  TotRecordOk: integer;
  TotRecordError: integer;
  //TotRecordExcludeCauseDoublon: integer;
  TotRecordInSourceFile: integer;

begin
  TotRecordOk := 0;
  TotRecordError := 0;
  //TotRecordExcludeCauseDoublon := 0;
  TotRecordInSourceFile := 0;
  iCompteur := 0;

  //Liste des doublon
  fColumnsTestdoublon.Clear;

  QueryAdd.Close;
  QueryAdd.Sql.Clear;
  QueryAdd.Sql.Add('insert into ' + fTableName);
  QueryAdd.Sql.Add('(');

  if fUsePrimaryIndex then
    begin
      QueryAdd.Sql.Add(fNamePrimaryIndex);
      tot := 1;
    end
  else tot := 0;

  for n := 0 to fNumColumnsSource.count - 1 do
    begin
      if fNumColumnsSource[n] <> -1 then
        begin
          //               if fInvisibleParamNames.IndexOf(fParamsTable[n].Name) = -1 then ///////// avant comment ///
          begin
            if tot > 0 then s := ',' else s := '';
            s := s + fParamsTable[n].Name;
            QueryAdd.Sql.Add(s);
            tot := tot + 1;
          end;
        end;
    end;

  //les autres colonnes invisibles
  for n := 0 to fInvisibleParamNames.count - 1 do
    begin
      if tot > 0 then s := ',' else s := '';
      s := s + fInvisibleParamNames[n];
      QueryAdd.Sql.Add(s);
      tot := tot + 1;
    end;

  QueryAdd.Sql.Add(')');
  NothingToUpload := ((fUsePrimaryIndex) and (tot = 1)) or ((not fUsePrimaryIndex) and (tot = 0));

  if not NothingToUpload then
    begin
      //Fin de la requte d'ajout
      QueryAdd.Sql.Add('values (');
      if fUsePrimaryIndex then
        begin
          QueryAdd.Sql.Add(':' + fNamePrimaryIndex);
          tot := 1;
        end
      else tot := 0;

      for n := 0 to fNumColumnsSource.count - 1 do
        begin
          if fNumColumnsSource[n] <> -1 then
            begin
              if fInvisibleParamNames.IndexOf(fParamsTable[n].Name) = -1 then
                begin
                  if tot > 0 then s := ',' else s := '';
                  s := s + ':' + fParamsTable[n].Name;
                  QueryAdd.Sql.Add(s);
                  tot := tot + 1;
                end;
            end;
        end;

      for n := 0 to fInvisibleParamNames.count - 1 do
        begin
          if tot > 0 then s := ',' else s := '';
          s := s + ':' + fInvisibleParamNames[n];
          QueryAdd.Sql.Add(s);
          tot := tot + 1;
        end;

      QueryAdd.Sql.Add(')');

      fCut := TCut.create;
      try
        //Sparateur de colonne
        if rbPV.checked then fCut.ParamSeparator := ';'
        else
          if rbV.checked then fCut.ParamSeparator := ','
          else
            if rbTab.checked then fCut.ParamSeparator := #9
            else
              if rbAutre.checked then fCut.ParamSeparator := edAutreSep.text;

        //Dlimiteur de chane de caractte
        fCut.StringDelimitor := edStringDelimitor.Text;

        //Nombre de paramtres
        fCut.SetTotalStringParams(SrcList.Items.Count);

        if fCut.Params.Count > 0 then
          begin
            AssignFile(F, edFileName.Text);
            Reset(F);

            //On saute la ligne des enttes si besoin est
            if (not Eof(F)) and (cbIncludeEntete.checked) then ReadLn(F, S);

            while not Eof(F) do
              begin
                ReadLn(F, S);

                fCut.Line := S;
                if fCut.StrToParams then
                  begin
                    inc(TotRecordInSourceFile);

                    try
                      //On fixe les paramtres de la requte
                      QueryAdd.Close;

                      if assigned(fOnBeforeInsertRecord) then fOnBeforeInsertRecord(QueryAdd);

                      //Y a t'il une Primary Key ?
                      if fUsePrimaryIndex then
                        begin

                          NewID := dm.uf_GetClefUnique(NameGeneratorPrimaryIndex);
                          if NewID = -1 then
                            begin
                              inc(TotRecordError);
                              break;
                            end;
                          QueryAdd.ParamByName(fNamePrimaryIndex).AsInteger := NewID;

                        end;

                      //Les autres paramtres
                      for n := 0 to fNumColumnsSource.count - 1 do
                        begin
                          if fNumColumnsSource[n] <> -1 then
                            begin
                              QueryAdd.ParamByName(fParamsTable[n].Name).Value := fCut.Params[fNumColumnsSource[n]].Value;
                            end;
                        end;

                      //On excute la requte
                      QueryAdd.ExecSQL;
                      QueryAdd.Close;

                      inc(iCompteur);

                      if iCompteur = 5000 then
                        begin
                          dm.IBTrans_Secondaire.CommitRetaining;
                          iCompteur := 0;
                        end;

                      inc(TotRecordOk);
                    except
                      inc(TotRecordError);
                    end;
                  end;
              end;
            CloseFile(F);
          end;

      finally
        fCut.Free;
      end;
    end;

  dm.IBTrans_Secondaire.CommitRetaining;

  MessageDlg('Rsum :'#13#10#13#10 + inttostr(TotRecordInSourceFile) + ' enregistrement(s) trait(s).'#13#10
    + inttostr(TotRecordOk) + ' enregistrement(s) rcuprs.'#13#10#13#10
    + inttostr(TotRecordError) + ' enregistrement(s) non rcupr(s) car erreur.'#13#10
    // + inttostr(TotRecordExcludeCauseDoublon) + ' enregistrement(s) non rcuprs car doublon.'
    , mtInformation, [mbOK], 0);
end;

procedure TFImportTextFile2Table.btnImportClick(Sender: TObject);
var Save_Cursor: TCursor;
begin
  if MessageDlg('Confirmez-vous l''importation des donnes du fichier texte, dans la base de donne ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      Save_Cursor := Screen.Cursor;
      Screen.Cursor := crHourglass;
      btnImport.Enabled := False;
      btnCancel.Enabled := False;
      UploadInDatabase;

      btnImport.Enabled := True;
      btnCancel.Enabled := True;
      Screen.Cursor := Save_Cursor;
      ModalResult := mrOk;
    end;
end;

procedure TFImportTextFile2Table.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFImportTextFile2Table.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;

procedure TFImportTextFile2Table.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

end.
