{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_edit_context;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, Buttons, ExtCtrls, TFlatSpeedButtonUnit,
  TFlatPanelUnit, URLLink, dxCntner, dxExEdtr, dxEdLib, dxEditor,
  ColorPickerButton, ComCtrls, WizardTree, TFlatEditUnit,
  TFlatSpinEditUnit, TFlatGroupBoxUnit, TFlatCheckBoxUnit, BrowseDr,
  u_objet_TState, u_comp_TGoodBtn, FileCtrl, u_comp_TYLanguage, jpeg,
  DynamicSkinForm;

type
  TFEditContext = class(TSuperForm)
    pBorder: TPanel;
    Panel2: TPanel;
    fpBoutons: TFlatPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    panDock: TPanel;
    Panel10: TPanel;
    Notebook: TNotebook;
    Label3: TLabel;
    Label2: TLabel;
    slPhotosDir: TdxButtonEdit;
    slGEDCOMDir: TdxButtonEdit;
    cpHommes: TColorPickerButton;
    cpFemmes: TColorPickerButton;
    lTaux: TLabel;
    Label4: TLabel;
    TauxCompressJpeg: TTrackBar;
    WizardTree: TWizardTree;
    edH1: TdxSpinEdit;
    edH2: TdxSpinEdit;
    edH3: TdxSpinEdit;
    edH5: TdxSpinEdit;
    edH6: TdxSpinEdit;
    edF1: TdxSpinEdit;
    edF2: TdxSpinEdit;
    edF3: TdxSpinEdit;
    edF6: TdxSpinEdit;
    Label18: TLabel;
    Label19: TLabel;
    edH4: TdxSpinEdit;
    edF4: TdxSpinEdit;
    ed7: TdxSpinEdit;
    Label14: TLabel;
    Label15: TLabel;
    cbShowHint: TdxCheckEdit;
    chbExit: TdxCheckEdit;
    FlatGroupBox2: TFlatGroupBox;
    Label5: TLabel;
    Bevel4: TBevel;
    Label115: TLabel;
    Label114: TLabel;
    Label6: TLabel;
    Bevel5: TBevel;
    Label117: TLabel;
    edButtonTransparence: TLabel;
    Label17: TLabel;
    Bevel6: TBevel;
    Label20: TLabel;
    Bevel7: TBevel;
    edBorderColor: TdxButtonEdit;
    edBorderStyle: TdxPickEdit;
    edButtonViewStyle: TdxPickEdit;
    ButtonTransparence: TdxPickEdit;
    cbLeft: TdxCheckEdit;
    cbRight: TdxCheckEdit;
    cbBottom: TdxCheckEdit;
    cbTop: TdxCheckEdit;
    cbHotTrack: TdxCheckEdit;
    cbShadow: TdxCheckEdit;
    Panel7: TPanel;
    Label21: TLabel;
    Label22: TLabel;
    Label24: TLabel;
    cbShowCousins: TdxCheckEdit;
    edPathDocs: TdxButtonEdit;
    Label26: TLabel;
    TempStyleCont: TdxEditStyleController;
    Panel6: TPanel;
    rbPatMaj: TRadioButton;
    rbPatFirst: TRadioButton;
    rbPatNormal: TRadioButton;
    Panel8: TPanel;
    rbPreMaj: TRadioButton;
    rbPreFirst: TRadioButton;
    prPreNormal: TRadioButton;
    cbActiveControl: TdxCheckEdit;
    fseArbreReduit: TdxSpinEdit;
    edNbFicheInHistorique: TdxSpinEdit;
    ColorDialog: TColorDialog;
    CheckAgeMiniMariage: TdxCheckEdit;
    CheckAgeMaxiMariage: TdxCheckEdit;
    CheckAgeMiniNaissanceEnfant: TdxCheckEdit;
    CheckAgeMaxiNaissanceEnfant: TdxCheckEdit;
    CheckEsperanceVie: TdxCheckEdit;
    CheckEcartAgeEpoux: TdxCheckEdit;
    CheckNbJourEntreNaissance: TdxCheckEdit;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    cbAnimArbre: TdxCheckEdit;
    cbArbreHorizontal: TdxCheckEdit;
    Label1: TLabel;
    edArbreShowNbGeneration: TdxSpinEdit;
    Label7: TLabel;
    edRoueShowNbGeneration: TdxSpinEdit;
    BrowseDirectoryDlg: TdfsBrowseDirectoryDlg;
    cbWeb: TdxCheckEdit;
    Shape1: TShape;
    Language: TYLanguage;
    chbBackup: TdxCheckEdit;
    Panel9: TPanel;
    Image1: TImage;
    Label8: TLabel;
    cbPhotos: TdxCheckEdit;
    Panel11: TPanel;
    Panel12: TPanel;
    cbSonsBase: TdxCheckEdit;
    cbVideosBase: TdxCheckEdit;
    cbInsee: TdxCheckEdit;
    rbFrench: TRadioButton;
    rbEnglish: TRadioButton;
    Label9: TLabel;
    cbSkin: TdxCheckEdit;
    cbNip: TdxCheckEdit;
    spDynamicSkinForm1: TspDynamicSkinForm;
    cbAgent: TdxCheckEdit;
    btnAgent: TFlatSpeedButton;
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TauxCompressJpegChange(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure WizardTreeChanging(Sender: TObject; NewItemIndex: Integer; var AllowChange: Boolean);
    procedure SuperFormFillFields(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure slPhotosDirButtonClick(Sender: TObject; AbsoluteIndex: Integer);
    procedure slGEDCOMDirButtonClick(Sender: TObject; AbsoluteIndex: Integer);
    procedure edPathDocsButtonClick(Sender: TObject; AbsoluteIndex: Integer);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure SuperFormFillProperties(Sender: TObject);
    procedure edBorderColorButtonClick(Sender: TObject;
      AbsoluteIndex: Integer);
    procedure edBorderColorDblClick(Sender: TObject);
    procedure edBorderStyleChange(Sender: TObject);
    procedure edButtonViewStyleChange(Sender: TObject);
    procedure ButtonTransparenceChange(Sender: TObject);
    procedure cbLeftClick(Sender: TObject);
    procedure cbTopClick(Sender: TObject);
    procedure cbRightClick(Sender: TObject);
    procedure cbBottomClick(Sender: TObject);
    procedure cbHotTrackClick(Sender: TObject);
    procedure cbShadowClick(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure cbActiveControlChange(Sender: TObject);
    procedure cbAgentChange(Sender: TObject);
    procedure btnAgentClick(Sender: TObject);
  private
    fFill: TState;
  public

  end;

implementation

uses u_common_func, u_dm, u_common_var, u_objet_TContext, u_common_const,
  u_form_main, u_Form_Agent;

{$R *.DFM}

procedure TFEditContext.Label10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFEditContext.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TFEditContext.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_PARAMETRES);
  end;
end;

procedure TFEditContext.TauxCompressJpegChange(Sender: TObject);
begin
  lTaux.Caption := IntToStr(TauxCompressJpeg.Position) + ' %';
end;

procedure TFEditContext.PaintBox1Paint(Sender: TObject);
begin
  PaintPointille(Sender);
end;

procedure TFEditContext.WizardTreeChanging(Sender: TObject;
  NewItemIndex: Integer; var AllowChange: Boolean);
begin
  //     if fFill.value = false then
  begin
    Notebook.PageIndex := NewItemIndex;

    DoRefreshControls;
  end;
end;

procedure TFEditContext.SuperFormFillFields(Sender: TObject);
begin
  fFill.Value := true;
  try
    TempStyleCont.BorderColor := dm.StyleController.BorderColor;
    TempStyleCont.BorderStyle := dm.StyleController.BorderStyle;
    TempStyleCont.ButtonStyle := dm.StyleController.ButtonStyle;
    TempStyleCont.ButtonTransparence := dm.StyleController.ButtonTransparence;
    TempStyleCont.Edges := dm.StyleController.Edges;
    TempStyleCont.HotTrack := dm.StyleController.HotTrack;
    TempStyleCont.Shadow := dm.StyleController.Shadow;

    case _Context.ModeSaisieNom of
      msAllUpper: rbPatMaj.checked := true;
      msJustFirstLetterUpper: rbPatFirst.checked := true;
      else rbPatNormal.checked := true;
    end;

    case _Context.ModeSaisiePrenom of
      msAllUpper: rbPreMaj.checked := true;
      msJustFirstLetterUpper: rbPreFirst.checked := true;
      else prPreNormal.checked := true;
    end;

    //---------------------------------------------------------------
    cpHommes.SelectionColor := _Context.ColorHomme;
    cpFemmes.SelectionColor := _Context.ColorFemme;

    TauxCompressJpeg.Position := _Context.TauxCompressionJPeg;
    lTaux.Caption := IntToStr(TauxCompressJpeg.Position) + ' %';

    //---------------------------------------------------------------
    cbSonsBase.checked := _Context.SonsBase = 1;
    cbVideosBase.checked := _Context.VideosBase = 1;

    if _Context.ChoixCartesInternet = 'www.expedia.fr' then
      rbFrench.checked := true
    else
      rbEnglish.checked := true;

    edH1.IntValue := _Context.AgeMiniMariageHommes;
    edF1.IntValue := _Context.AgeMiniMariageFemmes;
    edH2.IntValue := _Context.AgeMaxiMariageHommes;
    edF2.IntValue := _Context.AgeMaxiMariageFemmes;
    edH3.IntValue := _Context.AgeMiniNaissanceEnfantHommes;
    edF3.IntValue := _Context.AgeMiniNaissanceEnfantFemmes;
    edH4.IntValue := _Context.AgeMaxiNaissanceEnfantHommes;
    edF4.IntValue := _Context.AgeMaxiNaissanceEnfantFemmes;
    edH6.IntValue := _Context.AgeMaxiAuDecesHommes;
    edF6.IntValue := _Context.AgeMaxiAuDecesFemmes;
    ed7.IntValue := _Context.EcartAgeEntreEpoux;
    edH5.IntValue := _Context.NbJourEntre2NaissancesNormales;

    cbActiveControl.checked := _Context.CoherenceActive;

    CheckAgeMiniMariage.checked := _Context.CheckAgeMiniMariage;
    CheckAgeMaxiMariage.checked := _Context.CheckAgeMaxiMariage;
    CheckAgeMiniNaissanceEnfant.checked := _Context.CheckAgeMiniNaissanceEnfant;
    CheckAgeMaxiNaissanceEnfant.checked := _Context.CheckAgeMaxiNaissanceEnfant;
    CheckEsperanceVie.checked := _Context.CheckEsperanceVie;
    CheckEcartAgeEpoux.checked := _Context.CheckEcartAgeEpoux;
    CheckNbJourEntreNaissance.checked := _Context.CheckNbJourEntreNaissance;

    cbInsee.checked := _Context.AfficheInsee;
    cbSkin.Checked := _Context.Skin;

    cbNip.Checked := _Context.Nip = 1;

    //---------------------------------------------------------------
    slPhotosDir.Text := _Context.PathImages;
    slGEDCOMDir.Text := _Context.PathImportExport;
    edPathDocs.Text := _Context.PathDocs;

    cbShowHint.checked := _Context.CanSeeHint;
    cbPhotos.Checked := _Context.Photos;
    cbWeb.Checked := _Context.ShowWeb;
    chbExit.checked := _Context.ShowExit;
    chbBackup.Checked := _Context.Backup;
    //cbOpenWinDossier.checked := _Context.ActiveFenetreDossier;
    cbShowCousins.checked := _Context.RefreshCousins;
    cbAnimArbre.checked := _Context.AnimArbre;
    cbArbreHorizontal.checked := _Context.ArbreHorizontal;
    fseArbreReduit.IntValue := _Context.ArbreReduit;
    edNbFicheInHistorique.IntValue := _Context.MaxFicheDansHistorique;

    cbAgent.Checked := _Context.useAgent;
    btnAgent.Enabled := cbAgent.Checked;

    edArbreShowNbGeneration.IntValue := _Context.ArbreShowNbGeneration;
    edRoueShowNbGeneration.IntValue := _Context.RoueShowNbGeneration;

    //---------------------------------------------------------------
    edBorderColor.Color := _Context.SC_BorderColor;
    edBorderStyle.Text := _Context.SC_BorderStyle;
    edButtonViewStyle.Text := _Context.SC_ButtonStyle;
    ButtonTransparence.Text := _Context.SC_Transparence;
    cbLeft.Checked := _Context.SC_EdgesLeft;
    cbRight.Checked := _Context.SC_EdgesRight;
    cbTop.Checked := _Context.SC_EdgesTop;
    cbBottom.Checked := _Context.SC_EdgesBottom;
    cbHotTrack.Checked := _Context.SC_HotTrack;
    cbShadow.Checked := _Context.SC_Shadow;
  finally
    fFill.Value := false;
  end;
end;

procedure TFEditContext.SuperFormShowFirstTime(Sender: TObject);
begin

  doFillFields;
end;

procedure TFEditContext.slPhotosDirButtonClick(Sender: TObject; AbsoluteIndex: Integer);
begin
  BrowseDirectoryDlg.Selection := slPhotosDir.Text;
  if BrowseDirectoryDlg.Execute then slPhotosDir.Text := BrowseDirectoryDlg.Selection;
end;

procedure TFEditContext.slGEDCOMDirButtonClick(Sender: TObject; AbsoluteIndex: Integer);
begin
  BrowseDirectoryDlg.Selection := slGEDCOMDir.Text;
  if BrowseDirectoryDlg.Execute then slGEDCOMDir.Text := BrowseDirectoryDlg.Selection;
end;

procedure TFEditContext.edPathDocsButtonClick(Sender: TObject; AbsoluteIndex: Integer);
begin
  BrowseDirectoryDlg.Selection := edPathDocs.Text;
  if BrowseDirectoryDlg.Execute then edPathDocs.Text := BrowseDirectoryDlg.Selection;
end;

procedure TFEditContext.bsfbSelectionClick(Sender: TObject);
begin
  doFillProperties;
end;

procedure TFEditContext.SuperFormFillProperties(Sender: TObject);
begin
  dm.StyleController.BorderColor := TempStyleCont.BorderColor;
  dm.StyleController.BorderStyle := TempStyleCont.BorderStyle;
  dm.StyleController.ButtonStyle := TempStyleCont.ButtonStyle;
  dm.StyleController.ButtonTransparence := TempStyleCont.ButtonTransparence;
  dm.StyleController.Edges := TempStyleCont.Edges;
  dm.StyleController.HotTrack := TempStyleCont.HotTrack;
  dm.StyleController.Shadow := TempStyleCont.Shadow;


  if rbPatMaj.checked then _Context.ModeSaisieNom := msAllUpper
  else
    if rbPatFirst.checked then _Context.ModeSaisieNom := msJustFirstLetterUpper
    else
      _Context.ModeSaisieNom := msNormal;

  if rbPreMaj.checked then _Context.ModeSaisiePrenom := msAllUpper
  else
    if rbPreFirst.checked then _Context.ModeSaisiePrenom := msJustFirstLetterUpper
    else
      _Context.ModeSaisiePrenom := msNormal;

  //---------------------------------------------------------------
  _Context.ColorHomme := cpHommes.SelectionColor;
  _Context.ColorFemme := cpFemmes.SelectionColor;

  _Context.TauxCompressionJPeg := TauxCompressJpeg.Position;

  //---------------------------------------------------------------
  if cbSonsBase.Checked then
    _Context.SonsBase := 1
  else
    _Context.SonsBase := 0;

  if cbVideosBase.Checked then
    _Context.VideosBase := 1
  else
    _Context.VideosBase := 0;

  _Context.AgeMiniMariageHommes := edH1.IntValue;
  _Context.AgeMiniMariageFemmes := edF1.IntValue;
  _Context.AgeMaxiMariageHommes := edH2.IntValue;
  _Context.AgeMaxiMariageFemmes := edF2.IntValue;
  _Context.AgeMiniNaissanceEnfantHommes := edH3.IntValue;
  _Context.AgeMiniNaissanceEnfantFemmes := edF3.IntValue;
  _Context.AgeMaxiNaissanceEnfantHommes := edH4.IntValue;
  _Context.AgeMaxiNaissanceEnfantFemmes := edF4.IntValue;
  _Context.AgeMaxiAuDecesHommes := edH6.IntValue;
  _Context.AgeMaxiAuDecesFemmes := edF6.IntValue;
  _Context.EcartAgeEntreEpoux := ed7.IntValue;
  _Context.NbJourEntre2NaissancesNormales := edH5.IntValue;

  _Context.CoherenceActive := cbActiveControl.checked;
  _Context.AfficheInsee := cbInsee.checked;

  if cbNIP.Checked then
    _Context.Nip := 1
  else
    _Context.Nip := 0;

  _Context.CheckAgeMiniMariage := CheckAgeMiniMariage.checked;
  _Context.CheckAgeMaxiMariage := CheckAgeMaxiMariage.checked;
  _Context.CheckAgeMiniNaissanceEnfant := CheckAgeMiniNaissanceEnfant.checked;
  _Context.CheckAgeMaxiNaissanceEnfant := CheckAgeMaxiNaissanceEnfant.checked;
  _Context.CheckEsperanceVie := CheckEsperanceVie.checked;
  _Context.CheckEcartAgeEpoux := CheckEcartAgeEpoux.checked;
  _Context.CheckNbJourEntreNaissance := CheckNbJourEntreNaissance.checked;

  //---------------------------------------------------------------
  _Context.PathImages := slPhotosDir.Text;
  _Context.PathImportExport := slGEDCOMDir.Text;
  _Context.PathDocs := edPathDocs.Text;
  //     _Context.PathWord := edPathWord.Text;
  //     _Context.PathAdobe := edPathAdobe.Text;
       //---------------------------------------------------------------

  _Context.Photos := cbPhotos.Checked;
  _Context.CanSeeHint := cbShowHint.checked;
  _Context.Backup := chbBackup.Checked;
  _Context.ShowExit := chbExit.checked;
  _Context.ShowWeb := cbWeb.Checked;
  //_Context.ActiveFenetreDossier := cbOpenWinDossier.checked;
  _Context.RefreshCousins := cbShowCousins.checked;
  _Context.AnimArbre := cbAnimArbre.Checked;
  _Context.ArbreHorizontal := cbArbreHorizontal.checked;
  _Context.ArbreReduit := fseArbreReduit.IntValue;
  _Context.MaxFicheDansHistorique := edNbFicheInHistorique.IntValue;
  _Context.ArbreShowNbGeneration := edArbreShowNbGeneration.IntValue;
  _Context.RoueShowNbGeneration := edRoueShowNbGeneration.IntValue;


  //---------------------------------------------------------------
  _Context.SC_BorderColor := edBorderColor.Color;
  _Context.SC_BorderStyle := edBorderStyle.Text;
  _Context.SC_ButtonStyle := edButtonViewStyle.Text;
  _Context.SC_Transparence := ButtonTransparence.Text;
  _Context.SC_EdgesLeft := cbLeft.Checked;
  _Context.SC_EdgesRight := cbRight.Checked;
  _Context.SC_EdgesTop := cbTop.Checked;
  _Context.SC_EdgesBottom := cbBottom.Checked;
  _Context.SC_HotTrack := cbHotTrack.Checked;
  _Context.SC_Shadow := cbShadow.Checked;

  _Context.useAgent := cbAgent.Checked;


  if rbFrench.checked then
    _Context.ChoixCartesInternet := 'www.expedia.fr'
  else
    _Context.ChoixCartesInternet := 'www.expedia.com';

  _Context.Skin := cbSkin.Checked;

  _Context.ShouldSave := true;
end;


procedure TFEditContext.edBorderColorButtonClick(Sender: TObject;
  AbsoluteIndex: Integer);
begin
  ColorDialog.Color := edBorderColor.Color;
  if ColorDialog.Execute then
    begin
      edBorderColor.Color := ColorDialog.Color;
      edBorderColor.Font.Color := ColorToRGB(edBorderColor.Color) xor $FFFFFF;
      TempStyleCont.BorderColor := edBorderColor.Color;
    end;

end;

procedure TFEditContext.edBorderColorDblClick(Sender: TObject);
begin
  edBorderColorButtonClick(nil, 0);
end;

procedure TFEditContext.edBorderStyleChange(Sender: TObject);
begin
  TempStyleCont.BorderStyle := TdxEditBorderStyle(edBorderStyle.ItemIndex);
end;

procedure TFEditContext.edButtonViewStyleChange(Sender: TObject);
begin
  TempStyleCont.ButtonStyle := TdxEditButtonViewStyle(edButtonViewStyle.ItemIndex);
end;

procedure TFEditContext.ButtonTransparenceChange(Sender: TObject);
begin
  TempStyleCont.ButtonTransparence := TdxEditButtonTransparence(ButtonTransparence.ItemIndex);
end;

procedure TFEditContext.cbLeftClick(Sender: TObject);
begin
  with TempStyleCont do
    begin
      if cbLeft.Checked then
        Edges := Edges + [edgLeft]
      else
        Edges := Edges - [edgLeft];
    end;
end;

procedure TFEditContext.cbTopClick(Sender: TObject);
begin
  with TempStyleCont do
    begin
      if cbTop.Checked then
        Edges := Edges + [edgTop]
      else
        Edges := Edges - [edgTop];
    end;
end;

procedure TFEditContext.cbRightClick(Sender: TObject);
begin
  with TempStyleCont do
    begin
      if cbRight.Checked then
        Edges := Edges + [edgRight]
      else
        Edges := Edges - [edgRight];
    end;
end;

procedure TFEditContext.cbBottomClick(Sender: TObject);
begin
  with TempStyleCont do
    begin
      if cbBottom.Checked then
        Edges := Edges + [edgBottom]
      else
        Edges := Edges - [edgBottom];
    end;
end;

procedure TFEditContext.cbHotTrackClick(Sender: TObject);
begin
  TempStyleCont.HotTrack := cbHotTrack.Checked;
end;

procedure TFEditContext.cbShadowClick(Sender: TObject);
begin
  TempStyleCont.Shadow := cbShadow.Checked;
end;

procedure TFEditContext.SuperFormCreate(Sender: TObject);
begin

  _Agent.doAgent('Suggest', '', FMain.Left, FMain.Top);

  cbSkin.Enabled := DirExists(ExtractFilePath(Application.ExeName) + 'Skins');

  if _Context.Skin then
    begin
      ClientHeight := 442;
      ClientWidth := 602;
    end
  else
    begin
      // SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fFill := TState.create(false);
  Notebook.ActivePage := 'page3';
end;

procedure TFEditContext.SuperFormDestroy(Sender: TObject);
begin
_Agent.doAgent('Hide', '', 0,0);
  fFill.free;
end;

procedure TFEditContext.cbActiveControlChange(Sender: TObject);
begin
  if fFill.Value = false then
    begin
      fFill.Value := true;
      try
        CheckAgeMiniMariage.checked := cbActiveControl.checked;
        CheckAgeMaxiMariage.checked := cbActiveControl.checked;
        CheckAgeMiniNaissanceEnfant.checked := cbActiveControl.checked;
        CheckAgeMaxiNaissanceEnfant.checked := cbActiveControl.checked;
        CheckEsperanceVie.checked := cbActiveControl.checked;
        CheckEcartAgeEpoux.checked := cbActiveControl.checked;
        CheckNbJourEntreNaissance.checked := cbActiveControl.checked;

      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFEditContext.cbAgentChange(Sender: TObject);
begin
  if cbAgent.Checked then
    begin
      _Agent.doCreate(True);
    end
  else
    begin
   //  _Agent.doAgent('Announce', 'Dommage, je vous aimais bien, moi.....', Left, top);
      _Agent.doDestroy;
    end;

  btnAgent.Enabled := cbAgent.Checked;
end;

procedure TFEditContext.btnAgentClick(Sender: TObject);
var aFAgent: TFAgent;
begin

  aFAgent := TFAgent.create(self);
  try
    aFAgent.ShowModal;
  finally
    aFAgent.Free;
  end;

end;

end.

