{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_edit_raccourcis;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, StdCtrls, ExtCtrls,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery,
  dxCntner, dxTL, dxDBCtrl, dxDBGrid, TFlatButtonUnit, Buttons,
  u_comp_TGoodBtn, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFEditRaccourcis = class(TSuperForm)
    Query: TIBQuery;
    IBUpdateSQL: TIBUpdateSQL;
    DataSource: TDataSource;
    pBorder: TPanel;
    Panel7: TPanel;
    Panel4: TPanel;
    lbTitle: TLabel;
    Label1: TLabel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel1: TPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1RAC_CLEF: TdxDBGridMaskColumn;
    dxDBGrid1RAC_RAC: TdxDBGridMaskColumn;
    dxDBGrid1RAC_LIBELLE: TdxDBGridMaskColumn;
    dxDBGrid1RAC_DOSSIER: TdxDBGridMaskColumn;
    dxDBGrid1RAC_LANGUE: TdxDBGridMaskColumn;
    btnImport: TGoodBtn;
    btnFermer: TGoodBtn;
    btnExport: TGoodBtn;
    btnAdd: TGoodBtn;
    btnDel: TGoodBtn;
    Label3: TLabel;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure QueryNewRecord(DataSet: TDataSet);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnExportClick(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormCreate(Sender: TObject);
  private
    procedure OpenQuery;
    procedure OnBeforeInsertRecord(DataSet: TDataSet);
  public

  end;



implementation

uses u_dm, u_common_var, u_form_export_table_2_textfile,
  u_form_Import_textfile_2_table, u_common_func, u_common_const,
  u_form_main;

{$R *.DFM}

{ TFEditRefParticules }

procedure TFEditRaccourcis.OpenQuery;
begin
  Query.DisableControls;
  try
    Query.Close;
    Query.ParamByName('LANGUE').AsString := _Context.Langue;
    Query.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    Query.Open;
    Query.Last;
    Query.First;
  finally
    Query.EnableControls;
  end;

  doRefreshControls;
end;

procedure TFEditRaccourcis.SuperFormShowFirstTime(Sender: TObject);
begin
  OpenQuery;
end;

procedure TFEditRaccourcis.SuperFormRefreshControls(Sender: TObject);
begin
  btnImport.enabled := (Query.Active);
  btnExport.enabled := (Query.Active);
  btnAdd.enabled := (Query.Active);
  btnDel.enabled := (Query.Active) and (Query.RecordCount > 0);
end;

procedure TFEditRaccourcis.btnAddClick(Sender: TObject);
begin
  Query.Insert;
  doRefreshControls;
  SendFocus(dxDBGrid1);
end;

procedure TFEditRaccourcis.btnDelClick(Sender: TObject);
begin
  Query.Delete;
  doRefreshControls;
  SendFocus(dxDBGrid1);
end;

procedure TFEditRaccourcis.QueryNewRecord(DataSet: TDataSet);
begin
  DataSet.FieldByName('RAC_CLEF').AsInteger := dm.uf_GetClefUnique('REF_RACCOURCIS');
  DataSet.FieldByName('RAC_RAC').AsString := '';
  DataSet.FieldByName('RAC_LIBELLE').AsString := '';
  DataSet.FieldByName('RAC_LANGUE').AsString := _Context.Langue;
  DataSet.FieldByName('RAC_DOSSIER').AsInteger := dm.NumDossier;
end;

procedure TFEditRaccourcis.SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    if (Query.Active) and (Query.State in [dsEdit, dsInsert]) then Query.Post;
  except
  end;

  dm.IBTrans_Secondaire.CommitRetaining;
  dm.IBQueryRaccourcis.Close;
  dm.IBQueryRaccourcis.Open;
end;


procedure TFEditRaccourcis.btnExportClick(Sender: TObject);
var
  aFExportTable2TextFile: TFExportTable2TextFile;
begin
  aFExportTable2TextFile := TFExportTable2TextFile.create(self);
  try
    aFExportTable2TextFile.TableName := 'REF_RACCOURCIS';
    aFExportTable2TextFile.PropositionFileNameExport := 'Raccourcis.txt';
    aFExportTable2TextFile.CondSelect := '(RAC_DOSSIER=' + inttostr(dm.NumDossier) + ') AND (RAC_LANGUE=''' + _Context.Langue + ''')';
    aFExportTable2TextFile.ShowModal;
  finally
    aFExportTable2TextFile.Free;
  end;
end;

procedure TFEditRaccourcis.btnImportClick(Sender: TObject);
var
  aFImportTextFile2Table: TFImportTextFile2Table;
begin
  aFImportTextFile2Table := TFImportTextFile2Table.create(self);
  try
    aFImportTextFile2Table.TableName := 'REF_RACCOURCIS';
    aFImportTextFile2Table.UsePrimaryIndex := true;
    aFImportTextFile2Table.NamePrimaryIndex := 'RAC_CLEF';
    aFImportTextFile2Table.NameGeneratorPrimaryIndex := 'REF_RACCOURCIS';
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RAC_RAC', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RAC_LIBELLE', ptInput);
    aFImportTextFile2Table.InvisibleParamNames.Add('RAC_LANGUE');
    aFImportTextFile2Table.InvisibleParamNames.Add('RAC_DOSSIER');
    aFImportTextFile2Table.OnBeforeInsertRecord := OnBeforeInsertRecord;

    if aFImportTextFile2Table.ShowModal = mrOk then OpenQuery;
  finally
    aFImportTextFile2Table.free;
  end;
end;

procedure TFEditRaccourcis.OnBeforeInsertRecord(DataSet: TDataSet);
begin
  TIBQuery(DataSet).ParamByName('RAC_RAC').AsString := '';
  TIBQuery(DataSet).ParamByName('RAC_LIBELLE').AsString := '';
  TIBQuery(DataSet).ParamByName('RAC_LANGUE').AsString := _Context.Langue;
  TIBQuery(DataSet).ParamByName('RAC_DOSSIER').AsInteger := dm.NumDossier;
end;

procedure TFEditRaccourcis.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFEditRaccourcis.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_EDIT_RACCOURCIS_SAISIE);
  end;
end;

procedure TFEditRaccourcis.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFEditRaccourcis.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 433;
      ClientWidth := 369;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Height := ClientHeight;
end;

end.
