{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_edit_ref_religions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, StdCtrls, ExtCtrls,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery,
  dxCntner, dxTL, dxDBCtrl, dxDBGrid, TFlatButtonUnit, Buttons,
  u_comp_TGoodBtn, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFEditRefReligions = class(TSuperForm)
    Query: TIBQuery;
    IBUpdateSQL: TIBUpdateSQL;
    DataSource: TDataSource;
    pBorder: TPanel;
    Panel7: TPanel;
    Panel4: TPanel;
    lbTitle: TLabel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel1: TPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1RELI_CLEF: TdxDBGridMaskColumn;
    dxDBGrid1RELI_LIBELLE: TdxDBGridMaskColumn;
    dxDBGrid1LANGUE: TdxDBGridMaskColumn;
    btnAdd: TGoodBtn;
    btnDel: TGoodBtn;
    btnImport: TGoodBtn;
    btnExport: TGoodBtn;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure QueryNewRecord(DataSet: TDataSet);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnExportClick(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCreate(Sender: TObject);
  private
    procedure OpenQuery;
    procedure OnBeforeInsertRecord(DataSet: TDataSet);
  public

  end;



implementation

uses u_dm, u_common_var, u_form_export_table_2_textfile,
  u_form_Import_textfile_2_table, u_common_func, u_common_const,
  u_form_main;

{$R *.DFM}

{ TFEditRefParticules }

procedure TFEditRefReligions.OpenQuery;
begin
  Query.DisableControls;
  try
    Query.Close;
    Query.ParamByName('LANGUE').AsString := _Context.Langue;
    Query.Open;
    Query.Last;
    Query.First;
  finally
    Query.EnableControls;
  end;

  doRefreshControls;
end;

procedure TFEditRefReligions.SuperFormShowFirstTime(Sender: TObject);
begin
  OpenQuery;
end;

procedure TFEditRefReligions.SuperFormRefreshControls(Sender: TObject);
begin
  btnImport.enabled := (Query.Active);
  btnExport.enabled := (Query.Active);
  btnAdd.enabled := (Query.Active);
  btnDel.enabled := (Query.Active) and (Query.RecordCount > 0);
end;

procedure TFEditRefReligions.btnAddClick(Sender: TObject);
begin
  Query.Insert;
  doRefreshControls;
  SendFocus(dxDBGrid1);
end;

procedure TFEditRefReligions.btnDelClick(Sender: TObject);
begin
  Query.Delete;
  doRefreshControls;
  SendFocus(dxDBGrid1);
end;

procedure TFEditRefReligions.QueryNewRecord(DataSet: TDataSet);
begin
  DataSet.FieldByName('RELI_CLEF').AsInteger := dm.uf_GetClefUnique('REF_RELIGIONS');
  DataSet.FieldByName('RELI_LIBELLE').AsString := '';
  DataSet.FieldByName('LANGUE').AsString := _Context.Langue;
end;

procedure TFEditRefReligions.SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    if (Query.Active) and (Query.State in [dsEdit, dsInsert]) then Query.Post;
  except
  end;
  dm.IBTrans_Secondaire.CommitRetaining;
end;


procedure TFEditRefReligions.btnExportClick(Sender: TObject);
var
  aFExportTable2TextFile: TFExportTable2TextFile;
begin
  aFExportTable2TextFile := TFExportTable2TextFile.create(self);
  try
    aFExportTable2TextFile.TableName := 'REF_RELIGION';
    aFExportTable2TextFile.PropositionFileNameExport := 'Religions.txt';
    aFExportTable2TextFile.CondSelect := '(LANGUE=''' + _Context.Langue + ''')';
    aFExportTable2TextFile.ShowModal;
  finally
    aFExportTable2TextFile.Free;
  end;
end;

procedure TFEditRefReligions.btnImportClick(Sender: TObject);
var
  aFImportTextFile2Table: TFImportTextFile2Table;
begin
  aFImportTextFile2Table := TFImportTextFile2Table.create(self);
  try
    aFImportTextFile2Table.TableName := 'REF_RELIGION';
    aFImportTextFile2Table.UsePrimaryIndex := true;
    aFImportTextFile2Table.NamePrimaryIndex := 'RELI_CLEF';
    aFImportTextFile2Table.NameGeneratorPrimaryIndex := 'REF_RELIGIONS';
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RELI_LIBELLE', ptInput);
    aFImportTextFile2Table.InvisibleParamNames.Add('LANGUE');
    aFImportTextFile2Table.OnBeforeInsertRecord := OnBeforeInsertRecord;

    if aFImportTextFile2Table.ShowModal = mrOk then OpenQuery;
  finally
    aFImportTextFile2Table.free;
  end;
end;

procedure TFEditRefReligions.OnBeforeInsertRecord(DataSet: TDataSet);
begin
  TIBQuery(DataSet).ParamByName('RELI_LIBELLE').AsString := '';
  TIBQuery(DataSet).ParamByName('LANGUE').AsString := _Context.Langue;
end;

procedure TFEditRefReligions.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFEditRefReligions.Label10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFEditRefReligions.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;

procedure TFEditRefReligions.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 415;
      ClientWidth := 350;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Height := ClientHeight;
end;

end.
