{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_export_table_2_textfile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, Db, DBTables, StdCtrls, CheckLst, ComCtrls,
  TFlatPanelUnit, TFlatCheckBoxUnit, TFlatRadioButtonUnit,
  ExtCtrls, u_comp_TBlueFlatSpeedButton, Buttons,
  IBCustomDataSet, IBQuery, dxEditor, dxExEdtr, dxEdLib, dxCntner,
  TFlatSpeedButtonUnit, u_comp_TGoodBtn, u_comp_TYLanguage, DynamicSkinForm;

type
  TFExportTable2TextFile = class(TSuperForm)
    pBorder: TPanel;
    Panel4: TPanel;
    Panel8: TPanel;
    Panel5: TPanel;
    Label1: TLabel;
    BlueFlatSpeedButton1: TBlueFlatSpeedButton;
    panEtape1: TPanel;
    Label3: TLabel;
    Label6: TLabel;
    panEtape2: TPanel;
    Label5: TLabel;
    Label7: TLabel;
    Panel3: TPanel;
    Label11: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Panel6: TPanel;
    rbPV: TFlatRadioButton;
    rbV: TFlatRadioButton;
    rbTab: TFlatRadioButton;
    rbAutre: TFlatRadioButton;
    edAutreSep: TdxEdit;
    cbIncludeEntete: TFlatCheckBox;
    edStringDelimitor: TdxPickEdit;
    panEtape3: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    FlatPanel1: TFlatPanel;
    Panel1: TPanel;
    Label4: TLabel;
    DstList: TListView;
    edFileName: TdxEdit;
    SaveDialog: TSaveDialog;
    Query: TIBQuery;
    btnOk: TGoodBtn;
    btnCancel: TGoodBtn;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure BlueFlatSpeedButton1Click(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    fTableName: string;
    fFieldNames: TStringList;
    fPropositionFileNameExport: string;
    fCondSelect: string;

  public
    property TableName: string read fTableName write fTableName;
    property PropositionFileNameExport: string read fPropositionFileNameExport write fPropositionFileNameExport;
    property CondSelect: string read fCondSelect write fCondSelect;
  end;



implementation

uses
  u_objet_TCut, u_dm, u_common_func, u_common_var, u_common_const,
  u_form_main;

{$R *.DFM}

procedure TFExportTable2TextFile.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 475;
      ClientWidth := 477;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fCondSelect := '';
  fTableName := '';
  fFieldNames := TStringList.create;
  fPropositionFileNameExport := '';
end;

procedure TFExportTable2TextFile.BlueFlatSpeedButton1Click(Sender: TObject);
begin
  if (fPropositionFileNameExport <> '') and (edFileName.Text = '')
    then SaveDialog.FileName := _Context.PathDocs + fPropositionFileNameExport;
  if SaveDialog.Execute then
    begin
      edFileName.Text := SaveDialog.FileName;
      DoRefreshControls;
    end;
end;



procedure TFExportTable2TextFile.SuperFormShowFirstTime(Sender: TObject);
var
  n: integer;
  item: TListItem;
begin
  fFieldNames.Clear;

  //Rcupration de la liste des Fields
  Query.Close;
  try
    Query.Sql.Clear;
    Query.Sql.Add('select * from ' + fTableName + ' where 0=1');
    Query.Open;
    //   Query.Last;
    //   Query.First;

    for n := 0 to Query.FieldCount - 1 do
      begin
        fFieldNames.Add(Query.Fields[n].FieldName);
      end;

  finally
    Query.Close;
  end;







  DstList.Items.BeginUpdate;
  try
    DstList.Items.Clear;
    for n := 0 to fFieldNames.Count - 1 do
      begin
        item := DstList.Items.Add;
        item.Caption := fFieldNames[n];
        //			item.SubItems.Add('');
        item.Checked := true;
      end;

  finally
    DstList.Items.EndUpdate;
  end;

  DoRefreshControls;
end;

procedure TFExportTable2TextFile.btnOkClick(Sender: TObject);
var
  ok: boolean;
  k, n, w: integer;
  fCut: TCut;
  F: TextFile;
  aField: TField;
  PrevRecord: TBookmark;
  Save_Cursor: TCursor;

begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;

  ok := false;
  for n := 0 to DstList.items.Count - 1 do
    if DstList.Items[n].Checked then ok := true;

  if ok then
    begin
      fCut := TCut.create;
      try
        try
          //Sparateur de colonne
          if rbPV.checked then fCut.ParamSeparator := ';'
          else
            if rbV.checked then fCut.ParamSeparator := ','
            else
              if rbTab.checked then fCut.ParamSeparator := #9
              else
                if rbAutre.checked then fCut.ParamSeparator := edAutreSep.text;

          //Dlimiteur de chane de caractte
          fCut.StringDelimitor := edStringDelimitor.Text;

          fCut.Params.Clear;
          for k := 0 to DstList.Items.Count - 1 do
            begin
              if DstList.Items[k].checked then
                begin
                  fCut.Params.CreateParam(ftString, 'Param' + inttostr(k), ptInputOutput);
                end;
            end;

          Query.Close;
          Query.Sql.Clear;
          Query.Sql.Add('select * from ' + fTableName);
          if fCondSelect <> '' then Query.Sql.Add('where ' + fCondSelect);
          Query.Open;
          Query.Last;
          Query.First;

          if Query.RecordCount > 0 then
            begin
              btnOk.Enabled := False;
              btnCancel.Enabled := False;
              Application.ProcessMessages;

              PrevRecord := Query.GetBookmark;
              Query.DisableControls;
              try

                Query.First;
                AssignFile(F, edFileName.Text);
                Rewrite(F);
                try
                  //faut-il sauver les enttes ?
                  if cbIncludeEntete.checked then
                    begin
                      w := 0;
                      for k := 0 to DstList.Items.Count - 1 do
                        begin
                          if DstList.Items[k].checked then
                            begin
                              {
                               if DstList.Items[k].SubItems[0] <> ''
                                then fCut.Params[w].AsString := DstList.Items[k].SubItems[0]
                               else fCut.Params[w].AsString := DstList.Items[k].Caption;
                               }
                              fCut.Params[w].AsString := DstList.Items[k].Caption;
                              w := w + 1;
                            end;
                        end;

                      fCut.ParamsToStr;
                      WriteLn(F, fCut.Line);
                    end;


                  for n := 1 to Query.RecordCount do
                    begin
                      w := 0;
                      for k := 0 to DstList.Items.Count - 1 do
                        begin
                          if DstList.Items[k].checked then
                            begin
                              aField := Query.FieldByName(DstList.Items[k].Caption);
                              if aField <> nil then
                                begin
                                  fCut.Params[w].Value := aField.Value;
                                end
                              else
                                begin
                                  fCut.Params[w].AsString := '';
                                end;
                              w := w + 1;
                            end;
                        end;

                      fCut.ParamsToStr;
                      WriteLn(F, fCut.Line);

                      Query.Next;
                    end;
                finally
                  CloseFile(F);
                end;

              finally
                Query.EnableControls;

                if PrevRecord <> nil then
                  begin
                    Query.GoToBookmark(PrevRecord);
                    Query.FreeBookmark(PrevRecord);
                  end;
              end;

              MyMessageDlg('L''exportation s''est bien passe.', mtInformation, [mbOK], 0);
              btnOk.Enabled := True;
              btnCancel.Enabled := True;

              ModalResult := mrOk;
            end
          else
            begin
              MyMessageDlg('Il n' + #39 + 'y a aucun enregistrement  exporter !', mtInformation, [mbOK], 0);
            end;
        except
        end;
      finally
        fCut.Free;
      end;
    end
  else
    myMessageDlg('Il n' + #39 + 'y a rien  exporter !', mtInformation, [mbOK], 0);

  Screen.Cursor := Save_Cursor;
end;

procedure TFExportTable2TextFile.SuperFormRefreshControls(Sender: TObject);
var
  ok: boolean;
begin
  ok := (trim(edFileName.Text) <> '');

  btnOk.enabled := ok;
end;

procedure TFExportTable2TextFile.SuperFormDestroy(Sender: TObject);
begin
  fFieldNames.Free;
end;

procedure TFExportTable2TextFile.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFExportTable2TextFile.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;


procedure TFExportTable2TextFile.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

end.
