{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_TContext;

interface

uses
  Classes, Graphics, windows, Forms, Dialogs;

type
  TModeSaisie = (msNormal, msAllUpper, msJustFirstLetterUpper);


  TContext = class
  private
    fShouldSave: boolean;

    fXP: integer;
    fVersion: string;
    fCDSVersion: string;
    fBuild: string;
    fProductName: string;
    fOwner: string;
    fOrganization: string;

    fShowWeb: boolean;
    fShowNew: boolean;
    fMaxIndPourNaviguer: integer;
    fShowExit: boolean;
    fBackup: boolean;
    fCanPlaySound: boolean;
    fCanSeeHint: boolean;
    fColorHomme: integer;
    fColorFemme: integer;
    fTauxCompressionJPeg: integer;
    fMaxFicheDansHistorique: integer;
    fModeSaisieNom: TModeSaisie;
    fModeSaisiePrenom: TModeSaisie;
    fKeyRegistry: string;
    fPathFileNameBdd: string;
    fLangue: string;
    fLastNumDossier: integer;
    fSC_EdgesTop: boolean;
    fSC_EdgesBottom: boolean;
    fSC_EdgesLeft: boolean;
    fSC_HotTrack: boolean;
    fSC_EdgesRight: boolean;
    fSC_Shadow: boolean;
    fSC_BorderColor: integer;
    fSC_BorderStyle: string;
    fSC_Transparence: string;
    fSC_ButtonStyle: string;
    fFirstDemarrage: boolean;
    fSonsBase: Integer;
    fVideosBase: Integer;
    fNip: integer;

    sAppliPath: string;
    fMargeLeftPrinter: integer;
    fMargeRightPrinter: integer;
    fMargeBottomPrinter: integer;
    fMargeTopPrinter: integer;
    fRoueShowDeces: boolean;
    fRoueShowPrenom: boolean;
    fRoueShowNom: boolean;
    fRoueShowProfession: boolean;
    fRoueShowNaissance: boolean;
    fRoueDistDeces: integer;
    fRoueAngle: integer;
    fRoueDistNom: integer;
    fRoueDistPrenom: integer;
    fRoueCouleurRayon: integer;
    fRoueDistNaissance: integer;
    fRoueRayon: integer;
    fRoueDistProfession: integer;
    fRoueCouleurCercle: integer;
    fRoueFont: string;
    fRoueMargeLeft: integer;
    fRoueMargeTop: integer;

    fArbreShowDeces: boolean;
    fArbreShowProfession: boolean;
    fArbreShowNom: boolean;
    fArbreShowPrenom: boolean;
    fArbreShowNaissance: boolean;
    fArbreSpaceBetween2Gen: integer;
    fArbreDistProfession: integer;
    fArbreDistDeces: integer;
    fArbreDistPrenom: integer;
    fArbreDistNom: integer;
    fArbreSpaceBetween2Indi: integer;
    fArbreMargeTop: integer;
    fArbreHeightBox: integer;
    fArbreWidthBox: integer;
    fArbreDistNaissance: integer;
    fArbreMargeLeft: integer;
    fArbreFont: string;
    fArbreCouleurFondRectFemme: integer;
    fArbreCouleurRectFemme: integer;
    fArbreCouleurLiens: integer;
    fArbreCouleurFondRectHomme: integer;
    fArbreCouleurRectHomme: integer;
    fArbrePaintFondRecHomme: boolean;
    fArbrePaintFondRecFemme: boolean;
    fRoueShowNbGeneration: integer;
    fArbreShowNbGeneration: integer;
    fArbreCouleurTexteFemme: integer;
    fRoueCouleurTexteHomme: integer;
    fArbreCouleurTexteHomme: integer;
    fRoueCouleurTexteFemme: integer;
    fPathDocs: string;
    fPathImportExport: string;
    fPathImages: string;
    //    fPathWord: string;
    //    fPathAdobe: string;
    fMaxFavoris: integer;
    fIsPhilippe: boolean;
    fIsDev: boolean;
    fMaxScreen: Boolean;
    fPhotos: Boolean;
    fAgeMaxiAuDecesHommes: integer;
    fAgeMiniMariageHommes: integer;
    fAgeMiniNaissanceEnfantHommes: integer;
    fAgeMaxiMariageFemmes: integer;
    fNbJourEntre2NaissancesNormales: integer;
    fAgeMaxiNaissanceEnfantFemmes: integer;
    fNbJourEntre2NaissancesJumeaux: integer;
    fEcartAgeEntreEpoux: integer;
    fAgeMiniNaissanceEnfantFemmes: integer;
    fAgeMaxiAuDecesFemmes: integer;
    fAgeMaxiMariageHommes: integer;
    fAgeMiniMariageFemmes: integer;
    fAgeMaxiNaissanceEnfantHommes: integer;
    fCoherenceActive: boolean;
    fOpenLastIndiviShowedOnExit: boolean;
    fActiveFenetreDossier: boolean;
    fRefreshCousins: boolean;
    fArbreReduit: integer;
    fArbreComplet: integer;
    fCanShowWindowPbCoherence: boolean;
    fCheckNbJourEntreNaissance: boolean;
    fCheckAgeMiniNaissanceEnfant: boolean;
    fCheckAgeMiniMariage: boolean;
    fCheckAgeMaxiMariage: boolean;
    fCheckAgeMaxiNaissanceEnfant: boolean;
    fCheckEcartAgeEpoux: boolean;
    fCheckEsperanceVie: boolean;
    fAnimArbre: boolean;
    fArbreHorizontal: boolean;
    fRoueDecalageIndiCentral: integer;
    fFileNameReport: TStringList;
    fLanguage: string;
    fAfficheInsee: boolean;
    fChoixCartesInternet: string;
    fSkin: Boolean;
    fUseAgent: boolean;
    fSkinDefault: string;
    fNomAgent: string;

  public
    //Clef dans laquelle on sauvegarde les infos
    property KeyRegistry: string read fKeyRegistry write fKeyRegistry;
    property Version: string read fVersion write fVersion;
    property XP: integer read fXP write fXP;
    property CDSVersion: string read fCDSVersion write fCDSVersion;
    property Build: string read fBuild write fBuild;
    property ProductName: string read fProductName write fProductName;
    property Owner: string read fOwner write fOwner;
    property Organization: string read fOrganization write fOrganization;

    property Skin: boolean read fSkin write fSkin;
    property UseAgent: boolean read fUseAgent write fUseAgent;
    property NomAgent: string read fNomAgent write fNomAgent;
    property SkinDefault: string read fSkinDefault write fSkinDefault;

    //La base de donne
    property PathFileNameBdd: string read fPathFileNameBdd write fPathFileNameBdd;

    //Les rpertoires
    property PathImportExport: string read fPathImportExport write fPathImportExport;
    property PathImages: string read fPathImages write fPathImages;
    property PathDocs: string read fPathDocs write fPathDocs;

    property SonsBase: integer read fSonsBase write fSonsBase;
    property VideosBase: integer read fVideosBase write fVideosBase;
    property Nip: integer read fNip write fNip;

    //La langue (code)
    property Langue: string read fLangue write fLangue;
    //La langue (nom)
    property Language: string read fLanguage write fLanguage;

    property MaxIndPourNaviguer: integer read fMaxIndPourNaviguer write fMaxIndPourNaviguer;
    //Couleurs
    property ColorHomme: integer read fColorHomme write fColorHomme;
    property ColorFemme: integer read fColorFemme write fColorFemme;

    //JPeg
    property TauxCompressionJPeg: integer read fTauxCompressionJPeg write fTauxCompressionJPeg;

    //Nombre maximum de favoris par dossier
    property MaxFavoris: integer read fMaxFavoris write fMaxFavoris;

    //Mode de saisie
    property ModeSaisieNom: TModeSaisie read fModeSaisieNom write fModeSaisieNom;
    property ModeSaisiePrenom: TModeSaisie read fModeSaisiePrenom write fModeSaisiePrenom;

    //Paramtres gnraux
    property MaxScreen: boolean read fMaxScreen write fMaxScreen;
    property Photos: boolean read fPhotos write fPhotos;
    property CanSeeHint: boolean read fCanSeeHint write fCanSeeHint;
    property Backup: boolean read fBackup write fBackup;
    property ShowExit: boolean read fShowExit write fShowExit;
    property AfficheInsee: boolean read fAfficheInsee write fAfficheInsee;
    property ShowWeb: boolean read fShowWeb write fShowWeb;
    property ShowNew: boolean read fShowNew write fShowNew;
    property OpenLastIndiviShowedOnExit: boolean read fOpenLastIndiviShowedOnExit write fOpenLastIndiviShowedOnExit;
    property ActiveFenetreDossier: boolean read fActiveFenetreDossier write fActiveFenetreDossier;
    property RefreshCousins: boolean read fRefreshCousins write fRefreshCousins;
    property MaxFicheDansHistorique: integer read fMaxFicheDansHistorique write fMaxFicheDansHistorique;
    property CanPlaySound: boolean read fCanPlaySound write fCanPlaySound;
    property ArbreReduit: integer read fArbreReduit write fArbreReduit;
    property ArbreComplet: integer read fArbreComplet write fArbreComplet;
    property AnimArbre: boolean read fAnimArbre write fAnimArbre;
    property ArbreHorizontal: boolean read fArbreHorizontal write fArbreHorizontal;

    //les derniers lments ouverts
    property LastNumDossier: integer read fLastNumDossier write fLastNumDossier;

    //StyleController
    property SC_BorderColor: integer read fSC_BorderColor write fSC_BorderColor;
    property SC_BorderStyle: string read fSC_BorderStyle write fSC_BorderStyle;
    property SC_ButtonStyle: string read fSC_ButtonStyle write fSC_ButtonStyle;
    property SC_Transparence: string read fSC_Transparence write fSC_Transparence;
    property SC_EdgesLeft: boolean read fSC_EdgesLeft write fSC_EdgesLeft;
    property SC_EdgesTop: boolean read fSC_EdgesTop write fSC_EdgesTop;
    property SC_EdgesRight: boolean read fSC_EdgesRight write fSC_EdgesRight;
    property SC_EdgesBottom: boolean read fSC_EdgesBottom write fSC_EdgesBottom;
    property SC_HotTrack: boolean read fSC_HotTrack write fSC_HotTrack;
    property SC_Shadow: boolean read fSC_Shadow write fSC_Shadow;

    //Contrles de cohrences
    property CoherenceActive: boolean read fCoherenceActive write fCoherenceActive;
    property CanShowWindowPbCoherence: boolean read fCanShowWindowPbCoherence write fCanShowWindowPbCoherence;

    property AgeMaxiAuDecesHommes: integer read fAgeMaxiAuDecesHommes write fAgeMaxiAuDecesHommes;
    property AgeMaxiAuDecesFemmes: integer read fAgeMaxiAuDecesFemmes write fAgeMaxiAuDecesFemmes;
    property AgeMiniMariageHommes: integer read fAgeMiniMariageHommes write fAgeMiniMariageHommes;
    property AgeMiniMariageFemmes: integer read fAgeMiniMariageFemmes write fAgeMiniMariageFemmes;
    property AgeMaxiMariageHommes: integer read fAgeMaxiMariageHommes write fAgeMaxiMariageHommes;
    property AgeMaxiMariageFemmes: integer read fAgeMaxiMariageFemmes write fAgeMaxiMariageFemmes;
    property AgeMiniNaissanceEnfantHommes: integer read fAgeMiniNaissanceEnfantHommes write fAgeMiniNaissanceEnfantHommes;
    property AgeMiniNaissanceEnfantFemmes: integer read fAgeMiniNaissanceEnfantFemmes write fAgeMiniNaissanceEnfantFemmes;
    property AgeMaxiNaissanceEnfantHommes: integer read fAgeMaxiNaissanceEnfantHommes write fAgeMaxiNaissanceEnfantHommes;
    property AgeMaxiNaissanceEnfantFemmes: integer read fAgeMaxiNaissanceEnfantFemmes write fAgeMaxiNaissanceEnfantFemmes;

    property NbJourEntre2NaissancesNormales: integer read fNbJourEntre2NaissancesNormales write fNbJourEntre2NaissancesNormales;
    property NbJourEntre2NaissancesJumeaux: integer read fNbJourEntre2NaissancesJumeaux write fNbJourEntre2NaissancesJumeaux;
    property EcartAgeEntreEpoux: integer read fEcartAgeEntreEpoux write fEcartAgeEntreEpoux;

    property CheckAgeMiniMariage: boolean read fCheckAgeMiniMariage write fCheckAgeMiniMariage;
    property CheckAgeMaxiMariage: boolean read fCheckAgeMaxiMariage write fCheckAgeMaxiMariage;
    property CheckAgeMiniNaissanceEnfant: boolean read fCheckAgeMiniNaissanceEnfant write fCheckAgeMiniNaissanceEnfant;
    property CheckAgeMaxiNaissanceEnfant: boolean read fCheckAgeMaxiNaissanceEnfant write fCheckAgeMaxiNaissanceEnfant;
    property CheckEsperanceVie: boolean read fCheckEsperanceVie write fCheckEsperanceVie;
    property CheckEcartAgeEpoux: boolean read fCheckEcartAgeEpoux write fCheckEcartAgeEpoux;
    property CheckNbJourEntreNaissance: boolean read fCheckNbJourEntreNaissance write fCheckNbJourEntreNaissance;

    //graph
    property MargeLeftPrinter: integer read fMargeLeftPrinter write fMargeLeftPrinter;
    property MargeTopPrinter: integer read fMargeTopPrinter write fMargeTopPrinter;
    property MargeRightPrinter: integer read fMargeRightPrinter write fMargeRightPrinter;
    property MargeBottomPrinter: integer read fMargeBottomPrinter write fMargeBottomPrinter;

    //Roue
    property RoueShowNbGeneration: integer read fRoueShowNbGeneration write fRoueShowNbGeneration;
    property RoueAngle: integer read fRoueAngle write fRoueAngle;
    property RoueRayon: integer read fRoueRayon write fRoueRayon;
    property RoueMargeLeft: integer read fRoueMargeLeft write fRoueMargeLeft;
    property RoueMargeTop: integer read fRoueMargeTop write fRoueMargeTop;
    property RoueFont: string read fRoueFont write fRoueFont;
    property RoueCouleurTexteHomme: integer read fRoueCouleurTexteHomme write fRoueCouleurTexteHomme;
    property RoueCouleurTexteFemme: integer read fRoueCouleurTexteFemme write fRoueCouleurTexteFemme;
    property RoueShowNom: boolean read fRoueShowNom write fRoueShowNom;
    property RoueShowPrenom: boolean read fRoueShowPrenom write fRoueShowPrenom;
    property RoueShowProfession: boolean read fRoueShowProfession write fRoueShowProfession;
    property RoueShowNaissance: boolean read fRoueShowNaissance write fRoueShowNaissance;
    property RoueShowDeces: boolean read fRoueShowDeces write fRoueShowDeces;
    property RoueDistNom: integer read fRoueDistNom write fRoueDistNom;
    property RoueDistPrenom: integer read fRoueDistPrenom write fRoueDistPrenom;
    property RoueDistProfession: integer read fRoueDistProfession write fRoueDistProfession;
    property RoueDistNaissance: integer read fRoueDistNaissance write fRoueDistNaissance;
    property RoueDistDeces: integer read fRoueDistDeces write fRoueDistDeces;
    property RoueCouleurCercle: integer read fRoueCouleurCercle write fRoueCouleurCercle;
    property RoueCouleurRayon: integer read fRoueCouleurRayon write fRoueCouleurRayon;
    property RoueDecalageIndiCentral: integer read fRoueDecalageIndiCentral write fRoueDecalageIndiCentral;

    //Arbre
    property ArbreShowNbGeneration: integer read fArbreShowNbGeneration write fArbreShowNbGeneration;
    property ArbreMargeLeft: integer read fArbreMargeLeft write fArbreMargeLeft;
    property ArbreMargeTop: integer read fArbreMargeTop write fArbreMargeTop;
    property ArbreWidthBox: integer read fArbreWidthBox write fArbreWidthBox;
    property ArbreHeightBox: integer read fArbreHeightBox write fArbreHeightBox;
    property ArbreSpaceBetween2Gen: integer read fArbreSpaceBetween2Gen write fArbreSpaceBetween2Gen;
    property ArbreSpaceBetween2Indi: integer read fArbreSpaceBetween2Indi write fArbreSpaceBetween2Indi;
    property ArbreFont: string read fArbreFont write fArbreFont;
    property ArbreCouleurTexteHomme: integer read fArbreCouleurTexteHomme write fArbreCouleurTexteHomme;
    property ArbreCouleurTexteFemme: integer read fArbreCouleurTexteFemme write fArbreCouleurTexteFemme;
    property ArbreShowNom: boolean read fArbreShowNom write fArbreShowNom;
    property ArbreShowPrenom: boolean read fArbreShowPrenom write fArbreShowPrenom;
    property ArbreShowProfession: boolean read fArbreShowProfession write fArbreShowProfession;
    property ArbreShowNaissance: boolean read fArbreShowNaissance write fArbreShowNaissance;
    property ArbreShowDeces: boolean read fArbreShowDeces write fArbreShowDeces;
    property ArbreDistNom: integer read fArbreDistNom write fArbreDistNom;
    property ArbreDistPrenom: integer read fArbreDistPrenom write fArbreDistPrenom;
    property ArbreDistProfession: integer read fArbreDistProfession write fArbreDistProfession;
    property ArbreDistNaissance: integer read fArbreDistNaissance write fArbreDistNaissance;
    property ArbreDistDeces: integer read fArbreDistDeces write fArbreDistDeces;
    property ArbreCouleurLiens: integer read fArbreCouleurLiens write fArbreCouleurLiens;
    property ArbreCouleurRectHomme: integer read fArbreCouleurRectHomme write fArbreCouleurRectHomme;
    property ArbrePaintFondRecHomme: boolean read fArbrePaintFondRecHomme write fArbrePaintFondRecHomme;
    property ArbreCouleurFondRectHomme: integer read fArbreCouleurFondRectHomme write fArbreCouleurFondRectHomme;
    property ArbreCouleurRectFemme: integer read fArbreCouleurRectFemme write fArbreCouleurRectFemme;
    property ArbrePaintFondRecFemme: boolean read fArbrePaintFondRecFemme write fArbrePaintFondRecFemme;
    property ArbreCouleurFondRectFemme: integer read fArbreCouleurFondRectFemme write fArbreCouleurFondRectFemme;

    property FileNameReport: TStringList read fFileNameReport write fFileNameReport;

    //pour savoir si il faut enregistrer les modifications
    property ShouldSave: boolean read fShouldSave write fShouldSave;

    //savoir si c'est le premier dmarrage
    property FirstDemarrage: boolean read fFirstDemarrage;

    property IsPhilippe: boolean read fIsPhilippe;
    property IsDev: boolean read fIsDev;
    property ChoixCartesInternet: string read fChoixCartesInternet write fChoixCartesInternet;

    constructor Create;
    destructor destroy; override;

    procedure Load;
    procedure Save;
    procedure SaveOnlyIfShould;
    procedure WindowsVersion;

  end;

implementation

uses
  registry, sysutils, u_common_const, u_common_func;
{ TContext }

constructor TContext.Create;
var
  n: integer;
begin
  sAppliPath := ExtractFilePath(Application.EXEName);
  fXP := 0;
  fKeyRegistry := '\SOFTWARE\' + Application.Title;
  fShouldSave := False;
  fFirstDemarrage := True;
  fAfficheInsee := False;
  fMaxScreen := True;
  fPhotos := True;
  fVideosBase := 0;
  fSonsBase := 0;
  fNip := 1;
  fUseAgent := True;
  fNomAgent := 'Merlin';

  fFileNameReport := TStringList.create;
  for n := 0 to _MAX_REP_PATH do fFileNameReport.Add('');

  fSkin := True;
  fSkinDefault := ExtractFilePath(Application.ExeName) + 'Skins\corona!\SkIN.INI';

  //La base de donne
  fPathFileNameBdd := '';

  //Les rpertoires
  fPathImportExport := sAppliPath + _REL_PATH_IMPORT_EXPORT;
  fPathImages := sAppliPath + _REL_PATH_IMAGE;
  fPathDocs := sAppliPath + _REL_PATH_DOC;

  //La langue
  fLangue := 'FRA';
  fLanguage := 'Franais';

  fMaxIndPourNaviguer := 1500;

  //Couleurs
  fColorHomme := $00FF8000;
  fColorFemme := $008080FF;

  //JPeg
  fTauxCompressionJPeg := 30;

  //Nombre maximum de favoris par dossier
  fMaxFavoris := 20;

  //Mode de saisie
  fModeSaisieNom := msAllUpper;
  fModeSaisiePrenom := msJustFirstLetterUpper;

  //Paramtres gnraux
  fMaxScreen := True;
  fCanSeeHint := True;
  fShowExit := True;
  fBackup := False;
  fShowWeb := False;
  fShowNew := True;
  fOpenLastIndiviShowedOnExit := True;
  fActiveFenetreDossier := False;
  fRefreshCousins := True;
  fMaxFicheDansHistorique := 10;
  fCanPlaySound := True;
  fArbreReduit := 10;
  fArbreComplet := 10;
  fAnimArbre := True;
  fArbreHorizontal := True;

  //StyleController
  fSC_BorderColor := clWindowFrame;
  fSC_BorderStyle := 'xbsNone';
  fSC_ButtonStyle := 'btsSimple';
  fSC_Transparence := 'ebtNone';
  fSC_EdgesLeft := True;
  fSC_EdgesTop := True;
  fSC_EdgesRight := True;
  fSC_EdgesBottom := True;
  SC_HotTrack := True;
  SC_Shadow := False;

  //les derniers lments ouverts
  fLastNumDossier := 1;

  fMargeLeftPrinter := 10;
  fMargeRightPrinter := 10;
  fMargeBottomPrinter := 10;
  fMargeTopPrinter := 10;

  //Roue
  fRoueShowNbGeneration := 6;
  fRoueMargeLeft := 15;
  fRoueMargeTop := 10;
  fRoueAngle := 200;
  fRoueRayon := 29;
  fRoueFont := 'Tahoma,8,0000,clWindowText';
  fRoueCouleurTexteHomme := clBlack;
  fRoueCouleurTexteFemme := clBlack;
  fRoueShowDeces := True;
  fRoueShowPrenom := True;
  fRoueShowNom := True;
  fRoueShowProfession := True;
  fRoueShowNaissance := True;
  fRoueDistNom := 3;
  fRoueDistPrenom := 6;
  fRoueDistProfession := 10;
  fRoueDistNaissance := 14;
  fRoueDistDeces := 18;
  fRoueCouleurRayon := clBlue;
  fRoueCouleurCercle := clBlue;
  fRoueDecalageIndiCentral := 0;

  //Arbre
  fArbreShowNbGeneration := 12;
  fArbreMargeLeft := 2;
  fArbreMargeTop := 2;
  fArbreWidthBox := 58;
  fArbreHeightBox := 24;
  fArbreSpaceBetween2Gen := 5;
  fArbreSpaceBetween2Indi := 7;
  fArbreFont := 'Tahoma,8,0000,clWindowText';
  fArbreCouleurTexteHomme := clBlack;
  fArbreCouleurTexteFemme := clBlack;
  fArbreShowNom := True;
  fArbreShowPrenom := True;
  fArbreShowProfession := True;
  fArbreShowNaissance := True;
  fArbreShowDeces := True;
  fArbreDistNom := 1;
  fArbreDistPrenom := 6;
  fArbreDistProfession := 10;
  fArbreDistNaissance := 14;
  fArbreDistDeces := 18;
  fArbreCouleurLiens := clBlack;

  fArbreCouleurRectHomme := clBlack;
  fArbrePaintFondRecHomme := True;
  fArbreCouleurFondRectHomme := $00FFCC99;

  fArbreCouleurRectFemme := clBlack;
  fArbrePaintFondRecFemme := True;
  fArbreCouleurFondRectFemme := $0099CCFF;

  //Contrles de cohrences
  fCoherenceActive := True;
  fCanShowWindowPbCoherence := True;

  fAgeMiniMariageHommes := 12;
  fAgeMiniMariageFemmes := 10;
  fAgeMaxiMariageHommes := 85;
  fAgeMaxiMariageFemmes := 85;
  fAgeMiniNaissanceEnfantHommes := 14;
  fAgeMiniNaissanceEnfantFemmes := 17;
  fAgeMaxiNaissanceEnfantHommes := 65;
  fAgeMaxiNaissanceEnfantFemmes := 55;
  fAgeMaxiAuDecesHommes := 95;
  fAgeMaxiAuDecesFemmes := 97;
  fNbJourEntre2NaissancesNormales := 300;
  fNbJourEntre2NaissancesJumeaux := 2;
  fEcartAgeEntreEpoux := 40;

  fCheckNbJourEntreNaissance := True;
  fCheckAgeMiniNaissanceEnfant := True;
  fCheckAgeMiniMariage := True;
  fCheckAgeMaxiMariage := True;
  fCheckAgeMaxiNaissanceEnfant := True;
  fCheckEcartAgeEpoux := True;
  fCheckEsperanceVie := True;

  fChoixCartesInternet := 'wwww.expedia.fr';
end;

destructor TContext.destroy;
begin
  fFileNameReport.free;
  inherited;
end;

procedure TContext.Load;
var
  k: integer;
  fIni: TRegIniFile;

  procedure LoadStringList(Key: string; List: TStringList);
  var
    n, p: integer;
  begin
    List.Clear;
    p := fIni.ReadInteger(Key, 'Count', 0);
    for n := 0 to p - 1 do
      List.Add(fIni.ReadString(Key, 'Str' + inttostr(n), ''));
  end;

begin
  fShouldSave := False;

  fIni := TRegIniFile.create;
  try
    fIni.RootKey := HKEY_CURRENT_USER;

    if fIni.OpenKey(fKeyRegistry, False) then
      begin
        fIni.WriteString('Path', 'PathAppli', sAppliPath);

        //La base de donne
        fPathFileNameBdd := fIni.ReadString('Path', 'PathFileNameBdd', '');

        fFirstDemarrage := fPathFileNameBdd = '';

        //Les rpertoires
        fPathImportExport := fIni.ReadString('Path', 'PathImportExport', sAppliPath + _REL_PATH_IMPORT_EXPORT);
        fPathImages := fIni.ReadString('Path', 'PathImages', sAppliPath + _REL_PATH_IMAGE);
        fPathDocs := fIni.ReadString('Path', 'PathDocuments', sAppliPath + _REL_PATH_DOC);


        fUseAgent := fIni.ReadBool('Settings', 'UseAgent', True);

        // LEs skins ---------------------
        fSKin := fIni.ReadBool('Settings', 'Skin', True);
        fSkinDefault := fIni.ReadString('Settings', 'SkinDefault', ExtractFilePath(Application.ExeName) + 'Skins\corona!\SkIN.INI');

        fNomAgent := fIni.ReadString('Settings', 'NomAgent', 'Merlin');

        //La Langue
        fLangue := fIni.ReadString('Settings', 'Langue', 'FRA');
        fLanguage := fIni.ReadString('Settings', 'Language', 'Franais');
        fMaxIndPourNaviguer := fIni.ReadInteger('Settings', 'MaxIndPourNaviguer', 1500);
        //Couleurs
        fColorHomme := fIni.ReadInteger('Colors', 'ColorHomme', $00FF8000);
        fColorFemme := fIni.ReadInteger('Colors', 'ColorFemme', $008080FF);
        fSonsBase := fIni.ReadInteger('Settings', 'SonsBase', 0);
        fVideosBase := fIni.ReadInteger('Settings', 'VideosBase', 0);
        fNip := fIni.ReadInteger('Settings', 'Nip', 1);

        //JPeg
        fTauxCompressionJPeg := fIni.ReadInteger('Settings', 'TauxCompressionJPeg', 30);

        fChoixCartesInternet := fIni.ReadString('Settings', 'ChoixCartesInternet', 'www.expedia.fr');

        //Nombre maximum de favoris par dossier
        fMaxFavoris := fIni.ReadInteger('Settings', 'MaxFavoris', 20);

        //Mode de saisie
        k := fIni.ReadInteger('Settings', 'ModeSaisieNom', 1);
        case k of
          0: fModeSaisieNom := msNormal;
          1: fModeSaisieNom := msAllUpper;
          2: fModeSaisieNom := msJustFirstLetterUpper;
        end;

        k := fIni.ReadInteger('Settings', 'ModeSaisiePrenom', 2);
        case k of
          0: fModeSaisiePrenom := msNormal;
          1: fModeSaisiePrenom := msAllUpper;
          2: fModeSaisiePrenom := msJustFirstLetterUpper;
        end;

        //Paramtres gnraux
        fPhotos := fIni.ReadBool('Settings', 'Photos', True);
        fMaxScreen := fIni.ReadBool('Settings', 'MaxScreen', True);
        fCanSeeHint := fIni.ReadBool('Settings', 'CanSeeHint', True);
        fShowExit := fIni.ReadBool('Settings', 'ShowExit', True);
        fBackup := fIni.ReadBool('Settings', 'Backup', False);
        fAfficheInsee := fIni.ReadBool('Settings', 'AfficheInsee', False);

        fShowWeb := fIni.ReadBool('Settings', 'ShowWeb', False);
        fShowNew := fIni.ReadBool('Settings', 'ShowNew', True);
        fOpenLastIndiviShowedOnExit := fIni.ReadBool('Settings', 'OpenLastIndiviShowedOnExit', True);
        fActiveFenetreDossier := fIni.ReadBool('Settings', 'ActiveFenetreDossier', False);
        fRefreshCousins := fIni.ReadBool('Settings', 'RefreshCousins', True);
        fArbreReduit := fIni.ReadInteger('Settings', 'ArbreReduit', 10);
        fArbreComplet := fIni.ReadInteger('Settings', 'ArbreComplet', 10);
        fMaxFicheDansHistorique := fIni.ReadInteger('Settings', 'MaxFicheDansHistorique', 10);
        fCanPlaySound := fIni.ReadBool('Settings', 'CanPlaySound', True);
        fIsPhilippe := fIni.ReadBool('Settings', 'IsPhilippe', False);
        fIsDev := fIni.ReadBool('Settings', 'IsDev', False);
        fAnimArbre := fIni.ReadBool('Settings', 'AnimArbre', True);
        fArbreHorizontal := fIni.ReadBool('Settings', 'ArbreHorizontal', True);

        //StyleController
        fSC_BorderColor := fIni.ReadInteger('StyleController', 'SC_BorderColor', clWindowFrame);
        fSC_BorderStyle := fIni.ReadString('StyleController', 'SC_BorderStyle', 'xbsNone');
        fSC_ButtonStyle := fIni.ReadString('StyleController', 'SC_ButtonStyle', 'btsSimple');
        fSC_Transparence := fIni.ReadString('StyleController', 'SC_Transparence', 'ebtNone');
        fSC_EdgesLeft := fIni.ReadBool('StyleController', 'SC_EdgesLeft', True);
        fSC_EdgesTop := fIni.ReadBool('StyleController', 'SC_EdgesTop', True);
        fSC_EdgesRight := fIni.ReadBool('StyleController', 'SC_EdgesRight', True);
        fSC_EdgesBottom := fIni.ReadBool('StyleController', 'SC_EdgesBottom', True);
        fSC_HotTrack := fIni.ReadBool('StyleController', 'SC_HotTrack', False);
        fSC_Shadow := fIni.ReadBool('StyleController', 'SC_Shadow', False);

        //les derniers lments ouverts
        fLastNumDossier := fIni.ReadInteger('Last', 'LastNumDossier', 1);
        fMargeLeftPrinter := fIni.ReadInteger('Context', 'MargeLeftPrinter', 10);
        fMargeRightPrinter := fIni.ReadInteger('Context', 'MargeRightPrinter', 10);
        fMargeBottomPrinter := fIni.ReadInteger('Context', 'MargeBottomPrinter', 10);
        fMargeTopPrinter := fIni.ReadInteger('Context', 'MargeTopPrinter', 10);

        //Roue
        fRoueShowNbGeneration := fIni.ReadInteger('GraphRoue', 'RoueShowNbGeneration', 6);
        fRoueAngle := fIni.ReadInteger('GraphRoue', 'RoueAngle', 200);
        fRoueRayon := fIni.ReadInteger('GraphRoue', 'RoueRayon', 29);
        fRoueMargeLeft := fIni.ReadInteger('GraphRoue', 'RoueMargeLeft', 15);
        fRoueMargeTop := fIni.ReadInteger('GraphRoue', 'RoueMargeTop', 10);
        fRoueFont := fIni.ReadString('GraphRoue', 'RoueFont', 'Tahoma,8,0000,clWindowText');
        fRoueCouleurTexteHomme := fIni.ReadInteger('GraphRoue', 'RoueCouleurTexteHomme', clBlack);
        fRoueCouleurTexteFemme := fIni.ReadInteger('GraphRoue', 'RoueCouleurTexteFemme', clBlack);
        fRoueShowNom := fIni.ReadBool('GraphRoue', 'RoueShowNom', True);
        fRoueShowPrenom := fIni.ReadBool('GraphRoue', 'RoueShowPrenom', True);
        fRoueShowProfession := fIni.ReadBool('GraphRoue', 'RoueShowProfession', True);
        fRoueShowNaissance := fIni.ReadBool('GraphRoue', 'RoueShowNaissance', True);
        fRoueShowDeces := fIni.ReadBool('GraphRoue', 'RoueShowDeces', True);
        fRoueDistNom := fIni.ReadInteger('GraphRoue', 'RoueDistNom', 3);
        fRoueDistPrenom := fIni.ReadInteger('GraphRoue', 'RoueDistPrenom', 6);
        fRoueDistProfession := fIni.ReadInteger('GraphRoue', 'RoueDistProfession', 10);
        fRoueDistNaissance := fIni.ReadInteger('GraphRoue', 'RoueDistNaissance', 14);
        fRoueDistDeces := fIni.ReadInteger('GraphRoue', 'RoueDistDeces', 18);
        fRoueCouleurCercle := fIni.ReadInteger('GraphRoue', 'RoueCouleurCercle', clBlack);
        fRoueCouleurRayon := fIni.ReadInteger('GraphRoue', 'RoueCouleurRayon', clBlack);
        fRoueDecalageIndiCentral := fIni.ReadInteger('GraphRoue', 'RoueDecalageIndiCentral', 0);

        //Arbre
        fArbreShowNbGeneration := fIni.ReadInteger('GraphArbre', 'ArbreShowNbGeneration', 12);
        fArbreMargeLeft := fIni.ReadInteger('GraphArbre', 'ArbreMargeLeft', 2);
        fArbreMargeTop := fIni.ReadInteger('GraphArbre', 'ArbreMargeTop', 2);
        fArbreWidthBox := fIni.ReadInteger('GraphArbre', 'ArbreWidthBox', 58);
        fArbreHeightBox := fIni.ReadInteger('GraphArbre', 'ArbreHeightBox', 24);
        fArbreSpaceBetween2Gen := fIni.ReadInteger('GraphArbre', 'ArbreSpaceBetween2Gen', 5);
        fArbreSpaceBetween2Indi := fIni.ReadInteger('GraphArbre', 'ArbreSpaceBetween2Indi', 7);
        fArbreFont := fIni.ReadString('GraphArbre', 'ArbreFont', 'Tahoma,8,0000,clWindowText');
        fArbreCouleurTexteHomme := fIni.ReadInteger('GraphArbre', 'ArbreCouleurTexteHomme', clBlack);
        fArbreCouleurTexteFemme := fIni.ReadInteger('GraphArbre', 'ArbreCouleurTexteFemme', clBlack);
        fArbreShowNom := fIni.ReadBool('GraphArbre', 'ArbreShowNom', True);
        fArbreShowPrenom := fIni.ReadBool('GraphArbre', 'ArbreShowPrenom', True);
        fArbreShowProfession := fIni.ReadBool('GraphArbre', 'ArbreShowProfession', True);
        fArbreShowNaissance := fIni.ReadBool('GraphArbre', 'ArbreShowNaissance', True);
        fArbreShowDeces := fIni.ReadBool('GraphArbre', 'ArbreShowDeces', True);
        fArbreDistNom := fIni.ReadInteger('GraphArbre', 'ArbreDistNom', 1);
        fArbreDistPrenom := fIni.ReadInteger('GraphArbre', 'ArbreDistPrenom', 6);
        fArbreDistProfession := fIni.ReadInteger('GraphArbre', 'ArbreDistProfession', 10);
        fArbreDistNaissance := fIni.ReadInteger('GraphArbre', 'ArbreDistNaissance', 14);
        fArbreDistDeces := fIni.ReadInteger('GraphArbre', 'ArbreDistDeces', 18);
        fArbreCouleurLiens := fIni.ReadInteger('GraphArbre', 'ArbreCouleurLiens', clBlack);
        fArbreCouleurRectHomme := fIni.ReadInteger('GraphArbre', 'ArbreCouleurRectHomme', clBlack);
        fArbrePaintFondRecHomme := fIni.ReadBool('GraphArbre', 'ArbrePaintFondRecHomme', True);
        fArbreCouleurFondRectHomme := fIni.ReadInteger('GraphArbre', 'ArbreCouleurFondRectHomme', $00FFCC99);
        fArbreCouleurRectFemme := fIni.ReadInteger('GraphArbre', 'ArbreCouleurRectFemme', clBlack);
        fArbrePaintFondRecFemme := fIni.ReadBool('GraphArbre', 'ArbrePaintFondRecFemme', True);
        fArbreCouleurFondRectFemme := fIni.ReadInteger('GraphArbre', 'ArbreCouleurFondRectFemme', $0099CCFF);

        //Contrles de cohrences
        fCoherenceActive := fIni.ReadBool('Coherence', 'CoherenceActive', True);
        fCanShowWindowPbCoherence := fIni.ReadBool('Coherence', 'CanShowWindowPbCoherence', True);
        fAgeMiniMariageHommes := fIni.ReadInteger('Coherence', 'AgeMiniMariageHommes', 12);
        fAgeMiniMariageFemmes := fIni.ReadInteger('Coherence', 'AgeMiniMariageFemmes', 10);
        fAgeMaxiMariageHommes := fIni.ReadInteger('Coherence', 'AgeMaxiMariageHommes', 85);
        fAgeMaxiMariageFemmes := fIni.ReadInteger('Coherence', 'AgeMaxiMariageFemmes', 85);
        fAgeMiniNaissanceEnfantHommes := fIni.ReadInteger('Coherence', 'AgeMiniNaissanceEnfantHommes', 14);
        fAgeMiniNaissanceEnfantFemmes := fIni.ReadInteger('Coherence', 'AgeMiniNaissanceEnfantFemmes', 17);
        fAgeMaxiNaissanceEnfantHommes := fIni.ReadInteger('Coherence', 'AgeMaxiNaissanceEnfantHommes', 65);
        fAgeMaxiNaissanceEnfantFemmes := fIni.ReadInteger('Coherence', 'AgeMaxiNaissanceEnfantFemmes', 55);
        fAgeMaxiAuDecesHommes := fIni.ReadInteger('Coherence', 'AgeMaxiAuDecesHommes', 95);
        fAgeMaxiAuDecesFemmes := fIni.ReadInteger('Coherence', 'AgeMaxiAuDecesFemmes', 97);
        fNbJourEntre2NaissancesNormales := fIni.ReadInteger('Coherence', 'NbJourEntre2NaissancesNormales', 300);
        fNbJourEntre2NaissancesJumeaux := fIni.ReadInteger('Coherence', 'NbJourEntre2NaissancesJumeaux', 2);
        fEcartAgeEntreEpoux := fIni.ReadInteger('Coherence', 'EcartAgeEntreEpoux', 40);

        fCheckAgeMiniMariage := fIni.ReadBool('Coherence', 'CheckAgeMiniMariage', True);
        fCheckAgeMaxiMariage := fIni.ReadBool('Coherence', 'CheckAgeMaxiMariage', True);
        fCheckAgeMiniNaissanceEnfant := fIni.ReadBool('Coherence', 'CheckAgeMiniNaissanceEnfant', True);
        fCheckAgeMaxiNaissanceEnfant := fIni.ReadBool('Coherence', 'CheckAgeMaxiNaissanceEnfant', True);
        fCheckEsperanceVie := fIni.ReadBool('Coherence', 'CheckEsperanceVie', True);
        fCheckEcartAgeEpoux := fIni.ReadBool('Coherence', 'CheckEcartAgeEpoux', True);
        fCheckNbJourEntreNaissance := fIni.ReadBool('Coherence', 'CheckNbJourEntreNaissance', True);

        //fichiers 'rtm' des rapports utiliss
        for k := 0 to _MAX_REP_PATH do
          begin
            fFileNameReport[k] := fIni.ReadString('Reports', 'FileNameReport' + _REP_PATH_REPORT[k], '');
            if fFileNameReport[k] = '' then
              begin
                fFileNameReport[k] := GetFirstFileNameReport(_REP_PATH_REPORT[k]);
                if fFileNameReport[k] <> '' then fShouldSave := True;
              end;
          end;
      end;

  finally
    fIni.Free;
  end;

  //on vrifie que les rpertoires existent
  if (not DirExists(fPathImportExport)) then fPathImportExport := sAppliPath + _REL_PATH_IMPORT_EXPORT;
  if (not DirExists(fPathImages)) then fPathImages := sAppliPath + _REL_PATH_IMAGE;
  if (not DirExists(fPathDocs)) then fPathDocs := sAppliPath + _REL_PATH_DOC;

  WindowsVersion;
end;

procedure TContext.Save;
var
  k: integer;
  fIni: TRegIniFile;

  procedure SaveStringList(Key: string; List: TStringList);
  var
    n: integer;
  begin
    try
      fIni.EraseSection(Key);
    except
    end;

    fIni.WriteInteger(Key, 'Count', List.Count);
    for n := 0 to List.Count - 1 do
      fIni.WriteString(Key, 'Str' + inttostr(n), List[n]);
  end;

begin
  fShouldSave := False;

  fIni := TRegIniFile.create;
  try
    fIni.RootKey := HKEY_CURRENT_USER;

    if fIni.OpenKey(fKeyRegistry, True) then
      begin

        //La base de donne
        fIni.WriteString('Path', 'PathFileNameBdd', fPathFileNameBdd);

        //Les rpertoires
        fIni.WriteString('Path', 'PathImportExport', fPathImportExport);
        fIni.WriteString('Path', 'PathImages', fPathImages);
        fIni.WriteString('Path', 'PathDocuments', fPathDocs);

        fIni.WriteBool('Settings', 'UseAgent', fUseAgent);

        fIni.WriteString('Settings', 'NomAgent', fNomAgent);
        // Les Skins -----------------------
        fIni.WriteBool('Settings', 'Skin', fSkin);
        fIni.WriteString('Settings', 'SkinDefault', fSkinDefault);

        //La Langue
        fIni.WriteString('Settings', 'Langue', fLangue);
        fIni.WriteString('Settings', 'Language', fLanguage);

        fIni.WriteInteger('Settings', 'SonsBase', fSonsBase);
        fIni.WriteInteger('Settings', 'VideosBase', fVideosBase);
        fIni.WriteInteger('Settings', 'Nip', fNip);

        fIni.WriteInteger('Settings', 'MaxIndPourNaviguer', fMaxIndPourNaviguer);
        //Couleurs
        fIni.WriteInteger('Colors', 'ColorHomme', fColorHomme);
        fIni.WriteInteger('Colors', 'ColorFemme', fColorFemme);

        //JPeg
        fIni.WriteInteger('Settings', 'TauxCompressionJPeg', fTauxCompressionJPeg);

        fIni.WriteString('Settings', 'ChoixCartesInternet', fChoixCartesInternet);

        //Nombre maximum de favoris par dossier
        fIni.WriteInteger('Settings', 'MaxFavoris', fMaxFavoris);

        //Mode de saisie
        case fModeSaisieNom of
          msNormal: fIni.WriteInteger('Settings', 'ModeSaisieNom', 0);
          msAllUpper: fIni.WriteInteger('Settings', 'ModeSaisieNom', 1);
          else //msJustFirstLetterUpper
            fIni.WriteInteger('Settings', 'ModeSaisieNom', 2);
        end;

        case fModeSaisiePrenom of
          msNormal: fIni.WriteInteger('Settings', 'ModeSaisiePrenom', 0);
          msAllUpper: fIni.WriteInteger('Settings', 'ModeSaisiePrenom', 1);
          else //msJustFirstLetterUpper
            fIni.WriteInteger('Settings', 'ModeSaisiePrenom', 2);
        end;

        //Paramtres gnraux
        fIni.WriteBool('Settings', 'MaxScreen', fMaxScreen);
        fIni.WriteBool('Settings', 'Photos', fPhotos);
        fIni.WriteBool('Settings', 'CanSeeHint', fCanSeeHint);
        fIni.WriteBool('Settings', 'ShowExit', fShowExit);
        fIni.WriteBool('Settings', 'Backup', fBackup);
        fIni.WriteBool('Settings', 'ShowWeb', fShowWeb);
        fIni.WriteBool('Settings', 'ShowNew', fShowNew);

        fIni.WriteBool('Settings', 'AfficheInsee', fAfficheInsee);

        fIni.WriteBool('Settings', 'OpenLastIndiviShowedOnExit', fOpenLastIndiviShowedOnExit);
        fIni.WriteBool('Settings', 'ActiveFenetreDossier', fActiveFenetreDossier);
        fIni.WriteBool('Settings', 'RefreshCousins', fRefreshCousins);
        fIni.WriteInteger('Settings', 'MaxFicheDansHistorique', fMaxFicheDansHistorique);
        fIni.WriteBool('Settings', 'CanPlaySound', fCanPlaySound);
        fIni.WriteInteger('Settings', 'ArbreReduit', fArbreReduit);
        fIni.WriteInteger('Settings', 'ArbreComplet', fArbreComplet);
        fIni.WriteBool('Settings', 'AnimArbre', fAnimArbre);
        fIni.WriteBool('Settings', 'ArbreHorizontal', fArbreHorizontal);

        //StyleController
        fIni.WriteInteger('StyleController', 'SC_BorderColor', fSC_BorderColor);
        fIni.WriteString('StyleController', 'SC_BorderStyle', fSC_BorderStyle);
        fIni.WriteString('StyleController', 'SC_ButtonStyle', fSC_ButtonStyle);
        fIni.WriteString('StyleController', 'SC_Transparence', fSC_Transparence);
        fIni.WriteBool('StyleController', 'SC_EdgesLeft', fSC_EdgesLeft);
        fIni.WriteBool('StyleController', 'SC_EdgesTop', fSC_EdgesTop);
        fIni.WriteBool('StyleController', 'SC_EdgesRight', fSC_EdgesRight);
        fIni.WriteBool('StyleController', 'SC_EdgesBottom', fSC_EdgesBottom);
        fIni.WriteBool('StyleController', 'SC_HotTrack', fSC_HotTrack);
        fIni.WriteBool('StyleController', 'SC_Shadow', fSC_Shadow);

        //les derniers lments ouverts
        fIni.WriteInteger('Last', 'LastNumDossier', fLastNumDossier);

        //Graph
        fIni.WriteInteger('Context', 'MargeLeftPrinter', fMargeLeftPrinter);
        fIni.WriteInteger('Context', 'MargeRightPrinter', fMargeRightPrinter);
        fIni.WriteInteger('Context', 'MargeBottomPrinter', fMargeBottomPrinter);
        fIni.WriteInteger('Context', 'MargeTopPrinter', fMargeTopPrinter);

        //Roue
        fIni.WriteInteger('GraphRoue', 'RoueShowNbGeneration', fRoueShowNbGeneration);
        fIni.WriteInteger('GraphRoue', 'RoueAngle', fRoueAngle);
        fIni.WriteInteger('GraphRoue', 'RoueRayon', fRoueRayon);
        fIni.WriteInteger('GraphRoue', 'RoueMargeLeft', fRoueMargeLeft);
        fIni.WriteInteger('GraphRoue', 'RoueMargeTop', fRoueMargeTop);
        fIni.WriteString('GraphRoue', 'RoueFont', fRoueFont);
        fIni.WriteInteger('GraphRoue', 'RoueCouleurTexteHomme', fRoueCouleurTexteHomme);
        fIni.WriteInteger('GraphRoue', 'RoueCouleurTexteFemme', fRoueCouleurTexteFemme);
        fIni.WriteBool('GraphRoue', 'RoueShowNom', fRoueShowNom);
        fIni.WriteBool('GraphRoue', 'RoueShowPrenom', fRoueShowPrenom);
        fIni.WriteBool('GraphRoue', 'RoueShowProfession', fRoueShowProfession);
        fIni.WriteBool('GraphRoue', 'RoueShowNaissance', fRoueShowNaissance);
        fIni.WriteBool('GraphRoue', 'RoueShowDeces', fRoueShowDeces);
        fIni.WriteInteger('GraphRoue', 'RoueDistNom', fRoueDistNom);
        fIni.WriteInteger('GraphRoue', 'RoueDistPrenom', fRoueDistPrenom);
        fIni.WriteInteger('GraphRoue', 'RoueDistProfession', fRoueDistProfession);
        fIni.WriteInteger('GraphRoue', 'RoueDistNaissance', fRoueDistNaissance);
        fIni.WriteInteger('GraphRoue', 'RoueDistDeces', fRoueDistDeces);
        fIni.WriteInteger('GraphRoue', 'RoueCouleurCercle', fRoueCouleurCercle);
        fIni.WriteInteger('GraphRoue', 'RoueCouleurRayon', fRoueCouleurRayon);
        fIni.WriteInteger('GraphRoue', 'RoueDecalageIndiCentral', fRoueDecalageIndiCentral);

        //Arbre
        fIni.WriteInteger('GraphArbre', 'ArbreShowNbGeneration', fArbreShowNbGeneration);
        fIni.WriteInteger('GraphArbre', 'ArbreMargeLeft', fArbreMargeLeft);
        fIni.WriteInteger('GraphArbre', 'ArbreMargeTop', fArbreMargeTop);
        fIni.WriteInteger('GraphArbre', 'ArbreWidthBox', fArbreWidthBox);
        fIni.WriteInteger('GraphArbre', 'ArbreHeightBox', fArbreHeightBox);
        fIni.WriteInteger('GraphArbre', 'ArbreSpaceBetween2Gen', fArbreSpaceBetween2Gen);
        fIni.WriteInteger('GraphArbre', 'ArbreSpaceBetween2Indi', fArbreSpaceBetween2Indi);
        fIni.WriteString('GraphArbre', 'ArbreFont', fArbreFont);
        fIni.WriteInteger('GraphArbre', 'ArbreCouleurTexteHomme', fArbreCouleurTexteHomme);
        fIni.WriteInteger('GraphArbre', 'ArbreCouleurTexteFemme', fArbreCouleurTexteFemme);
        fIni.WriteBool('GraphArbre', 'ArbreShowNom', fArbreShowNom);
        fIni.WriteBool('GraphArbre', 'ArbreShowPrenom', fArbreShowPrenom);
        fIni.WriteBool('GraphArbre', 'ArbreShowProfession', fArbreShowProfession);
        fIni.WriteBool('GraphArbre', 'ArbreShowNaissance', fArbreShowNaissance);
        fIni.WriteBool('GraphArbre', 'ArbreShowDeces', fArbreShowDeces);
        fIni.WriteInteger('GraphArbre', 'ArbreDistNom', fArbreDistNom);
        fIni.WriteInteger('GraphArbre', 'ArbreDistPrenom', fArbreDistPrenom);
        fIni.WriteInteger('GraphArbre', 'ArbreDistProfession', fArbreDistProfession);
        fIni.WriteInteger('GraphArbre', 'ArbreDistNaissance', fArbreDistNaissance);
        fIni.WriteInteger('GraphArbre', 'ArbreDistDeces', fArbreDistDeces);
        fIni.WriteInteger('GraphArbre', 'ArbreCouleurLiens', fArbreCouleurLiens);
        fIni.WriteInteger('GraphArbre', 'ArbreCouleurRectHomme', fArbreCouleurRectHomme);
        fIni.WriteBool('GraphArbre', 'ArbrePaintFondRecHomme', fArbrePaintFondRecHomme);
        fIni.WriteInteger('GraphArbre', 'ArbreCouleurFondRectHomme', fArbreCouleurFondRectHomme);
        fIni.WriteInteger('GraphArbre', 'ArbreCouleurRectFemme', fArbreCouleurRectFemme);
        fIni.WriteBool('GraphArbre', 'ArbrePaintFondRecFemme', fArbrePaintFondRecFemme);
        fIni.WriteInteger('GraphArbre', 'ArbreCouleurFondRectFemme', fArbreCouleurFondRectFemme);

        //Contrles de cohrences
        fIni.WriteBool('Coherence', 'CoherenceActive', fCoherenceActive);
        fIni.WriteBool('Coherence', 'CanShowWindowPbCoherence', fCanShowWindowPbCoherence);
        fIni.WriteInteger('Coherence', 'AgeMiniMariageHommes', fAgeMiniMariageHommes);
        fIni.WriteInteger('Coherence', 'AgeMiniMariageFemmes', fAgeMiniMariageFemmes);
        fIni.WriteInteger('Coherence', 'AgeMaxiMariageHommes', fAgeMaxiMariageHommes);
        fIni.WriteInteger('Coherence', 'AgeMaxiMariageFemmes', fAgeMaxiMariageFemmes);
        fIni.WriteInteger('Coherence', 'AgeMiniNaissanceEnfantHommes', fAgeMiniNaissanceEnfantHommes);
        fIni.WriteInteger('Coherence', 'AgeMiniNaissanceEnfantFemmes', fAgeMiniNaissanceEnfantFemmes);
        fIni.WriteInteger('Coherence', 'AgeMaxiNaissanceEnfantHommes', fAgeMaxiNaissanceEnfantHommes);
        fIni.WriteInteger('Coherence', 'AgeMaxiNaissanceEnfantFemmes', fAgeMaxiNaissanceEnfantFemmes);
        fIni.WriteInteger('Coherence', 'AgeMaxiAuDecesHommes', fAgeMaxiAuDecesHommes);
        fIni.WriteInteger('Coherence', 'AgeMaxiAuDecesFemmes', fAgeMaxiAuDecesFemmes);
        fIni.WriteInteger('Coherence', 'NbJourEntre2NaissancesNormales', fNbJourEntre2NaissancesNormales);
        fIni.WriteInteger('Coherence', 'NbJourEntre2NaissancesJumeaux', fNbJourEntre2NaissancesJumeaux);
        fIni.WriteInteger('Coherence', 'EcartAgeEntreEpoux', fEcartAgeEntreEpoux);

        fIni.WriteBool('Coherence', 'CheckAgeMiniMariage', fCheckAgeMiniMariage);
        fIni.WriteBool('Coherence', 'CheckAgeMaxiMariage', fCheckAgeMaxiMariage);
        fIni.WriteBool('Coherence', 'CheckAgeMiniNaissanceEnfant', fCheckAgeMiniNaissanceEnfant);
        fIni.WriteBool('Coherence', 'CheckAgeMaxiNaissanceEnfant', fCheckAgeMaxiNaissanceEnfant);
        fIni.WriteBool('Coherence', 'CheckEsperanceVie', fCheckEsperanceVie);
        fIni.WriteBool('Coherence', 'CheckEcartAgeEpoux', fCheckEcartAgeEpoux);
        fIni.WriteBool('Coherence', 'CheckNbJourEntreNaissance', fCheckNbJourEntreNaissance);

        //fichiers 'rtm' des rapports utiliss
        for k := 0 to _MAX_REP_PATH do
          begin
            fIni.WriteString('Reports', 'FileNameReport' + _REP_PATH_REPORT[k], fFileNameReport[k]);
          end;
      end;

  finally
    fIni.Free;
  end;
end;

procedure TContext.SaveOnlyIfShould;
begin
  if fShouldSave then Save;
end;

procedure TContext.WindowsVersion;
var
  OsVInfo: TOSVERSIONINFO;
  HelpStr: array[0..50] of char;
begin
  ZeroMemory(@OsVinfo, sizeOf(OsVinfo));
  OsVInfo.dwOSVersionInfoSize := sizeof(TOSVERSIONINFO);
  if GetVersionEx(OsVInfo) then
    begin
      //label1.caption := inttostr(OsInfo.dwOSVersionInfoSize);
      fBuild := inttostr(OsVInfo.dwBuildNumber);
      fCDSVersion := OsVInfo.szCSDVersion;
      fVersion := Inttostr(OsVInfo.dwMajorVersion) + '.' + inttostr(OsVInfo.dwMinorVersion);


      if OsVinfo.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS then begin

          if (OsVinfo.dwMajorVersion = 4) and (OsVinfo.dwMinorVersion > 0) then

            StrFmt(HelpStr, 'Windows 98 - Version %d.%.2d.%d', [OsVinfo.dwMajorVersion,
              OsVinfo.dwMinorVersion,

              OsVinfo.dwBuildNumber and $FFFF]) else

            StrFmt(HelpStr, 'Windows 95 - Version %d.%d Build %d',

              [OsVinfo.dwMajorVersion, OsVinfo.dwMinorVersion,

              OsVinfo.dwBuildNumber and $FFFF]);

        end;

      if OsVinfo.dwPlatformId = VER_PLATFORM_WIN32_NT then

        if fVersion = '5.0' then
          StrFmt(HelpStr, 'Microsoft Windows 2000 Version %d.%.2d.%d',
            [OsVinfo.dwMajorVersion, OsVinfo.dwMinorVersion, OsVinfo.dwBuildNumber and $FFFF])
        else if fVersion > '5' then
          begin
            fXP := 1;
            StrFmt(HelpStr, 'Microsoft Windows XP Version %d.%.2d.%d',
              [OsVinfo.dwMajorVersion, OsVinfo.dwMinorVersion, OsVinfo.dwBuildNumber and $FFFF])
          end
        else if fVersion = '4' then
          StrFmt(HelpStr, 'Microsoft Windows NT Version %d.%.2d.%d',
            [OsVinfo.dwMajorVersion, OsVinfo.dwMinorVersion, OsVinfo.dwBuildNumber and $FFFF]);

    end;

  fProductName := HelpStr;
end;

end.

