{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_About_Suite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, ExtCtrls, TFlatPanelUnit,
  StdCtrls, jpeg, TFlatSpeedButtonUnit, Buttons, u_comp_TGoodBtn, ShellApi,
  u_comp_TYLanguage, RVScroll, RichView, RVStyle, DynamicSkinForm;

type
  TFAboutSuite = class(TSuperForm)
    pBorder: TPanel;
    Panel7: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    FlatPanel1: TFlatPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    lBuild: TLabel;
    pRien: TPanel;
    Label7: TLabel;
    Label1: TLabel;
    FlatPanel2: TFlatPanel;
    Image2: TImage;
    RVStyle1: TRVStyle;
    spDynamicSkinForm1: TspDynamicSkinForm;
    Panel1: TPanel;
    Panel2: TPanel;
    RV: TRichView;
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure RVJump(Sender: TObject; id: Integer);
  private

  public

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_objet_TContext, u_form_main;

{$R *.DFM}

procedure TFAboutSuite.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_INFOS_DOSSIER);
  end;
end;

procedure TFAboutSuite.pTopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFAboutSuite.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFAboutSuite.SuperFormCreate(Sender: TObject);

begin
  if _Context.Skin then
    begin
      ClientHeight := 338;
      ClientWidth := 388;
    end;

  rv.Clear;
  rv.FirstJumpNo := 0;

  {- Philippe Cazaux-Moutou ----------------------------------------------------------------------------}
  rv.Add('Philippe Cazaux-Moutou', rvsJump2);

  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Crateur du projet en 1995', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Conception et cration de la base', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Procdures stockes', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Conception du projet', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Dveloppement', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Installation', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Suivi', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Mises  jour', rvsNormal);

  {-----------------------------------------------------------------------------------------------------}

  {- Yann Uhel ----------------------------------------------------------------------------------------}
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('Yann Uhel', rvsHeading);

  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Dveloppement module Import/Export Gedcom', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Module impression des arbres et roue', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Aide au dveloppement', rvsNormal);
  {-----------------------------------------------------------------------------------------------------}

  {- Thierry Collier ----------------------------------------------------------------------------------------}
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('Thierry Collier', rvsHeading);

  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Module de calendrier et de conversion des dates', rvsNormal);
  {-----------------------------------------------------------------------------------------------------}

  {- Remerciements -------------------------------------------------------------------------------------}
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('Remerciements ', rvsHeading);

  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Maurice Zuida, qui a trouv le nom', rvsNormal);

  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Hui-Guan Tai pour le superbe blason  propos...', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Jean-Luc Derrien pour son aide sur la cartographie...', rvsNormal);

  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Melchior de Contades', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Jean-Raymond Floquet', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Pierre-Valery Archassal', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Les dveloppeurs des groupes de news Delphi', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'Et tous ceux que je ne peux citer', rvsNormal);

  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.AddTextFromNewLine(' ', rvsNormal);
  rv.Add('  ' + 'pour leur aide, leurs tests et leur contribution.', rvsNormal);
  {-----------------------------------------------------------------------------------------------------}

  rv.format;
  rv.Paint;
end;

procedure TFAboutSuite.RVJump(Sender: TObject; id: Integer);
var
  x: string;
begin
  x := 'mailto:' + Trim(dm.GetEmail); //+ '?Subject=Ancestrologie';
  ShellExecute(0, nil, PChar(x), nil, nil, SW_SHOWDEFAULT);
end;

end.
