{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Agent;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, ExtCtrls, TFlatPanelUnit,
  StdCtrls, jpeg, TFlatSpeedButtonUnit, Buttons, u_comp_TGoodBtn, ShellApi,
  u_comp_TYLanguage, DynamicSkinForm, GraphicEx, SkinCtrls;

type
  TFAgent = class(TSuperForm)
    pBorder: TPanel;
    Panel7: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    FlatPanel1: TFlatPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    lBuild: TLabel;
    pRien: TPanel;
    Label7: TLabel;
    FlatPanel2: TFlatPanel;
    spDynamicSkinForm1: TspDynamicSkinForm;
    Panel1: TPanel;
    Panel2: TPanel;
    spSkinPanel1: TspSkinPanel;
    Claude: TImage;
    Genie: TImage;
    Milton: TImage;
    Merlin: TImage;
    James: TImage;
    Ozzar: TImage;
    spSkinStdLabel1: TspSkinStdLabel;
    spSkinStdLabel2: TspSkinStdLabel;
    spSkinStdLabel3: TspSkinStdLabel;
    spSkinStdLabel4: TspSkinStdLabel;
    spSkinStdLabel5: TspSkinStdLabel;
    spSkinStdLabel6: TspSkinStdLabel;
    Image1: TImage;
    lTitre: TspSkinStdLabel;
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);

    procedure doAgent(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
  private

  public

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_objet_TContext, u_form_main,
  u_common_func;

{$R *.DFM}

procedure TFAgent.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_INFOS_DOSSIER);
  end;
end;

procedure TFAgent.pTopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFAgent.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFAgent.doAgent(Sender: TObject);
var
  sNom: string;
begin
  sNom := (sender as Timage).Name;

  if not FileExists(GetWindowsDir + '\msagent\chars\' + sNom + '.acs') then
    begin
      lTitre.Font.Color := clRed;
      lTitre.Caption := sNom + ' : Le personnage que vous avez choisi, n''est pas prsent sur votre disque dur' +
        '. Allez le tlcharger sur le site d''Ancestrologie'
    end
  else
    begin
      lTitre.Font.Color := clNavy;
      lTitre.Caption := 'Le personnage que vous avez choisi est : ' + sNom;

      _Context.NomAgent := sNom;
      
      _Agent.doDestroy;

      _Agent.sAgent := sNom;
      _Agent.doCreate(True);

      _Agent.doAgent('Announce', '', Left+width, Top);
    end

end;

procedure TFAgent.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 460;
      ClientWidth := 412;
    end;

  lTitre.Font.Color := clNavy;
  lTitre.Caption := 'Le personnage actuel est  : ' + _Agent.sAgent;

  _Agent.doAgent('Announce', '', Left+width, Top);
end;

procedure TFAgent.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  _Agent.doAgent('Hide', '', 0, 0);
end;

end.

