{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Compte_Villes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, StdCtrls, ExtCtrls,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery,
  dxCntner, dxTL, dxDBCtrl, dxDBGrid, TFlatButtonUnit, Buttons,
  u_comp_TGoodBtn, u_comp_TYLanguage, dxExEdtr, TeEngine, Series, TeeProcs,
  Chart, DBChart, QrTee, QuickRpt, TFlatPanelUnit, DynamicSkinForm;

type
  TFCompteVilles = class(TSuperForm)
    Query: TIBQuery;
    DataSource: TDataSource;
    pBorder: TPanel;
    pTop: TPanel;
    SpeedButton2: TSpeedButton;
    Label10: TLabel;
    SpeedButton1: TSpeedButton;
    Panel7: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel1: TPanel;
    dxDBGrid1: TdxDBGrid;
    Combien: TdxDBGridMaskColumn;
    Libelle: TdxDBGridMaskColumn;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    QueryCOMBIEN: TIntegerField;
    QueryRPA_LIBELLE: TIBStringField;
    FlatPanel1: TFlatPanel;
    fpGraph: TFlatPanel;
    QRChart: TDBChart;
    Series1: TBarSeries;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCreate(Sender: TObject);
    procedure fpGraphResize(Sender: TObject);
  private
    procedure OpenQuery;
  public

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_form_main;

{$R *.DFM}

{ TFEditRefParticules }

procedure TFCompteVilles.OpenQuery;
begin
  Query.DisableControls;
  try
    Query.Close;
    Query.Open;
  finally
    Query.EnableControls;
  end;

  doRefreshControls;
end;

procedure TFCompteVilles.SuperFormShowFirstTime(Sender: TObject);
begin
  OpenQuery;
end;

procedure TFCompteVilles.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFCompteVilles.Label10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFCompteVilles.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;

procedure TFCompteVilles.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 451;
      ClientWidth := 529;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Height := ClientHeight;
end;

procedure TFCompteVilles.fpGraphResize(Sender: TObject);
begin
  QRChart.Top := 0;
  QRChart.Left := 0;
  QRChart.Height := fpGraph.Height;
  QRChart.Width := fpGraph.Width;
end;

end.
