{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Infos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, ExtCtrls, TFlatPanelUnit, Ibquery,
  StdCtrls, jpeg, TFlatSpeedButtonUnit, Buttons, u_comp_TGoodBtn,
  u_comp_TYLanguage, DynamicSkinForm;

type
  TFInfos = class(TSuperForm)
    pBorder: TPanel;
    Panel7: TPanel;
    Panel9: TPanel;
    Image2: TImage;
    Panel10: TPanel;
    Panel11: TPanel;
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    lHommes: TLabel;
    lFemmes: TLabel;
    lIndeter: TLabel;
    lUnions: TLabel;
    lEveInd: TLabel;
    lEveFam: TLabel;
    lAdresses: TLabel;
    lPatronymes: TLabel;
    lImages: TLabel;
    lPays: TLabel;
    lRegions: TLabel;
    lDepts: TLabel;
    lVilles: TLabel;
    lIndividus: TLabel;
    Panel8: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    FlatPanel1: TFlatPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    Panel1: TPanel;
    Panel2: TPanel;
    Label5: TLabel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel16: TPanel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    btnCarto: TGoodBtn;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure btnCartoClick(Sender: TObject);
  private


  public
    procedure ShowStats;
  end;



implementation

uses u_dm, u_common_var, u_common_const, u_objet_TContext,
  u_Form_Compte_Villes, u_form_main;

{$R *.DFM}

procedure TFInfos.ShowStats;
var s_Proc: TIBQuery;

begin
  _FOccupe.doActive;
  try

    s_Proc := TIBQuery.Create(Application);

    with s_Proc do begin
        DisableControls;
        DataBase := dm.ibd_BASE;
        SQL.ADD('SELECT * FROM PROC_COMPTAGE(:DOSSIER, :I_MODE)');
        Params[0].AsInteger := dm.NumDossier;
        Params[1].AsInteger := 1;
        Open;

        while not Eof do begin
            if FieldByName('LIBELLE').AsString = 'INDIVID' then
              lIndividus.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'TUNIONS' then
              lUnions.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = '_HOMMES' then
              lHommes.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = '_FEMMES' then
              lFemmes.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'INDETER' then
              lIndeter.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'EVE_IND' then
              lEveInd.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'EVE_FAM' then
              lEveFam.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = '_VILLES' then
              lVilles.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'PATRONY' then
              lPatronymes.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = '___PAYS' then
              lPays.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'REGIONS' then
              lRegions.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'DEPARTE' then
              lDepts.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'MULTIME' then
              lImages.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger)
            else if FieldByName('LIBELLE').AsString = 'ADRESSE' then
              lAdresses.Caption := IntToStr(FieldByName('COMPTAGE').AsInteger);


            next;
          end;
        EnableControls;
        Close;
      end;

    s_Proc.Free;

  finally
    _FOccupe.doDesactive;
  end;
end;

procedure TFInfos.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_INFOS_DOSSIER);
  end;
end;

procedure TFInfos.pTopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFInfos.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;


procedure TFInfos.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 580;
      ClientWidth := 406;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Label1.Font.Color := _Context.ColorHomme;
  Label2.Font.Color := _Context.ColorFemme;

  lHommes.Font.Color := _Context.ColorHomme;
  lFemmes.Font.Color := _Context.ColorFemme;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;



  Label17.Caption := 'Produit : ' + _Context.ProductName;
  if _Context.CDSVersion = '' then
    begin
      Label18.Hide;
      Label19.Top := Label18.Top;
    end;

  Label18.Caption := 'Version : ' + _Context.CDSVersion;
  Label19.Caption := 'Build   : ' + _Context.Build;

  Height := ClientHeight - 10;
end;

procedure TFInfos.btnCartoClick(Sender: TObject);
var aFCompteVilles: TFCompteVilles;
begin
  aFCompteVilles := TFCompteVilles.create(self);
  try
    aFCompteVilles.ShowModal;
  finally
    aFCompteVilles.Free;
  end;
end;

end.
