{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Liste_Doublons;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, graphics,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, Menus, jpeg, dxDBTLCl, dxGrClms, u_comp_TGoodBtn,
  u_comp_TYLanguage, dialogs, IBUpdateSQL, dxExEdtr, DynamicSkinForm;

type
  TFListeDoublons = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQDoublons: TIBQuery;
    DSDoublons: TDataSource;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column3: TdxDBGridColumn;
    dxDBGrid1Column4: TdxDBGridColumn;
    dxDBGrid1Column5: TdxDBGridColumn;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    IBQDoublonsCLE_FICHE: TIntegerField;
    IBQDoublonsNOM: TIBStringField;
    IBQDoublonsPRENOM: TIBStringField;
    IBQDoublonsDATE_NAISS: TIBStringField;
    IBQDoublonsLIEU_NAISS: TIBStringField;
    IBQDoublonsDATE_DECES: TIBStringField;
    IBQDoublonsLIEU_DECES: TIBStringField;
    dxDBGrid1Column6: TdxDBGridColumn;
    IBQDoublons_DEL: TBooleanField;
    btnFermer: TGoodBtn;
    pBravo: TPanel;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Language: TYLanguage;
    pmGrid: TPopupMenu;
    Ouvrirlafichedansunenouvellefentre1: TMenuItem;
    Supprimerlafiche1: TMenuItem;
    N1: TMenuItem;
    IBUpdateSQL1: TIBUpdateSQL;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure pmGridPopup(Sender: TObject);
    procedure Ouvrirlafichedansunenouvellefentre1Click(Sender: TObject);
    procedure Supprimerlafiche1Click(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
  private
    fDialogMode: boolean;

    procedure SetDialogMode(const Value: boolean);
    procedure doShowDoublons;
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_common_func, u_form_main;


{$R *.DFM}

procedure TFListeDoublons.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 367;
      ClientWidth := 719;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  doShowDoublons;

  doRefreshControls;
end;


procedure TFListeDoublons.doShowDoublons;
var
  fTryToSelectCleFiche: integer;
begin

  fTryToSelectCleFiche := -1;
  try
    if IBQDoublons.Active then
      if IBQDoublons.IsEmpty = false
        then fTryToSelectCleFiche := IBQDoublons.FieldByName('CLE_FICHE').AsInteger;
  except
  end;


  IBQDoublons.Close;
  IBQDoublons.Params[0].AsInteger := dm.NumDossier;
  IBQDoublons.Open;

  if fTryToSelectCleFiche <> -1 then
    begin
      IBQDoublons.Locate('CLE_FICHE', fTryToSelectCleFiche, []);
    end;


  doRefreshControls;
end;

procedure TFListeDoublons.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQDoublons.Close;
end;

procedure TFListeDoublons.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
  //     panBtnDialog.visible := Value;
end;

procedure TFListeDoublons.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFListeDoublons.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;



//     if (anode.AbsoluteIndex mod 2) <> 0 then AColor := clRed;

procedure TFListeDoublons.pmGridPopup(Sender: TObject);
var
  ok: boolean;
begin
  ok := (IBQDoublons.Active) and (IBQDoublons.IsEmpty = false) and (dm.FicheActive <> IBQDoublons.FieldByName('CLE_FICHE').AsInteger);
  Ouvrirlafichedansunenouvellefentre1.enabled := ok;
  Supprimerlafiche1.enabled := ok;
end;

procedure TFListeDoublons.Ouvrirlafichedansunenouvellefentre1Click(Sender: TObject);
begin
  OpenFicheIndividuInBox(IBQDoublons.FieldByName('CLE_FICHE').AsInteger);
end;





procedure TFListeDoublons.Supprimerlafiche1Click(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la suppression de cette fiche individu ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      try
        Application.ProcessMessages;
        IBQDoublons.Delete;
        dm.IBT_BASE.CommitRetaining;

        Application.ProcessMessages;

      except
      end;
    end;

end;

procedure TFListeDoublons.SuperFormRefreshControls(Sender: TObject);
begin
  dxDBGrid1.Enabled := (IBQDoublons.Active) and (IBQDoublons.IsEmpty = false);
  pBravo.Visible := (IBQDoublons.Active) and (IBQDoublons.IsEmpty);
end;

procedure TFListeDoublons.dxDBGrid1DblClick(Sender: TObject);
begin
  if (IBQDoublons.Active) and (IBQDoublons.IsEmpty = false) and (dm.FicheActive <> IBQDoublons.FieldByName('CLE_FICHE').AsInteger)
    then OpenFicheIndividuInBox(IBQDoublons.FieldByName('CLE_FICHE').AsInteger);
end;

end.
