{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Liste_Unions;

interface


uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, Menus, jpeg, dxDBTLCl, dxGrClms, u_comp_TGoodBtn,
  Dialogs, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFListeUnions = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQUnions: TIBQuery;
    DSUnions: TDataSource;
    IBQUnionsUNION_CLE: TIntegerField;
    IBQUnionsMARI_CLE: TIntegerField;
    IBQUnionsMARI_NOM: TIBStringField;
    IBQUnionsMARI_PRENOM: TIBStringField;
    IBQUnionsFEMME_CLE: TIntegerField;
    IBQUnionsFEMME_NOM: TIBStringField;
    IBQUnionsFEMME_PRENOM: TIBStringField;
    IBQUnionsVILLE: TIBStringField;
    IBQUnionsPAYS: TIBStringField;
    pmUnions: TPopupMenu;
    mMari: TMenuItem;
    mFemme: TMenuItem;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column3: TdxDBGridColumn;
    dxDBGrid1Column4: TdxDBGridColumn;
    dxDBGrid1Column5: TdxDBGridColumn;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    GoodBtn7: TGoodBtn;
    N1: TMenuItem;
    ExporterenHTML1: TMenuItem;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    btnPrint: TGoodBtn;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure mMariClick(Sender: TObject);
    procedure mFemmeClick(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure pmUnionsPopup(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
  private
    fDialogMode: boolean;
    fCleFicheSelected: integer;

    procedure SetDialogMode(const Value: boolean);
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property CleFicheSelected: integer read fCleFicheSelected write fCleFicheSelected;

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_common_func, u_form_main;


{$R *.DFM}

procedure TFListeUnions.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 370;
      ClientWidth := 719;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Height := ClientHeight;

  SaveDialog.InitialDir := _Context.PathImportExport;

  IBQUnions.Params[0].AsInteger := dm.NumDossier;
  IBQUnions.Open;
end;

procedure TFListeUnions.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQUnions.Close;
end;

procedure TFListeUnions.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFListeUnions.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFListeUnions.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFListeUnions.mMariClick(Sender: TObject);
begin
  fCleFicheSelected := IBQUnionsMARI_CLE.AsInteger;
  ModalResult := mrOk;
end;

procedure TFListeUnions.mFemmeClick(Sender: TObject);
begin
  fCleFicheSelected := IBQUnionsFEMME_CLE.AsInteger;
  ModalResult := mrOk;
end;

procedure TFListeUnions.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Liste des Unions.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBQUnions.DisableControls;
      try
        SavePlace := IBQUnions.GetBookmark;
        dxDBGrid1.SaveToHTML(s_Fichier, True);
      finally
        IBQUnions.GotoBookmark(SavePlace);
        IBQUnions.FreeBookmark(SavePlace);

        IBQUnions.EnableControls;

      end;
    end;
end;

procedure TFListeUnions.pmUnionsPopup(Sender: TObject);
begin
  mMari.Enabled := dxDBGrid1.Count > 0;
  mFemme.Enabled := mMari.Enabled;
  ExporterenHTML1.Enabled := mMari.Enabled;
end;

procedure TFListeUnions.btnPrintClick(Sender: TObject);
begin
  FMain.doPrint(3);
end;

end.

