{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Maj_Internet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, ExtCtrls, TFlatPanelUnit, Ibquery,
  StdCtrls, jpeg, TFlatSpeedButtonUnit, Buttons, u_comp_TGoodBtn, IniFiles,
  u_comp_TYLanguage, u_comp_TInfoVersion, IdBaseComponent, ShellApi,
  IdAntiFreezeBase, IdAntiFreeze, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, RunLabel, ComCtrls, DynamicSkinForm, GraphicEx,
  SkinCtrls;

type
  TFMajInternet = class(TSuperForm)
    pBorder: TPanel;
    Panel7: TPanel;
    Panel9: TPanel;
    Image2: TImage;
    Panel10: TPanel;
    Panel11: TPanel;
    FlatPanel1: TFlatPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    lBuild: TLabel;
    InfoVersion: TInfoVersion;
    Label1: TLabel;
    pInfos: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    lSite: TLabel;
    Label4: TLabel;
    btnMAJ: TGoodBtn;
    pRien: TPanel;
    Label5: TLabel;
    Label7: TLabel;
    IdAntiFreeze1: TIdAntiFreeze;
    IdHTTP1: TIdHTTP;
    lRun: TLabel;
    btnNews: TGoodBtn;
    Animate: TAnimate;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure btnMAJClick(Sender: TObject);
    procedure btnNewsClick(Sender: TObject);
    procedure SuperFormActivate(Sender: TObject);
  private
    function doMaj(sPath: string): Integer;
  public

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_objet_TContext, u_form_Web,
  u_form_main;

{$R *.DFM}

procedure TFMajInternet.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_INFOS_DOSSIER);
  end;
end;

procedure TFMajInternet.pTopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFMajInternet.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFMajInternet.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 337;
      ClientWidth := 388;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  lBuild.Caption := InfoVersion.Version;

end;

procedure TFMajInternet.btnMAJClick(Sender: TObject);
var
  FicStream: TFileStream;
  FIniFile: TIniFile;
  sNoMineur, sBuild, sTaille: string;
  sPath: string;
  OkClose: Boolean;
begin
  OkClose := False;

  sPath := ExtractFilePath(Application.ExeName) + 'Update';

  if not FileExists(sPath) then
    CreateDir(sPath);

  sPath := sPath + '\';

  IdAntiFreeze1.Active := True;

  if btnMAJ.Caption = 'Mettre  jour' then
    begin
      doMaj(sPath);
      OkClose := True;
    end
  else
    begin
      lRun.Visible := True;
      Application.ProcessMessages;
      IdHTTP1.Disconnect;
      IdHTTP1.Host := 'privftp.pro.proxad.net';

      if FileExists(sPath + 'Update.ini') then DeleteFile(sPath + 'Update.ini');

      FicStream := TFileStream.Create(sPath + 'Update.ini', fmCreate);

      lRun.Caption := 'Vrification des mises  jour';

      try
        begin
          IdHTTP1.DoRequest(hmGet, dm.GetUrlMajAuto + 'Update.ini', nil, FicStream);

          FicStream.Free;

          if ((IdHTTP1.ResponseCode = 200) and (FileExists(sPath + 'Update.ini'))) then
            begin
              FIniFile := TIniFile.Create(sPath + 'Update.ini');
              if FIniFile.SectionExists('UPDATE') then
                begin
                  lRun.Visible := False;
                  sNoMineur := FIniFile.ReadString('UPDATE', 'NoMineur', '0');
                  sBuild := FIniFile.ReadString('UPDATE', 'Build', '0');
                  sTaille := FIniFile.ReadString('UPDATE', 'Taille', '0');

                  DeleteFile(sPath + 'Update.ini');

                  //if (StrToInt(sNoMineur) < StrToInt(InfoVersion.NoMineur)) and
                  if (StrToInt(sBuild) > StrToInt(InfoVersion.NoConstruction)) then
                    begin
                      if Length(sTaille) > 0 then
                        sBuild := sBuild + ' - Taille : ' + sTaille;

                      btnMAJ.Caption := 'Mettre  jour';
                      btnNews.Visible := True;
                      pInfos.Visible := true;
                      lSite.Caption := 'Build [' + sBuild + ']';

                      //  btnNewsClick(Sender);
                    end
                  else
                    begin
                      pRien.Visible := true;
                      btnMAJ.Enabled := False;
                    end;
                end;
              FIniFile.Free;
            end
          else
            lRun.Caption := 'Problme de connexion.';
        end;
      except
        begin
          FicStream.Free;
          Showmessage('Vous n''etes pas connect  Internet, connectez-vous et ressayez...');
        end;
      end;
      IdHTTP1.Disconnect;
    end;

  IdHTTP1.Disconnect;
  lRun.Visible := False;
  IdAntiFreeze1.Active := False;
  Application.ProcessMessages;

  if OkClose then
    begin
      if _Context.ShowExit then
        begin
          _Context.ShowExit := False;
          // _Context.save;
        end;
      // ShowMessage('La mise  jour en version ' + sVersion + ' s''est bien passe. Vous devez relancer Ancestrologie');
      dm.doCloseDatabase;
      FMain.Close;
    end;
end;

function TFMajInternet.doMaj(sPath: string): Integer;
var FicStream: TFileStream;
begin
  Screen.Cursor := crHourGlass;
  btnNews.Visible := False;
  Animate.Active := True;
  Animate.Visible := True;
  lRun.Visible := True;
  btnMAJ.Enabled := False;
  btnMAJ.Caption := 'Vrifier les MAJ';

  lRun.Caption := 'Tlchargement en cours...';
  Application.ProcessMessages;

  if FileExists(sPath + 'Ancestro2001.exe') then DeleteFile(sPath + 'Ancestro2001.exe');
  if FileExists(sPath + 'Ancestrologie.exe') then DeleteFile(sPath + 'Ancestrologie.exe');

  IdHTTP1.Disconnect;
  FicStream := TFileStream.Create(sPath + 'Ancestrologie.exe', fmCreate);
  IdHTTP1.DoRequest(hmGet, dm.GetUrlMajAuto + 'Ancestrologie.exe', nil, FicStream);
  FicStream.Free;
  IdHTTP1.Disconnect;

  Animate.Active := False;
  Animate.Visible := False;
  lRun.Caption := 'Tlchargement termin.';
  sleep(1000);
  btnMAJ.Enabled := True;

  ShellExecute(handle, 'Open', 'Updateur.exe', nil, nil, SW_HIDE);

end;

procedure TFMajInternet.btnNewsClick(Sender: TObject);
var aFWeb: TFWeb;
begin
  aFWeb := TFWeb.create(self);
  try
    aFWeb.Position := poScreenCenter;
    aFWeb.doInit(dm.GetUrlInfosMaj);
    aFWeb.ShowModal;
  finally
    aFWeb.Free;
  end;
end;

procedure TFMajInternet.SuperFormActivate(Sender: TObject);
begin
  if not FileExists(ExtractFilePath(Application.ExeName) + 'Updateur.exe') then
    begin
      btnMAJ.Enabled := False;
      ShowMessage('Le programme "Updateur.exe" est instrouvable dans le rpertoire d''Ancestrologie...');
    end;
end;

end.

