{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Verif_Event;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, graphics,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, Menus, jpeg, dxDBTLCl, dxGrClms, u_comp_TGoodBtn,
  u_comp_TYLanguage, dialogs, IBUpdateSQL, dxExEdtr, DynamicSkinForm;

type
  TFVerifEvent = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQVerif: TIBQuery;
    DSVerif: TDataSource;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column3: TdxDBGridColumn;
    dxDBGrid1Column4: TdxDBGridColumn;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    btnFermer: TGoodBtn;
    Label2: TLabel;
    Language: TYLanguage;
    IBQVerifEV_IND_KLE_FICHE: TIntegerField;
    IBQVerifSTYPE: TIBStringField;
    IBQVerifNOM: TIBStringField;
    IBQVerifPRENOM: TIBStringField;
    IBQVerifEV_IND_DATE_WRITEN: TIBStringField;
    btnDel: TGoodBtn;
    Label1: TLabel;
    IBQVerifEV_CLEF: TIntegerField;
    IBQDelete: TIBQuery;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
  private
    fDialogMode: boolean;

    procedure SetDialogMode(const Value: boolean);
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_common_func, u_form_main;


{$R *.DFM}

procedure TFVerifEvent.SuperFormCreate(Sender: TObject);
begin
  screen.Cursor := crHourglass;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 370;
      ClientWidth := 719;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Height := ClientHeight;

  Application.ProcessMessages;

  IBQVerif.Close;
  IBQVerif.Params[0].AsInteger := dm.NumDossier;
  IBQVerif.Open;

  btnDel.Enabled := dxDBGrid1.Count > 0;

  doRefreshControls;

  screen.Cursor := crDefault;
end;

procedure TFVerifEvent.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQVerif.Close;
end;

procedure TFVerifEvent.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFVerifEvent.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFVerifEvent.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFVerifEvent.SuperFormRefreshControls(Sender: TObject);
begin
  dxDBGrid1.Enabled := (IBQVerif.Active) and (IBQVerif.IsEmpty = false);
end;

procedure TFVerifEvent.dxDBGrid1DblClick(Sender: TObject);
begin
  if (IBQVerif.Active) and (IBQVerif.IsEmpty = false) and (dm.FicheActive <> IBQVerifEV_IND_KLE_FICHE.AsInteger)
    then OpenFicheIndividuInBox(IBQVerifEV_IND_KLE_FICHE.AsInteger);
end;

procedure TFVerifEvent.btnDelClick(Sender: TObject);
begin
  btnDel.Enabled := False;

  screen.Cursor := crHourglass;

  IBQDelete.Params[0].AsInteger := IBQVerifEV_CLEF.AsInteger;
  IBQDelete.ExecSQL;
  dm.IBT_BASE.CommitRetaining;
  IBQDelete.Close;

  IBQVerif.Close;
  IBQVerif.Params[0].AsInteger := dm.NumDossier;
  IBQVerif.Open;

  screen.Cursor := crDefault;

  btnDel.Enabled := dxDBGrid1.Count > 0;
end;

end.
