{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Actes_Affectation;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxCntner, dxTL,
  dxDBCtrl, dxDBGrid, jpeg, u_comp_TGoodBtn, u_comp_TYLanguage, Menus,
  Dialogs, IBStoredProc, dxDBTLCl, dxGrClms, ImgList, dxExEdtr,
  DynamicSkinForm;

type
  TFActesAffectation = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    Panel13: TPanel;
    Image1: TImage;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    DSActesTrouves: TDataSource;
    IBSPMAJ: TIBStoredProc;
    IBActesTrouves: TIBQuery;
    IBActesTrouvesEVE_CLEF: TIntegerField;
    IBActesTrouvesEVE_TYPE: TIBStringField;
    IBActesTrouvesEVE_LIB_LONG: TIBStringField;
    IBActesTrouvesEVE_DATE_WRITEN: TIBStringField;
    IBActesTrouvesEVE_CP: TIBStringField;
    IBActesTrouvesEVE_VILLE: TIBStringField;
    IBActesTrouvesEVE_ACTE: TIntegerField;
    IBActesTrouvesEVE_TABLE: TIBStringField;
    IBActesTrouvesEVE_IMAGE: TIntegerField;
    IBActesTrouvesIMAGE: TIntegerField;
    ImageList: TImageList;
    dxDBGrid: TdxDBGrid;
    dxDBGridColumn5: TdxDBGridImageColumn;
    dxDBGridColumn1: TdxDBGridColumn;
    dxDBGridColumn2: TdxDBGridColumn;
    dxDBGridColumn3: TdxDBGridColumn;
    dxDBGridColumn4: TdxDBGridColumn;
    Label1: TLabel;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnFermerClick(Sender: TObject);
    procedure IBActesTrouvesCalcFields(DataSet: TDataSet);
  private
    fDialogMode: boolean;
    fClefImage: integer;

    procedure SetDialogMode(const Value: boolean);
    procedure doSelect;
  public

    property DialogMode: boolean read fDialogMode write SetDialogMode;

    procedure doInit(iIndi, iImage: Integer);
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_form_main;

{$R *.DFM}

procedure TFActesAffectation.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  if _Context.Skin then
    begin
      ClientHeight := 276;
      ClientWidth := 631;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fDialogMode := true;

end;

procedure TFActesAffectation.doInit(iIndi, iImage: Integer);
begin
  fClefImage := iImage;
  IBActesTrouves.DisableControls;
  try
    IBActesTrouves.Close;
    IBActesTrouves.Params[0].AsInteger := iIndi; {Cle de l'individu}
    IBActesTrouves.Open;


  finally
    IBActesTrouves.EnableControls;
  end;
  bsfbSelection.Enabled := dxDBGrid.Count > 0;
end;

procedure TFActesAffectation.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBActesTrouves.Close;
end;

procedure TFActesAffectation.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFActesAffectation.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFActesAffectation.bsfbSelectionClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFActesAffectation.doSelect;
begin
  IBSPMAJ.ParamByName('I_EVE').AsInteger := IBActesTrouvesEVE_CLEF.AsInteger;
  IBSPMAJ.ParamByName('S_TABLE').AsString := IBActesTrouvesEVE_TABLE.AsString;
  IBSPMAJ.ParamByName('I_CLEF_IMAGE').AsInteger := fClefImage;

  IBSPMAJ.ExecProc;

  if fDialogMode then ModalResult := mrOk;
end;

procedure TFActesAffectation.dxDBGrid1DblClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFActesAffectation.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of

    VK_ESCAPE: ModalResult := mrCancel;

  end;
end;

procedure TFActesAffectation.btnFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFActesAffectation.IBActesTrouvesCalcFields(DataSet: TDataSet);
begin
  IBActesTrouvesIMAGE.AsInteger := 0;
  if IBActesTrouvesEVE_IMAGE.AsInteger > 0 then
    IBActesTrouvesIMAGE.AsInteger := 1;
end;

end.
