{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Evements_Ajout;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, Db,
  IBCustomDataSet, IBQuery, dxDBGrid, dxTL, dxDBCtrl, dxDBTLCl, dxGrClms,
  dxCntner, jpeg, ComCtrls, ImgList,
  TFlatSpeedButtonUnit, u_comp_TGoodBtn, u_comp_TYLanguage, dxExEdtr,
  DynamicSkinForm;

type
  TFEvenement_Ajout = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    DSAjoutEve: TDataSource;
    IBQAjoutEve: TIBQuery;
    ImagCat: TImageList;
    IBQAjoutEveREF_EVE_LIB_COURT: TIBStringField;
    IBQAjoutEveREF_EVE_LIB_LONG: TIBStringField;
    Panel1: TPanel;
    Image1: TImage;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1REF_EVE_CAT: TdxDBGridImageColumn;
    dxDBGrid1REF_EVE_LIB_LONG: TdxDBGridMaskColumn;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    IBQAjoutEveREF_EVE_CODE: TIntegerField;
    IBQAjoutEveREF_EVE_CAT: TIntegerField;
    IBQAjoutEveREF_EVE_VISIBLE: TIntegerField;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
    procedure dxDBTreeDblClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fRef_Eve_Lib_Court: string;
    fRef_Eve_Lib_Long: string;
    fDialogMode: boolean;

    procedure up_Boutons(a_Mode: Boolean);
    procedure SetDialogMode(const Value: boolean);
    procedure doSelect;
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property Ref_Eve_Lib_Court: string read fRef_Eve_Lib_Court write fRef_Eve_Lib_Court;
    property Ref_Eve_Lib_Long: string read fRef_Eve_Lib_Long write fRef_Eve_Lib_Long;

    procedure up_Init(I_CLEF: Integer; A_MODE: string);
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_form_main;


{$R *.DFM}

procedure TFEvenement_Ajout.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin

  if _Context.Skin then
    begin
      ClientHeight := 480;
      ClientWidth := 279;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fDialogMode := false;
  fRef_Eve_Lib_Court := '';

  up_Boutons(False);
end;

procedure TFEvenement_Ajout.up_Init(I_CLEF: Integer; A_MODE: string);
begin
  Screen.Cursor := crHourglass;

  if a_Mode = 'U' then Height := 270;

  IBQAjoutEve.DisableControls;
  try
    IBQAjoutEve.Close;
    IBQAjoutEve.Params[0].AsInteger := I_CLEF;
    IBQAjoutEve.Params[1].AsString := A_MODE;
    IBQAjoutEve.Open;
    IBQAjoutEve.Last;
    IBQAjoutEve.First;
  finally
    IBQAjoutEve.EnableControls;

    Screen.Cursor := crDefault;
  end;

end;

procedure TFEvenement_Ajout.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQAjoutEve.Close;
  IBQAjoutEve.Free;
end;

procedure TFEvenement_Ajout.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
  //     panBtnDialog.visible := Value;
end;

procedure TFEvenement_Ajout.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFEvenement_Ajout.up_Boutons(a_Mode: Boolean);
begin
  //
end;

procedure TFEvenement_Ajout.btnOkClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFEvenement_Ajout.doSelect;
begin
  if (IBQAjoutEve.Active) and (IBQAjoutEve.RecordCount > 0) then
    begin
      fRef_Eve_Lib_Court := IBQAjoutEveREF_EVE_LIB_COURT.AsString;
      fRef_Eve_Lib_Long := IBQAjoutEveREF_EVE_LIB_LONG.AsString;
      ModalResult := mrOk;
    end;
end;

procedure TFEvenement_Ajout.dxDBTreeDblClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFEvenement_Ajout.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFEvenement_Ajout.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    //	  VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_HELP_INDI_IDENTITE);
  end;
end;

end.
