{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Modif_Favoris;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, ExtCtrls, TFlatPanelUnit, Ibquery,
  StdCtrls, jpeg, TFlatSpeedButtonUnit, Buttons, u_comp_TGoodBtn,
  u_comp_TYLanguage, dxEdLib, dxCntner, dxEditor, dxExEdtr, dxDBELib, DB,
  IBCustomDataSet, DynamicSkinForm;

type
  TFModifFavoris = class(TSuperForm)
    pBorder: TPanel;
    Panel7: TPanel;
    Panel9: TPanel;
    Image2: TImage;
    Panel10: TPanel;
    Panel11: TPanel;
    FlatPanel1: TFlatPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    btnAppliquer: TGoodBtn;
    fpAdresses: TFlatPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    Label9: TLabel;
    edVille: TdxDBPickEdit;
    fbInfosVilles: TGoodBtn;
    fbPays: TGoodBtn;
    FlatPanel2: TFlatPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label11: TLabel;
    dxDBPickEdit1: TdxDBPickEdit;
    sDBECP: TdxEdit;
    sDBERegion: TdxEdit;
    sDBEPays: TdxEdit;
    edDept: TdxEdit;
    edVille_f: TdxEdit;
    dxCPr: TdxEdit;
    dxRegionr: TdxEdit;
    dxPaysr: TdxEdit;
    dxDeptr: TdxEdit;
    dxViller: TdxEdit;
    Label13: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    IBQuery1: TIBQuery;
    dxInsee: TdxEdit;
    Label15: TLabel;
    dxInseer: TdxEdit;
    Label16: TLabel;
    GoodBtn1: TGoodBtn;
    GoodBtn2: TGoodBtn;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure btnAppliquerClick(Sender: TObject);
    procedure fbInfosVillesClick(Sender: TObject);
    procedure fbPaysClick(Sender: TObject);
    procedure GoodBtn1Click(Sender: TObject);
    procedure GoodBtn2Click(Sender: TObject);
  private

  public
    procedure doInit(sParam: array of string);
  end;

implementation

uses u_dm, u_common_var, u_common_const, u_objet_TContext,
  u_form_list_villes, u_form_Pays, u_form_main;

{$R *.DFM}


procedure TFModifFavoris.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_INFOS_DOSSIER);
  end;
end;

procedure TFModifFavoris.pTopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFModifFavoris.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;


procedure TFModifFavoris.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 437;
      ClientWidth := 490;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

end;

procedure TFModifFavoris.doInit(sParam: array of string);
begin
  dxCPr.Text := sParam[0];
  dxInseer.Text := sParam[1];
  dxViller.Text := sParam[2];
  dxDeptr.Text := sParam[3];
  dxRegionr.Text := sParam[4];
  dxPaysr.Text := sParam[5];
end;

procedure TFModifFavoris.btnAppliquerClick(Sender: TObject);
var QUpdate: TIBQuery;
begin
  Screen.Cursor := crHourGlass;
  btnAppliquer.Enabled := False;

  QUpdate := TIBQuery.create(self);
  try
    QUpdate.Database := dm.ibd_BASE;
    QUpdate.SQL.Add('UPDATE EVENEMENTS_IND ' +
      'SET ' +
      'EV_IND_CP = :EV_IND_CP, ' +
      'EV_IND_VILLE = :EV_IND_VILLE, ' +
      'EV_IND_DEPT = :EV_IND_DEPT, ' +
      'EV_IND_REGION = :EV_IND_REGION, ' +
      'EV_IND_PAYS = :EV_IND_PAYS, ' +
      'EV_IND_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'EV_IND_KLE_DOSSIER = :DOSSIER AND ' +
      'EV_IND_CP = :EV_IND_CP_OLD AND ' +
      'UPPER(EV_IND_VILLE) = UPPER(:EV_IND_VILLE_OLD) AND ' +
      'UPPER(EV_IND_DEPT) = UPPER(:EV_IND_DEPT_OLD) AND ' +
      'UPPER(EV_IND_REGION) = UPPER(:EV_IND_REGION_OLD) AND ' +
      'UPPER(EV_IND_PAYS) = UPPER(:EV_IND_PAYS_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_CP_OLD').AsString := dxCPr.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;
    QUpdate.ParamByName('EV_IND_DEPT_OLD').AsString := dxDeptr.Text;
    QUpdate.ParamByName('EV_IND_REGION_OLD').AsString := dxRegionr.Text;
    QUpdate.ParamByName('EV_IND_PAYS_OLD').AsString := dxPaysr.Text;

    // showmessage(QUpdate.SQL.GetText);
    QUpdate.ExecSQL;
    QUpdate.Close;

    QUpdate.SQL.Clear;
    QUpdate.SQL.Add('UPDATE EVENEMENTS_FAM ' +
      'SET ' +
      'EV_FAM_CP = :EV_IND_CP, ' +
      'EV_FAM_VILLE = :EV_IND_VILLE, ' +
      'EV_FAM_DEPT = :EV_IND_DEPT, ' +
      'EV_FAM_REGION = :EV_IND_REGION, ' +
      'EV_FAM_PAYS = :EV_IND_PAYS, ' +
      'EV_FAM_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'EV_FAM_KLE_DOSSIER = :DOSSIER AND ' +
      'EV_FAM_CP = :EV_IND_CP_OLD AND ' +
      'UPPER(EV_FAM_VILLE) = UPPER(:EV_IND_VILLE_OLD) AND ' +
      'UPPER(EV_FAM_DEPT) = UPPER(:EV_IND_DEPT_OLD) AND ' +
      'UPPER(EV_FAM_REGION) = UPPER(:EV_IND_REGION_OLD) AND ' +
      'UPPER(EV_FAM_PAYS) = UPPER(:EV_IND_PAYS_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_CP_OLD').AsString := dxCPr.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;
    QUpdate.ParamByName('EV_IND_DEPT_OLD').AsString := dxDeptr.Text;
    QUpdate.ParamByName('EV_IND_REGION_OLD').AsString := dxRegionr.Text;
    QUpdate.ParamByName('EV_IND_PAYS_OLD').AsString := dxPaysr.Text;

    // showmessage(QUpdate.SQL.GetText);
    QUpdate.ExecSQL;
    QUpdate.Close;

    QUpdate.SQL.Clear;
    QUpdate.SQL.Add('UPDATE ADRESSES_IND ' +
      'SET ' +
      'ADR_CP = :EV_IND_CP, ' +
      'ADR_VILLE = :EV_IND_VILLE, ' +
      'ADR_DEPT = :EV_IND_DEPT, ' +
      'ADR_REGION = :EV_IND_REGION, ' +
      'ADR_PAYS = :EV_IND_PAYS, ' +
      'ADR_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'ADR_KLE_DOSSIER = :DOSSIER AND ' +
      'ADR_CP = :EV_IND_CP_OLD AND ' +
      'UPPER(ADR_VILLE) = UPPER(:EV_IND_VILLE_OLD) AND ' +
      'UPPER(ADR_DEPT) = UPPER(:EV_IND_DEPT_OLD) AND ' +
      'UPPER(ADR_REGION) = UPPER(:EV_IND_REGION_OLD) AND ' +
      'UPPER(ADR_PAYS) = UPPER(:EV_IND_PAYS_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_CP_OLD').AsString := dxCPr.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;
    QUpdate.ParamByName('EV_IND_DEPT_OLD').AsString := dxDeptr.Text;
    QUpdate.ParamByName('EV_IND_REGION_OLD').AsString := dxRegionr.Text;
    QUpdate.ParamByName('EV_IND_PAYS_OLD').AsString := dxPaysr.Text;

    // showmessage(QUpdate.SQL.GetText);
    QUpdate.ExecSQL;
    QUpdate.Close;
  finally
    QUpdate.Free;
  end;

  Screen.Cursor := crDefault;

  ModalResult := mrOk;
end;

procedure TFModifFavoris.fbInfosVillesClick(Sender: TObject);
var
  aFListVilles: TFListVilles;
begin
  aFListVilles := TFListVilles.create(self);
  try

    if aFListVilles.ShowModal = mrOk then
      begin
        sDBECP.Text := aFListVilles.Code;
        edVille_f.Text := aFListVilles.Ville;
        sDBEPays.Text := aFListVilles.Pays;
        edDept.Text := aFListVilles.Dept;
        sDBERegion.Text := aFListVilles.Region;
        dxInsee.Text := aFListVilles.Insee;
      end;
  finally
    aFListVilles.Free;
  end;
end;

procedure TFModifFavoris.fbPaysClick(Sender: TObject);
var
  aFPays: TFPays;
begin
  aFPays := TFPays.create(self);
  try
    if aFPays.ShowModal = mrOk then
      begin
        sDBEPays.Text := aFPays.Pays;
      end;
  finally
    aFPays.Free;
  end;
end;

procedure TFModifFavoris.GoodBtn1Click(Sender: TObject);
var QUpdate: TIBQuery;
begin
  Screen.Cursor := crHourGlass;
  btnAppliquer.Enabled := False;

  QUpdate := TIBQuery.create(self);
  try
    QUpdate.Database := dm.ibd_BASE;
    QUpdate.SQL.Add('UPDATE EVENEMENTS_IND ' +
      'SET ' +
      'EV_IND_CP = :EV_IND_CP, ' +
      'EV_IND_VILLE = :EV_IND_VILLE, ' +
      'EV_IND_DEPT = :EV_IND_DEPT, ' +
      'EV_IND_REGION = :EV_IND_REGION, ' +
      'EV_IND_PAYS = :EV_IND_PAYS, ' +
      'EV_IND_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'EV_IND_KLE_DOSSIER = :DOSSIER AND ' +
      'EV_IND_CP = :EV_IND_CP_OLD AND ' +
      'UPPER(EV_IND_VILLE) = UPPER(:EV_IND_VILLE_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_CP_OLD').AsString := dxCPr.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;

    try
      QUpdate.ExecSQL;
    except
      ShowMessage('Cette ville d''vnement individu, n''a pas t mise  jour...');
    end;

    QUpdate.Close;

    QUpdate.SQL.Clear;
    QUpdate.SQL.Add('UPDATE EVENEMENTS_FAM ' +
      'SET ' +
      'EV_FAM_CP = :EV_IND_CP, ' +
      'EV_FAM_VILLE = :EV_IND_VILLE, ' +
      'EV_FAM_DEPT = :EV_IND_DEPT, ' +
      'EV_FAM_REGION = :EV_IND_REGION, ' +
      'EV_FAM_PAYS = :EV_IND_PAYS, ' +
      'EV_FAM_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'EV_FAM_KLE_DOSSIER = :DOSSIER AND ' +
      'EV_FAM_CP = :EV_IND_CP_OLD AND ' +
      'UPPER(EV_FAM_VILLE) = UPPER(:EV_IND_VILLE_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_CP_OLD').AsString := dxCPr.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;

    try
      QUpdate.ExecSQL;
    except
      ShowMessage('Cette ville d''vnement famille, n''a pas t mise  jour...');
    end;

    QUpdate.Close;

    QUpdate.SQL.Clear;
    QUpdate.SQL.Add('UPDATE ADRESSES_IND ' +
      'SET ' +
      'ADR_CP = :EV_IND_CP, ' +
      'ADR_VILLE = :EV_IND_VILLE, ' +
      'ADR_DEPT = :EV_IND_DEPT, ' +
      'ADR_REGION = :EV_IND_REGION, ' +
      'ADR_PAYS = :EV_IND_PAYS, ' +
      'ADR_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'ADR_KLE_DOSSIER = :DOSSIER AND ' +
      'ADR_CP = :EV_IND_CP_OLD AND ' +
      'UPPER(ADR_VILLE) = UPPER(:EV_IND_VILLE_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_CP_OLD').AsString := dxCPr.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;

    try
      QUpdate.ExecSQL;
    except
      ShowMessage('Cette ville de domicile, n''a pas t mise  jour...');
    end;

    QUpdate.Close;

  finally
    QUpdate.Free;
  end;

  Screen.Cursor := crDefault;

  ModalResult := mrOk;
end;

procedure TFModifFavoris.GoodBtn2Click(Sender: TObject);
var QUpdate: TIBQuery;
begin
  Screen.Cursor := crHourGlass;
  btnAppliquer.Enabled := False;

  QUpdate := TIBQuery.create(self);
  try
    QUpdate.Database := dm.ibd_BASE;
    QUpdate.SQL.Add('UPDATE EVENEMENTS_IND ' +
      'SET ' +
      'EV_IND_CP = :EV_IND_CP, ' +
      'EV_IND_VILLE = :EV_IND_VILLE, ' +
      'EV_IND_DEPT = :EV_IND_DEPT, ' +
      'EV_IND_REGION = :EV_IND_REGION, ' +
      'EV_IND_PAYS = :EV_IND_PAYS, ' +
      'EV_IND_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'EV_IND_KLE_DOSSIER = :DOSSIER AND ' +
      'UPPER(EV_IND_VILLE) = UPPER(:EV_IND_VILLE_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;

    try
      QUpdate.ExecSQL;
    except
      ShowMessage('Cette ville d''vnement individu, n''a pas t mise  jour...');
    end;

    QUpdate.Close;

    QUpdate.SQL.Clear;
    QUpdate.SQL.Add('UPDATE EVENEMENTS_FAM ' +
      'SET ' +
      'EV_FAM_CP = :EV_IND_CP, ' +
      'EV_FAM_VILLE = :EV_IND_VILLE, ' +
      'EV_FAM_DEPT = :EV_IND_DEPT, ' +
      'EV_FAM_REGION = :EV_IND_REGION, ' +
      'EV_FAM_PAYS = :EV_IND_PAYS, ' +
      'EV_FAM_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'EV_FAM_KLE_DOSSIER = :DOSSIER AND ' +
      'UPPER(EV_FAM_VILLE) = UPPER(:EV_IND_VILLE_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;

    try
      QUpdate.ExecSQL;
    except
      ShowMessage('Cette ville d''vnement famille, n''a pas t mise  jour...');
    end;

    QUpdate.Close;

    QUpdate.SQL.Clear;
    QUpdate.SQL.Add('UPDATE ADRESSES_IND ' +
      'SET ' +
      'ADR_CP = :EV_IND_CP, ' +
      'ADR_VILLE = :EV_IND_VILLE, ' +
      'ADR_DEPT = :EV_IND_DEPT, ' +
      'ADR_REGION = :EV_IND_REGION, ' +
      'ADR_PAYS = :EV_IND_PAYS, ' +
      'ADR_INSEE = :EV_IND_INSEE ' +
      'WHERE ' +
      'ADR_KLE_DOSSIER = :DOSSIER AND ' +
      'UPPER(ADR_VILLE) = UPPER(:EV_IND_VILLE_OLD)');

    QUpdate.ParamByName('DOSSIER').AsInteger := dm.NumDossier;
    QUpdate.ParamByName('EV_IND_CP').AsString := sDBECP.Text;
    QUpdate.ParamByName('EV_IND_VILLE').AsString := edVille_f.Text;
    QUpdate.ParamByName('EV_IND_DEPT').AsString := edDept.Text;
    QUpdate.ParamByName('EV_IND_REGION').AsString := sDBERegion.Text;
    QUpdate.ParamByName('EV_IND_PAYS').AsString := sDBEPays.Text;
    QUpdate.ParamByName('EV_IND_INSEE').AsString := dxInsee.Text;
    QUpdate.ParamByName('EV_IND_VILLE_OLD').AsString := dxViller.Text;

    try
      QUpdate.ExecSQL;
    except
      ShowMessage('Cette ville de domicile, n''a pas t mise  jour...');
    end;

    QUpdate.Close;

  finally
    QUpdate.Free;
  end;

  Screen.Cursor := crDefault;

  ModalResult := mrOk;
end;

end.
