{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Pays;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, Sysutils,
  TFlatSpeedButtonUnit, OleCtrls, SHDocVw, u_comp_TGoodBtn, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, IBCustomDataSet, IBUpdateSQL, Db, IBQuery,
  u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFPays = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    panDock: TPanel;
    btnFermer: TGoodBtn;
    pPays: TPanel;
    dbPays: TdxDBGrid;
    dbPaysColumn1: TdxDBGridColumn;
    dbPaysColumn2: TdxDBGridColumn;
    dsPays: TDataSource;
    IBQPays: TIBQuery;
    IBQPaysRPA_CODE: TIntegerField;
    IBQPaysRPA_LIBELLE: TIBStringField;
    IBQPaysRPA_ABBREVIATION: TIBStringField;
    IBUPays: TIBUpdateSQL;
    btnAddPays: TGoodBtn;
    btnDelPays: TGoodBtn;
    bsfbSelection: TGoodBtn;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure btnAddPaysClick(Sender: TObject);
    procedure btnDelPaysClick(Sender: TObject);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SuperFormDestroy(Sender: TObject);
    procedure IBQPaysNewRecord(DataSet: TDataSet);
    procedure dbPaysDblClick(Sender: TObject);
  private
    fDialogMode: boolean;
    fsPays: string;
    fCode: string;

    procedure SetDialogMode(const Value: boolean);
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property Pays: string read fsPays write fsPays;
    property Code: string read fCode write fCode;
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_form_main;

{$R *.DFM}

procedure TFPays.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  if _Context.Skin then
    begin
      ClientHeight := 398;
      ClientWidth := 287;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  IBQPays.Open;
  fDialogMode := true;
end;

procedure TFPays.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFPays.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFPays.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;


procedure TFPays.bsfbSelectionClick(Sender: TObject);
begin

  if (IBQPays.Active) and (IBQPays.RecordCount > 0) then
    begin
      fsPays := IBQPaysRPA_LIBELLE.AsString;

      if fDialogMode = false then
        fCode := ''
      else
        begin
          ModalResult := mrOk;
        end;
    end;
end;

procedure TFPays.btnAddPaysClick(Sender: TObject);
begin
  IBQPays.Append;
  dbPays.SetFocus;
  doRefreshControls;
end;

procedure TFPays.btnDelPaysClick(Sender: TObject);
begin
  IBQPays.Delete;
  doRefreshControls;
end;

procedure TFPays.SuperFormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  try
    if (IBQPays.State in [dsEdit, dsInsert]) then IBQPays.Post;
  except
  end;
  dm.IBTrans_Secondaire.CommitRetaining;
end;

procedure TFPays.SuperFormDestroy(Sender: TObject);
begin
  IBQPays.Close
end;

procedure TFPays.IBQPaysNewRecord(DataSet: TDataSet);
var
  k: integer;
begin
  //l'ordre insert est dj fait.
  k := dm.uf_GetClefUnique('REF_PAYS');
  IBQPaysRPA_CODE.AsInteger := k;
end;

procedure TFPays.dbPaysDblClick(Sender: TObject);
begin
  bsfbSelectionClick(Sender);
end;

end.
