{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Restore;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, dxCntner, dxEditor, dxEdLib, u_comp_TBlueFlatSpeedButton,
  StdCtrls, ExtCtrls, GraphicEx, u_comp_TGoodBtn, dxExEdtr, IBServices,
  URLLink, ShellAPI, ComCtrls, IdGlobal, u_comp_TYLanguage;

type
  TFRestore = class(TSuperForm)
    Panel3: TPanel;
    Panel4: TPanel;
    Panel1: TPanel;
    Image2: TImage;
    Label7: TLabel;
    Notebook: TNotebook;
    Image1: TImage;
    GoodBtn1: TGoodBtn;
    OpenDialog: TOpenDialog;
    uPath: TURLLink;
    Language: TYLanguage;
    Memo1: TMemo;
    procedure PaintBox1Paint(Sender: TObject);
    procedure GoodBtn1Click(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormHide(Sender: TObject);
  private
    NewFileName: string;
  public

  end;

implementation

uses u_dm, u_common_var, u_form_main, u_common_func, u_common_const;
{$R *.DFM}

procedure TFRestore.PaintBox1Paint(Sender: TObject);
begin
  PaintPointille(Sender);
end;

procedure TFRestore.GoodBtn1Click(Sender: TObject);
var
  DiskSize: Int64;

  FileSize: Longint;

  Save_Cursor: TCursor;
  ibRestore: TIBRestoreService;
  IBBackup: TIBBackupService;
  FileNameGBK, PathNameGBK: string;
  lecteur: string;
  cp: integer;
begin
  _Agent.doAgent('Processing', '', 0, 0);

  Application.ProcessMessages;

  GoodBtn1.Enabled := False;

  SendFocus(Memo1);

  dm.IBT_BASE.CommitRetaining;
  dm.IBTrans_Secondaire.CommitRetaining;

  lecteur := AnsiUpperCase(extractFileDir(_Context.PathFileNameBdd));
  if length(lecteur) = 1 then
    begin

      DiskSize := DiskFree(ord(lecteur[1]) - ord('A'));
      FileSize := FileSizeByName(_Context.PathFileNameBdd);

      if (DiskSize - FileSize) < (2 * FileSize) then
        begin
          MyMessageDlg('L''espace disque, n''est pas suffisant pour effectuer l''optimisation' +
            #13#10#13#10 +
            'Il ne vous reste que ' + IntToStr(DiskSize) + ' octets de disponibles sur votre disque' +
            #13#10#13#10, mtInformation, [mbOK], 0);
          exit;
        end;
    end;

  Screen.Cursor := crHourglass;
  try
    FileNameGBK := ExtractFileName(_Context.PathFileNameBdd);
    FileNameGBK := ChangeFileExt(FileNameGBK, '.GBK');
    PathNameGBK := ExtractFilePath(_Context.PathFileNameBdd) + _REL_PATH_BACKUP;
    if not DirExists(PathNameGBK) then
      begin
        MkDir(PChar(PathNameGBK));
        if not DirExists(PathNameGBK) then Exit;
      end;

    IBBackup := TIBBackupService.Create(Self);
    with IBBackup do
      begin
        LoginPrompt := False;
        Params.Add('user_name=' + dm.s_User_Name);
        Params.Add('password=' + dm.s_PassWord);

        Active := True;

        try
          Verbose := True;
          Options := [NonTransportable, IgnoreLimbo];
          DatabaseName := _Context.PathFileNameBdd;
          BackupFile.Add(PathNameGBK + FileNameGBK);
          ServiceStart;

          Memo1.Clear;
          cp := 0;
          while not Eof do
            begin
              Memo1.Lines.Append(GetNextLine);
              inc(cp);
              if cp > 10 then
                begin
                  Application.ProcessMessages;
                  cp := 0;
                end;
              //if Memo1.Lines.Count > 100 then Memo1.Clear;
              while (Memo1.Lines.Count > 100) do
                Memo1.Lines.Delete(0);

            end;

        finally
          Active := False;
        end;
      end;

    IBBackup.Free;

    ibRestore := TIBRestoreService.Create(Self);
    dm.doCloseDatabase;
    Memo1.Clear;
    Application.ProcessMessages;

    with IBRestore do

      begin
        _Agent.doAgent('Writing', '', 0, 0);

        LoginPrompt := False;
        Params.Add('user_name=' + dm.s_User_Name);
        Params.Add('password=' + dm.s_PassWord);
        Active := True;

        try
          Verbose := True;
          Options := [Replace, UseAllSpace];
          PageBuffers := 32000;
          PageSize := 4096;
          DatabaseName.Add(_Context.PathFileNameBdd);

          if Length(NewFileName) > 0 then
            BackupFile.Add(NewFileName)
          else
            BackupFile.Add(PathNameGBK + FileNameGBK);

          Memo1.Clear;
          ServiceStart;

          cp := 0;
          while not Eof do
            begin
              Memo1.Lines.Append(GetNextLine);
              inc(cp);
              if cp > 10 then
                begin
                  Application.ProcessMessages;
                  cp := 0;
                end;

              //if Memo1.Lines.Count > 100 then Memo1.Clear;
              while (Memo1.Lines.Count > 100) do
                Memo1.Lines.Delete(0);
            end;

          Screen.Cursor := Save_Cursor;

          uPath.Caption := PathNameGBK + FileNameGBK;

          _Agent.doAgent('Hide', 'L''optimisaton est termine', 0, 0);

          MyMessageDlg('L''optimisation de la base s''est bien passe.'#13#10#13#10, mtInformation, [mbOK], 0);

        finally
          Active := False;
        end;
      end;
  finally
    Screen.Cursor := Save_Cursor;
  end;

  Memo1.lines.BeginUpdate;
  Memo1.Lines.Clear;
  Memo1.Lines.EndUpdate;

  ibRestore.Free;
  AutoFreeOnClose := true;
  DoSendMessage(Owner, 'OPEN_REPERTOIRE_AFTER_IMPORT');
  Close;
end;

procedure TFRestore.SuperFormCreate(Sender: TObject);
begin
  _Agent.doAgent('GestureLeft', '',
    FMain.Left +
    GoodBtn1.Left + 50,
    FMain.Top +
    GoodBtn1.Top + 100);
    
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  uPath.Caption := _Context.PathFileNameBdd;

end;

procedure TFRestore.SuperFormHide(Sender: TObject);
begin
_Agent.doAgent('Hide', '',0,0)
end;

end.

