{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_TriEvent;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, StdCtrls, Buttons, dxCntner, dxExEdtr,
  dxEdLib, u_comp_TYLanguage, jpeg, dxDBCtrl, dxDBGrid, dxTL, dxDBTLCl,
  dxGrClms, u_comp_TGoodBtn, TFlatPanelUnit, DB, IBCustomDataSet,
  IBUpdateSQL, IBQuery, DynamicSkinForm;

type
  TFTriEvent = class(TSuperForm)
    Language: TYLanguage;
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    pBottom: TPanel;
    Panel1: TPanel;
    Image1: TImage;
    qTri: TIBQuery;
    IBUTri: TIBUpdateSQL;
    dsTri: TDataSource;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridSpinColumn;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure lTitreMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormDestroy(Sender: TObject);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure dxDBGrid1Column2Change(Sender: TObject);
  private
    fModif: boolean;
  public
    property Modif: boolean read fModif write fModif;
    procedure doInit(iKey: Integer);
  end;

implementation

uses u_dm, u_common_var, u_common_const, u_form_main;

{$R *.DFM}

procedure TFTriEvent.SuperFormCreate(Sender: TObject);

begin
  if _Context.Skin then
    begin
      ClientHeight := 341;
      ClientWidth := 288;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

end;

procedure TFTriEvent.doInit(iKey: Integer);
begin
  qTri.Close;
  qTri.Params[0].AsInteger := iKey;
  qTri.Open;
  qTri.Edit;
end;

procedure TFTriEvent.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFTriEvent.lTitreMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFTriEvent.pTopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0)
end;

procedure TFTriEvent.SuperFormDestroy(Sender: TObject);
begin
  qTri.Close;
end;

procedure TFTriEvent.bsfbSelectionClick(Sender: TObject);
begin
  qTri.Post;
  fModif := true;
  Application.ProcessMessages;
  Close;
end;

procedure TFTriEvent.dxDBGrid1Column2Change(Sender: TObject);
begin
  bsfbSelection.Enabled := True;
end;

end.
