{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Ville_Ajout;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, Dialogs,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery, Sysutils,
  dxEditor, dxExEdtr, dxEdLib, dxDBELib, dxCntner, dxExGrEd, dxExELib,
  dxDBEdtr, dxTL, dxDBCtrl, dxDBGrid, DBCtrls, dxLayout, u_comp_TGoodBtn,
  Graphics, u_comp_TYLanguage, IBTable, DynamicSkinForm;

type
  TMydxDBPopupEdit = class(TdxDBPopupEdit)
  public
    procedure DropDown; override;
  end;

  TDummydxDropDownEdit = class(TdxInplaceDropDownEdit);

  TFVilleAjout = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    panDock: TPanel;
    IBQCP: TIBQuery;
    DSCP: TDataSource;
    IBUCP: TIBUpdateSQL;
    dxDBEdit1: TdxDBEdit;
    edVille: TdxDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    DSDept: TDataSource;
    DSRegion: TDataSource;
    DSPays: TDataSource;
    IBQDept: TIBQuery;
    IBQRegion: TIBQuery;
    IBQPays: TIBQuery;
    dxDBEdit3: TdxDBEdit;
    Label6: TLabel;
    Label7: TLabel;
    dxDBEdit4: TdxDBEdit;
    pDept: TPanel;
    Panel22: TPanel;
    Label9: TLabel;
    dxDBPanel: TdxDBGrid;
    dxDBGCLibelle: TdxDBGridColumn;
    dxDBPERegion: TdxDBPopupEdit;
    dxDBPEPays: TdxDBPopupEdit;
    Panel8: TPanel;
    dxDBPEDept: TdxDBPopupEdit;
    bsfbSelection: TGoodBtn;
    GoodBtn1: TGoodBtn;
    IBQDeptRDP_CODE: TIntegerField;
    IBQDeptRDP_LIBELLE: TIBStringField;
    IBQDeptRRG_CODE: TIntegerField;
    IBQDeptRDP_PAYS: TIntegerField;
    IBQDeptRDP_TEL: TIBStringField;
    IBQCP_PAYS: TStringField;
    IBQCP_REGION: TStringField;
    IBQCP_DEPT: TStringField;
    Panel1: TPanel;
    Label13: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    dxDBEdit5: TdxDBEdit;
    dxDBEdit6: TdxDBEdit;
    dxDBEdit7: TdxDBEdit;
    Label11: TLabel;
    Panel2: TPanel;
    IBQRegionRRG_CODE: TIntegerField;
    IBQRegionRRG_LIBELLE: TIBStringField;
    IBQPaysRPA_CODE: TIntegerField;
    IBQPaysRPA_LIBELLE: TIBStringField;
    IBQPaysRPA_ABBREVIATION: TIBStringField;
    IBQCPCP_CODE: TIntegerField;
    IBQCPCP_CP: TIBStringField;
    IBQCPCP_PREFIXE: TIBStringField;
    IBQCPCP_VILLE: TIBStringField;
    IBQCPCP_INDIC_TEL: TIBStringField;
    IBQCPCP_DEPT: TIntegerField;
    IBQCPCP_REGION: TIntegerField;
    IBQCPCP_PAYS: TIntegerField;
    IBQCPCP_INSEE: TIBStringField;
    IBQCPCP_HABITANTS: TFloatField;
    IBQCPCP_DENSITE: TFloatField;
    IBQCPCP_DIVERS: TIBStringField;
    IBQRegionRRG_PAYS: TIntegerField;
    IBQRegion_CODE: TIntegerField;
    iFrance: TImage;
    iAutre: TImage;
    IBQPays_CODE: TIntegerField;
    Language: TYLanguage;
    pGeographie: TPanel;
    Label17: TLabel;
    Label18: TLabel;
    dbLong: TdxDBEdit;
    dbLat: TdxDBEdit;
    IBTCp: TIBTable;
    IBQCPCP_LATITUDE: TFloatField;
    IBQCPCP_LONGITUDE: TFloatField;
    IBQCPCP_MAJ_INSEE: TIntegerField;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure IBQCPNewRecord(DataSet: TDataSet);
    procedure dxDBPEDeptInitPopup(Sender: TObject);
    procedure dxDBPERegionInitPopup(Sender: TObject);
    procedure dxDBPEPaysInitPopup(Sender: TObject);
    procedure dxDBPanelDblClick(Sender: TObject);
    procedure IBQRegionCalcFields(DataSet: TDataSet);
    procedure IBQPaysCalcFields(DataSet: TDataSet);
    procedure dxDBPanelKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DSCPDataChange(Sender: TObject; Field: TField);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    fVille: string;
    fCode: integer;
    fRegion: integer;
    fCodePays: Integer;
    bFirstTime: boolean;
    fLongitude: Boolean;

    tmpFieldLong: TFloatField;
    tmpFieldLat: TFloatField;

    //procedure doTesteLongitude;
  public
    //en entre
    property Code: integer read fCode write fCode;

    //en retour
    property Ville: string read fVille write fVille;
    property CodePays: Integer read fCodePays write fCodePays;


    function Prepare: boolean;
  end;

implementation

uses u_dm, u_common_const, u_common_func, u_common_var, u_form_main;

{$R *.DFM}

procedure TMydxDBPopupEdit.DropDown;
begin
  inherited;
end;

procedure TFVilleAjout.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 347;
      ClientWidth := 488;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  //doTesteLongitude;

  fCode := -1;
  fVille := '';
  pDept.Width := 400;
  pDept.Height := 250;
  bFirstTime := True;
end;

procedure TFVilleAjout.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQDept.Close;
  IBQRegion.Close;
  IBQPays.Close;
  IBQCP.Close;
end;

procedure TFVilleAjout.sbCloseClick(Sender: TObject);
begin
  IBQCP.Cancel;
  IBQCP.Close;
  Close;
end;

procedure TFVilleAjout.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFVilleAjout.bsfbSelectionClick(Sender: TObject);
begin
  if (IBQCP.State in [dsEdit, dsInsert]) then IBQCP.Post;

  try
    fVille := IBQCP.FieldByName('CP_VILLE').AsString;
    fCodePays := IBQPaysRPA_CODE.AsInteger;
  except
  end;

  IBQCP.Close;
end;

procedure TFVilleAjout.IBQCPNewRecord(DataSet: TDataSet);
begin
  //l'ordre insert est dj fait.
  fCode := dm.uf_GetClefUnique('REF_CP_VILLE');
  IBQCPCP_CODE.AsInteger := fCode;
end;

procedure TFVilleAjout.dxDBPEDeptInitPopup(Sender: TObject);
begin
  dxDBPanel.DataSource := DSDept;
  dxDBPanel.KeyField := 'RDP_CODE';
  dxDBGCLibelle.FieldName := 'RDP_LIBELLE';

  IBQDept.Close;
  IBQDept.Params[0].AsInteger := IBQRegion_CODE.AsInteger;
  IBQdept.Open;
  Label9.Caption := 'Dpartements';

  IBQRegion.DataSource := DSPays;
  IBQDept.DataSource := DSRegion;
end;

procedure TFVilleAjout.dxDBPERegionInitPopup(Sender: TObject);
begin

  IBQRegion.Close;
  IBQRegion.Params[0].AsInteger := IBQPays_CODE.AsInteger;
  IBQRegion.Open;

  Label9.Caption := 'Rgions';
  dxDBPanel.DataSource := DSRegion;
  dxDBPanel.KeyField := 'RRG_CODE';
  dxDBGCLibelle.FieldName := 'RRG_LIBELLE';

  IBQDept.Close;
  IBQRegion.DataSource := DSPays;
  IBQDept.DataSource := DSRegion;

end;

procedure TFVilleAjout.dxDBPEPaysInitPopup(Sender: TObject);
begin
  IBQPays.Close;
  IBQPays.Open;
  Label9.Caption := 'Pays';
  dxDBPanel.DataSource := DSPays;

  dxDBPanel.KeyField := 'RPA_CODE';
  dxDBGCLibelle.FieldName := 'RPA_LIBELLE';

  IBQRegion.DataSource := DSPays;
  IBQDept.DataSource := DSRegion;
end;

function TFVilleAjout.Prepare: boolean;
begin
  result := false;

  IBQDept.Open;
  IBQRegion.Open;
  IBQPays.Open;

  try
    case FormMode of

      sfmNew:
        begin
          IBQCP.Close;
          IBQCP.ParamByName('CODE').AsInteger := -1;
          IBQCP.Open;
          IBQCP.Insert;

          result := true;
        end;

      sfmEdit:
        begin
          //lTitre.Caption := 'Edition d''un lieu';
          IBQCP.Close;
          IBQCP.ParamByName('CODE').AsInteger := fCode;
          IBQCP.Open;
          IBQCP.Last;
          IBQCP.First;
          if IBQCP.RecordCount = 1 then result := true;

          iFrance.Visible := IBQCPCP_PAYS.AsInteger = 1;
          iAutre.Visible := IBQCPCP_PAYS.AsInteger <> 1;
        end;
    end;

  except
  end;

  bFirstTime := False;
end;


procedure TFVilleAjout.dxDBPanelDblClick(Sender: TObject);
begin
  fRegion := -1;

  if dxDBPanel.DataSource = DSPays then
    begin
      if not (IBQCP.State in [dsEdit, dsInsert]) then IBQCP.Edit;
      IBQCP.FieldByName('CP_PAYS').AsInteger := IBQPays.FieldByName('RPA_CODE').AsInteger;

      IBQCP.FieldByName('CP_REGION').Clear;
      IBQCP.FieldByName('CP_DEPT').Clear;


      (GetParentForm(dxDBPanel) as TdxPopupEditForm).ClosePopup(True);
    end
  else
    if dxDBPanel.DataSource = DSRegion then
      begin
        if not (IBQCP.State in [dsEdit, dsInsert]) then IBQCP.Edit;
        IBQCP.FieldByName('CP_REGION').AsInteger := IBQRegion.FieldByName('RRG_CODE').AsInteger;
        fRegion := IBQCP.FieldByName('CP_REGION').AsInteger;

        IBQCP.FieldByName('CP_DEPT').Clear;

        (GetParentForm(dxDBPanel) as TdxPopupEditForm).ClosePopup(True);


      end
    else
      if dxDBPanel.DataSource = DSDept then
        begin
          if not (IBQCP.State in [dsEdit, dsInsert]) then IBQCP.Edit;
          IBQCP.FieldByName('CP_DEPT').AsInteger := IBQDept.FieldByName('RDP_CODE').AsInteger;

          (GetParentForm(dxDBPanel) as TdxPopupEditForm).ClosePopup(True);
        end;
end;

procedure TFVilleAjout.IBQRegionCalcFields(DataSet: TDataSet);
begin
  IBQRegion_CODE.AsInteger := IBQCPCP_REGION.AsInteger;
end;

procedure TFVilleAjout.IBQPaysCalcFields(DataSet: TDataSet);
begin
  IBQPays_CODE.AsInteger := IBQCPCP_Pays.AsInteger;
end;

procedure TFVilleAjout.dxDBPanelKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then (GetParentForm(dxDBPanel) as TdxPopupEditForm).ClosePopup(True)
  else
    if (Key = VK_RETURN) then dxDBPanelDblClick(Sender);
end;

procedure TFVilleAjout.DSCPDataChange(Sender: TObject; Field: TField);
begin
  if bFirstTime then Exit;
  bsfbSelection.Enabled := True;
end;

procedure TFVilleAjout.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    //	  VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_VILLES);
  end;
end;
{
procedure TFVilleAjout.doTesteLongitude;
var ChpExiste: Boolean;
 i: integer;
 IBTCp: TIBTable;
begin

 IBTCp := TIBTable.Create(nil);
 IBTCp.DataBase := dm.ibd_BASE;
 IBTCp.TableName := 'REF_CP_VILLE';

 IBTCp.Open;
 ChpExiste := False;

 // Je lis dans cette table pour voir si le champ existe
 for i := 0 to IBTCp.FieldDefs.Count - 1 do
   if IBTCp.FieldDefs[i].Name = 'CP_LONGITUDE' then
     begin
       ChpExiste := True;
       fLongitude := True;
       pGeographie.Visible := True;
     end;

 IBTCp.Close;
 IBTCp.Free;

 if ChpExiste then
   // Il existe dans la table, donc je declare le champ
   begin
     tmpFieldLong := TFloatField.Create(nil);

     with tmpFieldLong do
       begin
         FieldName := 'CP_LONGITUDE';
         IBQCP.Open;
         Index := IBQCP.FieldCount;
         IBQCP.Close;
         DataSet := IBQCP;
       end;

     tmpFieldLat := TFloatField.Create(nil);

     with tmpFieldLat do
       begin
         FieldName := 'CP_LATITUDE';
         IBQCP.Open;
         Index := IBQCP.FieldCount;
         IBQCP.Close;
         DataSet := IBQCP;
       end;

     // J affecte le champ au query pour le rendre persistant
     IBQCP.Fields.Add(tmpFieldLong);
     IBQCP.Fields.Add(tmpFieldLat);

     // J affecte le champ a mon dbedi
     dbLong.DataField := 'CP_LONGITUDE';
     dbLat.DataField := 'CP_LATITUDE';

   end;

end;
 }

procedure TFVilleAjout.SuperFormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if fLongitude then
    begin
      dbLong.DataField := '';
      dbLong.DataSource := nil;

      dbLat.DataField := '';
      dbLat.DataSource := nil;

      IBQCP.Fields.Remove(tmpFieldLong);
      IBQCP.Fields.Remove(tmpFieldLat);
    end;
end;

end.
