{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Ville_Favoris;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, IBStoredProc,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxCntner, dxTL,
  dxDBCtrl, dxDBGrid, jpeg, u_comp_TGoodBtn, u_comp_TYLanguage, Menus,
  Dialogs, dxExEdtr, DynamicSkinForm;

type
  TFVillesFavoris = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQVillesFavoris: TIBQuery;
    DSVillesFavoris: TDataSource;
    IBQVillesFavorisEV_IND_VILLE: TIBStringField;
    IBQVillesFavorisEV_IND_CP: TIBStringField;
    IBQVillesFavorisEV_IND_DEPT: TIBStringField;
    IBQVillesFavorisEV_IND_REGION: TIBStringField;
    IBQVillesFavorisEV_IND_PAYS: TIBStringField;
    Panel13: TPanel;
    Image1: TImage;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    Label1: TLabel;
    pmUnions: TPopupMenu;
    mFiche: TMenuItem;
    N1: TMenuItem;
    ExporterenHTML1: TMenuItem;
    SaveDialog: TSaveDialog;
    IBQVillesFavorisEV_IND_INSEE: TIBStringField;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column6: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column3: TdxDBGridColumn;
    dxDBGrid1Column4: TdxDBGridColumn;
    dxDBGrid1Column5: TdxDBGridColumn;
    N2: TMenuItem;
    mModif: TMenuItem;
    GoodBtn1: TGoodBtn;
    mPrint: TMenuItem;
    btnPrint: TGoodBtn;
    GoodBtn2: TGoodBtn;
    btnPermute: TGoodBtn;
    GoodBtn3: TGoodBtn;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnFermerClick(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure pmUnionsPopup(Sender: TObject);
    procedure mFicheClick(Sender: TObject);
    procedure mModifClick(Sender: TObject);
    procedure GoodBtn1Click(Sender: TObject);
    procedure mPrintClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure btnPermuteClick(Sender: TObject);
    procedure GoodBtn3Click(Sender: TObject);
  private
    fDialogMode: boolean;

    fCode: string;
    fVille: string;
    fDept: string;
    fPays: string;
    fRegion: string;
    fInsee: string;
    fMode: boolean;

    procedure SetDialogMode(const Value: boolean);
    procedure doSelect;
  public
    property Code: string read fCode write fCode;
    property Mode: boolean read fMode write fMode;
    property Ville: string read fVille write fVille;
    property Dept: string read fDept write fDept;
    property Pays: string read fPays write fPays;
    property Region: string read fRegion write fRegion;
    property Insee: string read fInsee write fInsee;
    property DialogMode: boolean read fDialogMode write SetDialogMode;
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_Form_Individu_Sur_Favoris,
  u_form_Modif_Favoris, u_form_main, u_Form_InverseInsee,
  u_Form_Compte_Favoris;

{$R *.DFM}

procedure TFVillesFavoris.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  Application.ProcessMessages;
  if _Context.Skin then
    begin
      ClientHeight := 463;
      ClientWidth := 690;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  IBQVillesFavoris.Params[0].AsInteger := dm.NumDossier;
  IBQVillesFavoris.Open;
  fDialogMode := true;

  //dm.ShowHelp(_ID_VILLES_FAVORIS);
end;

procedure TFVillesFavoris.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQVillesFavoris.Close;
end;

procedure TFVillesFavoris.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFVillesFavoris.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFVillesFavoris.bsfbSelectionClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFVillesFavoris.doSelect;
begin
  fCode := IBQVillesFavorisEV_IND_CP.AsString;
  fVille := IBQVillesFavorisEV_IND_VILLE.AsString;
  fDept := IBQVillesFavorisEV_IND_DEPT.AsString;
  fPays := IBQVillesFavorisEV_IND_PAYS.AsString;
  fRegion := IBQVillesFavorisEV_IND_REGION.AsString;
  fInsee := IBQVillesFavorisEV_IND_INSEE.AsString;

  if fDialogMode = false then
    fCode := ''
  else ModalResult := mrOk;
end;

procedure TFVillesFavoris.dxDBGrid1DblClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFVillesFavoris.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_VILLES_FAVORIS);
  end;
end;

procedure TFVillesFavoris.btnFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFVillesFavoris.SuperFormShowFirstTime(Sender: TObject);
begin
  bsfbSelection.Visible := Mode;
end;

procedure TFVillesFavoris.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Liste des lieux favoris.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBQVillesFavoris.DisableControls;
      try
        SavePlace := IBQVillesFavoris.GetBookmark;
        dxDBGrid1.SaveToHTML(s_Fichier, True);
      finally
        IBQVillesFavoris.GotoBookmark(SavePlace);
        IBQVillesFavoris.FreeBookmark(SavePlace);

        IBQVillesFavoris.EnableControls;

      end;
    end;
end;

procedure TFVillesFavoris.pmUnionsPopup(Sender: TObject);
begin
  mFiche.Enabled := dxDBGrid1.Count > 0;
  ExporterenHTML1.Enabled := mFiche.Enabled;
end;

procedure TFVillesFavoris.mFicheClick(Sender: TObject);
var aFIndividusSurFavoris: TFIndividusSurFavoris;
begin
  aFIndividusSurFavoris := TFIndividusSurFavoris.create(self);
  try
    aFIndividusSurFavoris.DoInit(IBQVillesFavorisEV_IND_VILLE.AsString);
    aFIndividusSurFavoris.ShowModal;
  finally
    aFIndividusSurFavoris.Free;
  end;
end;

procedure TFVillesFavoris.mModifClick(Sender: TObject);
var aFModifFavoris: TFModifFavoris;
begin
  aFModifFavoris := TFModifFavoris.create(self);
  try
    aFModifFavoris.DoInit([IBQVillesFavorisEV_IND_CP.AsString,
      IBQVillesFavorisEV_IND_INSEE.AsString,
        IBQVillesFavorisEV_IND_VILLE.AsString,
        IBQVillesFavorisEV_IND_DEPT.AsString,
        IBQVillesFavorisEV_IND_REGION.AsString,
        IBQVillesFavorisEV_IND_PAYS.AsString]);

    if aFModifFavoris.ShowModal = mrOk then
      begin
        IBQVillesFavoris.Close;
        IBQVillesFavoris.Open;
      end;

  finally
    aFModifFavoris.Free;
  end;
end;

procedure TFVillesFavoris.GoodBtn1Click(Sender: TObject);
var s_Proc: TIBStoredProc;
begin
  Application.ProcessMessages;
  Screen.Cursor := crHourGlass;
  s_Proc := TIBStoredProc.Create(Application);

  try
    try
      with s_Proc do begin
          DataBase := dm.ibd_BASE;
          StoredProcName := 'PROC_MAJ_INSEE'; //'PROC_MAJ_LIEUX_FAVORIS';
          Prepare;
          ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
          ExecProc;
        end;
    except
    end;
  finally
    begin
      s_Proc.UnPrepare;
      s_Proc.free;
    end;
  end;

  IBQVillesFavoris.Close;
  IBQVillesFavoris.Open;

  Screen.Cursor := crDefault;
end;

procedure TFVillesFavoris.mPrintClick(Sender: TObject);
begin
  FMain.doPrint(2);
end;

procedure TFVillesFavoris.btnPrintClick(Sender: TObject);
begin
  mPrintClick(Sender);
end;

procedure TFVillesFavoris.sbCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFVillesFavoris.btnPermuteClick(Sender: TObject);
var aFInverseInsee: TFInverseInsee;
begin
  aFInverseInsee := TFInverseInsee.create(self);
  try
    aFInverseInsee.ShowModal;
  finally
    aFInverseInsee.Free;
  end;

  IBQVillesFavoris.Close;
  IBQVillesFavoris.Open;

end;

procedure TFVillesFavoris.GoodBtn3Click(Sender: TObject);
var aFCompteFavoris: TFCompteFavoris;
begin
  aFCompteFavoris := TFCompteFavoris.create(self);
  try
    aFCompteFavoris.ShowModal;
  finally
    aFCompteFavoris.Free;
  end;
end;

end.

