{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_anniversaires;

interface


uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, dxDBGrid,
  dxTL, dxDBCtrl, dxDBTLCl, dxGrClms, dxCntner, Sysutils, Db,
  IBCustomDataSet, IBQuery, jpeg, TFlatSpeedButtonUnit, u_comp_TGoodBtn,
  Dialogs, Menus, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFAnniversaires = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    panDock: TPanel;
    FlatPanel1: TFlatPanel;
    BlueFlatSpeedButton1: TBlueFlatSpeedButton;
    BlueFlatSpeedButton2: TBlueFlatSpeedButton;
    BlueFlatSpeedButton3: TBlueFlatSpeedButton;
    BlueFlatSpeedButton4: TBlueFlatSpeedButton;
    BlueFlatSpeedButton5: TBlueFlatSpeedButton;
    BlueFlatSpeedButton6: TBlueFlatSpeedButton;
    BlueFlatSpeedButton7: TBlueFlatSpeedButton;
    BlueFlatSpeedButton8: TBlueFlatSpeedButton;
    BlueFlatSpeedButton9: TBlueFlatSpeedButton;
    BlueFlatSpeedButton10: TBlueFlatSpeedButton;
    BlueFlatSpeedButton11: TBlueFlatSpeedButton;
    BlueFlatSpeedButton12: TBlueFlatSpeedButton;
    rbTous: TRadioButton;
    rbVivant: TRadioButton;
    Panel1: TPanel;
    DSAnni: TDataSource;
    IBQAnni: TIBQuery;
    IBQAnniCLE_FICHE: TIntegerField;
    IBQAnniNOM: TIBStringField;
    IBQAnniPRENOM: TIBStringField;
    IBQAnniDATE_DECES: TIBStringField;
    IBQAnniSEXE: TIntegerField;
    Panel2: TPanel;
    Panel3: TPanel;
    Image1: TImage;
    Panel4: TPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBGSexe: TdxDBGridImageColumn;
    dxDBGNom: TdxDBGridColumn;
    dxDBGPrenom: TdxDBGridColumn;
    btnFermer: TGoodBtn;
    bsfbSelection: TGoodBtn;
    pmGrid: TPopupMenu;
    ExporterenHTML1: TMenuItem;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    dxDBGNaissance: TdxDBGridDateColumn;
    IBQAnniDATE_NAISSANCE: TDateField;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure init(Sender: TObject);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure pmGridPopup(Sender: TObject);
  private
    year, month, day: word;
    i_Mois: SmallInt;
    i_Date: TDateTime;

    procedure up_Boutons(a_Mode: Boolean);
    procedure uf_ChargeNom(a_Mois: string);
    procedure doSelect;
  public

  end;

implementation

uses u_dm, u_form_main, cDateTime, u_common_func, u_common_var, u_common_const;
{$R *.DFM}

procedure TFAnniversaires.SuperFormCreate(Sender: TObject);
var
  n: integer;
begin

  if _Context.Skin then
    begin
      ClientHeight := 380;
      ClientWidth := 693;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  SaveDialog.InitialDir := _Context.PathImportExport;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  {on rcupere et dcompose la date du jour}
  DecodeDate(Now, year, month, day);
  i_Date := EncodeDate(year, Month, day);

  {On affecte le mois en cours au bouton mois}
  for n := 0 to ComponentCount - 1 do
    begin
      if (Components[n] is TBlueFlatSpeedButton) then
        if TBlueFlatSpeedButton(Components[n]).Tag = Month then
          TBlueFlatSpeedButton(Components[n]).down := true;
    end;

  init(Sender);

  up_Boutons(False);
end;

procedure TFAnniversaires.init(Sender: TObject);
var
  s_Mois: string;
begin

  {On calcule le mois en cours}

  if sender is TForm then
    i_Mois := cDateTime.Month(now)
  else
    if sender is TBlueFlatSpeedButton then
      i_Mois := (Sender as TBlueFlatSpeedButton).Tag;

  s_Mois := IntToStr(i_Mois);
  if Length(s_Mois) = 1 then s_Mois := '0' + s_Mois;

  uf_ChargeNom(s_Mois);

end;

procedure TFAnniversaires.uf_ChargeNom(a_Mois: string);
var
  i_Mode: smallint;
begin
  i_Mode := 0;

  if rbTous.Checked then i_Mode := 1
  else if rbVivant.Checked then i_Mode := 0;

  IBQAnni.DisableControls;
  try
    IBQAnni.Close;
    IBQAnni.Params[0].AsString := a_Mois;
    IBQAnni.Params[1].AsInteger := i_Mode;
    IBQAnni.Params[2].AsInteger := dm.NumDossier;
    IBQAnni.Open;
    IBQAnni.Last;
    IBQAnni.First;
  finally
    IBQAnni.EnableControls;
  end;

  doRefreshControls;
end;

procedure TFAnniversaires.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFAnniversaires.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFAnniversaires.up_Boutons(a_Mode: Boolean);
begin
  //
end;

procedure TFAnniversaires.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQAnni.Close;
  IBQAnni.Free;
end;

procedure TFAnniversaires.btnOkClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFAnniversaires.doSelect;
begin
  OpenFicheIndividuInBox(IBQAnni.FieldByName('CLE_FICHE').AsInteger);
end;

procedure TFAnniversaires.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_ANNIVERSAIRE);
  end;
end;

procedure TFAnniversaires.SuperFormRefreshControls(Sender: TObject);
begin
  bsfbSelection.enabled := (IBQAnni.Active) and (IBQAnni.RecordCount > 0);
end;

procedure TFAnniversaires.dxDBGrid1DblClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFAnniversaires.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Anniversaire du  mois en cours.HTM';
  SaveDialog.FileName := s_Fichier;

  if SaveDialog.Execute then
    begin
      IBQAnni.DisableControls;
      try
        SavePlace := IBQAnni.GetBookmark;
        dxDBGrid1.SaveToHTML(s_Fichier, True);
      finally
        IBQAnni.GotoBookmark(SavePlace);
        IBQAnni.FreeBookmark(SavePlace);

        IBQAnni.EnableControls;

      end;
    end;
end;

procedure TFAnniversaires.pmGridPopup(Sender: TObject);
begin
  ExporterenHTML1.enabled := IBQAnni.RecordCount > 0;
end;

end.
