unit u_form_biblio_Multimedia_Edit;

interface

uses
  Windows, Messages, u_comp_TYLanguage, CompSuperForm, DB, Forms, StdCtrls,
  u_comp_TGoodBtn, Classes, Controls, ExtCtrls, Buttons, dxCntner, ShellApi,
  dxExEdtr, dxEdLib, u_comp_TNakedSpeedButton, ppViewr, ppDB, ppModule,
  raCodMod, ppPrnabl, ppClass, ppCtrls, ppBands, ppCache, IBCustomDataSet,
  IBQuery, ppDBPipe, ppComm, ppRelatv, ppProd, ppReport, JPEG, daDataModule,
  ppDBJIT, u_objet_TState, Dialogs, SysUtils, ppVar, Printers, TXComp,
  DynamicSkinForm, ppTypes;

type

  TFBiblio_Multimedia_Edit = class(TSuperForm)
    Language: TYLanguage;
    panDock: TPanel;
    ScrollBox: TScrollBox;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel5: TPanel;
    Label2: TLabel;
    Bevel2: TBevel;
    Label3: TLabel;
    btnPrint: TNakedSpeedButton;
    rvPrinter: TdxCheckEdit;
    rbPDF: TdxCheckEdit;
    rbRTF: TdxCheckEdit;
    rbHtml: TdxCheckEdit;
    spbPreviewWhole: TSpeedButton;
    spbPreviewWidth: TSpeedButton;
    spbPreview100Percent: TSpeedButton;
    ppReport: TppReport;
    ppDBImage: TppDBPipeline;
    DSImage: TDataSource;
    QImage: TIBQuery;
    QImageMULTI_MEDIA: TBlobField;
    ppViewer: TppViewer;
    ppJITPVariable: TppJITPipeline;
    S_TITRE: TppField;
    B_STRETCH: TppField;
    cbStretch: TCheckBox;
    Bevel1: TBevel;
    SaveDialogRTF: TSaveDialog;
    SaveDialogPDF: TSaveDialog;
    SaveDialogHTML: TSaveDialog;
    I_HEIGHT: TppField;
    I_WIDTH: TppField;
    cbLandScape: TCheckBox;
    ppHeaderBand1: TppHeaderBand;
    ppLabel1: TppLabel;
    ppLine1: TppLine;
    ppDetailBand1: TppDetailBand;
    dbImage: TppDBImage;
    ppFooterBand1: TppFooterBand;
    ppLine2: TppLine;
    ppLabel2: TppLabel;
    ppVariable1: TppVariable;
    raCodeModule1: TraCodeModule;
    I_MODE: TppField;
    ExtraOptions: TExtraOptions;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure bfsbFermerClick(Sender: TObject);
    procedure SuperFormActivate(Sender: TObject);
    function ppJITPVariableGetFieldValue(aFieldName: string): Variant;
    procedure cbStretchClick(Sender: TObject);
    procedure spbPreviewWholeClick(Sender: TObject);
    procedure spbPreviewWidthClick(Sender: TObject);
    procedure spbPreview100PercentClick(Sender: TObject);
    procedure rvPrinterChange(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure rbPDFChange(Sender: TObject);
    procedure rbRTFChange(Sender: TObject);
    procedure rbHtmlChange(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure cbLandScapeClick(Sender: TObject);

  private
    FirstActivation: Boolean;
    fFill: TState;
    s_Nom: string;
    i_Clef: Integer;
  public
    procedure doInitialise(IClef: Integer; Titre: string);

  end;

implementation

uses u_dm, u_common_var, u_common_func, u_common_const, u_form_main;

{$R *.DFM}

procedure TFBiblio_Multimedia_Edit.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 506;
      ClientWidth := 615;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
  fFill := TState.create(false);
  FirstActivation := True;
end;

procedure TFBiblio_Multimedia_Edit.bfsbFermerClick(Sender: TObject);
begin
  Close
end;

procedure TFBiblio_Multimedia_Edit.doInitialise(IClef: Integer; Titre: string);
var
  MS: TMemoryStream;
  J1: TJPEGImage;
begin
  Screen.Cursor := crHourGlass;
  i_Clef := iClef;
  s_Nom := Titre;
  Caption := s_Nom;
  //QImage.DisableControls;
  QImage.Close;
  QImage.Params[0].AsInteger := IClef;
  QImage.Open;

  ppViewer.ZoomSetting := zsWholePage;

  J1 := TJPEGImage.Create;
  // ---
  with J1 do begin
      PixelFormat := jf24Bit;
      Scale := jsFullSize;
      Grayscale := False;
      Performance := jpBestQuality;
      ProgressiveDisplay := False;
      ProgressiveEncoding := True;
    end;

  MS := TMemoryStream.Create;
  QImageMULTI_MEDIA.SaveToStream(MS);
  MS.Seek(soFromBeginning, 0);
  J1.LoadFromStream(MS);

  cbLandScape.Checked := J1.Width > J1.Height;
  J1.Free;
  MS.Free;

  cbStretchClick(Self);

  // QImage.EnableControls;

  Screen.Cursor := crDefault;
end;

procedure TFBiblio_Multimedia_Edit.SuperFormActivate(Sender: TObject);
begin
  if FirstActivation then
    begin
      FirstActivation := False;
      Update;

    end;
end;

function TFBiblio_Multimedia_Edit.ppJITPVariableGetFieldValue(
  aFieldName: string): Variant;
var
  MS: TMemoryStream;
  J1: TJPEGImage;
begin
  Screen.Cursor := crHourGlass;
  if aFieldName = 'I_MODE' then
    if (cbLandScape.Checked) then
      result := 1
    else
      result := 0;

  if aFieldName = 'S_TITRE' then Result := s_Nom;

  if aFieldName = 'B_STRETCH' then
    if (cbStretch.Checked) then
      result := 1
    else
      result := 0;

  J1 := TJPEGImage.Create;
  // ---
  with J1 do begin
      PixelFormat := jf24Bit;
      Scale := jsFullSize;
      Grayscale := False;
      Performance := jpBestQuality;
      ProgressiveDisplay := False;
      ProgressiveEncoding := True;
    end;

  MS := TMemoryStream.Create;
  QImageMULTI_MEDIA.SaveToStream(MS);
  MS.Seek(soFromBeginning, 0);
  J1.LoadFromStream(MS);

  if aFieldName = 'I_HEIGHT' then Result := J1.Height;
  if aFieldName = 'I_WIDTH' then Result := J1.Width;

  J1.Free;
  MS.Free;
  Screen.Cursor := crDefault;
end;

procedure TFBiblio_Multimedia_Edit.cbStretchClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  ppReport.BeginUpdate;
  ppReport.Reset;
  ppReport.PrintToDevices;
  ppReport.EndUpdate;
  Screen.Cursor := crDefault;
end;

procedure TFBiblio_Multimedia_Edit.spbPreviewWholeClick(Sender: TObject);
begin
  ppViewer.ZoomSetting := zsWholePage;
end;

procedure TFBiblio_Multimedia_Edit.spbPreviewWidthClick(Sender: TObject);
begin
  ppViewer.ZoomSetting := zsPageWidth;
end;

procedure TFBiblio_Multimedia_Edit.spbPreview100PercentClick(
  Sender: TObject);
begin
  ppViewer.ZoomSetting := zs100Percent;
end;


procedure TFBiblio_Multimedia_Edit.SuperFormDestroy(Sender: TObject);
begin
  fFill.Free;
end;

procedure TFBiblio_Multimedia_Edit.rvPrinterChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := true;
        rbPDF.checked := false;
        rbRTF.checked := false;
        rbHtml.checked := false;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFBiblio_Multimedia_Edit.rbPDFChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := false;
        rbPDF.checked := true;
        rbRTF.checked := false;
        rbHtml.checked := false;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFBiblio_Multimedia_Edit.rbRTFChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := false;
        rbPDF.checked := false;
        rbHtml.checked := false;
        rbRTF.checked := true;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFBiblio_Multimedia_Edit.rbHtmlChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := false;
        rbPDF.checked := false;
        rbRTF.checked := false;
        rbHtml.checked := True;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFBiblio_Multimedia_Edit.btnPrintClick(Sender: TObject);
var
  suite: boolean;
begin

  if rbRTF.checked then
    begin
      SaveDialogRTF.FileName := s_Nom + '.RTF';
      suite := SaveDialogRTF.Execute;
    end
  else
    if rbPDF.checked then
      begin
        SaveDialogPDF.FileName := s_Nom + '.PDF';
        suite := SaveDialogPDF.Execute;
      end
    else
      if rbHTML.checked then
        begin
          SaveDialogHTML.FileName := s_Nom + '.HTM';
          suite := SaveDialogHTML.Execute;
        end
      else suite := true;

  if suite then
    begin
      //_FOccupe.doActive;
      try
        if rbRTF.checked then
          begin
            ppViewer.Report := nil;
            ppReport.DeviceType := 'RTFFile';
            ppReport.TextFileName := SaveDialogRTF.FileName;
            try

              ppReport.Print;
              Application.ProcessMessages;
              ShellExecute(application.Handle, nil, PChar(SaveDialogRTF.FileName), '', '', SW_SHOWNORMAL);

            finally
              ppReport.DeviceType := 'Screen';
              ppViewer.Report := ppReport;
            end;
          end
        else
          if rbPDF.checked then
            begin
              ppViewer.Report := nil;
              ppReport.DeviceType := 'PDFFile';
              ppReport.TextFileName := SaveDialogPDF.FileName;
              try
                ppReport.Print;
                Application.ProcessMessages;
                ShellExecute(application.Handle, nil, PChar(SaveDialogPDF.FileName), '', '', SW_SHOWNORMAL);
              finally
                ppReport.DeviceType := 'Screen';
                ppViewer.Report := ppReport;
              end;
            end
          else
            if rbHTML.checked then
              begin
                ppViewer.Report := nil;
                //ExtraOptions.HTML.PixelFormat    := pf8Bit;
                ppReport.DeviceType := 'HTMLFile';
                ppReport.TextFileName := SaveDialogHTML.FileName;
                try
                  ppReport.Print;
                  Application.ProcessMessages;
                finally
                  ppReport.DeviceType := 'Screen';
                  ppViewer.Report := ppReport;
                end;
              end
            else
              if rvPrinter.checked then
                begin
                  ppViewer.Report := nil;
                  ppReport.DeviceType := 'Printer';
                  try
                    ppReport.Print;
                  finally
                    ppReport.DeviceType := 'Screen';
                    ppViewer.Report := ppReport;
                  end;
                end;
      finally
        // _FOccupe.doDesactive;
      end;
    end

end;

procedure TFBiblio_Multimedia_Edit.cbLandScapeClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  if cbLandScape.Checked then
    ppReport.PrinterSetup.Orientation := poLandScape
  else
    ppReport.PrinterSetup.Orientation := poPortrait;

  ppReport.BeginUpdate;
  ppReport.Reset;
  ppReport.PrintToDevices;
  ppReport.EndUpdate;

  Screen.Cursor := crDefault;

end;

end.
