{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_edit_dossier;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages,
  TFlatSpeedButtonUnit, Db, dxExEdtr, dxEdLib, dxDBELib, dxCntner,
  dxEditor, DBCtrls, u_comp_TGoodBtn, u_comp_TYLanguage, DynamicSkinForm;

type
  TFEditDossier = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    panDock: TPanel;
    dxDBEdit1: TdxDBEdit;
    dxDBMemo1: TdxDBMemo;
    DataSource: TDataSource;
    DBText1: TDBText;
    Label1: TLabel;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    Label2: TLabel;
    Label3: TLabel;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sbCloseClick(Sender: TObject);
  private
    fDialogMode: boolean;

    procedure up_Boutons(a_Mode: Boolean);
    procedure SetDialogMode(const Value: boolean);
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_form_main;

{$R *.DFM}

procedure TFEditDossier.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin

  if _Context.Skin then
    begin
      ClientHeight := 217;
      ClientWidth := 380;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  up_Boutons(False);
end;

procedure TFEditDossier.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //
end;

procedure TFEditDossier.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFEditDossier.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFEditDossier.up_Boutons(a_Mode: Boolean);
begin
  //
end;

procedure TFEditDossier.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_DOSSIER);
  end;
end;

procedure TFEditDossier.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

end.
