{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_language;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, ExtCtrls, u_comp_TGoodBtn, u_comp_TYLanguage;

type
  TFLanguage = class(TSuperForm)
    Panel3: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    lbFacture: TLabel;
    Panel1: TPanel;
    lb: TListBox;
    Language: TYLanguage;
    Panel2: TPanel;
    Panel5: TPanel;
    Label1: TLabel;
    Panel7: TPanel;
    Label2: TLabel;
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure lbClick(Sender: TObject);
  private
    fListFiles: TStringList;
    fFill: boolean;
    procedure doTranslate;
  public

  end;

implementation

uses u_common_func, u_common_var, u_form_main, u_common_const;

{$R *.DFM}

procedure TFLanguage.SuperFormCreate(Sender: TObject);
var
  k: integer;
begin
  doTranslate;

  fFill := true;
  try
    fListFiles := TStringList.create;
    GetDirContent(_Path_Appli + _REL_PATH_TRADUCTIONS, fListFiles, '*' + _EXT_TRADUC);
    for k := 0 to fListFiles.count - 1 do
      begin
        lb.items.Append(extractFileNameWithoutExt(fListFiles[k]));
      end;

    lb.ItemIndex := lb.items.IndexOf(_Context.Language);
  finally
    fFill := false;
  end;
end;

procedure TFLanguage.SuperFormDestroy(Sender: TObject);
begin
  fListFiles.Free;
end;

procedure TFLanguage.lbClick(Sender: TObject);
var
  s: string;
  k: integer;
begin
  if fFill = false then
    begin
      //On traduit
      k := lb.ItemIndex;
      if k <> -1 then s := lb.items[k] else s := '';
      if s <> '' then
        begin
          _Context.Language := s;
          _Context.ShouldSave := true;
          _FileNameTraduction := fListFiles[k];
          _FileNameHelp := 'HelpAncestrologie_' + _Context.Language + '.chm';
          _FileNameOptimisationRtf := 'HelpOptimisation_' + _Context.Language + '.rtf';
          doTranslate;
          FMain.doTranslate;
        end;
    end;
end;

procedure TFLanguage.doTranslate;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
