{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_list_villes_Doublons;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, graphics,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, Menus, jpeg, dxDBTLCl, dxGrClms, u_comp_TGoodBtn,
  u_comp_TYLanguage, dialogs, IBUpdateSQL, dxExEdtr, DynamicSkinForm;

type
  TFListeVillesDoublons = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQDoublons: TIBQuery;
    DSDoublons: TDataSource;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column3: TdxDBGridColumn;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    btnFermer: TGoodBtn;
    pBravo: TPanel;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Language: TYLanguage;
    pmGrid: TPopupMenu;
    Supprimerlafiche1: TMenuItem;
    IBUpdateSQL1: TIBUpdateSQL;
    IBQDoublonsCP_CODE: TIntegerField;
    IBQDoublonsCP_VILLE: TIBStringField;
    IBQDoublonsCP_INSEE: TIBStringField;
    GoodBtn1: TGoodBtn;
    IBQDoublonsCP_CP: TIBStringField;
    IBQDoublonsCP_LONGITUDE: TFloatField;
    dxDBGrid1Column4: TdxDBGridColumn;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure pmGridPopup(Sender: TObject);
    procedure Supprimerlafiche1Click(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
  private
    fDialogMode: boolean;

    procedure SetDialogMode(const Value: boolean);
    procedure doShowDoublons;
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_common_func, u_form_main;


{$R *.DFM}

procedure TFListeVillesDoublons.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 370;
      ClientWidth := 719;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Application.ProcessMessages;

  doRefreshControls;
end;

procedure TFListeVillesDoublons.doShowDoublons;

begin

  IBQDoublons.Close;
  IBQDoublons.Open;

  doRefreshControls;
end;

procedure TFListeVillesDoublons.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQDoublons.Close;
end;

procedure TFListeVillesDoublons.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
  //     panBtnDialog.visible := Value;
end;

procedure TFListeVillesDoublons.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFListeVillesDoublons.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFListeVillesDoublons.pmGridPopup(Sender: TObject);
var
  ok: boolean;
begin
  ok := (IBQDoublons.Active) and (IBQDoublons.IsEmpty = false) and (dm.FicheActive <> IBQDoublons.FieldByName('CP_CODE').AsInteger);
  Supprimerlafiche1.enabled := ok;
end;

procedure TFListeVillesDoublons.Supprimerlafiche1Click(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la suppression de cette ville ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      try
        Application.ProcessMessages;
        IBQDoublons.Delete;
        dm.IBT_BASE.CommitRetaining;

        Application.ProcessMessages;
        doShowDoublons;
      except
      end;
    end;

end;

procedure TFListeVillesDoublons.SuperFormRefreshControls(Sender: TObject);
begin
  dxDBGrid1.Enabled := (IBQDoublons.Active) and (IBQDoublons.IsEmpty = false);
  pBravo.Visible := (IBQDoublons.Active) and (IBQDoublons.IsEmpty);
end;

procedure TFListeVillesDoublons.dxDBGrid1DblClick(Sender: TObject);
begin
  if (IBQDoublons.Active) and (IBQDoublons.IsEmpty = false) and (dm.FicheActive <> IBQDoublons.FieldByName('CP_CODE').AsInteger)
    then OpenFicheIndividuInBox(IBQDoublons.FieldByName('CP_CODE').AsInteger);
end;

procedure TFListeVillesDoublons.SuperFormShowFirstTime(Sender: TObject);
begin

  doShowDoublons;

end;

end.
