{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_msg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, GraphicEx, StdCtrls, TFlatSpeedButtonUnit,
  Buttons, u_comp_TGoodBtn, u_comp_TYLanguage, DynamicSkinForm;

type
  TFMsg = class(TSuperForm)
    Panel1: TPanel;
    Panel2: TPanel;
    lbMsg: TLabel;
    Image1: TImage;
    btn1: TGoodBtn;
    btn2: TGoodBtn;
    btn3: TGoodBtn;
    Language: TYLanguage;
    lYes: TLabel;
    lNo: TLabel;
    lCancel: TLabel;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure Panel15MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCreate(Sender: TObject);
  private
    fButtons: TMsgDlgButtons;
    fDlgType: TMsgDlgType;

  public
    property Buttons: TMsgDlgButtons read fButtons write fButtons;
    property DlgType: TMsgDlgType read fDlgType write fDlgType;
  end;



implementation

uses u_common_const, u_common_var, u_form_main;

{$R *.DFM}

procedure TFMsg.SuperFormShowFirstTime(Sender: TObject);
var
  k, p: integer;

  procedure PutInBtn(numBtn: integer; aText: string; aResult: word);
  begin
    case numBtn of

      1: begin
          btn1.Caption := aText;
          btn1.ModalResult := aResult;
          btn1.visible := true;
        end;
      2: begin
          btn2.Caption := aText;
          btn2.ModalResult := aResult;
          btn2.visible := true;
        end;
      3: begin
          btn3.Caption := aText;
          btn3.ModalResult := aResult;
          btn3.visible := true;
        end;
    end;
  end;

begin
  btn1.visible := false;
  btn2.visible := false;
  btn3.visible := false;

  k := 0;
  if (mbYes in fButtons) then inc(k);
  if (mbNo in fButtons) then inc(k);
  if (mbOk in fButtons) then inc(k);
  if (mbCancel in fButtons) then inc(k);
  if (mbIgnore in fButtons) then inc(k);

  if (k > 0) and (k <= 3) then
    begin
      p := 3 - k; //numro du btn de dpart (-1)

      if (mbYes in fButtons) then
        begin
          inc(p);
          putInBtn(p, lYes.Caption, mrYes);
          fButtons := fButtons - [mbYes];
        end;

      if (mbNo in fButtons) then
        begin
          inc(p);
          putInBtn(p, lNo.Caption, mrNo);
          fButtons := fButtons - [mbNo];
        end;

      if (mbOk in fButtons) then
        begin
          inc(p);
          putInBtn(p, 'Ok', mrOk);
          fButtons := fButtons - [mbOk];
        end;

      if (mbCancel in fButtons) then
        begin
          inc(p);
          putInBtn(p, lCancel.Caption, mrCancel);
          fButtons := fButtons - [mbCancel];
        end;

      if (mbIgnore in fButtons) then
        begin
          inc(p);
          putInBtn(p, 'Ignorer', mrIgnore);
          fButtons := fButtons - [mbIgnore];
        end;
    end;

  case fDlgType of

    mtWarning: Caption := 'Attention';
    mtError: Caption := 'Erreur';
    mtInformation: Caption := 'Information';
    mtConfirmation: Caption := 'Confirmation';
    else
      Caption := '';
  end;

  //  lbTitre

    {

    k := 0;
    for n := Low(fButtons) to High(fButtons) do inc(k);

    if k > 0 then
    begin
         p := 3 - k; //numro du btn de dpart (-1)
         for B := Low(fButtons) to High(fButtons) do
         begin
              inc(p);

              //texte et retour du bouton :
              case B of
                   mbYes: begin
                        end;
                   mbNo: begin
                             theText := 'Non';
                             theRetour := mrNo;
                        end;
                   mbOk: begin
                             theText := 'Ok';
                             theRetour := mrOk;
                        end;
                   mbCancel: begin
                             theText := 'Annuler';
                             theRetour := mrCancel;
                        end;
                   mbIgnore: begin
                             theText := 'Ignorer';
                             theRetour := mrIgnore;
                        end;
              else
                   begin
                        theText := '';
                        theRetour := mrNone;
                   end;
              end;

              //affectation au bouton :
              case p of

                   1: begin
                             btn1.Caption := theText;
                             btn1.ModalResult := theRetour;
                             btn1.visible := true;
                        end;
                   2: begin
                             btn2.Caption := theText;
                             btn2.ModalResult := theRetour;
                             btn2.visible := true;
                        end;
                   3: begin
                             btn3.Caption := theText;
                             btn3.ModalResult := theRetour;
                             btn3.visible := true;
                        end;
              end;
         end;
    end;
    }
 // end;
end;


procedure TFMsg.Panel15MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFMsg.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (ssAlt in Shift) and (Key = VK_F4) then Key := 0;
end;

procedure TFMsg.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 103;
      ClientWidth := 411;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
