{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_postit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, Buttons, ExtCtrls, TFlatSpeedButtonUnit,
  TFlatPanelUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery, dxCntner,
  dxEditor, dxExEdtr, dxEdLib, dxDBELib, u_comp_TGoodBtn, GraphicEx,
  u_comp_TYLanguage;

type
  TFPostit = class(TSuperForm)
    query: TIBQuery;
    IBUpdateSQL: TIBUpdateSQL;
    DataSource: TDataSource;
    Panel5: TPanel;
    Panel15: TPanel;
    SpeedButton2: TSpeedButton;
    Panel4: TPanel;
    fpBoutons: TFlatPanel;
    memo: TdxDBMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel6: TPanel;
    GoodBtn2: TGoodBtn;
    Image1: TImage;
    bsfbSelection: TGoodBtn;
    GoodBtn3: TGoodBtn;
    queryM_CLEF: TIntegerField;
    queryM_MEMO: TBlobField;
    queryM_DOSSIER: TIntegerField;
    Language: TYLanguage;
    procedure Panel15MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure GoodBtn2Click(Sender: TObject);
    procedure GoodBtn3Click(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCreate(Sender: TObject);
  private

  public
    function doOpenQuery: boolean;

  end;


implementation

uses u_dm, u_common_func, u_common_const, u_common_var;

{$R *.DFM}

function TFPostit.doOpenQuery: boolean;
var
  k: integer;
  s: string;
begin
  result := false;
  s := 'Ceci est un pense bte, vous pouvez taper autant de texte que vous voulez.';
  //     try
  query.Close;
  query.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
  query.Open;
  query.Last;
  query.First;

  if query.RecordCount = 0 then
    begin
      //On en cr un
      k := dm.uf_GetClefUnique('MEMO_INFOS');
      if k <> -1 then
        begin
          query.Insert;
          Query.FieldByName('M_CLEF').AsInteger := k;
          Query.FieldByName('M_DOSSIER').AsInteger := dm.NumDossier;
          Query.FieldByName('M_MEMO').AsString := s;
          Query.Post;
          result := true;
        end;
    end
  else
    result := true;

  {
    if (queryM_MEMO.IsNull) or (queryM_MEMO.BlobSize = 0) then
    begin
  if (Query.Active) and (not (Query.State in [dsEdit, dsInsert])) then Query.Edit;

  if (Query.Active) and (Query.State in [dsEdit, dsInsert]) then
  begin

       Query.Post;
  end;
    end;
    }
end;

procedure TFPostit.Panel15MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFPostit.SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    if (Query.State in [dsInsert, dsEdit]) then Query.Post;
  except
  end;

  Query.Close;
end;

procedure TFPostit.bsfbSelectionClick(Sender: TObject);
begin
  if MyMessageDlg('Vous tes toujours d' + #39 + 'accord pour effacer le contenue de ce bloc-notes ''?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      try
        if (Query.Active) and (not (Query.State in [dsInsert, dsEdit])) then Query.Edit;
        if (Query.Active) then
          begin
            queryM_MEMO.Clear;
            Query.Post;
          end;
      except
      end;
    end;
end;

procedure TFPostit.GoodBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TFPostit.GoodBtn3Click(Sender: TObject);
begin
  Close;
end;

procedure TFPostit.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    // VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_POSTIT);
  end;
end;

procedure TFPostit.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
