{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_select_database;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, dxCntner, dxEditor, dxEdLib, u_comp_TBlueFlatSpeedButton,
  StdCtrls, ExtCtrls, GraphicEx, u_comp_TGoodBtn, dxExEdtr,
  u_comp_TYLanguage;

type
  TFSelectDatabase = class(TSuperForm)
    Panel3: TPanel;
    Panel4: TPanel;
    Panel1: TPanel;
    Image2: TImage;
    Label7: TLabel;
    Notebook: TNotebook;
    Label2: TLabel;
    lbEmplacementbdd: TdxEdit;
    Image1: TImage;
    lbEtat: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GoodBtn10: TGoodBtn;
    Label8: TLabel;
    GoodBtn1: TGoodBtn;
    Image3: TImage;
    Label9: TLabel;
    Label10: TLabel;
    GoodBtn2: TGoodBtn;
    Label3: TLabel;
    PaintBox1: TPaintBox;
    Label11: TLabel;
    OpenDialog: TOpenDialog;
    Language: TYLanguage;
    procedure BlueFlatSpeedButton1Click(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure dxButtonEdit1ButtonClick(Sender: TObject;
      AbsoluteIndex: Integer);
    procedure GoodBtn10Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure GoodBtn1Click(Sender: TObject);
  private
    procedure TestConnexionDadabase;
    procedure doSelectBdd;

  public

  end;


implementation

uses u_dm, u_common_var, u_form_main, u_common_func, u_common_const;

{$R *.DFM}

procedure TFSelectDatabase.BlueFlatSpeedButton1Click(Sender: TObject);
begin
  doSelectBdd;
end;


procedure TFSelectDatabase.doSelectBdd;
var
  s: string;
  NewFileName: string;
begin
  NewFileName := '';

  //prparation de la boite OpenDialog
  if FileExists(dm.ibd_BASE.DatabaseName) then
    begin
      OpenDialog.InitialDir := ExtractFilePath(dm.ibd_BASE.DatabaseName);
      OpenDialog.FileName := ExtractFileName(dm.ibd_BASE.DatabaseName);
    end
  else
    begin
      s := ExtractFilePath(_Context.PathFileNameBdd);

      if DirExists(s) = false then
        begin
          s := ExtractFilePath(Application.ExeName) + 'Database\';
          if DirExists(s) = false then s := ExtractFilePath(Application.ExeName);
        end;

      OpenDialog.InitialDir := s;
      OpenDialog.FileName := '';
    end;

  //On demande le nom de la base
  if OpenDialog.Execute then
    begin
      //Nouveau nom
      NewFileName := OpenDialog.FileName;
      lbEmplacementbdd.Text := OpenDialog.FileName;
    end;

  Application.ProcessMessages;

  //Ce nom de fichier est-il correcte ?
  if FileExists(NewFileName) then
    begin
      dm.doCloseDatabase;
      Application.ProcessMessages;
      FMain.doRefreshControls;
      Application.ProcessMessages;

      _Context.PathFileNameBdd := NewFileName;
      _Context.ShouldSave := true;

      dm.doOpenDatabase;
      Application.ProcessMessages;
      FMain.doRefreshControls;

      if dm.ibd_BASE.Connected then
        begin
          TestConnexionDadabase;
          //On quitte ce module, puisque a c'est bien pass
          AutoFreeOnClose := true;
          DoSendMessage(Owner, 'DO_AFTER_SELECT_DATABASE');
          Close;
        end
      else
        TestConnexionDadabase;
    end
  else
    begin
      TestConnexionDadabase;
    end;
end;

procedure TFSelectDatabase.TestConnexionDadabase;
var etat: boolean;
begin
  try
    etat := dm.ibd_BASE.connected;
  except
    etat := false;
  end;

  if etat then Notebook.PageIndex := 0 else Notebook.PageIndex := 1;

  Application.ProcessMessages;
end;

procedure TFSelectDatabase.SuperFormShowFirstTime(Sender: TObject);
begin
  TestConnexionDadabase;
  if dm.ibd_BASE.connected
    then lbEmplacementbdd.Text := dm.ibd_BASE.DatabaseName
  else lbEmplacementbdd.Text := '';
end;

procedure TFSelectDatabase.dxButtonEdit1ButtonClick(Sender: TObject;
  AbsoluteIndex: Integer);
begin
  BlueFlatSpeedButton1Click(Sender);
end;

procedure TFSelectDatabase.GoodBtn10Click(Sender: TObject);
begin
  application.processmessages;
  doSelectBdd;
end;

procedure TFSelectDatabase.PaintBox1Paint(Sender: TObject);
begin
  PaintPointille(Sender);
end;

procedure TFSelectDatabase.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

procedure TFSelectDatabase.GoodBtn1Click(Sender: TObject);
begin
  dm.ShowHelp(_HELP_PB_BDD);
end;

end.
