{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_select_dossier;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, dxCntner, Dialogs,
  dxTL, dxDBCtrl, dxDBGrid, IBCustomDataSet, IBUpdateSQL, Db, IBQuery,
  jpeg, TFlatSpeedButtonUnit, TFlatTabControlUnit, dxEditor, dxEdLib,
  dxDBELib, dxExEdtr, u_comp_TGoodBtn, u_comp_TYLanguage, DynamicSkinForm;

type
  TFSelectDossier = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    panDock: TPanel;
    DSDossier: TDataSource;
    IBQDossier: TIBQuery;
    IBUDossier: TIBUpdateSQL;
    dxDBGListe: TdxDBGrid;
    dxDBGListeNOM_DOSSIER: TdxDBGridMaskColumn;
    dxDBGListeDS_VERROU: TdxDBGridMaskColumn;
    dxDBGListeDS_BASE_PATH: TdxDBGridMaskColumn;
    IBQDossierCLE_DOSSIER: TIntegerField;
    IBQDossierNOM_DOSSIER: TIBStringField;
    IBQDossierDS_BASE_PATH: TIBStringField;
    IBQDossierDS_INFOS: TIBStringField;
    IBQDossierDS_OUVERTURE: TDateTimeField;
    IBQDossierDS_FERMETURE: TDateTimeField;
    IBQDossierDS_LAST: TIntegerField;
    Panel3: TPanel;
    Image1: TImage;
    fpBoutons: TFlatPanel;
    fsbSelection: TGoodBtn;
    bFermer: TGoodBtn;
    bfsbAjout: TGoodBtn;
    btnEdit: TGoodBtn;
    bfsbDelete: TGoodBtn;
    IBQDossierDS_VERROU: TIntegerField;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure bfsbAjoutClick(Sender: TObject);
    procedure bfsbDeleteClick(Sender: TObject);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure IBQDossierNewRecord(DataSet: TDataSet);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure fsbSelectionClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure dxDBGListeDblClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure IBQDossierAfterScroll(DataSet: TDataSet);
    procedure SuperFormShowFirstTime(Sender: TObject);
  private
    fCanDeleteCurrentDossier: boolean;
    fActiveNewDossierIfSelect: boolean;
    fCleDossier: integer;
    fNomDossier: string;

    procedure doSelectDossier;
    procedure doEditDossier;

  public
    //en entre
    property CanDeleteCurrentDossier: boolean read fCanDeleteCurrentDossier write fCanDeleteCurrentDossier;
    property ActiveNewDossierIfSelect: boolean read fActiveNewDossierIfSelect write fActiveNewDossierIfSelect;

    //en sortie
    property CleDossier: integer read fCleDossier write fCleDossier;
    property NomDossier: string read fNomDossier write fNomDossier;

  end;

implementation

uses u_dm, u_common_var, u_form_main,
  u_form_edit_dossier, u_common_const, u_common_func;


{$R *.DFM}

procedure TFSelectDossier.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 262;
      ClientWidth := 471;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fCanDeleteCurrentDossier := true;
  fActiveNewDossierIfSelect := true;

  fCleDossier := -1;
  fNomDossier := '';

  IBQDossier.Open;
  IBQDossier.Last;
  IBQDossier.First;

  doRefreshControls;
end;


procedure TFSelectDossier.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFSelectDossier.bfsbAjoutClick(Sender: TObject);
var
  aFEditDossier: TFEditDossier;
begin
  IBQDossier.Insert;

  aFEditDossier := TFEditDossier.create(self);
  try
    aFEditDossier.DataSource.DataSet := IBQDossier;
    if aFEditDossier.ShowModal = mrOk then
      begin
        IBQDossier.Post;
      end
    else
      begin
        IBQDossier.Cancel;
      end;

  finally
    aFEditDossier.Free;
  end;

  doRefreshControls;
end;

procedure TFSelectDossier.bfsbDeleteClick(Sender: TObject);
begin
  //quel est le dossier actif ?
  if MyMessageDlg('Confirmez-vous la supression de ce dossier ? Si vous continuez, tout le contenue de cette gnalogie sera perdu !', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      //si ce dossier est le dossier en cours
      if IBQDossier.FieldByName('CLE_DOSSIER').AsInteger = dm.NumDossier then
        begin
          //si le module en cours est la fentre individu
          if FMain.IDModuleActif = _ID_INDIVIDU then
            begin
              //On ferme les query de la fiche, sans rien demander
              FMain.aFIndividu.ForceCloseAllQuerys;
            end;

          //On ferme le module actif
          FMain.CloseModuleActif;

          if FMain.aFPostit <> nil then FMain.aFPostit.Close;

          dm.NumDossier := -1;
          dm.NomDossier := '';
        end;

      Application.ProcessMessages;

      //On supprime le dossier
      IBQDossier.Delete;

      //On commit tout a
      dm.IBT_BASE.CommitRetaining;
    end;

  doRefreshControls;
  FMain.DoRefreshControls;
end;

procedure TFSelectDossier.SuperFormClose(Sender: TObject; var Action: TCloseAction);
begin
  IBQDossier.Close;
end;

procedure TFSelectDossier.IBQDossierNewRecord(DataSet: TDataSet);
begin
  IBQDossierDS_VERROU.AsInteger := 0;
  IBQDossierDS_LAST.AsInteger := -1;
  IBQDossierCLE_DOSSIER.AsInteger := dm.uf_GetClefUnique('DOSSIER');
end;



procedure TFSelectDossier.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_DOSSIER);
  end;
end;


procedure TFSelectDossier.fsbSelectionClick(Sender: TObject);
begin
  doSelectDossier;
end;

//c'est forcment un dossier diffrent du dossier en cours

procedure TFSelectDossier.doSelectDossier;
begin
  //soit on change le dossier en cours
  if fActiveNewDossierIfSelect then
    begin
      //on s'assure que les modules sont ferms
      if FMain.CloseModuleActif then
        begin
          _FOccupe.doActive;
          try
            dm.doSaveLastFicheActiveOfDossier;
            dm.doOpenDossier(IBQDossier.FieldByName('CLE_DOSSIER').AsInteger);
            // dm.up_Comptage(0);

            Application.ProcessMessages;

            fCleDossier := dm.NumDossier;
            fNomDossier := dm.NomDossier;

            _Context.LastNumDossier := dm.NumDossier;
            _Context.ShouldSave := True;

            //on rafraichis les favoris
            dm.LoadFavoris(FMain.menu_Favoris);

            Application.ProcessMessages;

            FMain.doRefreshControls;

            ModalResult := mrOk;

            Application.ProcessMessages;
          finally
            _FOccupe.doDesactive;
          end;

          Application.ProcessMessages;
        end;
    end
  else
    //soit on rcupre seulement la cl du dossier souhait (pour importation gedcom, par exemple)
    begin
      fCleDossier := IBQDossier.FieldByName('CLE_DOSSIER').AsInteger;
      fNomDossier := IBQDossier.FieldByName('NOM_DOSSIER').AsString;

      ModalResult := mrOk;
    end;
end;


procedure TFSelectDossier.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFSelectDossier.btnEditClick(Sender: TObject);
begin
  doEditDossier;
end;

procedure TFSelectDossier.doEditDossier;
var
  aFEditDossier: TFEditDossier;
begin
  IBQDossier.Edit;

  aFEditDossier := TFEditDossier.create(self);
  try
    aFEditDossier.DataSource.DataSet := IBQDossier;
    if aFEditDossier.ShowModal = mrOk then
      begin
        IBQDossier.Post;

        //si c'est le dossier en cours, alors on rfraichit les infos dans FMain
        if IBQDossier.FieldByName('CLE_DOSSIER').AsInteger = dm.NumDossier then
          begin
            dm.NomDossier := IBQDossier.FieldByName('NOM_DOSSIER').AsString;
            FMain.lbNomDossier.Caption := dm.NomDossier;
          end;
      end
    else
      begin
        IBQDossier.Cancel;
      end;

  finally
    aFEditDossier.Free;
  end;

  doRefreshControls;
end;

procedure TFSelectDossier.dxDBGListeDblClick(Sender: TObject);
begin
  if fActiveNewDossierIfSelect then
    begin
      if (IBQDossier.Active) and (IBQDossier.RecordCount > 0) and (IBQDossier.FieldByName('CLE_DOSSIER').AsInteger <> dm.NumDossier)
        then doSelectDossier;
    end
  else
    begin
      if (IBQDossier.Active) and (IBQDossier.RecordCount > 0)
        then doSelectDossier;
    end;
end;

procedure TFSelectDossier.SuperFormRefreshControls(Sender: TObject);
begin
  bfsbAjout.enabled := (IBQDossier.Active);


  if fCanDeleteCurrentDossier then
    begin
      bfsbDelete.enabled := (IBQDossier.Active) and (IBQDossier.RecordCount > 0);
    end
  else
    begin
      bfsbDelete.enabled := (IBQDossier.Active) and (IBQDossier.RecordCount > 0) and (IBQDossier.FieldByName('CLE_DOSSIER').AsInteger <> dm.NumDossier);
    end;


  btnEdit.enabled := (IBQDossier.Active) and (IBQDossier.RecordCount > 0);


  if fActiveNewDossierIfSelect then
    begin
      // fsbSelection.enabled := (IBQDossier.Active) and (IBQDossier.RecordCount > 0) and (IBQDossier.FieldByName('CLE_DOSSIER').AsInteger <> dm.NumDossier);
    end
  else
    begin
      //  fsbSelection.enabled := (IBQDossier.Active) and (IBQDossier.RecordCount > 0);
    end;

  //     fsbSelection.enabled := (IBQDossier.Active) and (IBQDossier.RecordCount > 0) and (IBQDossier.FieldByName('CLE_DOSSIER').AsInteger <> dm.NumDossier);
end;

procedure TFSelectDossier.IBQDossierAfterScroll(DataSet: TDataSet);
begin
  doRefreshControls;
end;

procedure TFSelectDossier.SuperFormShowFirstTime(Sender: TObject);
begin
  doRefreshControls;
end;

end.
