{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_ask_name_files_to_export_report;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, Buttons, ExtCtrls, u_comp_TGoodBtn, dxCntner,
  dxEditor, dxEdLib, dxExEdtr, TFlatCheckBoxUnit,
  TFlatRadioButtonUnit, TFlatGroupBoxUnit, u_comp_TYLanguage,
  DynamicSkinForm;

type
  TFAskNameFilesToExportReport = class(TSuperForm)
    pBorder: TPanel;
    Panel2: TPanel;
    Panel8: TPanel;
    btnOk: TGoodBtn;
    btnCancel: TGoodBtn;
    Panel3: TPanel;
    lbFile1: TLabel;
    lbFile2: TLabel;
    lbFile3: TLabel;
    edNameFile1: TdxEdit;
    btn1: TSpeedButton;
    edNameFile2: TdxEdit;
    btn2: TSpeedButton;
    edNameFile3: TdxEdit;
    btn3: TSpeedButton;
    FlatGroupBox1: TFlatGroupBox;
    Panel6: TPanel;
    rbPV: TFlatRadioButton;
    rbV: TFlatRadioButton;
    rbTab: TFlatRadioButton;
    rbAutre: TFlatRadioButton;
    edAutreSep: TdxEdit;
    FlatGroupBox2: TFlatGroupBox;
    cbIncludeEntete: TFlatCheckBox;
    SaveDialog1: TSaveDialog;
    SaveDialog2: TSaveDialog;
    SaveDialog3: TSaveDialog;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure btn3Click(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fNbFileToAsk: integer;

  public
    property NbFileToAsk: integer read fNbFileToAsk write fNbFileToAsk;

  end;


implementation

uses u_dm, u_common_var, u_common_const, u_form_main;

{$R *.DFM}

procedure TFAskNameFilesToExportReport.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 324;
      ClientWidth := 452;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fNbFileToAsk := 1;
  SaveDialog1.InitialDir := _Context.PathDocs;
  SaveDialog2.InitialDir := _Context.PathDocs;
  SaveDialog3.InitialDir := _Context.PathDocs;
end;

procedure TFAskNameFilesToExportReport.SuperFormRefreshControls(Sender: TObject);
var
  Ok: boolean;
begin
  case fNbFileToAsk of

    1: Ok := (edNameFile1.Text <> '');
    2: Ok := (edNameFile1.Text <> '') and (edNameFile2.Text <> '');
    3: Ok := (edNameFile1.Text <> '') and (edNameFile2.Text <> '') and (edNameFile3.Text <> '');
    else
      Ok := false;
  end;

  btnOk.Enabled := Ok;
end;

procedure TFAskNameFilesToExportReport.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFAskNameFilesToExportReport.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFAskNameFilesToExportReport.SuperFormShowFirstTime(Sender: TObject);
begin
  //Hauteur de la fentre
  case fNbFileToAsk of

    1: Height := 228;
    2: Height := 277;

  end;

  doRefreshControls;
end;

procedure TFAskNameFilesToExportReport.btn1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then edNameFile1.Text := SaveDialog1.FileName;
  doRefreshControls;
end;

procedure TFAskNameFilesToExportReport.btn2Click(Sender: TObject);
begin
  if SaveDialog2.Execute then edNameFile2.Text := SaveDialog2.FileName;
  doRefreshControls;
end;


procedure TFAskNameFilesToExportReport.btn3Click(Sender: TObject);
begin
  if SaveDialog3.Execute then edNameFile3.Text := SaveDialog3.FileName;
  doRefreshControls;
end;

procedure TFAskNameFilesToExportReport.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    _KEY_HELP: dm.ShowHelp(_ID_PRINT);
  end;
end;

end.
