{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_param_reports;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, Buttons, ExtCtrls, dxCntner, dxExEdtr, dxEdLib,
  dxEditor, dxTL, dxDBCtrl, dxDBGrid, Db, IBCustomDataSet, IBQuery,
  u_comp_TGoodBtn, u_comp_TYLanguage, DynamicSkinForm, SkinCtrls;

type
  TFParamReports = class(TSuperForm)
    pBorder: TPanel;
    Panel2: TPanel;
    Notebook: TNotebook;
    cbAnniv_Naissance: TdxCheckEdit;
    Label1: TLabel;
    cbAnniv_Deces: TdxCheckEdit;
    cbAnniv_Mariage: TdxCheckEdit;
    PickMonth: TdxPickEdit;
    Panel3: TPanel;
    Label2: TLabel;
    gridCouples: TdxDBGrid;
    IBConjoints: TIBQuery;
    IBConjointsCLE_FICHE: TIntegerField;
    IBConjointsNOM: TIBStringField;
    IBConjointsPRENOM: TIBStringField;
    IBConjointsDATE_NAISSANCE: TIBStringField;
    IBConjointsANNEE_NAISSANCE: TIntegerField;
    IBConjointsDATE_DECES: TIBStringField;
    IBConjointsANNEE_DECES: TIntegerField;
    IBConjointsCLE_PERE: TIntegerField;
    IBConjointsCLE_MERE: TIntegerField;
    IBConjointsNUM_SOSA: TFloatField;
    IBConjointsTYPE_UNION: TIntegerField;
    IBConjointsUNION_CLEF: TIntegerField;
    IBConjointsNOM_PRENOM: TStringField;
    IBConjointsKLE_DOSSIER: TIntegerField;
    IBConjointsSEXE: TIntegerField;
    DSConjoints: TDataSource;
    gridCouplesNOM: TdxDBGridMaskColumn;
    gridCouplesPRENOM: TdxDBGridMaskColumn;
    cbLimitOnYear: TdxCheckEdit;
    Label3: TLabel;
    edYearFrom: TdxSpinEdit;
    edYearTo: TdxSpinEdit;
    cbLimitOnSosa: TdxCheckEdit;
    edInterval: TdxPickEdit;
    Label4: TLabel;
    Label5: TLabel;
    rbTrieParPatronyme: TRadioButton;
    RadioButton1: TRadioButton;
    cbOnlySosaEclair: TdxCheckEdit;
    Label6: TLabel;
    Label7: TLabel;
    edVilleEclair: TdxEdit;
    Label8: TLabel;
    Label9: TLabel;
    cbTous: TdxCheckEdit;
    cbPhotos: TdxCheckEdit;
    Label11: TLabel;
    cbPhotosIndi: TdxCheckEdit;
    cbToutDossierIndi: TdxCheckEdit;
    cbToutDossierFam: TdxCheckEdit;
    Language: TYLanguage;
    rgStats: TRadioGroup;
    spDynamicSkinForm1: TspDynamicSkinForm;
    btnShowConfigBox: TspSkinButton;
    procedure SuperFormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    year, month, day: word;
    fPtrListReport: TForm;
  public
    property PtrListReport: TForm read fPtrListReport write fPtrListReport;
  end;


implementation

uses u_dm, u_form_list_report, u_common_const, u_common_func, u_common_var,
  u_form_main;

{$R *.DFM}

procedure TFParamReports.SuperFormCreate(Sender: TObject);
var
  n: integer;
begin
  if _Context.Skin then
    begin
      ClientHeight := 228;
      ClientWidth := 298;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fPtrListReport := nil;
  for n := 1 to 12 do PickMonth.items.Add(LongMonthNames[n]);
  DecodeDate(Now, year, month, day);
  PickMonth.ItemIndex := month - 1;
end;

procedure TFParamReports.Button1Click(Sender: TObject);
begin
  if fPtrListReport <> nil then
    begin
      TFListReport(fPtrListReport).doRefreshReport;
    end;
end;

procedure TFParamReports.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFParamReports.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFParamReports.SuperFormShowFirstTime(Sender: TObject);
var
  p: TPoint;
begin
  //Position de la fentre
  p := Point(Screen.width, Screen.Height);
  Left := p.x - Width - 10;
  Top := p.y - Height - 50;
end;

procedure TFParamReports.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    // VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_PRINT);
  end;
end;

end.
