unit u_form_Biblio_Documents;

interface

uses
  Windows, u_comp_TYLanguage, Controls, StdCtrls, Classes, Dialogs,
  ExtCtrls, Forms, CompSuperForm, ComCtrls, dxTL, dxCntner, SysUtils,
  TFlatSplitterUnit, Menus, DB, IBCustomDataSet, IBQuery, ImgList,
  u_objet_TState, Messages,
  u_form_biblio_Sources, IBUpdateSQL, Buttons, jpeg, u_comp_TGoodBtn,
  TFlatPanelUnit, dxExEdtr;

type

  TFBiblio_Documents = class(TSuperForm)
    Language: TYLanguage;
    ImagCat: TImageList;
    pmTV: TPopupMenu;
    mAjoutImage: TMenuItem;
    mAjoutNote: TMenuItem;
    mAjoutSource: TMenuItem;
    mDelete: TMenuItem;
    N2: TMenuItem;
    pBorder: TPanel;
    Panel13: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    btnFermer: TGoodBtn;
    bsfbNouveau: TGoodBtn;
    bsfbSelection: TGoodBtn;
    Panel4: TPanel;
    Panel10: TPanel;
    Panel1: TPanel;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    TrackBar: TTrackBar;
    TL: TdxTreeList;
    TLColLibelle: TdxTreeListColumn;
    TLColRecordType: TdxTreeListColumn;
    TLColRecordKey: TdxTreeListColumn;
    TLColAssoType: TdxTreeListColumn;
    TLColAssoKey: TdxTreeListColumn;
    TLColNode: TdxTreeListColumn;
    FlatSplitter2: TFlatSplitter;
    panDock: TPanel;
    rbOrphelins: TRadioButton;
    rbTous: TRadioButton;
    procedure SuperFormCreate(Sender: TObject);
    procedure TLChangeNode(Sender: TObject; OldNode,
      Node: TdxTreeListNode);
    procedure SuperFormDestroy(Sender: TObject);
    procedure TLGetSelectedIndex(Sender: TObject; Node: TdxTreeListNode;
      var Index: Integer);
    procedure pmTVPopup(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure rbTousClick(Sender: TObject);
    procedure rbOrphelinsClick(Sender: TObject);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure btnFermerClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    fFill: TState;
    fIDTypeReport: integer;
    fFormIndividu: TForm;
    fDetailFormIncrusted: integer;
    fFirstIncrust: boolean;
    fKey: integer;
    fModified: boolean;

    fRecord_Type: integer;
    fRecord_Key: integer;
    fAsso_Type: integer;
    fAsso_Key: integer;

    //permet de savoir si les querys des detail sont ouverts
    fMultimediaIsLoaded: boolean;
    fSourcesIsLoaded: boolean;
    fNotesIsLoaded: boolean;
    fDialogMode: boolean;

    procedure SetFormIndividu(const Value: TForm);
    procedure doRempliTV;
    procedure doOpenDetail(iRecord_Type, iRecord_Key, iAsso_Type, iAsso_Key: integer);
    procedure doCloseDetail(iRecord_Type: integer);

    procedure doRempliRacine;
    procedure SetDialogMode(const Value: boolean);

    function doAjouteItem(
      ItemPere: TdxTreeListNode;
      IDImage: Integer;
      sTitre: string;
      iRecord_Type,
      iRecord_Key,
      iAsso_Type,
      iAsso_Key: Integer): TdxTreeListNode;
    function doAjouteSousItem(
      ItemPere: TdxTreeListNode;
      IDImage: Integer;
      sTitre: string;
      iRecord_Type,
      iRecord_Key,
      iAsso_Type,
      iAsso_Key: Integer): TdxTreeListNode;

    function TestFicheIsModified: boolean;

  public

    // les details ------------------------------------------
    afSources: TFBiblio_Sources;

    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;
    property Modified: boolean read fModified write fModified;

    property Record_Type: Integer read fRecord_Type write fRecord_Type;
    property Record_Key: Integer read fRecord_Key write fRecord_Key;
    property Asso_Type: Integer read fAsso_Type write fAsso_Type;
    property Asso_Key: Integer read fAsso_Key write fAsso_Key;

    procedure doInitialize;
    procedure doUpdateBase(aCommit: boolean);
    procedure doCancelUpdate;

    function doOpenQuerys: boolean;
    procedure doCloseQuerys;
  end;

implementation

uses u_dm, u_form_main, u_form_individu, u_common_var, u_common_func, clipbrd,
  u_common_const;

{$R *.DFM}

const
  //Les types de documents --------------------------------
  _NOTES_RECORD = 10;
  _SOURCES_RECORD = 11;
  _MULTIMEDIA_RECORD = 12;

  // les tables -------------------------------------------
  _INDI = 1;
  _EVENT_INDI = 2;
  _UNIONS = 3;
  _EVENT_UNION = 4;

  // les icones du TV ------------------------------------
  _IMAGE_INDI_HOMME = 9;
  _IMAGE_INDI_FEMME = 8;
  _IMAGE_MULTIMEDIA = 7;
  _IMAGE_SOURCES = 3;
  _IMAGE_NOTES = 2;
  _IMAGE_UNION = 10;

procedure TFBiblio_Documents.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;
end;

procedure TFBiblio_Documents.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;

  {
  if Value = False then
    begin
      pTop.visible := False;
      Panel10.visible := False;
      pBorder.BorderWidth := 1;
      pBorder.BevelOuter := bvNone;
      Panel7.visible := false;
      bsfbSelection.visible := false;
      FlatSplitter2.visible := false;
    end
  else
    begin
      Position := poMainFormCenter;
      BorderStyle := bsNone;
      Panel13.BorderWidth := 5;
      height := 547;
    end;
    }
end;

// -- Gestion de la fenetre ----------------------------------------------------------------------------------

procedure TFBiblio_Documents.doInitialize;
begin
  //on indique que rien n'est charg
  fMultimediaIsLoaded := false;
  fSourcesIsLoaded := false;
  fNotesIsLoaded := false;
end;

procedure TFBiblio_Documents.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 536;
      ClientWidth := 645;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fDialogMode := false;
  fModified := false;
  fIDTypeReport := -1;
  fFill := TState.create(false);

  fFill.value := true;
  try

  finally
    fFill.value := false;
  end;

end;

procedure TFBiblio_Documents.SuperFormDestroy(Sender: TObject);
begin
  fFill.Free;
end;

// -- Ce qu on fait quand on a cliqu sur un element du TV ---------------------------------------------------

procedure TFBiblio_Documents.TLGetSelectedIndex(Sender: TObject;
  Node: TdxTreeListNode; var Index: Integer);
begin
  Index := Node.ImageIndex;
end;

procedure TFBiblio_Documents.TLChangeNode(Sender: TObject; OldNode,
  Node: TdxTreeListNode);
var
  k: integer;
  Item: TdxTreeListNode;
begin
  if fFill.Value = false then
    begin
      fFill.Value := true;
      try
        if TL.FocusedNode <> nil then
          begin
            Item := TL.FocusedNode;
            try
              //     doUpdateBase(False);

              k := StrToInt(item.Strings[2]);

              if (Item.Values[5] <> -1) then
                //if (k <> fIDTypeReport) and (Item.Values[5] <> -1) then
                begin
                  Pandock.Show;
                  fIDTypeReport := k;
                  doOpenDetail(Item.Values[1],
                    Item.Values[2],
                    Item.Values[3],
                    Item.Values[4]);
                end
              else
                begin
                  Pandock.Hide;
                  afSources.HideIncrust;

                  doCloseDetail(-1);
                end;

            except
            end;

          end;
      finally
        fFill.Value := false;
      end;
    end;

end;

// -- Gestion du dtail de la selection du TV ----------------------------------------------------------------

procedure TFBiblio_Documents.doCloseDetail(iRecord_Type: integer);
begin
  fMultimediaIsLoaded := false;
  FSourcesIsLoaded := false;
  FNotesIsLoaded := false;

  fDetailFormIncrusted := 0;
  fKey := -1;
  fIDTypeReport := -1;
  fFill.Value := false;
end;

procedure TFBiblio_Documents.doOpenDetail(iRecord_Type, iRecord_Key, iAsso_Type, iAsso_Key: integer);
//var Item: TdxTreeListNode;
begin
  // Item := TL.FocusedNode;
  doCloseDetail(iRecord_Type);

  if (not fFill.Value) then
    begin
      fFill.Value := true;
      try
        PanDock.Show;
        if TestFicheIsModified then doUpdateBase(False);

        //on regarde si les donnes sont charges
        case iAsso_Type of

          _SOURCES_RECORD:
            if fSourcesIsLoaded = false then
              begin
                aFSources.ShowIncrust(panDock);
                fSourcesIsLoaded := aFSources.doOpenQuerys(
                  iRecord_Key, 'I');
              end;
        end;

        if fDetailFormIncrusted <> iRecord_Key then
          begin
            //on dsincruste la form
            case fDetailFormIncrusted of
              _SOURCES_RECORD: afSources.HideIncrust;
            end;
          end;

        if (fKey <> iRecord_Key) then
          begin
            fFirstIncrust := false;
            fKey := iRecord_Key;

            //on incruste celle demande
            case iAsso_Type of
              _SOURCES_RECORD: aFSources.ShowIncrust(panDock);
            end;

            fDetailFormIncrusted := iRecord_Type;
          end;

        Application.ProcessMessages;

      finally
        fFill.Value := false;
      end;
    end;

end;

// -- Gestion des tables -------------------------------------------------------------------------------------

function TFBiblio_Documents.doOpenQuerys: boolean;

begin
  doRempliTV;

  result := true;
end;

// - Gestion des ajouts d elements dans le treeview ----------------------------------------------------------

procedure TFBiblio_Documents.doRempliTV;
begin
  Pandock.Hide;
  TL.BeginUpdate;

  try
    TL.ClearNodes;

    doRempliRacine;

    TL.FullExpand;
  finally
    TL.EndUpdate;
  end;

end;

function TFBiblio_Documents.doAjouteItem(
  ItemPere: TdxTreeListNode;
  IDImage: Integer;
  sTitre: string;
  iRecord_Type,
  iRecord_Key,
  iAsso_Type,
  iAsso_Key: Integer): TdxTreeListNode;
var Item: TdxTreeListNode;
begin
  Item := TL.Add;
  if Item <> nil then
    begin
      Item.Values[0] := sTitre;
      Item.Values[1] := iRecord_Type;
      Item.Values[2] := iRecord_Key; //TFIndividu(fFormindividu).Clefiche;
      Item.Values[3] := iAsso_Type;
      Item.Values[4] := iAsso_Key;
      Item.Values[5] := -1;
      Item.ImageIndex := IDImage;
    end;

  result := Item;
end;

function TFBiblio_Documents.doAjouteSousItem(
  ItemPere: TdxTreeListNode;
  IDImage: Integer;
  sTitre: string;
  iRecord_Type,
  iRecord_Key,
  iAsso_Type,
  iAsso_Key: Integer): TdxTreeListNode;
var Item: TdxTreeListNode;
begin

  if TL.FocusedNode <> nil then
    begin
      Item := ItemPere.AddChild;
      if Item <> nil then
        begin
          Item.ImageIndex := IDImage;
          Item.Values[0] := sTitre;
          Item.Values[1] := iRecord_Type;
          Item.Values[2] := iRecord_Key; //TFIndividu(fFormindividu).Clefiche;
          Item.Values[3] := iAsso_Type;
          Item.Values[4] := iAsso_Key;
          if iAsso_Key = -1 then
            Item.Values[5] := -1
          else
            Item.Values[5] := 1;
        end;
    end;

  result := Item;
end;
// -----------------------------------------------------------------------------------------------------------

// -- On rempli les docs de l individu -----------------------------------------------------------------------

procedure TFBiblio_Documents.doRempliRacine;
var Item, ItemSource, ItemNote, ItemMultimedia: TdxTreeListNode;
  i_IBLoad: TIBQuery;
begin

  // On ajoute l item ----------------------------------------------------------------------------------------
  ItemSource := doAjouteItem(Item,
    _IMAGE_SOURCES,
    'Sources',
    _SOURCES_RECORD,
    -1,
    _SOURCES_RECORD,
    -1);

  ItemNote := doAjouteItem(Item,
    _IMAGE_NOTES,
    'Notes',
    _NOTES_RECORD,
    -1,
    _NOTES_RECORD,
    -1);

  ItemMultimedia := doAjouteItem(Item,
    _IMAGE_MULTIMEDIA,
    'Multimedias',
    _MULTIMEDIA_RECORD,
    -1,
    _MULTIMEDIA_RECORD,
    -1);

  i_IBLoad := TIBQuery.Create(Self);

  i_IBLoad.DataBase := dm.ibd_BASE;
  i_IBLoad.SQL.Add('SELECT * FROM PROC_BIBLIO_LOAD (:MODE, :DOSSIER)');

  i_IBLoad.Close;

  if rbTous.Checked then
    i_IBLoad.Params[0].AsInteger := 0
  else
    i_IBLoad.Params[0].AsInteger := 1;

  i_IBLoad.Params[1].AsInteger := dm.NumDossier;
  i_IBLoad.Open;

  while not i_IBLoad.Eof do
    begin
      if i_IBLoad.FieldByName('TYPE_DOC').AsString = 'S' then
        doAjouteSousItem(ItemSource,
          _IMAGE_SOURCES,
          i_IBLoad.FieldByName('TITRE').AsString,
          _SOURCES_RECORD,
          i_IBLoad.FieldByName('ID').AsInteger, //iRecord_Key,
          _SOURCES_RECORD,
          i_IBLoad.FieldByName('ID').AsInteger);

      if i_IBLoad.FieldByName('TYPE_DOC').AsString = 'N' then
        doAjouteSousItem(ItemNote,
          _IMAGE_NOTES,
          i_IBLoad.FieldByName('TITRE').AsString,
          _NOTES_RECORD,
          i_IBLoad.FieldByName('ID').AsInteger, //iRecord_Key,
          _NOTES_RECORD,
          i_IBLoad.FieldByName('ID').AsInteger);

      if i_IBLoad.FieldByName('TYPE_DOC').AsString = 'M' then
        doAjouteSousItem(ItemMultimedia,
          _IMAGE_MULTIMEDIA,
          i_IBLoad.FieldByName('TITRE').AsString,
          _MULTIMEDIA_RECORD,
          i_IBLoad.FieldByName('ID').AsInteger, //iRecord_Key,
          _MULTIMEDIA_RECORD,
          i_IBLoad.FieldByName('ID').AsInteger);

      i_IBLoad.Next;
    end;

  i_IBLoad.Close;
  i_IBLoad.Free;
end;


// -----------------------------------------------------------------------------------------------------------

procedure TFBiblio_Documents.SuperFormRefreshControls(Sender: TObject);
begin
  fModified := TestFicheIsModified;

  if fModified then
    begin
      TFIndividu(fFormindividu).Modified := true;
      TFIndividu(fFormindividu).DoRefreshControls;
    end;
end;

// -- Centralisation des actions sur la base pour la bibliotheque de docs ------------------------------------

function TFBiblio_Documents.TestFicheIsModified: boolean;
// On verifie si un query a boug -----------------
begin
  result := fModified;

  if result = false then
    begin
      //test des photos et docs
      if (dm.DSSources_Record.State in [dsEdit, dsInsert]) then result := true;

    end;
end;

procedure TFBiblio_Documents.doUpdateBase(aCommit: boolean);
// On mets a jour les tables et la base ----------
begin
  {
 if (afSources.DSSources_Record.State in [dsEdit, dsInsert]) then
   begin
     afSources.IBQSources_Record.post;
     if (afSources.IBQPointeurs.State in [dsEdit, dsInsert]) then
       begin
         afSources.IBQPointeurs.post;
       end;
   end;
   }
 //On commit tout ce que l'utilisateur  modifi
  if aCommit then
    begin
      dm.IBT_BASE.CommitRetaining;
      fModified := false;
    end;

  // DoRefreshControls;

  // doRempliTV;
end;

procedure TFBiblio_Documents.doCancelUpdate;
begin

  //donc, rien est modifi
  fModified := false;
  //Rafraichissements
  // DoRefreshControls;

 // doRempliTV;
end;

// -- Gestion du popup menu-----------------------------------------------------------------------------------

procedure TFBiblio_Documents.pmTVPopup(Sender: TObject);
var Item: TdxTreeListNode;
begin
  Item := TL.FocusedNode;
  mDelete.Caption := 'Supprimer : ' + Item.Values[0];

end;
// -----------------------------------------------------------------------------------------------------------

procedure TFBiblio_Documents.rbTousClick(Sender: TObject);
begin
  doRempliTV;
end;

procedure TFBiblio_Documents.rbOrphelinsClick(Sender: TObject);
begin
  doRempliTV;
end;

procedure TFBiblio_Documents.bsfbSelectionClick(Sender: TObject);
var Item: TdxTreeListNode;
begin
  if TL.FocusedNode <> nil then
    begin
      Item := TL.FocusedNode;

      fRecord_Type := Item.Values[1];
      fRecord_Key := Item.Values[2];
      fAsso_Type := Item.Values[3];
      fAsso_Key := Item.Values[4];

      ModalResult := mrOk;

    end;

end;

procedure TFBiblio_Documents.doCloseQuerys;
begin
  //
end;

procedure TFBiblio_Documents.btnFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFBiblio_Documents.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

end.
