unit u_form_biblio_Sources;

interface

uses
  Windows, Messages, u_comp_TYLanguage, Classes, CompSuperForm, Forms, SysUtils,
  dxCntner, dxEditor, dxEdLib, dxDBELib, Controls, ExtCtrls, StdCtrls, DB,
  IBCustomDataSet, IBQuery, IBUpdateSQL, dxExEdtr, u_comp_TGoodBtn, DBCtrls,
  Buttons, TFlatPanelUnit, jpeg, TFlatTabControlUnit, dxDBTLCl, dxGrClms,
  dxGrClEx, dxTL, dxDBCtrl, dxDBGrid, MPlayer, Graphics, Dialogs,
  DynamicSkinForm;

type

  TFBiblio_Sources = class(TSuperForm)
    Language: TYLanguage;
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    panDock: TPanel;
    fpBoutons: TFlatPanel;
    btnFermer: TGoodBtn;
    btnAppliquer: TGoodBtn;
    Panel3: TPanel;
    Image1: TImage;
    DataSource1: TDataSource;
    FlatTabControl: TFlatTabControl;
    pSource: TFlatPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    Label2: TLabel;
    dxDBMemo2: TdxDBMemo;
    dxDBMemo3: TdxDBMemo;
    dxDBEdit3: TdxDBEdit;
    dxDBMemo4: TdxDBMemo;
    dxDBMemo5: TdxDBMemo;
    pMedia: TFlatPanel;
    dxDBGrid: TdxDBGrid;
    colInfos: TdxDBGridColumn;
    colDevise: TdxDBGridMemoColumn;
    colMemo: TdxDBGridMemoColumn;
    colCri: TdxDBGridMemoColumn;
    colDate: TdxDBGridColumn;
    colIdent: TdxDBGridImageColumn;
    colType: TdxDBGridPopupColumn;
    colImage: TdxDBGridGraphicColumn;
    pBouton: TFlatPanel;
    btnAjout: TGoodBtn;
    btnDel: TGoodBtn;
    MediaPlayer: TMediaPlayer;
    DSMultimedia: TDataSource;
    IBMultimedia: TIBQuery;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_INDIVIDU: TIntegerField;
    IBMultimediaMULTI_INFOS: TIBStringField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    IBMultimediaMULTI_DATE_MODIF: TDateTimeField;
    IBMultimediaMULTI_MEMO: TMemoField;
    IBMultimediablobsize: TStringField;
    IBMultimediaMULTI_DOSSIER: TIntegerField;
    IBMultimediaMULTI_STRETCH: TIntegerField;
    IBMultimediaMULTI_IDENTITE: TIntegerField;
    IBMultimediaMULTI_TYPE: TIBStringField;
    IBMultimediaMULTI_REDUITE: TBlobField;
    IBMultimediaMULTI_DEVISE: TBlobField;
    IBMultimediaMULTI_CRI: TBlobField;
    IBMultimediaMULTI_DOCRTF: TBlobField;
    IBMultimediaMULTI_IMAGE_RTF: TIntegerField;
    IBMultimediaMULTI_NUM_ACTE: TIntegerField;
    IBMultimediaMULTI_TYPE_ACTE: TIBStringField;
    IBMultimediaMULTI_SONS_VIDEOS: TBlobField;
    IBMultimediaMULTI_PATH: TIBStringField;
    IBMultimediaMULTI_NOM: TIBStringField;
    IBMultimediaMP_IDENTITE: TIntegerField;
    IBMultimediaMP_CLEF: TIntegerField;
    IBQDelPointeur: TIBQuery;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbCloseClick(Sender: TObject);
    procedure btnFermerClick(Sender: TObject);
    procedure btnAppliquerClick(Sender: TObject);
    procedure doChangeEtat(Sender: TObject);
    procedure FlatTabControlTabChanged(Sender: TObject);
    procedure btnAjoutClick(Sender: TObject);
    procedure colImageGetGraphicClass(Sender: TObject;
      Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
    procedure btnDelClick(Sender: TObject);
  private
    fID, fIdEvent: integer;
    fTable: string;
    fFinInitialisation: boolean;
    fText: string;
    fModif: Boolean;
    bFirst: Boolean;

    procedure doNewRecord(DataSet: TDataSet);

  public
    property sText: string read fText write fText;
    property Modif: boolean read fModif write fModif;
    function doAjoutSource: integer;
    function doOpenQuerys(iRecord_Key: Integer; sTable: string): boolean;

  end;

implementation

uses u_dm, u_common_var, u_common_func, u_common_const,
  u_Form_Bibliotheque_Multimedia, u_form_main;

{$R *.DFM}

procedure TFBiblio_Sources.SuperFormCreate(Sender: TObject);
begin
  pSource.Align := alClient;
  pMedia.Align := alClient;

  bFirst := True;

  if _Context.Skin then
    begin
      ClientHeight := 450;
      ClientWidth := 555;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
  //  Height := 425;
//  Width := 427;

end;

function TFBiblio_Sources.doOpenQuerys(iRecord_Key: Integer; sTable: string): boolean;
begin
  fIdEvent := iRecord_Key;
  fTable := sTable;

  dm.IBQSources_Record.Close;
  dm.IBQSources_Record.Params[0].AsInteger := iRecord_Key;
  //  and TYPE_TABLE = :sTable
  dm.IBQSources_Record.Params[1].AsString := fTable;
  dm.IBQSources_Record.Open;
  dm.IBQSources_Record.Last;
  dm.IBQSources_Record.Open;

  if dm.IBQSources_Record.RecordCount <= 0 then
    begin
      dm.IBQSources_Record.Insert;
      doNewRecord(dm.IBQSources_Record);
    end;

  IBMultimedia.DisableControls;
  try
    IBMultimedia.Close;
    IBMultimedia.Params[0].AsInteger := dm.FicheActive; {Cle de l'individu}
    IBMultimedia.Params[1].AsInteger := dm.IBQSources_RecordID.AsInteger;
    IBMultimedia.Open;
    IBMultimedia.Last;
    IBMultimedia.First;
    btnDel.Enabled := IBMultimedia.RecordCount > 0;
  finally
    IBMultimedia.EnableControls;
  end;

  fFinInitialisation := True;
  result := true;

  bFirst := False;
end;

procedure TFBiblio_Sources.doNewRecord(DataSet: TDataSet);
begin
  fID := dm.uf_GetClefUnique('SOURCES_RECORD');
  DataSet.FieldByName('ID').AsInteger := fID;
  DataSet.FieldByName('CHANGE_DATE').AsDateTime := Now;
  DataSet.FieldByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
  DataSet.FieldByName('DATA_ID').AsInteger := fIdEvent;
  DataSet.FieldByName('TYPE_TABLE').AsString := fTable;
end;

function TFBiblio_Sources.doAjoutSource: integer;
begin
  //Cration d'un record

  dm.IBQSources_Record.Insert;
  dm.IBQSources_Record.Post; // pourquoi faire un post ici ???

  Application.ProcessMessages;
  //result := fKeyNote;
end;


procedure TFBiblio_Sources.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFBiblio_Sources.sbCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TFBiblio_Sources.btnFermerClick(Sender: TObject);
begin
  dm.IBQSources_Record.CancelUpdates;
end;

procedure TFBiblio_Sources.btnAppliquerClick(Sender: TObject);
begin
  sText := dxDBMemo5.Text;
  Close;
end;

procedure TFBiblio_Sources.doChangeEtat(Sender: TObject);
begin
  btnAppliquer.Enabled := True;
end;

procedure TFBiblio_Sources.FlatTabControlTabChanged(Sender: TObject);
begin
  case FlatTabControl.ActiveTab of
    0: begin
        pSource.Show;
        pMedia.Hide;
        pBouton.Hide;
      end;

    1: begin
        pSource.Hide;
        pMedia.Show;
        pBouton.Show;
      end;
  end;
end;

procedure TFBiblio_Sources.btnAjoutClick(Sender: TObject);
var aFBibliothequeMultimedia: TFBibliothequeMultimedia;
begin

  if MediaPlayer.DeviceID <> 0 then
    begin
      MediaPlayer.Stop;
      MediaPlayer.Close;
    end;

  aFBibliothequeMultimedia := TFBibliothequeMultimedia.create(self);
  try

    aFBibliothequeMultimedia.doInit(True, dm.IBQSources_RecordID.AsInteger, 'F', 'F');
    aFBibliothequeMultimedia.ShowModal;

    if aFBibliothequeMultimedia.Clef > 0 then
      begin
        btnAppliquer.Enabled := True;

        IBMultimedia.DisableControls;
        IBMultimedia.Close;
        IBMultimedia.Open;

        btnDel.Enabled := IBMultimedia.RecordCount > 0;

        IBMultimedia.EnableControls;

        fModif := True;
      end;

  finally
    aFBibliothequeMultimedia.Free;
  end;
  Application.ProcessMessages;

  // btnAppliquerClick(Sender);
end;

procedure TFBiblio_Sources.colImageGetGraphicClass(Sender: TObject;
  Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
begin
  GraphicClass := TJPEGImage;
end;

procedure TFBiblio_Sources.btnDelClick(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la suppression de ce document ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      IBMultimedia.DisableControls;

      IBQDelPointeur.Close;
      IBQDelPointeur.params[0].AsInteger := IBMultimediaMP_CLEF.AsInteger;
      IBQDelPointeur.ExecSQL;
      IBQDelPointeur.Close;

      IBMultimedia.Close;
      IBMultimedia.Open;

      btnDel.Enabled := IBMultimedia.RecordCount > 0;

      fModif := True;

      IBMultimedia.EnableControls;
      //  btnAppliquerClick(Sender);
    end;

end;

end.
