{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_edit_ref_token_date;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, StdCtrls, ExtCtrls,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery,
  dxCntner, dxTL, dxDBCtrl, dxDBGrid, TFlatButtonUnit, Buttons,
  u_comp_TGoodBtn, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFEditRefTokenDate = class(TSuperForm)
    Query: TIBQuery;
    IBUpdateSQL: TIBUpdateSQL;
    DataSource: TDataSource;
    pBorder: TPanel;
    Panel7: TPanel;
    Panel4: TPanel;
    lbTitle: TLabel;
    Panel6: TPanel;
    btnAdd: TGoodBtn;
    btnDel: TGoodBtn;
    Panel3: TPanel;
    BlueFlatSpeedButton1: TBlueFlatSpeedButton;
    BlueFlatSpeedButton2: TBlueFlatSpeedButton;
    BlueFlatSpeedButton3: TBlueFlatSpeedButton;
    BlueFlatSpeedButton4: TBlueFlatSpeedButton;
    BlueFlatSpeedButton5: TBlueFlatSpeedButton;
    BlueFlatSpeedButton6: TBlueFlatSpeedButton;
    BlueFlatSpeedButton7: TBlueFlatSpeedButton;
    BlueFlatSpeedButton8: TBlueFlatSpeedButton;
    BlueFlatSpeedButton9: TBlueFlatSpeedButton;
    BlueFlatSpeedButton10: TBlueFlatSpeedButton;
    BlueFlatSpeedButton11: TBlueFlatSpeedButton;
    BlueFlatSpeedButton12: TBlueFlatSpeedButton;
    Label1: TLabel;
    BlueFlatSpeedButton13: TBlueFlatSpeedButton;
    BlueFlatSpeedButton14: TBlueFlatSpeedButton;
    BlueFlatSpeedButton15: TBlueFlatSpeedButton;
    BlueFlatSpeedButton16: TBlueFlatSpeedButton;
    BlueFlatSpeedButton17: TBlueFlatSpeedButton;
    BlueFlatSpeedButton18: TBlueFlatSpeedButton;
    BlueFlatSpeedButton19: TBlueFlatSpeedButton;
    BlueFlatSpeedButton20: TBlueFlatSpeedButton;
    BlueFlatSpeedButton21: TBlueFlatSpeedButton;
    BlueFlatSpeedButton22: TBlueFlatSpeedButton;
    Label2: TLabel;
    Panel5: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel1: TPanel;
    dxDBGrid1: TdxDBGrid;
    Panel8: TPanel;
    btnImport: TGoodBtn;
    btnExport: TGoodBtn;
    btnFermer: TGoodBtn;
    dxDBGrid1Column1: TdxDBGridColumn;
    QueryClearErrors: TIBQuery;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure QueryNewRecord(DataSet: TDataSet);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnExportClick(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCreate(Sender: TObject);
    procedure BlueFlatSpeedButton1Click(Sender: TObject);
  private
    fTypeToken: integer;
    procedure OpenQuery;
    procedure OnBeforeInsertRecord(DataSet: TDataSet);
    procedure TryToSave;
  public

  end;

implementation

uses u_dm, u_common_var, u_form_export_table_2_textfile,
  u_form_Import_textfile_2_table, u_common_func, u_gedcom_const,
  u_common_const, u_form_main;

{$R *.DFM}

{ TFEditRefParticules }

procedure TFEditRefTokenDate.OpenQuery;
begin
  Query.DisableControls;
  try
    Query.Close;
    Query.ParamByName('LANGUE').AsString := _Context.Langue;
    Query.ParamByName('TYPE_TOKEN').AsInteger := fTypeToken;
    Query.Open;
    Query.Last;
    Query.First;
  finally
    Query.EnableControls;
  end;

  doRefreshControls;
end;

procedure TFEditRefTokenDate.SuperFormShowFirstTime(Sender: TObject);
begin
  OpenQuery;
end;

procedure TFEditRefTokenDate.SuperFormRefreshControls(Sender: TObject);
begin
  btnImport.enabled := (Query.Active);
  btnExport.enabled := (Query.Active);
  btnAdd.enabled := (Query.Active);
  btnDel.enabled := (Query.Active) and (Query.RecordCount > 0);
end;

procedure TFEditRefTokenDate.btnAddClick(Sender: TObject);
begin
  Query.Insert;
  doRefreshControls;
  SendFocus(dxDBGrid1);
end;

procedure TFEditRefTokenDate.btnDelClick(Sender: TObject);
begin
  Query.Delete;
  doRefreshControls;
  SendFocus(dxDBGrid1);
end;

procedure TFEditRefTokenDate.QueryNewRecord(DataSet: TDataSet);
begin
  DataSet.FieldByName('ID').AsInteger := dm.uf_GetClefUnique('TOKEN_DATE');
  DataSet.FieldByName('TYPE_TOKEN').AsInteger := fTypeToken;
  DataSet.FieldByName('LANGUE').AsString := _Context.Langue;
end;

procedure TFEditRefTokenDate.SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  TryToSave;

  dm.IBTrans_Secondaire.CommitRetaining;
end;

procedure TFEditRefTokenDate.TryToSave;
begin
  try
    if (Query.Active) and (Query.State in [dsEdit, dsInsert]) then Query.Post;
  except
  end;
end;


procedure TFEditRefTokenDate.btnExportClick(Sender: TObject);
var aFExportTable2TextFile: TFExportTable2TextFile;
begin
  aFExportTable2TextFile := TFExportTable2TextFile.create(self);
  try
    aFExportTable2TextFile.TableName := 'REF_TOKEN_DATE';
    aFExportTable2TextFile.PropositionFileNameExport := 'MotsClefDate.txt';
    aFExportTable2TextFile.CondSelect := '(LANGUE=''' + _Context.Langue + ''')';
    aFExportTable2TextFile.ShowModal;
  finally
    aFExportTable2TextFile.Free;
  end;
end;

procedure TFEditRefTokenDate.btnImportClick(Sender: TObject);
var aFImportTextFile2Table: TFImportTextFile2Table;
begin
  aFImportTextFile2Table := TFImportTextFile2Table.create(self);
  try
    aFImportTextFile2Table.TableName := 'REF_TOKEN_DATE';
    aFImportTextFile2Table.UsePrimaryIndex := true;
    aFImportTextFile2Table.NamePrimaryIndex := 'ID';
    aFImportTextFile2Table.NameGeneratorPrimaryIndex := 'TOKEN_DATE';
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'TYPE_TOKEN', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'TOKEN', ptInput);
    aFImportTextFile2Table.InvisibleParamNames.Add('LANGUE');
    aFImportTextFile2Table.OnBeforeInsertRecord := OnBeforeInsertRecord;

    if aFImportTextFile2Table.ShowModal = mrOk then
      begin
        //Petit nettoyage...
        QueryClearErrors.Close;
        QueryClearErrors.ParamByName('LANGUE').AsString := _Context.Langue;
        QueryClearErrors.ParamByName('MIN_TYPE').AsInteger := _TYPE_TOKEN_JANVIER;
        QueryClearErrors.ParamByName('MAX_TYPE').AsInteger := _TYPE_TOKEN_SEPARATEUR_DATE;
        QueryClearErrors.ExecSQL;
        QueryClearErrors.Close;

        dm.IBTrans_Secondaire.CommitRetaining;

        //ouverture
        OpenQuery;
      end;
  finally
    aFImportTextFile2Table.free;
  end;
end;


procedure TFEditRefTokenDate.OnBeforeInsertRecord(DataSet: TDataSet);
begin
  TIBQuery(DataSet).ParamByName('TOKEN').AsString := '';
  TIBQuery(DataSet).ParamByName('TYPE_TOKEN').AsInteger := -1;
  TIBQuery(DataSet).ParamByName('LANGUE').AsString := _Context.Langue;
end;


procedure TFEditRefTokenDate.Label10MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFEditRefTokenDate.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFEditRefTokenDate.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_EDIT_TOKEN_DATE);
  end;
end;

procedure TFEditRefTokenDate.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 529;
      ClientWidth := 516;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  fTypeToken := _TYPE_TOKEN_JANVIER;
end;

procedure TFEditRefTokenDate.BlueFlatSpeedButton1Click(Sender: TObject);
begin
  TryToSave;
  fTypeToken := TControl(Sender).Tag;
  OpenQuery;
end;

end.
