{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_export_gedcom;

interface

uses
  Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, ExtCtrls, WizardTree, TFlatGaugeUnit,
  TFlatPanelUnit, u_comp_TBlueFlatSpeedButton, TFlatGroupBoxUnit,
  u_objet_TState, ibquery, db, IBCustomDataSet, dxCntner, dxEditor,
  dxEdLib, IBStoredProc, u_objet_TIntegerList,
  u_gedcom_type, u_gedcom_func, u_objet_TGedcomDate, ComCtrls, Buttons, dxExEdtr, URLLink,
  TFlatSpeedButtonUnit, u_comp_TGoodBtn, u_comp_TYLanguage,
  u_comp_TInfoVersion;

type
  TFExportGedcom = class(TSuperForm)
    Panel4: TPanel;
    Panel1: TPanel;
    WizardTree: TWizardTree;
    Panel2: TPanel;
    Notebook: TNotebook;
    Labelaa: TLabel;
    Label17: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label28: TLabel;
    Label30: TLabel;
    Label3: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    rbJeuCarWindows: TRadioButton;
    rbJeuCarMacintosh: TRadioButton;
    rbJeuCarMSDOS: TRadioButton;
    rbJeuCarAnsel: TRadioButton;
    Label29: TLabel;
    Label5: TLabel;
    lbEportEnCours: TLabel;
    Label32: TLabel; cbImportEvent: TCheckBox;
    cbImportNotes: TCheckBox;
    cbImportSources: TCheckBox;
    rbTout: TRadioButton;
    rbExportBranche: TRadioButton;
    panExportBranche: TPanel;
    rbOnlyAscendance: TRadioButton;
    rbOnlyDescendance: TRadioButton;
    rbOnlyAscendAndDescend: TRadioButton;
    Label2: TLabel;
    Label4: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    QIndi: TIBQuery;
    QEvent: TIBQuery;
    lbHeaderNom: TdxEdit;
    lbHeaderAddr1: TdxEdit;
    lbHeaderAddr2: TdxEdit;
    lbHeaderAddr3: TdxEdit;
    QFamSMari: TIBQuery;
    QFamSFemme: TIBQuery;
    QFam: TIBQuery;
    ProcTrouveEnfants: TIBStoredProc;
    QChild: TIBQuery;
    QEventFam: TIBQuery;
    QAssoEvent: TIBQuery;
    cbImportTemoins: TCheckBox;
    QAssoEventFam: TIBQuery;
    Animate: TAnimate;
    NbNiveaux: TdxSpinEdit;
    Label16: TLabel;
    URLLink1: TURLLink;
    Panel7: TPanel;
    IBQFindNom: TIBQuery;
    edPathFileNameGED: TdxEdit;
    panFin: TPanel;
    Label10: TLabel;
    Panel8: TPanel;
    Panel9: TPanel;
    Image1: TImage;
    Label1: TLabel;
    lbExportOk: TLabel;
    lbHeaderTel: TdxEdit;
    lbHeaderEMail: TdxEdit;
    lbHeaderSiteWeb: TdxEdit;
    Label6: TLabel;
    cbIndiquerCoord: TdxCheckEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label15: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    lbEportEnCours2: TLabel;
    Panel6: TPanel;
    Label18: TLabel;
    Panel3: TPanel;
    btnSelectIndiDepart: TGoodBtn;
    btnSelectFile: TGoodBtn;
    btnPrevious: TGoodBtn;
    btnNext: TGoodBtn;
    btnNewExport: TGoodBtn;
    Label21: TLabel;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    Button1: TButton;
    QDom: TIBQuery;
    InfoVersion: TInfoVersion;
    QMedia: TIBQuery;
    qSources: TIBQuery;
    procedure btnNextClick(Sender: TObject);
    procedure btnPreviousClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure WizardTreeChange(Sender: TObject);
    procedure WizardTreeChanging(Sender: TObject; NewItemIndex: Integer; var AllowChange: Boolean);
    procedure rbJeuCarWindowsClick(Sender: TObject);
    procedure rbJeuCarMacintoshClick(Sender: TObject);
    procedure rbJeuCarMSDOSClick(Sender: TObject);
    procedure rbJeuCarAnselClick(Sender: TObject);
    procedure btnSelectFileClick(Sender: TObject);
    procedure btnSelectIndiDepartClick(Sender: TObject);
    procedure rbExportBrancheClick(Sender: TObject);
    procedure rbToutClick(Sender: TObject);
    procedure URLLink1Click(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure btnNewExportClick(Sender: TObject);
    procedure cbIndiquerCoordChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SuperFormShow(Sender: TObject);
    procedure SuperFormHide(Sender: TObject);
  private
    fListCleFicheExported: TIntegerList;
    fListDontForgetClefFicheConjoint: TIntegerList;

    fTempLines, lines: TStringList;
    fFill: TState;
    FontColorWhite: boolean;
    fMaxNumEtapePossible: integer;

    fCleIndiDepart: integer;
    fNameIndiDepart: string;
    fSexeIndiDepart: integer;

    fJeuxCaractere: TSetCodageCaracteres;

    fListFAMC_ToExport: TIntegerList;
    fListSOUR_ToExport: TIntegerList;

    F: TextFile;

    procedure GoToPage(aNumPage: integer);

    procedure doExportHeader;
    procedure doExportIndividu(Q: TIBquery; CanExportConjoints: boolean);
    procedure doExportEvenement(Q: TIBquery);
    procedure doExportDomicileIndividu(Q: TIBquery);
    procedure doExportMediaIndividu(Q: TIBquery);
    procedure doExportSourceEventIndividu(Q: TIBquery; sTable: string);

    procedure doExportFamilles(Q: TIBquery);
    procedure doExportEvenementFamille(Q: TIBquery);

    procedure PrepareTexte(Blob: TMemoField; List: TStringList; TagName: string; LevelTag: integer);
    procedure PrepareAdresse(Blob: TMemoField; List: TStringList; TagName: string; LevelTag: integer);

    procedure doExportation;

  public

    property CleIndiDepart: integer read fCleIndiDepart write fCleIndiDepart;
    property NameIndiDepart: string read fNameIndiDepart write fNameIndiDepart;
    property SexeIndiDepart: integer read fSexeIndiDepart write fSexeIndiDepart;

    function CanSetCleFicheFromFavoris: boolean;
  end;

implementation

uses
  u_dm, u_common_var, cDateTime, u_form_individu_par_prenom, u_common_func,
  u_form_main, SysUtils, u_common_const;

{$R *.DFM}

procedure TFExportGedcom.btnNextClick(Sender: TObject);
begin
  _Agent.doAgent('RestPose', '',
    Fmain.Left,
    Fmain.Top);
    
  if NoteBook.PageIndex < NoteBook.Pages.Count - 2 then
    begin
      GoToPage(NoteBook.PageIndex + 1);
    end
  else
    begin
      //c'est le lancement de l'export

      doExportation;
    end;

  DoRefreshControls;
end;

procedure TFExportGedcom.btnPreviousClick(Sender: TObject);
begin
  if NoteBook.PageIndex > 0 then
    begin
      GoToPage(NoteBook.PageIndex - 1);
    end;

  DoRefreshControls;
end;

procedure TFExportGedcom.GoToPage(aNumPage: integer);
begin
  fFill.Value := true;
  try
    Notebook.PageIndex := aNumPage;
    WizardTree.ItemIndex := aNumPage;
  finally
    fFill.Value := false;
  end;

  FMain.RefreshMenuFavoris_Individus((aNumPage = 0) and (rbExportBranche.checked));

  DoRefreshControls;
end;


procedure TFExportGedcom.SuperFormRefreshControls(Sender: TObject);
var
  Coul: TColor;
begin
  //choix du fichier
  if Notebook.PageIndex = 0 then
    begin
      btnPrevious.visible := false;
      btnNext.visible := true;
      btnNext.Caption := 'Suivant >';
    end
  else
    //Header
    if Notebook.PageIndex = 1 then
      begin
        btnPrevious.visible := true;
        btnNext.visible := true;
        btnNext.Caption := 'Suivant >';
        //btnNext.enabled := fMaxNumEtapePossible > 1;
      end
    else
      if NoteBook.PageIndex = NoteBook.Pages.Count - 2 then
        begin
          btnPrevious.visible := true;
          btnNext.visible := true;
          btnNext.Caption := 'Exporter';
        end
      else
        if NoteBook.PageIndex = NoteBook.Pages.Count - 1 then
          begin
            btnPrevious.visible := false;
            btnNext.visible := false;
            //          btnNext.Caption := 'Exporter';
          end
        else
          begin
            btnPrevious.visible := true;
            btnNext.visible := true;
            btnNext.Caption := 'Suivant >';
          end;

  btnNext.enabled := fMaxNumEtapePossible > Notebook.PageIndex;
  if (rbExportBranche.checked) and (fCleIndiDepart = -1) then btnNext.enabled := false;

  panFin.visible := trim(edPathFileNameGED.text) <> '';

  if rbExportBranche.checked then Coul := clBlack else Coul := clGray;

  rbOnlyAscendance.Font.Color := Coul;
  rbOnlyDescendance.Font.Color := Coul;
  rbOnlyAscendAndDescend.Font.Color := Coul;
  Label16.Font.Color := Coul;
  Label21.Font.Color := Coul;
  NbNiveaux.Font.Color := Coul;
  NbNiveaux.Font.Color := Coul;
  btnSelectIndiDepart.Font.Color := Coul;

  panExportBranche.enabled := rbExportBranche.checked;
  btnSelectIndiDepart.enabled := rbExportBranche.checked;


  if cbIndiquerCoord.checked then Coul := clBlack else Coul := clGray;

  lbHeaderNom.enabled := cbIndiquerCoord.checked;
  lbHeaderAddr1.enabled := cbIndiquerCoord.checked;
  lbHeaderAddr2.enabled := cbIndiquerCoord.checked;
  lbHeaderAddr3.enabled := cbIndiquerCoord.checked;
  lbHeaderTel.enabled := cbIndiquerCoord.checked;
  lbHeaderEMail.enabled := cbIndiquerCoord.checked;
  lbHeaderSiteWeb.enabled := cbIndiquerCoord.checked;

  Label23.Font.Color := Coul;
  Label24.Font.Color := Coul;
  Label28.Font.Color := Coul;
  Label30.Font.Color := Coul;
  Label6.Font.Color := Coul;

  btnSelectIndiDepart.Caption := 'Exporter  partir de : ' + fNameIndiDepart;
end;


procedure TFExportGedcom.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fListCleFicheExported := TIntegerList.create;
  fListDontForgetClefFicheConjoint := TIntegerList.create;


  fCleIndiDepart := -1; //dm._Global.uf_GetFicheActive;
  fNameIndiDepart := '?';
  fSexeIndiDepart := -1;
  fFill := TState.create(false);
  FontColorWhite := true;
  fMaxNumEtapePossible := 4;
  fTempLines := TStringList.create;
  lines := TStringList.create;
  fJeuxCaractere := ccWindows;
  //On se place sur la premire page
  btnNewExport.visible := false;
  fListFAMC_ToExport := TIntegerList.create;
  fListSOUR_ToExport := TIntegerlist.Create;

  GoToPage(0);

  DoRefreshControls;
end;

procedure TFExportGedcom.SuperFormDestroy(Sender: TObject);
begin
  //     fListCleIndiExport.Free;
  fListCleFicheExported.Free;
  fListDontForgetClefFicheConjoint.Free;

  fFill.free;
  fTempLines.Free;
  lines.free;
  fListFAMC_ToExport.Free;
  fListSOUR_ToExport.Free;
end;

procedure TFExportGedcom.WizardTreeChange(Sender: TObject);
begin
  WizardTree.Refresh;
end;

procedure TFExportGedcom.WizardTreeChanging(Sender: TObject;
  NewItemIndex: Integer; var AllowChange: Boolean);
begin
  if fFill.value = false then
    begin
      //peut-on changer de page ?
      if NewItemIndex <= fMaxNumEtapePossible then
        begin
          if fMaxNumEtapePossible <> 1000 then GoToPage(NewItemIndex)
          else
            AllowChange := false;
        end
      else
        AllowChange := false;

      DoRefreshControls;
    end;
end;

procedure TFExportGedcom.doExportIndividu(Q: TIBquery; CanExportConjoints: boolean);
var
  s: string;
  k, n, sex, p, i: integer;
begin
  //entte de l'individu
  WriteLn(F, ConvertionToChaine('0 @I' + inttostr(Q.fieldByName('CLE_FICHE').AsInteger) + '@ INDI', fJeuxCaractere));

  //prnom, nom
  WriteLn(F, ConvertionToChaine('1 NAME ' + AssembleAllString([Q.fieldByName('PRENOM').AsString, Q.fieldByName('NOM').AsString], '/') + '/', fJeuxCaractere));

  //Prefixe
  s := Q.fieldByName('PREFIXE').AsString;
  if s <> '' then WriteLn(F, ConvertionToChaine('2 NPFX ' + s, fJeuxCaractere));

  //Surnom
  s := Q.fieldByName('SURNOM').AsString;
  if s <> '' then WriteLn(F, ConvertionToChaine('2 NICK ' + s, fJeuxCaractere));

  //suffixe
  s := Q.fieldByName('SUFFIXE').AsString;
  if s <> '' then WriteLn(F, ConvertionToChaine('2 NSFX ' + s, fJeuxCaractere));

  //sexe
  sex := Q.FieldByName('SEXE').AsInteger;
  if sex = 1 then WriteLn(F, ConvertionToChaine('1 SEX M', fJeuxCaractere))
  else
    if sex = 2 then WriteLn(F, ConvertionToChaine('1 SEX F', fJeuxCaractere));

  //Filiation
  s := Q.fieldByName('FILLIATION').AsString;
  if s <> '' then WriteLn(F, ConvertionToChaine('1 FILA ' + s, fJeuxCaractere));

  //FAMC
  k := dm.GetCleUnion(Q.FieldByName('CLE_PERE').AsInteger, Q.FieldByName('CLE_MERE').AsInteger);
  if k <> -1 then
    begin
      WriteLn(F, ConvertionToChaine('1 FAMC @F' + inttostr(k) + '@', fJeuxCaractere));
      if fListFAMC_ToExport.IndexOf(k) = -1
        then fListFAMC_ToExport.Add(k);
    end;

  if CanExportConjoints then
    begin
      if (sex = 1) then
        begin
          QFamSMari.Close;
          QFamSMari.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
          QFamSMari.ParamByName('CLE_INDI').AsInteger := Q.fieldByName('CLE_FICHE').AsInteger;
          QFamSMari.Open;
          QFamSMari.last;
          QFamSMari.first;

          for n := 1 to QFamSMari.RecordCount do
            begin
              if (rbExportBranche.checked) and (rbOnlyAscendance.checked = false) then
                begin
                  i := QFamSMari.FieldByName('UNION_FEMME').AsInteger;
                  p := fListCleFicheExported.IndexOf(i);
                  if p = -1 then
                    begin
                      p := fListDontForgetClefFicheConjoint.IndexOf(i);
                      if p = -1 then fListDontForgetClefFicheConjoint.Add(i);
                    end;
                end;

              WriteLn(F, ConvertionToChaine('1 FAMS @F' + inttostr(QFamSMari.fieldByName('UNION_CLEF').AsInteger) + '@', fJeuxCaractere));

              if fListFAMC_ToExport.IndexOf(QFamSMari.fieldByName('UNION_CLEF').AsInteger) = -1
                then fListFAMC_ToExport.Add(QFamSMari.fieldByName('UNION_CLEF').AsInteger);

              QFamSMari.next;
            end;
        end
      else
        if (sex = 2) then
          begin
            QFamSFemme.Close;
            QFamSFemme.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
            QFamSFemme.ParamByName('CLE_INDI').AsInteger := Q.fieldByName('CLE_FICHE').AsInteger;
            QFamSFemme.Open;
            QFamSFemme.last;
            QFamSFemme.first;

            for n := 1 to QFamSFemme.RecordCount do
              begin
                if (rbExportBranche.checked) and (rbOnlyAscendance.checked = false) then
                  begin
                    //PCM ici caca
                    //i := QFamSMari.FieldByName('UNION_MARI').AsInteger;
                    // remplac par ca
                    i := QFamSFemme.FieldByName('UNION_MARI').AsInteger;

                    p := fListCleFicheExported.IndexOf(i);
                    if p = -1 then
                      begin
                        p := fListDontForgetClefFicheConjoint.IndexOf(i);
                        if p = -1 then fListDontForgetClefFicheConjoint.Add(i);
                      end;
                  end;

                WriteLn(F, ConvertionToChaine('1 FAMS @F' + inttostr(QFamSFemme.fieldByName('UNION_CLEF').AsInteger) + '@', fJeuxCaractere));

                if fListFAMC_ToExport.IndexOf(QFamSFemme.fieldByName('UNION_CLEF').AsInteger) = -1
                  then fListFAMC_ToExport.Add(QFamSFemme.fieldByName('UNION_CLEF').AsInteger);

                QFamSFemme.next;
              end;
          end;
    end;

  //sources
  if cbImportSources.checked then
    begin
      PrepareTexte(TMemoField(Q.fieldByName('SOURCE')), lines, 'SOUR', 1);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
        end;
    end;

  //notes
  if cbImportNotes.checked then
    begin
      PrepareTexte(TMemoField(Q.fieldByName('COMMENT')), lines, 'NOTE', 1);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
        end;
    end;
end;

procedure TFExportGedcom.doExportEvenement(Q: TIBquery);
var
  n, k: integer;
  s, s2, sType: string;
begin
  s := trim(Q.fieldbyname('EV_IND_TYPE').AsString);
  sType := s;
  if s <> '' then
    begin
      s2 := trim(Q.fieldbyname('EV_IND_DESCRIPTION').AsString);
      if s2 <> '' then s2 := ' ' + s2;

      //l'vnement
      WriteLn(F, ConvertionToChaine('1 ' + s + s2, fJeuxCaractere));

      //date de l'vnement
      s := trim(Q.fieldbyname('EV_IND_DATE_WRITEN').AsString);
      if s <> '' then
        begin
          if _GDate.DecodeHumanDate(s) then
            begin
              s := _GDate.EncodeGedcomDate;
              if s <> '' then WriteLn(F, ConvertionToChaine('2 DATE ' + s, fJeuxCaractere));
            end
          else
            begin
              WriteLn(F, ConvertionToChaine('2 DATE (' + s + ')', fJeuxCaractere));
            end;
        end;

      s := Copy(Q.fieldbyname('EV_IND_HEURE').AsString, 1, 5);
      if s <> '' then WriteLn(F, ConvertionToChaine('2 TIME ' + s, fJeuxCaractere));

      //lieux
      s :=
        trim(Q.fieldByName('EV_IND_VILLE').AsString) + ',' +
        trim(Q.fieldByName('EV_IND_CP').AsString) + ',' +
        trim(Q.fieldByName('EV_IND_DEPT').AsString) + ',' +
        trim(Q.fieldByName('EV_IND_REGION').AsString) + ',' +
        trim(Q.fieldByName('EV_IND_PAYS').AsString) + ',' +
        trim(Q.fieldByName('EV_IND_SUBD').AsString);

      if s <> ',,,,,' then WriteLn(F, ConvertionToChaine('2 PLAC ' + s, fJeuxCaractere));

      //Lieu dit
      s := trim(Q.FieldByName('EV_IND_ADRESSE').AsString);
      if s <> '' then WriteLn(F, ConvertionToChaine('2 LIEU ' + s, fJeuxCaractere));

      s := trim(Q.FieldByName('EV_IND_INSEE').AsString);
      if s <> '' then WriteLn(F, ConvertionToChaine('2 XINSEE ' + s, fJeuxCaractere));

      s := trim(Q.FieldByName('EV_IND_ORDRE').AsString);
      if sType = 'BIRT' then
        WriteLn(F, ConvertionToChaine('2 XORD ' + '0', fJeuxCaractere))
      else
        if s <> '' then
          WriteLn(F, ConvertionToChaine('2 XORD ' + s, fJeuxCaractere))
        else
          WriteLn(F, ConvertionToChaine('2 XORD ' + '1', fJeuxCaractere));

      //Sources     // PCM
      if cbImportSources.checked then
        begin
          WriteLn(F, ConvertionToChaine('2 SOUR @S' + inttostr(Q.fieldByName('EV_IND_CLEF').AsInteger) + 'I@', fJeuxCaractere));
          {
          PrepareTexte(TMemoField(Q.fieldByName('EV_IND_SOURCE')), lines, 'SOUR', 2);
          if lines.count > 0 then
            begin
              for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
            end;
           }
        end;

      //notes
      if cbImportNotes.checked then
        begin
          PrepareTexte(TMemoField(Q.fieldByName('EV_IND_COMMENT')), lines, 'NOTE', 2);
          if lines.count > 0 then
            begin
              for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
            end;
        end;

      s := trim(Q.FieldByName('EV_IND_ACTE').AsString);
      if s = '1' then WriteLn(F, ConvertionToChaine('2 XACTE ' + s, fJeuxCaractere));

      if cbImportTemoins.checked then
        begin
          //les associations de cet vnement
          QAssoEvent.Close;
          try
            QAssoEvent.ParamByName('CLE_EVENT').AsInteger := Q.FieldByName('EV_IND_CLEF').AsInteger;
            QAssoEvent.ParamByName('ASSOC_KLE_DOSSIER').AsInteger := dm.NumDossier;
            QAssoEvent.Open;
            QAssoEvent.last;
            QAssoEvent.first;
            for n := 0 to QAssoEvent.RecordCount - 1 do
              begin
                //ASSO
                WriteLn(F, ConvertionToChaine('2 ASSO @I' + QAssoEvent.FieldByName('ASSOC_KLE_ASSOCIE').AsString + '@', fJeuxCaractere));

                //Type
                WriteLn(F, ConvertionToChaine('3 TYPE INDI', fJeuxCaractere));

                //Type de relation
                WriteLn(F, ConvertionToChaine('3 RELA ' + QAssoEvent.FieldByName('REF_RELA_TAG').AsString, fJeuxCaractere));

                //Notes
                if cbImportNotes.checked then
                  begin
                    PrepareTexte(TMemoField(QAssoEvent.fieldByName('ASSOC_NOTES')), lines, 'NOTE', 3);
                    if lines.count > 0 then
                      begin
                        for k := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[k], fJeuxCaractere));
                      end;
                  end;

                //Sources
                if cbImportSources.checked then
                  begin
                    PrepareTexte(TMemoField(QAssoEvent.fieldByName('ASSOC_SOURCES')), lines, 'SOUR', 3);
                    if lines.count > 0 then
                      begin
                        for k := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[k], fJeuxCaractere));
                      end;
                  end;

                QAssoEvent.next;
              end;
          finally
            QAssoEvent.Close;
          end;
        end;
    end;
end;

procedure TFExportGedcom.doExportation;
var
  n, k: integer;
  //     NumRec, TotRec: integer;
  StartTime, Duree: TDateTime;
begin
  DeleteFile(SaveDialog.FileName);
  system.AssignFile(F, SaveDialog.FileName);
  system.Rewrite(F);
  try
    //On change de page
    GoToPage(5);
    DoRefreshControls;
    Application.ProcessMessages;

    screen.cursor := crHourGlass;
    Animate.CommonAVI := aviCopyFiles;
    Animate.Visible := true;
    Animate.Active := true;
    try

      //dbut de l'heure
      fListFAMC_ToExport.Clear;

      StartTime := Now;
      //cration du fichier

           //l'entte
      doExportHeader;

      //les individus
      QIndi.Close;
      try
        QIndi.SQL.Clear;
        if rbTout.checked then
          begin
            QIndi.SQL.Add('select * from individu where KLE_DOSSIER=:KLE_DOSSIER');
            QIndi.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
          end
        else
          begin
            if rbOnlyAscendance.checked then
              begin
                QIndi.SQL.Add('select * from PROC_ARBRE_EXPORT (:I_CLEF,:I_NIVEAU,:I_DOSSIER,:I_PARQUI)');

                QIndi.ParamByName('I_CLEF').AsInteger := fCleIndiDepart;
                QIndi.ParamByName('I_NIVEAU').AsInteger := Trunc(NbNiveaux.Value); ;
                QIndi.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
                QIndi.ParamByName('I_PARQUI').AsInteger := 0;
              end
            else
              if rbOnlyDescendance.checked then
                begin
                  QIndi.SQL.Add('select * from PROC_DESCENDANCE (:I_CLEF,:I_NIVEAU,:I_DOSSIER)');

                  QIndi.ParamByName('I_CLEF').AsInteger := fCleIndiDepart;
                  QIndi.ParamByName('I_NIVEAU').AsInteger := Trunc(NbNiveaux.Value);
                  QIndi.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
                end
              else
                begin
                  QIndi.SQL.Add('select * from PROC_ASCEND_DESCEND (:I_CLEF,:I_NIVEAU,:I_DOSSIER,:I_PARQUI)');

                  QIndi.ParamByName('I_CLEF').AsInteger := fCleIndiDepart;
                  QIndi.ParamByName('I_NIVEAU').AsInteger := Trunc(NbNiveaux.Value);
                  QIndi.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
                  QIndi.ParamByName('I_PARQUI').AsInteger := 0;
                end;
          end;

        QIndi.Open;
        QIndi.last;
        QIndi.first;
        fListCleFicheExported.Clear;
        fListDontForgetClefFicheConjoint.Clear;

        //Si on export la descendance, il faut aussi ajouter les conjoints
        if (rbExportBranche.checked) and (rbOnlyAscendance.checked = false) then
          begin
            while (not QIndi.EOF) do
              begin
                fListCleFicheExported.Add(QIndi.FieldByName('CLE_FICHE').AsInteger);
                QIndi.Next;
              end;

            QIndi.first;
          end;


        for n := 0 to QIndi.RecordCount - 1 do
          begin
            doExportIndividu(QIndi, true);

            if cbImportEvent.checked then
              begin
                QEvent.Close;
                QEvent.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
                QEvent.ParamByName('KLE_FICHE').AsInteger := QIndi.FieldByName('CLE_FICHE').AsInteger;
                QEvent.Open;
                QEvent.Last;
                QEvent.First;
                if QEvent.RecordCount > 0 then
                  begin
                    for k := 1 to QEvent.RecordCount do
                      begin
                        doExportEvenement(QEvent);
                        QEvent.Next;
                      end;
                  end;
              end;

            //ses domiciles
            QDom.Close;
            QDom.ParamByName('CLE_FICHE').AsInteger := QIndi.FieldByName('CLE_FICHE').AsInteger;
            QDom.Open;
            QDom.First;
            while (not QDom.EOF) do
              begin
                doExportDomicileIndividu(QDom);
                QDom.Next;
              end;

            //ses Images
            QMedia.Close;
            QMedia.ParamByName('CLE').AsInteger := QIndi.FieldByName('CLE_FICHE').AsInteger;
            QMedia.Open;
            QMedia.First;
            while (not QMedia.EOF) do
              begin
                doExportMediaIndividu(QMedia);
                QMedia.Next;
              end;


            QIndi.next;
          end;
      finally
        QIndi.Close;
      end;

      if (rbExportBranche.checked) and (rbOnlyAscendance.checked = false) then
        begin
          //On exporte les individus des unions non remontes
          if fListDontForgetClefFicheConjoint.Count > 0 then
            begin
              try
                QIndi.Close;
                QIndi.SQL.Clear;
                QIndi.SQL.Add('select * from individu where CLE_FICHE=:CLE_FICHE');


                for n := 0 to fListDontForgetClefFicheConjoint.Count - 1 do
                  begin
                    QIndi.Close;
                    QIndi.ParamByName('CLE_FICHE').AsInteger := fListDontForgetClefFicheConjoint[n];
                    QIndi.Open;
                    QIndi.Last;
                    QIndi.First;
                    if QIndi.RecordCount = 1 then
                      begin
                        doExportIndividu(QIndi, false);

                        if cbImportEvent.checked then
                          begin
                            QEvent.Close;
                            QEvent.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
                            QEvent.ParamByName('KLE_FICHE').AsInteger := QIndi.FieldByName('CLE_FICHE').AsInteger;
                            QEvent.Open;
                            QEvent.Last;
                            QEvent.First;
                            if QEvent.RecordCount > 0 then
                              begin
                                for k := 1 to QEvent.RecordCount do
                                  begin
                                    doExportEvenement(QEvent);
                                    QEvent.Next;
                                  end;
                              end;
                          end;

                        //ses domiciles
                        QDom.Close;
                        QDom.ParamByName('CLE_FICHE').AsInteger := QIndi.FieldByName('CLE_FICHE').AsInteger;
                        QDom.Open;
                        QDom.First;
                        while (not QDom.EOF) do
                          begin
                            doExportDomicileIndividu(QDom);
                            QDom.Next;
                          end;
                      end;
                  end;


              finally
                QIndi.Close;
              end;
            end;
        end;

      QFam.Close;
      try
        //on reconstitue la requete, selon le sexe
        QFam.Sql.Clear;
        QFam.Sql.Add('select UNION_CLEF,UNION_MARI,UNION_FEMME,UNION_TYPE,SOURCE,COMMENT from T_UNION where (KLE_DOSSIER=:KLE_DOSSIER) and (UNION_CLEF=:UNION_CLEF)');
        QFam.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;

        for n := 0 to fListFAMC_ToExport.Count - 1 do
          begin
            QFam.Close;
            QFam.ParamByName('UNION_CLEF').AsInteger := fListFAMC_ToExport[n];
            QFam.Open;
            QFam.last;
            QFam.first;

            if QFam.RecordCount = 1 then
              begin
                doExportFamilles(QFam);

                QEventFam.Close;
                QEventFam.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
                QEventFam.ParamByName('EV_FAM_KLE_FAMILLE').AsInteger := QFam.FieldByName('UNION_CLEF').AsInteger;
                QEventFam.Open;
                QEventFam.Last;
                QEventFam.First;

                if QEventFam.RecordCount > 0 then
                  begin
                    for k := 1 to QEventFam.RecordCount do
                      begin
                        doExportEvenementFamille(QEventFam);
                        QEventFam.Next;
                      end;
                  end;

              end;
          end;
      finally
        QFam.Close;
      end;

      //Sources    PCM-----------------------------------------------------------------------------------
      if cbImportSources.checked then
        begin
          try
            qSources.Close;
            qSources.Params[0].AsInteger := dm.NumDossier;
            qSources.Params[1].AsString := 'I';
            qSources.Open;
            qSources.Last;
            qSources.First;

            if qSources.RecordCount > 0 then
              begin
                for k := 1 to qSources.RecordCount do
                  begin
                    doExportSourceEventIndividu(qSources, qSources.fieldbyname('TYPE_TABLE').AsString);
                    qSources.Next;
                  end;
              end;
          finally
            qSources.Close;
          end;

          try
            qSources.Close;
            qSources.Params[0].AsInteger := dm.NumDossier;
            qSources.Params[1].AsString := 'F';
            qSources.Open;
            qSources.Last;
            qSources.First;

            if qSources.RecordCount > 0 then
              begin
                for k := 1 to qSources.RecordCount do
                  begin
                    doExportSourceEventIndividu(qSources, qSources.fieldbyname('TYPE_TABLE').AsString);
                    qSources.Next;
                  end;
              end;
          finally
            qSources.Close;
          end;
        end;

      //la fin
      WriteLn(F, ConvertionToChaine('0 TRLR', fJeuxCaractere));
      Duree := Now - StartTime;

      //          FlatGauge.Progress := 100;
      fListFAMC_ToExport.Clear;
    finally
      Animate.Active := false;
      Animate.Visible := false;
      screen.cursor := crDefault;
    end;

    lbEportEnCours.visible := false;
    lbEportEnCours2.visible := false;
    lbExportOk.visible := true;
    btnNewExport.visible := true;

  finally
    CloseFile(F);
  end;

  //on indique que tout s'est pass
        _Agent.doAgent('Congratulate', 'C''est termin',
        Fmain.Left + 260,
        Fmain.Top + 340);
  MyMessageDlg('L''exportation a t effectue avec succs, en ' + inttostr(Hour(Duree)) + 'h, ' + inttostr(Minute(Duree)) + 'min, ' + inttostr(Second(Duree)) + 'sec.', mtInformation, [mbOK], 0);
end;

procedure TFExportGedcom.PrepareTexte(Blob: TMemoField; List: TStringList; TagName: string; LevelTag: integer);
var
  s, s2: string;
  n, k, p: integer;
begin
  List.Clear;
  try
    if Blob.IsNull = false then
      begin
        fTempLines.Text := Blob.AsString;
        for n := 0 to fTempLines.Count - 1 do
          begin
            //la chaine
            s := fTempLines[n];

            //
            p := 1;
            repeat
              k := length(s);
              if k > 248 then
                begin
                  s2 := copy(s, 1, 248);
                  if list.count = 0 then List.Add(TagName + ' ' + s2)
                  else
                    begin
                      if p = 1 then List.Add('CONT ' + s2) else List.Add('CONC ' + s2);
                    end;
                  delete(s, 1, 248);
                end
              else
                begin
                  if list.count = 0 then List.Add(TagName + ' ' + s)
                  else
                    begin
                      if p = 1 then List.Add('CONT ' + s) else List.Add('CONC ' + s);
                    end;
                  s := '';
                end;
              inc(p);

            until s = '';
          end;

        //on numrote les lignes
        for n := 0 to List.count - 1 do
          begin
            if n = 0 then List[0] := inttostr(LevelTag) + ' ' + List[0]
            else
              List[n] := inttostr(LevelTag + 1) + ' ' + List[n];
          end;
      end;
  except
  end;
end;

procedure TFExportGedcom.doExportFamilles(Q: TIBquery);
var
  n: integer;
begin
  //numro de la famille
  WriteLn(F, ConvertionToChaine('0 @F' + inttostr(Q.fieldByName('UNION_CLEF').AsInteger) + '@ FAM', fJeuxCaractere));

  //Le type d'union
  if Q.fieldByName('UNION_TYPE').AsInteger <> 0 then
    begin
      WriteLn(F, ConvertionToChaine('1 TYPU ' + inttostr(Q.fieldByName('UNION_TYPE').AsInteger), fJeuxCaractere));
    end;

  //le mari
  if Q.fieldByName('UNION_MARI').IsNull = false then
    begin
      WriteLn(F, ConvertionToChaine('1 HUSB @I' + inttostr(Q.fieldByName('UNION_MARI').AsInteger) + '@', fJeuxCaractere));
    end;

  //la femme
  if Q.fieldByName('UNION_FEMME').IsNull = false then
    begin
      WriteLn(F, ConvertionToChaine('1 WIFE @I' + inttostr(Q.fieldByName('UNION_FEMME').AsInteger) + '@', fJeuxCaractere));
    end;

  //les enfants
  QChild.Close;
  try
    QChild.Params[0].Assign(Q.fieldByName('UNION_MARI'));
    QChild.Params[1].Assign(Q.fieldByName('UNION_FEMME'));
    QChild.Params[2].AsInteger := dm.NumDossier;
    QChild.Open;

    QChild.last;
    QChild.first;

    for n := 0 to QChild.RecordCount - 1 do
      begin
        WriteLn(F, ConvertionToChaine('1 CHIL @I' + inttostr(QChild.fieldByName('CLE_FICHE').AsInteger) + '@', fJeuxCaractere));
        QChild.next;
      end;
  finally
    QChild.Close;
  end;

  //sources
  if cbImportSources.checked then
    begin
      PrepareTexte(TMemoField(Q.fieldByName('SOURCE')), lines, 'SOUR', 1);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
        end;
    end;

  //notes
  if cbImportNotes.checked then
    begin
      PrepareTexte(TMemoField(Q.fieldByName('COMMENT')), lines, 'NOTE', 1);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
        end;
    end;
end;


procedure TFExportGedcom.doExportHeader;
var
  aGedDate: TGedcomDate;
  s: string;
begin
  WriteLn(F, ConvertionToChaine('0 HEAD', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('1 SOUR Ancestrologie', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('2 VERS Version ' + InfoVersion.Version, fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('2 NAME Ancestrologie 2001', fJeuxCaractere));

  WriteLn(F, ConvertionToChaine('2 CORP P.C.M. Universal', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('3 ADDR www.ancestrologie.com', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('3 PHON ', fJeuxCaractere));
  aGedDate := TGedcomDate.create;
  try
    s := inttostr(Day(now)) + ' ' + aGedDate.MonthNum2MonthGedcom(Month(now)) + ' ' + inttostr(Year(now));
    WriteLn(F, ConvertionToChaine('1 DATE ' + s, fJeuxCaractere));
  finally
    aGedDate.Free;
  end;

  WriteLn(F, ConvertionToChaine('1 DATE ', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('2 TIME ' + FormatDateTime('hh:nn:ss', now), fJeuxCaractere));

  WriteLn(F, ConvertionToChaine('1 GEDC', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('2 VERS 5.5', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('2 FORM LINEAGE-LINKED', fJeuxCaractere));

  case fJeuxCaractere of
    ccWindows: WriteLn(F, ConvertionToChaine('1 CHAR ANSI', fJeuxCaractere));
    ccMacintosh: WriteLn(F, ConvertionToChaine('1 CHAR MACINTOSH', fJeuxCaractere));
    ccDOS: WriteLn(F, ConvertionToChaine('1 CHAR IBMPC', fJeuxCaractere));
    ccANSEL: WriteLn(F, ConvertionToChaine('1 CHAR ANSEL', fJeuxCaractere));
  end;

  WriteLn(F, ConvertionToChaine('1 LANG FRENCH', fJeuxCaractere));

  WriteLn(F, ConvertionToChaine('1 PLAC', fJeuxCaractere));
  WriteLn(F, ConvertionToChaine('2 FORM Ville , Code Lieu , Dpartement , Rgion , Pays, Subdivision', fJeuxCaractere));

  if cbIndiquerCoord.checked then
    begin
      WriteLn(F, ConvertionToChaine('1 SUBM @S0@', fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('0 @S0@ SUBM', fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('1 NAME ' + trim(lbHeaderNom.Text), fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('1 ADDR ' + trim(lbHeaderAddr1.Text), fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('2 CONT ' + trim(lbHeaderAddr2.Text), fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('2 CONT ' + trim(lbHeaderAddr3.Text), fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('1 PHON ' + trim(lbHeaderTel.Text), fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('1 _EMAIL ' + trim(lbHeaderEMail.Text), fJeuxCaractere));
      WriteLn(F, ConvertionToChaine('1 _URL ' + trim(lbHeaderSiteWeb.Text), fJeuxCaractere));
    end;
end;

procedure TFExportGedcom.rbJeuCarWindowsClick(Sender: TObject);
begin
  fJeuxCaractere := ccWindows;
end;

procedure TFExportGedcom.rbJeuCarMacintoshClick(Sender: TObject);
begin
  fJeuxCaractere := ccMacintosh;
end;

procedure TFExportGedcom.rbJeuCarMSDOSClick(Sender: TObject);
begin
  fJeuxCaractere := ccDOS;
end;

procedure TFExportGedcom.rbJeuCarAnselClick(Sender: TObject);
begin
  fJeuxCaractere := ccANSEL;
end;

procedure TFExportGedcom.btnSelectFileClick(Sender: TObject);
var
  ok: boolean;
begin
  SaveDialog.InitialDir := _Context.PathImportExport;

  if SaveDialog.execute then
    begin
      if FileExists(SaveDialog.FileName) then
        begin
          Ok := MyMessageDlg('Le fichier slectionn existe dj.'#13#10#13#10'Souhaitez-vous l''craser ?', mtWarning, [mbYes, mbNo], 0) = mrYes;
        end
      else
        ok := true;


      if ok then
        begin
          //DeleteFile( SaveDialog.FileName);
              //on montre le nom du fichier  importer
          edPathFileNameGED.Text := SaveDialog.FileName;

          fMaxNumEtapePossible := 1000;
        end;
    end;

  DoRefreshControls;
end;

procedure TFExportGedcom.doExportEvenementFamille(Q: TIBquery);
var
  n, k: integer;
  s: string;
begin
  s := trim(Q.fieldbyname('EV_FAM_TYPE').AsString);
  if s <> '' then
    begin
      // pcm

   //l'vnement
      WriteLn(F, ConvertionToChaine('1 ' + s, fJeuxCaractere));

      //date de l'vnement
      s := trim(Q.fieldbyname('EV_FAM_DATE_WRITEN').AsString);
      if s <> '' then
        begin
          if _GDate.DecodeHumanDate(s) then
            begin
              s := _GDate.EncodeGedcomDate;
              if s <> '' then WriteLn(F, ConvertionToChaine('2 DATE ' + s, fJeuxCaractere));
            end
          else
            begin
              WriteLn(F, ConvertionToChaine('2 DATE (' + s + ')', fJeuxCaractere));
            end;
        end;

      //lieux
      s :=
        trim(Q.fieldByName('EV_FAM_VILLE').AsString) + ',' +
        trim(Q.fieldByName('EV_FAM_CP').AsString) + ',' +
        trim(Q.fieldByName('EV_FAM_DEPT').AsString) + ',' +
        trim(Q.fieldByName('EV_FAM_REGION').AsString) + ',' +
        trim(Q.fieldByName('EV_FAM_PAYS').AsString) + ',' +
        trim(Q.fieldByName('EV_FAM_SUBD').AsString);

      if s <> ',,,,,' then WriteLn(F, ConvertionToChaine('2 PLAC ' + s, fJeuxCaractere));

      //Lieu dit
      s := trim(Q.FieldByName('EV_FAM_ADRESSE').AsString);
      if s <> '' then WriteLn(F, ConvertionToChaine('2 LIEU ' + s, fJeuxCaractere));

      //Sources
      if cbImportSources.checked then
        begin
          WriteLn(F, ConvertionToChaine('2 SOUR @S' + inttostr(Q.fieldByName('EV_FAM_CLEF').AsInteger) + 'F@', fJeuxCaractere));
          {
          PrepareTexte(TMemoField(Q.fieldByName('EV_FAM_SOURCE')), lines, 'SOUR', 2);
          if lines.count > 0 then
            begin
              for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
            end;
          }
        end;


      //notes
      if cbImportNotes.checked then
        begin
          PrepareTexte(TMemoField(Q.fieldByName('EV_FAM_COMMENT')), lines, 'NOTE', 2);
          if lines.count > 0 then
            begin
              for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
            end;
        end;

      if cbImportTemoins.checked then
        begin
          //les associations de cet vnement
          QAssoEventFam.Close;
          try
            QAssoEventFam.ParamByName('CLE_EVENT').AsInteger := Q.FieldByName('EV_FAM_CLEF').AsInteger;
            QAssoEventFam.ParamByName('ASSOC_KLE_DOSSIER').AsInteger := dm.NumDossier;
            QAssoEventFam.Open;
            QAssoEventFam.last;
            QAssoEventFam.first;
            for n := 0 to QAssoEventFam.RecordCount - 1 do
              begin
                //ASSO
                WriteLn(F, ConvertionToChaine('2 ASSO @I' + QAssoEventFam.FieldByName('ASSOC_KLE_ASSOCIE').AsString + '@', fJeuxCaractere));

                //Type
                WriteLn(F, ConvertionToChaine('3 TYPE FAM', fJeuxCaractere));

                //Type de relation
                WriteLn(F, ConvertionToChaine('3 RELA ' + QAssoEventFam.FieldByName('REF_RELA_TAG').AsString, fJeuxCaractere));

                //Notes
                if cbImportNotes.checked then
                  begin
                    PrepareTexte(TMemoField(QAssoEventFam.fieldByName('ASSOC_NOTES')), lines, 'NOTE', 3);
                    if lines.count > 0 then
                      begin
                        for k := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[k], fJeuxCaractere));
                      end;
                  end;

                //Sources
                if cbImportSources.checked then
                  begin
                    PrepareTexte(TMemoField(QAssoEventFam.fieldByName('ASSOC_SOURCES')), lines, 'SOUR', 3);
                    if lines.count > 0 then
                      begin
                        for k := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[k], fJeuxCaractere));
                      end;
                  end;

                QAssoEventFam.Next;
              end;
          finally
            QAssoEventFam.Close;
          end;
        end;
    end;
end;

procedure TFExportGedcom.btnSelectIndiDepartClick(Sender: TObject);
var
  aFIndividuPrenom: TFIndividuPrenom;
begin
  aFIndividuPrenom := TFIndividuPrenom.create(self);
  try
    aFIndividuPrenom.Position := poMainFormCenter;
    aFIndividuPrenom.up_InitIndividuPrenom('A', '', 0, 2);
    if aFIndividuPrenom.ShowModal = mrOk then
      begin
        fCleIndiDepart := aFIndividuPrenom.ClefIndividuSelected;
        fNameIndiDepart := aFIndividuPrenom.NomPrenomIndividuSelected;
        fSexeIndiDepart := aFIndividuPrenom.SexeIndividuSelected;
      end;

  finally
    aFIndividuPrenom.Free;
  end;

  DoRefreshControls;
end;

procedure TFExportGedcom.rbExportBrancheClick(Sender: TObject);
begin
  DoRefreshControls;
  FMain.RefreshMenuFavoris_Individus((Notebook.PageIndex = 0) and (rbExportBranche.checked));
end;

procedure TFExportGedcom.rbToutClick(Sender: TObject);
begin
  DoRefreshControls;
  FMain.RefreshMenuFavoris_Individus((Notebook.PageIndex = 0) and (rbExportBranche.checked));
end;

procedure TFExportGedcom.URLLink1Click(Sender: TObject);
begin
  GotoThisURL('www.gedx.com');
end;

procedure TFExportGedcom.SuperFormShowFirstTime(Sender: TObject);
begin
  //on recherche le nom de la presonne ouverte dans la fiche dtail
  if dm.FicheActive <> -1 then
    begin
      try
        try
          IBQFindNom.Close;
          IBQFindNom.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
          IBQFindNom.ParamByName('CLE_FICHE').AsInteger := dm.FicheActive;
          IBQFindNom.Open;
          IBQFindNom.Last;
          IBQFindNom.First;
          if IBQFindNom.RecordCount = 1 then
            begin
              fNameIndiDepart := AssembleString([IBQFindNom.FieldByName('NOM').AsString, IBQFindNom.FieldByName('PRENOM').AsString]);
              fCleIndiDepart := dm.FicheActive;
              fSexeIndiDepart := IBQFindNom.FieldByName('SEXE').AsInteger;
            end;
        finally
          IBQFindNom.Close;
        end;
      except
      end;
    end;

  DoRefreshControls;
end;

procedure TFExportGedcom.btnNewExportClick(Sender: TObject);
begin
  fMaxNumEtapePossible := 4;
  btnNewExport.visible := false;
  lbEportEnCours.visible := true;
  lbEportEnCours2.visible := true;
  lbExportOk.visible := false;
  edPathFileNameGED.Text := '';

  GoToPage(0);
end;

procedure TFExportGedcom.cbIndiquerCoordChange(Sender: TObject);
begin
  DoRefreshControls;
end;

function TFExportGedcom.CanSetCleFicheFromFavoris: boolean;
begin
  result := false;
  if Notebook.PageIndex = 0 then
    begin
      if rbExportBranche.checked then
        begin
          result := true;
        end;
    end;
end;

procedure TFExportGedcom.Button1Click(Sender: TObject);
var
  F2: TextFile;
begin
  AssignFile(F2, 'd:\abcd efgh ijkl.txt');
  Rewrite(F2);
  WriteLn(F2, 'hhhhhh');
  CloseFile(F2);
end;

// Export des adresses de l indiividu ------------------------------------------------------------------

procedure TFExportGedcom.doExportDomicileIndividu(Q: TIBquery);
var
  n: integer;
  s, sNom: string;
begin
  sNom := QIndi.FieldByName('NOM').AsString;
  if Length(QIndi.FieldByName('PRENOM').AsString) > 0 then
    sNom := sNom + ', ' + QIndi.FieldByName('PRENOM').AsString;

  //Tag Domicile
  //  WriteLn(F, ConvertionToChaine('1 DOMI', fJeuxCaractere));

  //Adresse
  WriteLn(F, ConvertionToChaine('1 ADDR', fJeuxCaractere));

  PrepareAdresse(TMemoField(Q.fieldByName('ADR_ADRESSE')), lines, '2 ADR', 2);
  if lines.count > 0 then
    {
    begin
      for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
    end;
    }
    begin
      // WriteLn(F, ConvertionToChaine('2 ADR1 ' + Lines[0], fJeuxCaractere));
      // WriteLn(F, ConvertionToChaine('2 ADR2 ' + Lines[1], fJeuxCaractere));
      for n := 0 to lines.count - 1 do
        WriteLn(F, ConvertionToChaine('2 ADR' + IntToStr(n + 1) + ' ' + Lines[n], fJeuxCaractere));
    end;


  //CP
  s := trim(Q.fieldbyname('ADR_CP').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 POST ' + s, fJeuxCaractere));

  //VILLE
  s := trim(Q.fieldbyname('ADR_VILLE').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 CITY ' + s, fJeuxCaractere));

  //DEPT
  s := trim(Q.fieldbyname('ADR_DEPT').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 STAT ' + s, fJeuxCaractere));

  //REGION
  s := trim(Q.fieldbyname('ADR_REGION').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 REG ' + s, fJeuxCaractere));

  //PAYS
  s := trim(Q.fieldbyname('ADR_PAYS').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 CTRY ' + s, fJeuxCaractere));

  //EMAIL
  s := trim(Q.fieldbyname('ADR_MAIL').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 MAIL ' + s, fJeuxCaractere));

  //DATE
  s := trim(Q.fieldbyname('ADR_DATE_WRITEN').AsString);
  if s <> '' then
    begin
      if _GDate.DecodeHumanDate(s) then
        begin
          s := _GDate.EncodeGedcomDate;
          if s <> '' then WriteLn(F, ConvertionToChaine('2 DATE ' + s, fJeuxCaractere));
        end
      else
        begin
          WriteLn(F, ConvertionToChaine('2 DATE (' + s + ')', fJeuxCaractere));
        end;
    end;

  //TEL
  PrepareTexte(TMemoField(Q.fieldByName('ADR_TEL')), lines, 'TEL', 2);
  if lines.count > 0 then
    begin
      for n := 0 to lines.count - 1 do WriteLn(F, ConvertionToChaine(lines[n], fJeuxCaractere));
    end;

end;

procedure TFExportGedcom.PrepareAdresse(Blob: TMemoField; List: TStringList; TagName: string; LevelTag: integer);
var
  s, s2: string;
  n, k, p: integer;
begin
  List.Clear;
  try
    if Blob.IsNull = false then
      begin
        fTempLines.Text := Blob.AsString;
        for n := 0 to fTempLines.Count - 1 do
          begin
            //la chaine
            s := fTempLines[n];

            //
            p := 1;
            repeat
              k := length(s);
              if k > 248 then
                begin
                  s2 := copy(s, 1, 248);
                  if list.count = 0 then List.Add(s2)
                  else
                    begin
                      if p = 1 then List.Add(s2) else List.Add(s2);
                    end;
                  delete(s, 1, 248);
                end
              else
                begin
                  if list.count = 0 then List.Add(s)
                  else
                    begin
                      if p = 1 then List.Add(s) else List.Add(s);
                    end;
                  s := '';
                end;
              inc(p);

            until s = '';
          end;
      end;
  except
  end;
end;

procedure TFExportGedcom.doExportMediaIndividu(Q: TIBquery);
var
  s: string;
begin
  //Multimedia
  WriteLn(F, ConvertionToChaine('1 PICT ', fJeuxCaractere));

  //Le path
  s := trim(Q.fieldbyname('MULTI_PATH').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 PATH ' + s, fJeuxCaractere));

  s := trim(Q.fieldbyname('MULTI_TYPE').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 XTYPE ' + s, fJeuxCaractere));

  s := trim(Q.fieldbyname('MP_IDENTITE').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 XIDEN ' + s, fJeuxCaractere));

  s := trim(Q.fieldbyname('MULTI_IMAGE_RTF').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 XMODE ' + s, fJeuxCaractere));

  s := trim(Q.fieldbyname('MULTI_NUM_ACTE').AsString);
  if s <> '' then WriteLn(F, ConvertionToChaine('2 XACTE ' + s, fJeuxCaractere));
end;


procedure TFExportGedcom.doExportSourceEventIndividu(Q: TIBquery; sTable: string);
var
  s: string;
  n: integer;
begin
  //entte de la source
  if sTable = 'I' then
    WriteLn(F, ConvertionToChaine('0 @S' + inttostr(Q.fieldByName('DATA_ID').AsInteger) + 'I@ SOUR', fJeuxCaractere))
  else
    WriteLn(F, ConvertionToChaine('0 @S' + inttostr(Q.fieldByName('DATA_ID').AsInteger) + 'F@ SOUR', fJeuxCaractere));

  s := trim(Q.fieldbyname('TEXTE').AsString);
  if s <> '' then
    begin
      PrepareAdresse(TMemoField(Q.fieldByName('TEXTE')), lines, '1 TEXT', 2);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do
            if n = 0 then
              WriteLn(F, ConvertionToChaine('1 TEXT ' + Lines[n], fJeuxCaractere))
            else
              WriteLn(F, ConvertionToChaine('2 CONT ' + Lines[n], fJeuxCaractere));
        end;
    end;

  s := trim(Q.fieldbyname('ABR').AsString);
  if s <> '' then
    WriteLn(F, ConvertionToChaine('1 ABBR ' + s, fJeuxCaractere));

  s := trim(Q.fieldbyname('DATA_EVEN').AsString);
  if s <> '' then
    WriteLn(F, ConvertionToChaine('1 REPO ' + s, fJeuxCaractere));

  s := trim(Q.fieldbyname('TITL').AsString);
  if s <> '' then
    begin
      PrepareAdresse(TMemoField(Q.fieldByName('TITL')), lines, '1 TITL', 2);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do
            if n = 0 then
              WriteLn(F, ConvertionToChaine('1 TITL ' + Lines[n], fJeuxCaractere))
            else
              WriteLn(F, ConvertionToChaine('2 CONT ' + Lines[n], fJeuxCaractere));
        end;
    end;

  s := trim(Q.fieldbyname('AUTH').AsString);
  if s <> '' then
    begin
      PrepareAdresse(TMemoField(Q.fieldByName('AUTH')), lines, '1 AUTH', 2);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do
            if n = 0 then
              WriteLn(F, ConvertionToChaine('1 AUTH ' + Lines[n], fJeuxCaractere))
            else
              WriteLn(F, ConvertionToChaine('2 CONT ' + Lines[n], fJeuxCaractere));
        end;
    end;

  s := trim(Q.fieldbyname('PUBL').AsString);
  if s <> '' then
    begin
      PrepareAdresse(TMemoField(Q.fieldByName('PUBL')), lines, '1 PUBL', 2);
      if lines.count > 0 then
        begin
          for n := 0 to lines.count - 1 do
            if n = 0 then
              WriteLn(F, ConvertionToChaine('1 PUBL ' + Lines[n], fJeuxCaractere))
            else
              WriteLn(F, ConvertionToChaine('2 CONT ' + Lines[n], fJeuxCaractere));
        end;
    end;

  WriteLn(F, ConvertionToChaine('1 EVEN ' + sTable, fJeuxCaractere))
end;

procedure TFExportGedcom.SuperFormShow(Sender: TObject);
begin
  _Agent.doAgent('GestureLeft', 'Cliquez sur le bouton',
    Fmain.Left + 560,
    Fmain.Top + 450);
end;

procedure TFExportGedcom.SuperFormHide(Sender: TObject);
begin
  _Agent.doAgent('Hide', '',
    0,
    0);

end;

end.
