{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_export_geneanet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, Buttons, dxTL, dxDBCtrl, dxDBGrid, dxCntner, Db,
  IBCustomDataSet, IBQuery, IBStoredProc, StdCtrls, URLLink,
  TFlatSpeedButtonUnit, ExtCtrls, u_comp_TGoodBtn,
  GraphicEx, u_comp_TYLanguage, dxExEdtr;

type
  TFExportGeneanet = class(TSuperForm)
    IBQPatronymes: TIBQuery;
    IBQPatronymesNOM: TIBStringField;
    DSPatronymes: TDataSource;
    QGeneanet: TIBQuery;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    URLLink2: TURLLink;
    Label1: TLabel;
    Panel4: TPanel;
    Panel5: TPanel;
    grid: TdxDBGrid;
    dxDBGridColumn1: TdxDBGridColumn;
    Panel6: TPanel;
    Label37: TLabel;
    btnExport: TGoodBtn;
    Panel7: TPanel;
    Image1: TImage;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    procedure btnExportClick(Sender: TObject);
    procedure URLLink2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure gridClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
  private

    procedure doExport;
  public
    procedure doPrepare;
  end;




implementation

uses u_dm,
  u_objet_TCut, u_common_var, u_common_func, u_common_const;

{$R *.DFM}

{ TFExportGeneanet }



procedure TFExportGeneanet.doPrepare;
begin
  IBQPatronymes.Close;
  IBQPatronymes.Params[0].AsInteger := dm.NumDossier;
  IBQPatronymes.Open;
  IBQPatronymes.last;
  IBQPatronymes.first;
  doRefreshControls;
end;



procedure TFExportGeneanet.btnExportClick(Sender: TObject);
begin
  doExport;
end;


procedure TFExportGeneanet.doExport;
var
  n, k, tot: integer;
  fContent: TStringList;
  fCut: TCut;
begin
  tot := 0;
  if (IBQPatronymes.Active) and (IBQPatronymes.RecordCount > 0) then
    begin
      fContent := TStringList.create;
      try
        fCut := TCut.create;
        try
          fCut.ParamSeparator := ';';
          fCut.SetTotalStringParams(10);


          IBQPatronymes.DisableControls;
          try
            _FOccupe.doActive;
            try

              for k := 0 to grid.SelectedCount - 1 do
                begin
                  IBQPatronymes.Bookmark := grid.SelectedRows[k];

                  QGeneanet.Close;
                  QGeneanet.ParamByName('S_PATRONYME').AsString := IBQPatronymes.FieldByName('NOM').AsString;
                  QGeneanet.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
                  QGeneanet.ParamByName('S_TYPE').AsString := 'BIRT';
                  QGeneanet.Open;
                  QGeneanet.last;
                  QGeneanet.first;

                  if QGeneanet.RecordCount > 0 then
                    begin


                      for n := 1 to QGeneanet.RecordCount do
                        begin
                          fCut.Params[0].AsString := QGeneanet.FieldByName('NOM').AsString;
                          fCut.Params[1].AsString := '';
                          fCut.Params[2].AsString := QGeneanet.FieldByName('DATE_DEBUT').AsString;
                          fCut.Params[3].AsString := QGeneanet.FieldByName('DATE_FIN').AsString;
                          fCut.Params[4].AsString := QGeneanet.FieldByName('COMBIEN').AsString;
                          fCut.Params[5].AsString := QGeneanet.FieldByName('VILLE').AsString;
                          fCut.Params[6].AsString := QGeneanet.FieldByName('CP').AsString;
                          fCut.Params[7].AsString := '';
                          fCut.Params[8].AsString := QGeneanet.FieldByName('PAYS_CODE').AsString;
                          fCut.Params[9].AsString := 'F';

                          fCut.ParamsToStr;
                          fContent.Add(fCut.Line);
                          inc(tot);

                          QGeneanet.Next;
                        end;
                    end;

                  QGeneanet.Close;
                end;

            finally
              _FOccupe.doDesactive;
            end;


            if tot > 0 then
              begin
                SaveDialog.InitialDir := _Context.PathImportExport;

                if SaveDialog.Execute then
                  begin
                    fContent.SaveToFile(SaveDialog.FileName);
                    MyMessageDlg('L''exportation au format "Geneanet" est ralis.'#13#10#13#10' Il vous reste maintenant  tlcharger le fichier sur le site Internet "www.geneanet.com".', mtInformation, [mbOK], 0);
                  end;
              end
            else
              begin
                MyMessageDlg('Je n' + #39 + 'ai trouv personne  exporter.', mtInformation, [mbOK], 0);
              end;

          finally
            IBQPatronymes.EnableControls;
          end;

        finally
          fCut.Free;
        end;
      finally
        fContent.free;
      end;
    end;
end;

procedure TFExportGeneanet.URLLink2Click(Sender: TObject);
begin
  GotoThisURL('www.geneanet.com');
end;

procedure TFExportGeneanet.Image1Click(Sender: TObject);
begin
  GotoThisURL('www.geneanet.com');
end;

procedure TFExportGeneanet.gridClick(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFExportGeneanet.SuperFormRefreshControls(Sender: TObject);
begin
  btnExport.enabled := (IBQPatronymes.Active) and (IBQPatronymes.recordCount > 0) and (grid.SelectedCount > 0);
end;

procedure TFExportGeneanet.SuperFormShowFirstTime(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFExportGeneanet.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
