{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_gedcom_func;

interface

type
  TSetCodageCaracteres = (ccANSEL, ccDOS, ccWindows, ccMacintosh);



function AssembleString(s: array of string; Separator: string): string;
function AssembleAllString(s: array of string; Separator: string): string;
function TestAnselMatching(c1, c2: char; var cc: char): boolean;

function Oem2Ansi(SBefore: string): string;
function Ansel2Ansi(SBefore: string): string;
function Ansi2Ansel(SBefore: string): string;
function Ansi2Oem(SBefore: string): string;
function Ansi2Mac(SBefore: string): string;
function MacToAnsi(SBefore: string): string;

function MacToIso(C: char): char;
function IsoToMac(C: char): char;


function ConvertionChaine(aChaine: string; FromFormat: TSetCodageCaracteres): string;
function ConvertionToChaine(aChaine: string; ToFormat: TSetCodageCaracteres): string;

procedure ClearListToken;


const
  MAXTABLE = 47;
  ANSELTABLE: array[0..MAXTABLE] of string =
  ('e', 'e', 'e', 'e', 'o', 'o', 'o', 'o', 'a', 'a', 'a', 'a', 'u', 'u', 'u', 'u', 'i', 'i', 'i', 'i', 'y', 'y', 'c', '~n',
    'E', 'E', 'E', 'E', 'O', 'O', 'O', 'O', 'A', 'A', 'A', 'A', 'U', 'U', 'U', 'U', 'I', 'I', 'I', 'I', 'Y', 'Y', 'C', '~N');
  ANSITABLE: array[0..MAXTABLE] of char =
  ('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
    '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '');

  NONE = $2E; { Car. Mac pour remplacer les inexistants }

  MacToIso1: array[0..255] of byte = (
    $00, $01, $02, $03, $04, $05, $06, $07,
    $08, $09, $0A, $0B, $0C, $0D, $0E, $0F,
    $10, $11, $12, $13, $14, $15, $16, $17,
    $18, $19, $1A, $1B, $1C, $1D, $1E, $1F,
    $20, $21, $22, $23, $24, $25, $26, $27,
    $28, $29, $2A, $2B, $2C, $2D, $2E, $2F,
    $30, $31, $32, $33, $34, $35, $36, $37,
    $38, $39, $3A, $3B, $3C, $3D, $3E, $3F,
    $40, $41, $42, $43, $44, $45, $46, $47,
    $48, $49, $4A, $4B, $4C, $4D, $4E, $4F,
    $50, $51, $52, $53, $54, $55, $56, $57,
    $58, $59, $5A, $5B, $5C, $5D, $5E, $5F,
    $60, $61, $62, $63, $64, $65, $66, $67,
    $68, $69, $6A, $6B, $6C, $6D, $6E, $6F,
    $70, $71, $72, $73, $74, $75, $76, $77,
    $78, $79, $7A, $7B, $7C, $7D, $7E, $7F,
    $C4, $C5, $C7, $C9, $D1, $D6, $DC, $E1,
    $E0, $E2, $E4, $E3, $E5, $E7, $E9, $E8,
    $EA, $EB, $ED, $EC, $EE, $EF, $F1, $F3,
    $F2, $F4, $F6, $F5, $FA, $F9, $FB, $FC,
    NONE, $B0, $A2, $A3, $A7, $BA, $B6, $DF,
    $AE, $A9, NONE, $B4, $A8, NONE, $C6, $D8,
    NONE, $B1, NONE, NONE, $A5, $B5, NONE, NONE,
    NONE, NONE, NONE, NONE, NONE, NONE, $E6, $F8,
    $BF, $A1, $AC, NONE, NONE, NONE, NONE, $AB,
    $BB, NONE, NONE, $C0, $C3, $D5, NONE, NONE,
    $2D, $2D, $22, $22, $27, $27, NONE, NONE,
    $FF, NONE, NONE, NONE, NONE, NONE, NONE, NONE,
    NONE, NONE, NONE, NONE, NONE, NONE, NONE, NONE,
    NONE, NONE, NONE, NONE, NONE, NONE, NONE, NONE,
    NONE, NONE, NONE, NONE, NONE, NONE, NONE, NONE,
    NONE, NONE, NONE, NONE, NONE, NONE, NONE, NONE
    );

  NOPE = $B7;

  Iso1ToMac: array[0..255] of byte = (
    $00, $01, $02, $03, $04, $05, $06, $07,
    $08, $09, $0A, $0B, $0C, $0D, $0E, $0F,
    $10, $11, $12, $13, $14, $15, $16, $17,
    $18, $19, $1A, $1B, $1C, $1D, $1E, $1F,
    $20, $21, $22, $23, $24, $25, $26, $27,
    $28, $29, $2A, $2B, $2C, $2D, $2E, $2F,
    $30, $31, $32, $33, $34, $35, $36, $37,
    $38, $39, $3A, $3B, $3C, $3D, $3E, $3F,
    $40, $41, $42, $43, $44, $45, $46, $47,
    $48, $49, $4A, $4B, $4C, $4D, $4E, $4F,
    $50, $51, $52, $53, $54, $55, $56, $57,
    $58, $59, $5A, $5B, $5C, $5D, $5E, $5F,
    $60, $61, $62, $63, $64, $65, $66, $67,
    $68, $69, $6A, $6B, $6C, $6D, $6E, $6F,
    $70, $71, $72, $73, $74, $75, $76, $77,
    $78, $79, $7A, $7B, $7C, $7D, $7E, $7F,
    NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE,
    NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE,
    NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE,
    NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE,
    NOPE, $C1, $A2, $A3, NOPE, $B4, $7C, $A4,
    $AC, $A9, NOPE, $C7, $C2, $2D, $A8, NOPE,
    $A1, $B1, NOPE, NOPE, $AB, $B5, $A6, $A5,
    NOPE, NOPE, NOPE, $C8, NOPE, NOPE, NOPE, $C0,
    $CB, NOPE, NOPE, $CC, $80, $81, $AE, $82,
    NOPE, $83, NOPE, NOPE, NOPE, NOPE, NOPE, NOPE,
    NOPE, $84, NOPE, NOPE, NOPE, $CD, $85, NOPE,
    $AF, NOPE, NOPE, NOPE, $86, NOPE, NOPE, $E1,
    $88, $87, $89, $8B, $8A, $8C, $BE, $8D,
    $8F, $8E, $90, $91, $93, $92, $94, $95,
    NOPE, $96, $98, $97, $99, $9B, $9A, $D6,
    $BF, $9D, $9C, $9E, $9F, NOPE, NOPE, $D8
    );



var
  StrAnsi: string;


implementation

uses
  SysUtils, windows, u_gedcom_var;

var
  aze: integer;

function AssembleString(s: array of string; Separator: string): string;
var
  i: Integer;
  sub: string;
begin
  result := '';
  for i := 0 to High(s) do
    begin
      sub := trim(s[i]);
      if sub <> '' then
        begin
          if (result <> '') and (i > 0) then result := result + Separator;
          result := result + sub;
        end;
    end;
end;

function AssembleAllString(s: array of string; Separator: string): string;
var
  i: Integer;
  sub: string;
begin
  result := '';
  for i := 0 to High(s) do
    begin
      sub := trim(s[i]);
      if (i > 0) then result := result + Separator;
      result := result + sub;
    end;
end;


function TestAnselMatching(c1, c2: char; var cc: char): boolean;
var
  i: integer;
begin
  Result := false;
  if (ord(c1) >= 128) then begin
      for i := 0 to MAXTABLE do
        if (ANSELTABLE[i] = (string(c1) + string(c2))) then begin
            cc := ANSITABLE[i];
            Result := true;
            break;
          end;
    end;
end;




function Oem2Ansi(SBefore: string): string;
var
  sz: PChar;
begin
  sz := StrAlloc(length(SBefore) + 1);
  oemtochar(PChar(SBefore), sz);
  result := sz;
  StrDispose(sz);
end;


function Ansel2Ansi(SBefore: string): string;
var
  n, k: integer;
  c1, c2, cc: char;
begin
  k := length(SBefore);
  if k < 2 then Result := SBefore
  else
    begin
      Result := '';
      c1 := SBefore[1];
      n := 2;

      repeat
        c2 := SBefore[n];
        n := n + 1;

        //on tient 2 caractres. sont-ils des ansel ?
        if TestAnselMatching(c1, c2, cc) then
          begin
            Result := Result + cc;
            if n <= k then begin c1 := SBefore[n]; n := n + 1; end;
          end
        else
          begin
            Result := Result + c1;
            if n > k then Result := Result + c2;
            c1 := c2;
          end;
      until n > k;
    end;
end;

function ConvertionChaine(aChaine: string; FromFormat: TSetCodageCaracteres): string;
begin
  case FromFormat of
    ccANSEL: result := Ansel2Ansi(aChaine);
    ccDOS: result := Oem2Ansi(aChaine);
    ccMacintosh: result := MacToAnsi(aChaine);
    else
      result := aChaine;
  end;
end;

function ConvertionToChaine(aChaine: string; ToFormat: TSetCodageCaracteres): string;
begin
  case ToFormat of
    ccANSEL: result := Ansi2Ansel(aChaine);
    ccDOS: result := Ansi2Oem(aChaine);
    ccMacintosh: result := Ansi2Mac(aChaine);
    else
      result := aChaine;
  end;
end;


function Ansi2Ansel(SBefore: string): string;
var
  n, k: integer;
begin
  result := '';
  for n := 1 to length(SBefore) do
    begin
      k := pos(SBefore[n], StrAnsi);
      if k = 0 then result := result + SBefore[n] else result := result + ANSELTABLE[k - 1];
    end;
end;

function Ansi2Oem(SBefore: string): string;
var
  sz: PChar;
begin
  sz := StrAlloc(length(SBefore) + 1);
  charToOem(PChar(SBefore), sz);
  result := sz;
  StrDispose(sz);
end;

procedure ClearListToken;
begin
  Token_Du.Clear;
  Token_Au.Clear;
  Token_Avant.Clear;
  Token_Apres.Clear;
  Token_Entre.Clear;
  Token_Et.Clear;
  Token_Calculee.Clear;
  Token_Estimee.Clear;
  Token_Vers.Clear;
  Token_Human_Month_01.Clear;
  Token_Human_Month_02.Clear;
  Token_Human_Month_03.Clear;
  Token_Human_Month_04.Clear;
  Token_Human_Month_05.Clear;
  Token_Human_Month_06.Clear;
  Token_Human_Month_07.Clear;
  Token_Human_Month_08.Clear;
  Token_Human_Month_09.Clear;
  Token_Human_Month_10.Clear;
  Token_Human_Month_11.Clear;
  Token_Human_Month_12.Clear;
  Separator_Human_Date.Clear;
end;


function MacToIso(C: char): char;
begin
  result := chr(MacToIso1[ord(C)]);
end;

function IsoToMac(C: char): char;
begin
  result := chr(Iso1ToMac[ord(C)]);
end;

function Ansi2Mac(SBefore: string): string;
var
  n: integer;
begin
  result := '';
  for n := 1 to length(SBefore) do result := result + IsoToMac(SBefore[n]);
end;


function MacToAnsi(SBefore: string): string;
var
  n: integer;
begin
  result := '';
  for n := 1 to length(SBefore) do result := result + MacToIso(SBefore[n]);
end;


initialization
  StrAnsi := '';
  for aze := 0 to MAXTABLE do StrAnsi := StrAnsi + ANSITABLE[aze];

end.
