{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_graph_config_hierarchie;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, dxCntner, dxEditor, dxExEdtr, dxEdLib, StdCtrls, Buttons,
  u_objet_TState, u_objet_TGraphArbre, ExtCtrls, ColorPickerButton,
  TFlatSpeedButtonUnit, u_comp_TNakedSpeedButton,
  u_form_graph_paintbox, u_comp_TYLanguage, DynamicSkinForm;

type
  TFGraphConfigHierarchie = class(TSuperForm)
    FontDialog: TFontDialog;
    pBorder: TPanel;
    Panel11: TPanel;
    Panel14: TPanel;
    Panel13: TPanel;
    Panel6: TPanel;
    Panel8: TPanel;
    panTabs: TPanel;
    PaintBoxOnglet: TPaintBox;
    Panel12: TPanel;
    Panel5: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Notebook: TNotebook;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    edMargeLeft: TdxSpinEdit;
    edMargeTop: TdxSpinEdit;
    edWidthIndi: TdxSpinEdit;
    edHeightIndi: TdxSpinEdit;
    edSpaceBetweenGeneration: TdxSpinEdit;
    edSpaceBetewwenIndi: TdxSpinEdit;
    Label2: TLabel;
    Label19: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label21: TLabel;
    Label23: TLabel;
    edColorTexteHomme: TColorPickerButton;
    edColorTexteFemme: TColorPickerButton;
    FlatSpeedButton1: TFlatSpeedButton;
    cNom: TdxCheckEdit;
    cPrenom: TdxCheckEdit;
    cProf: TdxCheckEdit;
    cNaissance: TdxCheckEdit;
    cDeces: TdxCheckEdit;
    edDistProf: TdxSpinEdit;
    edDistNaissance: TdxSpinEdit;
    edDistDeces: TdxSpinEdit;
    edDistNom: TdxSpinEdit;
    edDistPrenom: TdxSpinEdit;
    panExempleFont: TPanel;
    edCouleurRectHomme: TColorPickerButton;
    Label20: TLabel;
    edCouleurFondRectHomme: TColorPickerButton;
    edCouleurRectFemme: TColorPickerButton;
    Label22: TLabel;
    edCouleurFondFemme: TColorPickerButton;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    edCouleurLiens: TColorPickerButton;
    cPaintFondRecHomme: TdxCheckEdit;
    cPaintFondRecFemme: TdxCheckEdit;
    Panel16: TPanel;
    btnSetMouseMoveOrSelect: TNakedSpeedButton;
    btnSetMouseZoomMore: TNakedSpeedButton;
    btnSetZoomAll: TNakedSpeedButton;
    btnSetMouseZoomLess: TNakedSpeedButton;
    lZoom: TLabel;
    lbZoom: TLabel;
    TrackBar: TScrollBar;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CaracteristiquesChange(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure PaintBoxOngletPaint(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure PaintBoxOngletMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btnSetMouseMoveOrSelectClick(Sender: TObject);
    procedure btnSetMouseZoomMoreClick(Sender: TObject);
    procedure btnSetMouseZoomLessClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure btnSetZoomAllClick(Sender: TObject);
    procedure TrackBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fFill: TState;
    fTextesOnglets: TStringList;
    fOngletID: integer;
    procedure ApplyChanges;
    procedure doActiveOnglet(onglet: integer);
    procedure SetTabByPositionMouse(x: integer);
  public
    PtrGraph: TGraphArbre;
    GraphPaintBox: TFGraphPaintBox;
  end;


implementation

uses u_common_var, u_common_graph_var, u_dm, u_common_func, u_form_main,
  u_common_const;

{$R *.DFM}

procedure TFGraphConfigHierarchie.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 378;
      ClientWidth := 244;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fFill := TState.create(false);
  fTextesOnglets := TStringList.create;
  fTextesOnglets.Add('Dimensions');
  fTextesOnglets.Add('Textes');
  fTextesOnglets.Add('Couleurs');
  fOngletID := 0;
end;

procedure TFGraphConfigHierarchie.SuperFormDestroy(Sender: TObject);
begin
  fFill.free;
  fTextesOnglets.free;
end;

procedure TFGraphConfigHierarchie.SpeedButton1Click(Sender: TObject);
begin
  FontDialog.Font.Assign(panExempleFont.Font);

  if FontDialog.execute then
    begin
      panExempleFont.Font.Assign(FontDialog.Font);
      ApplyChanges;
    end;
end;



procedure TFGraphConfigHierarchie.CaracteristiquesChange(Sender: TObject);
begin
  ApplyChanges;
end;

procedure TFGraphConfigHierarchie.ApplyChanges;
begin
  if fFill.Value = false then
    begin
      _Context.ShouldSave := true;

      //on remplie le context

      _Context.ArbreMargeLeft := edMargeLeft.IntValue;
      _Context.ArbreMargeTop := edMargeTop.IntValue;

      _Context.ArbreWidthBox := edWidthIndi.IntValue;
      _Context.ArbreHeightBox := edHeightIndi.IntValue;
      _Context.ArbreSpaceBetween2Gen := edSpaceBetweenGeneration.IntValue;
      _Context.ArbreSpaceBetween2Indi := edSpaceBetewwenIndi.IntValue;

      _Context.ArbreFont := FontToString(panExempleFont.Font);
      _Context.ArbreCouleurTexteHomme := edColorTexteHomme.SelectionColor;
      _Context.ArbreCouleurTexteFemme := edColorTexteFemme.SelectionColor;

      _Context.ArbreShowNom := cNom.checked;
      _Context.ArbreShowPrenom := cPrenom.checked;
      _Context.ArbreShowProfession := cProf.checked;
      _Context.ArbreShowNaissance := cNaissance.checked;
      _Context.ArbreShowDeces := cDeces.checked;

      _Context.ArbreDistNom := edDistNom.IntValue;
      _Context.ArbreDistPrenom := edDistPrenom.IntValue;
      _Context.ArbreDistProfession := edDistProf.IntValue;
      _Context.ArbreDistNaissance := edDistNaissance.IntValue;
      _Context.ArbreDistDeces := edDistDeces.IntValue;

      _Context.ArbreCouleurLiens := edCouleurLiens.SelectionColor;
      _Context.ArbreCouleurRectHomme := edCouleurRectHomme.SelectionColor;
      _Context.ArbrePaintFondRecHomme := cPaintFondRecHomme.checked;
      _Context.ArbreCouleurFondRectHomme := edCouleurFondRectHomme.SelectionColor;
      _Context.ArbreCouleurRectFemme := edCouleurRectFemme.SelectionColor;
      _Context.ArbrePaintFondRecFemme := cPaintFondRecFemme.checked;
      _Context.ArbreCouleurFondRectFemme := edCouleurFondFemme.SelectionColor;

      //on rafraichit le graph
      _Viewer.BeginUpdate;
      try
        PtrGraph.Prepare;

        _Viewer.BuildZonesImpression;
        _Viewer.BuildMiniature;
        _Viewer.PrepareGraph;
      finally
        _Viewer.EndUpdate;
      end;

      _Viewer.Refresh;
      _Viewer.RefreshMiniature;
    end;
end;


procedure TFGraphConfigHierarchie.SuperFormShowFirstTime(Sender: TObject);
var
  p: TPoint;
begin
  //Position de la fentre
 // p := FMain.ClientToScreen(Point(FMain.Width, FMain.Height));
  p := Point(Screen.width, Screen.Height);
  Left := p.x - Width - 10;
  Top := p.y - Height - 50;



  doActiveOnglet(0);
  Application.ProcessMessages;

  fFill.Value := true;
  try
    edMargeLeft.IntValue := _Context.ArbreMargeLeft;
    edMargeTop.IntValue := _Context.ArbreMargeTop;

    edWidthIndi.IntValue := _Context.ArbreWidthBox;
    edHeightIndi.IntValue := _Context.ArbreHeightBox;
    edSpaceBetweenGeneration.IntValue := _Context.ArbreSpaceBetween2Gen;
    edSpaceBetewwenIndi.IntValue := _Context.ArbreSpaceBetween2Indi;

    StringToFont(_Context.ArbreFont, panExempleFont.Font);
    edColorTexteHomme.SelectionColor := _Context.ArbreCouleurTexteHomme;
    edColorTexteFemme.SelectionColor := _Context.ArbreCouleurTexteFemme;


    cNom.checked := _Context.ArbreShowNom;
    cPrenom.checked := _Context.ArbreShowPrenom;
    cProf.checked := _Context.ArbreShowProfession;
    cNaissance.checked := _Context.ArbreShowNaissance;
    cDeces.checked := _Context.ArbreShowDeces;

    edDistNom.IntValue := _Context.ArbreDistNom;
    edDistPrenom.IntValue := _Context.ArbreDistPrenom;
    edDistProf.IntValue := _Context.ArbreDistProfession;
    edDistNaissance.IntValue := _Context.ArbreDistNaissance;
    edDistDeces.IntValue := _Context.ArbreDistDeces;

    edCouleurLiens.SelectionColor := _Context.ArbreCouleurLiens;
    edCouleurRectHomme.SelectionColor := _Context.ArbreCouleurRectHomme;
    cPaintFondRecHomme.checked := _Context.ArbrePaintFondRecHomme;
    edCouleurFondRectHomme.SelectionColor := _Context.ArbreCouleurFondRectHomme;
    edCouleurRectFemme.SelectionColor := _Context.ArbreCouleurRectFemme;
    cPaintFondRecFemme.checked := _Context.ArbrePaintFondRecFemme;
    edCouleurFondFemme.SelectionColor := _Context.ArbreCouleurFondRectFemme;





  finally
    fFill.Value := false;
  end;
end;

procedure TFGraphConfigHierarchie.PaintBoxOngletPaint(Sender: TObject);
begin
  PaintOnglet(PaintBoxOnglet, 3, fOngletID, 74, 18, clBlack, $00C5E8F3, $008FC6D8, fTextesOnglets);
end;


procedure TFGraphConfigHierarchie.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFGraphConfigHierarchie.SpeedButton2Click(Sender: TObject);
begin
  Close;
end;

procedure TFGraphConfigHierarchie.PaintBoxOngletMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
  p := TControl(Sender).ClientToScreen(Point(X, Y));
  p := panTabs.ScreenToClient(p);
  SetTabByPositionMouse(p.x);
end;


procedure TFGraphConfigHierarchie.SetTabByPositionMouse(x: integer);
var k: integer;
begin
  k := (x div 71);
  if k < 0 then k := 0;
  if k > 2 then k := 2;
  doActiveOnglet(k);
end;

procedure TFGraphConfigHierarchie.doActiveOnglet(onglet: integer);
begin
  fOngletID := onglet;
  PaintBoxOnglet.Refresh;
  Application.ProcessMessages;
  Notebook.PageIndex := onglet;
end;

procedure TFGraphConfigHierarchie.btnSetMouseMoveOrSelectClick(
  Sender: TObject);
begin
  GraphPaintBox.SetMoveMove(self);
end;

procedure TFGraphConfigHierarchie.btnSetMouseZoomMoreClick(Sender: TObject);
begin
  GraphPaintBox.SetModeZoomMore(self);
end;

procedure TFGraphConfigHierarchie.btnSetMouseZoomLessClick(Sender: TObject);
begin
  GraphPaintBox.SetModeZoomLess(self);
end;

procedure TFGraphConfigHierarchie.TrackBarChange(Sender: TObject);
begin
  GraphPaintBox.TrackBarZoomChange(self);
end;

procedure TFGraphConfigHierarchie.btnSetZoomAllClick(Sender: TObject);
begin
  GraphPaintBox.SetZoomAll(self);
end;

procedure TFGraphConfigHierarchie.TrackBarScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  if ScrollCode = scEndScroll then GraphPaintBox.Zooming := false;
end;

procedure TFGraphConfigHierarchie.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    //	  VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_PRINT_ARBRE);
  end;
end;

end.
