{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_graph_config_roue;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, Buttons, dxCntner, dxEditor, dxExEdtr, dxEdLib,
  u_objet_TGraphRoue, u_objet_TState, ExtCtrls, ColorPickerButton,
  TFlatSpeedButtonUnit, u_comp_TNakedSpeedButton,
  u_form_graph_paintbox, u_comp_TYLanguage, DynamicSkinForm;

type
  TFGraphConfigRoue = class(TSuperForm)
    FontDialog: TFontDialog;
    pBorder: TPanel;
    Panel11: TPanel;
    Panel14: TPanel;
    Panel13: TPanel;
    Panel6: TPanel;
    Panel8: TPanel;
    panTabs: TPanel;
    PaintBoxOnglet: TPaintBox;
    Panel12: TPanel;
    Panel5: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Notebook: TNotebook;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    edColorTexteHomme: TColorPickerButton;
    edColorTexteFemme: TColorPickerButton;
    FlatSpeedButton1: TFlatSpeedButton;
    cNom: TdxCheckEdit;
    cPrenom: TdxCheckEdit;
    cProf: TdxCheckEdit;
    cNaissance: TdxCheckEdit;
    cDeces: TdxCheckEdit;
    edDistProf: TdxSpinEdit;
    edDistNaissance: TdxSpinEdit;
    edDistDeces: TdxSpinEdit;
    edDistNom: TdxSpinEdit;
    edDistPrenom: TdxSpinEdit;
    panExempleFont: TPanel;
    Panel17: TPanel;
    btnSetMouseMoveOrSelect: TNakedSpeedButton;
    btnSetMouseZoomMore: TNakedSpeedButton;
    btnSetZoomAll: TNakedSpeedButton;
    btnSetMouseZoomLess: TNakedSpeedButton;
    lZoom: TLabel;
    lbZoom: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label1: TLabel;
    edAngle: TdxSpinEdit;
    edRayon: TdxSpinEdit;
    edMargeLeft: TdxSpinEdit;
    edMargeTop: TdxSpinEdit;
    edCouleurFondRectHomme: TColorPickerButton;
    edCouleurFondFemme: TColorPickerButton;
    cPaintFondRecHomme: TdxCheckEdit;
    cPaintFondRecFemme: TdxCheckEdit;
    edColorCercle: TColorPickerButton;
    Label17: TLabel;
    Label18: TLabel;
    edColorRayon: TColorPickerButton;
    TrackBar: TScrollBar;
    Label28: TLabel;
    Label29: TLabel;
    edDecalageIndiCentral: TdxSpinEdit;
    Panel16: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure CaracteristiquesChange(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure btnSetMouseMoveOrSelectClick(Sender: TObject);
    procedure btnSetMouseZoomMoreClick(Sender: TObject);
    procedure btnSetZoomAllClick(Sender: TObject);
    procedure btnSetMouseZoomLessClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure PaintBoxOngletPaint(Sender: TObject);
    procedure PaintBoxOngletMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure TrackBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fFill: TState;
    fTextesOnglets: TStringList;
    fOngletID: integer;
    procedure ApplyChanges;
    procedure doActiveOnglet(onglet: integer);
    procedure SetTabByPositionMouse(x: integer);
  public
    PtrGraph: TGraphRoue;
    GraphPaintBox: TFGraphPaintBox;
  end;



implementation

uses u_common_graph_var, u_dm, u_common_var, u_common_func, u_form_main,
  u_common_const;

{$R *.DFM}

procedure TFGraphConfigRoue.SuperFormShowFirstTime(Sender: TObject);
var
  p: TPoint;
begin
  //Position de la fentre
  p := Point(Screen.width, Screen.Height);
  Left := p.x - Width - 10;
  Top := p.y - Height - 50;


  fFill.Value := true;
  try
    //edNbGeneration.IntValue := PtrGraph.NbGeneration;

    edAngle.IntValue := _Context.RoueAngle;
    edRayon.IntValue := _Context.RoueRayon;
    edMargeLeft.IntValue := _Context.RoueMargeLeft;
    edMargeTop.IntValue := _Context.RoueMargeTop;

    StringToFont(_Context.RoueFont, panExempleFont.Font);
    edColorTexteHomme.SelectionColor := _Context.RoueCouleurTexteHomme;
    edColorTexteFemme.SelectionColor := _Context.RoueCouleurTexteFemme;


    cNom.checked := _Context.RoueShowNom;
    cPrenom.checked := _Context.RoueShowPrenom;
    cProf.checked := _Context.RoueShowProfession;
    cNaissance.checked := _Context.RoueShowNaissance;
    cDeces.checked := _Context.RoueShowDeces;

    edDistNom.IntValue := _Context.RoueDistNom;
    edDistPrenom.IntValue := _Context.RoueDistPrenom;
    edDistProf.IntValue := _Context.RoueDistProfession;
    edDistNaissance.IntValue := _Context.RoueDistNaissance;
    edDistDeces.IntValue := _Context.RoueDistDeces;
    edDecalageIndiCentral.IntValue := _Context.RoueDecalageIndiCentral;

    edColorCercle.SelectionColor := _Context.RoueCouleurCercle;
    edColorRayon.SelectionColor := _Context.RoueCouleurRayon;


  finally
    fFill.Value := false;
  end;
end;

procedure TFGraphConfigRoue.ApplyChanges;
begin
  if fFill.Value = false then
    begin
      _Context.ShouldSave := true;

      //on remplie le context

      _Context.RoueAngle := edAngle.IntValue;
      _Context.RoueRayon := edRayon.IntValue;
      _Context.RoueMargeLeft := edMargeLeft.IntValue;
      _Context.RoueMargeTop := edMargeTop.IntValue;

      _Context.RoueFont := FontToString(panExempleFont.Font);
      _Context.RoueCouleurTexteHomme := edColorTexteHomme.SelectionColor;
      _Context.RoueCouleurTexteFemme := edColorTexteFemme.SelectionColor;


      _Context.RoueShowNom := cNom.checked;
      _Context.RoueShowPrenom := cPrenom.checked;
      _Context.RoueShowProfession := cProf.checked;
      _Context.RoueShowNaissance := cNaissance.checked;
      _Context.RoueShowDeces := cDeces.checked;

      _Context.RoueDistNom := edDistNom.IntValue;
      _Context.RoueDistPrenom := edDistPrenom.IntValue;
      _Context.RoueDistProfession := edDistProf.IntValue;
      _Context.RoueDistNaissance := edDistNaissance.IntValue;
      _Context.RoueDistDeces := edDistDeces.IntValue;
      _Context.RoueDecalageIndiCentral := edDecalageIndiCentral.IntValue;

      _Context.RoueCouleurCercle := edColorCercle.SelectionColor;
      _Context.RoueCouleurRayon := edColorRayon.SelectionColor;


      //on rafraichit le graph
      _Viewer.BeginUpdate;
      try
        PtrGraph.Prepare;

        _Viewer.BuildZonesImpression;
        _Viewer.BuildMiniature;
        _Viewer.PrepareGraph;
      finally
        _Viewer.EndUpdate;
      end;

      _Viewer.Refresh;
      _Viewer.RefreshMiniature;
    end;
end;


procedure TFGraphConfigRoue.CaracteristiquesChange(Sender: TObject);
begin
  ApplyChanges;
end;



procedure TFGraphConfigRoue.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 378;
      ClientWidth := 244;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fFill := TState.create(false);
  fTextesOnglets := TStringList.create;
  fTextesOnglets.Add('Design');
  fTextesOnglets.Add('Textes');
  fOngletID := 0;
end;

procedure TFGraphConfigRoue.SuperFormDestroy(Sender: TObject);
begin
  fFill.free;
  fTextesOnglets.free;
end;

procedure TFGraphConfigRoue.SpeedButton1Click(Sender: TObject);
begin
  FontDialog.Font.Assign(panExempleFont.Font);
  if FontDialog.execute then
    begin
      panExempleFont.Font.Assign(FontDialog.Font);
      ApplyChanges;
    end;
end;

procedure TFGraphConfigRoue.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFGraphConfigRoue.SpeedButton2Click(Sender: TObject);
begin
  Close;
end;

procedure TFGraphConfigRoue.btnSetMouseMoveOrSelectClick(Sender: TObject);
begin
  GraphPaintBox.SetMoveMove(self);
end;

procedure TFGraphConfigRoue.btnSetMouseZoomMoreClick(Sender: TObject);
begin
  GraphPaintBox.SetModeZoomMore(self);
end;

procedure TFGraphConfigRoue.btnSetZoomAllClick(Sender: TObject);
begin
  GraphPaintBox.SetZoomAll(self);
end;

procedure TFGraphConfigRoue.btnSetMouseZoomLessClick(Sender: TObject);
begin
  GraphPaintBox.SetModeZoomLess(self);
end;

procedure TFGraphConfigRoue.TrackBarChange(Sender: TObject);
begin
  GraphPaintBox.TrackBarZoomChange(self);
end;

procedure TFGraphConfigRoue.PaintBoxOngletPaint(Sender: TObject);
begin
  PaintOnglet(PaintBoxOnglet, 2, fOngletID, 74, 18, clBlack, $00C5E8F3, $008FC6D8, fTextesOnglets);
end;

procedure TFGraphConfigRoue.PaintBoxOngletMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
  p := TControl(Sender).ClientToScreen(Point(X, Y));
  p := panTabs.ScreenToClient(p);
  SetTabByPositionMouse(p.x);
end;


procedure TFGraphConfigRoue.SetTabByPositionMouse(x: integer);
var k: integer;
begin
  k := (x div 71);
  if k < 0 then k := 0;
  if k > 1 then k := 1;
  doActiveOnglet(k);
end;

procedure TFGraphConfigRoue.doActiveOnglet(onglet: integer);
begin
  fOngletID := onglet;
  PaintBoxOnglet.Refresh;
  Application.ProcessMessages;
  Notebook.PageIndex := onglet;
end;

procedure TFGraphConfigRoue.TrackBarScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  if ScrollCode = scEndScroll then GraphPaintBox.Zooming := false;
end;

procedure TFGraphConfigRoue.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    //	  VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_PRINT_ROUE);
  end;
end;

end.
