{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_graph_miniature;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls;

type
  TFGraphMiniature = class(TSuperForm)
    Panel1: TPanel;
    PaintBox: TPaintBox;
    procedure SuperFormResize(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SuperFormHide(Sender: TObject);
  private
    fMoving: boolean;
    fStartPos: TPoint;
    fInitialDecal: TPoint;

  public
    procedure DrawCadreAs;

  end;



implementation

uses u_common_graph_var, u_common_var, u_common_const;

{$R *.DFM}

procedure TFGraphMiniature.DrawCadreAs;
begin

end;

procedure TFGraphMiniature.SuperFormResize(Sender: TObject);
begin
  if _Viewer <> nil then
    begin
      _Viewer.BuildMiniature;
    end;
end;


procedure TFGraphMiniature.SuperFormCreate(Sender: TObject);
begin

  fMoving := false;
end;


procedure TFGraphMiniature.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (_Viewer <> nil) and (_Viewer.Chantier <> nil) then
    begin
      if _Viewer.Chantier.Graph <> nil then
        begin
          _Viewer.MovingOnMiniature := true;
          fStartPos.x := x;
          fStartPos.y := y;

          fInitialDecal.x := _Viewer.DecalX;
          fInitialDecal.y := _Viewer.DecalY;
        end;
    end;
end;


procedure TFGraphMiniature.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  deltaX, deltaY: integer;
  deltaViewerX, deltaViewerY: integer;
  deltaChantierX, deltaChantierY: single;
  //     fdx, fdy: integer;
begin
  if _Viewer <> nil then
    begin
      if _Viewer.MovingOnMiniature then
        begin
          //               fdx := fDecalX;
          //               fdy := fDecalY;
                         //les delta de dplacement dans la miniature
          deltaX := (x - fStartPos.x);
          deltaY := (y - fStartPos.y);

          //               if fDecalX > 0 then fDecalX := 0;
            //             if fDecalY > 0 then fDecalY := 0;

              //           if (fdx <> fDecalX) or (fdy <> fDecalY) then
          begin
            {
            //ce dplacement correspond  combien de mtre, dans le chantier ?
            deltaChantierX := (deltaX * 100) / (_Viewer.ZoomMiniature * _Viewer.echelle);
            deltaChantierY := (deltaY * 100) / (_Viewer.ZoomMiniature * _Viewer.echelle);

            //ce nombre de mtre correspond  combien de pixels, dans le viewer ?
            deltaViewerX := round(deltaChantierX * _Viewer.echelle * _Viewer.Zoom / 100);
            deltaViewerY := round(deltaChantierY * _Viewer.echelle * _Viewer.Zoom / 100);
            }

            //ce dplacement correspond  combien de mtre, dans le chantier ?
    //               deltaChantierX := (deltaX * _Viewer.ZoomMiniature) / (_Viewer.echelle);
    //               deltaChantierY := (deltaY * _Viewer.ZoomMiniature) / (_Viewer.echelle);
            deltaChantierX := (deltaX * 100) / (_Viewer.ZoomMiniature);
            deltaChantierY := (deltaY * 100) / (_Viewer.ZoomMiniature);



            //ce nombre de mtre correspond  combien de pixels, dans le viewer ?
    //               deltaViewerX := round(deltaChantierX * _Viewer.echelle / _Viewer.Zoom);
    //               deltaViewerY := round(deltaChantierY * _Viewer.echelle / _Viewer.Zoom);
            deltaViewerX := round(deltaChantierX * _Viewer.Zoom / 100);
            deltaViewerY := round(deltaChantierY * _Viewer.Zoom / 100);


            //On applique le dcalage, dans le grand viewer
            _Viewer.DecalX := fInitialDecal.x - deltaViewerX;
            _Viewer.DecalY := fInitialDecal.y - deltaViewerY;


            //rafraichissement
            _Viewer.Refresh;
            _Viewer.RefreshMiniature;
          end;
        end;
    end;
end;


procedure TFGraphMiniature.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if _Viewer <> nil then
    begin
      _Viewer.MovingOnMiniature := false;
    end;
end;





procedure TFGraphMiniature.SuperFormHide(Sender: TObject);
begin
  _LastPosMiniature := Point(Left, Top);
end;

end.
