{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_graph_paintbox;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, ComCtrls, AdvStatusBar, Menus, StdCtrls,
  ActnList, u_comp_TBlueFlatSpeedButton, TFlatSpeedButtonUnit,
  u_comp_TInfoVersion, Buttons, Grids,
  u_objet_TState, TFlatHintUnit,
  u_objet_graph_TGraph, printers,
  u_form_graph_miniature, TFlatPanelUnit, TFlatButtonUnit, dxCntner,
  dxEditor, dxExEdtr, dxEdLib, u_comp_TNakedSpeedButton, u_comp_TYLanguage;

type
  TMyPopupMenu = class(TPopupMenu)
  public
    property PopupPoint;
  end;


  TFGraphPaintBox = class(TSuperForm)
    PrinterSetupDialog: TPrinterSetupDialog;
    popupFacteur: TPopupMenu;
    N111: TMenuItem;
    N110me1: TMenuItem;
    N150me1: TMenuItem;
    N1100me1: TMenuItem;
    ActionList: TActionList;
    Chantier_New: TAction;
    Chantier_Open: TAction;
    Chantier_OpenLast: TAction;
    Chantier_Close: TAction;
    Chantier_Quitter: TAction;
    Config_Preferences: TAction;
    Vue_SaveAs: TAction;
    Vue_Save: TAction;
    Vue_Delete: TAction;
    Pieu_EditCoordRef: TAction;
    Pieu_Retirer: TAction;
    Pieu_Importer: TAction;
    Pieu_SelectInWiewer: TAction;
    Pieu_VoirTous: TAction;
    Pieu_VoirAucun: TAction;
    Chantier_Print: TAction;
    Chantier_ConfigPrint: TAction;
    Viewer_CacherPieu: TAction;
    Viewer_EditCoordRef: TAction;
    Viewer_CentrerSurLePieu: TAction;
    Viewer_SelectPieu: TAction;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    PanelPaintBox: TPanel;
    PaintBox: TPaintBox;
    Panel3: TPanel;
    Panel5: TPanel;
    Label1: TLabel;
    btnPrint: TNakedSpeedButton;
    NakedSpeedButton2: TNakedSpeedButton;
    btnCfgGraph: TNakedSpeedButton;
    btnSelectIndiGraph: TNakedSpeedButton;
    btnRefresh: TNakedSpeedButton;
    edNbGeneration: TdxSpinEdit;
    NakedSpeedButton1: TNakedSpeedButton;
    popup: TPopupMenu;
    popup_VoirLaFicheInBox: TMenuItem;
    N1: TMenuItem;
    Imprimercettepage1: TMenuItem;
    Language: TYLanguage;
    sbDesc: TCheckBox;
    procedure SuperFormCreate(Sender: TObject);
    procedure menu_QuitChantierClick(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure btnSetMouseZoomMoreClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure Supprimercettevue1Click(Sender: TObject);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SuperFormResize(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure N111Click(Sender: TObject);
    procedure SuperFormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnVueClick(Sender: TObject);
    procedure cbVuesChange(Sender: TObject);
    procedure Vue_SaveExecute(Sender: TObject);
    procedure Vue_SaveAsExecute(Sender: TObject);
    procedure btnSelectIndiGraphClick(Sender: TObject);
    procedure btnCfgGraphClick(Sender: TObject);
    procedure edNbGenerationChange(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure btnPrinterSetupClick(Sender: TObject);
    procedure NakedSpeedButton1Click(Sender: TObject);
    procedure popupPopup(Sender: TObject);
    procedure popup_VoirLaFicheInBoxClick(Sender: TObject);
    procedure Imprimercettepage1Click(Sender: TObject);
    procedure sbDescClick(Sender: TObject);

  private


    //pour viter les mises--jour circulaires entre controls, par leurs vnements
    fFill: TState;

    //utilis uniquement par le trackBar du Zoom
    fZooming: boolean;
    fZoomOnX_Viewer: integer;
    fZoomOnY_Viewer: integer;
    fZoomOnX_Chantier: single;
    fZoomOnY_Chantier: single;

    //pour se souvenir quel pieu est sous la souris
//          fMemorizeIndexPieuUnderMouse: integer;

    //le graph
    fGraph: TGraph;

    fGraphMiniature: TFGraphMiniature;
    fPtrLabelZoom: TLabel;
    fPtrTrackBar: TScrollBar;
    //          fFormOptions: TForm;

    procedure CreateIntelligence;
    procedure DestroyIntelligence;

    //Refraichissement des diffrentes parties de l'interface
//          procedure RefreshComboboxVueList(TryToSelectVueName: string);


    //Evenement dclachs par l'objet Viewer, pour inter-agir avec l'interface
    procedure OnMouseMoveOnChantier(Sender: TObject; X, Y: single);
    procedure OnMouseMoveOnViewer(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure OnZoomChanged(Sender: TObject);
    procedure OnCurrentVueChanged(Sender: TObject);
    procedure OnAfterApplyVue(Sender: TObject; Name: string);


  public
    {
              property ZoomOnX_Viewer: integer read fZoomOnX_Viewer write fZoomOnX_Viewer;
              property ZoomOnY_Viewer: integer read fZoomOnY_Viewer write fZoomOnY_Viewer;
              property ZoomOnX_Chantier: single read fZoomOnX_Chantier write fZoomOnX_Chantier;
              property ZoomOnY_Chantier: single read fZoomOnY_Chantier write fZoomOnY_Chantier;
              }


  //  property FormOptions: TForm read fFormOptions write fFormOptions;
    property GraphMiniature: TFGraphMiniature read fGraphMiniature write fGraphMiniature;
    property PtrLabelZoom: TLabel read fPtrLabelZoom write fPtrLabelZoom;
    property PtrTrackBar: TScrollBar read fPtrTrackBar write fPtrTrackBar;

    property Zooming: boolean read fZooming write fZooming;

    procedure PlugGraph(aGraph: TGraph);
    procedure UnplugGraph;


    procedure SetZoom100(sender: TObject);
    procedure SetMoveMove(sender: TObject);
    procedure SetGraphOnTopLeft(sender: TObject);
    procedure SetModeZoomMore(sender: TObject);
    procedure SetZoomAll(sender: TObject);
    procedure SetModeZoomLess(sender: TObject);
    procedure SetShowMiniature;
    procedure TrackBarZoomChange(Sender: TObject);

    procedure RefreshTout;
    procedure doSelectOtherIndividu(CleIndi: integer);

    //   property Chantier :TChantier   read fChantier   write fChantier   ;
  end;


implementation

uses u_dm,
  u_common_graph_var, u_common_graph_const,
  u_common_graph_type, u_common_graph_func,
  u_objet_graph_TChantier,
  u_objet_graph_TViewer, u_objet_graph_TVue, u_form_rechercher, u_rm,
  u_form_main, u_common_const, u_common_func, u_common_var;

{$R *.DFM}


procedure TFGraphPaintBox.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  //     fFormOptions := nil;

  fPtrLabelZoom := nil;
  fPtrTrackBar := nil;



  //Curseurs de souris
 // Screen.Cursors[_CURHAND] := LoadCursor(HInstance, 'CURHAND');
 // Screen.Cursors[_CURPOPUP] := LoadCursor(HInstance, 'CURPOPUP');
 // Screen.Cursors[_CURSOR_ZOOM_MOINS] := LoadCursor(HInstance, 'ZOOM_MOINS');
 // Screen.Cursors[_CURSOR_ZOOM_PLUS] := LoadCursor(HInstance, 'ZOOM_PLUS');
 // Screen.Cursors[_CURSOR_MAIN] := LoadCursor(HInstance, 'MAIN');


  fFill := TState.create(false);
  //     fStartZoomingFromTrackBar := false;
  fZooming := false;

  //     fGraphMiniature := TFGraphMiniature.create(self);
end;

procedure TFGraphPaintBox.menu_QuitChantierClick(Sender: TObject);
begin
  Close;
end;





procedure TFGraphPaintBox.SuperFormShowFirstTime(Sender: TObject);
//var        p: tpoint;
begin
  //     Application.HintPause := 100;
  PtrTrackBar.Min := _ZOOM_MIN;
  PtrTrackBar.Max := _ZOOM_MAX;


  //Chargement du context
//  _Context.LoadFromFile;

  //Miniature
//   p.x := 0; p.y := 0;
  //     p := btnMiniature.clienttoscreen(p);
//     fGraphMiniature.Left := 0; //p.x; //- (fGraphMiniature.Width - btnMiniature.width);
//     fGraphMiniature.top := 0; //p.y + btnMiniature.Height + 4;
  //fGraphMiniature.top := p.y + +4;

  //Divers
  DoRefreshControls;

  //On montre la miniature ?
//     fGraphMiniature.visible := _Context.MiniatureOpened;
end;

procedure TFGraphPaintBox.btnSetMouseZoomMoreClick(Sender: TObject);
begin
  _Viewer.MouseMode := mmZoomMore;
end;

procedure TFGraphPaintBox.SuperFormDestroy(Sender: TObject);
begin
  //     fGraphMiniature.Free;
  fFill.Free;
end;


procedure TFGraphPaintBox.TrackBarZoomChange(Sender: TObject);
begin
  if fFill.Value = False then
    begin
      fFill.Value := True;
      try
        if fZooming = false then
          begin
            //On va zoomer avec comme point central, le centre du viewer
            fZoomOnX_Viewer := PaintBox.Width div 2;
            fZoomOnY_Viewer := PaintBox.Height div 2;

            //Le point correspondant, en coord chantier est :
            _Viewer.CoordViewer_To_CoordChantier(fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);
          end;

        fZooming := true;

        //Maintenant, on zoom, de faon  avoir, aprs l'opration, le point central du zoom plac au mme endroit
        _Viewer.ApplyZoomAtPoint2(PtrTrackBar.Position, fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);
        _Viewer.RefreshMiniature;

        //  TrackBarZoom.Position := _Viewer.Zoom;

      finally
        fFill.Value := false;
      end;
    end;
end;

(*
procedure TFMain.TrackBarZoomChange(Sender: TObject);
//var     k: integer;
begin
     if fFill.Value = False then
     begin
          fFill.Value := True;
          try
               if fZooming = false then
               begin
                    //On cherche les coordonnes du chantier, sur laquelle zoomer
                    {///////////////:
                    k := _Chantier.PieuList.IndexSelectedPieu;
                    if k <> -1 then
                    begin
                         //Le point correspondant, en coord chantier est :
                         fZoomOnX_Chantier := _Chantier.PieuList[k].XCCAtDepth;
                         fZoomOnY_Chantier := _Chantier.PieuList[k].YCCAtDepth;

                         //Quelles sont ces coordonnes dans le Viewer ?
                         _Viewer.CoordChantier_To_CoordViewer(fZoomOnX_Chantier, fZoomOnY_Chantier, fZoomOnX_Viewer, fZoomOnY_Viewer);

                         //Quelles sont ces coordonnes dans le PaintBox ?
                         fZoomOnX_Viewer := fZoomOnX_Viewer + _Viewer.DecalX;
                         fZoomOnY_Viewer := fZoomOnY_Viewer + _Viewer.DecalY;
                    end
                    else
                    }
                    begin
                         //On va zoomer avec comme point central, le centre du viewer
                         fZoomOnX_Viewer := PaintBox.Width div 2;
                         fZoomOnY_Viewer := PaintBox.Height div 2;

                         //Le point correspondant, en coord chantier est :
                         _Viewer.CoordViewer_To_CoordChantier(fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);
                    end;
               end;

               fZooming := true;

               //Maintenant, on zoom, de faon  avoir, aprs l'opration, le point central du zoom plac au mme endroit
               _Viewer.ApplyZoomAtPoint2(TrackBarZoom.Position, fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);
               _Viewer.RefreshMiniature;
               TrackBarZoom.Position := _Viewer.Zoom;

          finally
               fFill.Value := false;
          end;
     end;
end;
*)

procedure TFGraphPaintBox.OnZoomChanged(Sender: TObject);
begin
  //////////!!!!!!!!!!
 // TFGraphOptions(fFormOptions).fFill.Value := true;
  fFill.Value := true;
  try
    PtrLabelZoom.Caption := inttostr(_Viewer.Zoom) + ' %';

    PtrTrackBar.Position := _Viewer.Zoom;
    _Chantier.CurrentVueModified := true;
  finally
    fFill.Value := false;
    //    TFGraphOptions(fFormOptions).fFill.Value := false;
  end;

end;



procedure TFGraphPaintBox.CreateIntelligence;
begin
  fFill.Value := true;
  try
    //Cration de l'objet Chantier
    _Chantier := TChantier.Create;

    //Branchement du Graph
//          _Chantier.Graph := _MonGraph;
    _Chantier.Graph := fGraph;
    _Chantier.Graph.Prepare;

    //Cration de l'objet Viewer
    _Viewer := TViewer.create;

    //Branchements divers
    _Chantier.OnCurrentVueChanged := OnCurrentVueChanged;

    _Viewer.BeginUpdate;
    try
      _Viewer.Chantier := _Chantier;
      _Viewer.PaintBox := PaintBox;
      _Viewer.PanelPaintBox := PanelPaintBox;
      _Viewer.OnMouseMoveOnChantier := OnMouseMoveOnChantier;
      _Viewer.OnZoomChanged := OnZoomChanged;
      _Viewer.OnMouseMoveOnViewer := OnMouseMoveOnViewer;
      _Viewer.OnAfterApplyVue := OnAfterApplyVue;
      _Viewer.PaintBoxMiniature := fGraphMiniature.PaintBox;
      //   _Viewer.ShowHintOnPieu := _Context.ShowHintOnPieu;
         //               _Viewer.Echelle := _Context.Echelle;
      //   _Viewer.IncrementZoom := _Context.IncrementZoom;
      //   _Viewer.Font.Assign(_Context.Font);
      //   _Viewer.ColorBackground := _Context.ColorBackground;
      //   _Viewer.ColorPieuxSelected := _Context.ColorPieuxSelected;
      //   _Viewer.ColorPieux := _Context.ColorPieux;
      //   _Viewer.ColorPieuxOutOfDepth := _Context.ColorPieuxOutOfDepth;
      //   _Viewer.ColorPieuxTrace := _Context.ColorPieuxTrace;

    finally
      _Viewer.EndUpdate;
    end;


    //prparation de diffrents controls
//          TrackBarZoom.Min := _ZOOM_MIN;
//          TrackBarZoom.Max := _ZOOM_MAX;

//          btnVueIsModified.Visible := false;
  finally
    fFill.Value := false;
  end;
end;


procedure TFGraphPaintBox.SuperFormRefreshControls(Sender: TObject);
begin
  //     TFGraphOptions(fFormOptions).RefreshButtons(not (_Chantier = nil));

end;

procedure TFGraphPaintBox.DestroyIntelligence;
var
  fLastVue: TVue;
begin
  //Destruction de l'objet Chantier chantier
  if _Chantier <> nil then
    begin
      //On mmorise dans le chantier, la dernire vue utilise.
  //          if (cbVues.ItemIndex = -1) or (_Chantier.CurrentVueModified)
  //             then _Chantier.SaveToFile_LastVueUsed('')
  //       else _Chantier.SaveToFile_LastVueUsed(cbVues.Items[cbVues.ItemIndex]);

      //dernier chantier ouvert
  //          _Context.LastRelPathChantier := _Chantier.RelPathChantier;

      //quelques infos sur le viewer
      if _Viewer <> nil then
        begin
          //               _Context.ShowHintOnPieu := _Viewer.ShowHintOnPieu;
                         //               _Context.Echelle := _Viewer.Echelle;
            //             _Context.IncrementZoom := _Viewer.IncrementZoom;
             //            _Context.Font.Assign(_Viewer.Font);
              //           _Context.ColorBackground := _Viewer.ColorBackground;
              //           _Context.ColorPieuxSelected := _Viewer.ColorPieuxSelected;
                //         _Context.ColorPieux := _Viewer.ColorPieux;
                 //        _Context.ColorPieuxOutOfDepth := _Viewer.ColorPieuxOutOfDepth;
                  //       _Context.ColorPieuxTrace := _Viewer.ColorPieuxTrace;
        end;

      //On sauvegarde la vue actuelle, dans le fichier des vues
      fLastVue := TVue.create;
      try
        fLastVue.Name := _LAST_NAME_VUE;
        //        if fLastVue.FlashViewer(_Viewer) then fLastVue.SaveToFile('bbbbbbbbbb');
      finally
        fLastVue.Free;
      end;
    end;

  //Destruction de l'objet Viewer
  if _Viewer <> nil then
    begin
      FreeAndNil(_Viewer);
    end;


  if _Chantier <> nil then
    begin
      //Destruction
      FreeAndNil(_Chantier);
    end;

  PaintBox.Refresh;
  fGraphMiniature.PaintBox.Refresh;
  //     RefreshComboboxVueList('');

  DoRefreshControls;
end;


procedure TFGraphPaintBox.Supprimercettevue1Click(Sender: TObject);
begin
  //Quelle est la vue courante ?
  {
  if cbVues.ItemIndex <> -1 then
  begin
       if MyMessageDlg('Confirmez-vous la suppression de cette vue ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
       begin
            //Suppression
            _Chantier.VueList.DeleteByName(cbVues.Items[cbVues.ItemIndex], 'bbbbbbbb');

            //on rafrachit le combo de slection des vues
            RefreshComboboxVueList('');
       end;
  end;
  }
end;

procedure TFGraphPaintBox.OnCurrentVueChanged(Sender: TObject);
begin
  //     btnVueIsModified.visible := _Chantier.CurrentVueModified;
end;

procedure TFGraphPaintBox.OnMouseMoveOnViewer(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  //
end;

{
procedure TFMain.TrackBarZoomMouseUp(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer);
begin
     fZooming := false;
end;
}


procedure TFGraphPaintBox.SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  DestroyIntelligence;

  //     _Context.MiniatureOpened := fGraphMiniature.visible;

       //     _Context.SaveToFile;
end;

procedure TFGraphPaintBox.OnAfterApplyVue(Sender: TObject; Name: string);
begin
  //On position l'itemIndex du Combox sur la bonne ligne
  fFill.Value := True;
  try
    //          cbVues.ItemIndex := cbVues.Items.IndexOf(Name);
  finally
    fFill.Value := false;
  end;
end;

procedure TFGraphPaintBox.SuperFormResize(Sender: TObject);
begin
  if _Viewer <> nil then _Viewer.RefreshMiniature;
end;



procedure TFGraphPaintBox.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
//var     P, m: tpoint;
begin
  {
       if _Viewer <> nil then
            begin
                 if _Viewer.Moving = false then
                      begin
                           if Key = VK_ESCAPE then
                                begin
                                     //Annulation des boutons de zoom, si ils sont activs
                                     if TFGraphOptions(fFormOptions).btnSetMouseMoveOrSelect.Down = false then
                                          begin
                                               TFGraphOptions(fFormOptions).btnSetMouseMoveOrSelect.Down := true;
                                               _Viewer.MouseMode := mmMoveOrSelect;
                                          end;
                                end
                           else
                                begin
                                     m := mouse.CursorPos;
                                     p := PaintBox.ScreenToClient(m);

                                     if (p.x >= 0) and (p.x < PaintBox.width) and (p.y >= 0) and (p.y < PaintBox.height) then
                                          begin
                                               if (Shift = [ssCtrl]) then
                                                    begin
                                                         _Viewer.MouseMode := mmZoomMore;
                                                         TFGraphOptions(fFormOptions).btnSetMouseZoomMore.down := true;
                                                         //					plan.Cursor := _CURSOR_ZOOM_PLUS;
                                                         //					fMouseMode := _ZOOM_MORE_CHANTIER;
                                                    end
                                               else
                                                    if (Shift = [ssShift]) then
                                                         begin
                                                              _Viewer.MouseMode := mmZoomLess;
                                                              TFGraphOptions(fFormOptions).btnSetMouseZoomLess.down := true;
                                                              //					plan.Cursor := _CURSOR_ZOOM_MOINS;
                                                              //					fMouseMode := _ZOOM_LESS_CHANTIER;
                                                         end
                                                    else
                                                         begin
                                                              _Viewer.MouseMode := mmMoveOrSelect;
                                                              TFGraphOptions(fFormOptions).btnSetMouseMoveOrSelect.down := true;
                                                         end;

                                               Mouse.CursorPos := m;
                                          end;
                                end;
                      end;
            end;
            }
end;



procedure TFGraphPaintBox.SuperFormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
//var     P, m: tpoint;
begin
  {
       if _Viewer <> nil then
            begin
                 if _Viewer.Moving = false then
                      begin
                           m := mouse.CursorPos;
                           p := PaintBox.ScreenToClient(m);

                           if (p.x >= 0) and (p.x < PaintBox.width) and (p.y >= 0) and (p.y < PaintBox.height) then
                                begin
                                     _Viewer.MouseMode := mmMoveOrSelect;
                                     TFGraphOptions(fFormOptions).btnSetMouseMoveOrSelect.down := true;
                                     Mouse.CursorPos := m;
                                end;
                      end;
            end;
            }
end;



procedure TFGraphPaintBox.N111Click(Sender: TObject);
var
  //     k: integer;
  z: integer;
begin
  if fFill.Value = False then
    begin
      fFill.Value := True;
      try
        z := (Sender as TMenuItem).Tag;

        //On cherche les coordonnes du chantier, sur laquelle zoomer
        {////////////////
        k := _Chantier.PieuList.IndexSelectedPieu;
        if k <> -1 then
        begin
             //Le point correspondant, en coord chantier est :
             fZoomOnX_Chantier := _Chantier.PieuList[k].XCCAtDepth;
             fZoomOnY_Chantier := _Chantier.PieuList[k].YCCAtDepth;

             //Quelles sont ces coordonnes dans le Viewer ?
             _Viewer.CoordChantier_To_CoordViewer(fZoomOnX_Chantier, fZoomOnY_Chantier, fZoomOnX_Viewer, fZoomOnY_Viewer);

             //Quelles sont ces coordonnes dans le PaintBox ?
             fZoomOnX_Viewer := fZoomOnX_Viewer + _Viewer.DecalX;
             fZoomOnY_Viewer := fZoomOnY_Viewer + _Viewer.DecalY;
        end
        else
        }
        begin
          //On va zoomer avec comme point central, le centre du viewer
          fZoomOnX_Viewer := PaintBox.Width div 2;
          fZoomOnY_Viewer := PaintBox.Height div 2;

          //Le point correspondant, en coord chantier est :
          _Viewer.CoordViewer_To_CoordChantier(fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);
        end;

        //Maintenant, on zoom, de faon  avoir, aprs l'opration, le point central du zoom plac au mme endroit
        _Viewer.ApplyZoomAtPoint2(z, fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);
        _Viewer.RefreshMiniature;
        //               TrackBarZoom.Position := _Viewer.Zoom;

      finally
        fFill.Value := false;
      end;
    end;
end;



procedure TFGraphPaintBox.btnVueClick(Sender: TObject);
//var     p: tpoint;
begin
  //   p.x := 0; p.y := 0;
  //   p := btnVue.clienttoscreen(p);
  //   popupVue.popup(p.x, p.y + btnVue.height);
end;


procedure TFGraphPaintBox.cbVuesChange(Sender: TObject);
begin
  {
       if (fFill.Value = false) and (_Viewer <> nil) then
       begin
            //Slection d'une autre vue
            _Viewer.ApplyVue(cbVues.Items[cbVues.ItemIndex]);

            DoRefreshControls;
       end;
       }
end;

procedure TFGraphPaintBox.Vue_SaveExecute(Sender: TObject);
begin
  //Quelle est la vue courante ?
  {
  if cbVues.ItemIndex = -1 then Vue_SaveAsExecute(Sender)
  else
  begin
       if MyMessageDlg('Confirmez-vous la sauvegarde de cette vue ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
       begin
            doSaveVueCourante;
       end;
  end;
  }
end;

procedure TFGraphPaintBox.Vue_SaveAsExecute(Sender: TObject);
//r
//   aFAskNewNameVue: TFAskNewNameVue;
 //  aVue: TVue;
  // p: TPoint;
begin
  {
       aFAskNewNameVue := TFAskNewNameVue.create(self);
       try
            p.x := 0; p.y := 0;
            p := cbVues.clienttoscreen(p);
            aFAskNewNameVue.Left := p.x;
            aFAskNewNameVue.Top := p.y + cbVues.height + 1;
            aFAskNewNameVue.VueList := _Chantier.VueList;

            if aFAskNewNameVue.ShowModal = mrOk then
            begin
                 //On flash la vue
                 aVue := _Viewer.FlashVue(trim(aFAskNewNameVue.edNom.text));

                 //a c'est bien pass ?
                 if aVue <> nil then
                 begin
                      //On ajoute cette vue dans la liste
                      _Chantier.VueList.Add(aVue);

                      //Sauvegarde de la vue
                      _Chantier.VueList.SaveVueToFile(aVue, 'bbbbbbbbbb');

                      //on rafrachit le combo de slection des vues
                      RefreshComboboxVueList(trim(aFAskNewNameVue.edNom.text));

                      _Chantier.CurrentVueModified := false;
                 end;
            end;

       finally
            aFAskNewNameVue.Free;
       end;
       }
end;

procedure TFGraphPaintBox.OnMouseMoveOnChantier(Sender: TObject; X, Y: single);
begin
  {
       if _Chantier <> nil then
       begin
            if _Chantier.Graph <> nil
                 then StatusBar.Panels[0].Text := 'X : ' + SFloatN(X, 2) + ' m / Y : ' + SFloatN(Y, 2) + ' m' + '    dy=' + inttostr(_VIewer.DecalY)
            else StatusBar.Panels[0].Text := '';
       end
       else
            StatusBar.Panels[0].Text := '';
            }
end;


procedure TFGraphPaintBox.PlugGraph(aGraph: TGraph);
//var
//     fLastVue: TVue;
//     NoVue: boolean;
begin
  //On ferme le chantier prcdemment ouvert
  DestroyIntelligence;

  fGraph := aGraph;

  //On cr un objet chantier et on initialise les branchements (event, viewer, ...)
  CreateIntelligence;

  {
  NoVue := false;
  if _Chantier.VueList.IndexOfName(_Chantier.LastVueName) <> -1 then
  begin
       _Viewer.ApplyVue(_Chantier.LastVueName);
  end
  else
  begin
       //On rcupre la dernire vue utilise
       fLastVue := TVue.create;
       try
            fLastVue.Name := _LAST_NAME_VUE;
            if fLastVue.LoadFromFile(_LAST_NAME_VUE, 'aaaaaaaaaaaa')
                 then _Viewer.ApplyVue2(fLastVue)
            else NoVue := True;
       finally
            fLastVue.Free;
       end;
  end;
  }

  _Viewer.BuildZonesImpression;
  _Viewer.MouseMode := mmMoveOrSelect;
  _Chantier.CurrentVueModified := false;

  //Miniature
  _Viewer.BuildMiniature;

  SetZoomAll(nil);

  _Viewer.DecalX := 0;
  _Viewer.DecalY := 0;
  _Viewer.Refresh;
  _Viewer.RefreshMiniature;

  DoRefreshControls;
end;

procedure TFGraphPaintBox.SetZoom100(sender: TObject);
var
  //     k: integer;
  z: integer;
begin
  if fFill.Value = False then
    begin
      fFill.Value := True;
      try
        z := 100;

        //On va zoomer avec comme point central, le centre du viewer
        fZoomOnX_Viewer := PaintBox.Width div 2;
        fZoomOnY_Viewer := PaintBox.Height div 2;

        //Le point correspondant, en coord chantier est :
        _Viewer.CoordViewer_To_CoordChantier(fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);

        //Maintenant, on zoom, de faon  avoir, aprs l'opration, le point central du zoom plac au mme endroit
        _Viewer.ApplyZoomAtPoint2(z, fZoomOnX_Viewer, fZoomOnY_Viewer, fZoomOnX_Chantier, fZoomOnY_Chantier);
        _Viewer.RefreshMiniature;
        //               TrackBarZoom.Position := _Viewer.Zoom;

      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFGraphPaintBox.SetMoveMove(sender: TObject);
begin
  _Viewer.MouseMode := mmMoveOrSelect;
end;

procedure TFGraphPaintBox.SetModeZoomLess(sender: TObject);
begin
  _Viewer.MouseMode := mmZoomLess;
end;

procedure TFGraphPaintBox.SetModeZoomMore(sender: TObject);
begin
  _Viewer.MouseMode := mmZoomMore;
end;

procedure TFGraphPaintBox.SetZoomAll(sender: TObject);
begin
  _Viewer.ZoomAll;
end;

procedure TFGraphPaintBox.SetGraphOnTopLeft(sender: TObject);
begin
  _Viewer.DecalX := 0;
  _Viewer.DecalY := 0;
  _Viewer.Refresh;
  _Viewer.RefreshMiniature;
end;

procedure TFGraphPaintBox.SetShowMiniature;
begin
  //     fGraphMiniature.Show;
end;

procedure TFGraphPaintBox.UnplugGraph;
begin
  //On ferme le chantier prcdemment ouvert
  DestroyIntelligence;

  fGraph := nil;

  doRefreshControls;
end;

procedure TFGraphPaintBox.RefreshTout;
begin
  _Viewer.BeginUpdate;
  try
    fgraph.Load;
    fgraph.Prepare;

    _Viewer.BuildZonesImpression;
    _Viewer.BuildMiniature;
    _Viewer.PrepareGraph;

  finally
    _Viewer.EndUpdate;
  end;

  _Viewer.Refresh;
  _Viewer.RefreshMiniature;
end;

procedure TFGraphPaintBox.btnSelectIndiGraphClick(Sender: TObject);
var
  aFRechercher: TFRechercher;
  rep: integer;
begin
  aFRechercher := TFRechercher.create(self);
  try
    rep := aFRechercher.ShowModal;
    if rep = mrOk then
      begin
        doSelectOtherIndividu(aFRechercher.CleFicheSelected);
      end;
  finally
    aFRechercher.Free;
  end;
end;

procedure TFGraphPaintBox.doSelectOtherIndividu(CleIndi: integer);
begin
  if FMain.IDModuleActif = _ID_PRINT_ROUE then FMain.aGraphRoue.CleIndiDepart := CleIndi
  else
    if FMain.IDModuleActif = _ID_PRINT_ARBRE then FMain.aGraphArbre.CleIndiDepart := CleIndi;

  RefreshTout;
  btnRefresh.enabled := false;
end;


procedure TFGraphPaintBox.btnCfgGraphClick(Sender: TObject);
begin
  if FMain.IDModuleActif = _ID_PRINT_ROUE then FMain.aFConfigRoue.Show
  else
    if FMain.IDModuleActif = _ID_PRINT_ARBRE then FMain.aFConfigHierarchie.Show;
end;

procedure TFGraphPaintBox.edNbGenerationChange(Sender: TObject);
begin
  btnRefresh.enabled := true;
end;

procedure TFGraphPaintBox.btnRefreshClick(Sender: TObject);
begin
  if FMain.IDModuleActif = _ID_PRINT_ROUE then FMain.aGraphRoue.NbGeneration := edNbGeneration.IntValue
  else
    if FMain.IDModuleActif = _ID_PRINT_ARBRE then
      begin
        FMain.aGraphArbre.NbGeneration := edNbGeneration.IntValue;

        if sbDesc.Checked then
          FMain.aGraphArbre.Descendance := 1
        else
          FMain.aGraphArbre.Descendance := 0;
      end;

  RefreshTout;
  btnRefresh.enabled := false;
end;



procedure TFGraphPaintBox.btnPrintClick(Sender: TObject);
begin
  if Printer.Printers.Count = 0 then
    begin
      MyMessageDlg('Il n''y a aucune imprimante disponible.', mtError, [mbOK], 0);
    end
  else
    begin
      if FMain.IDModuleActif = _ID_PRINT_ROUE then rm.Print(FMain.aGraphRoue)
      else
        if FMain.IDModuleActif = _ID_PRINT_ARBRE then rm.Print(FMain.aGraphArbre);
    end;
end;

procedure TFGraphPaintBox.btnPrinterSetupClick(Sender: TObject);
begin
  rm.PrinterSetup;
  //  if fIDModuleActif = _ID_PRINT_ARBRE then aGraphArbre.PrinterSetup;
  {
  _Viewer.PageWidth := round(rm.rp.PageWidth - (_Context.MargeLeftPrinter + _Context.MargeRightPrinter));
  _Viewer.PageHeight := round(rm.rp.PageHeight - (_Context.MargeTopPrinter + _Context.MargeBottomPrinter));

 _Viewer. BuildZonesImpression;
 _Viewer.Refresh;
 _Viewer.RefreshMiniature;
 }


            //on rafraichit le graph
  _Viewer.BeginUpdate;
  try
    _Viewer.PageWidth := round(rm.rp.PageWidth - (_Context.MargeLeftPrinter + _Context.MargeRightPrinter));
    _Viewer.PageHeight := round(rm.rp.PageHeight - (_Context.MargeTopPrinter + _Context.MargeBottomPrinter));

    fGraph.Prepare;

    _Viewer.BuildZonesImpression;
    _Viewer.BuildMiniature;
    _Viewer.PrepareGraph;
  finally
    _Viewer.EndUpdate;
  end;

  _Viewer.Refresh;
  _Viewer.RefreshMiniature;

end;

procedure TFGraphPaintBox.NakedSpeedButton1Click(Sender: TObject);
begin
  SetGraphOnTopLeft(self);
end;

procedure TFGraphPaintBox.popupPopup(Sender: TObject);
var
  k: integer;
  p: TPoint;
begin
  k := -1;
  p := PaintBox.ScreenToClient(TMyPopupMenu(popup).PopupPoint);

  if fGraph <> nil then k := fGraph.GetCleIndividuAtXY(p.X, p.Y);

  popup_VoirLaFicheInBox.visible := k <> -1;
  popup_VoirLaFicheInBox.tag := k;
end;

procedure TFGraphPaintBox.popup_VoirLaFicheInBoxClick(Sender: TObject);
begin
  OpenFicheIndividuInBox(TMenuItem(Sender).Tag);
end;

procedure TFGraphPaintBox.Imprimercettepage1Click(Sender: TObject);
var
  P: TPoint;
  kx, ky, nx, ny: integer;
begin
  P := PaintBox.ScreenToClient(TMyPopupMenu(popup).PopupPoint);
  kx := -1;
  ky := -1;

  P.x := P.x - _Viewer.DecalX;
  P.y := P.y - _Viewer.DecalY;

  for ny := 1 to _Viewer.TPYV.count - 1 do
    begin
      for nx := 1 to _Viewer.TPXV.count - 1 do
        begin
          if (P.x >= _Viewer.TPXV[nx - 1]) and (P.y >= _Viewer.TPYV[ny - 1]) and
            (P.x <= _Viewer.TPXV[nx]) and (P.y <= _Viewer.TPYV[ny]) then
            begin
              kx := nx - 1;
              ky := ny - 1;
              break;
            end;
        end;
    end;

  if (kx <> -1) and (ky <> -1) then
    begin
      if Printer.Printers.Count = 0 then
        begin
          MyMessageDlg('Il n''y a aucune imprimante disponible.', mtError, [mbOK], 0);
        end
      else
        begin
          //On imprime juste la page
          if FMain.IDModuleActif = _ID_PRINT_ROUE then rm.PrintPage(FMain.aGraphRoue, kx, ky)
          else
            if FMain.IDModuleActif = _ID_PRINT_ARBRE then rm.PrintPage(FMain.aGraphArbre, kx, ky);
        end;
    end;
end;

procedure TFGraphPaintBox.sbDescClick(Sender: TObject);
begin
  btnRefresh.enabled := true;
end;

end.
