{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_graph_TChantier;

interface

uses
  Classes,
  Controls,
  Dialogs,
  inifiles,
  u_objet_graph_TGraph,
  u_objet_graph_TVue,
  u_objet_graph_TVueList;

type
  TChantier = class

  private
    fVueList: TVueList;
    fCurrentVueModified: boolean;
    fOnCurrentVueChanged: TNotifyEvent;
    fLastVueName: string;
    fGraph: TGraph;

    procedure SetCurrentVueModified(const Value: boolean);

  public
    constructor Create;
    destructor Destroy; override;
    procedure Init;


    procedure SaveToFile_LastVueUsed(Name: string);

    //Le graph
    property Graph: TGraph read fGraph write fGraph;

    //Les vues du chantier
    property VueList: TVueList read fVueList write fVueList;


    //Flag d'indication que la vue courrante est modififie
    property CurrentVueModified: boolean read fCurrentVueModified write SetCurrentVueModified;
    property OnCurrentVueChanged: TNotifyEvent read fOnCurrentVueChanged write fOnCurrentVueChanged;

    //Le nom de la dernire vue utilis
    property LastVueName: string read fLastVueName;
  end;


implementation

uses
  u_common_graph_var,
  u_common_graph_func,
  u_common_graph_const,
  SysUtils;


constructor TChantier.Create;
begin
  //     fGraph := TGraph.Create;
  fVueList := TVueList.create;
  fOnCurrentVueChanged := nil;
  Init;
end;


destructor TChantier.Destroy;
begin
  //     fGraph.Free;
  fVueList.Free;

  inherited;
end;


procedure TChantier.Init;
begin
  CurrentVueModified := false;
  fLastVueName := '';
end;






procedure TChantier.SetCurrentVueModified(const Value: boolean);
begin
  fCurrentVueModified := Value;
  if assigned(fOnCurrentVueChanged) then fOnCurrentVueChanged(self);
end;


procedure TChantier.SaveToFile_LastVueUsed(Name: string);
var
  fIni: TIniFile;
begin
  /////////////
  fIni := TIniFile.Create('d:\aaaaaa.ini');
  try
    try
      fIni.WriteString('General', 'NameLastVue', Name);

      fIni.UpdateFile;
    except
    end;
  finally
    fIni.Free;
  end;
end;





end.
