{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_graph_TViewer;

interface

uses
  classes,
  controls,
  extctrls,
  windows,
  dialogs,
  forms,
  u_common_graph_type,
  u_common_graph_const,
  u_objet_graph_TChantier,
  u_objet_TState,
  u_objet_graph_TVue,
  u_objet_TSingleList,
  u_objet_TIntegerList,
  Graphics;


type

  TViewer = class

  private
    fPaintBox: TPaintBox;
    fCanDraw: TState;
    fCanDrawMiniature: TState;
    fZoom: integer;
    fChantier: TChantier;
    fColorBackground: TColor;
    fColorPieuxSelected: TColor;
    fColorPieuxTrace: TColor;
    fColorPieuxOutOfDepth: TColor;
    fColorPieux: TColor;
    //          fEchelle: integer;
    fDecalY: integer;
    fDecalX: integer;
    fMoving: boolean;
    fStartPos: TPoint;
    fActualPos: TPoint;
    fInitialDecal: TPoint;
    fMouseMode: TMouseMode;
    fOnMouseMoveOnChantier: TMouseMoveOnChantierEvent;
    fOnZoomChanged: TNotifyEvent;

    fLastIdxPieuOfHint: integer;
    fOnMouseMoveOnViewer: TMouseMoveEvent;
    fOnAfterApplyVue: TEventApplyVue;

    //Miniature
    fPaintBoxMiniature: TPaintBox;
    fZoomMiniature: single;
    fDecalMiniatureX: integer;
    fDecalMiniatureY: integer;
    fMovingOnMiniature: boolean;
    fPanelPaintBox: TPanel;
    fShowHintOnPieu: boolean;
    fIncrementZoom: integer;
    fFont: TFont;
    fPageHeight: single;
    fPageWidth: single;


    //les lignes du papier
    fTPXC, fTPYC: TSingleList;
    fTPXV, fTPYV: TIntegerList;





    procedure OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OnMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure OnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OnPaint(Sender: TObject);
    procedure OnPaintMiniature(Sender: TObject);
    procedure SetPaintBox(const Value: TPaintBox);
    procedure SetChantier(const Value: TChantier);
    //          procedure SetEchelle(const Value: integer);
    procedure ZoomMoreAtPoint(x, y: integer);
    procedure ZoomLessAtPoint(x, y: integer);
    procedure SetZoom(const Value: integer);
    procedure CallZoomChanged;
    //          procedure doPreparePieu(aPieu: TPieu; coef: single);
    procedure SetMouseMode(const Value: TMouseMode);
    procedure SetPaintBoxMiniature(const Value: TPaintBox);
    procedure SetColorBackground(const Value: TColor);
    procedure SetShowHintOnPieu(const Value: boolean);




  public

    //le composant d'affichage
    property PaintBox: TPaintBox read fPaintBox write SetPaintBox;
    property PanelPaintBox: TPanel read fPanelPaintBox write fPanelPaintBox;

    //Le chantier
    property Chantier: TChantier read fChantier write SetChantier;

    //Divers proprites du viewer
    property Zoom: integer read fZoom write SetZoom;
    property ColorBackground: TColor read fColorBackground write SetColorBackground;
    property ColorPieuxSelected: TColor read fColorPieuxSelected write fColorPieuxSelected;
    property ColorPieux: TColor read fColorPieux write fColorPieux;
    property ColorPieuxOutOfDepth: TColor read fColorPieuxOutOfDepth write fColorPieuxOutOfDepth;
    property ColorPieuxTrace: TColor read fColorPieuxTrace write fColorPieuxTrace;

    property ShowHintOnPieu: boolean read fShowHintOnPieu write SetShowHintOnPieu;
    property IncrementZoom: integer read fIncrementZoom write fIncrementZoom;
    property Font: TFont read fFont write fFont;


    //Echelle : 20 pixels pour 1 m rel sur le chantier,  Zoom=100%
   // property Echelle: integer read fEchelle write SetEchelle;

    //Mode d'utilisation de la souris
    property MouseMode: TMouseMode read fMouseMode write SetMouseMode;

    property DecalX: integer read fDecalX write fDecalX;
    property DecalY: integer read fDecalY write fDecalY;

    property DecalMiniatureX: integer read fDecalMiniatureX;
    property Moving: boolean read fMoving;

    property OnMouseMoveOnChantier: TMouseMoveOnChantierEvent read fOnMouseMoveOnChantier write fOnMouseMoveOnChantier;
    property OnMouseMoveOnViewer: TMouseMoveEvent read fOnMouseMoveOnViewer write fOnMouseMoveOnViewer;
    property OnZoomChanged: TNotifyEvent read fOnZoomChanged write fOnZoomChanged;
    property OnAfterApplyVue: TEventApplyVue read fOnAfterApplyVue write fOnAfterApplyVue;


    //Proprits de gestion du plan miniature
    property PaintBoxMiniature: TPaintBox read fPaintBoxMiniature write SetPaintBoxMiniature;



    //proprits du papier : zone imprimable en mm
    property PageWidth: single read fPageWidth write fPageWidth;
    property PageHeight: single read fPageHeight write fPageHeight;

    //les ligne en pointills
    property TPXC: TSingleList read fTPXC write fTPXC;
    property TPYC: TSingleList read fTPYC write fTPYC;
    property TPXV: TIntegerList read fTPXV write fTPXV;
    property TPYV: TIntegerList read fTPYV write fTPYV;


    //pour les marges, c'est dans l'objet TContext
    {
rp.MarginLeft := _Context.MargeLeftPrinter;
rp.MarginTop := _Context.MargeTopPrinter;
rp.MarginRight := _Context.MargeRightPrinter;
rp.MarginBottom := _Context.MargeBottomPrinter;
}


    constructor Create;
    destructor Destroy; override;
    procedure Init;

    //avant de changer un group de proprits
    procedure BeginUpdate;
    procedure EndUpdate;

    procedure Refresh;


    //mthodes de zoom (sinon, Zoom:=.., simplement)
    procedure ZoomAll;
    procedure ApplyZoomAtPoint(aZoom, x, y: integer);
    procedure ApplyZoomAtPoint2(aZoom, xv, yv: integer; xc, yc: single);

    //Lance le calcul de la position des pieux dans le viewer, selon Zoom (avant dcallage)
    procedure PrepareGraph;
    //          procedure PrepareOnePieu(aPieu: TPieu);

    procedure CentreChantier;


    procedure CoordChantier_To_CoordViewer(xc, yc: single; var xv, yv: integer);
    procedure CoordViewer_To_CoordChantier(xv, yv: integer; var xc, yc: single);


    //          function GetIndexPieuUnderMouse(XViewer, YViewer: integer): integer;

    function FlashVue(NameVue: string): TVue;
    procedure ApplyVue(NameVue: string);
    procedure ApplyVue2(aVue: TVue);

    //zones d'impression
    procedure BuildZonesImpression;



    //Pour la miniature
    procedure BuildMiniature;
    procedure RefreshMiniature;
    property MovingOnMiniature: boolean read fMovingOnMiniature write fMovingOnMiniature;
    procedure CoordChantier_To_CoordViewerMiniature(xc, yc: single; var xv, yv: integer);
    procedure CoordViewerMiniature_To_CoordChantier(xv, yv: integer; var xc, yc: single);
    property ZoomMiniature: single read fZoomMiniature;
  end;

implementation

uses
  SysUtils, u_rm, u_common_var;

{ TViewer }


procedure TViewer.BeginUpdate;
begin
  fCanDraw.Value := false;
  fCanDrawMiniature.Value := false;
end;

procedure TViewer.EndUpdate;
begin
  fCanDraw.Value := true;
  fCanDrawMiniature.Value := true;
end;


constructor TViewer.Create;
begin
  fPaintBox := nil;
  fPanelPaintBox := nil;
  fPaintBoxMiniature := nil;
  fCanDraw := TState.Create(true);
  fCanDrawMiniature := TState.create(true);
  fMoving := false;
  fMouseMode := mmMoveOrSelect;
  fOnMouseMoveOnChantier := nil;
  fOnZoomChanged := nil;
  fOnMouseMoveOnViewer := nil;
  fOnAfterApplyVue := nil;
  fFont := TFont.Create;
  fTPXC := TSingleList.create;
  fTPYC := TSingleList.create;
  fTPXV := TIntegerList.create;
  fTPYV := TIntegerList.create;
  Init;
end;


procedure TViewer.Init;
begin
  fZoom := 100;
  fZoomMiniature := 100;
  fDecalY := 0;
  fDecalX := 0;

  fShowHintOnPieu := true;
  //     fEchelle := 20;
  fIncrementZoom := 20;

  fColorBackground := clWhite;
  fColorPieuxSelected := clYellow;
  fColorPieuxTrace := clBlue;
  fColorPieuxOutOfDepth := clGreen;
  fColorPieux := clRed;

  fLastIdxPieuOfHint := -1;
  fMovingOnMiniature := false;

  //en mm
  fPageWidth := round(rm.rp.PageWidth - (_Context.MargeLeftPrinter + _Context.MargeRightPrinter));
  fPageHeight := round(rm.rp.PageHeight - (_Context.MargeTopPrinter + _Context.MargeBottomPrinter));

  CallZoomChanged;
end;


destructor TViewer.Destroy;
begin
  BeginUpdate;
  //     BeginUpdateMiniature;
  PaintBox := nil;
  fPanelPaintBox := nil;
  PaintBoxMiniature := nil;
  Chantier := nil;
  fCanDraw.Free;
  fCanDrawMiniature.Free;
  fFont.Free;
  fTPXC.free;
  fTPYC.free;
  fTPXV.free;
  fTPYV.free;


  inherited;
end;


procedure TViewer.OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (fCanDraw.Value) and (fPaintBox <> nil) then
    begin
      case fMouseMode of

        mmMoveOrSelect:
          begin
            //Soit on bouge
            if (Shift = [ssLeft]) then
              begin
                fMoving := true;
                fStartPos.x := x;
                fStartPos.y := y;
                fActualPos.x := x;
                fActualPos.y := y;

                fInitialDecal.x := fDecalX;
                fInitialDecal.y := fDecalY;

                RefreshMiniature;
              end
                //soit on slectionne
            else
              if (Shift = [ssLeft, ssDouble]) then
                begin
                  {////////////////////
                  k := GetIndexPieuUnderMouse(X, Y);
                  fChantier.PieuList.SelectPieu(k);
                  fChantier.CurrentVueModified := true;
                  if k <> -1 then
                  begin


                  end;
                  }
                  Refresh;
                end
              else
                if (Shift = [ssRight]) then
                  begin
                    // ShowMessage(inttostr(fDecalX) + '  ;  ' + inttostr(fDecalY));
                  end;
          end;


        mmZoomMore:
          begin
            if (ssLeft in Shift) then ZoomMoreAtPoint(X, Y);
          end;

        mmZoomLess:
          begin
            if (ssLeft in Shift) then ZoomLessAtPoint(X, Y);
          end;
      end;
    end;
end;

procedure TViewer.OnMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  XC, YC: single;
begin
  if assigned(fOnMouseMoveOnViewer) then fOnMouseMoveOnViewer(sender, Shift, X, Y);

  if (ssLeft in Shift) and (fMoving) then
    begin
      //on recalcul le dcalage
     // fdx := fDecalX;
     // fdy := fDecalY;

      fDecalX := (x - fStartPos.x) + fInitialDecal.x;
      fDecalY := (y - fStartPos.y) + fInitialDecal.y;
      fMoving := true;

      // if fDecalX > 0 then fDecalX := 0;
      // if fDecalY > 0 then fDecalY := 0;

       // if (fdx <> fDecalX) or (fdy <> fDecalY) then
       // begin
      fChantier.CurrentVueModified := true;
      Refresh;
      RefreshMiniature;
      // end;
    end
  else
    //maj du Hint
    begin
      //On recherche le Pieu sous la souris
      if fShowHintOnPieu then
        begin
          {/////////////////
               k := GetIndexPieuUnderMouse(X, Y);
               if k <> -1 then
               begin
                    aPieu := fChantier.PieuList[k];
                    if (aPieu.enabled) and (aPieu.visible) and (aPieu.KnowPositionInChantier) then
                    begin
                         fPaintBox.Hint := fChantier.PieuList[k].GetHint;
                         if (k <> fLastIdxPieuOfHint) then Application.ActivateHint(point(x, y));
                    end
                    else
                         fPaintBox.Hint := '';
               end
               else
               begin
                    fPaintBox.Hint := '';
                    //			Application.CancelHint;
               end;

               }
          fLastIdxPieuOfHint := -1;

        end;
    end;

  if assigned(fOnMouseMoveOnChantier) then
    begin
      CoordViewer_To_CoordChantier(X, Y, XC, YC);
      fOnMouseMoveOnChantier(self, XC, YC);
    end;
end;

procedure TViewer.OnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if fMoving then
    begin
      fMoving := false;
      Refresh;
      RefreshMiniature;
    end;

  fMoving := false;
end;

procedure TViewer.OnPaint(Sender: TObject);
var
  n: integer;
begin
  if (fCanDraw.Value) and (fPaintBox <> nil) then
    begin
      //on dessine les traits des feuilles de papier
      if (fTPXV.Count > 1) and (fTPYV.Count > 1) then
        begin
          fPaintBox.Canvas.Pen.Color := $00696969;
          fPaintBox.Canvas.Pen.Style := psDot;


          for n := 0 to fTPXV.count - 1 do
            begin
              fPaintBox.Canvas.MoveTo(fTPXV[n] + DecalX, fTPYV[0] + DecalY);
              fPaintBox.Canvas.LineTo(fTPXV[n] + DecalX, fTPYV.Last + DecalY);
            end;
          for n := 0 to fTPYV.count - 1 do
            begin
              fPaintBox.Canvas.MoveTo(fTPXV[0] + DecalX, fTPYV[n] + DecalY);
              fPaintBox.Canvas.LineTo(fTPXV.last + DecalX, fTPYV[n] + DecalY);
            end;
        end;

      //on apple la procdure de dessin du graph
      fChantier.Graph.Paint(fPaintBox, fDecalX, fDecalY);
    end;
end;

procedure TViewer.Refresh;
begin
  if fPaintBox <> nil then fPaintBox.Refresh;
end;

procedure TViewer.SetChantier(const Value: TChantier);
begin
  fChantier := Value;
end;

procedure TViewer.SetPaintBox(const Value: TPaintBox);
begin
  BeginUpdate;
  try
    //dcrochage
    if (fPaintBox <> nil) then
      begin
        fPaintBox.OnMouseDown := nil;
        fPaintBox.OnMouseMove := nil;
        fPaintBox.OnMouseUp := nil;
        fPaintBox.OnPaint := nil;
      end;

    fPaintBox := Value;

    //branchement des vnements
    if Value <> nil then
      begin
        fPaintBox.OnMouseDown := OnMouseDown;
        fPaintBox.OnMouseMove := OnMouseMove;
        fPaintBox.OnMouseUp := OnMouseUp;
        fPaintBox.OnPaint := OnPaint;
      end;

  finally
    EndUpdate;
  end;
end;

procedure TViewer.SetZoom(const Value: integer);
begin
  //la valeur du nouveau Zoom est-elle correcte ?
  if (Value >= _ZOOM_MIN) and (Value <= _ZOOM_MAX) then
    begin
      if fPaintBox <> nil then
        begin
          if fChantier <> nil then
            begin
              {/////////////////
                  k := fChantier.PieuList.IndexSelectedPieu;
                  if k <> -1 then
                  begin
                       //On recherche la position du centre du pieu
                       ApplyZoomAtPoint(Value, fChantier.PieuList[k].XCVAtDepth + fDecalX, fChantier.PieuList[k].YCVAtDepth + fDecalY);
                  end
                  else
                       ApplyZoomAtPoint(Value, fPaintBox.Width div 2, fPaintBox.Height div 2);
                  }
              ApplyZoomAtPoint(Value, fPaintBox.Width div 2, fPaintBox.Height div 2);
            end;
        end;
    end;
end;

procedure TViewer.ZoomAll;
var
  Ok: boolean;
  //     R: TRect;
  R: TFloatRect;
  //     aPieu: TPieu;
  wc, hc: single;
  //     coefx, coefy, coef: single;
  fZoomW, fZoomH: single;
begin
  if (fPaintBox <> nil) then
    begin
      if (fPaintBox.Width > 0) and (fPaintBox.Height > 0) then
        begin
          BeginUpdate;
          try
            //On encadre les coordonnes chantiers des pieux
            Ok := fChantier.Graph.GetRectEncadrement(R);

            //Si on a russi  encadrer les pieux
            if Ok then
              begin
                //On ajoute une bordure au rectangle de dlimitaion, pour ne pas avoir des pieux colls sur les cts
                //R.Left := R.Left - _ADD_MARGE_WIDTH;
                //R.Right := R.Right + _ADD_MARGE_WIDTH;
                //R.Top := R.Top + _ADD_MARGE_WIDTH;
                //R.Bottom := R.Bottom - _ADD_MARGE_WIDTH;

                wc := R.Right - R.Left; //en m
                hc := R.Bottom - R.Top; //en m

                if (wc > 0) and (hc > 0) then
                  begin
                    //   fZoomW := ((fPaintBox.Width * 100) / (fEchelle * wc));
                   // fZoomW := (fEchelle * wc) / (fPaintBox.Width);
                    fZoomW := ((fPaintBox.Width * 100) / (wc * 72 / 25.4));
                    //   fZoomH := ((fPaintBox.Height * 100) / (fEchelle * hc));
                   // fZoomH := (fEchelle * hc) / (fPaintBox.Height);
                    fZoomH := ((fPaintBox.Height * 100) / (hc * 72 / 25.4));

                    // if fZoomW > fZoomH then fZoom := trunc(fZoomW - 1) else fZoom := trunc(fZoomH - 1);
                       // if fZoomW < fZoomH then fZoom := trunc(fZoomW - 1) else fZoom := trunc(fZoomH - 1);
        //                              if fZoomW < fZoomH then fZoom := trunc(fZoomH - 1) else fZoom := trunc(fZoomW - 1);

                    if fZoomW > fZoomH then fZoom := trunc(fZoomH - 1) else fZoom := trunc(fZoomW - 1);


                    if fZoom < _ZOOM_MIN then fZoom := _ZOOM_MIN;
                    if fZoom > _ZOOM_MAX then fZoom := _ZOOM_MAX;


                    CallZoomChanged;

                    //On centre tout a
                    CentreChantier;

                    fChantier.CurrentVueModified := true;
                  end;
              end;

          finally
            EndUpdate;
          end;

          if Ok then
            begin
              PrepareGraph;
              Refresh;
              RefreshMiniature;
            end;
        end;
    end;
end;

procedure TViewer.PrepareGraph;
var
  e: single;
  n: integer;
begin
  //Calcul des coord de tous les pieux, dans le Viewer
//  e := fEchelle / fZoom;
  e := (fZoom * 72) / (100 * 25.4);
  fChantier.Graph.CoordChantier_2_CoordViewer(e);

  for n := 0 to fTPXC.count - 1 do
    begin
      fTPXV[n] := trunc(fTPXC[n] * e);
    end;
  for n := 0 to fTPYC.count - 1 do
    begin
      fTPYV[n] := trunc(fTPYC[n] * e);
    end;
end;

{
procedure TViewer.PrepareOnePieu(aPieu: TPieu);
var
     e: single;
begin
     //Calcul des coord du pieu, dans le Viewer
     e := fEchelle / fZoom;
     doPreparePieu(aPieu, e);
end;


procedure TViewer.doPreparePieu(aPieu: TPieu; coef: single);
begin
     if aPieu.enabled then
     begin
          if aPieu.KnowPositionInChantier then
          begin
               //Coordonnes du centre
               aPieu.XCVAtDepth := round(coef * aPieu.XCCAtDepth);
               aPieu.YCVAtDepth := -round(coef * aPieu.YCCAtDepth);


               //Coordonnes des 4 points du pieu
               aPieu.RectV.P1.x := round(coef * aPieu.RectC.P1.x);
               aPieu.RectV.P2.x := round(coef * aPieu.RectC.P2.x);
               aPieu.RectV.P3.x := round(coef * aPieu.RectC.P3.x);
               aPieu.RectV.P4.x := round(coef * aPieu.RectC.P4.x);

               aPieu.RectV.P1.y := -round(coef * aPieu.RectC.P1.y);
               aPieu.RectV.P2.y := -round(coef * aPieu.RectC.P2.y);
               aPieu.RectV.P3.y := -round(coef * aPieu.RectC.P3.y);
               aPieu.RectV.P4.y := -round(coef * aPieu.RectC.P4.y);


               //Coordonnes du rectangle d'encadrement
               aPieu.REncadreV.Left := round(coef * aPieu.REncadreC.Left);
               aPieu.REncadreV.Right := round(coef * aPieu.REncadreC.Right);
               aPieu.REncadreV.Top := -round(coef * aPieu.REncadreC.Top);
               aPieu.REncadreV.Bottom := -round(coef * aPieu.REncadreC.Bottom);


               //Coordonnes des 4 points du pieu,  CteNGF
               aPieu.RectVAtCoteNGF.P1.x := round(coef * aPieu.RectCAtCoteNGF.P1.x);
               aPieu.RectVAtCoteNGF.P2.x := round(coef * aPieu.RectCAtCoteNGF.P2.x);
               aPieu.RectVAtCoteNGF.P3.x := round(coef * aPieu.RectCAtCoteNGF.P3.x);
               aPieu.RectVAtCoteNGF.P4.x := round(coef * aPieu.RectCAtCoteNGF.P4.x);

               aPieu.RectVAtCoteNGF.P1.y := -round(coef * aPieu.RectCAtCoteNGF.P1.y);
               aPieu.RectVAtCoteNGF.P2.y := -round(coef * aPieu.RectCAtCoteNGF.P2.y);
               aPieu.RectVAtCoteNGF.P3.y := -round(coef * aPieu.RectCAtCoteNGF.P3.y);
               aPieu.RectVAtCoteNGF.P4.y := -round(coef * aPieu.RectCAtCoteNGF.P4.y);
          end;
     end;
end;
 }

 {
procedure TViewer.SetEchelle(const Value: integer);
begin
     BeginUpdate;
     try
          fEchelle := Value;
          fChantier.CurrentVueModified := true;
     finally
          EndUpdate;
     end;

     Refresh;
     RefreshMiniature;
end;
}

//but : avant d'appliquer le zoom, on cherche les coord du chantier qui correspondent  (x;y)=coord sur le viewer
//on zoom, puis, on replace les coord chantier exactement sur (x,y) du viewer
//C'est pour zoomer, avec centre du zoom l o on clique

procedure TViewer.ApplyZoomAtPoint(aZoom, x, y: integer);
var
  NewX, NewY: integer;
  XChant, YChant: single;
begin
  BeginUpdate;
  try
    //Quelles sont les coord du point sur lequel on a click, dans le chantier ?
    CoordViewer_To_CoordChantier(x, y, XChant, YChant);

    //on vrifie que le Zoom est correct
    if aZoom < _ZOOM_MIN then aZoom := _ZOOM_MIN;
    if aZoom > _ZOOM_MAX then aZoom := _ZOOM_MAX;

    fZoom := aZoom;

    CallZoomChanged;

    //On recalcul tout, avec le nouveau Zoom
    PrepareGraph;

    CoordChantier_To_CoordViewer(XChant, YChant, NewX, NewY);

    fDecalX := (x - NewX);
    fDecalY := (y - NewY);

    //          if fDecalX > 0 then fDecalX := 0;
    //          if fDecalY > 0 then fDecalY := 0;

    fChantier.CurrentVueModified := true;

  finally
    EndUpdate;
  end;

  Refresh;
  RefreshMiniature;
end;

//but : on applique le zoom,
//puis on fait correspondre (xc,yc) coord chantier, sur le pixel (xv,yv) du viewer

procedure TViewer.ApplyZoomAtPoint2(aZoom, xv, yv: integer; xc, yc: single);
var
  NewX, NewY: integer;
  //     XChant, YChant: single;
begin
  BeginUpdate;
  try
    //on vrifie que le Zoom est correct
    if aZoom < _ZOOM_MIN then aZoom := _ZOOM_MIN;
    if aZoom > _ZOOM_MAX then aZoom := _ZOOM_MAX;

    fZoom := aZoom;

    CallZoomChanged;

    //On recalcul tout, avec le nouveau Zoom
    PrepareGraph;

    CoordChantier_To_CoordViewer(xc, yc, NewX, NewY);

    fDecalX := (xv - NewX);
    fDecalY := (yv - NewY);

    //          if fDecalX > 0 then fDecalX := 0;
    //          if fDecalY > 0 then fDecalY := 0;

    fChantier.CurrentVueModified := true;

  finally
    EndUpdate;
  end;

  Refresh;
  RefreshMiniature;
end;


procedure TViewer.ZoomLessAtPoint(x, y: integer);
var
  value: integer;

  function DecreasePourcent(var P: integer): boolean;
  var
    a: integer;
  begin
    result := false;

    //On rduit de xx en xx, avec un min de yy

    a := ((P div fIncrementZoom)) * fIncrementZoom;
    if a = P then a := P - fIncrementZoom;
    if a < _ZOOM_MIN then a := _ZOOM_MIN;

    if a <> p then
      begin
        p := a;
        result := true;
      end;
  end;

begin
  Value := fZoom;
  if DecreasePourcent(Value) then ApplyZoomAtPoint(Value, x, y);
end;


procedure TViewer.ZoomMoreAtPoint(x, y: integer);
var
  value: integer;

  function IncreasePourcent(var P: integer): boolean;
  var
    a: integer;
  begin
    result := false;

    //On avance de xx en xx, avec un max de yy
    a := ((P div fIncrementZoom) + 1) * fIncrementZoom;
    if a > _ZOOM_MAX then a := _ZOOM_MAX;

    if a <> p then
      begin
        p := a;
        result := true;
      end;
  end;

begin
  Value := fZoom;
  if IncreasePourcent(Value) then ApplyZoomAtPoint(Value, x, y);
end;


procedure TViewer.CoordViewer_To_CoordChantier(xv, yv: integer; var xc, yc: single);
var
  e: single;
begin
  //    e := fEchelle * fZoom / 100;
//     e := fEchelle / fZoom;
  e := (fZoom * 72) / (100 * 25.4);
  xc := (xv - fDecalX) / e;
  yc := (yv - fDecalY) / e;
end;


procedure TViewer.CoordChantier_To_CoordViewer(xc, yc: single; var xv, yv: integer);
var
  e: single;
begin
  //     e := fEchelle / fZoom;
  e := (fZoom * 72) / (100 * 25.4);
  //     xv := trunc(xc * e) + fDecalX;
      //     yv := -trunc(yc * e) + fDecalY;
  xv := trunc(xc * e);
  yv := trunc(yc * e);
end;




procedure TViewer.CentreChantier;
var
  Ok: boolean;
  R: TFloatRect;
  pcx, pcy: single;
  x, y: integer;
  //     aPieu: TPieu;
begin
  //On calcul DecalX et DecalY, de faon  centrer le forage dans le viewer
//     Ok := false;

  if (fPaintBox <> nil) then
    begin
      if (fPaintBox.Width > 0) and (fPaintBox.Height > 0) then
        begin
          Ok := fChantier.Graph.GetRectEncadrement(R);


          if Ok then
            begin
              //coordonnes du centre du chantier
              pcx := ((R.Right - R.Left) / 2) + R.Left;
              pcy := ((R.Bottom - R.Top) / 2) + R.Top;

              //transformation des coord. pour le viewer
              CoordChantier_To_CoordViewer(pcx, pcy, x, y);

              //Calcul des dcalages
              fDecalX := (fPaintBox.Width div 2) - x;
              fDecalY := (fPaintBox.Height div 2) - y;

              //                                   if fDecalX > 0 then fDecalX := 0;
              //                                   if fDecalY > 0 then fDecalY := 0;

              fChantier.CurrentVueModified := true;
            end;
        end;
    end;
end;

{
procedure TViewer.ZoomLess;
begin
 if fPaintBox <> nil then ZoomLessAtPoint(fPaintBox.Width div 2, fPaintBox.Height div 2);
end;


procedure TViewer.ZoomMore;
begin
 if fPaintBox <> nil then ZoomMoreAtPoint(fPaintBox.Width div 2, fPaintBox.Height div 2);
 // if fPaintBox <> nil then ZoomLessAtPoint(fPaintBox.Width div 2, fPaintBox.Height div 2);
end;
}

procedure TViewer.CallZoomChanged;
begin
  if assigned(fOnZoomChanged) then fOnZoomChanged(self);
end;

{   /////////////////
function TViewer.GetIndexPieuUnderMouse(XViewer, YViewer: integer): integer;
var
     n: integer;
     aPieu: TPieu;
     rgn: hrgn;
     ok: boolean;
     c: array[1..4] of TPoint;
begin
     result := -1;
     if fChantier <> nil then
     begin

          //On enlve le dcalage
          XViewer := XViewer - fDecalX;
          YViewer := YViewer - fDecalY;

          for n := 0 to fChantier.PieuList.Count - 1 do
          begin
               aPieu := fChantier.PieuList[n];

               if (aPieu.enabled) and (aPieu.visible) and (aPieu.KnowPositionInChantier) then
               begin
                    //Si le point est dans le rectangle d'encadrement du pieu
                    if PtInRect(aPieu.REncadreV, Point(XViewer, YViewer)) then
                    begin
                         //On regarde dans le vrai rectangle du pieu

                         try
                              c[1] := aPieu.RectV.P1;
                              c[2] := aPieu.RectV.P2;
                              c[3] := aPieu.RectV.P3;
                              c[4] := aPieu.RectV.P4;
                              rgn := CreatePolygonRgn(c, 4, ALTERNATE);
                              ok := PtInRegion(rgn, XViewer, YViewer);
                              DeleteObject(Rgn);

                              if ok then
                              begin
                                   result := n;
                                   break;
                              end;
                         except
                         end;
                    end;
               end;
          end;
     end;
end;
}


procedure TViewer.SetMouseMode(const Value: TMouseMode);
begin
  fMouseMode := Value;

  if fPaintBox <> nil then
    begin
      case Value of
        mmZoomMore: fPaintBox.Cursor := _CURSOR_ZOOM_PLUS;
        mmZoomLess: fPaintBox.Cursor := _CURSOR_ZOOM_MOINS;
        else
          fPaintBox.Cursor := _CURSOR_MAIN;
      end;
    end;
end;



function TViewer.FlashVue(NameVue: string): TVue;
var
  k: integer;
  aVue: TVue;
  ok: boolean;
begin
  result := nil;
  if fChantier <> nil then
    begin
      //On recherche l'instance de la vue qui porte ce nom
      k := fChantier.VueList.IndexOfName(NameVue);

      //si on ne l'a pas trouve, on cr une vue
      if k = -1 then
        begin
          aVue := TVue.create;
          aVue.Name := NameVue;
        end
      else
        aVue := fChantier.VueList[k];

      //On flash la vue actuelle
      ok := aVue.FlashViewer(self);

      //a s'est bien pass ?
      if ok then result := aVue
      else
        begin
          //comme a s'est mal pass, on dtruit la vue, si on l'a cr dans cette proc
          if k = -1 then aVue.Free;
        end;
    end;
end;

procedure TViewer.ApplyVue(NameVue: string);
var
  k: integer;
  aVue: TVue;
begin
  if (fChantier <> nil) and (fPaintBox <> nil) then
    begin
      k := fChantier.VueList.IndexOfName(NameVue);
      if k <> -1 then
        begin
          aVue := fChantier.VueList[k];

          ApplyVue2(aVue);
        end;
    end;
end;

procedure TViewer.ApplyVue2(aVue: TVue);
begin
  BeginUpdate;
  try
    //couleurs
    ColorBackground := aVue.ColorBackground;
    fColorPieuxSelected := aVue.ColorPieuxSelected;
    fColorPieux := aVue.ColorPieux;
    fColorPieuxOutOfDepth := aVue.ColorPieuxOutOfDepth;
    fColorPieuxTrace := aVue.ColorPieuxTrace;

    fFont.Assign(aVue.Font);
    //          fEchelle := aVue.Echelle;

              //On applique le zoom
    ApplyZoomAtPoint2(aVue.Zoom, fPaintBox.Width div 2, fPaintBox.Height div 2, aVue.XChantierInCentre, aVue.YChantierInCentre);

    fChantier.CurrentVueModified := false;

    if assigned(fOnAfterApplyVue) then fOnAfterApplyVue(self, aVue.Name);

  finally
    EndUpdate;
  end;

  PrepareGraph;
  Refresh;
  BuildMiniature;
end;




procedure TViewer.BuildMiniature;
var
  Ok: boolean;
  //     R: TRect;
  e: single;
  R: TFloatRect;
  //     aPieu: TPieu;
  wc, hc: single;
  pcx, pcy: single;
  x, y: integer;
  fZoomW, fZoomH: single;
begin
  if (fPaintBoxMiniature <> nil) then
    begin
      if (fPaintBoxMiniature.Width > 0) and (fPaintBoxMiniature.Height > 0) then
        begin
          BeginUpdate;
          try
            //On encadre les coordonnes chantiers des pieux
            Ok := fChantier.Graph.GetRectEncadrement(R);

            //Si on a russi  encadrer les pieux
            if Ok then
              begin
                //On ajoute une bordure au rectangle de dlimitaion, pour ne pas avoir des pieux colls sur les cts
              //  R.Left := R.Left - _ADD_MARGE_WIDTH;
              //  R.Right := R.Right + _ADD_MARGE_WIDTH;
              //  R.Top := R.Top - _ADD_MARGE_WIDTH;
              //  R.Bottom := R.Bottom + _ADD_MARGE_WIDTH;

                wc := R.Right - R.Left; //en m
                hc := R.Bottom - R.Top; //en m

                if (wc > 0) and (hc > 0) then
                  begin
                    //  fZoomW := ((fPaintBoxMiniature.Width * 100) / (fEchelle * wc));
                    //  fZoomH := ((fPaintBoxMiniature.Height * 100) / (fEchelle * hc));

        //                              fZoomW := (fEchelle * wc) / (fPaintBoxMiniature.Width);
        //                              fZoomH := (fEchelle * hc) / (fPaintBoxMiniature.Height);

                    //  fZoomW := ((fPaintBoxMiniature.Width * 100) / ( wc));
                    //  fZoomH := ((fPaintBoxMiniature.Height * 100) / ( hc));


                    fZoomW := ((fPaintBoxMiniature.Width * 100) / (wc * 72 / 25.4));
                    fZoomH := ((fPaintBoxMiniature.Height * 100) / (hc * 72 / 25.4));



                    //                              if fZoomW < fZoomH then fZoomMiniature := trunc(fZoomW - 1) else fZoomMiniature := trunc(fZoomH - 1);
        //                           //   if fZoomW < fZoomH then fZoomMiniature := trunc(fZoomH - 1) else fZoomMiniature := trunc(fZoomW - 1);

                   //// if fZoomW > fZoomH then fZoomMiniature := trunc(fZoomH - 1) else fZoomMiniature := trunc(fZoomW - 1);
                    if fZoomW > fZoomH then fZoomMiniature := fZoomH - 0.1 else fZoomMiniature := fZoomW - 0.1;


                    if fZoomMiniature <= 0 then fZoomMiniature := 0.001;
                    // if fZoomMiniature > _ZOOM_MAX then fZoomMiniature := _ZOOM_MAX;

                     //On centre tout a dans la miniature
                    pcx := ((R.Right - R.Left) / 2) + R.Left;
                    pcy := ((R.Bottom - R.Top) / 2) + R.Top;

                    //transformation des coord. pour le viewer de la miniature
                    CoordChantier_To_CoordViewerMiniature(pcx, pcy, x, y);

                    //Calcul des dcalages
                    fDecalMiniatureX := (fPaintBoxMiniature.Width div 2) - x;
                    fDecalMiniatureY := (fPaintBoxMiniature.Height div 2) - y;
                  end;
              end;

          finally
            EndUpdate;
          end;

          if Ok then
            begin
              //Calcul des coord de tous les pieux, dans le Viewer miniature
          //    e := fEchelle / fZoomMiniature;
              e := (fZoomMiniature * 72) / (100 * 25.4);

              fChantier.Graph.CoordChantier_2_CoordMiniature(e);

              RefreshMiniature;
            end;
        end;
    end;
end;





procedure TViewer.SetPaintBoxMiniature(const Value: TPaintBox);
begin
  BeginUpdate;
  try
    //dcrochage
    if (fPaintBoxMiniature <> nil) then
      begin
        fPaintBoxMiniature.OnPaint := nil;
      end;

    fPaintBoxMiniature := Value;

    //branchement des vnements
    if Value <> nil then
      begin
        fPaintBoxMiniature.OnPaint := OnPaintMiniature;
      end;

  finally
    EndUpdate;
  end;
end;

{
procedure TViewer.BeginUpdateMiniature;
begin
 fCanDrawMiniature.Value := false;
end;

procedure TViewer.EndUpdateMiniature;
begin
 fCanDrawMiniature.Value := true;
end;
 }

procedure TViewer.RefreshMiniature;
begin
  if fPaintBoxMiniature <> nil then fPaintBoxMiniature.Refresh;
end;





procedure TViewer.OnPaintMiniature(Sender: TObject);
var
  xc0, yc0: single;
  xc1, yc1: single;
  xvm0, yvm0: integer;
  xvm1, yvm1: integer;
begin
  if (fCanDrawMiniature.Value) and (fPaintBoxMiniature <> nil) then
    begin
      fPaintBoxMiniature.Canvas.Pen.Color := $000085FC;

      //le graph
      fChantier.Graph.PaintMiniature(fPaintBoxMiniature, fDecalMiniatureX, fDecalMiniatureY);

      //Cadre correspondant au grand viewer
      fPaintBoxMiniature.Canvas.Pen.Color := clWhite;
      if fPaintBox <> nil then
        begin
          //ou est le (0;0) et le (Width,Height)
          CoordViewer_To_CoordChantier(0, 0, xc0, yc0);
          CoordViewer_To_CoordChantier(fPaintBox.Width - 1, fPaintBox.Height - 1, xc1, yc1);

          //On transpose ces coord dans la miniature
          CoordChantier_To_CoordViewerMiniature(xc0, yc0, xvm0, yvm0);
          CoordChantier_To_CoordViewerMiniature(xc1, yc1, xvm1, yvm1);

          //On dessine le cadre
          fPaintBoxMiniature.Canvas.MoveTo(xvm0 + fDecalMiniatureX, yvm0 + fDecalMiniatureY);
          fPaintBoxMiniature.Canvas.LineTo(xvm1 + fDecalMiniatureX, yvm0 + fDecalMiniatureY);
          fPaintBoxMiniature.Canvas.LineTo(xvm1 + fDecalMiniatureX, yvm1 + fDecalMiniatureY);
          fPaintBoxMiniature.Canvas.LineTo(xvm0 + fDecalMiniatureX, yvm1 + fDecalMiniatureY);
          fPaintBoxMiniature.Canvas.LineTo(xvm0 + fDecalMiniatureX, yvm0 + fDecalMiniatureY);
        end;
    end;
end;


procedure TViewer.CoordChantier_To_CoordViewerMiniature(xc, yc: single; var xv, yv: integer);
var
  e: single;
begin
  //     e := fEchelle / fZoomMiniature;
  e := (fZoomMiniature * 72) / (100 * 25.4);
  //     xv := trunc(xc * e) + fDecalX;
  //     yv := -trunc(yc * e) + fDecalY;
  xv := trunc(xc * e);
  yv := trunc(yc * e);
end;



procedure TViewer.CoordViewerMiniature_To_CoordChantier(xv, yv: integer; var xc, yc: single);
var
  e: single;
begin
  //     e := fEchelle / fZoomMiniature;
  e := (fZoomMiniature * 72) / (100 * 25.4);
  xc := (xv - fDecalMiniatureX) / e;
  yc := (yv - fDecalMiniatureY) / e;
end;



procedure TViewer.SetColorBackground(const Value: TColor);
begin
  fColorBackground := Value;
  if fPaintBox <> nil then fPaintBox.Color := fColorBackground;
  if fPanelPaintBox <> nil then fPanelPaintBox.Color := fColorBackground;
end;

procedure TViewer.SetShowHintOnPieu(const Value: boolean);
begin
  fShowHintOnPieu := Value;
  if fPaintBox <> nil then fPaintBox.Hint := '';
end;

procedure TViewer.BuildZonesImpression;
var
  w, h: extended;
  n, k: integer;
  R: TFloatRect;
begin
  fTPXC.Clear;
  fTPYC.Clear;
  fTPXV.Clear;
  fTPYV.Clear;

  if fChantier.Graph.GetRectEncadrement(R) then
    begin
      //il y en a au moins une.
      w := R.Right - R.Left;
      k := trunc(w / fPageWidth) + 1;

      w := 0;
      for n := 1 to k do
        begin
          fTPXC.Add(w);
          fTPXV.Add(0);
          w := w + fPageWidth;
        end;
      fTPXC.Add(w);
      fTPXV.Add(0);


      h := R.Bottom - R.Top;
      k := trunc(h / fPageHeight) + 1;


      h := 0;
      for n := 1 to k do
        begin
          fTPYC.Add(h);
          fTPYV.Add(0);
          h := h + fPageHeight;
        end;
      fTPYC.Add(h);
      fTPYV.Add(0);
    end;
end;

end.
