{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Individu_Sur_Favoris;

interface


uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, Menus, jpeg, dxDBTLCl, dxGrClms, u_comp_TGoodBtn,
  Dialogs, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFIndividusSurFavoris = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQIndiSurVille: TIBQuery;
    DSIndiSurVille: TDataSource;
    pmUnions: TPopupMenu;
    mFiche: TMenuItem;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column4: TdxDBGridColumn;
    dxDBGrid1Column5: TdxDBGridColumn;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    GoodBtn7: TGoodBtn;
    N1: TMenuItem;
    ExporterenHTML1: TMenuItem;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    Label1: TLabel;
    dxDBGrid1Column6: TdxDBGridImageColumn;
    IBQIndiSurVilleCLE_FICHE: TIntegerField;
    IBQIndiSurVilleNOM: TIBStringField;
    IBQIndiSurVillePRENOM: TIBStringField;
    IBQIndiSurVilleDATE_NAISSANCE: TIBStringField;
    IBQIndiSurVilleEV_IND_CP: TIBStringField;
    IBQIndiSurVilleEV_IND_VILLE: TIBStringField;
    IBQIndiSurVilleEV_IND_PAYS: TIBStringField;
    IBQIndiSurVilleSEXE: TIntegerField;
    lVille: TLabel;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure mFicheClick(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure pmUnionsPopup(Sender: TObject);
  private
    fDialogMode: boolean;
    fCleFicheSelected: integer;

    procedure SetDialogMode(const Value: boolean);
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property CleFicheSelected: integer read fCleFicheSelected write fCleFicheSelected;

    procedure DoInit(sVille: string);
  end;

implementation

uses u_dm, u_common_var, u_common_const, u_common_func, u_Form_Posthumes,
  u_form_main;


{$R *.DFM}

procedure TFIndividusSurFavoris.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 378;
      ClientWidth := 719;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  SaveDialog.InitialDir := _Context.PathImportExport;

end;

procedure TFIndividusSurFavoris.DoInit(sVille: string);
begin
  lVille.Caption := sVille;

  IBQIndiSurVille.Params[0].AsInteger := dm.NumDossier;
  IBQIndiSurVille.Params[1].AsString := sVille;
  IBQIndiSurVille.Open;
end;

procedure TFIndividusSurFavoris.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQIndiSurVille.Close;
end;

procedure TFIndividusSurFavoris.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFIndividusSurFavoris.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFIndividusSurFavoris.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFIndividusSurFavoris.mFicheClick(Sender: TObject);
begin
  OpenFicheIndividuInBox(IBQIndiSurVilleCLE_FICHE.AsInteger);
end;

procedure TFIndividusSurFavoris.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Liste des Individus sans villes.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBQIndiSurVille.DisableControls;
      try
        SavePlace := IBQIndiSurVille.GetBookmark;
        dxDBGrid1.SaveToHTML(s_Fichier, True);
      finally
        IBQIndiSurVille.GotoBookmark(SavePlace);
        IBQIndiSurVille.FreeBookmark(SavePlace);

        IBQIndiSurVille.EnableControls;

      end;
    end;
end;

procedure TFIndividusSurFavoris.pmUnionsPopup(Sender: TObject);
begin
  mFiche.Enabled := dxDBGrid1.Count > 0;
  mFiche.Caption := 'Ouvrir la fiche de : ' + IBQIndiSurVilleNOM.AsString;
  if Length(IBQIndiSurVillePRENOM.AsString) > 0 then mFiche.Caption := mFiche.Caption + ', ' + IBQIndiSurVillePRENOM.AsString;
  ExporterenHTML1.Enabled := mFiche.Enabled;
end;



end.
