{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Liste_Nouveaux_Indi;

interface


uses
  Windows, CompSuperForm, Forms, Dialogs, Menus, DB, IBCustomDataSet,
  IBQuery, jpeg, ExtCtrls, dxDBGrid, dxTL, dxDBCtrl, dxDBTLCl, dxGrClms,
  dxCntner, ComCtrls, dxExEdtr, dxEdLib, StdCtrls, u_comp_TGoodBtn,
  TFlatPanelUnit, Controls, Buttons, Classes, SysUtils, Messages,
  u_comp_TYLanguage, DynamicSkinForm;

type
  TFListeNouveauxIndi = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQNouveaux: TIBQuery;
    DSNouveaux: TDataSource;
    pmUnions: TPopupMenu;
    mMari: TMenuItem;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column3: TdxDBGridColumn;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    GoodBtn7: TGoodBtn;
    N1: TMenuItem;
    ExporterenHTML1: TMenuItem;
    SaveDialog: TSaveDialog;
    IBQNouveauxCLE_FICHE: TIntegerField;
    IBQNouveauxNOM: TIBStringField;
    IBQNouveauxPRENOM: TIBStringField;
    IBQNouveauxSEXE: TIntegerField;
    IBQNouveauxDATE_NAISSANCE: TIBStringField;
    IBQNouveauxDATE_DECES: TIBStringField;
    rbNew: TRadioButton;
    rbModify: TRadioButton;
    cbNew: TdxCheckEdit;
    dxDBGrid1Column1: TdxDBGridImageColumn;
    DateTimePicker: TDateTimePicker;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure mMariClick(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure pmUnionsPopup(Sender: TObject);
    procedure DateTimePickerCloseUp(Sender: TObject);
    procedure cbNewClick(Sender: TObject);
    procedure rbModifyClick(Sender: TObject);
    procedure rbNewClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dxDBGrid1DblClick(Sender: TObject);
  private

    fDialogMode: boolean;
    fCleFicheSelected: integer;

    procedure SetDialogMode(const Value: boolean);
    procedure doOpen;
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property CleFicheSelected: integer read fCleFicheSelected write fCleFicheSelected;

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_common_func, u_form_main;


{$R *.DFM}

procedure TFListeNouveauxIndi.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  cbNew.checked := _Context.ShowNew;

  if _Context.Skin then
    begin
      ClientHeight := 370;
      ClientWidth := 719;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  DateTimePicker.Date := date - 7;
  SaveDialog.InitialDir := _Context.PathDocs;
  doOpen;
end;

procedure TFListeNouveauxIndi.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQNouveaux.Close;
end;

procedure TFListeNouveauxIndi.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFListeNouveauxIndi.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFListeNouveauxIndi.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFListeNouveauxIndi.mMariClick(Sender: TObject);
begin
  fCleFicheSelected := IBQNouveauxCLE_FICHE.AsInteger;
  ModalResult := mrOk;
end;

procedure TFListeNouveauxIndi.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Liste des derniers individus saisis.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBQNouveaux.DisableControls;
      try
        SavePlace := IBQNouveaux.GetBookmark;
        dxDBGrid1.SaveToHTML(s_Fichier, True);
      finally
        IBQNouveaux.GotoBookmark(SavePlace);
        IBQNouveaux.FreeBookmark(SavePlace);

        IBQNouveaux.EnableControls;

      end;
    end;
end;

procedure TFListeNouveauxIndi.pmUnionsPopup(Sender: TObject);
begin
  mMari.Enabled := (IBQNouveaux.Active) and (IBQNouveaux.IsEmpty = false);
  ExporterenHTML1.Enabled := (IBQNouveaux.Active) and (IBQNouveaux.IsEmpty = false);
end;

procedure TFListeNouveauxIndi.doOpen;
var
  s_Date: string;
begin
  IBQNouveaux.Close;
  s_date := DateToStr(DateTimePicker.Date);
  IBQNouveaux.Params[0].AsDate := StrToDate(s_date);
  IBQNouveaux.Params[1].AsInteger := dm.NumDossier;

  if rbNew.Checked then
    IBQNouveaux.Params[2].AsInteger := 1
  else
    IBQNouveaux.Params[2].AsInteger := 2;

  IBQNouveaux.Open;
end;

procedure TFListeNouveauxIndi.DateTimePickerCloseUp(Sender: TObject);
begin
  doOpen;
end;

procedure TFListeNouveauxIndi.cbNewClick(Sender: TObject);
begin
  _Context.ShowNew := cbNew.Checked;
  _Context.ShouldSave := true;
end;

procedure TFListeNouveauxIndi.rbModifyClick(Sender: TObject);
begin
  doOpen;
end;

procedure TFListeNouveauxIndi.rbNewClick(Sender: TObject);
begin
  doOpen;
end;

procedure TFListeNouveauxIndi.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_NOUVEAUX_INDI);
  end;
end;

procedure TFListeNouveauxIndi.dxDBGrid1DblClick(Sender: TObject);
begin
  if (IBQNouveaux.Active) and (IBQNouveaux.IsEmpty = false) then
    begin
      fCleFicheSelected := IBQNouveauxCLE_FICHE.AsInteger;
      ModalResult := mrOk;
    end;
end;

end.
