{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Orphelins;

interface


uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBQuery, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, Menus, jpeg, dxDBTLCl, dxGrClms, u_comp_TGoodBtn,
  Dialogs, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFOrphelins = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQOrphelins: TIBQuery;
    DSNaissance: TDataSource;
    pmUnions: TPopupMenu;
    mFiche: TMenuItem;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column4: TdxDBGridColumn;
    dxDBGrid1Column5: TdxDBGridColumn;
    Panel3: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    GoodBtn7: TGoodBtn;
    N1: TMenuItem;
    ExporterenHTML1: TMenuItem;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    IBQOrphelinsCLE_FICHE: TIntegerField;
    IBQOrphelinsNOM: TIBStringField;
    IBQOrphelinsPRENOM: TIBStringField;
    IBQOrphelinsDATE_NAISSANCE: TIBStringField;
    IBQOrphelinsDATE_DECES: TIBStringField;
    Label1: TLabel;
    dxDBGrid1Column6: TdxDBGridImageColumn;
    IBQOrphelinsSEXE: TIntegerField;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure mFicheClick(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure pmUnionsPopup(Sender: TObject);
  private
    fDialogMode: boolean;
    fCleFicheSelected: integer;

    procedure SetDialogMode(const Value: boolean);
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property CleFicheSelected: integer read fCleFicheSelected write fCleFicheSelected;

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_common_func, u_form_main;


{$R *.DFM}

procedure TFOrphelins.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 370;
      ClientWidth := 719;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  SaveDialog.InitialDir := _Context.PathImportExport;

  IBQOrphelins.Params[0].AsInteger := dm.NumDossier;
  IBQOrphelins.Open;
end;

procedure TFOrphelins.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQOrphelins.Close;
end;

procedure TFOrphelins.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFOrphelins.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFOrphelins.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFOrphelins.mFicheClick(Sender: TObject);
begin
  fCleFicheSelected := IBQOrphelinsCLE_FICHE.AsInteger;
  ModalResult := mrOk;
end;

procedure TFOrphelins.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Liste des Individus orphelins.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBQOrphelins.DisableControls;
      try
        SavePlace := IBQOrphelins.GetBookmark;
        dxDBGrid1.SaveToHTML(s_Fichier, True);
      finally
        IBQOrphelins.GotoBookmark(SavePlace);
        IBQOrphelins.FreeBookmark(SavePlace);

        IBQOrphelins.EnableControls;

      end;
    end;
end;

procedure TFOrphelins.pmUnionsPopup(Sender: TObject);
begin
  mFiche.Enabled := dxDBGrid1.Count > 0;
  ExporterenHTML1.Enabled := mFiche.Enabled;
end;

end.
