{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_coherence;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, StdCtrls, Buttons, dxCntner, dxExEdtr,
  dxEdLib, u_comp_TYLanguage, DynamicSkinForm;

type
  TFCoherence = class(TSuperForm)
    pBorder: TPanel;
    Panel2: TPanel;
    panCas1: TPanel;
    Label1: TLabel;
    Bevel2: TBevel;
    cb: TdxCheckEdit;
    panCas2: TPanel;
    Label2: TLabel;
    Bevel1: TBevel;
    panCas3: TPanel;
    Label3: TLabel;
    Bevel3: TBevel;
    panCas4: TPanel;
    Label4: TLabel;
    Bevel4: TBevel;
    panCas5: TPanel;
    Label5: TLabel;
    Bevel5: TBevel;
    panCas6: TPanel;
    Label6: TLabel;
    Bevel6: TBevel;
    Memo: TMemo;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure cbChange(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
  private
    fFormIndividu: TForm;


  public
    property FormIndividu: TForm read fFormIndividu write fFormIndividu;

    procedure Refresh;
  end;



implementation

uses u_dm, u_form_individu, u_common_var, u_form_main, u_common_const;

{$R *.DFM}

procedure TFCoherence.SuperFormCreate(Sender: TObject);
var
  n: integer;
begin
  if _Context.Skin then
    begin
      ClientHeight := 261;
      ClientWidth := 235;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fFormIndividu := nil;
  for n := 0 to ComponentCount - 1 do
    begin
      if (Components[n] is TControl) then
        begin
          //  if TControl(Components[n]) <> memo then
          TControl(Components[n]).Cursor := crHandPoint;
        end;
    end;
end;


procedure TFCoherence.Label10MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFCoherence.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;


procedure TFCoherence.Refresh;
var
  n: integer;
  H: integer;
begin
  if fFormIndividu <> nil then
    begin
      panCas1.visible := TFIndividu(fFormIndividu).CoherenceDate.Pb[1];
      panCas2.visible := TFIndividu(fFormIndividu).CoherenceDate.Pb[2];
      panCas3.visible := TFIndividu(fFormIndividu).CoherenceDate.Pb[3];
      panCas4.visible := TFIndividu(fFormIndividu).CoherenceDate.Pb[4];
      panCas5.visible := TFIndividu(fFormIndividu).CoherenceDate.Pb[5];
      panCas6.visible := TFIndividu(fFormIndividu).CoherenceDate.Pb[6];

      //Hauteur
      n := 0;
      if panCas1.visible then inc(n);
      if panCas2.visible then inc(n);
      if panCas3.visible then inc(n);
      if panCas4.visible then inc(n);
      if panCas5.visible then inc(n);
      if panCas6.visible then inc(n);

      memo.visible := TFIndividu(fFormIndividu).CoherenceDate.MorePbEventIndi.Count > 0;
      memo.lines.Assign(TFIndividu(fFormIndividu).CoherenceDate.MorePbEventIndi);

      // H := (24 * n) + pTop.Height + 33;
      if memo.lines.Count > 0 then
        begin
          memo.top := H - 45;
          memo.Height := (13 * memo.lines.count) + 2;
          H := H + memo.Height + 3;
        end;
      Height := H;
    end;
end;

procedure TFCoherence.cbChange(Sender: TObject);
begin
  _Context.CanShowWindowPbCoherence := not cb.Checked;
  _Context.ShouldSave := true;
end;

procedure TFCoherence.SuperFormShowFirstTime(Sender: TObject);
//var       p: TPoint;
begin
  {
       if fFormIndividu <> nil then
       begin
       p := TFIndividu(fFormIndividu).ClientToScreen(Point(5, 5));
       Top := p.y-145;
       Left := p.x;
       end;
       }
end;

end.
