{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, TFlatTabControlUnit, TFlatSpeedButtonUnit,
  u_form_individu_identite,
  u_form_individu_Union,
  u_form_arbre,
  u_form_individu_photos_et_docs,
  u_form_individu_observations,
  u_form_individu_Domiciles,
  u_form_individu_Actes,
  u_objet_TState,
  IBCustomDataSet,
  IBUpdateSQL,
  Db,
  IBQuery,
  GraphicEx,
  u_objet_TGedcomDate,
  u_form_coherence,
  u_objet_TCoherenceDate,
  StdCtrls, Buttons, Menus, u_comp_TGoodBtn, u_comp_TYLanguage,
  DynamicSkinForm, SkinCtrls;

const
  _ONGLET_IDENTITE = 0;
  _ONGLET_SES_CONJOINTS = 1;
  _ONGLET_ARBRE = 2;
  _ONGLET_PHOTOS_DOCS = 3;
  _ONGLET_OBSERVATIONS = 4;
  _ONGLET_DOMICILES = 5;
  _ONGLET_ACTES = 6;

type
  TFIndividu = class(TSuperForm)
    QueryIndividu: TIBQuery;
    QueryIndividuCLE_FICHE: TIntegerField;
    QueryIndividuKLE_DOSSIER: TIntegerField;
    QueryIndividuCLE_IMPORTATION: TIBStringField;
    QueryIndividuCLE_PARENTS: TIntegerField;
    QueryIndividuCLE_PERE: TIntegerField;
    QueryIndividuCLE_MERE: TIntegerField;
    QueryIndividuPREFIXE: TIBStringField;
    QueryIndividuNOM: TIBStringField;
    QueryIndividuPRENOM: TIBStringField;
    QueryIndividuSURNOM: TIBStringField;
    QueryIndividuSUFFIXE: TIBStringField;
    QueryIndividuDATE_NAISSANCE: TIBStringField;
    QueryIndividuDATE_DECES: TIBStringField;
    QueryIndividuSOURCE: TMemoField;
    QueryIndividuCOMMENT: TMemoField;
    QueryIndividuFILLIATION: TIBStringField;
    QueryIndividuNUM_SOSA: TFloatField;
    QueryIndividuDATE_MODIF: TDateTimeField;
    QueryIndividuDATE_CREATION: TDateTimeField;
    QueryIndividuMODIF_PAR_QUI: TIBStringField;
    QueryIndividuS_PREFIXE: TStringField;
    QueryIndividuS_FILIATION: TStringField;
    UpdateIndividu: TIBUpdateSQL;
    panBack: TPanel;
    Panel13: TPanel;
    Panel8: TPanel;
    panTop: TPanel;
    btnNaviguer: TFlatSpeedButton;
    Panel19: TPanel;
    panTabs: TPanel;
    PaintBoxOnglet: TPaintBox;
    Panel12: TPanel;
    Panel5: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    btnPrecedent: TFlatSpeedButton;
    btnSuivant: TFlatSpeedButton;
    popup_Precedent: TPopupMenu;
    popup_Suivant: TPopupMenu;
    btnPbCoherence: TFlatSpeedButton;
    QueryGetDatesInd: TIBQuery;
    QueryGetAllEnfants: TIBQuery;
    QueryGetDatesIndEV_CLEF: TIntegerField;
    QueryGetDatesIndEV_KLE_OWNER: TIntegerField;
    QueryGetDatesIndEV_TYPE: TIBStringField;
    QueryGetDatesIndEV_DATE_WRITEN: TIBStringField;
    QueryGetDatesIndS_TABLE: TIBStringField;
    QueryGetDatesInd_EVENT_LONG_NAME: TStringField;
    bsfbNouveau: TGoodBtn;
    bsfbSupprimer: TGoodBtn;
    bsfbAppliquer: TGoodBtn;
    bsfbAnnuler: TGoodBtn;
    btnFermer: TGoodBtn;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel11: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel1: TPanel;
    panDock: TPanel;
    panNobody: TPanel;
    Label13: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    FlatSpeedButton1: TGoodBtn;
    FlatSpeedButton2: TGoodBtn;
    QueryIndividuSEXE: TIntegerField;
    QueryIndividuANNEE_NAISSANCE: TIntegerField;
    QueryIndividuANNEE_DECES: TIntegerField;
    QueryIndividuDECEDE: TIntegerField;
    QueryIndividuAGE_AU_DECES: TIntegerField;
    Language: TYLanguage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    btnPrint: TGoodBtn;
    QueryIndividuINFOS_DATE: TStringField;
    spDynamicSkinForm1: TspDynamicSkinForm;
    spSkinTextLabel1: TspSkinTextLabel;
    QueryIndividuINDI_TRIE_NOM: TIBStringField;
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure btnNaviguerClick(Sender: TObject);
    procedure bsfbNouveauClick(Sender: TObject);
    procedure bsfbAppliquerClick(Sender: TObject);
    procedure bsfbAnnulerClick(Sender: TObject);
    procedure bsfbSupprimerClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure onClickOnOnglet(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure QueryIndividuNewRecord(DataSet: TDataSet);
    procedure FlatSpeedButton1Click(Sender: TObject);
    procedure PaintBoxOngletPaint(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure FlatSpeedButton2Click(Sender: TObject);
    procedure SuperFormShow(Sender: TObject);
    // procedure Label10MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btnFermerClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure popup_PrecedentPopup(Sender: TObject);
    procedure btnPrecedentClick(Sender: TObject);
    procedure popup_SuivantPopup(Sender: TObject);
    procedure btnSuivantClick(Sender: TObject);
    procedure btnPbCoherenceClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure QueryIndividuCalcFields(DataSet: TDataSet);
    procedure SuperFormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    fFill: TState;
    fCleFiche: integer;

    //indique quel form est actuelle incruste
    fOngletFormIncrusted: integer;

    fTextesOnglets: TStringList;

    //permet de savoir si les querys des onglets sont ouverts
    fOngletIdentiteIsLoaded: boolean;
    fOngletSesConjointsIsLoaded: boolean;
    fOngletArbreIsLoaded: boolean;
    fOngletPhotosDocsIsLoaded: boolean;
    fOngletObservationsIsLoaded: boolean;
    fOngletDomicilesIsLoaded: boolean;
    fOngletActesIsLoaded: boolean;

    //Les fiches associs aux querys

    aFIndividuPhotosEtDocs: TFIndividuPhotosEtDocs;
    aFIndividuObservations: TFIndividuObservations;
    aFIndividuDomiciles: TFIndividuDomiciles;
    aFIndividuActes: TFIndividuActes;

    fModified: boolean;
    fDialogMode: boolean;

    fCleFicheAvantInsert: Integer;
    fFirstIncrust: boolean;
    fProposeToCreateNewIndividuIfNotFind: boolean;
    fLocateOnFirstIndividuDossierIfNotFind: boolean;

    GedDateCoherence: TGedcomDate;

    aFCoherence: TFCoherence;
    fCoherenceDate: TCoherenceDate;


    procedure doInitialize;
    function doOpenQuerys: boolean;
    procedure SetDialogMode(const Value: boolean);

    procedure DoNouvelleFiche;
    function TestFicheIsModified: boolean;
    function DoAppliquer: word; //rponse mrXX
    procedure DoAnnuler;
    procedure SetTabByPositionMouse(x: integer);

    procedure OnSelectIndividuInListPrevious(Sender: TObject);
    procedure OnSelectIndividuInListNext(Sender: TObject);
    procedure doGoToFiche(aIndexCleFicheInList, sens: integer);

  public
    aFIndividuIdentite: TFIndividuIdentite;
    aFIndividuUnion: TFIndividuUnion;
    aFIndividuArbre: TFArbre;

    //en entre
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property LocateOnFirstIndividuDossierIfNotFind: boolean read fLocateOnFirstIndividuDossierIfNotFind write fLocateOnFirstIndividuDossierIfNotFind;
    property ProposeToCreateNewIndividuIfNotFind: boolean read fProposeToCreateNewIndividuIfNotFind write fProposeToCreateNewIndividuIfNotFind;
    property Modified: boolean read fModified write fModified;
    property CleFiche: integer read fCleFiche;

    property CoherenceDate: TCoherenceDate read fCoherenceDate write fCoherenceDate;

    property OngletSesConjointsIsLoaded: boolean read fOngletSesConjointsIsLoaded;

    property OngletFormIncrusted: integer read fOngletFormIncrusted;

    procedure RefreshNomIndividu;
    procedure RefreshPhoto;
    procedure doActiveOnglet(onglet: integer);
    function GetNomIndividu: string;

    procedure LoadCoherenceDates;

    //pour fermer tous les query, sans poser de question
    procedure ForceCloseAllQuerys;

    //en entre
    function doOpenFiche(aCleFiche: integer): boolean;

    //en sortie
    function VerifyCanCloseFiche: boolean;

    function ChangeFicheActive(aCleFiche: integer): boolean;
  end;

var
  FIndividu: TFIndividu;

implementation

uses u_common_var, u_common_func, u_form_main, u_common_const, u_dm;

{$R *.DFM}
{ TFIndi }

procedure TFIndividu.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fLocateOnFirstIndividuDossierIfNotFind := false;
  fProposeToCreateNewIndividuIfNotFind := false;

  fTextesOnglets := TStringList.create;
  fTextesOnglets.Add(Label1.Caption);
  fTextesOnglets.Add(Label2.Caption);
  fTextesOnglets.Add(Label3.Caption);
  fTextesOnglets.Add(Label6.Caption);
  fTextesOnglets.Add(Label7.Caption);
  fTextesOnglets.Add(Label8.Caption);
  fTextesOnglets.Add(Label9.Caption);

  fCleFicheAvantInsert := -1;
  fDialogMode := false;
  fFirstIncrust := true;
  panNobody.visible := false;

  fModified := false;
  fOngletFormIncrusted := _ONGLET_IDENTITE;
  fFill := TState.create(false);

  GedDateCoherence := TGedcomDate.Create;
  GedDateCoherence.AssignTokens;

  aFCoherence := TFCoherence.create(self);
  aFCoherence.FormIndividu := Self;

  fCoherenceDate := TCoherenceDate.create;
  fCoherenceDate.FormIndividu := self;
  fCoherenceDate.FormCoherence := aFCoherence;

  Application.ProcessMessages;

  fFill.value := true;
  try
    //Identit
    aFIndividuIdentite := TFIndividuIdentite.create(self);
    aFIndividuIdentite.FormIndividu := self;

    //unions
    aFIndividuUnion := TFIndividuUnion.create(self);
    aFIndividuUnion.FormIndividu := self;

    //l'arbre
    aFIndividuArbre := TFArbre.create(self);
    aFIndividuArbre.FormIndividu := self;

    //Photos et Docs
    aFIndividuPhotosEtDocs := TFIndividuPhotosEtDocs.create(self);
    aFIndividuPhotosEtDocs.FormIndividu := self;

    //Observations
    aFIndividuObservations := TFIndividuObservations.create(self);
    aFIndividuObservations.FormIndividu := self;

    //Domiciles
    aFIndividuDomiciles := TFIndividuDomiciles.Create(Self);
    aFIndividuDomiciles.FormIndividu := self;

    // Actes
    aFIndividuActes := TFIndividuActes.Create(Self);
    aFIndividuActes.FormIndividu := self;

  finally
    fFill.value := false;
  end;

  PaintBoxOnglet.refresh;
  Application.ProcessMessages;
  doRefreshControls;
end;

function TFIndividu.GetNomIndividu: string;
begin
  result := aFIndividuIdentite.lTitre.Caption;

end;

procedure TFIndividu.RefreshPhoto;
begin
  aFIndividuIdentite.RefreshPhoto;
end;

procedure TFIndividu.SuperFormDestroy(Sender: TObject);
begin
  aFIndividuIdentite.Free;
  aFIndividuUnion.Free;
  aFIndividuArbre.Free;
  aFIndividuPhotosEtDocs.Free;
  aFIndividuObservations.Free;
  aFIndividuDomiciles.Free;
  aFIndividuActes.Free;

  fFill.free;

  if _FormNavigation.visible then _FormNavigation.Hide;
  fTextesOnglets.free;
  GedDateCoherence.free;
  fCoherenceDate.Free;
  aFCoherence.free;
end;

procedure TFIndividu.doInitialize;
begin
  //On s'assure que tous les querys sont ferms
  QueryIndividu.Close;
  aFIndividuIdentite.doInitialize;
  aFIndividuUnion.doInitialize;
  aFIndividuArbre.doInitialize;
  aFIndividuPhotosEtDocs.doInitialize;
  aFIndividuObservations.doInitialize;
  aFIndividuDomiciles.doInitialize;
  aFIndividuActes.doInitialize;

  //on indique que rien n'est charg
  fOngletIdentiteIsLoaded := false;
  fOngletSesConjointsIsLoaded := false;
  fOngletArbreIsLoaded := false;
  fOngletPhotosDocsIsLoaded := false;
  fOngletObservationsIsLoaded := false;
  fOngletDomicilesIsLoaded := false;
  fOngletActesIsLoaded := false;

end;

function TFIndividu.doOpenFiche(aCleFiche: integer): boolean;
begin
  result := false;

  //on ferme touts les query en cours
  doInitialize;

  //On ouvre le query principal
  fCleFiche := aCleFiche;

  // ici on enregistre les donnes pour la table de dll ------------------------------------------------

  if doOpenQuerys then
    begin
      //On a trouv l'individu
      result := true;
      if fDialogMode = false then
        dm.DoUpdateDLL;

      //on active la form de l'onglet slectionn
      doActiveOnglet(fOngletFormIncrusted);

      //On ouvre les querys de la form "identit"
      LoadCoherenceDates;
      CoherenceDate.Test;
    end
  else
    begin
      //on a pas trouv l'individu
      doInitialize;

      //On regarde si il existe au moins quelqu'un dans la base
      if fLocateOnFirstIndividuDossierIfNotFind then
        begin
          //on recherche le 1er individu du dossier
          aCleFiche := dm.uf_MaxIndividu;

          //l'a-t'on trouv ?
          if aCleFiche <> -1 then
            begin
              fCleFiche := aCleFiche;

              if doOpenQuerys then
                begin
                  //On a trouv l'individu
                  result := true;

                  //on active la form de l'onglet slectionn
                  doActiveOnglet(fOngletFormIncrusted);

                  //On ouvre les querys de la form "identit"
                  LoadCoherenceDates;
                  CoherenceDate.Test;
                end;
            end
          else
            //on ne l'a pas trouv
            begin
              if fProposeToCreateNewIndividuIfNotFind then
                begin
                  //si personne n'existe dans le dossier courant,
                  panNobody.visible := true;
                  panNobody.left := 0;
                  panNobody.top := 0;
                  panNobody.width := width;
                  panNobody.height := height;
                end;
            end;
        end;
    end;

  if (Result) and (fDialogMode = False) then
    begin
      dm.AddFicheOpen(fCleFiche, QueryIndividu.FieldByName('SEXE').AsInteger, AssembleString([QueryIndividu.FieldByName('NOM').AsString, QueryIndividu.FieldByName('PRENOM').AsString]));
    end;

  doRefreshControls;

  //si la fentre de navigation est ouverte, alors, on refresh
  if _FormNavigation.visible then
    if _FormNavigation.CallingOpenFicheFromMe = false
      then _FormNavigation.LoadPeopleArroundIndividu(fCleFiche);
end;

function TFIndividu.doOpenQuerys: boolean;
begin
  result := false;

  //identit
  QueryIndividu.DisableControls;
  try
    QueryIndividu.Close;
    //QueryIndividu.Params[0].AsInteger := dm.NumDossier;
    QueryIndividu.Params[0].AsInteger := fCleFiche;
    QueryIndividu.Open;
    QueryIndividu.last;
    QueryIndividu.first;

    //a-t'on trouv l'individu ?
    if QueryIndividu.RecordCount = 1 then
      begin
        if fDialogMode = false then dm.FicheActive := fCleFiche;
        result := true;
      end;

  finally
    QueryIndividu.EnableControls;
  end;
end;

procedure TFIndividu.doActiveOnglet(onglet: integer);
begin
  if (not fFill.Value) then
    begin
      fFill.Value := true;
      btnPrint.Visible := onglet = _ONGLET_ARBRE;

      try
        //on regarde si les donnes sont charges dans l'onglet appel
        case onglet of
          _ONGLET_ACTES:
            begin
              if fOngletActesIsLoaded = false
                then fOngletActesIsLoaded := aFIndividuActes.doOpenQuerys;
            end;

          _ONGLET_IDENTITE:
            begin
              if fOngletIdentiteIsLoaded = false
                then fOngletIdentiteIsLoaded := aFIndividuIdentite.doOpenQuerys;
            end;

          _ONGLET_SES_CONJOINTS:
            begin
              if fOngletSesConjointsIsLoaded = false
                then fOngletSesConjointsIsLoaded := aFIndividuUnion.doOpenQuerys;
            end;

          _ONGLET_ARBRE:
            begin
              if fOngletArbreIsLoaded = false then
                begin
                  fOngletArbreIsLoaded := true;
                  aFIndividuArbre.Init_Arbre;
                end;
            end;

          _ONGLET_PHOTOS_DOCS:
            begin
              if fOngletPhotosDocsIsLoaded = false
                then fOngletPhotosDocsIsLoaded := aFIndividuPhotosEtDocs.doOpenQuerys;
            end;

          _ONGLET_OBSERVATIONS:
            begin
              if fOngletObservationsIsLoaded = false
                then fOngletObservationsIsLoaded := aFIndividuObservations.doOpenQuerys;
            end;

          _ONGLET_DOMICILES:
            begin
              if fOngletDomicilesIsLoaded = false
                then fOngletDomicilesIsLoaded := aFIndividuDomiciles.doOpenQuerys;
            end;

        end;

        //on montre l'onglet
        PaintBoxOnglet.refresh;
        if fOngletFormIncrusted <> onglet then
          begin
            //on dsincruste la form
            case fOngletFormIncrusted of

              _ONGLET_IDENTITE:
                begin
                  aFIndividuIdentite.HideIncrust;
                  aFIndividuIdentite.pIdentiteComplete.Hide;
                  aFIndividuIdentite.pIdentiteReduite.Show;
                end;

              _ONGLET_SES_CONJOINTS: aFIndividuUnion.HideIncrust;
              _ONGLET_ARBRE: aFIndividuArbre.HideIncrust;
              _ONGLET_PHOTOS_DOCS: aFIndividuPhotosEtDocs.HideIncrust;
              _ONGLET_OBSERVATIONS: aFIndividuObservations.HideIncrust;
              _ONGLET_DOMICILES: aFIndividuDomiciles.HideIncrust;
              _ONGLET_ACTES: aFIndividuActes.HideIncrust;
            end;
          end;

        if (fOngletFormIncrusted <> onglet) or (fFirstIncrust = true) then
          begin
            fFirstIncrust := false;

            //on incruste celle demande
            case onglet of

              _ONGLET_ACTES: begin
                  aFIndividuActes.ShowIncrust(panDock);
                end;
              _ONGLET_IDENTITE: begin
                  aFIndividuIdentite.ShowIncrust(panDock);
                end;
              _ONGLET_SES_CONJOINTS: begin
                  aFIndividuUnion.ShowIncrust(panDock);
                  // SendFocus(aFIndividuUnion.TreeConj);
                end;
              _ONGLET_ARBRE: begin
                  aFIndividuArbre.ShowIncrust(panDock);
                  // SendFocus(aFIndividuArbre.dxsGenerations);
                end;
              _ONGLET_PHOTOS_DOCS: begin
                  aFIndividuPhotosEtDocs.ShowIncrust(panDock);
                  // SendFocus(aFIndividuPhotosEtDocs.gridListDocs);
                end;
              _ONGLET_OBSERVATIONS: begin
                  aFIndividuObservations.ShowIncrust(panDock);
                  // SendFocus(aFIndividuObservations.memo);
                end;
              _ONGLET_DOMICILES: begin
                  aFIndividuDomiciles.ShowIncrust(panDock);
                  // SendFocus(aFIndividuDomiciles.dxDBGrid1);
                end;
            end;

            fOngletFormIncrusted := onglet;
          end;

        RefreshNomIndividu;

        Application.ProcessMessages;

      finally
        fFill.Value := false;
      end;
    end;
  PaintBoxOnglet.refresh;
end;

function TFIndividu.VerifyCanCloseFiche: boolean;
var
  rep: word;
begin
  result := true;

  if TestFicheIsModified then
    begin
      rep := MyMessageDlg('Vous avez modifi la fiche individu.' + #13#10#13#10 + 'Souhaitez-vous enregistrer les modifications ?', mtWarning, [mbYes, mbNo, mbCancel], 0);
      case rep of
        mrYes: begin
            if DoAppliquer = mrCancel then result := false;
          end;
        mrNo: DoAnnuler;
        mrCancel: result := false;
      end;
    end;
end;

procedure TFIndividu.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;

  bsfbNouveau.visible := Value = false;
  bsfbSupprimer.visible := Value = false;
  bsfbAppliquer.visible := Value = false;
  bsfbAnnuler.visible := Value = false;
  btnFermer.visible := Value;
  btnNaviguer.visible := Value = false;
  btnPrecedent.visible := Value = false;
  btnSuivant.visible := Value = false;

  if Value = False then
    begin
      panBack.BorderWidth := 0;
      // panBack.BevelOuter := bvNone;
    end
  else
    begin
      Position := poMainFormCenter;
      //BorderStyle := bsNone;
      //    Panel13.BorderWidth := 5;
      //    height := 547;
      ClientHeight := 500;
      ClientWidth := 699;
    end;
end;

procedure TFIndividu.btnNaviguerClick(Sender: TObject);
var
  p: tpoint;
begin
  if _FormNavigation.visible = false then
    begin
      if _FormNavigation.FirstShow = true then
        begin
          p.x := panTop.width; p.y := panTop.Height;
          p := panTop.clienttoscreen(p);
          _FormNavigation.left := p.x - _FormNavigation.Width;
          _FormNavigation.top := p.y;
        end;

      _FormNavigation.LoadPeopleArroundIndividu(fCleFiche);
      _FormNavigation.Show;
    end
  else
    _FormNavigation.Hide;
end;

procedure TFIndividu.bsfbNouveauClick(Sender: TObject);
begin
  DoNouvelleFiche;
end;

procedure TFIndividu.DoNouvelleFiche;
var
  rep: word;
  suite: boolean;
begin
  suite := true;

  //La fiche a-t'elle t modifie ?
  if (fCleFiche <> -1) and (TestFicheIsModified) then
    begin
      rep := MyMessageDlg('Cet individu a t modifi. Souhaitez-vous enregistrer, avant de crer un nouvel individu ?', mtWarning, [mbYes, mbNo, mbCancel], 0);

      case rep of
        mrYes: begin
            if DoAppliquer = mrCancel then suite := false;
          end;
        mrNo: DoAnnuler;
        else
          suite := false;
      end;
    end;

  if suite then
    begin
      fCleFicheAvantInsert := fCleFiche; //PCM
      fCleFiche := -1;

      //par scurit, on ferme les query
      doInitialize;
      fCoherenceDate.Reset;

      QueryIndividu.Open;
      QueryIndividu.Insert;

      //On se place sur l'onglet "identit"
      doActiveOnglet(_ONGLET_IDENTITE);

      aFIndividuIdentite.pIdentiteReduite.Hide;
      aFIndividuIdentite.pIdentiteComplete.Show;
      aFIndividuIdentite.pIdentiteComplete.Height := 105;

      if aFIndividuIdentite.edCivilite.CanFocus then aFIndividuIdentite.edCivilite.SetFocus;
    end;

  DoRefreshControls;
end;

function TFIndividu.TestFicheIsModified: boolean;
begin
  result := fModified;

  if result = false then
    begin
      //test de l'identit
      if (QueryIndividu.State in [dsEdit, dsInsert]) or fModified then result := true;

      //test des photos et docs
      if (aFIndividuPhotosEtDocs.DSMultimedia.State in [dsEdit, dsInsert]) then result := true;

      //test des Actes
      if ((aFIndividuActes.DSActes.State in [dsEdit, dsInsert]) or
        (aFIndividuActes.DSActesFam.State in [dsEdit, dsInsert])) then result := true;

      // Domiciles
      if (aFIndividuDomiciles.dsAdresses.State in [dsEdit, dsInsert]) then result := true;
      //les unions
      if (aFIndividuUnion.dsEve.State in [dsEdit, dsInsert]) then result := true;

      //les sources et notes de l'union
      if (aFIndividuUnion.DataSourceSourceCommentUnion.State in [dsEdit, dsInsert]) then result := true;

    end;
end;

procedure TFIndividu.bsfbAppliquerClick(Sender: TObject);
begin
  DoAppliquer;
end;

function TFIndividu.DoAppliquer: word; //rponse mrXX
var
  suite: boolean;
begin
  Suite := true;

  if Suite then
    begin
      result := mrOk;

      if (trim(QueryIndividuNOM.AsString) <> '') then
        begin
          // Les sources des evenements
          if dm.IBQSources_Record.State in [dsEdit, dsInsert] then
            begin
              dm.IBQSources_Record.Post;
              dm.IBQSources_Record.Close;
            end;

          //On post les Evnements
          if (aFIndividuIdentite.dsEve.State in [dsEdit, dsInsert])
            then aFIndividuIdentite.ibqEve.Post;

          //On post L'individu
          if (QueryIndividu.State in [dsEdit, dsInsert])
            then
            begin
              QueryIndividu.Post;

              dm.IBUpdateNOM.Close;
              dm.IBUpdateNOM.Params[0].AsInteger := fCleFiche;
              dm.IBUpdateNOM.ExecSQL;
              dm.IBUpdateNOM.Close;
            end;

          //photos et docs
          if (aFIndividuPhotosEtDocs.DSMultimedia.State in [dsEdit, dsInsert])
            then aFIndividuPhotosEtDocs.IBMultimedia.Post;

          //Actes
          if (aFIndividuActes.DSActes.State in [dsEdit, dsInsert])
            then aFIndividuActes.IBActes.Post;

          if (aFIndividuActes.DSActesFam.State in [dsEdit, dsInsert])
            then aFIndividuActes.IBActesFam.Post;
          aFIndividuActes.doOpenQuerys;

          //Unions
          if (aFIndividuUnion.dsEve.State in [dsEdit, dsInsert])
            then aFIndividuUnion.ibqEve.Post;

          if (aFIndividuUnion.QSourcesNotesUnion.Active) then
            if (aFIndividuUnion.QSourcesNotesUnion.State in [dsEdit, dsInsert])
              then aFIndividuUnion.QSourcesNotesUnion.Post;

          // Domiciles
          if (aFIndividuDomiciles.dsAdresses.State in [dsEdit, dsInsert])
            then aFIndividuDomiciles.IBQAdresses.Post;

          //On commit tout ce que l'utilisateur  modifi
          dm.IBT_BASE.CommitRetaining;

          aFIndividuIdentite.IBQEve.Close;
          aFIndividuIdentite.IBQEve.Open;

          dm.FicheActive := fCleFiche;

          dm.AddFicheOpen(fCleFiche, QueryIndividu.FieldByName('SEXE').AsInteger, AssembleString([QueryIndividu.FieldByName('NOM').AsString, QueryIndividu.FieldByName('PRENOM').AsString]));

          dm.VerifyInfosInListFicheOpen(fCleFiche, QueryIndividu.FieldByName('SEXE').AsInteger, AssembleString([QueryIndividu.FieldByName('NOM').AsString, QueryIndividu.FieldByName('PRENOM').AsString]));

          fModified := false;

          //rafraichissement
          DoRefreshControls;
        end
      else
        begin
          if (QueryIndividu.Active) then
            begin
              MyMessageDlg('Merci d''indiquer un patronyme pour cet individu', mtInformation, [mbOk], 0);
              result := mrCancel;
            end;
        end;
    end
  else
    result := mrCancel;
end;

procedure TFIndividu.bsfbAnnulerClick(Sender: TObject);
begin
  DoAnnuler;
end;

procedure TFIndividu.DoAnnuler;
begin
  if QueryIndividu.State = dsInsert then fCleFiche := fCleFicheAvantInsert;

  //on annule tout ce qu'on a fait
  doInitialize;

  aFIndividuIdentite.aFIndividuEditEventLife.Hide;

  //On RollBack tout ce que l'utilisateur a fait depuis l'ouverture de cette fiche
  dm.IBT_BASE.RollbackRetaining;

  //donc, rien est modifi
  fModified := false;

  //Rafraichissements
  DoRefreshControls;

  //Re-ouverture de la fiche, aprs cette anulation

  doOpenFiche(fCleFiche);
end;

procedure TFIndividu.bsfbSupprimerClick(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la supression de cette fiche ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      QueryIndividu.Delete;

      //On commit tout ce que l'utilisateur  modifi
      dm.IBT_BASE.CommitRetaining;

      doInitialize;
      fClefiche := -1;

      DoRefreshControls;
      Application.ProcessMessages;

      doOpenFiche(-1);
      Application.ProcessMessages;

      DoRefreshControls;
      Application.ProcessMessages;

      dm.LoadFavoris(FMain.menu_Favoris);

    end;
end;

procedure TFIndividu.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if key = VK_ESCAPE then
    if fDialogMode then Close;
  if key = VK_RETURN then
    if bsfbAppliquer.Enabled then bsfbAppliquerClick(Sender);
end;

procedure TFIndividu.SuperFormRefreshControls(Sender: TObject);
var
  fFicheIsModified: boolean;
begin
  //dans quelle tat est la fiche ?
  if fCleFiche = -1 then
    begin
      btnNaviguer.enabled := false;
      bsfbNouveau.enabled := true;
      bsfbSupprimer.enabled := false;
      bsfbAppliquer.enabled := false;
      bsfbAnnuler.enabled := false;
      btnPbCoherence.visible := false;
    end
  else
    begin
      fFicheIsModified := TestFicheIsModified and (fDialogMode = false);
      btnNaviguer.enabled := (fDialogMode = false);
      bsfbNouveau.enabled := (fDialogMode = false);
      bsfbSupprimer.enabled := (fDialogMode = false);
      bsfbAppliquer.enabled := fFicheIsModified and (fDialogMode = false);
      bsfbAnnuler.enabled := fFicheIsModified and (fDialogMode = false);
    end;

  btnPrecedent.enabled := (dm.FicheOpenIndex > 0) and (dm.FicheOpenIndex < dm.ListFicheOpenInfos.Count);
  btnSuivant.enabled := (dm.FicheOpenIndex >= 0) and (dm.FicheOpenIndex < dm.ListFicheOpenInfos.Count - 1);

  if fDialogMode = false then
    begin
      FMain.option_RenumerotationSOSA.enabled := (bsfbAppliquer.enabled = false);
    end;

  aFIndividuIdentite.DoRefreshControls;
  aFIndividuUnion.DoRefreshControls;
  aFIndividuArbre.DoRefreshControls;
  aFIndividuPhotosEtDocs.DoRefreshControls;
  aFIndividuObservations.DoRefreshControls;
  aFIndividuDomiciles.DoRefreshControls;
  aFIndividuActes.DoRefreshControls;

  FMain.Caption := Application.Title + ' - ' + QueryIndividuINFOS_DATE.AsString;

  Application.ProcessMessages;
end;

procedure TFIndividu.PaintBoxOngletPaint(Sender: TObject);
begin
  PaintOnglet(PaintBoxOnglet, 7, fOngletFormIncrusted, 70, 18, clBlack, $00C5E8F3, $008FC6D8, fTextesOnglets);
end;

procedure TFIndividu.onClickOnOnglet(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
  if fCleFiche <> -1 then
    begin
      p := TControl(Sender).ClientToScreen(Point(X, Y));
      p := panTabs.ScreenToClient(p);
      SetTabByPositionMouse(p.x);
    end;
end;

procedure TFIndividu.SetTabByPositionMouse(x: integer);
var k: integer;
begin
  k := (x div 67);
  if k < 0 then k := 0;
  if k > 6 then k := 6;
  doActiveOnglet(k);
end;

procedure TFIndividu.RefreshNomIndividu;
var
  s: string;
begin
  s := AssembleString([QueryIndividuNOM.AsString, QueryIndividuPRENOM.AsString]);

  case QueryIndividuSEXE.AsInteger of
    1:
      begin
        aFIndividuUnion.lNom.Font.Color := _Context.ColorHomme;
        aFIndividuArbre.lNom.Font.Color := _Context.ColorHomme;
        aFIndividuPhotosEtDocs.lNom.Font.Color := _Context.ColorHomme;
        aFIndividuObservations.lNom.Font.Color := _Context.ColorHomme;
        aFIndividuDomiciles.lNom.Font.Color := _Context.ColorHomme;
        aFIndividuActes.lNom.Font.Color := _Context.ColorHomme;
      end;
    2:
      begin
        aFIndividuUnion.lNom.Font.Color := _Context.ColorFemme;
        aFIndividuArbre.lNom.Font.Color := _Context.ColorFemme;
        aFIndividuPhotosEtDocs.lNom.Font.Color := _Context.ColorFemme;
        aFIndividuObservations.lNom.Font.Color := _Context.ColorFemme;
        aFIndividuDomiciles.lNom.Font.Color := _Context.ColorFemme;
        aFIndividuActes.lNom.Font.Color := _Context.ColorFemme;
      end;
  end;

  aFIndividuUnion.lNom.Caption := CoupeChaine(s, aFIndividuUnion.lNom); ;
  aFIndividuArbre.lNom.Caption := CoupeChaine(s, aFIndividuArbre.lNom);
  aFIndividuPhotosEtDocs.lNom.Caption := CoupeChaine(s, aFIndividuPhotosEtDocs.lNom);
  aFIndividuObservations.lNom.Caption := CoupeChaine(s, aFIndividuObservations.lNom);
  aFIndividuDomiciles.lNom.Caption := CoupeChaine(s, aFIndividuDomiciles.lNom);
  aFIndividuActes.lNom.Caption := CoupeChaine(s, aFIndividuDomiciles.lNom);
end;

procedure TFIndividu.QueryIndividuNewRecord(DataSet: TDataSet);

var
  k: integer;
begin
  //l'ordre insert est dj fait.
  k := dm.uf_GetClefUnique('INDIVIDU');

  //table INDIVIDU
  fCleFiche := k;
  QueryIndividu.FieldByName('CLE_FICHE').AsInteger := k;
  QueryIndividu.FieldByName('SEXE').AsInteger := 0;
  QueryIndividu.FieldByName('CLE_IMPORTATION').AsString := inttostr(k);
  QueryIndividu.FieldByName('KLE_DOSSIER').AsInteger := dm.NumDossier;

end;

procedure TFIndividu.FlatSpeedButton1Click(Sender: TObject);
begin
  panNobody.visible := false;
  DoNouvelleFiche;
end;

procedure TFIndividu.ForceCloseAllQuerys;
begin
  doInitialize;
end;

procedure TFIndividu.SuperFormShowFirstTime(Sender: TObject);
begin
  Application.ProcessMessages;

  if aFCoherence.Visible then aFCoherence.BringToFront;
end;

procedure TFIndividu.FlatSpeedButton2Click(Sender: TObject);
begin
  AutoFreeOnClose := true;
  DoSendMessage(Owner, 'OPEN_IMPORT_GEDCOM_FROM_FICHE_INDIVIDU');
  Close;
end;

procedure TFIndividu.SuperFormShow(Sender: TObject);
begin                                        
  Application.ProcessMessages;

end;
{
procedure TFIndividu.Label10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;
}

procedure TFIndividu.btnFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFIndividu.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFIndividu.popup_PrecedentPopup(Sender: TObject);
var
  n: integer;
  item: TMenuItem;
  aFicheOpenInfo: TFicheOpenInfo;

begin
  //Nettoyage du popup
  for n := popup_Precedent.items.count - 1 downto 0 do popup_Precedent.items.delete(n);

  if (dm.FicheOpenIndex >= 0) and (dm.FicheOpenIndex < dm.ListFicheOpenInfos.Count) then
    begin
      for n := dm.FicheOpenIndex - 1 downto 0 do
        begin
          aFicheOpenInfo := TFicheOpenInfo(dm.ListFicheOpenInfos[n]);

          item := TMenuItem.create(self);
          item.caption := aFicheOpenInfo.TitreNomPrenom;
          case aFicheOpenInfo.Sexe of
            1: item.ImageIndex := 1;
            2: item.ImageIndex := 0;
            else
              item.ImageIndex := 2;
          end;
          item.Tag := n;
          item.OnClick := OnSelectIndividuInListPrevious;

          popup_Precedent.items.add(item);
        end;
    end;
end;

procedure TFIndividu.OnSelectIndividuInListPrevious(Sender: TObject);
begin
  doGoToFiche(TMenuItem(Sender).Tag, 0);
end;

procedure TFIndividu.OnSelectIndividuInListNext(Sender: TObject);
begin
  doGoToFiche(TMenuItem(Sender).Tag, 1);
end;

procedure TFIndividu.doGoToFiche(aIndexCleFicheInList, sens: integer);
var
  Ok: boolean;
begin
  dm.CanAddFicheOpenInList := false;
  try
    if VerifyCanCloseFiche then
      begin

        repeat
          ok := true;
          if (aIndexCleFicheInList >= 0) and (aIndexCleFicheInList < dm.ListFicheOpenInfos.Count) then
            begin
              if doOpenFiche(TFicheOpenInfo(dm.ListFicheOpenInfos[aIndexCleFicheInList]).CleFiche) then dm.FicheOpenIndex := aIndexCleFicheInList
              else
                begin
                  if Sens = 0 then
                    begin
                      if aIndexCleFicheInList > 0 then
                        begin
                          dec(aIndexCleFicheInList);
                          ok := false;
                        end;
                    end
                  else
                    begin
                      if aIndexCleFicheInList < dm.ListFicheOpenInfos.Count - 1 then
                        begin
                          inc(aIndexCleFicheInList);
                          ok := false;
                        end;
                    end;
                end;
            end;
        until (Ok = true);
      end;
  finally
    dm.CanAddFicheOpenInList := true;
  end;

  doRefreshControls;
end;

procedure TFIndividu.btnPrecedentClick(Sender: TObject);
var
  k: integer;
begin
  k := dm.FicheOpenIndex - 1;
  if (k >= 0) and (k < dm.ListFicheOpenInfos.Count)
    then doGoToFiche(k, 0);
end;

procedure TFIndividu.popup_SuivantPopup(Sender: TObject);
var
  n: integer;
  item: TMenuItem;
  aFicheOpenInfo: TFicheOpenInfo;

begin
  //Nettoyage du popup
  for n := popup_Suivant.items.count - 1 downto 0 do popup_Suivant.items.delete(n);

  if (dm.FicheOpenIndex >= 0) and (dm.FicheOpenIndex < dm.ListFicheOpenInfos.Count) then
    begin
      for n := dm.FicheOpenIndex + 1 to dm.ListFicheOpenInfos.Count - 1 do
        begin
          aFicheOpenInfo := TFicheOpenInfo(dm.ListFicheOpenInfos[n]);

          item := TMenuItem.create(self);
          item.caption := aFicheOpenInfo.TitreNomPrenom;
          case aFicheOpenInfo.Sexe of
            1: item.ImageIndex := 1;
            2: item.ImageIndex := 0;
            else
              item.ImageIndex := 2;
          end;
          item.Tag := n;
          item.OnClick := OnSelectIndividuInListNext;

          popup_Suivant.items.add(item);
        end;
    end;
end;

procedure TFIndividu.btnSuivantClick(Sender: TObject);
var
  k: integer;
begin
  k := dm.FicheOpenIndex + 1;
  if (k >= 0) and (k < dm.ListFicheOpenInfos.Count)
    then doGoToFiche(k, 1);
end;

procedure TFIndividu.LoadCoherenceDates;
var
  n: integer;
  s: string;
begin
  fCoherenceDate.Reset;

  if _Context.CoherenceActive then
    begin
      fCoherenceDate.Sexe := QueryIndividuSEXE.AsInteger;

      //rcupration des dates et des eve
      QueryGetDatesInd.Close;
      try
        QueryGetDatesInd.Params[0].AsInteger := fCleFiche;
        QueryGetDatesInd.Open;
        QueryGetDatesInd.Last;
        QueryGetDatesInd.First;

        for n := 0 to QueryGetDatesInd.RecordCount - 1 do
          begin
            s := QueryGetDatesInd.FieldByName('EV_TYPE').AsString;

            if s = 'BIRT' then
              begin
                if QueryGetDatesInd.FieldByName('EV_KLE_OWNER').AsInteger = fCleFiche then
                  begin
                    fCoherenceDate.Naissance.SetDateWriten(QueryGetDatesInd.FieldByName('EV_DATE_WRITEN').AsString);
                    fCoherenceDate.Naissance.LongEventName := QueryGetDatesInd_EVENT_LONG_NAME.AsString;
                  end;
              end
            else
              if s = 'DEAT' then
                begin
                  if QueryGetDatesInd.FieldByName('EV_KLE_OWNER').AsInteger = fCleFiche then
                    begin
                      fCoherenceDate.Deces.SetDateWriten(QueryGetDatesInd.FieldByName('EV_DATE_WRITEN').AsString);
                      fCoherenceDate.Deces.LongEventName := QueryGetDatesInd_EVENT_LONG_NAME.AsString;
                    end;
                end
              else
                if s = 'MARR' then
                  begin
                    fCoherenceDate.AddInfoDateWriten(
                      QueryGetDatesInd.FieldByName('EV_DATE_WRITEN').AsString,
                      '',
                      QueryGetDatesInd.FieldByName('EV_CLEF').AsInteger,
                      QueryGetDatesInd.FieldByName('EV_KLE_OWNER').AsInteger,
                      fCoherenceDate.Mariages,
                      QueryGetDatesInd_EVENT_LONG_NAME.AsString
                      );
                  end
                else
                  begin
                    if QueryGetDatesInd.FieldByName('S_TABLE').AsString = 'I' then
                      begin
                        fCoherenceDate.AddInfoDateWriten(
                          QueryGetDatesInd.FieldByName('EV_DATE_WRITEN').AsString,
                          QueryGetDatesInd.FieldByName('EV_TYPE').AsString,
                          QueryGetDatesInd.FieldByName('EV_CLEF').AsInteger,
                          QueryGetDatesInd.FieldByName('EV_KLE_OWNER').AsInteger,
                          fCoherenceDate.AutresEventInd,
                          QueryGetDatesInd_EVENT_LONG_NAME.AsString
                          );
                      end
                    else
                      if QueryGetDatesInd.FieldByName('S_TABLE').AsString = 'F' then
                        begin
                          fCoherenceDate.AddInfoDateWriten(
                            QueryGetDatesInd.FieldByName('EV_DATE_WRITEN').AsString,
                            QueryGetDatesInd.FieldByName('EV_TYPE').AsString,
                            QueryGetDatesInd.FieldByName('EV_CLEF').AsInteger,
                            QueryGetDatesInd.FieldByName('EV_KLE_OWNER').AsInteger,
                            fCoherenceDate.AutresEventUnion,
                            QueryGetDatesInd_EVENT_LONG_NAME.AsString
                            );
                        end;
                  end;

            QueryGetDatesInd.Next;
          end;

      finally
        QueryGetDatesInd.Close;
      end;

      //rcupration des dates de naissance des enfants
      QueryGetAllEnfants.Close;
      try
        //soit c'est un homme
        if QueryIndividuSEXE.AsInteger = 1 then
          begin
            QueryGetAllEnfants.Params[0].AsInteger := fCleFiche;
            QueryGetAllEnfants.Params[1].AsInteger := 0;
          end
        else
          begin
            QueryGetAllEnfants.Params[0].AsInteger := 0;
            QueryGetAllEnfants.Params[1].AsInteger := fCleFiche;
          end;
        QueryGetAllEnfants.Params[2].AsInteger := dm.NumDossier;


        QueryGetAllEnfants.Open;
        QueryGetAllEnfants.Last;
        QueryGetAllEnfants.First;

        for n := 0 to QueryGetAllEnfants.RecordCount - 1 do
          begin
            fCoherenceDate.AddInfoDateWriten(
              QueryGetAllEnfants.FieldByName('DATE_NAISSANCE').AsString,
              '',
              -1,
              -1,
              fCoherenceDate.NaissancesEnfants,
              '');

            QueryGetAllEnfants.Next;
          end;

      finally
        QueryGetAllEnfants.Close;
      end;
    end;
end;

procedure TFIndividu.btnPbCoherenceClick(Sender: TObject);
begin
  aFCoherence.Refresh;
  aFCoherence.Show;
end;

function TFIndividu.ChangeFicheActive(aCleFiche: integer): boolean;
begin
  if VerifyCanCloseFiche then result := doOpenFiche(aCleFiche) else result := false;
end;

procedure TFIndividu.btnPrintClick(Sender: TObject);
var bZoom: Boolean;
begin
  bZoom := aFIndividuArbre.oc.Zoom;
  aFIndividuArbre.oc.Options := [];
  aFIndividuArbre.oc.Zoom := False;
  FMain.doPrint(1);
  aFIndividuArbre.DoRefreshControls;
  aFIndividuArbre.oc.Zoom := bZoom;
end;

procedure TFIndividu.QueryIndividuCalcFields(DataSet: TDataSet);
var s_Chaine: string;
begin
  if Length(QueryIndividuDATE_CREATION.AsString) > 0 then
    s_Chaine := 'Fiche cre le : ' + FormatDateTime('dd mmmm yyyy', QueryIndividuDATE_CREATION.AsDateTime);

  if Length(QueryIndividuDATE_MODIF.AsString) > 0 then
    s_Chaine := s_Chaine + ' - modifie le : ' + FormatDateTime('dddd dd mmmm yyyy "  " hh:mm', QueryIndividuDATE_MODIF.AsDateTime);

  QueryIndividuINFOS_DATE.AsString := s_Chaine;

end;

procedure TFIndividu.SuperFormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

end.

