{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_Actes;

interface

uses
  Windows, Messages, Forms, u_comp_TYLanguage, Controls, StdCtrls, Classes,
  ExtCtrls, CompSuperForm, DB, IBCustomDataSet, IBQuery, dxCntner, dxTL,
  dxDBCtrl, dxDBGrid, TFlatPanelUnit, dxDBTLCl, dxGrClms, IBUpdateSQL, Jpeg,
  Dialogs, u_comp_TGoodBtn, IBStoredProc, Menus, ImgList, dxExEdtr;

type

  TFIndividuActes = class(TSuperForm)
    Panel10: TPanel;
    Panel13: TPanel;
    lNom: TLabel;
    Label8: TLabel;
    Language: TYLanguage;
    IBActes: TIBQuery;
    DSActes: TDataSource;
    PanelPrenom: TFlatPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    dxDBGrid1Column3: TdxDBGridColumn;
    dxDBGrid1Column4: TdxDBGridColumn;
    dxDBGrid1Column5: TdxDBGridCheckColumn;
    IBUpdateActes: TIBUpdateSQL;
    IBActesEVE_CLEF: TIntegerField;
    IBActesEVE_TYPE: TIBStringField;
    IBActesEVE_LIB_LONG: TIBStringField;
    IBActesEVE_DATE_WRITEN: TIBStringField;
    IBActesEVE_CP: TIBStringField;
    IBActesEVE_VILLE: TIBStringField;
    IBActesEVE_ACTE: TIntegerField;
    IBActesEVE_TABLE: TIBStringField;
    FlatPanel1: TFlatPanel;
    dxDBGrid2: TdxDBGrid;
    dxDBGridColumn1: TdxDBGridColumn;
    dxDBGridColumn2: TdxDBGridColumn;
    dxDBGridColumn3: TdxDBGridColumn;
    dxDBGridColumn4: TdxDBGridColumn;
    IBActesTrouves: TIBQuery;
    DSActesTrouves: TDataSource;
    IBActesTrouvesEVE_CLEF: TIntegerField;
    IBActesTrouvesEVE_TYPE: TIBStringField;
    IBActesTrouvesEVE_LIB_LONG: TIBStringField;
    IBActesTrouvesEVE_DATE_WRITEN: TIBStringField;
    IBActesTrouvesEVE_CP: TIBStringField;
    IBActesTrouvesEVE_VILLE: TIBStringField;
    IBActesTrouvesEVE_ACTE: TIntegerField;
    IBActesTrouvesEVE_TABLE: TIBStringField;
    FlatPanel2: TFlatPanel;
    dxDBGrid3: TdxDBGrid;
    dxDBGridColumn6: TdxDBGridColumn;
    dxDBGridColumn7: TdxDBGridColumn;
    dxDBGridColumn8: TdxDBGridColumn;
    dxDBGridColumn9: TdxDBGridColumn;
    dxDBGridCheckColumn1: TdxDBGridCheckColumn;
    dxDBGridColumn10: TdxDBGridColumn;
    Label1: TLabel;
    lActesIndi: TLabel;
    lActesFam: TLabel;
    bsbraz: TGoodBtn;
    IBUActesFam: TIBUpdateSQL;
    IBActesFam: TIBQuery;
    DSActesFam: TDataSource;
    IBActesFamEVE_CLEF: TIntegerField;
    IBActesFamEVE_TYPE: TIBStringField;
    IBActesFamEVE_LIB_LONG: TIBStringField;
    IBActesFamEVE_DATE_WRITEN: TIBStringField;
    IBActesFamEVE_CP: TIBStringField;
    IBActesFamEVE_VILLE: TIBStringField;
    IBActesFamEVE_ACTE: TIntegerField;
    IBActesFamEVE_TABLE: TIBStringField;
    IBSPRaz: TIBStoredProc;
    pmActesIndi: TPopupMenu;
    mPrintActesIndi: TMenuItem;
    SaveDialog: TSaveDialog;
    pmActesFam: TPopupMenu;
    MenuItem1: TMenuItem;
    pmTous: TPopupMenu;
    MenuItem2: TMenuItem;
    N1: TMenuItem;
    mOpenActe: TMenuItem;
    IBMultimedia: TIBQuery;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    IBActesTrouvesEVE_IMAGE: TIntegerField;
    dxDBGrid2Column5: TdxDBGridImageColumn;
    ImageList: TImageList;
    IBActesTrouvesIMAGE: TIntegerField;
    colImegaActe: TdxDBGridButtonColumn;
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure DSActesStateChange(Sender: TObject);
    procedure bsbrazClick(Sender: TObject);
    procedure mPrintActesIndiClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure pmTousPopup(Sender: TObject);
    procedure pmActesIndiPopup(Sender: TObject);
    procedure pmActesFamPopup(Sender: TObject);
    procedure mOpenActeClick(Sender: TObject);
    procedure IBActesTrouvesCalcFields(DataSet: TDataSet);
    procedure colImegaActeButtonClick(Sender: TObject;
      AbsoluteIndex: Integer);
  private
    fFormIndividu: TForm;

    procedure SetFormIndividu(const Value: TForm);

  public
    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;

    procedure doInitialize;
    function doOpenQuerys: boolean;

  end;

implementation

uses u_dm, u_common_const, u_common_var, u_form_individu,
  u_form_biblio_Multimedia_Edit, u_Form_Bibliotheque_Multimedia;

{$R *.DFM}

procedure TFIndividuActes.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;
end;

procedure TFIndividuActes.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fFormIndividu := nil;
end;


procedure TFIndividuActes.SuperFormRefreshControls(Sender: TObject);
begin
  DSActes.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
  DSActesFam.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
  //doInitialize;
end;

procedure TFIndividuActes.doInitialize;
begin
  IBActesTrouves.DisableControls;
  try
    IBActesTrouves.Close;
    IBActesTrouves.Params[0].AsInteger := TFIndividu(fFormindividu).CleFiche; {Cle de l'individu}
    IBActesTrouves.Open;
  finally
    IBActesTrouves.EnableControls;
  end;

  IBActes.DisableControls;
  try
    IBActes.Close;
    IBActes.Params[0].AsInteger := TFIndividu(fFormindividu).CleFiche; {Cle de l'individu}
    IBActes.Open;
  finally
    IBActes.EnableControls;
  end;

  IBActesFam.DisableControls;
  try
    IBActesFam.Close;
    IBActesFam.Params[0].AsInteger := TFIndividu(fFormindividu).CleFiche; {Cle de l'individu}
    IBActesFam.Open;
  finally
    IBActesFam.EnableControls;
  end;

  bsbraz.Enabled := dxDBGrid2.Count > 0;
end;

function TFIndividuActes.doOpenQuerys: boolean;
begin

  doInitialize;
  result := true;
end;

procedure TFIndividuActes.DSActesStateChange(Sender: TObject);
begin
  TFIndividu(FormIndividu).DoRefreshControls;
end;

procedure TFIndividuActes.bsbrazClick(Sender: TObject);
begin
  IBSPRaz.ParamByName('INDI').AsInteger := TFIndividu(fFormindividu).CleFiche;
  IBSPRaz.ExecProc;
  doInitialize;
  DSActes.Edit;
  TFIndividu(FormIndividu).DoRefreshControls;
end;

procedure TFIndividuActes.mPrintActesIndiClick(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := lActesIndi.Caption + '.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBActes.DisableControls;
      try
        SavePlace := IBActes.GetBookmark;
        dxDBGrid1.SaveToHTML(s_Fichier, True);
      finally
        IBActes.GotoBookmark(SavePlace);
        IBActes.FreeBookmark(SavePlace);

        IBActes.EnableControls;

      end;
    end;

end;

procedure TFIndividuActes.MenuItem1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := lActesFam.Caption + '.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBActesFam.DisableControls;
      try
        SavePlace := IBActesFam.GetBookmark;
        dxDBGrid3.SaveToHTML(s_Fichier, True);
      finally
        IBActesFam.GotoBookmark(SavePlace);
        IBActesFam.FreeBookmark(SavePlace);

        IBActesFam.EnableControls;

      end;
    end;
end;

procedure TFIndividuActes.MenuItem2Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := Label1.Caption + '.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBActesTrouves.DisableControls;
      try
        SavePlace := IBActesTrouves.GetBookmark;
        dxDBGrid2.SaveToHTML(s_Fichier, True);
      finally
        IBActesTrouves.GotoBookmark(SavePlace);
        IBActesTrouves.FreeBookmark(SavePlace);

        IBActesTrouves.EnableControls;

      end;
    end;
end;

procedure TFIndividuActes.pmTousPopup(Sender: TObject);
begin
  MenuItem2.Enabled := dxDBGrid2.Count > 0;

  with IBMultimedia do
    begin
      //     Params[0].AsInteger := dm.NumDossier;
      Params[0].AsInteger := IBActesTrouvesEVE_CLEF.AsInteger;
      Params[1].AsString := IBActesTrouvesEVE_TABLE.AsString;
      Open;
      Last;
      First;
      MOpenActe.Enabled := RecordCount > 0;
      Close;
    end;
end;

procedure TFIndividuActes.pmActesIndiPopup(Sender: TObject);
begin
  mPrintActesIndi.Enabled := dxDBGrid1.Count > 0;
end;

procedure TFIndividuActes.pmActesFamPopup(Sender: TObject);
begin
  MenuItem1.Enabled := dxDBGrid3.Count > 0;
end;

procedure TFIndividuActes.mOpenActeClick(Sender: TObject);
var
  aFMultimediEdit: TFBiblio_Multimedia_Edit;

begin
  aFMultimediEdit := TFBiblio_Multimedia_Edit.create(self);
  try
    //   IBMultimedia.Params[0].AsInteger := dm.NumDossier;
    IBMultimedia.Params[0].AsInteger := IBActesTrouvesEVE_CLEF.AsInteger;
    //    IBMultimedia.Params[2].AsString := IBActesTrouvesEVE_TABLE.AsString;
    IBMultimedia.Open;

    aFMultimediEdit.doInitialise(IBMultimediaMULTI_CLEF.AsInteger, lNom.Caption);

    Application.ProcessMessages;
    aFMultimediEdit.ShowModal;
    IBMultimedia.Close;
  finally
    aFMultimediEdit.Free;
  end;
end;

procedure TFIndividuActes.IBActesTrouvesCalcFields(DataSet: TDataSet);
begin
  IBActesTrouvesIMAGE.AsInteger := 0;
  if IBActesTrouvesEVE_IMAGE.AsInteger > 0 then
    IBActesTrouvesIMAGE.AsInteger := 1;
end;

procedure TFIndividuActes.colImegaActeButtonClick(Sender: TObject;
  AbsoluteIndex: Integer);
var aFBibliothequeMultimedia: TFBibliothequeMultimedia;
begin

  aFBibliothequeMultimedia := TFBibliothequeMultimedia.create(self);
  try

    aFBibliothequeMultimedia.doInit(True, IBActesTrouvesEVE_CLEF.AsInteger, IBActesTrouvesEVE_TABLE.AsString, 'A');
    aFBibliothequeMultimedia.ShowModal;

    IBMultimedia.DisableControls;

    if aFBibliothequeMultimedia.Clef > 0 then
      begin
        //  doAddPointeur(aFBibliothequeMultimedia.Clef);

        TFIndividu(fFormindividu).Modified := true;
        TFIndividu(FormIndividu).DoRefreshControls;
      end;
  finally
    aFBibliothequeMultimedia.Free;
  end;
  Application.ProcessMessages;
end;

end.
