{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_Affecte_Enfant;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, Db, Dialogs,
  IBCustomDataSet, IBQuery, dxDBGrid, dxTL, dxDBCtrl, dxDBTLCl, dxGrClms,
  dxCntner, jpeg, ComCtrls, ImgList,
  TFlatSpeedButtonUnit, u_comp_TGoodBtn, u_comp_TYLanguage, dxExEdtr,
  DynamicSkinForm;

type
  TFAffecte_Enfant = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    IBQPere: TIBQuery;
    ImagCat: TImageList;
    Panel1: TPanel;
    Image1: TImage;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    IBQMere: TIBQuery;
    IBQMereNOM: TIBStringField;
    IBQMerePRENOM: TIBStringField;
    IBQMereSEXE: TIntegerField;
    IBQPereNOM: TIBStringField;
    IBQPerePRENOM: TIBStringField;
    IBQPereSEXE: TIntegerField;
    lPere: TLabel;
    lMere: TLabel;
    IBQEnfant: TIBQuery;
    lEnfant: TLabel;
    IBQEnfantNOM: TIBStringField;
    IBQEnfantPRENOM: TIBStringField;
    IBQEnfantSEXE: TIntegerField;
    Label1: TLabel;
    Label2: TLabel;
    btnNonPere: TGoodBtn;
    btnNonMere: TGoodBtn;
    Label3: TLabel;
    IBQMereCLE_FICHE: TIntegerField;
    IBQPereCLE_FICHE: TIntegerField;
    Shape1: TShape;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnOkClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnNonPereClick(Sender: TObject);
    procedure btnNonMereClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
  private
    fDialogMode: boolean;
    fClefPere: integer;
    fClefMere: integer;
    iPere, iMere: Integer;

    procedure SetDialogMode(const Value: boolean);
    procedure doSelect;
  public
    property ClefMere: integer read fClefMere write fClefMere;
    property ClefPere: integer read fClefPere write fClefPere;

    property DialogMode: boolean read fDialogMode write SetDialogMode;

    procedure DoInit(I_CLEF, I_CONJOINT, I_ENFANT: Integer);
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_form_individu_par_prenom,
  u_form_main;


{$R *.DFM}

procedure TFAffecte_Enfant.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  if _Context.Skin then
    begin
      ClientHeight := 198;
      ClientWidth := 435;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fDialogMode := false;

end;

procedure TFAffecte_Enfant.DoInit(I_CLEF, I_CONJOINT, I_ENFANT: Integer);
begin
  Screen.Cursor := crHourglass;

  fClefPere := -1;
  fClefMere := -1;

  lPere.Font.Color := _Context.ColorHomme;
  lMere.Font.Color := _Context.ColorFemme;

  IBQEnfant.Close;
  IBQEnfant.Params[0].AsInteger := I_ENFANT;
  IBQEnfant.Open;
  lEnfant.Caption := IBQEnfantNOM.AsString + ', ' + IBQEnfantPRENOM.AsString;

  if IBQEnfantSEXE.AsInteger = 1 then
    lEnfant.Font.Color := _Context.ColorHomme
  else
    lEnfant.Font.Color := _Context.ColorFemme;

  IBQEnfant.Close;

  IBQPere.Close;
  IBQPere.Params[0].AsInteger := I_CLEF;
  IBQPere.Open;

  if IBQPereSEXE.AsInteger = 1 then
    begin
      lPere.Caption := IBQPereNOM.AsString + ', ' + IBQPerePRENOM.AsString;
      btnNonPere.Visible := False;
      fClefPere := IBQPereCLE_FICHE.AsInteger;
      iPere := fClefPere;
    end
  else
    begin
      lmere.Caption := IBQPereNOM.AsString + ', ' + IBQPerePRENOM.AsString;
      btnNonMere.Visible := False;
      fClefMere := IBQPereCLE_FICHE.AsInteger;
      iMere := fClefMere;
    end;

  IBQMere.Close;
  IBQMere.Params[0].AsInteger := I_CONJOINT;
  IBQMere.Open;

  if IBQMereSEXE.AsInteger = 1 then
    lPere.Caption := IBQMereNOM.AsString + ', ' + IBQMerePRENOM.AsString
  else
    lmere.Caption := IBQMereNOM.AsString + ', ' + IBQMerePRENOM.AsString;

  Screen.Cursor := crDefault;
end;

procedure TFAffecte_Enfant.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFAffecte_Enfant.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFAffecte_Enfant.btnOkClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFAffecte_Enfant.doSelect;
begin
  if iPere > 0 then fClefPere := iPere;
  if iMere > 0 then fClefMere := iMere;

  ModalResult := mrOk;
end;

procedure TFAffecte_Enfant.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFAffecte_Enfant.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    // _KEY_HELP: dm.ShowHelp(_HELP_INDI_IDENTITE);
  end;
end;

procedure TFAffecte_Enfant.btnNonPereClick(Sender: TObject);
var
  aFIndividuPrenom: TFIndividuPrenom;
  aLettre: string;
begin
  aFIndividuPrenom := TFIndividuPrenom.create(self);

  try
    aFIndividuPrenom.Position := poMainFormCenter;

    aLettre := Copy(lPere.Caption, 1, 1);

    aFIndividuPrenom.up_InitIndividuPrenom(aLettre, '', 1, 2);

    if aFIndividuPrenom.ShowModal = mrOk then

      if aFIndividuPrenom.ClefIndividuSelected = 1 then
        ShowMessage('L''individu ne peux pas tre  la fois, lui mme et son pere')
      else
        begin
          IBQPere.Close;
          IBQPere.Params[0].AsInteger := aFIndividuPrenom.ClefIndividuSelected;
          IBQPere.Open;

          lPere.Caption := IBQPereNOM.AsString + ', ' + IBQPerePRENOM.AsString;
          iPere := aFIndividuPrenom.ClefIndividuSelected;
          bsfbSelection.Visible := IBQMereCLE_FICHE.AsInteger > 0;
          if bsfbSelection.Visible then
            btnFermer.Caption := 'Annuler'
          else
            btnFermer.Caption := 'OK';
        end
  finally
    aFIndividuPrenom.Free;
  end;
end;

procedure TFAffecte_Enfant.btnNonMereClick(Sender: TObject);
var
  aFIndividuPrenom: TFIndividuPrenom;
  // aLettre: string;
begin
  aFIndividuPrenom := TFIndividuPrenom.create(self);

  try
    aFIndividuPrenom.Position := poMainFormCenter;

    aFIndividuPrenom.up_InitIndividuPrenom('', '', 2, 2);

    if aFIndividuPrenom.ShowModal = mrOk then

      if aFIndividuPrenom.ClefIndividuSelected = 1 then
        ShowMessage('L''individu ne peux pas tre  la fois, lui mme et sa mre')
      else
        begin
          IBQMere.Close;
          IBQMere.Params[0].AsInteger := aFIndividuPrenom.ClefIndividuSelected;
          IBQMere.Open;

          lmere.Caption := IBQMereNOM.AsString + ', ' + IBQMerePRENOM.AsString;
          iMere := aFIndividuPrenom.ClefIndividuSelected;

          bsfbSelection.Visible := IBQMereCLE_FICHE.AsInteger > 0;
          if bsfbSelection.Visible then
            btnFermer.Caption := 'Annuler'
          else
            btnFermer.Caption := 'OK';
        end
  finally
    aFIndividuPrenom.Free;
  end
end;

procedure TFAffecte_Enfant.SuperFormDestroy(Sender: TObject);
begin
  IBQPere.Close;
  IBQMere.Close;
end;

end.
