{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_Domiciles;

interface

uses
  forms, Windows, CompSuperForm, Classes, Controls, dxCntner, dxTL, dxDBGrid,
  ExtCtrls, TFlatTabControlUnit, StdCtrls, Graphics,
  TFlatPanelUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery,
  u_comp_TBlueFlatSpeedButton, DBCtrls, dxEdLib, dxDBELib, dxEditor,
  dxExEdtr, dxDBCtrl, Buttons, TFlatButtonUnit, URLLink,
  TFlatSpeedButtonUnit, u_comp_TGoodBtn, ShellApi, u_comp_TYLanguage, Menus;

type
  TFIndividuDomiciles = class(TSuperForm)
    dsAdresses: TDataSource;
    IBQAdresses: TIBQuery;
    IBUAdresses: TIBUpdateSQL;
    Panel10: TPanel;
    Panel13: TPanel;
    IBQAdressesADR_CLEF: TIntegerField;
    IBQAdressesADR_KLE_DOSSIER: TIntegerField;
    IBQAdressesADR_KLE_IND: TIntegerField;
    IBQAdressesADR_ADRESSE: TBlobField;
    IBQAdressesADR_CP: TIBStringField;
    IBQAdressesADR_VILLE: TIBStringField;
    IBQAdressesADR_DEPT: TIBStringField;
    IBQAdressesADR_REGION: TIBStringField;
    IBQAdressesADR_PAYS: TIBStringField;
    IBQAdressesADR_TEL: TBlobField;
    IBQAdressesADR_MAIL: TIBStringField;
    lNom: TLabel;
    Label8: TLabel;
    IBQAdressesADR_TYPE: TIntegerField;
    Language: TYLanguage;
    Panel1: TPanel;
    PanelPrenom: TFlatPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBGCVille: TdxDBGridColumn;
    dxDBGCPays: TdxDBGridColumn;
    Panel2: TPanel;
    bfsbAjoutAdresse: TGoodBtn;
    bfsbDeleteAdresse: TGoodBtn;
    Panel3: TPanel;
    fpAdresses: TFlatPanel;
    Label6: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    Label9: TLabel;
    sDBMAdresse: TdxDBMemo;
    sDBECP: TdxDBEdit;
    sDBERegion: TdxDBEdit;
    sDBEPays: TdxDBEdit;
    sDBEMail: TdxDBEdit;
    sDBMemo1: TdxDBMemo;
    edVille: TdxDBPickEdit;
    edDept: TdxDBEdit;
    btnSearchVille: TGoodBtn;
    FlatSpeedButton1: TGoodBtn;
    fbInfosVilles: TGoodBtn;
    fbPays: TGoodBtn;
    btnEMail: TGoodBtn;
    fbCarte: TGoodBtn;
    IBQAdressesADR_DATE_WRITEN: TIBStringField;
    Label10: TLabel;
    sDBMDate: TdxDBEdit;
    pmDate: TPopupMenu;
    ibqToken: TIBQuery;
    ibqTokenTOKEN: TIBStringField;
    IBQAdressesADR_DATE_YEAR_1: TIntegerField;
    IBQAdressesADR_DATE_YEAR_2: TIntegerField;
    IBQAdressesADR_DATE_1: TDateField;
    IBQAdressesADR_DATE_2: TDateField;
    edVille_f: TdxDBEdit;
    lbDay: TLabel;
    dxDBGrid1Column3: TdxDBGridColumn;
    fbCalend: TGoodBtn;
    procedure ftAdresseTabChanged(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure bfsbAjoutAdresseClick(Sender: TObject);
    procedure bfsbDeleteAdresseClick(Sender: TObject);
    procedure IBQAdressesNewRecord(DataSet: TDataSet);
    procedure dsAdressesStateChange(Sender: TObject);
    procedure fbInfosVillesClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure btnSearchVilleClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure sDBECPChange(Sender: TObject);
    procedure edVilleChange(Sender: TObject);
    procedure FlatSpeedButton1Click(Sender: TObject);
    procedure btnEMailClick(Sender: TObject);
    procedure sDBEMailChange(Sender: TObject);
    procedure fbPaysClick(Sender: TObject);
    procedure fbCarteClick(Sender: TObject);
    procedure dxDBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OnKeyDownHelp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sDBMDateChange(Sender: TObject);
    procedure IBQAdressesBeforePost(DataSet: TDataSet);
    procedure IBQAdressesAfterScroll(DataSet: TDataSet);
    procedure fbCalendClick(Sender: TObject);

  private
    l_Cp, l_Dept, l_Pays, l_Villes, l_Region: TStringList;
    fFormIndividu: TForm;
    procedure SetFormIndividu(const Value: TForm);
    procedure up_SubMenu(Sender: TObject);
    procedure doShowDay;
  public
    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;

    procedure doInitialize;
    function doOpenQuerys: boolean;

  end;

implementation

uses u_dm, u_form_individu, u_form_list_villes, u_common_func,
  SysUtils, u_form_Ville_Favoris, u_form_Pays, u_common_const, u_common_var,
  u_form_calendriers;

{$R *.DFM}

function TFIndividuDomiciles.doOpenQuerys: boolean;
begin
  ftAdresseTabChanged(Self);
  Result := True;
  dsAdresses.autoEdit := (TFIndividu(fFormindividu).DialogMode = false);
end;

procedure TFIndividuDomiciles.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;
end;

procedure TFIndividuDomiciles.ftAdresseTabChanged(Sender: TObject);
begin
  IBQAdresses.DisableControls;
  IBQAdresses.Close;
  IBQAdresses.Params[0].AsInteger := dm.NumDossier;
  IBQAdresses.Params[1].AsInteger := TFIndividu(fFormindividu).CleFiche;
  IBQAdresses.Open;
  IBQAdresses.EnableControls;
  doShowDay;
end;

procedure TFIndividuDomiciles.SuperFormCreate(Sender: TObject);
var i: integer;
  NewItem: TMenuItem;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  lbDay.caption := '';

  fFormIndividu := nil;
  l_CP := TStringList.Create;
  l_Dept := TStringList.Create;
  l_Pays := TStringList.Create;
  l_Villes := TStringList.Create;
  l_Region := TStringList.Create;

  ibqToken.Params[0].AsString := _Context.Langue;
  ibqToken.Open;
  i := 0;
  while not ibqToken.Eof do
    begin
      //pmDate.Items.Add (ibqToken.ParamByName('TOKEN').AsString);
      NewItem := TMenuItem.Create(Self);
      NewItem.Caption := ibqTokenTOKEN.AsString;
      pmDate.Items.Add(NewItem);
      pmDate.Items[i].OnClick := up_SubMenu;
      ibqToken.next;
      inc(i);
    end;

  ibqToken.Close;
end;

procedure TFIndividuDomiciles.up_SubMenu(Sender: TObject);
var sToken: string;
begin
  sToken := (sender as TMenuItem).Caption;

  if (not (IBQAdresses.State in [dsEdit, dsInsert])) then
    IBQAdresses.Edit;

  if sDBMDate.text = '' then
    IBQAdresses.FieldByName('ADR_DATE_WRITEN').AsString := sToken
  else
    IBQAdresses.FieldByName('ADR_DATE_WRITEN').AsString := sDBMDate.text + ' ' + sToken;

  sDBMDate.SelStart := Length(sDBMDate.text) + 1
end;

procedure TFIndividuDomiciles.bfsbAjoutAdresseClick(Sender: TObject);
begin
  IBQAdresses.Append;
  IBQAdresses.Post;
  TFIndividu(FormIndividu).DoRefreshControls;
  sDBMDate.SetFocus;
  doShowDay;
end;

procedure TFIndividuDomiciles.bfsbDeleteAdresseClick(Sender: TObject);
begin
  IBQAdresses.Delete;
  DoRefreshControls;
  TFIndividu(fFormindividu).Modified := true;
  TFIndividu(FormIndividu).DoRefreshControls;

  doShowDay;
end;

procedure TFIndividuDomiciles.IBQAdressesNewRecord(DataSet: TDataSet);
var
  k: integer;
begin
  k := dm.uf_GetClefUnique('ADRESSES_IND');
  IBQAdressesADR_CLEF.AsInteger := k;
  IBQAdressesADR_KLE_IND.AsInteger := TFIndividu(fFormindividu).CleFiche;
  IBQAdressesADR_KLE_DOSSIER.AsInteger := dm.NumDossier;
  IBQAdressesADR_TYPE.AsInteger := 1;
end;

procedure TFIndividuDomiciles.doInitialize;
begin
  IBQAdresses.Close;
end;

procedure TFIndividuDomiciles.dsAdressesStateChange(Sender: TObject);
begin
  TFIndividu(FormIndividu).DoRefreshControls;
end;

procedure TFIndividuDomiciles.fbInfosVillesClick(Sender: TObject);
var
  aFListVilles: TFListVilles;
begin
  aFListVilles := TFListVilles.create(self);
  try

    if aFListVilles.ShowModal = mrOk then
      begin
        if not (IBQAdresses.State in [dsEdit, dsInsert]) then IBQAdresses.Edit;

        IBQAdresses.FieldByName('ADR_CP').asString := aFListVilles.Code;
        IBQAdresses.FieldByName('ADR_VILLE').asString := aFListVilles.Ville;
        IBQAdresses.FieldByName('ADR_PAYS').asString := aFListVilles.Pays;
        IBQAdresses.FieldByName('ADR_DEPT').asString := aFListVilles.Dept;
        IBQAdresses.FieldByName('ADR_REGION').asString := aFListVilles.Region;
      end;
  finally
    aFListVilles.Free;
  end;
end;

procedure TFIndividuDomiciles.SuperFormRefreshControls(Sender: TObject);
var
  ok: boolean;
begin
  ok := (TFIndividu(fFormindividu).CleFiche <> -1) and
    (IBQAdresses.active) and
    (IBQAdresses.IsEmpty = False) and
    (TFIndividu(fFormindividu).DialogMode = false);

  bfsbAjoutAdresse.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and
    (IBQAdresses.active) and (
    TFIndividu(fFormindividu).DialogMode = false);

  bfsbDeleteAdresse.enabled := Ok;

  btnSearchVille.enabled := ok;
  FlatSpeedButton1.enabled := ok;

  edVille_f.enabled := ok;
  fpAdresses.enabled := ok;
  fbPays.enabled := ok;
  fbInfosVilles.enabled := ok;
  fbCarte.enabled := ok;

  sDBMDate.enabled := ok;
  sDBMAdresse.enabled := ok;
  sDBECP.enabled := ok;
  edDept.enabled := ok;
  edVille.enabled := ok;
  sDBERegion.enabled := ok;
  sDBEPays.enabled := ok;
  sDBEMail.enabled := ok;
  sDBMemo1.enabled := ok;
  btnEMail.enabled := Ok and (trim(sDBEMail.Text) <> '');

  Label10.enabled := ok;
  Label6.enabled := ok;
  Label1.enabled := ok;
  Label9.enabled := ok;
  Label3.enabled := ok;
  Label4.enabled := ok;
  Label7.enabled := ok;
  Label5.enabled := ok;
  Label2.enabled := ok;

  dsAdresses.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);

  //     lNom.Caption := AssembleString([TFIndividu(fFormindividu).QueryIndividuNOM.AsString,          TFIndividu(fFormindividu).QueryIndividuPRENOM.AsString]);

  edVille.Items.clear;
  edVille.Visible := False;
  edVille_f.Visible := True;

end;

procedure TFIndividuDomiciles.btnSearchVilleClick(Sender: TObject);
var aProc: TIBQuery;
begin
  aProc := TIBQuery.create(self);

  try
    aProc.Database := dm.ibd_BASE;
    aProc.Transaction := dm.IBTrans_Secondaire;

    aProc.SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_CP(:I_CODE)');
    //aProc.Params[0].AsString := TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_CP.asString;
    aProc.Params[0].AsString := sDBECP.Text;
    aProc.Open;

    edVille_f.Clear;
    edVille.Items.Clear;
    l_Cp.Clear;
    l_Dept.Clear;
    l_Pays.Clear;
    l_Villes.Clear;
    l_Region.Clear;

    while not aProc.eof do
      begin
        edVille.Items.Add(aProc.FieldByName('VILLE').AsString);

        l_Villes.Add(aProc.FieldByName('VILLE').AsString);
        l_CP.Add(aProc.FieldByName('CODE').AsString);
        l_Dept.Add(aProc.FieldByName('DEPARTEMENT').AsString);
        l_Pays.Add(aProc.FieldByName('PAYS').AsString);
        l_Region.Add(aProc.FieldByName('REGION').AsString);

        aProc.next;
      end;

    if l_Villes.Count > 0 then
      begin
        if (not (IBQAdresses.State in [dsEdit, dsInsert])) then IBQAdresses.Edit;
        IBQAdresses.FieldByName('ADR_CP').asString := l_CP[0];
        IBQAdresses.FieldByName('ADR_VILLE').AsString := l_Villes[0];
        IBQAdresses.FieldByName('ADR_DEPT').asString := l_Dept[0];
        IBQAdresses.FieldByName('ADR_PAYS').asString := l_Pays[0];
        IBQAdresses.FieldByName('ADR_REGION').asString := l_Region[0];
      end;

    if edVille.Items.Count > 1 then
      begin
        edVille.DroppedDown := True;
        edVille.Top := edVille_f.Top;
        edVille.Left := edVille_f.Left;
        edVille.Width := edVille_f.Width;

        edVille.Visible := True;
        edVille_f.Visible := False;
      end
    else
      begin
        edVille.Visible := False;
        edVille_f.Visible := True;
      end;

  finally
    aProc.Free;
  end;
end;


procedure TFIndividuDomiciles.SuperFormDestroy(Sender: TObject);
begin
  l_CP.Free;
  l_Dept.Free;
  l_Pays.Free;
  l_Villes.Free;
  l_Region.Free;
end;

procedure TFIndividuDomiciles.sDBECPChange(Sender: TObject);
begin
  edVille.items.Clear;
  edVille_f.Clear;

  l_CP.Clear;
  l_Dept.Clear;
  l_Pays.Clear;
  l_Villes.Clear;
  l_Region.Clear;
  edDept.Text := '';
  edVille.Text := '';
  sDBEPays.Text := '';
  sDBERegion.Text := '';
end;

procedure TFIndividuDomiciles.edVilleChange(Sender: TObject);
var
  k: integer;
begin
  //on recherche la ville dans la liste
 // k := l_Villes.IndexOf(AnsiUpperCase(IBQAdresses.FieldByName('ADR_VILLE').AsString));
  k := l_Villes.IndexOf(AnsiUpperCase(edVille.Text));

  if k <> -1 then
    begin
      IBQAdresses.FieldByName('ADR_CP').asString := l_CP[k];
      IBQAdresses.FieldByName('ADR_DEPT').asString := l_Dept[k];
      IBQAdresses.FieldByName('ADR_PAYS').asString := l_Pays[k];
      IBQAdresses.FieldByName('ADR_REGION').asString := l_Region[k];
    end;
end;


procedure TFIndividuDomiciles.FlatSpeedButton1Click(Sender: TObject);
var
  aFVillesFavoris: TFVillesFavoris;
begin
  aFVillesFavoris := TFVillesFavoris.create(self);
  try
    if aFVillesFavoris.ShowModal = mrOk then
      begin
        if not (IBQAdresses.State in [dsEdit, dsInsert]) then IBQAdresses.Edit;

        IBQAdresses.FieldByName('ADR_CP').asString := aFVillesFavoris.Code;
        IBQAdresses.FieldByName('ADR_VILLE').asString := aFVillesFavoris.Ville;
        IBQAdresses.FieldByName('ADR_PAYS').asString := aFVillesFavoris.Pays;
        IBQAdresses.FieldByName('ADR_DEPT').asString := aFVillesFavoris.Dept;
        IBQAdresses.FieldByName('ADR_REGION').asString := aFVillesFavoris.Region;
      end;
  finally
    aFVillesFavoris.Free;
  end;
end;



procedure TFIndividuDomiciles.btnEMailClick(Sender: TObject);
var
  x: string;
begin
  x := 'mailto:' + trim(sDBEMail.Text); //+ '?Subject=Message de ' + lNom.Caption;
  ShellExecute(0, nil, PChar(x), nil, nil, SW_SHOWDEFAULT);
end;

procedure TFIndividuDomiciles.sDBEMailChange(Sender: TObject);
begin
  btnEMail.enabled := trim(sDBEMail.Text) <> '';
end;

procedure TFIndividuDomiciles.fbPaysClick(Sender: TObject);
var
  aFPays: TFPays;
begin
  aFPays := TFPays.create(self);
  try
    if aFPays.ShowModal = mrOk then
      begin
        IBQAdresses.Edit;
        IBQAdresses.FieldByName('ADR_PAYS').asString := aFPays.Pays;
      end;
  finally
    aFPays.Free;
  end
end;

procedure TFIndividuDomiciles.fbCarteClick(Sender: TObject);
var sPays: string;
begin
  if (IBQAdresses.FieldByName('ADR_PAYS').asString = 'DEPARTEMENT OUTREMER') or
    (IBQAdresses.FieldByName('ADR_PAYS').asString = 'TERRITOIRE OUTREMER') then
    sPays := IBQAdresses.FieldByName('ADR_REGION').asString
  else
    sPays := IBQAdresses.FieldByName('ADR_PAYS').asString;

  //  showmessage(spays);
  GotoThisURL('http://' + _Context.ChoixCartesInternet + '/pub/agent.dll?qscr=mmfn&plce1=' +
    IBQAdresses.FieldByName('ADR_VILLE').asString + '%2C' + sPays + '&wpst1=1&rtbl=0&regn1=2&cnty1=4&subm=1&fmap=1&tpid=1&dchg=&zz=992108484196');

end;

procedure TFIndividuDomiciles.dxDBGrid1KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  //TFIndividu(fFormindividu).TestIfHelp(Key);
end;

procedure TFIndividuDomiciles.OnKeyDownHelp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  //TFIndividu(fFormindividu).TestIfHelp(Key);
end;

procedure TFIndividuDomiciles.sDBMDateChange(Sender: TObject);
begin
  if _GDate.DecodeHumanDate(TdxDbEdit(sDBMDate).Text) then
    begin
      sDBMDate.Font.color := clWindowText;
    end
  else
    begin
      sDBMDate.Font.color := clRed;
    end;

  doShowDay;
end;

procedure TFIndividuDomiciles.doShowDay;
begin
  if _GDate.DecodeHumanDate(TdxDbEdit(sDBMDate).Text) then
    begin
      if _GDate.KnowDate then
        begin
          lbDay.Caption := '(' + LongDayNames[DayOfWeek(_GDate.GDate.DateTime1)] + ')';
          lbDay.visible := true;
        end
      else lbDay.visible := false;
    end
  else
    begin
      lbDay.visible := false;
    end;
end;


procedure TFIndividuDomiciles.IBQAdressesBeforePost(DataSet: TDataSet);
begin
  //on prpare les champs d'accueil de la date
  IBQAdressesADR_DATE_YEAR_1.Clear;
  IBQAdressesADR_DATE_1.Clear;
  IBQAdressesADR_DATE_YEAR_2.Clear;
  IBQAdressesADR_DATE_2.Clear;

  if _GDate.DecodeHumanDate(DataSet.FieldByName('ADR_DATE_WRITEN').AsString) then
    begin
      //Soit la date n'est pas une priode
      if (_GDate.GDate.UseDate2 = false) then
        begin
          //l'anne
          if (_GDate.KnowYear) then IBQAdressesADR_DATE_YEAR_1.AsInteger := _GDate.GDate.Year1;

          //la date entire
          if (_GDate.KnowDate) then IBQAdressesADR_DATE_1.AsDateTime := _GDate.GDate.DateTime1;
        end
      else
        //soit la date est une priode
        if (_GDate.GDate.UseDate1) and (_GDate.GDate.UseDate2) then
          begin
            //Date1
            if (_GDate.GDate.UseDate1) and (_GDate.GDate.ValidDateTime1) then IBQAdressesADR_DATE_1.AsDateTime := _GDate.GDate.DateTime1;
            //Anne 1
            if (_GDate.GDate.UseDate1) and (_GDate.GDate.Year1 <> -1) then IBQAdressesADR_DATE_YEAR_1.AsInteger := _GDate.GDate.Year1;

            //Date2
            if (_GDate.GDate.UseDate2) and (_GDate.GDate.ValidDateTime2) then IBQAdressesADR_DATE_2.AsDateTime := _GDate.GDate.DateTime2;
            //Anne 2
            if (_GDate.GDate.UseDate2) and (_GDate.GDate.Year2 <> -1) then IBQAdressesADR_DATE_YEAR_2.AsInteger := _GDate.GDate.Year2;
          end;
    end;
end;

procedure TFIndividuDomiciles.IBQAdressesAfterScroll(DataSet: TDataSet);
begin
  doShowDay;
end;

procedure TFIndividuDomiciles.fbCalendClick(Sender: TObject);
var
  aFCalendriers: TFCalendriers;
begin

  aFCalendriers := TFCalendriers.create(self);
  try
    aFCalendriers.doInit(IBQAdressesADR_DATE_1.asString);
    if aFCalendriers.ShowModal = mrOk then
      begin
        if not (IBQAdresses.State in [dsEdit, dsInsert]) then IBQAdresses.Edit;

        IBQAdresses.FieldByName('ADR_DATE_WRITEN').asString := aFCalendriers.laDate;

      end;
  finally
    aFCalendriers.Free;
  end;
end;

end.
