{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_Saisie_Rapide;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, Dialogs, Sysutils,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery,
  dxExEdtr, dxEdLib, dxDBELib, dxCntner, dxEditor, dxTL, dxDBCtrl,
  dxDBGrid, u_comp_TGoodBtn, u_comp_TYLanguage, DynamicSkinForm;

type
  TMydxDBPopupEdit = class(TdxDBPopupEdit)

  public
    procedure DropDown; override;

  end;

  TFIndividuSaisieRapide = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    panDock: TPanel;
    Panel11: TFlatPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    DBRSexe: TdxDBImageEdit;
    sDBENom: TdxDBPopupEdit;
    sDBEPrenom: TdxDBPopupEdit;
    IBIndDetail: TIBQuery;
    IBIndDetailNOM: TIBStringField;
    IBIndDetailPRENOM: TIBStringField;
    IBIndDetailCLE_FICHE: TIntegerField;
    IBIndDetailCLE_IMPORTATION: TIBStringField;
    IBIndDetailKLE_DOSSIER: TIntegerField;
    IBUIndDetail: TIBUpdateSQL;
    DSIndDetail: TDataSource;
    pPatronymes: TPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBGNom: TdxDBGridColumn;
    Panel22: TPanel;
    Label10: TLabel;
    pPrenom: TPanel;
    dxDBGrid2: TdxDBGrid;
    dxDBGridColumn1: TdxDBGridColumn;
    Panel12: TPanel;
    Label11: TLabel;
    DSPatronymes: TDataSource;
    IBQPatronymes: TIBQuery;
    IBQPatronymesNOM: TIBStringField;
    DSPrenoms: TDataSource;
    IBQPrenoms: TIBQuery;
    IBQPrenomsPRENOM: TIBStringField;
    btnFermer: TGoodBtn;
    fsbNouveau: TGoodBtn;
    fsbEnregistrer: TGoodBtn;
    IBIndDetailSEXE: TIntegerField;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure IBIndDetailNewRecord(DataSet: TDataSet);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure fsbNouveauClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure sDBENomKeyPress(Sender: TObject; var Key: Char);
    procedure sDBEPrenomKeyPress(Sender: TObject; var Key: Char);
    procedure sDBENomInitPopup(Sender: TObject);
    procedure sDBEPrenomInitPopup(Sender: TObject);
    procedure dxDBGrid2DblClick(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure DSIndDetailStateChange(Sender: TObject);
    procedure sDBENomChange(Sender: TObject);
    procedure fsbEnregistrerClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dxDBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dxDBGrid2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sDBENomKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sDBEPrenomKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure IBIndDetailBeforePost(DataSet: TDataSet);
    procedure sDBEPrenomExit(Sender: TObject);
  private
    fDialogMode: boolean;
    fCleFiche: integer;
    fSexeFiche: integer;
    fSexe: integer;
    fNomFiche: string;
    fFicheIsModified: boolean;
    fIndividuHaveBeenCreated: boolean;


    procedure up_Boutons(a_Mode: Boolean);
    procedure SetDialogMode(const Value: boolean);
    function ContraintesSaisieIsOk: boolean;
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property CleFiche: integer read fCleFiche write fCleFiche;
    property SexeFiche: integer read fSexeFiche write fSexeFiche;
    property NomFiche: string read fNomFiche write fNomFiche;
    property Sexe: integer read fSexe write fSexe;

    property IndividuHaveBeenCreated: boolean read fIndividuHaveBeenCreated;
  end;

implementation

uses u_dm, u_common_var, u_objet_TContext, u_common_func, u_common_const,
  u_form_main;
{$R *.DFM}

procedure TFIndividuSaisieRapide.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  if _Context.Skin then
    begin
      ClientHeight := 157;
      ClientWidth := 451;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fFicheIsModified := false;
  fIndividuHaveBeenCreated := false;

  fCleFiche := -1;
  fNomFiche := '';

  up_Boutons(False);
end;

procedure TFIndividuSaisieRapide.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBIndDetail.Close;
end;

procedure TFIndividuSaisieRapide.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
  //     panBtnDialog.visible := Value;
end;

procedure TFIndividuSaisieRapide.sbCloseClick(Sender: TObject);
begin
  if (DSIndDetail.State in [dsEdit, dsInsert]) then
    begin
      if ContraintesSaisieIsOk then
        begin
          //on demande si on enregistre, ou non
          if MyMessageDlg('Souhaitez-vous enregistrer cette individu ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
              IBIndDetail.Post;
              fIndividuHaveBeenCreated := true;

              fCleFiche := IBIndDetail.FieldByName('CLE_FICHE').AsInteger;
              fNomFiche := IBIndDetail.FieldByName('NOM').AsString;
              fSexeFiche := IBIndDetail.FieldByName('SEXE').AsInteger;
            end
          else
            IBIndDetail.Cancel;
        end
      else
        begin
          //on annule sans rien demander
          IBIndDetail.Cancel;
        end;
    end;

  Close;
end;

procedure TFIndividuSaisieRapide.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFIndividuSaisieRapide.up_Boutons(a_Mode: Boolean);
begin
  //
end;

procedure TFIndividuSaisieRapide.IBIndDetailNewRecord(DataSet: TDataSet);
var
  k: integer;
begin
  //l'ordre insert est dj fait.
  k := dm.uf_GetClefUnique('INDIVIDU');

  IBIndDetail.FieldByName('CLE_FICHE').AsInteger := k;
  IBIndDetail.FieldByName('SEXE').AsInteger := 0;
  IBIndDetail.FieldByName('CLE_IMPORTATION').AsString := inttostr(k);
  IBIndDetail.FieldByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
end;

procedure TFIndividuSaisieRapide.SuperFormShowFirstTime(Sender: TObject);

begin
  IBIndDetail.Open;
  IBIndDetail.Insert;
  IBIndDetailSEXE.AsInteger := SEXE;

  DoRefreshControls;
end;

procedure TFIndividuSaisieRapide.fsbNouveauClick(Sender: TObject);

begin

  try
    //on cr un nouvel individu
    IBIndDetail.Insert;
  except
  end;

  DoRefreshControls;

  SendFocus(sDBENom);
end;

procedure TFIndividuSaisieRapide.SuperFormRefreshControls(Sender: TObject);
begin
  fsbNouveau.enabled := (IBIndDetail.Active) and (not (DSIndDetail.State in [dsEdit, dsInsert]));
  fsbEnregistrer.enabled := (IBIndDetail.Active) and (fFicheIsModified) and (ContraintesSaisieIsOk) and (DSIndDetail.State in [dsEdit, dsInsert]);
end;

function TFIndividuSaisieRapide.ContraintesSaisieIsOk: boolean;
begin
  result := false;
  try
    result := (IBIndDetail.Active) and (trim(sDBENom.Text) <> '');
  except
  end;
end;



procedure TFIndividuSaisieRapide.sDBENomKeyPress(Sender: TObject; var Key: Char);
begin
  if _Context.ModeSaisieNom = msAllUpper then Key := UpCase(Key)
  else
    if _Context.ModeSaisieNom = msJustFirstLetterUpper then
      begin
        if sDBENom.Text = '' then Key := UpCase(Key);
      end;
end;

procedure TFIndividuSaisieRapide.sDBEPrenomKeyPress(Sender: TObject; var Key: Char);
begin
  if _Context.ModeSaisiePrenom = msAllUpper then Key := UpCase(Key)
  else
    if _Context.ModeSaisiePrenom = msJustFirstLetterUpper then
      begin
        if (sDBEPrenom.Text = '') then Key := UpCase(Key);
      end;
end;

procedure TFIndividuSaisieRapide.sDBENomInitPopup(Sender: TObject);
begin
  pPatronymes.Width := 400;
  pPatronymes.Height := 250;

  IBQPatronymes.Close;
  IBQPatronymes.Params[0].AsInteger := dm.NumDossier;
  IBQPatronymes.Open;
end;

procedure TFIndividuSaisieRapide.sDBEPrenomInitPopup(Sender: TObject);
begin
  pPrenom.Width := 400;
  pPrenom.Height := 250;

  IBQPrenoms.Close;
  IBQPrenoms.Params[0].AsInteger := dm.NumDossier;
  IBQPrenoms.Open;
end;

procedure TFIndividuSaisieRapide.dxDBGrid2DblClick(Sender: TObject);
begin
  IBIndDetail.Edit;

  if Length(IBIndDetailPreNOM.AsString) > 0 then
    IBIndDetailPreNOM.AsString := IBIndDetailPreNOM.AsString + ', ' + IBQPrenomsPrenom.AsString
  else
    IBIndDetailPreNOM.AsString := IBQPrenomsPrenom.AsString;

  fFicheIsModified := true;
  doRefreshControls;

  (GetParentForm(dxDBGrid2) as TdxPopupEditForm).ClosePopup(True);
end;

procedure TFIndividuSaisieRapide.dxDBGrid1DblClick(Sender: TObject);
begin
  IBIndDetail.Edit;
  IBIndDetailNOM.AsString := IBQPatronymesNOM.AsString;
  fFicheIsModified := true;
  doRefreshControls;
  (GetParentForm(dxDBGrid1) as TdxPopupEditForm).ClosePopup(True);
end;

procedure TFIndividuSaisieRapide.DSIndDetailStateChange(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFIndividuSaisieRapide.sDBENomChange(Sender: TObject);
begin
  fFicheIsModified := true;
  doRefreshControls;
end;

procedure TFIndividuSaisieRapide.fsbEnregistrerClick(Sender: TObject);
begin
  try
    IBIndDetail.Post;
    fIndividuHaveBeenCreated := true;
    fCleFiche := IBIndDetail.FieldByName('CLE_FICHE').AsInteger;
    fNomFiche := IBIndDetail.FieldByName('NOM').AsString;
    fSexeFiche := IBIndDetail.FieldByName('SEXE').AsInteger;

    dm.IBUpdateNOM.Close;
    dm.IBUpdateNOM.Params[0].AsInteger := fCleFiche;
    dm.IBUpdateNOM.ExecSQL;
    dm.IBUpdateNOM.Close;
  except
  end;

  DoRefreshControls;

  SendFocus(fsbNouveau);
end;

procedure TFIndividuSaisieRapide.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: sbCloseClick(self);
    _KEY_HELP: dm.ShowHelp(_ID_SAISIE_RAPIDE);
    VK_RETURN: fsbEnregistrerClick(Sender);
  end;
end;

procedure TFIndividuSaisieRapide.dxDBGrid1KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then (GetParentForm(dxDBGrid1) as TdxPopupEditForm).ClosePopup(True)
  else
    if (Key = VK_RETURN) then dxDBGrid1DblClick(Sender);
end;

procedure TFIndividuSaisieRapide.dxDBGrid2KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then (GetParentForm(dxDBGrid2) as TdxPopupEditForm).ClosePopup(True)
  else
    if (Key = VK_RETURN) then dxDBGrid2DblClick(Sender);
end;

procedure TFIndividuSaisieRapide.sDBENomKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  s: string;
  k: integer;
begin
  if (Key = _KEY_OPEN_LIST) then TMydxDBPopupEdit(sDBENom).DropDown
  else
    begin
      try
        if dm.EngineRaccourcis_TdxDBPopupEdit2(sDBENom, Key, Shift, s, k) then
          begin
            if not (IBIndDetail.state in [dsEdit, dsInsert]) then IBIndDetail.Edit;
            IBIndDetailNOM.AsString := ApplyModeSaisie(_Context.ModeSaisieNom, s);
            sDBENom.SelStart := k + 1;
          end;
      except
      end;
    end;
end;

procedure TFIndividuSaisieRapide.sDBEPrenomKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  s: string;
  k: integer;
begin
  if (Key = _KEY_OPEN_LIST) then TMydxDBPopupEdit(sDBEPrenom).DropDown
  else
    begin
      try
        if dm.EngineRaccourcis_TdxDBPopupEdit2(sDBEPrenom, Key, Shift, s, k) then
          begin
            if not (IBIndDetail.state in [dsEdit, dsInsert]) then IBIndDetail.Edit;
            IBIndDetailPRENOM.AsString := ApplyModeSaisie(_Context.ModeSaisiePrenom, s);
            sDBEPrenom.SelStart := k + 1;
          end;
      except
      end;
    end;
end;


{ TMydxDBPopupEdit }

procedure TMydxDBPopupEdit.DropDown;
begin
  inherited;
end;


procedure TFIndividuSaisieRapide.IBIndDetailBeforePost(DataSet: TDataSet);
begin
  try
    IBIndDetailNOM.AsString := trimRight(IBIndDetailNOM.AsString);
    IBIndDetailPRENOM.AsString := trimRight(IBIndDetailPRENOM.AsString);
  except
  end;
end;

procedure TFIndividuSaisieRapide.sDBEPrenomExit(Sender: TObject);
begin
  if DSIndDetail.State in [dsEdit, dsInsert] then
    IBIndDetailPRENOM.AsString := doFormatePrenoms(sDBEPrenom.Text)
end;

end.
