{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_Union;

interface

uses
  Forms, Windows, CompSuperForm, Menus, TFlatTabControlUnit, ComCtrls, TFlatPanelUnit, Controls,
  ExtCtrls, Classes, StdCtrls, Db, IBCustomDataSet, IBQuery, dxTL, Sysutils,
  dxDBGrid, dxCntner, dxGrClms, Dialogs, IBStoredProc,
  u_comp_TBlueFlatSpeedButton, RVScroll, RichView, IBUpdateSQL,
  dxTLClms, dxDBCtrl, graphics,
  u_Form_Union_Events_Details,
  u_Form_Union_Events_Sources,
  u_form_Union_events_notes,
  u_Form_Union_Events_Temoins, TFlatButtonUnit, dxDBTLCl, URLLink,
  u_objet_TIntegerList, u_comp_TGoodBtn, u_comp_TYLanguage, dxEditor,
  dxExEdtr, dxEdLib, dxDBELib, TFlatSplitterUnit;

type

  TNodeIndividu = class
  private
    fSexe: integer;
    fCleFiche: integer;
    fCaption: string;
    fTypeUnion: integer;
    fUnionClef: integer;
    fSosa: Int64;
  public
    constructor Create;
    property Caption: string read fCaption write fCaption;
    property CleFiche: integer read fCleFiche write fCleFiche;
    property Sexe: integer read fSexe write fSexe;
    property TypeUnion: integer read fTypeUnion write fTypeUnion;
    property UnionClef: integer read fUnionClef write fUnionClef;
    property Sosa: Int64 read fSosa write fSosa;
  end;

  TFIndividuUnion = class(TSuperForm)
    popupEvents: TPopupMenu;
    option_NewEvent: TMenuItem;
    N1: TMenuItem;
    option_DeleteEvent: TMenuItem;
    popupConjoints: TPopupMenu;
    IBConjoints: TIBQuery;
    IBQDetailConjoint: TIBQuery;
    IBQUnions: TIBQuery;
    IBUUnions: TIBUpdateSQL;
    DSUnion: TDataSource;
    DSConjoints: TDataSource;
    IBUEve: TIBUpdateSQL;
    dsEve: TDataSource;
    IBQEve: TIBQuery;
    IBQUnionsUNION_CLEF: TIntegerField;
    IBQUnionsUNION_MARI: TIntegerField;
    IBQUnionsUNION_FEMME: TIntegerField;
    IBQEveEV_FAM_CLEF: TIntegerField;
    IBQEveEV_FAM_KLE_FAMILLE: TIntegerField;
    IBQEveEV_FAM_KLE_DOSSIER: TIntegerField;
    IBQEveEV_FAM_TYPE: TIBStringField;
    IBQEveEV_FAM_DATE_WRITEN: TIBStringField;
    IBQEveEV_FAM_DATE: TDateField;
    IBQEveEV_FAM_ADRESSE: TIBStringField;
    IBQEveEV_FAM_CP: TIBStringField;
    IBQEveEV_FAM_VILLE: TIBStringField;
    IBQEveEV_FAM_DEPT: TIBStringField;
    IBQEveEV_FAM_PAYS: TIBStringField;
    IBQEveEV_FAM_SOURCE: TMemoField;
    IBQEveEV_FAM_COMMENT: TMemoField;
    IBQEveEV_FAM_REGION: TIBStringField;
    IBQEveEV_FAM_SUBD: TIBStringField;
    IBQEve_LONG_NAME_EVENT: TStringField;
    IBQEve_IG_EVENT: TIntegerField;
    IBConjointsCLE_FICHE: TIntegerField;
    IBConjointsNOM: TIBStringField;
    IBConjointsPRENOM: TIBStringField;
    IBConjointsDATE_NAISSANCE: TIBStringField;
    IBConjointsANNEE_NAISSANCE: TIntegerField;
    IBConjointsDATE_DECES: TIBStringField;
    IBConjointsANNEE_DECES: TIntegerField;
    IBConjointsCLE_PERE: TIntegerField;
    IBConjointsCLE_MERE: TIntegerField;
    IBConjointsNUM_SOSA: TFloatField;
    IBConjointsTYPE_UNION: TIntegerField;
    IBConjointsUNION_CLEF: TIntegerField;
    IBConjointsNOM_PRENOM: TStringField;
    IBConjointsKLE_DOSSIER: TIntegerField;
    mOuvrirFiche: TMenuItem;
    IBQUnionsKLE_DOSSIER: TIntegerField;
    IBQUnionsUNION_TYPE: TIntegerField;
    IBQEveEV_FAM_DATE_YEAR: TIntegerField;
    IBConjointsSEXE: TIntegerField;
    Language: TYLanguage;
    Panel1: TPanel;
    FlatPanel1: TFlatPanel;
    gridEvents: TdxDBGrid;
    gridEventsColumn2: TdxDBGridImageColumn;
    gridEventsColumn3: TdxDBGridColumn;
    Panel2: TPanel;
    FlatTabControl: TFlatTabControl;
    panDockEvents: TPanel;
    Panel4: TPanel;
    Label3: TLabel;
    btnDelEvent: TGoodBtn;
    btnAddEvent: TGoodBtn;
    Panel3: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    lNom: TLabel;
    Label8: TLabel;
    bsfbAjout: TGoodBtn;
    bsfbRetirer: TGoodBtn;
    Panel7: TPanel;
    TreeConj: TdxTreeList;
    dxTreeList1Column1: TdxTreeListColumn;
    dxTreeListColumnTypeUnion: TdxTreeListPickColumn;
    FlatSplitter1: TFlatSplitter;
    Panel8: TPanel;
    FlatTabControlCommentUnion: TFlatTabControl;
    Panel9: TPanel;
    edCommentaires: TdxDBMemo;
    edSources: TdxDBMemo;
    QSourcesNotesUnion: TIBQuery;
    IBUSourcesNotesUnion: TIBUpdateSQL;
    DataSourceSourceCommentUnion: TDataSource;
    btnDetail: TGoodBtn;
    procedure DSUnionStateChange(Sender: TObject);
    procedure IBConjointsCalcFields(DataSet: TDataSet);
    procedure dsDeleteUnionStateChange(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure TreeConjEditing(Sender: TObject; Node: TdxTreeListNode; var Allow: Boolean);
    procedure TreeConjDeletion(Sender: TObject; Node: TdxTreeListNode);
    procedure dxTreeListColumnTypeUnionCloseUp(Sender: TObject; var Value: Variant; var Accept: Boolean);
    procedure FlatTabControlTabChanged(Sender: TObject);
    procedure TreeConjChangeNode(Sender: TObject; OldNode, Node: TdxTreeListNode);
    procedure bsfbAjoutClick(Sender: TObject);
    procedure bsfbRetirerClick(Sender: TObject);
    procedure btnAddEventClick(Sender: TObject);
    procedure IBQEveNewRecord(DataSet: TDataSet);
    procedure dsEveStateChange(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure popupEventsPopup(Sender: TObject);
    procedure btnDelEventClick(Sender: TObject);
    procedure IBQEveAfterScroll(DataSet: TDataSet);
    procedure mOuvrirFicheClick(Sender: TObject);
    procedure popupConjointsPopup(Sender: TObject);
    procedure IBQEveBeforePost(DataSet: TDataSet);
    procedure TreeConjKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure gridEventsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TreeConjMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TreeConjCustomDrawCell(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; ANode: TdxTreeListNode; AColumn: TdxTreeListColumn;
      ASelected, AFocused, ANewItemRow: Boolean; var AText: string;
      var AColor: TColor; AFont: TFont; var AAlignment: TAlignment;
      var ADone: Boolean);
    procedure FlatTabControlCommentUnionTabChanged(Sender: TObject);
    procedure DataSourceSourceCommentUnionStateChange(Sender: TObject);
    procedure btnDetailClick(Sender: TObject);

  private
    fModuleDocked: integer;
    fFormIndividu: TForm;
    fCanScroll: boolean;
    fCanScrollEvent: boolean;

    CurNodeC: TdxTreeListNode;
    CurColumnC: TdxTreeListColumn;

    fCodesRefTemoins: TIntegerList;
    fLibellesRefTemoins: TStringList;

    aFUnionEventsDetails: TFUnionEventsDetails;
    aFUnionEventsSources: TFUnionEventsSources;
    aFUnionEventsTemoins: TFUnionEventsTemoins;
    aFUnionEventsNotes: TFUnionEventsNotes;



    procedure SetFormIndividu(const Value: TForm);
    function AddThisIndividu(aNodeIndividu: TNodeIndividu; ToNode: TdxTreeListNode): TdxTreeListNode;
    procedure ShowEvents;
    procedure doScrollEvent;
    procedure doShowGoodTab_CommentSourceUnion;
  public
    //en entre
    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;

    procedure doInitialize;
    function doOpenQuerys: boolean;
    function GetCleEventUnionSelected: integer;
  end;

implementation

uses u_dm, u_form_Main, u_form_individu_par_prenom, u_form_individu,
  u_form_Evements_Ajout, u_common_func, u_common_const, u_common_var,
  u_form_biblio_Sources;

{$R *.DFM}

procedure TFIndividuUnion.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  CurNodeC := nil;
  CurColumnC := nil;

  aFUnionEventsDetails := TFUnionEventsDetails.create(self);
  aFUnionEventsDetails.FormIndividuUnion := self;

  aFUnionEventsSources := TFUnionEventsSources.create(self);
  aFUnionEventsSources.FormIndividuUnion := self;

  aFUnionEventsTemoins := TFUnionEventsTemoins.create(self);
  aFUnionEventsTemoins.FormIndividuUnion := self;

  aFUnionEventsNotes := TFUnionEventsNotes.create(self);
  aFUnionEventsNotes.FormIndividuUnion := self;

  aFUnionEventsDetails.ShowIncrust(panDockEvents);
  fModuleDocked := 0;

  fCodesRefTemoins := TIntegerList.create;
  fLibellesRefTemoins := TStringList.create;

  dxTreeListColumnTypeUnion.Items.Clear;
  try
    dm.IBQTypeUnion.First;

    while not dm.IBQTypeUnion.Eof do
      begin
        fCodesRefTemoins.Add(dm.IBQTypeUnionI_TYPE.AsInteger);
        fLibellesRefTemoins.Add(dm.IBQTypeUnionLIBELLE.AsString);
        dxTreeListColumnTypeUnion.Items.Add(dm.IBQTypeUnionLIBELLE.AsString);

        dm.IBQTypeUnion.next;
      end;
  except
  end;

end;

procedure TFIndividuUnion.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;
  aFUnionEventsTemoins.FormIndividu := Value;
end;

procedure TFIndividuUnion.DSUnionStateChange(Sender: TObject);
begin
  TFIndividu(FormIndividu).doRefreshControls;
end;

procedure TFIndividuUnion.IBConjointsCalcFields(DataSet: TDataSet);
begin
  // On fabrique le nom des conjoints
  IBConjointsNOM_PRENOM.asString := AssembleString([IBConjointsNOM.AsString,
    IBConjointsPRENOM.asString]);
  IBConjointsKLE_DOSSIER.AsInteger := dm.NumDossier;
end;

procedure TFIndividuUnion.dsDeleteUnionStateChange(Sender: TObject);
begin
  TFIndividu(FormIndividu).doRefreshControls;
end;

{ TNodeIndividu }

constructor TNodeIndividu.Create;
begin
  fCaption := '';
  fSexe := -1;
  fCleFiche := -1;
  fTypeUnion := -1;
  fUnionClef := -1;
end;

procedure TFIndividuUnion.SuperFormRefreshControls(Sender: TObject);
var
  CleEventUnion: integer;
begin

  if (TFIndividu(fFormindividu).DialogMode = True) then gridEvents.Cursor := crArrow;

  CleEventUnion := GetCleEventUnionSelected;

  bsfbRetirer.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TreeConj.FocusedNode <> nil) and (TreeConj.FocusedNode.Level = 0) and (TFIndividu(fFormindividu).DialogMode = false);
  bsfbAjout.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
  //gridEvents.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);

  btnAddEvent.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TreeConj.FocusedNode <> nil) and (IBQEve.active) and (TFIndividu(fFormindividu).DialogMode = false);
  btnDelEvent.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TreeConj.FocusedNode <> nil) and (IBQEve.active) and (CleEventUnion <> -1) and (TFIndividu(fFormindividu).DialogMode = false);

  aFUnionEventsDetails.doRefresh((TFIndividu(fFormindividu).CleFiche <> -1) and (IBQEve.active) and (CleEventUnion <> -1) and (TFIndividu(fFormindividu).DialogMode = false));
  aFUnionEventsNotes.doRefresh((TFIndividu(fFormindividu).CleFiche <> -1) and (IBQEve.active) and (CleEventUnion <> -1) and (TFIndividu(fFormindividu).DialogMode = false));
  aFUnionEventsSources.doRefresh((TFIndividu(fFormindividu).CleFiche <> -1) and (IBQEve.active) and (CleEventUnion <> -1) and (TFIndividu(fFormindividu).DialogMode = false));
  aFUnionEventsTemoins.doRefresh((TFIndividu(fFormindividu).CleFiche <> -1) and (IBQEve.active) and (CleEventUnion <> -1) and (TFIndividu(fFormindividu).DialogMode = false));

  DSConjoints.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
  DSUnion.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
  dsEve.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);

  aFUnionEventsDetails.doOnDateChange;
end;

procedure TFIndividuUnion.SuperFormShowFirstTime(Sender: TObject);
begin
  aFUnionEventsTemoins.FormIndividu := fFormIndividu;
  DoRefreshControls;
end;

function TFIndividuUnion.AddThisIndividu(aNodeIndividu: TNodeIndividu; ToNode: TdxTreeListNode): TdxTreeListNode;
var
  w: integer;
  N: TdxTreeListNode;
  k: integer;
begin
  //Si ToNode=Nil, alors c'est un conjoint qu'on ajoute, sinon, c'est un parent du conjoint
  if ToNode = nil then N := TreeConj.Add else N := ToNode.AddChild;

  if N <> nil then
    begin
      N.Data := aNodeIndividu;

      N.Values[0] := aNodeIndividu.Caption;
      if ToNode = nil then
        begin
          //Type d'union
          w := fCodesRefTemoins.IndexOf(aNodeIndividu.TypeUnion);

          if w <> -1 then N.Values[1] := fLibellesRefTemoins[w]
          else N.Values[1] := '';

          //Type d'union
            //               if (aNodeIndividu.TypeUnion < 0) or (aNodeIndividu.TypeUnion > 6) then aNodeIndividu.TypeUnion := 0;
            //               N.Values[1] := dxTreeListColumnTypeUnion.Items[aNodeIndividu.TypeUnion];

          N.ImageIndex := 3;
          N.SelectedIndex := 3;
        end
      else
        begin
          N.Values[1] := '';

          //image du sexe

          case aNodeIndividu.Sexe of
            1: k := 1;
            2: k := 0;
            else
              k := -1;
          end;

          //	if aNodeIndividu.Sexe = 1 then k := 1;
          //	if aNodeIndividu.Sexe = 2 then k := 2;
          N.ImageIndex := k;
          N.SelectedIndex := k;
        end;
    end;

  result := N;
end;

procedure TFIndividuUnion.TreeConjEditing(Sender: TObject; Node: TdxTreeListNode; var Allow: Boolean);
begin
  if Node.Level = 1 then Allow := False
  else
    if Node.Level = 0 then
      begin
        if TreeConj.FocusedColumn = 0 then Allow := false;
      end;
end;

procedure TFIndividuUnion.TreeConjDeletion(Sender: TObject; Node: TdxTreeListNode);
begin
  if Node.Data <> nil then
    begin
      TNodeIndividu(Node.Data).free;
      Node.Data := nil;
    end;
end;

procedure TFIndividuUnion.dxTreeListColumnTypeUnionCloseUp(Sender: TObject; var Value: Variant; var Accept: Boolean);
var
  w: integer;
  UnionType: integer;
  QUpdateTypeUnion: TIBQuery;
  aNode: TNodeIndividu;
begin
  //on regarde si cette valeur est diffrente du type d'union actuel
  if TreeConj.FocusedNode <> nil then
    begin
      if (TreeConj.FocusedNode.strings[dxTreeListColumnTypeUnion.index] <> Value) then
        begin
          if (TreeConj.FocusedNode.Data <> nil) then
            begin
              aNode := TNodeIndividu(TreeConj.FocusedNode.Data);

              w := fLibellesRefTemoins.IndexOf(Value);
              if w <> -1 then UnionType := fCodesRefTemoins[w]
              else UnionType := -1;

              aNode.TypeUnion := UnionType;

              QUpdateTypeUnion := TIBQuery.create(self);
              try
                QUpdateTypeUnion.Database := dm.ibd_BASE;
                QUpdateTypeUnion.SQL.Add('update T_UNION set UNION_TYPE = :UNION_TYPE where UNION_CLEF=' + inttostr(aNode.UnionClef));
                QUpdateTypeUnion.ParamByName('UNION_TYPE').AsInteger := UnionType;
                QUpdateTypeUnion.ExecSQL;
                QUpdateTypeUnion.Close;

                //on indique qu'on a fait une modification
                TFIndividu(fFormindividu).Modified := true;

              finally
                QUpdateTypeUnion.Free;
              end;

              TFIndividu(fFormindividu).DoRefreshControls;
            end;
        end;
    end;
end;


procedure TFIndividuUnion.FlatTabControlTabChanged(Sender: TObject);
begin
  case fModuleDocked of
    0: aFUnionEventsDetails.HideIncrust;
    1: aFUnionEventsNotes.HideIncrust;
    2: aFUnionEventsSources.HideIncrust;
    3: aFUnionEventsTemoins.HideIncrust;
  end;

  btnDetail.Visible := FlatTabControl.ActiveTab = 2;

  case FlatTabControl.ActiveTab of
    0: begin
        aFUnionEventsDetails.ShowIncrust(panDockEvents);
        SendFocus(aFUnionEventsDetails.edDate);
      end;
    1: begin
        aFUnionEventsNotes.ShowIncrust(panDockEvents);
        SendFocus(aFUnionEventsNotes.edMemo);
      end;
    2: begin
        aFUnionEventsSources.ShowIncrust(panDockEvents);
        SendFocus(aFUnionEventsSources.edMemo);

      end;
    3: begin
        aFUnionEventsTemoins.ShowIncrust(panDockEvents);
        SendFocus(aFUnionEventsTemoins.bsfbAjout);

      end;
  end;

  fModuleDocked := FlatTabControl.ActiveTab;

end;

procedure TFIndividuUnion.TreeConjChangeNode(Sender: TObject; OldNode,
  Node: TdxTreeListNode);
begin
  ShowEvents;
end;


procedure TFIndividuUnion.ShowEvents;
var
  k: integer;
  aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
begin
  //On rcupre la cl de l'union
  k := -1;
  aNode := TreeConj.FocusedNode;
  if (aNode <> nil) and (aNode.Data <> nil) then
    begin
      if aNode.level = 1 then aNode := aNode.Parent;

      aNodeIndividu := TNodeIndividu(aNode.Data);
      k := aNodeIndividu.UnionClef;
    end;


  //Sauvegarde des notes et sources de l'union en cours, si besoin
  if (QSourcesNotesUnion.State in [dsEdit, dsInsert]) then QSourcesNotesUnion.Post;


  //on ouvre le query sur les sources et notes de cette union
  QSourcesNotesUnion.Close;
  if k <> -1 then
    begin
      QSourcesNotesUnion.ParamByName('UNION_CLEF').AsInteger := k;
      QSourcesNotesUnion.Open;
    end;
  doShowGoodTab_CommentSourceUnion;


  //Sauvegarde de l'vnement en cours si besoin
  if (dsEve.State in [dsEdit, dsInsert]) then IBQEve.Post;

  //Recherche des vnements associs  cette union
  IBQEve.Close;
  if k <> -1 then
    begin
      fCanScrollEvent := false;
      try
        IBQEve.Params[0].AsInteger := k;
        IBQEve.Open;
        IBQEve.Last;
        IBQEve.First;
      finally
        fCanScrollEvent := true;
      end;

      doScrollEvent;
    end;
end;



procedure TFIndividuUnion.bsfbAjoutClick(Sender: TObject);
{
Permet de rajouter un conjoint a l'individu en cours
}
var
  aNodeIndividu: TNodeIndividu;
  NodeConjoint: TdxTreeListNode;
  s: string;
  i_bConjoints: TIBQuery;
  aFIndividuPrenom: TFIndividuPrenom;
  i_Sexe, SexeConjoint: integer;
  NewUnionCle: integer;
begin
  //on rcupre le sexe de l'individu
  i_Sexe := TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger;

  //on peux ajouter un conjoint uniquement si il est de sexe connu
  if (i_Sexe = 1) or (i_Sexe = 2) then
    begin
      if i_Sexe = 1 then SexeConjoint := 2 else SexeConjoint := 1;

      //Cration de la boite de recherche d'un individu par le prnom
      aFIndividuPrenom := TFIndividuPrenom.create(self);
      try
        aFIndividuPrenom.Position := poMainFormCenter;
        aFIndividuPrenom.up_InitIndividuPrenom('A', '', SexeConjoint, 2);

        if aFIndividuPrenom.ShowModal = mrOk then
          if aFIndividuPrenom.ClefIndividuSelected = TFIndividu(fFormindividu).Clefiche then
            ShowMessage('L''individu ne peux pas tre  la fois, lui mme et son conjoint')
          else
            begin
              //On ouvre le query des unions
              NewUnionCle := dm.uf_GetClefUnique('T_UNION');
              IBQUnions.DisableControls;
              IBQUnions.Open;
              IBQUnions.Append;
              IBQUnions.FieldByName('UNION_CLEF').AsInteger := NewUnionCle;
              IBQUnions.FieldByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
              IBQUnions.FieldByName('UNION_TYPE').AsInteger := 0;

              if i_Sexe = 1 then
                begin
                  IBQUnions.FieldByName('UNION_MARI').AsInteger := TFIndividu(fFormindividu).CleFiche;
                  IBQUnions.FieldByName('UNION_FEMME').AsInteger := aFIndividuPrenom.ClefIndividuSelected;
                end
              else
                begin
                  IBQUnions.FieldByName('UNION_MARI').AsInteger := aFIndividuPrenom.ClefIndividuSelected;
                  IBQUnions.FieldByName('UNION_FEMME').AsInteger := TFIndividu(fFormindividu).CleFiche;
                end;

              IBQUnions.Post;
              IBQUnions.EnableControls;

              //on indique que l'individu est modifi
              TFIndividu(fFormindividu).Modified := true;

              i_bConjoints := TIBQuery.Create(Self);
              try
                i_bConjoints.DisableControls;
                i_bConjoints.DataBase := dm.ibd_BASE;
                i_bConjoints.SQL.ADD('select *  FROM PROC_PRENOM_PAR_NOM_PAR_CLEF(:CLE_FICHE,:KLE_DOSSIER)');
                i_bConjoints.Params[0].AsInteger := aFIndividuPrenom.ClefIndividuSelected;
                i_bConjoints.Params[1].AsInteger := dm.NumDossier;
                i_bConjoints.Open;

                //on ajoute un item dans le TreeList
                TreeConj.BeginUpdate;
                try
                  //Nom, Prenom, Date de naissance, Date de dces
                  s := AssembleString([i_bConjoints.FieldByName('NOM').AsString, i_bConjoints.FieldByName('PRENOM').AsString]);
                  if i_bConjoints.FieldByName('DATE_NAISSANCE').AsString <> '' then s := s + ' (  ' + i_bConjoints.FieldByName('DATE_NAISSANCE').AsString + ')';
                  if i_bConjoints.FieldByName('DATE_DECES').AsString <> '' then s := s + ' - ( + ' + i_bConjoints.FieldByName('DATE_DECES').AsString + ')';

                  //Cration d'un objet, pour ce conjoint
                  aNodeIndividu := TNodeIndividu.create;
                  aNodeIndividu.Caption := s;
                  aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                  aNodeIndividu.Sexe := i_bConjoints.FieldByName('SEXE').AsInteger;
                  aNodeIndividu.TypeUnion := 0;
                  aNodeIndividu.UnionClef := NewUnionCle;

                  //On ajoute ce conjoint dans le treeView
                  NodeConjoint := AddThisIndividu(aNodeIndividu, nil);

                  if NodeConjoint <> nil then
                    begin
                      //Ce conjoint a-t'il un pre ?
                      if i_bConjoints.FieldByName('NOM_PERE').AsString <> '' then
                        begin
                          s := AssembleString([i_bConjoints.FieldByName('NOM_PERE').AsString,
                            i_bConjoints.FieldByName('PRENOM_PERE').AsString]);
                          if i_bConjoints.FieldByName('PERE_DATE_NAISSANCE').AsString <> '' then
                            s := s + ' n le ' + i_bConjoints.FieldByName('PERE_DATE_NAISSANCE').AsString;

                          aNodeIndividu := TNodeIndividu.create;
                          aNodeIndividu.Caption := s;
                          //aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                          aNodeIndividu.CleFiche := i_bConjoints.FieldByName('PERE_CLE_FICHE').AsInteger;
                          aNodeIndividu.Sexe := 1;

                          //On ajoute le pre du conjoint, dans le treeView
                          AddThisIndividu(aNodeIndividu, NodeConjoint);
                        end;

                      //Ce conjoint a-t'il une mre ?
                      if i_bConjoints.FieldByName('NOM_MERE').AsString <> '' then
                        begin
                          s := AssembleString([i_bConjoints.FieldByName('NOM_MERE').AsString,
                            i_bConjoints.FieldByName('PRENOM_MERE').AsString]);
                          if i_bConjoints.FieldByName('MERE_DATE_NAISSANCE').AsString <> '' then
                            s := s + ' ne le ' + i_bConjoints.FieldByName('MERE_DATE_NAISSANCE').AsString;

                          aNodeIndividu := TNodeIndividu.create;
                          aNodeIndividu.Caption := s;
                          //aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                          aNodeIndividu.CleFiche := i_bConjoints.FieldByName('MERE_CLE_FICHE').AsInteger;
                          aNodeIndividu.Sexe := 2;

                          //On ajoute la mre du conjoint, dans le treeView
                          AddThisIndividu(aNodeIndividu, NodeConjoint);
                        end;
                    end;

                finally
                  TreeConj.EndUpdate;
                end;
                i_bConjoints.EnableControls;
              finally
                i_bConjoints.Free;
              end;


              TFIndividu(fFormindividu).LoadCoherenceDates;
              TFIndividu(fFormindividu).CoherenceDate.Test;

              //On rafraichit la liste des conjoints dans FIndividuIdentite
              TFIndividu(fFormindividu).aFIndividuIdentite.RempliConjoints;
              TFIndividu(fFormindividu).aFIndividuIdentite.RempliEnfants;


              ShowEvents;
              TFIndividu(fFormindividu).DoRefreshControls;
            end;

      finally
        aFIndividuPrenom.Free;
      end;

      TFIndividu(fFormindividu).DoRefreshControls;
    end;
end;

{---------------------------------------------------------------------------------------------------}

{Delete d'un conjoint-------------------------------------------------------------------------------}

procedure TFIndividuUnion.bsfbRetirerClick(Sender: TObject);
var
  aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
  QUpdateTypeUnion: TIBQuery;
begin
  if TreeConj.FocusedNode <> nil then
    begin
      aNode := TreeConj.FocusedNode;
      if (aNode.Data <> nil) and (aNode.Level = 0) then
        begin
          //on rcupre l'objet de stockage de l'individu
          aNodeIndividu := TNodeIndividu(aNode.Data);

          if aNodeIndividu.UnionClef <> -1 then
            begin
              if MyMessageDlg('Confirmez-vous la suppression de cette union avec : ' +
                aNodeIndividu.fCaption + ' ?',
                mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                begin
                  QUpdateTypeUnion := TIBQuery.create(self);
                  try
                    QUpdateTypeUnion.Database := dm.ibd_BASE;
                    QUpdateTypeUnion.SQL.Add('EXECUTE PROCEDURE PROC_DELETE_UNION(:CLEF)');
                    // QUpdateTypeUnion.SQL.Add('delete from T_UNION where UNION_CLEF=' + inttostr(aNodeIndividu.UnionClef));
                    QUpdateTypeUnion.Params[0].AsInteger := aNodeIndividu.UnionClef;
                    QUpdateTypeUnion.ExecSQL;
                    QUpdateTypeUnion.Close;

                    //on indique qu'on a fait une modification
                    TFIndividu(fFormindividu).Modified := true;
                  finally
                    QUpdateTypeUnion.Free;
                  end;

                  TreeConj.FocusedNode.Free;


                  TFIndividu(fFormindividu).LoadCoherenceDates;
                  TFIndividu(fFormindividu).CoherenceDate.Test;

                  ShowEvents;
                  TFIndividu(fFormindividu).DoRefreshControls;



                  //On rafraichit la liste des conjoints dans FIndividuIdentite
                  TFIndividu(fFormindividu).aFIndividuIdentite.RempliConjoints;
                  TFIndividu(fFormindividu).aFIndividuIdentite.RempliEnfants;

                  TFIndividu(fFormindividu).DoRefreshControls;
                end;
            end;
        end;
    end;
end;

{---------------------------------------------------------------------------------------------------}

procedure TFIndividuUnion.btnAddEventClick(Sender: TObject);
var
  aFEvenement_Ajout: TFEvenement_Ajout;
begin
  aFEvenement_Ajout := TFEvenement_Ajout.create(self);
  try
    aFEvenement_Ajout.up_Init(TFIndividu(fFormindividu).CleFiche, 'U');

    if aFEvenement_Ajout.ShowModal = mrOk then
      begin
        ibqEve.Append;
        ibqEveEV_FAM_TYPE.AsString := aFEvenement_Ajout.Ref_Eve_Lib_Court;
        //               IBQEveREF_EVE_LIB_LONG.AsString := aFEvenement_Ajout.Ref_Eve_Lib_Long;
        ibqEve.Post;



        if aFUnionEventsDetails.edDate.CanFocus then aFUnionEventsDetails.edDate.SetFocus;

        TFIndividu(fFormindividu).Modified := true;
        TFIndividu(FormIndividu).DoRefreshControls;
      end;
  finally
    aFEvenement_Ajout.Free;
  end;
end;

procedure TFIndividuUnion.IBQEveNewRecord(DataSet: TDataSet);
var
  k: integer;
  aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
begin
  k := -1;
  aNode := TreeConj.FocusedNode;
  if (aNode <> nil) and (aNode.Data <> nil) then
    begin
      if aNode.level = 1 then aNode := aNode.Parent;

      aNodeIndividu := TNodeIndividu(aNode.Data);
      k := aNodeIndividu.UnionClef;
    end;

  if k <> -1 then
    begin
      IBQEveEV_FAM_CLEF.AsInteger := dm.uf_GetClefUnique('EVENEMENTS_FAM');
      ibqEveEV_FAM_KLE_FAMILLE.AsInteger := k;
      ibqEveEV_FAM_KLE_DOSSIER.AsInteger := dm.NumDossier;
    end
  else
    DataSet.Cancel;
end;

procedure TFIndividuUnion.dsEveStateChange(Sender: TObject);
begin
  TFIndividu(fFormindividu).DoRefreshControls;
end;

procedure TFIndividuUnion.SuperFormDestroy(Sender: TObject);
begin
  fCodesRefTemoins.free;
  fLibellesRefTemoins.free;
end;

procedure TFIndividuUnion.popupEventsPopup(Sender: TObject);
begin
  option_NewEvent.visible := TFIndividu(fFormindividu).DialogMode = False;
  option_DeleteEvent.visible := TFIndividu(fFormindividu).DialogMode = False;

  option_NewEvent.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (IBQEve.active);
  option_DeleteEvent.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (IBQEve.active) and (IBQEve.RecordCount > 0);
end;

procedure TFIndividuUnion.btnDelEventClick(Sender: TObject);
begin
  //suppression de l'vnement
  ibqEve.Delete;


  TFIndividu(fFormindividu).Modified := true;
  TFIndividu(FormIndividu).DoRefreshControls;

  TFIndividu(fFormindividu).LoadCoherenceDates;
  TFIndividu(fFormindividu).CoherenceDate.Test; ;
  TFIndividu(fFormindividu).DoRefreshControls;
end;

function TFIndividuUnion.GetCleEventUnionSelected: integer;
begin
  //on rcupre la clef de de l'evenement slectionn
  result := -1;
  try
    if IBQEve.Active then
      if IBQEve.IsEmpty = false then result := IBQEve.FieldByName('EV_FAM_CLEF').AsInteger;
  except
  end;
end;


procedure TFIndividuUnion.doInitialize;
begin
  TreeConj.BeginUpdate;
  try
    TreeConj.ClearNodes;
  finally
    TreeConj.EndUpdate;
  end;

  IBQUnions.Close;
  IBQEve.Close;
  IBConjoints.Close;
  IBQDetailConjoint.Close;
  QSourcesNotesUnion.Close;
end;



function TFIndividuUnion.doOpenQuerys: boolean;
var
  n: integer;
  aNodeIndividu: TNodeIndividu;
  NodeConjoint, ShoulSelectThisNode: TdxTreeListNode;

  aNode: TdxTreeListNode;
  s: string;
  LastCleFiche: integer;
begin
  //result := false;

  fCanScroll := false;
  ShoulSelectThisNode := nil;

  ibConjoints.DisableControls;
  ibConjoints.Close;
  ibConjoints.Params[0].AsInteger := dm.NumDossier;
  ibConjoints.Params[1].AsInteger := TFIndividu(fFormindividu).CleFiche;
  ibConjoints.Open;
  ibConjoints.last;
  ibConjoints.first;

  TreeConj.BeginUpdate;
  try
    //on regarde si un indi est slectionn
    LastCleFiche := -1;
    aNode := TreeConj.FocusedNode;
    if (aNode <> nil) and (aNode.Data <> nil) then
      begin
        if aNode.level = 1 then aNode := aNode.Parent;
        aNodeIndividu := TNodeIndividu(aNode.Data);
        LastCleFiche := aNodeIndividu.CleFiche;
      end;

    //on efface tout dans le treeview
    TreeConj.ClearNodes;

    for n := 1 to ibConjoints.RecordCount do
      begin
        //Nom, Prenom, Date de naissance, Date de dces
        s := AssembleString([ibConjoints.FieldByName('NOM').AsString, ibConjoints.FieldByName('PRENOM').AsString]);
        if ibConjoints.FieldByName('DATE_NAISSANCE').AsString <> '' then s := s + ' (  ' + ibConjoints.FieldByName('DATE_NAISSANCE').AsString + ')';
        if ibConjoints.FieldByName('DATE_DECES').AsString <> '' then s := s + ' - ( + ' + ibConjoints.FieldByName('DATE_DECES').AsString + ')';

        //cration d'un objet pour ce conjoint
        aNodeIndividu := TNodeIndividu.create;
        aNodeIndividu.Caption := s;
        aNodeIndividu.CleFiche := ibConjoints.FieldByName('CLE_FICHE').AsInteger;
        aNodeIndividu.Sexe := ibConjoints.FieldByName('SEXE').AsInteger;
        aNodeIndividu.TypeUnion := ibConjoints.FieldByName('TYPE_UNION').AsInteger;
        aNodeIndividu.UnionClef := ibConjoints.FieldByName('UNION_CLEF').AsInteger;

        aNodeIndividu.Sosa := 0;

        if ibConjoints.FieldByName('NUM_SOSA').AsFloat > 0 then
          aNodeIndividu.Sosa := Trunc(ibConjoints.FieldByName('NUM_SOSA').AsFloat);

        //On ajoute ce conjoint dans le treeView
        NodeConjoint := AddThisIndividu(aNodeIndividu, nil);

        if NodeConjoint <> nil then
          begin
            if LastCleFiche = aNodeIndividu.CleFiche then ShoulSelectThisNode := NodeConjoint;


            //recherche des parents
            IBQDetailConjoint.DisableControls;
            IBQDetailConjoint.close;
            IBQDetailConjoint.open;

            //Le pre de ce conjoint
            if IBQDetailConjoint.FieldByName('NOM_PERE').AsString <> '' then
              begin
                s := AssembleString([IBQDetailConjoint.FieldByName('NOM_PERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_PERE').AsString]);
                if IBQDetailConjoint.FieldByName('PERE_DATE_NAISSANCE').AsString <> '' then s := s + ' n le ' + IBQDetailConjoint.FieldByName('PERE_DATE_NAISSANCE').AsString;

                aNodeIndividu := TNodeIndividu.create;
                aNodeIndividu.Caption := s;
                //aNodeIndividu.CleFiche := IBQDetailConjoint.FieldByName('CLE_FICHE').AsInteger;
                aNodeIndividu.CleFiche := IBQDetailConjoint.FieldByName('PERE_CLE_FICHE').AsInteger;
                aNodeIndividu.Sexe := 1;

                //On ajoute le pre du conjoint, dans le treeView
                AddThisIndividu(aNodeIndividu, NodeConjoint);
              end;

            //la mere de ce conjoint
            if IBQDetailConjoint.FieldByName('NOM_MERE').AsString <> '' then
              begin
                s := AssembleString([IBQDetailConjoint.FieldByName('NOM_MERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_MERE').AsString]);
                if IBQDetailConjoint.FieldByName('MERE_DATE_NAISSANCE').AsString <> '' then s := s + ' ne le ' + IBQDetailConjoint.FieldByName('MERE_DATE_NAISSANCE').AsString;

                aNodeIndividu := TNodeIndividu.create;
                aNodeIndividu.Caption := s;
                //aNodeIndividu.CleFiche := IBQDetailConjoint.FieldByName('CLE_FICHE').AsInteger;
                aNodeIndividu.CleFiche := IBQDetailConjoint.FieldByName('MERE_CLE_FICHE').AsInteger;
                aNodeIndividu.Sexe := 2;

                //On ajoute la mre du conjoint, dans le treeView
                AddThisIndividu(aNodeIndividu, NodeConjoint);
              end;
            IBQDetailConjoint.EnableControls;
          end;

        ibConjoints.next;
      end;

    result := true;
  finally
    TreeConj.EndUpdate;
  end;

  //on essaye de reslectionner l'ancien node
  if ShoulSelectThisNode <> nil then ShoulSelectThisNode.Selected := true;

  ibConjoints.EnableControls;

  fCanScroll := true;

  ShowEvents;
end;

procedure TFIndividuUnion.IBQEveAfterScroll(DataSet: TDataSet);
begin
  doScrollEvent;
end;

procedure TFIndividuUnion.doScrollEvent;
begin
  if fCanScrollEvent then
    begin
      aFUnionEventsDetails.doOnDateChange;
      aFUnionEventsTemoins.OpenTemoins(IBQEveEV_FAM_CLEF.AsInteger);
    end;
end;

procedure TFIndividuUnion.mOuvrirFicheClick(Sender: TObject);
var aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
begin
  if TreeConj.FocusedNode <> nil then
    begin
      aNode := TreeConj.FocusedNode;
      if (aNode.Data <> nil) and (aNode.Level >= 0) then
        begin
          //on rcupre l'objet de stockage de l'individu
          aNodeIndividu := TNodeIndividu(aNode.Data);

          TFIndividu(fFormindividu).ChangeFicheActive(aNodeIndividu.CleFiche);
        end;
    end;
end;

procedure TFIndividuUnion.popupConjointsPopup(Sender: TObject);
begin
  mOuvrirFiche.enabled := (TreeConj.FocusedNode <> nil) and (TreeConj.FocusedNode.Data <> nil) and (TreeConj.FocusedNode.Level >= 0);
end;

procedure TFIndividuUnion.IBQEveBeforePost(DataSet: TDataSet);
var s_Proc: TIBStoredProc;
begin

  {- Ici on va verifier que le lieu existe, sinon on le creer dans la base -----------------------------}

  Application.ProcessMessages;
  Screen.Cursor := crHourGlass;
  s_Proc := TIBStoredProc.Create(Application);

  try
    try
      with s_Proc do begin
          DataBase := dm.ibd_BASE;
          StoredProcName := 'PROC_AJOUT_VILLE';
          Prepare;
          ParamByName('S_CP').AsString := IBQEveEV_FAM_CP.AsString;
          ParamByName('S_VILLE').AsString := IBQEveEV_FAM_VILLE.AsString;
          ParamByName('S_DEPT').AsString := IBQEveEV_FAM_DEPT.AsString;
          ParamByName('S_REGION').AsString := IBQEveEV_FAM_REGION.AsString;
          ParamByName('S_PAYS').AsString := IBQEveEV_FAM_PAYS.AsString;

          ExecProc;
        end;
    except
    end;
  finally
    begin
      s_Proc.UnPrepare;
      s_Proc.free;
    end;
  end;

  Screen.Cursor := crDefault;
  {-----------------------------------------------------------------------------------------------------}

  //on prpare les champs d'accueil de la date
  DataSet.FieldByName('EV_FAM_DATE_YEAR').Clear;
  DataSet.FieldByName('EV_FAM_DATE').Clear;

  if _GDate.DecodeHumanDate(DataSet.FieldByName('EV_FAM_DATE_WRITEN').AsString) then
    begin
      //l'anne
      if (_GDate.KnowYear) then DataSet.FieldByName('EV_FAM_DATE_YEAR').AsInteger := _GDate.GDate.Year1;

      //la date entire
      if (_GDate.KnowDate) then
        DataSet.FieldByName('EV_FAM_DATE').AsDateTime := _GDate.GDate.DateTime1;
    end;
end;

procedure TFIndividuUnion.TreeConjKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //     TFIndividu(fFormindividu).TestIfHelp(Key);
end;

procedure TFIndividuUnion.gridEventsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //   TFIndividu(fFormindividu).TestIfHelp(Key);
end;

procedure TFIndividuUnion.TreeConjMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  ARect: TRect;
  AColumn: TdxTreeListColumn;
  ANode: TdxTreeListNode;
begin
  ANode := TreeConj.GetNodeAt(X, Y);
  AColumn := TreeConj.GetColumnAt(X, Y);

  if (ANode <> nil) and (AColumn <> nil) then
    begin
      ARect := TreeConj.GetEditRect(ANode, AColumn.Index);
      if PtInRect(ARect, Point(X, Y)) then
        begin
          TreeConj.Cursor := 5;
          CurNodeC := ANode;
          CurColumnC := AColumn;
          TreeConj.Invalidate;
        end
      else
        begin
          TreeConj.Cursor := crDefault;
          if (CurNodeC <> nil) or (CurColumnC <> nil) then
            begin
              CurNodeC := nil;
              CurColumnC := nil;
              TreeConj.Invalidate;
            end;

        end;
    end
  else
    begin
      TreeConj.Cursor := crDefault;
      if (CurNodeC <> nil) or (CurColumnC <> nil) then
        begin
          CurNodeC := nil;
          CurColumnC := nil;
          TreeConj.Invalidate;
        end;
    end;
end;


procedure TFIndividuUnion.TreeConjCustomDrawCell(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
  AColumn: TdxTreeListColumn; ASelected, AFocused, ANewItemRow: Boolean;
  var AText: string; var AColor: TColor; AFont: TFont;
  var AAlignment: TAlignment; var ADone: Boolean);
begin
  if AColumn = dxTreeList1Column1 then
    begin


      if ASelected then AColor := TreeConj.HighlightColor else AColor := clWindow;
      //AColor := clWindow;
      {
      if (ANode = CurNodeC) and (AColumn = CurColumnC) then
      begin
       AFont.Style := [fsUnderline];

      end
      else
      begin
       AFont.Style := [];
      end;
               }
      case TNodeIndividu(aNode.data).Sexe of
        1: aFont.Color := _Context.ColorHomme;
        2: aFont.Color := _Context.ColorFemme;
        else
          aFont.Color := clBlack
      end;

      if TNodeIndividu(aNode.data).Sosa > 0 then
        begin
          AFont.Color := _COLOR_SOSA;
        end;
    end;
end;

{
 if TNodeIndividu(aNode.data).Sosa > 0 then
 begin
  AFont.Color := _COLOR_SOSA;
  //AFont.Style := AFont.Style + [fsBold];
 end;
 }

procedure TFIndividuUnion.FlatTabControlCommentUnionTabChanged(Sender: TObject);
begin
  doShowGoodTab_CommentSourceUnion;
end;

procedure TFIndividuUnion.doShowGoodTab_CommentSourceUnion;
begin
  case FlatTabControlCommentUnion.ActiveTab of

    0: begin
        edCommentaires.Show;
        edSources.Hide;
      end;

    1: begin
        edCommentaires.Hide;
        edSources.Show;
      end;
  end;
end;

procedure TFIndividuUnion.DataSourceSourceCommentUnionStateChange(Sender: TObject);
begin
  TFIndividu(FormIndividu).doRefreshControls;
end;

procedure TFIndividuUnion.btnDetailClick(Sender: TObject);
var
  aFBiblio_Sources: TFBiblio_Sources;
begin
  aFBiblio_Sources := TFBiblio_Sources.create(self);
  try

    Application.ProcessMessages;
    aFBiblio_Sources.doOpenQuerys(IBQEveEV_FAM_CLEF.AsInteger, 'F');
    aFBiblio_Sources.ShowModal;
  finally

    if dm.IBQSources_Record.State in [dsEdit, dsInsert] then
      begin
        dsEve.Edit;
        IBQEveEV_FAM_SOURCE.asString := aFBiblio_Sources.sText;
      end
    else if aFBiblio_Sources.Modif = True then
      begin
        TFIndividu(fFormindividu).Modified := true;
        TFIndividu(FormIndividu).DoRefreshControls;
      end;
    aFBiblio_Sources.Free;
  end;

end;

end.
