{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_edit_event_life;

interface

uses
  Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
  StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages, Dialogs,
  TFlatSpeedButtonUnit, dxTLClms, dxTL, dxCntner, TFlatButtonUnit,
  dxExEdtr, dxEdLib, dxDBELib, dxEditor, Db,
  Graphics, IBQuery, SysUtils, IBCustomDataSet, IBUpdateSQL,
  u_objet_TIntegerList, TFlatTabControlUnit, dxDBCtrl, dxDBGrid, ImgList,
  dxDBEdtr, DBCtrls, u_comp_TGoodBtn, Menus, u_comp_TYLanguage,
  u_comp_TNakedSpeedButton, DynamicSkinForm;

type

  TNodeIndividu = class
  private
    fSexe: integer;
    fCleFiche: integer;
    fCaption: string;
    fTypeUnion: integer;
    fUnionClef: integer;
  public
    constructor Create;
    property Caption: string read fCaption write fCaption;
    property CleFiche: integer read fCleFiche write fCleFiche;
    property Sexe: integer read fSexe write fSexe;
    property TypeUnion: integer read fTypeUnion write fTypeUnion;
    property UnionClef: integer read fUnionClef write fUnionClef;
  end;

  TFIndividuEditEventLife = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    panDock: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    edDept: TdxDBEdit;
    edCP: TdxDBEdit;
    edLieu: TdxDBEdit;
    edVille: TdxDBPickEdit;
    edRegion: TdxDBEdit;
    edSubdi: TdxDBEdit;
    edDesc: TdxDBEdit;
    Panel1: TPanel;
    Label11: TLabel;
    Label12: TLabel;
    TreeConj: TdxTreeList;
    dxTreeList1Column1: TdxTreeListColumn;
    dxTreeListColumnTypeUnion: TdxTreeListPickColumn;
    DataSource: TDataSource;
    IBTemoins: TIBQuery;
    IBTemoinsCLE_FICHE: TIntegerField;
    IBTemoinsNOM: TIBStringField;
    IBTemoinsPRENOM: TIBStringField;
    IBTemoinsDATE_NAISSANCE: TIBStringField;
    IBTemoinsDATE_DECES: TIBStringField;
    IBTemoinsSEXE: TIntegerField;
    IBTemoinsASSOC_TYPE: TIntegerField;
    IBTemoinsASSOC_CLEF: TIntegerField;
    IBTemoinsKLE_DOSSIER: TIntegerField;
    DSTemoins: TDataSource;
    IBQDetailTemoins: TIBQuery;
    IBQAssocies: TIBQuery;
    IBQAssociesASSOC_CLEF: TIntegerField;
    IBQAssociesASSOC_KLE_IND: TIntegerField;
    IBQAssociesASSOC_KLE_ASSOCIE: TIntegerField;
    IBQAssociesASSOC_NOTES: TBlobField;
    IBQAssociesASSOC_SOURCES: TBlobField;
    IBQAssociesASSOC_EVENEMENT: TIntegerField;
    IBQAssociesASSOC_TABLE: TIBStringField;
    IBQAssociesTYPE_TEMOIN: TStringField;
    IBUAssocies: TIBUpdateSQL;
    DSUnion: TDataSource;
    FlatTabControl: TFlatTabControl;
    panDockEvents: TPanel;
    edCommentaires: TdxDBMemo;
    edSources: TdxDBMemo;
    Panel2: TPanel;
    Panel3: TPanel;
    dxDBImageEdit1: TdxDBImageEdit;
    Panel5: TPanel;
    DBText1: TDBText;
    lbDay: TLabel;
    edDate: TdxDBEdit;
    btnSearchVille: TGoodBtn;
    fbCarte: TGoodBtn;
    btnVillesFavoris: TGoodBtn;
    fbInfosVilles: TGoodBtn;
    fbPays: TGoodBtn;
    btnFermer: TGoodBtn;
    bsfbAjout: TGoodBtn;
    bsfbRetirer: TGoodBtn;
    Label5: TLabel;
    IBQAssociesASSOC_TYPE: TIntegerField;
    IBQAssociesASSOC_KLE_DOSSIER: TIntegerField;
    ibqToken: TIBQuery;
    ibqTokenTOKEN: TIBStringField;
    edPays: TdxDBEdit;
    pmDate: TPopupMenu;
    Language: TYLanguage;
    dbcbVille: TdxDBEdit;
    fbCalend: TGoodBtn;
    IBMultimedia: TIBQuery;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    btnActe: TBlueFlatSpeedButton;
    btnPrecedent: TFlatSpeedButton;
    btnSuivant: TFlatSpeedButton;
    edInsee: TdxDBEdit;
    Label6: TLabel;
    btnDetail: TGoodBtn;
    spDynamicSkinForm1: TspDynamicSkinForm;
    edHeure: TdxDBTimeEdit;
    Label13: TLabel;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure edDateChange(Sender: TObject);
    procedure edCPChange(Sender: TObject);
    procedure btnSearchVilleClick(Sender: TObject);
    procedure edVilleChange(Sender: TObject);
    procedure fbInfosVillesClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure DSUnionDataChange(Sender: TObject; Field: TField);
    procedure DSUnionStateChange(Sender: TObject);
    procedure TreeConjDeletion(Sender: TObject; Node: TdxTreeListNode);
    procedure TreeConjEditing(Sender: TObject; Node: TdxTreeListNode;
      var Allow: Boolean);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure bsfbAjoutClick(Sender: TObject);
    procedure bsfbRetirerClick(Sender: TObject);
    procedure FlatTabControlTabChanged(Sender: TObject);
    procedure DataSourceStateChange(Sender: TObject);
    procedure btnFermerClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure dxDBImageEdit1Enter(Sender: TObject);
    procedure btnVillesFavorisClick(Sender: TObject);
    procedure edDateExit(Sender: TObject);
    procedure SuperFormHide(Sender: TObject);
    procedure TreeConjChangeNode(Sender: TObject; OldNode,
      Node: TdxTreeListNode);
    procedure dxTreeListColumnTypeUnionCloseUp(Sender: TObject;
      var Value: Variant; var Accept: Boolean);
    procedure fbPaysClick(Sender: TObject);
    procedure fbCarteClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormShow(Sender: TObject);
    procedure TreeConjCustomDrawCell(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; ANode: TdxTreeListNode; AColumn: TdxTreeListColumn;
      ASelected, AFocused, ANewItemRow: Boolean; var AText: string;
      var AColor: TColor; AFont: TFont; var AAlignment: TAlignment;
      var ADone: Boolean);
    procedure fbCalendClick(Sender: TObject);
    procedure btnActeClick(Sender: TObject);
    procedure btnSuivantClick(Sender: TObject);
    procedure btnPrecedentClick(Sender: TObject);
    procedure btnDetailClick(Sender: TObject);
  private
    l_Cp, l_Dept, l_Pays, l_Villes, l_Region, l_Insee: TStringList;
    fCodesRefTemoins: TIntegerList;
    fLibellesRefTemoins: TStringList;

    fFormIndividu: TForm;

    function AddThisIndividu(aNodeIndividu: TNodeIndividu; ToNode: TdxTreeListNode): TdxTreeListNode;
    procedure doTestCoherence;
    procedure up_SubMenu(Sender: TObject);
    procedure doShowGoodTab_CommentSourceEvent;

  public
    property FormIndividu: TForm read fFormIndividu write fFormIndividu;

    procedure OpenTemoins;
    procedure doShowDay;
    procedure doBoutons;
  end;

implementation

uses u_dm, u_common_var, u_form_list_villes,
  u_form_individu, u_form_individu_par_prenom, u_common_func,
  u_form_Evements_Ajout, u_form_Ville_Favoris, u_form_Pays, u_common_const,
  u_form_calendriers, u_form_biblio_Multimedia_Edit, u_form_biblio_Sources,
  u_form_main;

{$R *.DFM}


procedure TFIndividuEditEventLife.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFIndividuEditEventLife.edDateChange(Sender: TObject);
begin
  if _GDate.DecodeHumanDate(TdxDbEdit(edDate).Text) then
    begin
      edDate.Font.color := clWindowText;
    end
  else
    begin
      edDate.Font.color := clRed;
    end;

  doShowDay;
end;

procedure TFIndividuEditEventLife.doShowDay;
begin
  if _GDate.DecodeHumanDate(TdxDbEdit(edDate).Text) then
    begin
      if _GDate.KnowDate then
        begin

          lbDay.Caption := '(' + LongDayNames[DayOfWeek(_GDate.GDate.DateTime1)] + ')';
          lbDay.visible := true;
        end
      else lbDay.visible := false;
    end
  else
    begin
      lbDay.visible := false;
    end;
end;

procedure TFIndividuEditEventLife.edCPChange(Sender: TObject);
begin
  edVille.items.Clear;
  dbcbVille.Clear;
  l_Dept.Clear;
  l_Cp.Clear;
  l_Pays.Clear;
  l_Villes.Clear;
  l_Region.Clear;
  l_Insee.Clear;
  edDept.Text := '';
  edVille.Text := '';
  edPays.Text := '';
  edRegion.Text := '';
  edInsee.Text := '';

  btnSearchVille.Enabled := Length(edCP.Text) > 0
end;

procedure TFIndividuEditEventLife.btnSearchVilleClick(Sender: TObject);
var aProc: TIBQuery;
begin
  aProc := TIBQuery.create(self);

  try
    aProc.Database := dm.ibd_BASE;
    aProc.Transaction := dm.IBTrans_Secondaire;

    aProc.SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_CP(:I_CODE)');
    //aProc.Params[0].AsString := TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_CP.asString;
    aProc.Params[0].AsString := edCP.Text;
    aProc.Open;

    edVille.Items.Clear;
    dbcbVille.Clear;

    l_Cp.Clear;
    l_Dept.Clear;
    l_Pays.Clear;
    l_Villes.Clear;
    l_Region.Clear;
    l_Insee.Clear;

    while not aProc.eof do
      begin
        edVille.Items.Add(aProc.FieldByName('VILLE').AsString);

        l_CP.Add(aProc.FieldByName('CODE').AsString);
        l_Villes.Add(aProc.FieldByName('VILLE').AsString);
        l_Dept.Add(aProc.FieldByName('DEPARTEMENT').AsString);
        l_Pays.Add(aProc.FieldByName('PAYS').AsString);
        l_Region.Add(aProc.FieldByName('REGION').AsString);
        l_Insee.Add(aProc.FieldByName('CP_INSEE').AsString);

        aProc.next;
      end;

    if l_Villes.Count > 0 then
      begin
        if (not (DataSource.DataSet.State in [dsEdit, dsInsert])) then DataSource.DataSet.Edit;

        DataSource.DataSet.FieldByName('EV_IND_CP').AsString := l_CP[0];
        DataSource.DataSet.FieldByName('EV_IND_VILLE').AsString := l_Villes[0];
        DataSource.DataSet.FieldByName('EV_IND_DEPT').asString := l_Dept[0];
        DataSource.DataSet.FieldByName('EV_IND_PAYS').asString := l_Pays[0];
        DataSource.DataSet.FieldByName('EV_IND_REGION').asString := l_Region[0];
        DataSource.DataSet.FieldByName('EV_IND_INSEE').asString := l_Insee[0];
      end;

    if edVille.Items.Count > 1 then
      begin
        edVille.DroppedDown := True;
        edVille.Top := dbcbVille.Top;
        edVille.Left := dbcbVille.Left;
        edVille.Width := dbcbVille.Width;

        edVille.Visible := True;
        dbcbVille.Visible := False;
      end
    else
      begin
        edVille.Visible := False;
        dbcbVille.Visible := True;
      end;

  finally
    aProc.Free;
  end;
end;

procedure TFIndividuEditEventLife.edVilleChange(Sender: TObject);
var
  k: integer;
begin
  //on recherche la ville dans la liste
 // k := l_Villes.IndexOf(AnsiUpperCase(DataSource.DataSet.FieldByName('EV_IND_VILLE').AsString));
  k := l_Villes.IndexOf(AnsiUpperCase(edVille.Text));

  if k <> -1 then
    begin
      DataSource.DataSet.FieldByName('EV_IND_CP').asString := l_CP[k];
      DataSource.DataSet.FieldByName('EV_IND_DEPT').asString := l_Dept[k];
      DataSource.DataSet.FieldByName('EV_IND_PAYS').asString := l_Pays[k];
      DataSource.DataSet.FieldByName('EV_IND_REGION').asString := l_Region[k];
      DataSource.DataSet.FieldByName('EV_IND_INSEE').asString := l_Insee[k];
    end;

end;

procedure TFIndividuEditEventLife.fbInfosVillesClick(Sender: TObject);
var
  aFListVilles: TFListVilles;
begin
  aFListVilles := TFListVilles.create(self);
  try

    if aFListVilles.ShowModal = mrOk then
      begin
        if not (DataSource.DataSet.State in [dsEdit, dsInsert]) then
          DataSource.DataSet.Edit;

        DataSource.DataSet.FieldByName('EV_IND_CP').asString := aFListVilles.Code;
        DataSource.DataSet.FieldByName('EV_IND_VILLE').asString := aFListVilles.Ville;
        DataSource.DataSet.FieldByName('EV_IND_PAYS').asString := aFListVilles.Pays;
        DataSource.DataSet.FieldByName('EV_IND_DEPT').asString := aFListVilles.Dept;
        DataSource.DataSet.FieldByName('EV_IND_REGION').asString := aFListVilles.Region;
        DataSource.DataSet.FieldByName('EV_IND_INSEE').asString := aFListVilles.Insee;
      end;
  finally
    aFListVilles.Free;
  end;
end;

procedure TFIndividuEditEventLife.SuperFormCreate(Sender: TObject);
var
  NewItem: TMenuItem;
  I: integer;
begin
  if _Context.Skin then
    begin
      ClientHeight := 512;
      ClientWidth := 418;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  lbDay.caption := '';
  fFormIndividu := nil;

  l_Cp := TStringList.Create;
  l_Dept := TStringList.Create;
  l_Pays := TStringList.Create;
  l_Villes := TStringList.Create;
  l_Region := TStringList.Create;
  l_Insee := TStringList.Create;

  fCodesRefTemoins := TIntegerList.create;
  fLibellesRefTemoins := TStringList.create;

  dxTreeListColumnTypeUnion.Items.Clear;
  try
    dm.IBQTypeTemoin.First;

    while not dm.IBQTypeTemoin.Eof do
      begin
        fCodesRefTemoins.Add(dm.IBQTypeTemoinI_TYPE.AsInteger);
        fLibellesRefTemoins.Add(dm.IBQTypeTemoinLIBELLE.AsString);
        dxTreeListColumnTypeUnion.Items.Add(dm.IBQTypeTemoinLIBELLE.AsString);

        dm.IBQTypeTemoin.next;
      end;
  except
  end;

  ibqToken.Params[0].AsString := _Context.Langue;
  ibqToken.Open;
  i := 0;
  while not ibqToken.Eof do
    begin
      //pmDate.Items.Add (ibqToken.ParamByName('TOKEN').AsString);
      NewItem := TMenuItem.Create(Self);
      NewItem.Caption := ibqTokenTOKEN.AsString;
      pmDate.Items.Add(NewItem);
      pmDate.Items[i].OnClick := up_SubMenu;
      ibqToken.next;
      inc(i);
    end;

  ibqToken.Close;

  doRefreshControls;

end;

procedure TFIndividuEditEventLife.up_SubMenu(Sender: TObject);
var sToken: string;
begin
  sToken := (sender as TMenuItem).Caption;

  if (not (DataSource.DataSet.State in [dsEdit, dsInsert])) then
    DataSource.DataSet.Edit;

  if edDate.text = '' then
    DataSource.DataSet.FieldByName('EV_IND_DATE_WRITEN').AsString := sToken
  else
    DataSource.DataSet.FieldByName('EV_IND_DATE_WRITEN').AsString := edDate.text + ' ' + sToken;

  edDate.SelStart := Length(edDate.text) + 1
end;

procedure TFIndividuEditEventLife.SuperFormDestroy(Sender: TObject);
begin
  l_CP.Free;
  l_Dept.Free;
  l_Pays.Free;
  l_Villes.Free;
  l_Region.Free;
  l_Insee.Free;

  fCodesRefTemoins.free;
  fLibellesRefTemoins.free;
end;

procedure TFIndividuEditEventLife.DSUnionDataChange(Sender: TObject; Field: TField);
begin
  TFIndividu(fFormIndividu).DoRefreshControls;
end;

procedure TFIndividuEditEventLife.DSUnionStateChange(Sender: TObject);
begin
  TFIndividu(fFormIndividu).DoRefreshControls;
end;

procedure TFIndividuEditEventLife.TreeConjDeletion(Sender: TObject;
  Node: TdxTreeListNode);
begin
  if Node.Data <> nil then
    begin
      TNodeIndividu(Node.Data).free;
      Node.Data := nil;
    end;
end;

procedure TFIndividuEditEventLife.TreeConjEditing(Sender: TObject;
  Node: TdxTreeListNode; var Allow: Boolean);
begin
  if Node.Level = 1 then Allow := False
  else
    if Node.Level = 0 then
      begin
        if TreeConj.FocusedColumn = 0 then Allow := false;
      end;
end;

procedure TFIndividuEditEventLife.SuperFormRefreshControls(Sender: TObject);
var
  OkEvent: boolean;
begin

  if fFormIndividu <> nil then
    begin
      //     btnSelectReligion.visible := (TFIndividu(fFormIndividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false) and (DataSource.DataSet.FieldByName('EV_IND_TYPE').AsString = 'RELI');
      OkEvent := (TFIndividu(fFormIndividu).CleFiche <> -1) and (DataSource.DataSet <> nil)
        and (DataSource.DataSet.Active) and (DataSource.DataSet.RecordCount > 0) and
        (TFIndividu(fFormindividu).DialogMode = false);
      //   OkTemoins :=(IBTemoins

      edDate.enabled := OkEvent;
      edCP.enabled := OkEvent;
      btnSearchVille.enabled := OkEvent;
      edVille.enabled := OkEvent;
      dbcbVille.enabled := OkEvent;
      fbInfosVilles.enabled := OkEvent;
      btnVillesFavoris.enabled := OkEvent;
      edDept.enabled := OkEvent;
      edPays.enabled := OkEvent;
      fbPays.enabled := OkEvent;
      edRegion.enabled := OkEvent;
      edInsee.enabled := OkEvent;
      edSubdi.enabled := OkEvent;
      edLieu.enabled := OkEvent;
      edDesc.enabled := OkEvent;
      fbCalend.enabled := OkEvent;
      fbCarte.enabled := OkEvent;
      edSources.enabled := OkEvent;
      edCommentaires.enabled := OkEvent;

      bsfbAjout.enabled := OkEvent and (TFIndividu(fFormIndividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
      bsfbRetirer.enabled := OkEvent and (TreeConj.FocusedNode <> nil) and (TreeConj.FocusedNode.Level = 0) and (TFIndividu(fFormindividu).DialogMode = false);
      TreeConj.enabled := OkEvent and (TFIndividu(fFormindividu).DialogMode = false);
      DataSource.AutoEdit := OkEvent and (TFIndividu(fFormindividu).DialogMode = false);

      doBoutons;
    end;
end;

procedure TFIndividuEditEventLife.bsfbAjoutClick(Sender: TObject);
var
  aNodeIndividu: TNodeIndividu;
  NodeConjoint: TdxTreeListNode;
  s: string;
  i_bConjoints: TIBQuery;
  aFIndividuPrenom: TFIndividuPrenom;
  NewAssocCle: integer;
begin

  //Cration de la boite de recherche d'un individu par le prnom
  aFIndividuPrenom := TFIndividuPrenom.create(self);
  try
    aFIndividuPrenom.Position := poMainFormCenter;

    aFIndividuPrenom.up_InitIndividuPrenom('A', '', 0, 2);

    if aFIndividuPrenom.ShowModal = mrOk then
      begin
        //On ouvre le query des unions
        NewAssocCle := dm.uf_GetClefUnique('T_ASSOCIATIONS');
        IBQAssocies.Open;
        IBQAssocies.Append;
        IBQAssocies.FieldByName('ASSOC_CLEF').AsInteger := NewAssocCle;
        IBQAssocies.FieldByName('ASSOC_KLE_DOSSIER').AsInteger := dm.NumDossier;
        IBQAssocies.FieldByName('ASSOC_TYPE').AsInteger := 0;
        IBQAssocies.FieldByName('ASSOC_TABLE').AsString := 'I';
        IBQAssocies.FieldByName('ASSOC_EVENEMENT').AsInteger := DataSource.DataSet.FieldByName('EV_IND_CLEF').AsInteger;

        IBQAssocies.FieldByName('ASSOC_KLE_IND').AsInteger := TFIndividu(fFormIndividu).CleFiche;
        IBQAssocies.FieldByName('ASSOC_KLE_ASSOCIE').AsInteger := aFIndividuPrenom.ClefIndividuSelected;

        IBQAssocies.Post;

        //on indique que l'individu est modifi
        TFIndividu(fFormIndividu).Modified := true;

        i_bConjoints := TIBQuery.Create(Self);
        try
          i_bConjoints.DataBase := dm.ibd_BASE;
          i_bConjoints.SQL.ADD('select *  FROM PROC_PRENOM_PAR_NOM_PAR_CLEF(:CLE_FICHE,:KLE_DOSSIER)');
          i_bConjoints.Params[0].AsInteger := aFIndividuPrenom.ClefIndividuSelected;
          i_bConjoints.Params[1].AsInteger := dm.NumDossier;
          i_bConjoints.Open;

          //on ajoute un item dans le TreeList
          TreeConj.BeginUpdate;
          try
            //Nom, Prenom, Date de naissance, Date de dces
            s := AssembleString([i_bConjoints.FieldByName('NOM').AsString, i_bConjoints.FieldByName('PRENOM').AsString]);
            if i_bConjoints.FieldByName('DATE_NAISSANCE').AsString <> '' then s := s + ' (  ' + i_bConjoints.FieldByName('DATE_NAISSANCE').AsString + ')';
            if i_bConjoints.FieldByName('DATE_DECES').AsString <> '' then s := s + ' - ( + ' + i_bConjoints.FieldByName('DATE_DECES').AsString + ')';

            //Cration d'un objet, pour ce conjoint
            aNodeIndividu := TNodeIndividu.create;
            aNodeIndividu.Caption := s;
            aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
            aNodeIndividu.Sexe := i_bConjoints.FieldByName('SEXE').AsInteger;
            aNodeIndividu.TypeUnion := 0;
            aNodeIndividu.UnionClef := NewAssocCle;

            //On ajoute ce conjoint dans le treeView
            NodeConjoint := AddThisIndividu(aNodeIndividu, nil);

            TreeConj.FocusedNumber := TreeConj.RowCount;

            if NodeConjoint <> nil then
              begin
                //Ce conjoint a-t'il un pre ?
                if i_bConjoints.FieldByName('NOM_PERE').AsString <> '' then
                  begin
                    s := AssembleString([i_bConjoints.FieldByName('NOM_PERE').AsString,
                      i_bConjoints.FieldByName('PRENOM_PERE').AsString]);
                    if i_bConjoints.FieldByName('PERE_DATE_NAISSANCE').AsString <> '' then
                      s := s + ' n le ' + i_bConjoints.FieldByName('PERE_DATE_NAISSANCE').AsString;

                    aNodeIndividu := TNodeIndividu.create;
                    aNodeIndividu.Caption := s;
                    aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                    aNodeIndividu.Sexe := 1;

                    //On ajoute le pre du conjoint, dans le treeView
                    AddThisIndividu(aNodeIndividu, NodeConjoint);
                  end;

                //Ce conjoint a-t'il une mre ?
                if i_bConjoints.FieldByName('NOM_MERE').AsString <> '' then
                  begin
                    s := AssembleString([i_bConjoints.FieldByName('NOM_MERE').AsString,
                      i_bConjoints.FieldByName('PRENOM_MERE').AsString]);
                    if i_bConjoints.FieldByName('MERE_DATE_NAISSANCE').AsString <> '' then
                      s := s + ' ne le ' + i_bConjoints.FieldByName('MERE_DATE_NAISSANCE').AsString;

                    aNodeIndividu := TNodeIndividu.create;
                    aNodeIndividu.Caption := s;
                    aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                    aNodeIndividu.Sexe := 2;

                    //On ajoute la mre du conjoint, dans le treeView
                    AddThisIndividu(aNodeIndividu, NodeConjoint);
                  end;
              end;

          finally
            TreeConj.EndUpdate;
          end;
        finally
          i_bConjoints.Free;
        end;
      end;

  finally
    aFIndividuPrenom.Free;
  end;

  TFIndividu(fFormIndividu).DoRefreshControls;

end;

procedure TFIndividuEditEventLife.bsfbRetirerClick(Sender: TObject);
var
  aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
  QUpdateTypeUnion: TIBQuery;
begin
  if TreeConj.FocusedNode <> nil then
    begin
      aNode := TreeConj.FocusedNode;
      if (aNode.Data <> nil) and (aNode.Level = 0) then
        begin
          //on rcupre l'objet de stockage de l'individu
          aNodeIndividu := TNodeIndividu(aNode.Data);

          if aNodeIndividu.UnionClef <> -1 then
            begin
              if MyMessageDlg('Confirmez-vous la suppression de ce tmoin associ  : ' +
                aNodeIndividu.fCaption + ' ?',
                mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                begin
                  QUpdateTypeUnion := TIBQuery.create(self);
                  try
                    QUpdateTypeUnion.Database := dm.ibd_BASE;
                    //QUpdateTypeUnion.SQL.Add('EXECUTE PROCEDURE PROC_DELETE_UNION(:CLEF)');
                    QUpdateTypeUnion.SQL.Add('delete from T_ASSOCIATIONS where ASSOC_CLEF=' + inttostr(aNodeIndividu.UnionClef));
                    //QUpdateTypeUnion.Params[0].AsInteger := aNodeIndividu.UnionClef;
                    QUpdateTypeUnion.ExecSQL;
                    QUpdateTypeUnion.Close;

                    //on indique qu'on a fait une modification
                    TFIndividu(fFormIndividu).Modified := true;
                  finally
                    QUpdateTypeUnion.Free;
                  end;

                  TreeConj.FocusedNode.Free;
                  TFIndividu(fFormIndividu).DoRefreshControls;
                end;
            end;
        end;
    end;

end;

function TFIndividuEditEventLife.AddThisIndividu(aNodeIndividu: TNodeIndividu; ToNode: TdxTreeListNode): TdxTreeListNode;
var
  N: TdxTreeListNode;
  k, w: integer;
begin
  //Si ToNode=Nil, alors c'est un conjoint qu'on ajoute, sinon, c'est un parent du conjoint
  if ToNode = nil then N := TreeConj.Add else N := ToNode.AddChild;

  if N <> nil then
    begin
      N.Data := aNodeIndividu;

      N.Values[0] := aNodeIndividu.Caption;
      if ToNode = nil then
        begin
          //Type d'union
          w := fCodesRefTemoins.IndexOf(aNodeIndividu.TypeUnion);

          if w <> -1 then N.Values[1] := fLibellesRefTemoins[w]
          else N.Values[1] := '';

          N.ImageIndex := 3;
          N.SelectedIndex := 3;
        end
      else
        begin
          N.Values[1] := '';

          //image du sexe
          case aNodeIndividu.Sexe of
            1: k := 1;
            2: k := 0;
            else
              k := -1;
          end;

          N.ImageIndex := k;
          N.SelectedIndex := k;
        end;
    end;

  result := N;
end;

{ TNodeIndividu }

constructor TNodeIndividu.Create;
begin
  fCaption := '';
  fSexe := -1;
  fCleFiche := -1;
  fTypeUnion := -1;
  fUnionClef := -1;
end;

procedure TFIndividuEditEventLife.OpenTemoins;
var
  n: integer;
  aNodeIndividu: TNodeIndividu;
  NodeConjoint: TdxTreeListNode;

  s: string;
begin
  IBTemoins.DisableControls;

  IBTemoins.Close;
  IBTemoins.Params[0].AsInteger := dm.NumDossier;
  IBTemoins.Params[1].AsInteger := TFIndividu(fFormindividu).CleFiche;
  IBTemoins.Params[2].AsInteger := DataSource.DataSet.FieldByName('EV_IND_CLEF').AsInteger;
  IBTemoins.Open;
  IBTemoins.last;
  IBTemoins.first;

  TreeConj.BeginUpdate;
  try
    //on efface tout dans le treeview
    TreeConj.ClearNodes;

    for n := 1 to IBTemoins.RecordCount do
      begin
        //Nom, Prenom, Date de naissance, Date de dces
        s := AssembleString([IBTemoins.FieldByName('NOM').AsString, IBTemoins.FieldByName('PRENOM').AsString]);
        if IBTemoins.FieldByName('DATE_NAISSANCE').AsString <> '' then s := s + ' (  ' + IBTemoins.FieldByName('DATE_NAISSANCE').AsString + ')';
        if IBTemoins.FieldByName('DATE_DECES').AsString <> '' then s := s + ' - ( + ' + IBTemoins.FieldByName('DATE_DECES').AsString + ')';

        //cration d'un objet pour ce conjoint
        aNodeIndividu := TNodeIndividu.create;
        aNodeIndividu.Caption := s;
        aNodeIndividu.CleFiche := IBTemoins.FieldByName('CLE_FICHE').AsInteger;
        aNodeIndividu.Sexe := IBTemoins.FieldByName('SEXE').AsInteger;
        aNodeIndividu.TypeUnion := IBTemoins.FieldByName('ASSOC_TYPE').AsInteger;
        aNodeIndividu.UnionClef := IBTemoins.FieldByName('ASSOC_CLEF').AsInteger;

        //On ajoute ce conjoint dans le treeView
        NodeConjoint := AddThisIndividu(aNodeIndividu, nil);

        if NodeConjoint <> nil then
          begin

            //recherche des parents
            IBQDetailTemoins.DisableControls;
            IBQDetailTemoins.close;
            IBQDetailTemoins.open;

            //Le pre de ce conjoint
            if IBQDetailTemoins.FieldByName('NOM_PERE').AsString <> '' then
              begin
                s := AssembleString([IBQDetailTemoins.FieldByName('NOM_PERE').AsString, IBQDetailTemoins.FieldByName('PRENOM_PERE').AsString]);
                if IBQDetailTemoins.FieldByName('PERE_DATE_NAISSANCE').AsString <> '' then s := s + ' n le ' + IBQDetailTemoins.FieldByName('PERE_DATE_NAISSANCE').AsString;

                aNodeIndividu := TNodeIndividu.create;
                aNodeIndividu.Caption := s;
                aNodeIndividu.CleFiche := IBQDetailTemoins.FieldByName('CLE_FICHE').AsInteger;
                aNodeIndividu.Sexe := 1;

                //On ajoute le pre du conjoint, dans le treeView
                AddThisIndividu(aNodeIndividu, NodeConjoint);
              end;

            //la mere de ce conjoint
            if IBQDetailTemoins.FieldByName('NOM_MERE').AsString <> '' then
              begin
                s := AssembleString([IBQDetailTemoins.FieldByName('NOM_MERE').AsString, IBQDetailTemoins.FieldByName('PRENOM_MERE').AsString]);
                if IBQDetailTemoins.FieldByName('MERE_DATE_NAISSANCE').AsString <> '' then s := s + ' ne le ' + IBQDetailTemoins.FieldByName('MERE_DATE_NAISSANCE').AsString;

                aNodeIndividu := TNodeIndividu.create;
                aNodeIndividu.Caption := s;
                aNodeIndividu.CleFiche := IBQDetailTemoins.FieldByName('CLE_FICHE').AsInteger;
                aNodeIndividu.Sexe := 2;

                //On ajoute la mre du conjoint, dans le treeView
                AddThisIndividu(aNodeIndividu, NodeConjoint);
              end;
            IBQDetailTemoins.EnableControls;
          end;

        IBTemoins.next;
      end;
  finally
    TreeConj.EndUpdate;
  end;
  IBTemoins.EnableControls;
end;

procedure TFIndividuEditEventLife.FlatTabControlTabChanged(Sender: TObject);
begin
  doShowGoodTab_CommentSourceEvent;
end;

procedure TFIndividuEditEventLife.doShowGoodTab_CommentSourceEvent;
begin
  case FlatTabControl.ActiveTab of
    0: begin
        edCommentaires.Show;
        edSources.Hide;
        btnDetail.Hide;
      end;

    1: begin
        edCommentaires.Hide;
        edSources.Show;
        btnDetail.Visible := true;
      end;
  end;
end;

procedure TFIndividuEditEventLife.DataSourceStateChange(Sender: TObject);
begin
  if (DataSource.State in [dsEdit, dsInsert]) then
    begin
      TFIndividu(fFormindividu).Modified := true;
      TFIndividu(fFormindividu).DoRefreshControls;
    end;
end;

procedure TFIndividuEditEventLife.btnFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFIndividuEditEventLife.sbCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFIndividuEditEventLife.dxDBImageEdit1Enter(Sender: TObject);
begin
  if edDate.CanFocus then edDate.SetFocus;
end;

procedure TFIndividuEditEventLife.btnVillesFavorisClick(Sender: TObject);
var
  aFVillesFavoris: TFVillesFavoris;
begin
  aFVillesFavoris := TFVillesFavoris.create(self);
  try
    aFVillesFavoris.Mode := True;
    if aFVillesFavoris.ShowModal = mrOk then
      begin

        if not (DataSource.DataSet.State in [dsEdit, dsInsert]) then
          DataSource.DataSet.Edit;

        DataSource.DataSet.FieldByName('EV_IND_CP').asString := aFVillesFavoris.Code;
        DataSource.DataSet.FieldByName('EV_IND_VILLE').asString := aFVillesFavoris.Ville;
        DataSource.DataSet.FieldByName('EV_IND_PAYS').asString := aFVillesFavoris.Pays;
        DataSource.DataSet.FieldByName('EV_IND_DEPT').asString := aFVillesFavoris.Dept;
        DataSource.DataSet.FieldByName('EV_IND_REGION').asString := aFVillesFavoris.Region;
        DataSource.DataSet.FieldByName('EV_IND_INSEE').asString := aFVillesFavoris.Insee;

      end;
  finally
    aFVillesFavoris.Free;
  end;
end;

procedure TFIndividuEditEventLife.edDateExit(Sender: TObject);
begin
  doTestCoherence;
end;

procedure TFIndividuEditEventLife.doTestCoherence;
var
  s: string;
begin
  //on refait un test de cohrence
  s := DataSource.DataSet.FieldByName('EV_IND_TYPE').AsString;
  if s = 'BIRT' then
    begin
      TFIndividu(fFormIndividu).CoherenceDate.Naissance.SetDateWriten(TdxDbEdit(edDate).Text);
      TFIndividu(fFormIndividu).CoherenceDate.Test;
    end
  else
    if s = 'DEAT' then
      begin
        TFIndividu(fFormIndividu).CoherenceDate.Deces.SetDateWriten(TdxDbEdit(edDate).Text);
        TFIndividu(fFormIndividu).CoherenceDate.Test;
      end
    else
      begin
        TFIndividu(fFormIndividu).CoherenceDate.AddInfoDateWriten(
          TdxDbEdit(edDate).Text,
          s,
          DataSource.DataSet.FieldByName('EV_IND_CLEF').AsInteger,
          DataSource.DataSet.FieldByName('EV_IND_KLE_FICHE').AsInteger,
          TFIndividu(fFormIndividu).CoherenceDate.AutresEventInd,
          DataSource.DataSet.FieldByName('_LONG_EVENT_NAME').AsString
          );

        TFIndividu(fFormIndividu).CoherenceDate.Test;
      end;
end;

procedure TFIndividuEditEventLife.SuperFormHide(Sender: TObject);
begin
  doTestCoherence;

end;

procedure TFIndividuEditEventLife.TreeConjChangeNode(Sender: TObject; OldNode, Node: TdxTreeListNode);
begin
  doRefreshControls;
end;

procedure TFIndividuEditEventLife.dxTreeListColumnTypeUnionCloseUp(
  Sender: TObject; var Value: Variant; var Accept: Boolean);
var
  w: integer;
  UnionType: integer;
  QUpdateTypeUnion: TIBQuery;
  aNode: TNodeIndividu;
begin
  //on regarde si cette valeur est diffrente du type d'union actuel
  if TreeConj.FocusedNode <> nil then
    begin
      if (TreeConj.FocusedNode.strings[dxTreeListColumnTypeUnion.index] <> Value) then
        begin
          if (TreeConj.FocusedNode.Data <> nil) then
            begin
              aNode := TNodeIndividu(TreeConj.FocusedNode.Data);

              w := fLibellesRefTemoins.IndexOf(Value);
              if w <> -1 then UnionType := fCodesRefTemoins[w]
              else UnionType := -1;

              aNode.TypeUnion := UnionType;

              QUpdateTypeUnion := TIBQuery.create(self);
              try
                QUpdateTypeUnion.Database := dm.ibd_BASE;
                QUpdateTypeUnion.SQL.Add('update T_ASSOCIATIONS set ASSOC_TYPE = :ASSOC_TYPE where ASSOC_CLEF=' + inttostr(aNode.UnionClef));
                QUpdateTypeUnion.ParamByName('ASSOC_TYPE').AsInteger := UnionType;
                QUpdateTypeUnion.ExecSQL;
                QUpdateTypeUnion.Close;

                //on indique qu'on a fait une modification
                TFIndividu(fFormindividu).Modified := true;

              finally
                QUpdateTypeUnion.Free;
              end;

              TFIndividu(fFormindividu).DoRefreshControls;
            end;
        end;
    end;
end;

procedure TFIndividuEditEventLife.fbPaysClick(Sender: TObject);
var
  aFPays: TFPays;
begin
  aFPays := TFPays.create(self);
  try
    if aFPays.ShowModal = mrOk then
      begin
        DataSource.DataSet.Edit;
        DataSource.DataSet.FieldByName('EV_IND_PAYS').asString := aFPays.Pays;
      end;
  finally
    aFPays.Free;
  end;
end;

procedure TFIndividuEditEventLife.fbCarteClick(Sender: TObject);
var sPays: string;
begin
  if (DataSource.DataSet.FieldByName('EV_IND_PAYS').asString = 'DEPARTEMENT OUTREMER') or
    (DataSource.DataSet.FieldByName('EV_IND_PAYS').asString = 'TERRITOIRE OUTREMER') then
    sPays := DataSource.DataSet.FieldByName('EV_IND_REGION').asString
  else
    sPays := DataSource.DataSet.FieldByName('EV_IND_PAYS').asString;

  //  showmessage(spays);
  GotoThisURL('http://' + _Context.ChoixCartesInternet + '/pub/agent.dll?qscr=mmfn&plce1=' +
    DataSource.DataSet.FieldByName('EV_IND_VILLE').asString + '%2C' + sPays + '&wpst1=1&rtbl=0&regn1=2&cnty1=4&subm=1&fmap=1&tpid=1&dchg=&zz=992108484196');

end;

procedure TFIndividuEditEventLife.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    //	  VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_HELP_INDI_IDENTITE);
  end;
end;

procedure TFIndividuEditEventLife.SuperFormShow(Sender: TObject);
begin
  btnDetail.Visible := _Context.IsDev;

  edVille.Items.clear;
  edVille.Visible := False;
  dbcbVille.Visible := True;
  doShowGoodTab_CommentSourceEvent;

  doBoutons;

end;

procedure TFIndividuEditEventLife.TreeConjCustomDrawCell(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
  AColumn: TdxTreeListColumn; ASelected, AFocused, ANewItemRow: Boolean;
  var AText: string; var AColor: TColor; AFont: TFont;
  var AAlignment: TAlignment; var ADone: Boolean);
begin
  if AColumn = dxTreeList1Column1 then
    begin
      case TNodeIndividu(aNode.data).Sexe of
        1: aFont.Color := _Context.ColorHomme;
        2: aFont.Color := _Context.ColorFemme;
        else
          aFont.Color := clBlack
      end;
    end;
end;

procedure TFIndividuEditEventLife.fbCalendClick(Sender: TObject);
var
  aFCalendriers: TFCalendriers;
begin

  aFCalendriers := TFCalendriers.create(self);
  try
    aFCalendriers.doInit(DataSource.DataSet.FieldByName('EV_IND_DATE').asString);
    if aFCalendriers.ShowModal = mrOk then
      begin
        if not (DataSource.DataSet.State in [dsEdit, dsInsert]) then
          DataSource.DataSet.Edit;

        DataSource.DataSet.FieldByName('EV_IND_DATE_WRITEN').asString := aFCalendriers.laDate;

      end;
  finally
    aFCalendriers.Free;
  end;
end;

procedure TFIndividuEditEventLife.btnActeClick(Sender: TObject);
var
  aFMultimediEdit: TFBiblio_Multimedia_Edit;

begin
  aFMultimediEdit := TFBiblio_Multimedia_Edit.create(self);
  try
    IBMultimedia.Params[0].AsInteger := dm.NumDossier;
    IBMultimedia.Params[1].AsInteger := DataSource.DataSet.FieldByName('EV_IND_CLEF').AsInteger;
    IBMultimedia.Params[2].AsString := 'I';
    IBMultimedia.Open;

    aFMultimediEdit.doInitialise(IBMultimediaMULTI_CLEF.AsInteger,
      TFIndividu(fFormindividu).aFIndividuIdentite.lTitre.Caption);

    Application.ProcessMessages;
    aFMultimediEdit.ShowModal;
    IBMultimedia.Close;
  finally
    aFMultimediEdit.Free;
  end;
end;

procedure TFIndividuEditEventLife.btnSuivantClick(Sender: TObject);
begin

  DataSource.DataSet.DisableControls;
  DataSource.DataSet.Next;
  doBoutons;
  DataSource.DataSet.EnableControls;
end;

procedure TFIndividuEditEventLife.btnPrecedentClick(Sender: TObject);
begin
  DataSource.DataSet.DisableControls;
  DataSource.DataSet.Prior;
  doBoutons;
  DataSource.DataSet.EnableControls;
end;

procedure TFIndividuEditEventLife.doBoutons;
begin
  FlatTabControl.ActiveTab := 0;

  DataSource.DataSet.DisableControls;
  btnPrecedent.Enabled := datasource.DataSet.RecNo > 1;
  btnSuivant.Enabled := not (datasource.DataSet.RecNo > datasource.DataSet.RecordCount - 1);

  btnActe.Visible := DataSource.DataSet.FieldByName('QUID_IMAGE').AsInteger = 1;

  DataSource.DataSet.EnableControls;
end;

procedure TFIndividuEditEventLife.btnDetailClick(Sender: TObject);
var
  aFBiblio_Sources: TFBiblio_Sources;
begin
  aFBiblio_Sources := TFBiblio_Sources.create(self);
  try

    Application.ProcessMessages;
    aFBiblio_Sources.doOpenQuerys(DataSource.DataSet.FieldByName('EV_IND_CLEF').AsInteger, 'I');
    aFBiblio_Sources.ShowModal;
  finally

    if dm.IBQSources_Record.State in [dsEdit, dsInsert] then
      begin
        DataSource.DataSet.Edit;
        DataSource.DataSet.FieldByName('EV_IND_SOURCE').asString := aFBiblio_Sources.sText;

        FlatTabControl.ActiveTab := 1;
      end;

    aFBiblio_Sources.Free;
  end;

end;

end.

