{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_events;

interface

uses
     Windows, Messages, SysUtils, Forms, CompSuperForm, ImgList, Controls,
     IBCustomDataSet, IBUpdateSQL, Db, IBQuery, Menus, TFlatCheckBoxUnit,
     dxDBGrid, ComCtrls, TFlatButtonUnit, dxDBCtrl, dxTL, dxDBTLCl, dxGrClms,
     dxCntner, TFlatPanelUnit, ExtCtrls, TFlatTabControlUnit, Classes,
     StdCtrls, URLLink, Dialogs, TFlatSpeedButtonUnit,
     u_form_individu_events_details,
     u_form_individu_events_sources,
     u_form_individu_events_notes,
     u_form_individu_events_temoins, dxTLClms, Graphics, TFlatSplitterUnit;
type

     TNodeIndividu = class
     private
          fCleFiche: integer;
          fCaption: string;
     public
          constructor Create;
          property CleFiche: integer read fCleFiche write fCleFiche;
          property Caption: string read fCaption write fCaption;
     end;

     TFIndividuEvents = class(TSuperForm)
          FlatTabControl: TFlatTabControl;
          popupEvents: TPopupMenu;
          popupEvents_New: TMenuItem;
          N1: TMenuItem;
          popupEvents_Delete: TMenuItem;
          IBUEve: TIBUpdateSQL;
          dsEve: TDataSource;
          IBQEve: TIBQuery;
          PanelPrenom: TFlatPanel;
          Panel6: TPanel;
          IBParents: TIBQuery;
          IBParentsCLE_FICHE: TIntegerField;
          IBParentsNOM_PERE: TIBStringField;
          IBParentsPRENOM_PERE: TIBStringField;
          IBParentsPERE_CLE_FICHE: TIntegerField;
          IBParentsNOM_MERE: TIBStringField;
          IBParentsPRENOM_MERE: TIBStringField;
          IBParentsMERE_CLE_FICHE: TIntegerField;
          dsParents: TDataSource;
          IBConjoints: TIBQuery;
          IBConjointsCLE_FICHE: TIntegerField;
          IBConjointsNOM: TIBStringField;
          IBConjointsPRENOM: TIBStringField;
          IBConjointsDATE_NAISSANCE: TIBStringField;
          IBConjointsDATE_DECES: TIBStringField;
          IBConjointsSEXE: TIntegerField;
          IBConjointsTYPE_UNION: TIntegerField;
          IBConjointsUNION_CLEF: TIntegerField;
          IBConjointsKLE_DOSSIER: TIntegerField;
          IBConjointsNOM_PRENOM: TStringField;
          dsConjoits: TDataSource;
          IBQDetailConjoint: TIBQuery;
          IBEnfants: TIBQuery;
          IBEnfantsCLE_FICHE: TIntegerField;
          IBEnfantsNOM: TIBStringField;
          IBEnfantsPRENOM: TIBStringField;
          IBEnfantsSEXE: TSmallintField;
          IBEnfantsDATE_NAISSANCE: TIBStringField;
          IBEnfantsDATE_DECES: TIBStringField;
          IBEnfantsKLE_DOSSIER: TIntegerField;
          IBEnfantsNOM_PRENOM: TStringField;
          dsEnfants: TDataSource;
          IBParentsPERE_NAISSANCE: TIBStringField;
          IBParentsPERE_DECES: TIBStringField;
          IBParentsMERE_NAISSANCE: TIBStringField;
          IBParentsMERE_DECES: TIBStringField;
          sDBEPere: TURLLink;
          sDBEMere: TURLLink;
          IBParentsPERE_SOSA: TFloatField;
          IBParentsMERE_SOSA: TFloatField;
          btnAjoutPere: TFlatSpeedButton;
          btnAjoutMere: TFlatSpeedButton;
          fsbDelPere: TFlatSpeedButton;
          fsbDelMere: TFlatSpeedButton;
          IBUAjoutEnfant: TIBUpdateSQL;
          IBQAjoutEnfant: TIBQuery;
          IBQAjoutEnfantCLE_FICHE: TIntegerField;
          IBQAjoutEnfantCLE_PERE: TIntegerField;
          IBQAjoutEnfantCLE_MERE: TIntegerField;
          btnAddEvent: TFlatButton;
          btnDelEvent: TFlatButton;
          Panel3: TPanel;
          URLLink13: TLabel;
          URLLink14: TLabel;
          gridEvents: TdxDBGrid;
          IBQEveEV_IND_CLEF: TIntegerField;
          IBQEveEV_IND_KLE_FICHE: TIntegerField;
          IBQEveEV_IND_KLE_DOSSIER: TIntegerField;
          IBQEveEV_IND_TYPE: TIBStringField;
          IBQEveEV_IND_DATE_WRITEN: TIBStringField;
          IBQEveEV_IND_DATE_YEAR: TSmallintField;
          IBQEveEV_IND_DATE: TDateField;
          IBQEveEV_IND_ADRESSE: TIBStringField;
          IBQEveEV_IND_CP: TIBStringField;
          IBQEveEV_IND_VILLE: TIBStringField;
          IBQEveEV_IND_DEPT: TIBStringField;
          IBQEveEV_IND_PAYS: TIBStringField;
          IBQEveEV_IND_CAUSE: TIBStringField;
          IBQEveEV_IND_SOURCE: TMemoField;
          IBQEveEV_IND_COMMENT: TMemoField;
          IBQEveEV_IND_TYPEANNEE: TSmallintField;
          IBQEveEV_IND_DESCRIPTION: TIBStringField;
          IBQEveEV_IND_REGION: TIBStringField;
          IBQEveEV_IND_SUBD: TIBStringField;
          IBQEve_LONG_EVENT_NAME: TStringField;
          IBQEve_IMG_EVENT: TIntegerField;
          panDockEvents: TPanel;
          gridEventsEV_IND_DATE_WRITEN: TdxDBGridMaskColumn;
          gridEventsEV_IND_ADRESSE: TdxDBGridMaskColumn;
          gridEventsEV_IND_CP: TdxDBGridMaskColumn;
          gridEventsEV_IND_VILLE: TdxDBGridMaskColumn;
          gridEventsEV_IND_DEPT: TdxDBGridMaskColumn;
          gridEventsEV_IND_PAYS: TdxDBGridMaskColumn;
          gridEventsEV_IND_DESCRIPTION: TdxDBGridMaskColumn;
          gridEventsEV_IND_REGION: TdxDBGridMaskColumn;
          gridEventsEV_IND_SUBD: TdxDBGridMaskColumn;
          gridEvents_LONG_EVENT_NAME: TdxDBGridLookupColumn;
          gridEvents_IMG_EVENT: TdxDBGridImageColumn;
          Panel4: TPanel;
          Panel5: TPanel;
          FlatSplitter1: TFlatSplitter;
          Panel7: TPanel;
          Label3: TLabel;
          Label4: TLabel;
          panConjoints: TFlatPanel;
          Label5: TLabel;
          Label6: TLabel;
          btnAjoutEnfant: TFlatButton;
          btnRetirerEnfant: TFlatButton;
          chbTous: TFlatCheckBox;
          panEnfants: TFlatPanel;
          dxDBGEnfants: TdxDBGrid;
          dxDBGSexe: TdxDBGridImageColumn;
          dxDBGNom: TdxDBGridColumn;
          Label1: TLabel;
          Label2: TLabel;
          tv: TdxTreeList;
          tvColumn1: TdxTreeListColumn;
          pmConjoints: TPopupMenu;
          mOuvrirConjoint: TMenuItem;
          panEvents: TPanel;
          Label7: TLabel;
          Label8: TLabel;
          FlatSpeedButton1: TFlatSpeedButton;
          Label9: TLabel;
          procedure SuperFormCreate(Sender: TObject);
          procedure SuperFormDestroy(Sender: TObject);
          procedure FlatTabControlTabChanged(Sender: TObject);
          procedure dsEveIndStateChange(Sender: TObject);
          procedure SuperFormRefreshControls(Sender: TObject);
          procedure popupEventsPopup(Sender: TObject);
          procedure btnAddEventClick(Sender: TObject);
          procedure btnDelEventClick(Sender: TObject);
          procedure IBConjointsCalcFields(DataSet: TDataSet);
          procedure IBEnfantsCalcFields(DataSet: TDataSet);
          procedure sDBEPereClick(Sender: TObject);
          procedure sDBEMereClick(Sender: TObject);
          procedure dxDBGEnfantsDblClick(Sender: TObject);
          procedure fsbDelPereClick(Sender: TObject);
          procedure fsbDelMereClick(Sender: TObject);
          procedure btnAjoutPereClick(Sender: TObject);
          procedure btnAjoutMereClick(Sender: TObject);
          procedure btnAjoutEnfantClick(Sender: TObject);
          procedure btnRetirerEnfantClick(Sender: TObject);
          procedure chbTousClick(Sender: TObject);
          procedure IBQEveNewRecord(DataSet: TDataSet);
          procedure IBQEveBeforePost(DataSet: TDataSet);
          procedure dsEveStateChange(Sender: TObject);
          procedure IBQEveAfterScroll(DataSet: TDataSet);
          procedure gridEventsGetPreviewText(Sender: TObject; Node: TdxTreeListNode; var Text: string);
          procedure tvDeletion(Sender: TObject; Node: TdxTreeListNode);
          procedure tvChangeNode(Sender: TObject; OldNode, Node: TdxTreeListNode);
          procedure tvDblClick(Sender: TObject);
          procedure mOuvrirConjointClick(Sender: TObject);
          procedure SuperFormResize(Sender: TObject);
          procedure FlatSpeedButton1Click(Sender: TObject);

     private
          aFIndividuEventsDetails: TFIndividuEventsDetails;
          aFIndividuEventsSources: TFIndividuEventsSources;
          aFIndividuEventsNotes: TFIndividuEventsNotes;
          aFIndividuEventsTemoins: TFIndividuEventsTemoins;

          fModuleDocked: integer;
          fFormIndividu: TForm;
          fCanScroll: boolean;
          procedure SetFormIndividu(const Value: TForm);

          procedure doCreateNewEvent;
          procedure doDeleteEvent;
          procedure RempliConjoints;
          procedure RempliEnfants;
          procedure doResizePanEvents;
     public
          property FormIndividu: TForm read fFormIndividu write SetFormIndividu;
          function OpenQuerys: boolean;
          procedure OpenQueryEvents;
          procedure CloseQuerysSaufPrincipal;
          function GetCleEventSelected: integer;
     end;


implementation

uses u_dm, u_form_Main, u_form_individu, u_form_Patronymes, u_form_Prenoms,
     u_form_Evements_Ajout, u_common_var, u_form_individu_par_prenom,
     u_common_func;

{$R *.DFM}

procedure TFIndividuEvents.SuperFormCreate(Sender: TObject);
begin

     aFIndividuEventsDetails := TFIndividuEventsDetails.create(self);
     aFIndividuEventsDetails.FormIndividuIdentite := self;

     aFIndividuEventsSources := TFIndividuEventsSources.create(self);
     aFIndividuEventsSources.FormIndividuIdentite := self;

     aFIndividuEventsNotes := TFIndividuEventsNotes.create(self);
     aFIndividuEventsNotes.FormIndividuIdentite := self;

     aFIndividuEventsTemoins := TFIndividuEventsTemoins.create(self);
     aFIndividuEventsTemoins.FormIndividuIdentite := self;

     aFIndividuEventsDetails.ShowIncrust(panDockEvents);
     fModuleDocked := 0;
end;

procedure TFIndividuEvents.SuperFormDestroy(Sender: TObject);
begin
     aFIndividuEventsDetails.Free;
     aFIndividuEventsSources.Free;
     aFIndividuEventsNotes.Free;
     aFIndividuEventsTemoins.Free;
end;

procedure TFIndividuEvents.FlatTabControlTabChanged(Sender: TObject);
begin
     case fModuleDocked of
          0: aFIndividuEventsDetails.HideIncrust;
          1: aFIndividuEventsNotes.HideIncrust;
          2: aFIndividuEventsSources.HideIncrust;
          3: aFIndividuEventsTemoins.HideIncrust;
     end;

     case FlatTabControl.ActiveTab of
          0: aFIndividuEventsDetails.ShowIncrust(panDockEvents);
          1: aFIndividuEventsNotes.ShowIncrust(panDockEvents);
          2: aFIndividuEventsSources.ShowIncrust(panDockEvents);
          3: aFIndividuEventsTemoins.ShowIncrust(panDockEvents);
     end;

     fModuleDocked := FlatTabControl.ActiveTab;
end;

function TFIndividuEvents.OpenQuerys: boolean;
{
Initialisation de la fiche individu
}
begin
     OpenQueryEvents;

     {*----------------------------------------------------------------------------
     Initialisation de l'objet famille

     tout est accs sur l'individu central, qui a des parents, des conjoints,
     des enfants
     -----------------------------------------------------------------------------*}

     IBConjoints.Close;
     IBEnfants.Close;

     ibConjoints.Params[0].AsInteger := dm.NumDossier;
     ibConjoints.Open;

     // On lui recherche ses parents
     IBParents.DisableControls;
     IBParents.Close;
     IBParents.Params[0].AsInteger := TFIndividu(fFormindividu).CleFiche;
     IBParents.Params[1].AsInteger := dm.NumDossier;
     IBParents.prepare;
     IBParents.Open;

     RempliConjoints;

     chbTous.Enabled := tv.Count > 0;

     RempliEnfants;

     // On fabrique le nom du pere
     if Length(IBParents.FieldByName('NOM_PERE').AsString) > 0 then
          begin
               //SBZapPere.Enabled := True;
               sDBEPere.Caption := AssembleString([IBParents.FieldByName('NOM_PERE').AsString,
                    IBParents.FieldByName('PRENOM_PERE').AsString]);

               if Length(IBParents.FieldByName('PERE_NAISSANCE').AsString) > 0 then
                    sDBEPere.Hint := 'N le : ' + IBParents.FieldByName('PERE_NAISSANCE').AsString;
               if Length(IBParents.FieldByName('PERE_DECES').AsString) > 0 then
                    sDBEPere.Hint := sDBEPere.Hint + #13#10 + 'Dcd le : ' + IBParents.FieldByName('PERE_DECES').AsString;
               if IBParentsPERE_SOSA.AsInteger > 0 then
                    sDBEPere.Hint := sDBEPere.Hint + #13#10 + #13#10 + 'Sosa : ' + IntToStr(IBParentsPERE_SOSA.AsInteger);

               sDBEPere.ShowHint := True;

          end
     else
          sDBEPere.Caption := '';

     // On fabrique le nom de la mere
     if Length(IBParents.FieldByName('NOM_MERE').AsString) > 0 then
          begin
               //SBZapMere.Enabled := True;
               sDBEMere.Caption := AssembleString([IBParents.FieldByName('NOM_MERE').AsString,
                    IBParents.FieldByName('PRENOM_MERE').AsString]);

               if Length(IBParents.FieldByName('MERE_NAISSANCE').AsString) > 0 then
                    sDBEMere.Hint := 'Ne le : ' + IBParents.FieldByName('MERE_NAISSANCE').AsString;
               if Length(IBParents.FieldByName('MERE_DECES').AsString) > 0 then
                    sDBEMere.Hint := sDBEMere.Hint + #13#10 + 'Dcde le : ' + IBParents.FieldByName('MERE_DECES').AsString;
               if IBParentsMERE_SOSA.AsInteger > 0 then
                    sDBEMere.Hint := sDBEMere.Hint + #13#10 + #13#10 + 'Sosa : ' + IntToStr(IBParentsMERE_SOSA.AsInteger);

               sDBEMere.ShowHint := True;
          end
     else
          sDBEMere.Caption := '';

     IBParents.EnableControls;

     fsbDelPere.Enabled := Length(sDBEPere.Caption) > 0;
     fsbDelMere.Enabled := Length(sDBEMere.Caption) > 0;

     result := true;
end;

procedure TFIndividuEvents.SetFormIndividu(const Value: TForm);
begin
     fFormIndividu := Value;
end;

procedure TFIndividuEvents.dsEveIndStateChange(Sender: TObject);
begin
     TFIndividu(FormIndividu).DoRefreshControls; ;
end;

procedure TFIndividuEvents.CloseQuerysSaufPrincipal;

begin

     IBQEve.Close;
     ibConjoints.Close;
     IBQDetailConjoint.Close;
     ibEnfants.Close;
     IBParents.Close;
     aFIndividuEventsTemoins.CloseQuerys;

end;

procedure TFIndividuEvents.doResizePanEvents;
begin
     panEvents.left := 0;
     panEvents.top := 0;
     panEvents.width := width;
end;

procedure TFIndividuEvents.SuperFormRefreshControls(Sender: TObject);
var
     CleEvent: integer;
begin
     CleEvent := GetCleEventSelected;

     panEvents.visible := not ((CleEvent <> -1) and (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false));
     if panEvents.visible then doResizePanEvents;

     btnAddEvent.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
     btnDelEvent.enabled := (CleEvent <> -1) and (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);

     aFIndividuEventsDetails.doRefresh((CleEvent <> -1) and (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false));
     aFIndividuEventsNotes.doRefresh((CleEvent <> -1) and (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false));
     aFIndividuEventsSources.doRefresh((CleEvent <> -1) and (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false));
     aFIndividuEventsTemoins.doRefresh((CleEvent <> -1) and (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false));

     btnAjoutPere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
     fsbDelPere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
          and (IBParents.Active)
          and (IBParentsPERE_CLE_FICHE.IsNull = false)
          and (TFIndividu(fFormindividu).DialogMode = false);

     btnAjoutMere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
     fsbDelMere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
          and (IBParents.Active)
          and (IBParentsMERE_CLE_FICHE.IsNull = false)
          and (TFIndividu(fFormindividu).DialogMode = false);



     tv.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
     dxDBGEnfants.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
     chbTous.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);

     btnAjoutEnfant.Enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (IBEnfants.Active) and (TFIndividu(fFormindividu).DialogMode = false);
     btnRetirerEnfant.Enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (IBEnfants.Active) and (ibEnfants.RecordCount > 0) and (TFIndividu(fFormindividu).DialogMode = false);

     dsEve.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
     dsParents.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
     dsConjoits.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
     dsEnfants.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
end;

function TFIndividuEvents.GetCleEventSelected: integer;
begin
     //on rcupre la clef de de l'evenement slectionn
     result := -1;
     try
          if IBQEve.Active then
               if IBQEve.IsEmpty = false then result := IBQEve.FieldByName('EV_IND_CLEF').AsInteger;
     except
     end;
end;

procedure TFIndividuEvents.popupEventsPopup(Sender: TObject);
var
     CleEvent: integer;
begin
     CleEvent := GetCleEventSelected;
     popupEvents_New.enabled := (TFIndividu(fFormindividu).CleFiche <> -1);
     popupEvents_Delete.enabled := (CleEvent <> -1) and (TFIndividu(fFormindividu).CleFiche <> -1);
end;

procedure TFIndividuEvents.btnAddEventClick(Sender: TObject);
begin
     doCreateNewEvent;
end;

procedure TFIndividuEvents.doCreateNewEvent;
var
     aFEvenement_Ajout: TFEvenement_Ajout;
begin
     aFEvenement_Ajout := TFEvenement_Ajout.create(self);
     try
          aFEvenement_Ajout.up_Init(TFIndividu(fFormindividu).CleFiche, 'I');
          if aFEvenement_Ajout.ShowModal = mrOk then
               begin
                    ibqEve.Append;
                    ibqEveEV_IND_TYPE.AsString := aFEvenement_Ajout.Ref_Eve_Lib_Court;
                    if aFIndividuEventsDetails.edDate.CanFocus then
                         aFIndividuEventsDetails.edDate.SetFocus;

                    TFIndividu(fFormindividu).Modified := true;
                    TFIndividu(FormIndividu).DoRefreshControls;
               end;
     finally
          aFEvenement_Ajout.Free;
     end;
end;

procedure TFIndividuEvents.btnDelEventClick(Sender: TObject);
begin
     doDeleteEvent;
end;

procedure TFIndividuEvents.doDeleteEvent;
begin
     ibqEve.Delete;
     OpenQueryEvents;
     TFIndividu(fFormindividu).Modified := true;
     TFIndividu(FormIndividu).DoRefreshControls;
end;

procedure TFIndividuEvents.OpenQueryEvents;
begin
     fCanScroll := false;
     IBQEve.DisableControls;
     IBQEve.Close;
     IBQEve.ParamByName('CLEFICHE').AsInteger := TFIndividu(fFormindividu).CleFiche;
     IBQEve.ParamByName('CLEDOSSIER').AsInteger := dm.NumDossier;
     IBQEve.Open;
     IBQEve.EnableControls;
     fCanScroll := true;

     IBQEveAfterScroll(IBQEve);
end;

procedure TFIndividuEvents.RempliConjoints;
var
     n: integer;
     //SubItem: TTreeNode;
     s: string;
     //aNodeIndi: TNodeIndividu;

     NodeConj, Node: TdxTreeListNode;
     NodeIndi: TNodeIndividu;
begin
     ibConjoints.DisableControls;
     try
          ibConjoints.Close;
          ibConjoints.Params[0].AsInteger := dm.NumDossier;
          ibConjoints.Params[1].AsInteger := TFIndividu(fFormindividu).CleFiche;
          ibConjoints.Open;
          ibConjoints.last;
          ibConjoints.first;

          tv.BeginUpdate;
          try
               tv.ClearNodes;

               for n := 1 to ibConjoints.RecordCount do
                    begin
                         s := AssembleString([ibConjoints.FieldByName('NOM').AsString, ibConjoints.FieldByName('PRENOM').AsString]);
                         if ibConjoints.FieldByName('DATE_NAISSANCE').AsString <> '' then
                              s := s + ' ( + ' + ibConjoints.FieldByName('DATE_NAISSANCE').AsString + ')';

                         if ibConjoints.FieldByName('DATE_DECES').AsString <> '' then
                              s := s + ' - ( * ' + ibConjoints.FieldByName('DATE_DECES').AsString + ')';

                         NodeIndi := TNodeIndividu.create;
                         NodeIndi.CleFiche := ibConjoints.FieldByName('CLE_FICHE').AsInteger;
                         NodeIndi.Caption := AssembleString([ibConjoints.FieldByName('NOM').AsString, ibConjoints.FieldByName('PRENOM').AsString]);

                         NodeConj := tv.Add;
                         NodeConj.Values[0] := s;
                         NodeConj.Data := NodeIndi;
                         case IBConjointsSEXE.AsInteger of
                              1: NodeConj.ImageIndex := 1;
                              2: NodeConj.ImageIndex := 0;
                         else
                              NodeConj.ImageIndex := 2;
                         end;
                         NodeConj.SelectedIndex := NodeConj.ImageIndex;



                         IBQDetailConjoint.DisableControls;
                         IBQDetailConjoint.close;
                         IBQDetailConjoint.open;

                         if IBQDetailConjoint.FieldByName('NOM_PERE').AsString <> '' then
                              begin
                                   s := AssembleString([IBQDetailConjoint.FieldByName('NOM_PERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_PERE').AsString]);
                                   if IBQDetailConjoint.FieldByName('PERE_DATE_NAISSANCE').AsString <> '' then
                                        s := s + ' n le ' + IBQDetailConjoint.FieldByName('PERE_DATE_NAISSANCE').AsString;

                                   NodeIndi := TNodeIndividu.create;
                                   NodeIndi.CleFiche := IBQDetailConjoint.FieldByName('PERE_CLE_FICHE').AsInteger;
                                   NodeIndi.Caption := AssembleString([IBQDetailConjoint.FieldByName('NOM_PERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_PERE').AsString]);

                                   Node := NodeConj.AddChild;
                                   Node.Values[0] := 'son pre : ' + s;
                                   Node.Data := NodeIndi;
                                   Node.ImageIndex := 1;
                                   Node.SelectedIndex := 1;

                              end;

                         if IBQDetailConjoint.FieldByName('NOM_MERE').AsString <> '' then
                              begin
                                   s := AssembleString([IBQDetailConjoint.FieldByName('NOM_MERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_MERE').AsString]);
                                   if IBQDetailConjoint.FieldByName('MERE_DATE_NAISSANCE').AsString <> '' then
                                        s := s + ' ne le ' + IBQDetailConjoint.FieldByName('MERE_DATE_NAISSANCE').AsString;

                                   NodeIndi := TNodeIndividu.create;
                                   NodeIndi.CleFiche := IBQDetailConjoint.FieldByName('MERE_CLE_FICHE').AsInteger;
                                   NodeIndi.Caption := AssembleString([IBQDetailConjoint.FieldByName('NOM_MERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_MERE').AsString]);

                                   Node := NodeConj.AddChild;
                                   Node.Values[0] := 'sa mre : ' + s;
                                   Node.Data := NodeIndi;

                                   Node.ImageIndex := 0;
                                   Node.SelectedIndex := 0;
                              end;

                         ibConjoints.next;
                         IBQDetailConjoint.EnableControls;
                    end;

               {
               if tvConj.items.count > 0 then
                    tvConj.Selected := tvConj.Items[0]
               else
                    chbTous.Checked := True;
                    }

          finally
               tv.EndUpdate;
          end;

     finally
          ibConjoints.EnableControls;
     end;
end;

procedure TFIndividuEvents.IBConjointsCalcFields(DataSet: TDataSet);
begin
     IBConjointsKLE_DOSSIER.AsInteger := dm.NumDossier;

     // On fabrique le nom des conjoints
     IBConjointsNOM_PRENOM.asString := AssembleString([IBConjointsNOM.AsString,
          IBConjointsPRENOM.asString]);
end;

procedure TFIndividuEvents.RempliEnfants;
var
     i_Conjoint: integer;
begin
     // Pour chaque conjoints, on recherche les enfants
     IBEnfants.DisableControls;
     IBEnfants.Close;
     i_Conjoint := 0;

     { ---------------------------------------------------------------------
       Le passage des paramatres est invers en fonction du sexe de
       l'individu central.
       Les parametres de la procedure sont
       1 - Le code du pere
       2 - Le code de la mere
       3 - Le code du dossier courant
      --------------------------------------------------------------------}

     if chbTous.Checked then
          i_conjoint := 0
     else
          if tv.FocusedNode <> nil then
               begin
                    if tv.FocusedNode.level = 0 then i_Conjoint := TNodeIndividu(tv.FocusedNode.Data).CleFiche
                    else if tv.FocusedNode.level = 1 then
                         begin
                              i_Conjoint := TNodeIndividu(tv.FocusedNode.Parent).CleFiche
                         end;
               end
          else
               i_conjoint := 0;

     //soit c'est un homme
     if TFIndividu(fFormindividu).IBIndDetailSEXE.AsInteger = 1 then
          // if TFIndividu(fFormindividu).aFIndividuIdentite.DBRSexe.ItemIndex = 0 then
          begin
               IBEnfants.Params[0].AsInteger := IBParents.FieldByName('CLE_FICHE').AsInteger;
               IBEnfants.Params[1].AsInteger := i_Conjoint;
          end
     else
          begin
               IBEnfants.Params[0].AsInteger := i_Conjoint;
               IBEnfants.Params[1].AsInteger := IBParents.FieldByName('CLE_FICHE').AsInteger;
          end;

     IBEnfants.Params[2].AsInteger := dm.NumDossier;
     IBEnfants.Open;

     dxDBGEnfants.ShowHint := dxDBGEnfants.Count > 0;

     IBEnfants.EnableControls;

end;

procedure TFIndividuEvents.IBEnfantsCalcFields(DataSet: TDataSet);
begin

     // On fabrique le nom des enfants
     IBEnfantsNOM_PRENOM.asString := AssembleString([IBEnfantsNOM.AsString,
          IBEnfantsPRENOM.asString]);

end;

procedure TFIndividuEvents.sDBEPereClick(Sender: TObject);
begin
     TFIndividu(fFormindividu).doOpenFiche(IBParentsPERE_CLE_FICHE.AsInteger);
end;

procedure TFIndividuEvents.sDBEMereClick(Sender: TObject);
begin
     TFIndividu(fFormindividu).doOpenFiche(IBParentsMERE_CLE_FICHE.AsInteger);
end;

procedure TFIndividuEvents.dxDBGEnfantsDblClick(Sender: TObject);
begin
     TFIndividu(fFormindividu).doOpenFiche(IBEnfantsCLE_FICHE.AsInteger);
end;

{ TNodeIndividu }

constructor TNodeIndividu.Create;
begin
     fCleFiche := -1;
     fCaption := '';
end;

procedure TFIndividuEvents.fsbDelPereClick(Sender: TObject);
begin
     TFIndividu(fFormindividu).DSIndDetail.Edit;
     TFIndividu(fFormindividu).IBIndDetailCLE_PERE.AsInteger := 0;
     sDBEPere.Caption := '';
     sDBEPere.Hint := '';
     sDBEPere.ShowHint := False;
     fsbDelPere.Enabled := False;
end;

procedure TFIndividuEvents.fsbDelMereClick(Sender: TObject);
begin
     TFIndividu(fFormindividu).DSIndDetail.Edit;
     TFIndividu(fFormindividu).IBIndDetailCLE_MERE.AsInteger := 0;
     sDBEMere.Caption := '';
     sDBEMere.Hint := '';
     sDBEMere.ShowHint := False;
     fsbDelMere.Enabled := False;
end;

procedure TFIndividuEvents.btnAjoutPereClick(Sender: TObject);
var
     aFIndividuPrenom: TFIndividuPrenom;
     aLettre: string;
begin
     //Cration de la boite de recherche d'un individu par le prnom
     aFIndividuPrenom := TFIndividuPrenom.create(self);

     try
          aFIndividuPrenom.Position := poMainFormCenter;

          aLettre := Copy(TFIndividu(fFormindividu).IBIndDetailNOM.AsString, 1, 1);
          aFIndividuPrenom.up_InitIndividuPrenom(aLettre, '',1, 2);

          if aFIndividuPrenom.ShowModal = mrOk then
               if aFIndividuPrenom.SexeIndividuSelected = 2 then
                    ShowMessage('Le pre d''un individu ne peut pas tre une femme....')
               else
                    if aFIndividuPrenom.ClefIndividuSelected = TFIndividu(fFormindividu).Clefiche then
                         ShowMessage('L''individu ne peux pas tre  la fois, lui mme et son pre')
                    else
                         begin
                              TFIndividu(fFormindividu).DSIndDetail.Edit;
                              TFIndividu(fFormindividu).IBIndDetailCLE_PERE.AsInteger := aFIndividuPrenom.ClefIndividuSelected;
                              sDBEPere.Caption := aFIndividuPrenom.NomPrenomIndividuSelected;
                              fsbDelPere.Enabled := True;
                         end;

     finally
          aFIndividuPrenom.Free;
     end;
end;

procedure TFIndividuEvents.btnAjoutMereClick(Sender: TObject);
var
     aFIndividuPrenom: TFIndividuPrenom;
begin
     //Cration de la boite de recherche d'un individu par le prnom
     aFIndividuPrenom := TFIndividuPrenom.create(self);

     try
          aFIndividuPrenom.Position := poMainFormCenter;

          aFIndividuPrenom.up_InitIndividuPrenom('A','', 0, 2);

          if aFIndividuPrenom.ShowModal = mrOk then
               if aFIndividuPrenom.SexeIndividuSelected = 1 then
                    ShowMessage('La mre d''un individu ne peut pas tre un homme....')
               else
                    if aFIndividuPrenom.ClefIndividuSelected = TFIndividu(fFormindividu).Clefiche then
                         ShowMessage('L''individu ne peux pas tre  la fois, lui mme et sa mre')
                    else
                         begin
                              TFIndividu(fFormindividu).DSIndDetail.Edit;
                              TFIndividu(fFormindividu).IBIndDetailCLE_MERE.AsInteger := aFIndividuPrenom.ClefIndividuSelected;
                              sDBEMere.Caption := aFIndividuPrenom.NomPrenomIndividuSelected;
                              fsbDelMere.Enabled := True;
                         end;

     finally
          aFIndividuPrenom.Free;
     end;
end;

procedure TFIndividuEvents.btnAjoutEnfantClick(Sender: TObject);
var
     aFIndividuPrenom: TFIndividuPrenom;
     i_Node: Integer;
begin
     i_Node := 0;
     if tv.FocusedNode <> nil then
          begin
               if tv.FocusedNode.level = 0 then i_Node := TNodeIndividu(tv.FocusedNode).CleFiche
               else if tv.FocusedNode.level = 1 then
                    begin
                         i_Node := TNodeIndividu(tv.FocusedNode.Parent).CleFiche;
                    end;
          end;


     //Cration de la boite de recherche d'un individu par le prnom
     aFIndividuPrenom := TFIndividuPrenom.create(self);

     try
          aFIndividuPrenom.Position := poMainFormCenter;

          aFIndividuPrenom.up_InitIndividuPrenom('A','', 0, 2);

          if aFIndividuPrenom.ShowModal = mrOk then

               if aFIndividuPrenom.ClefIndividuSelected = TFIndividu(fFormindividu).Clefiche then
                    ShowMessage('L''individu ne peux pas tre  la fois, lui mme et son enfant')
               else
                    begin
                         IBQAjoutEnfant.Close;
                         IBQAjoutEnfant.Params[0].AsInteger := aFIndividuPrenom.ClefIndividuSelected;
                         IBQAjoutEnfant.Open;
                         IBQAjoutEnfant.Edit;

                         if TFIndividu(fFormindividu).IBIndDetailSEXE.AsInteger = 1 then
                              begin
                                   IBQAjoutEnfantCLE_PERE.AsInteger := TFIndividu(fFormindividu).CleFiche;
                                   IBQAjoutEnfantCLE_MERE.AsInteger := i_Node;
                              end
                         else
                              if TFIndividu(fFormindividu).IBIndDetailSEXE.AsInteger = 2 then
                                   begin
                                        IBQAjoutEnfantCLE_PERE.AsInteger := i_Node;
                                        IBQAjoutEnfantCLE_MERE.AsInteger := TFIndividu(fFormindividu).CleFiche;
                                   end
                              else
                                   begin
                                        IBQAjoutEnfantCLE_PERE.Clear;
                                        IBQAjoutEnfantCLE_MERE.Clear
                                   end;


                         IBQAjoutEnfant.Post;
                         IBQAjoutEnfant.Close;

                         TFIndividu(fFormindividu).Modified := True;
                         TFIndividu(fFormindividu).DoRefreshControls;

                         RempliEnfants;
                    end;

     finally
          aFIndividuPrenom.Free;
     end;

     DoRefreshControls;
end;

procedure TFIndividuEvents.btnRetirerEnfantClick(Sender: TObject);
begin
     if MessageDlg('Confirmez-vous la supression de cet enfant ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
          begin
               try
                    {
                              IBDeleteEnfant.Close;
                              IBDeleteEnfant.ParamByName('CLE_FICHE').AsInteger := IBEnfants.FieldByName('CLE_FICHE').AsInteger;
                              IBDeleteEnfant.ExecSQL;
                              IBDeleteEnfant.Close;
                     }

                    IBQAjoutEnfant.Close;
                    IBQAjoutEnfant.Params[0].AsInteger := IBEnfants.FieldByName('CLE_FICHE').AsInteger;
                    IBQAjoutEnfant.Open;
                    IBQAjoutEnfant.Edit;

                    IBQAjoutEnfantCLE_PERE.AsInteger := 0;
                    IBQAjoutEnfantCLE_MERE.AsInteger := 0;

                    IBQAjoutEnfant.Post;
                    TFIndividu(fFormindividu).Modified := True;
                    TFIndividu(fFormindividu).DoRefreshControls;
               except
               end;

               RempliEnfants;
               //  RempliConjoints;
          end;

     doRefreshControls;
end;

procedure TFIndividuEvents.chbTousClick(Sender: TObject);
begin
     RempliEnfants;
     doRefreshControls;
end;

procedure TFIndividuEvents.IBQEveNewRecord(DataSet: TDataSet);
begin
     ibqEveEV_IND_CLEF.AsInteger := dm.uf_GetClefUnique('EVENEMENTS_IND');
     ibqEveEV_IND_KLE_FICHE.AsInteger := TFIndividu(fFormindividu).CleFiche;
     ibqEveEV_IND_KLE_DOSSIER.AsInteger := dm.NumDossier;
end;

procedure TFIndividuEvents.IBQEveBeforePost(DataSet: TDataSet);
begin
     //on prpare les champs d'accueil de la date
     DataSet.FieldByName('EV_IND_DATE_YEAR').Clear;
     DataSet.FieldByName('EV_IND_DATE').Clear;

     if _GDate.DecodeHumanDate(DataSet.FieldByName('EV_IND_DATE_WRITEN').AsString) then
          begin
               //l'anne
               if (_GDate.KnowYear) then DataSet.FieldByName('EV_IND_DATE_YEAR').AsInteger := _GDate.GDate.Year1;

               //la date entire
               if _GDate.KnowDate then DataSet.FieldByName('EV_IND_DATE').AsDateTime := _GDate.GDate.DateTime1;
          end;
end;

procedure TFIndividuEvents.dsEveStateChange(Sender: TObject);
begin
     TFIndividu(fFormindividu).DoRefreshControls;
end;

procedure TFIndividuEvents.IBQEveAfterScroll(DataSet: TDataSet);
var
     CleEvent: integer;
     s_Chaine: string;
begin
     if fCanScroll then
          begin
               CleEvent := GetCleEventSelected;

               if CleEvent <> -1 then
                    begin
                         aFIndividuEventsTemoins.OpenQuerys;

                         if IBQEveEV_IND_TYPE.AsString = 'BIRT' then
                              if TFIndividu(fFormindividu).IBIndDetailSEXE.AsInteger = 1 then
                                   s_Chaine := 'N le : '
                              else
                                   s_Chaine := 'Ne le : ';

                         s_Chaine := s_Chaine + IBQEveEV_IND_DATE_WRITEN.AsString;
                         if Length(IBQEveEV_IND_VILLE.AsString) > 0 then
                              s_Chaine := s_Chaine + '  ' + IBQEveEV_IND_VILLE.AsString;
                         if Length(IBQEveEV_IND_CP.AsString) > 0 then
                              s_Chaine := s_Chaine + ' - ' + IBQEveEV_IND_CP.AsString;

                         {
                    if length(s_Chaine) > 0 then
                        aFIndividuEventsDetails.lTitre.Caption := s_Chaine
                    else
                         aFIndividuEventsDetails.lTitre.Caption := 'Pas de date...';
                          }

                    end;
          end;
end;

procedure TFIndividuEvents.gridEventsGetPreviewText(Sender: TObject;
     Node: TdxTreeListNode; var Text: string);
var
     s, s2, s3: string;
const
     _space = '               ';
begin
     //Text := Node.Values[dxDBGrid2EV_IND_DESCRIPTION.Index] + #10;
     s := '';

     //date
     s2 := trim(Node.Values[gridEventsEV_IND_DATE_WRITEN.Index]);
     if s2 <> '' then s := _space + s2;

     //Ville (CP)
     s2 := trim(Node.Values[gridEventsEV_IND_VILLE.Index]);
     if s2 <> '' then
          begin
               s3 := trim(Node.Values[gridEventsEV_IND_CP.Index]);
               if s3 <> '' then s2 := s2 + '  (' + s3 + ')';
               s2 := _space + s2;
          end;

     if s2 <> '' then s := s + #10 + s2;

     //     if s='' then s:=#10;


     Text := s;

     {
         gridEventsEV_IND_DATE_WRITEN: TdxDBGridMaskColumn;
         gridEventsEV_IND_ADRESSE: TdxDBGridMaskColumn;
         gridEventsEV_IND_CP: TdxDBGridMaskColumn;
         gridEventsEV_IND_VILLE: TdxDBGridMaskColumn;
         gridEventsEV_IND_DEPT: TdxDBGridMaskColumn;
         gridEventsEV_IND_PAYS: TdxDBGridMaskColumn;
         gridEventsEV_IND_DESCRIPTION: TdxDBGridMaskColumn;
         gridEventsEV_IND_REGION: TdxDBGridMaskColumn;
         gridEventsEV_IND_SUBD: TdxDBGridMaskColumn;
         gridEvents_LONG_EVENT_NAME: TdxDBGridLookupColumn;
         gridEvents_IMG_EVENT: TdxDBGridImageColumn;
         }
end;

procedure TFIndividuEvents.tvDeletion(Sender: TObject;
     Node: TdxTreeListNode);
begin
     if Node.data <> nil then
          begin
               TNodeIndividu(Node.data).free;
               Node.data := nil;
          end;
end;

procedure TFIndividuEvents.tvChangeNode(Sender: TObject; OldNode,
     Node: TdxTreeListNode);
var
     s_Hint: string;
     //_Node: Integer;
    // NodeIndi: TNodeIndividu;
begin
     if Node.Data <> nil then
          begin
               //NodeIndi := TNodeIndividu(Node.data);
               //i_Node := NodeIndi.CleFiche;

               s_Hint := '';

               if Length(Node.Strings[0]) > 0 then
                    s_Hint := AssembleString([TFIndividu(fFormindividu).IBIndDetailNOM.AsString, TFIndividu(fFormindividu).IBIndDetailPRENOM.AsString]) +
                    ' et  ' + Node.Strings[0];
               btnAjoutEnfant.Hint := 'Ajouter un enfant  ' + s_Hint;

               RempliEnfants;

               btnRetirerEnfant.Enabled := Node.Level = 0;
               btnRetirerEnfant.Enabled := (IBEnfants.RecordCount > 0) and (Node.Level = 0);

               doRefreshControls;
          end;
end;

procedure TFIndividuEvents.tvDblClick(Sender: TObject);
var aNodeIndividu: TNodeIndividu;
     aNode: TdxTreeListNode;
begin
     if Tv.FocusedNode <> nil then
          begin
               aNode := Tv.FocusedNode;
               if (aNode.Data <> nil) and (aNode.Level >= 0) then
                    begin
                         //on rcupre l'objet de stockage de l'individu
                         aNodeIndividu := TNodeIndividu(aNode.Data);

                         TFIndividu(fFormindividu).doOpenFiche(aNodeIndividu.CleFiche);
                    end;
          end;
end;


procedure TFIndividuEvents.mOuvrirConjointClick(Sender: TObject);
begin
     { TODO : Rebrancher Fiche Individu }
end;
{
var
     aFIndividu: TFIndividu;
     aNodeIndividu: TNodeIndividu;
     aNode: TdxTreeListNode;
begin
     if Tv.FocusedNode <> nil then
          begin
               aNode := Tv.FocusedNode;
               if (aNode.Data <> nil) and (aNode.Level >= 0) then
                    begin
                         //on rcupre l'objet de stockage de l'individu
                         aNodeIndividu := TNodeIndividu(aNode.Data);

                         aFIndividu := TFIndividu.create(self);
                         try
                              aFIndividu.doOpenFiche(aNodeIndividu.CleFiche);
                              aFIndividu.Show;
                         except
                              try
                                   aFIndividu.Close;
                              except
                              end;
                         end;
                    end;
          end;
end;
 }

procedure TFIndividuEvents.SuperFormResize(Sender: TObject);
begin
     if panEvents.visible then doResizePanEvents;
end;

procedure TFIndividuEvents.FlatSpeedButton1Click(Sender: TObject);
begin
     doCreateNewEvent;
end;

end.
