{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_events_details;

interface

uses
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     CompSuperForm, StdCtrls, Buttons,
     u_comp_TBlueFlatSpeedButton, Db, IBCustomDataSet, IBQuery,
     IBUpdateSQL, IBStoredProc, dxCntner, dxEditor, dxEdLib, dxDBELib,
     dxExEdtr, TFlatButtonUnit, TFlatSpeedButtonUnit, URLLink, ExtCtrls;

type
     TFIndividuEventsDetails = class(TSuperForm)
          Label7: TLabel;
          Label8: TLabel;
          Label9: TLabel;
          Label10: TLabel;
          fbPays: TFlatSpeedButton;
          fbInfosDate: TFlatSpeedButton;
          fbInfosVilles: TFlatSpeedButton;
          btnSearchVille: TFlatSpeedButton;
          Label2: TLabel;
          Label3: TLabel;
          Label4: TLabel;
          edDate: TdxDBEdit;
          edDept: TdxDBEdit;
          edCP: TdxDBEdit;
          edLieu: TdxDBEdit;
          edVille: TdxDBPickEdit;
          edPays: TdxDBEdit;
          edRegion: TdxDBEdit;
          edSubdi: TdxDBEdit;
          Label1: TLabel;
          edDesc: TdxDBEdit;
          procedure btnSearchVilleClick(Sender: TObject);
          procedure SuperFormCreate(Sender: TObject);
          procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
          procedure edDateChange(Sender: TObject);
          procedure fbInfosVillesClick(Sender: TObject);
          procedure edVilleChange(Sender: TObject);
          procedure edCPChange(Sender: TObject);
          procedure fbInfosDateClick(Sender: TObject);
     private
          l_Dept, l_Pays, l_Villes, l_Region: TStringList;
          fFormIndividuIdentite: TForm;
          procedure SetFormIndividuIdentite(const Value: TForm);
     public
          property FormIndividuIdentite: TForm read fFormIndividuIdentite write SetFormIndividuIdentite;
          procedure DoRefresh(Mode: boolean);
     end;

implementation

uses
     u_form_individu_events,
     u_form_individu,
     u_dm, u_common_var, u_form_list_villes, u_form_Aide_Date;

{$R *.DFM}

{ TFIndividuIdentiteEventsDetails }


procedure TFIndividuEventsDetails.SuperFormCreate(Sender: TObject);
begin
     l_Dept := TStringList.Create;
     l_Pays := TStringList.Create;
     l_Villes := TStringList.Create;
     l_Region := TStringList.Create;
end;

procedure TFIndividuEventsDetails.SuperFormClose(Sender: TObject;
     var Action: TCloseAction);
begin
     l_Dept.Free;
     l_Pays.Free;
     l_Villes.Free;
end;

procedure TFIndividuEventsDetails.DoRefresh(Mode: boolean);
begin
     {
          edDate.enabled := Mode;
          edCP.enabled := Mode;
          edVille.enabled := Mode;
          edDept.enabled := Mode;
          edPays.enabled := Mode;
          edDesc.enabled := Mode;
          edSubdi.enabled := Mode;
          edRegion.enabled := Mode;
          edLieu.enabled := Mode;
          edPays.enabled := Mode;
          }
     Label7.enabled := Mode;
     Label8.enabled := Mode;
     Label9.enabled := Mode;
     Label10.enabled := Mode;
     Label1.enabled := Mode;
     Label3.enabled := Mode;
     Label4.enabled := Mode;
     Label10.enabled := Mode;
     Label2.enabled := Mode;
     Label3.enabled := Mode;
     Label4.enabled := Mode;

     fbInfosDate.enabled := Mode;
     fbInfosVilles.enabled := Mode;
     fbPays.enabled := Mode;
     btnSearchVille.enabled := Mode;
end;

procedure TFIndividuEventsDetails.SetFormIndividuIdentite(const Value: TForm);
var
     PtrForm: TFIndividuEvents;
begin
     fFormIndividuIdentite := Value;

     if Value <> nil then PtrForm := TFIndividuEvents(Value) else PtrForm := nil;

     edDate.DataSource := PtrForm.dsEve;
     edCP.DataSource := PtrForm.dsEve;
     edVille.DataSource := PtrForm.dsEve;
     edDept.DataSource := PtrForm.dsEve;
     edPays.DataSource := PtrForm.dsEve;
     edDesc.DataSource := PtrForm.dsEve;
     edPays.DataSource := PtrForm.dsEve;
     edLieu.DataSource := PtrForm.dsEve;
     edSubdi.DataSource := PtrForm.dsEve;

end;

procedure TFIndividuEventsDetails.btnSearchVilleClick(
     Sender: TObject);
var aProc: TIBQuery;
begin
     aProc := TIBQuery.create(self);

     try
          aProc.Database := dm.ibd_BASE;

          aProc.SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_CP(:I_CODE)');
          //aProc.Params[0].AsString := TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_CP.asString;
          aProc.Params[0].AsString := edCP.Text;
          aProc.Open;

          edVille.Items.Clear;
          l_Dept.Clear;
          l_Pays.Clear;
          l_Villes.Clear;
          l_Region.Clear;

          while not aProc.eof do
               begin
                    edVille.Items.Add(aProc.FieldByName('VILLE').AsString);

                    l_Villes.Add(AnsiUpperCase(aProc.FieldByName('VILLE').AsString));
                    l_Dept.Add(aProc.FieldByName('DEPARTEMENT').AsString);
                    l_Pays.Add(aProc.FieldByName('PAYS').AsString);
                    l_Region.Add(aProc.FieldByName('REGION').AsString);

                    aProc.next;
               end;

          if l_Villes.Count > 0 then
               begin
                    if (not (TFIndividuEvents(fFormIndividuIdentite).dsEve.State in [dsEdit, dsInsert]))
                         then TFIndividuEvents(fFormIndividuIdentite).IBQEve.Edit;

                    TFIndividuEvents(fFormIndividuIdentite).IBQEveEV_IND_VILLE.AsString := l_Villes[0];
                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_DEPT.asString := l_Dept[0];
                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_PAYS.asString := l_Pays[0];
                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_REGION.asString := l_Region[0];
               end;

          if edVille.Items.Count > 1 then
               begin
                    edVille.DroppedDown := True;
               end;

     finally
          aProc.Free;
     end;
end;

procedure TFIndividuEventsDetails.edDateChange(Sender: TObject);
begin
     if _GDate.DecodeHumanDate(TdxDbEdit(edDate).Text)
          then edDate.Font.color := clWindowText
     else edDate.Font.color := clRed;
end;

procedure TFIndividuEventsDetails.fbInfosVillesClick(Sender: TObject);
var
     aFListVilles: TFListVilles;
begin
     aFListVilles := TFListVilles.create(self);
     try

          if aFListVilles.ShowModal = mrOk then
               begin
                    if not (TFIndividuEvents(fFormIndividuIdentite).dsEve.State in [dsEdit, dsInsert]) then
                         TFIndividuEvents(fFormIndividuIdentite).ibqEve.Edit;

                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_CP.asString := aFListVilles.Code;
                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_VILLE.asString := aFListVilles.Ville;
                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_PAYS.asString := aFListVilles.Pays;
                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_DEPT.asString := aFListVilles.Dept;
                    TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_REGION.asString := aFListVilles.Region;
               end;
     finally
          aFListVilles.Free;
     end;
end;

procedure TFIndividuEventsDetails.edVilleChange(Sender: TObject);
var
     k: integer;
begin
     //on recherche la ville dans la liste
     k := l_Villes.IndexOf(AnsiUpperCase(TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_VILLE.AsString));
     if k <> -1 then
          begin
               TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_DEPT.asString := l_Dept[k];
               TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_PAYS.asString := l_Pays[k];
               TFIndividuEvents(fFormIndividuIdentite).ibqEveEV_IND_REGION.asString := l_Region[k];
          end;

end;

procedure TFIndividuEventsDetails.edCPChange(Sender: TObject);
begin
     edVille.items.Clear;
     l_Dept.Clear;
     l_Pays.Clear;
     l_Villes.Clear;
     l_Region.Clear;
     edDept.Text := '';
     edVille.Text := '';
     edPays.Text := '';
     edRegion.Text := '';
end;

procedure TFIndividuEventsDetails.fbInfosDateClick(Sender: TObject);
var
     aFAideDate: TFAideDate;
begin
     //Cration de la boite de recherche d'un individu par le prnom
     aFAideDate := TFAideDate.create(self);
     try
          aFAideDate.ShowModal;
     finally
          aFAideDate.Free;
     end;
end;

end.
