{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_events_temoins;

interface

uses
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     CompSuperForm, StdCtrls, dxTLClms, dxTL, dxCntner,
     u_comp_TBlueFlatSpeedButton, Db, IBCustomDataSet, IBQuery,
     IBUpdateSQL, ExtCtrls, TFlatPanelUnit, TFlatButtonUnit, URLLink,
     u_objet_TIntegerList;

type
     TNodeIndividu = class
     private
          fSexe: integer;
          fCleFiche: integer;
          fCaption: string;
          fTypeUnion: integer;
          fUnionClef: integer;
     public
          constructor Create;
          property Caption: string read fCaption write fCaption;
          property CleFiche: integer read fCleFiche write fCleFiche;
          property Sexe: integer read fSexe write fSexe;
          property TypeUnion: integer read fTypeUnion write fTypeUnion;
          property UnionClef: integer read fUnionClef write fUnionClef;
     end;

     TFIndividuEventsTemoins = class(TSuperForm)
          IBTemoins: TIBQuery;
          IBQDetailTemoins: TIBQuery;
          DSTemoins: TDataSource;
          DSUnion: TDataSource;
          IBUAssocies: TIBUpdateSQL;
          IBQAssocies: TIBQuery;
          IBTemoinsCLE_FICHE: TIntegerField;
          IBTemoinsNOM: TIBStringField;
          IBTemoinsPRENOM: TIBStringField;
          IBTemoinsDATE_NAISSANCE: TIBStringField;
          IBTemoinsDATE_DECES: TIBStringField;
          IBTemoinsSEXE: TIntegerField;
          IBTemoinsASSOC_TYPE: TIntegerField;
          IBTemoinsASSOC_CLEF: TIntegerField;
          IBTemoinsKLE_DOSSIER: TIntegerField;
          IBQAssociesASSOC_CLEF: TIntegerField;
          IBQAssociesASSOC_KLE_IND: TIntegerField;
          IBQAssociesASSOC_KLE_ASSOCIE: TIntegerField;
          IBQAssociesASSOC_KLE_DOSSIER: TSmallintField;
          IBQAssociesASSOC_NOTES: TBlobField;
          IBQAssociesASSOC_SOURCES: TBlobField;
          IBQAssociesASSOC_TYPE: TSmallintField;
          IBQAssociesASSOC_EVENEMENT: TIntegerField;
          IBQAssociesASSOC_TABLE: TIBStringField;
          IBQAssociesTYPE_TEMOIN: TStringField;
          Panel1: TPanel;
          bsfbAjout: TFlatButton;
          bsfbRetirer: TFlatButton;
          TreeConj: TdxTreeList;
          dxTreeList1Column1: TdxTreeListColumn;
          dxTreeListColumnTypeUnion: TdxTreeListPickColumn;
          Label3: TLabel;
          Label4: TLabel;
          procedure bsfbAjoutClick(Sender: TObject);
          procedure DSUnionDataChange(Sender: TObject; Field: TField);
          procedure bsfbRetirerClick(Sender: TObject);
          procedure dxTreeListColumnTypeUnionCloseUp(Sender: TObject;
               var Value: Variant; var Accept: Boolean);
          procedure TreeConjDeletion(Sender: TObject; Node: TdxTreeListNode);
          procedure TreeConjEditing(Sender: TObject; Node: TdxTreeListNode;
               var Allow: Boolean);
          procedure SuperFormRefreshControls(Sender: TObject);
          procedure SuperFormCreate(Sender: TObject);
          procedure SuperFormDestroy(Sender: TObject);
     private
          fCodesRefTemoins: TIntegerList;
          fLibellesRefTemoins: TStringList;

          fFormIndividuIdentite: TForm;
          procedure SetFormIndividuIdentite(const Value: TForm);

          function AddThisIndividu(aNodeIndividu: TNodeIndividu; ToNode: TdxTreeListNode): TdxTreeListNode;

     public
          property FormIndividuIdentite: TForm read fFormIndividuIdentite write SetFormIndividuIdentite;

          procedure DoRefresh(Mode: boolean);
          procedure OpenQuerys;
          procedure CloseQuerys;
     end;

implementation

uses u_form_individu_events, u_form_individu, u_Dm, u_form_individu_par_prenom,
     u_common_func;
{$R *.DFM}

procedure TFIndividuEventsTemoins.SuperFormCreate(Sender: TObject);
begin
     fCodesRefTemoins := TIntegerList.create;
     fLibellesRefTemoins := TStringList.create;

     dxTreeListColumnTypeUnion.Items.Clear;
     try
          dm.IBQTypeTemoin.First;

          while not dm.IBQTypeTemoin.Eof do
               begin
                    fCodesRefTemoins.Add(dm.IBQTypeTemoinI_TYPE.AsInteger);
                    fLibellesRefTemoins.Add(dm.IBQTypeTemoinLIBELLE.AsString);
                    dxTreeListColumnTypeUnion.Items.Add(dm.IBQTypeTemoinLIBELLE.AsString);

                    dm.IBQTypeTemoin.next;
               end;
     except
     end;
end;

procedure TFIndividuEventsTemoins.DoRefresh(Mode: boolean);
begin
     bsfbAjout.enabled := mode;
     bsfbRetirer.enabled := mode and (TreeConj.FocusedNode <> nil) and (TreeConj.FocusedNode.level = 0);
end;

procedure TFIndividuEventsTemoins.SetFormIndividuIdentite(const Value: TForm);
begin
     fFormIndividuIdentite := Value;
end;

procedure TFIndividuEventsTemoins.CloseQuerys;
begin
     IBQAssocies.Close;
     IBTemoins.Close;
     IBQDetailTemoins.Close;
end;

procedure TFIndividuEventsTemoins.OpenQuerys;
var
     n: integer;
     aNodeIndividu: TNodeIndividu;
     NodeConjoint: TdxTreeListNode;

     s: string;
begin
     IBTemoins.DisableControls;
     {
     IBTemoins.Close;
     IBTemoins.Params[0].AsInteger := dm.NumDossier;
     IBTemoins.Params[1].AsInteger := TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).CleFiche;
     IBTemoins.Params[2].AsString := 'I';
     IBTemoins.Params[3].AsInteger := TFIndividuEvents(fFormindividuIdentite).GetCleEventSelected;
     IBTemoins.Open;
     IBTemoins.last;
     IBTemoins.first;
     }
     IBTemoins.Close;
     IBTemoins.Open;
     IBTemoins.last;
     IBTemoins.first;
     TreeConj.BeginUpdate;
     try
          //on efface tout dans le treeview
          TreeConj.ClearNodes;

          for n := 1 to IBTemoins.RecordCount do
               begin
                    //Nom, Prenom, Date de naissance, Date de dces
                    s := AssembleString([IBTemoins.FieldByName('NOM').AsString, IBTemoins.FieldByName('PRENOM').AsString]);
                    if IBTemoins.FieldByName('DATE_NAISSANCE').AsString <> '' then s := s + ' (  ' + IBTemoins.FieldByName('DATE_NAISSANCE').AsString + ')';
                    if IBTemoins.FieldByName('DATE_DECES').AsString <> '' then s := s + ' - ( + ' + IBTemoins.FieldByName('DATE_DECES').AsString + ')';

                    //cration d'un objet pour ce conjoint
                    aNodeIndividu := TNodeIndividu.create;
                    aNodeIndividu.Caption := s;
                    aNodeIndividu.CleFiche := IBTemoins.FieldByName('CLE_FICHE').AsInteger;
                    aNodeIndividu.Sexe := IBTemoins.FieldByName('SEXE').AsInteger;
                    aNodeIndividu.TypeUnion := IBTemoins.FieldByName('ASSOC_TYPE').AsInteger;
                    aNodeIndividu.UnionClef := IBTemoins.FieldByName('ASSOC_CLEF').AsInteger;

                    //On ajoute ce conjoint dans le treeView
                    NodeConjoint := AddThisIndividu(aNodeIndividu, nil);

                    if NodeConjoint <> nil then
                         begin

                              //recherche des parents
                              IBQDetailTemoins.DisableControls;
                              IBQDetailTemoins.close;
                              IBQDetailTemoins.open;

                              //Le pre de ce conjoint
                              if IBQDetailTemoins.FieldByName('NOM_PERE').AsString <> '' then
                                   begin
                                        s := AssembleString([IBQDetailTemoins.FieldByName('NOM_PERE').AsString, IBQDetailTemoins.FieldByName('PRENOM_PERE').AsString]);
                                        if IBQDetailTemoins.FieldByName('PERE_DATE_NAISSANCE').AsString <> '' then s := s + ' n le ' + IBQDetailTemoins.FieldByName('PERE_DATE_NAISSANCE').AsString;

                                        aNodeIndividu := TNodeIndividu.create;
                                        aNodeIndividu.Caption := s;
                                        aNodeIndividu.CleFiche := IBQDetailTemoins.FieldByName('CLE_FICHE').AsInteger;
                                        aNodeIndividu.Sexe := 2;

                                        //On ajoute le pre du conjoint, dans le treeView
                                        AddThisIndividu(aNodeIndividu, NodeConjoint);
                                   end;

                              //la mere de ce conjoint
                              if IBQDetailTemoins.FieldByName('NOM_MERE').AsString <> '' then
                                   begin
                                        s := AssembleString([IBQDetailTemoins.FieldByName('NOM_MERE').AsString, IBQDetailTemoins.FieldByName('PRENOM_MERE').AsString]);
                                        if IBQDetailTemoins.FieldByName('MERE_DATE_NAISSANCE').AsString <> '' then s := s + ' ne le ' + IBQDetailTemoins.FieldByName('MERE_DATE_NAISSANCE').AsString;

                                        aNodeIndividu := TNodeIndividu.create;
                                        aNodeIndividu.Caption := s;
                                        aNodeIndividu.CleFiche := IBQDetailTemoins.FieldByName('CLE_FICHE').AsInteger;
                                        aNodeIndividu.Sexe := 1;

                                        //On ajoute la mre du conjoint, dans le treeView
                                        AddThisIndividu(aNodeIndividu, NodeConjoint);
                                   end;
                              IBQDetailTemoins.EnableControls;
                         end;

                    IBTemoins.next;
               end;
     finally
          TreeConj.EndUpdate;
     end;
     IBTemoins.EnableControls;
end;

function TFIndividuEventsTemoins.AddThisIndividu(aNodeIndividu: TNodeIndividu; ToNode: TdxTreeListNode): TdxTreeListNode;
var
     N: TdxTreeListNode;
     k, w: integer;
begin
     //Si ToNode=Nil, alors c'est un conjoint qu'on ajoute, sinon, c'est un parent du conjoint
     if ToNode = nil then N := TreeConj.Add else N := ToNode.AddChild;

     if N <> nil then
          begin
               N.Data := aNodeIndividu;

               N.Values[0] := aNodeIndividu.Caption;
               if ToNode = nil then
                    begin
                         //Type d'union
                         w := fCodesRefTemoins.IndexOf(aNodeIndividu.TypeUnion);

                         if w <> -1 then N.Values[1] := fLibellesRefTemoins[w]
                         else N.Values[1] := '';

                         N.ImageIndex := 3;
                         N.SelectedIndex := 3;
                    end
               else
                    begin
                         N.Values[1] := '';

                         //image du sexe
                         k := -1;
                         if aNodeIndividu.Sexe = 1 then k := 0;
                         if aNodeIndividu.Sexe = 2 then k := 1;
                         N.ImageIndex := k;
                         N.SelectedIndex := k;
                    end;
          end;

     result := N;
end;

constructor TNodeIndividu.Create;
begin
     fCaption := '';
     fSexe := -1;
     fCleFiche := -1;
     fTypeUnion := -1;
     fUnionClef := -1;
end;

procedure TFIndividuEventsTemoins.bsfbAjoutClick(Sender: TObject);
var
     aNodeIndividu: TNodeIndividu;
     NodeConjoint: TdxTreeListNode;
     s: string;
     i_bConjoints: TIBQuery;
     aFIndividuPrenom: TFIndividuPrenom;
     NewAssocCle: integer;
begin

     //Cration de la boite de recherche d'un individu par le prnom
     aFIndividuPrenom := TFIndividuPrenom.create(self);
     try
          aFIndividuPrenom.Position := poMainFormCenter;

          aFIndividuPrenom.up_InitIndividuPrenom('A', '',0, 2);

          if aFIndividuPrenom.ShowModal = mrOk then
               begin
                    //On ouvre le query des unions
                    NewAssocCle := dm.uf_GetClefUnique('T_ASSOCIATIONS');
                    IBQAssocies.Open;
                    IBQAssocies.Append;
                    IBQAssocies.FieldByName('ASSOC_CLEF').AsInteger := NewAssocCle;
                    IBQAssocies.FieldByName('ASSOC_KLE_DOSSIER').AsInteger := dm.NumDossier;
                    IBQAssocies.FieldByName('ASSOC_TYPE').AsInteger := 0;
                    IBQAssocies.FieldByName('ASSOC_TABLE').AsString := 'I';
                    IBQAssocies.FieldByName('ASSOC_EVENEMENT').AsInteger := TFIndividuEvents(fFormindividuIdentite).GetCleEventSelected;

                    IBQAssocies.FieldByName('ASSOC_KLE_IND').AsInteger := TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).CleFiche; ;
                    IBQAssocies.FieldByName('ASSOC_KLE_ASSOCIE').AsInteger := aFIndividuPrenom.ClefIndividuSelected;

                    IBQAssocies.Post;

                    //on indique que l'individu est modifi
                    TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).Modified := true;

                    i_bConjoints := TIBQuery.Create(Self);
                    try
                         i_bConjoints.DataBase := dm.ibd_BASE;
                         i_bConjoints.SQL.ADD('select *  FROM PROC_PRENOM_PAR_NOM_PAR_CLEF(:CLE_FICHE,:KLE_DOSSIER)');
                         i_bConjoints.Params[0].AsInteger := aFIndividuPrenom.ClefIndividuSelected;
                         i_bConjoints.Params[1].AsInteger := dm.NumDossier;
                         i_bConjoints.Open;


                         //on ajoute un item dans le TreeList
                         TreeConj.BeginUpdate;
                         try
                              //Nom, Prenom, Date de naissance, Date de dces
                              s := AssembleString([i_bConjoints.FieldByName('NOM').AsString, i_bConjoints.FieldByName('PRENOM').AsString]);
                              if i_bConjoints.FieldByName('DATE_NAISSANCE').AsString <> '' then s := s + ' (  ' + i_bConjoints.FieldByName('DATE_NAISSANCE').AsString + ')';
                              if i_bConjoints.FieldByName('DATE_DECES').AsString <> '' then s := s + ' - ( + ' + i_bConjoints.FieldByName('DATE_DECES').AsString + ')';

                              //Cration d'un objet, pour ce conjoint
                              aNodeIndividu := TNodeIndividu.create;
                              aNodeIndividu.Caption := s;
                              aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                              aNodeIndividu.Sexe := i_bConjoints.FieldByName('SEXE').AsInteger;
                              aNodeIndividu.TypeUnion := 0;
                              aNodeIndividu.UnionClef := NewAssocCle;

                              //On ajoute ce conjoint dans le treeView
                              NodeConjoint := AddThisIndividu(aNodeIndividu, nil);

                              TreeConj.FocusedNumber := TreeConj.RowCount;

                              if NodeConjoint <> nil then
                                   begin
                                        //Ce conjoint a-t'il un pre ?
                                        if i_bConjoints.FieldByName('NOM_PERE').AsString <> '' then
                                             begin
                                                  s := AssembleString([i_bConjoints.FieldByName('NOM_PERE').AsString,
                                                       i_bConjoints.FieldByName('PRENOM_PERE').AsString]);
                                                  if i_bConjoints.FieldByName('PERE_DATE_NAISSANCE').AsString <> '' then
                                                       s := s + ' n le ' + i_bConjoints.FieldByName('PERE_DATE_NAISSANCE').AsString;

                                                  aNodeIndividu := TNodeIndividu.create;
                                                  aNodeIndividu.Caption := s;
                                                  aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                                                  aNodeIndividu.Sexe := 1;

                                                  //On ajoute le pre du conjoint, dans le treeView
                                                  AddThisIndividu(aNodeIndividu, NodeConjoint);
                                             end;

                                        //Ce conjoint a-t'il une mre ?
                                        if i_bConjoints.FieldByName('NOM_MERE').AsString <> '' then
                                             begin
                                                  s := AssembleString([i_bConjoints.FieldByName('NOM_MERE').AsString,
                                                       i_bConjoints.FieldByName('PRENOM_MERE').AsString]);
                                                  if i_bConjoints.FieldByName('MERE_DATE_NAISSANCE').AsString <> '' then
                                                       s := s + ' ne le ' + i_bConjoints.FieldByName('MERE_DATE_NAISSANCE').AsString;

                                                  aNodeIndividu := TNodeIndividu.create;
                                                  aNodeIndividu.Caption := s;
                                                  aNodeIndividu.CleFiche := i_bConjoints.FieldByName('CLE_FICHE').AsInteger;
                                                  aNodeIndividu.Sexe := 2;

                                                  //On ajoute la mre du conjoint, dans le treeView
                                                  AddThisIndividu(aNodeIndividu, NodeConjoint);
                                             end;
                                   end;

                         finally
                              TreeConj.EndUpdate;
                         end;
                    finally
                         i_bConjoints.Free;
                    end;
               end;

     finally
          aFIndividuPrenom.Free;
     end;

     TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).DoRefreshControls;

end;

procedure TFIndividuEventsTemoins.DSUnionDataChange(
     Sender: TObject; Field: TField);
begin
     TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).DoRefreshControls;
end;

{Delete d'un tmoin-------------------------------------------------------------------------------}

procedure TFIndividuEventsTemoins.bsfbRetirerClick(Sender: TObject);
var
     aNodeIndividu: TNodeIndividu;
     aNode: TdxTreeListNode;
     QUpdateTypeUnion: TIBQuery;
begin
     if TreeConj.FocusedNode <> nil then
          begin
               aNode := TreeConj.FocusedNode;
               if (aNode.Data <> nil) and (aNode.Level = 0) then
                    begin
                         //on rcupre l'objet de stockage de l'individu
                         aNodeIndividu := TNodeIndividu(aNode.Data);

                         if aNodeIndividu.UnionClef <> -1 then
                              begin
                                   if MessageDlg('Confirmez-vous la suppression de ce tmoin associ  : ' +
                                        aNodeIndividu.fCaption + ' ?',
                                        mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                                        begin
                                             QUpdateTypeUnion := TIBQuery.create(self);
                                             try
                                                  QUpdateTypeUnion.Database := dm.ibd_BASE;
                                                  //QUpdateTypeUnion.SQL.Add('EXECUTE PROCEDURE PROC_DELETE_UNION(:CLEF)');
                                                  QUpdateTypeUnion.SQL.Add('delete from T_ASSOCIATIONS where ASSOC_CLEF=' + inttostr(aNodeIndividu.UnionClef));
                                                  //QUpdateTypeUnion.Params[0].AsInteger := aNodeIndividu.UnionClef;
                                                  QUpdateTypeUnion.ExecSQL;
                                                  QUpdateTypeUnion.Close;

                                                  //on indique qu'on a fait une modification
                                                  TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).Modified := true;
                                             finally
                                                  QUpdateTypeUnion.Free;
                                             end;

                                             TreeConj.FocusedNode.Free;
                                             TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).DoRefreshControls;
                                        end;
                              end;
                    end;
          end;

end;

procedure TFIndividuEventsTemoins.dxTreeListColumnTypeUnionCloseUp(
     Sender: TObject; var Value: Variant; var Accept: Boolean);
var
     w: integer;
     UnionType: integer;
     QUpdateTypeUnion: TIBQuery;
     aNode: TNodeIndividu;
begin
     //on regarde si cette valeur est diffrente du type d'union actuel
     if TreeConj.FocusedNode <> nil then
          begin
               if (TreeConj.FocusedNode.strings[dxTreeListColumnTypeUnion.index] <> Value) then
                    begin
                         if (TreeConj.FocusedNode.Data <> nil) then
                              begin
                                   aNode := TNodeIndividu(TreeConj.FocusedNode.Data);

                                   w := fLibellesRefTemoins.IndexOf(Value);
                                   if w <> -1 then UnionType := fCodesRefTemoins[w]
                                   else UnionType := -1;

                                   aNode.TypeUnion := UnionType;

                                   QUpdateTypeUnion := TIBQuery.create(self);
                                   try
                                        QUpdateTypeUnion.Database := dm.ibd_BASE;
                                        QUpdateTypeUnion.SQL.Add('update T_ASSOCIATIONS set ASSOC_TYPE = :ASSOC_TYPE where ASSOC_CLEF=' + inttostr(aNode.UnionClef));
                                        QUpdateTypeUnion.ParamByName('ASSOC_TYPE').AsInteger := UnionType;
                                        QUpdateTypeUnion.ExecSQL;
                                        QUpdateTypeUnion.Close;

                                        //on indique qu'on a fait une modification
                                        TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).Modified := true;

                                   finally
                                        QUpdateTypeUnion.Free;
                                   end;

                                   TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).DoRefreshControls;
                              end;
                    end;
          end;
end;

procedure TFIndividuEventsTemoins.TreeConjDeletion(Sender: TObject;
     Node: TdxTreeListNode);
begin
     if Node.Data <> nil then
          begin
               TNodeIndividu(Node.Data).free;
               Node.Data := nil;
          end;
end;

procedure TFIndividuEventsTemoins.TreeConjEditing(Sender: TObject;
     Node: TdxTreeListNode; var Allow: Boolean);
begin
     if Node.Level = 1 then Allow := False
     else
          if Node.Level = 0 then
               begin
                    if TreeConj.FocusedColumn = 0 then Allow := false;
               end;
end;

procedure TFIndividuEventsTemoins.SuperFormRefreshControls(
     Sender: TObject);
begin
     bsfbRetirer.enabled := (TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).CleFiche <> -1) and (TreeConj.FocusedNode <> nil) and (TreeConj.FocusedNode.Level = 0);
     bsfbAjout.enabled := (TFIndividu(TFIndividuEvents(fFormindividuIdentite).FormIndividu).CleFiche <> -1);
end;

procedure TFIndividuEventsTemoins.SuperFormDestroy(Sender: TObject);
begin
     fCodesRefTemoins.free;
     fLibellesRefTemoins.free;
end;

end.
