{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_identite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, Math, iBStoredProc, Jpeg, dxExEdtr, Menus, ImgList, DB,
  IBCustomDataSet, IBUpdateSQL, IBQuery, PCM_TDBJPEGImage, GraphicEx,
  URLLink, ExtCtrls, dxEdLib, dxDBELib, dxDBEdtr, dxEditor, dxCntner,
  TFlatPanelUnit, TFlatCheckBoxUnit, dxTLClms, dxTL, dxDBGrid, dxDBCtrl,
  dxDBTLCl, dxGrClms, StdCtrls, u_comp_TGoodBtn, TFlatSplitterUnit,
  u_comp_TYLanguage,
  u_form_individu_edit_event_life;

{, TFlatButtonUnit, ExtCtrls, URLLink, TFlatSpeedButtonUnit,
GraphicEx, StdCtrls, dxExEdtr, dxEdLib, dxDBELib, dxDBEdtr, dxEditor,
dxCntner, TFlatPanelUnit, Db, IBCustomDataSet, IBQuery, Menus, dxTL,
dxDBGrid, dxDBCtrl, dxDBTLCl, dxGrClms, IBUpdateSQL, TFlatCheckBoxUnit,
DBCGrids, Mask, DBCtrls, JPEG, u_form_individu_edit_event_life, Buttons,
u_comp_TGoodBtn, u_comp_TYLanguage, TFlatSplitterUnit, dxTLClms, ImgList,
iBStoredProc, PCM_TDBJPEGImage, Math, DateUtils;}

type
  TMydxDBPopupEdit = class(TdxDBPopupEdit)
  public
    procedure DropDown; override;
  end;

  TMydxDBGrid = class(TdxDBGrid)
  public
    property VisibleRowCount;
    property RowCount;

  end;

  TNodeIndividu = class
  private
    fCleFiche: integer;
    fCaption: string;
    fSosa: Int64;
    fUnionClef: integer;
    fNom: string;
    fSexe: integer;
  public
    constructor Create;
    property CleFiche: integer read fCleFiche write fCleFiche;
    property Caption: string read fCaption write fCaption;
    property Sosa: Int64 read fSosa write fSosa;
    property UnionClef: integer read fUnionClef write fUnionClef;
    property Nom: string read fNom write fNom;
    property Sexe: integer read fSexe write fSexe;
  end;

  TFIndividuIdentite = class(TSuperForm)
    IBParents: TIBQuery;
    IBConjoints: TIBQuery;
    IBQDetailConjoint: TIBQuery;
    IBEnfants: TIBQuery;
    IBEnfantsCLE_FICHE: TIntegerField;
    IBEnfantsNOM: TIBStringField;
    IBEnfantsPRENOM: TIBStringField;
    IBEnfantsDATE_NAISSANCE: TIBStringField;
    IBEnfantsDATE_DECES: TIBStringField;
    IBEnfantsKLE_DOSSIER: TIntegerField;
    IBEnfantsNOM_PRENOM: TStringField;
    IBUAjoutEnfant: TIBUpdateSQL;
    IBQAjoutEnfant: TIBQuery;
    IBQAjoutEnfantCLE_FICHE: TIntegerField;
    IBQAjoutEnfantCLE_PERE: TIntegerField;
    IBQAjoutEnfantCLE_MERE: TIntegerField;
    pPatronymes: TPanel;
    Panel22: TPanel;
    Label7: TLabel;
    pPrenom: TPanel;
    dxDBGrid2: TdxDBGrid;
    dxDBGridColumn2: TdxDBGridColumn;
    Panel12: TPanel;
    Label16: TLabel;
    IBQEve: TIBQuery;
    IBQEveEV_IND_CLEF: TIntegerField;
    IBQEveEV_IND_KLE_FICHE: TIntegerField;
    IBQEveEV_IND_KLE_DOSSIER: TIntegerField;
    IBQEveEV_IND_TYPE: TIBStringField;
    IBQEveEV_IND_DATE_WRITEN: TIBStringField;
    IBQEveEV_IND_DATE: TDateField;
    IBQEveEV_IND_ADRESSE: TIBStringField;
    IBQEveEV_IND_CP: TIBStringField;
    IBQEveEV_IND_VILLE: TIBStringField;
    IBQEveEV_IND_DEPT: TIBStringField;
    IBQEveEV_IND_PAYS: TIBStringField;
    IBQEveEV_IND_CAUSE: TIBStringField;
    IBQEveEV_IND_SOURCE: TMemoField;
    IBQEveEV_IND_COMMENT: TMemoField;
    IBQEveEV_IND_DESCRIPTION: TIBStringField;
    IBQEveEV_IND_REGION: TIBStringField;
    IBQEveEV_IND_SUBD: TIBStringField;
    IBQEve_LONG_EVENT_NAME: TStringField;
    IBQEve_IMG_EVENT: TIntegerField;
    dsEve: TDataSource;
    IBQEve_DETAIL: TStringField;
    dxDBGrid1: TdxDBGrid;
    dxDBGridColumn1: TdxDBGridColumn;
    IBEnfantsSOSA: TFloatField;
    IBConjointsCLE_FICHE: TIntegerField;
    IBConjointsNOM: TIBStringField;
    IBConjointsPRENOM: TIBStringField;
    IBConjointsDATE_NAISSANCE: TIBStringField;
    IBConjointsANNEE_NAISSANCE: TIntegerField;
    IBConjointsDATE_DECES: TIBStringField;
    IBConjointsANNEE_DECES: TIntegerField;
    IBConjointsCLE_PERE: TIntegerField;
    IBConjointsCLE_MERE: TIntegerField;
    IBConjointsNUM_SOSA: TFloatField;
    IBConjointsTYPE_UNION: TIntegerField;
    IBConjointsUNION_CLEF: TIntegerField;
    IBConjointsKLE_DOSSIER: TIntegerField;
    IBConjointsNOM_PRENOM: TStringField;
    Panel8: TPanel;
    pIdentiteReduite: TFlatPanel;
    imgSexeInconnu: TImage;
    imgSexeFemme: TImage;
    imgSexeHomme: TImage;
    lTitre: TURLLink;
    lNaissance: TLabel;
    lDeces: TLabel;
    lSosa: TLabel;
    Panel15: TPanel;
    Image1: TImage;
    Label17: TLabel;
    DataSourceIndividu: TDataSource;
    dsPhoto: TDataSource;
    IBQPhoto: TIBQuery;
    DSPatronymes: TDataSource;
    IBQPatronymes: TIBQuery;
    IBQPatronymesNOM: TIBStringField;
    DSPrenoms: TDataSource;
    IBQPrenoms: TIBQuery;
    IBQPrenomsPRENOM: TIBStringField;
    pIdentiteComplete: TFlatPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    edSuffixe: TdxDBEdit;
    edSurnom: TdxDBEdit;
    DBRSexe: TdxDBImageEdit;
    edCivilite: TdxDBLookupEdit;
    sDBENom: TdxDBPopupEdit;
    sDBEPrenom: TdxDBPopupEdit;
    sDBCBfiliation: TdxDBLookupEdit;
    PaintBox5: TPaintBox;
    IBEnfantsSEXE: TIntegerField;
    IBQEveEV_IND_DATE_YEAR: TIntegerField;
    IBQEveEV_IND_TYPEANNEE: TIntegerField;
    IBConjointsSEXE: TIntegerField;
    Language: TYLanguage;
    Panel17: TPanel;
    Panel9: TPanel;
    Panel18: TPanel;
    Panel4: TPanel;
    Panel1: TPanel;
    Label8: TLabel;
    btnNewEvent: TGoodBtn;
    btnDeleteEvent: TGoodBtn;
    Panel3: TPanel;
    panInfoCoutRow: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel16: TPanel;
    panParents: TPanel;
    Panel27: TPanel;
    PaintBox3: TPaintBox;
    panPere: TPanel;
    lbNomPere: TURLLink;
    lbNeLeDecesLePere: TLabel;
    fsbDelPere: TGoodBtn;
    btnAjoutPere: TGoodBtn;
    Panel29: TPanel;
    lbNomMere: TURLLink;
    lbNeLeDecesLeMere: TLabel;
    fsbDelMere: TGoodBtn;
    btnAjoutMere: TGoodBtn;
    Label3: TLabel;
    Panel28: TPanel;
    Panel30: TPanel;
    Panel31: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    lConjoints: TLabel;
    btnAjoutConjoint: TGoodBtn;
    btnRetirerConjoint: TGoodBtn;
    Panel24: TPanel;
    tv: TdxTreeList;
    Panel19: TPanel;
    FlatSplitter1: TFlatSplitter;
    Panel23: TPanel;
    Panel25: TPanel;
    lEnfants: TLabel;
    btnAjoutEnfant: TGoodBtn;
    btnRetirerEnfant: TGoodBtn;
    chbTous: TFlatCheckBox;
    Panel26: TPanel;
    Panel5: TPanel;
    dxDBGEve: TdxDBGrid;
    dxDBGEveColumn3: TdxDBGridImageColumn;
    dxDBGEveColumn2: TdxDBGridColumn;
    Panel2: TPanel;
    FlatSplitter2: TFlatSplitter;
    tvColumn1: TdxTreeListColumn;
    tvColumnEnfants: TdxTreeListImageColumn;
    ImageEnfants: TImageList;
    tvEnfants: TdxTreeList;
    dxTreeListColumn1: TdxTreeListColumn;
    PopupVideEnfants: TPopupMenu;
    PopupVideConjoints: TPopupMenu;
    PopupVideEve: TPopupMenu;
    dsConjoits: TDataSource;
    PCM_TDBJPEGImage1: TPCM_TDBJPEGImage;
    IBQPhotoMULTI_REDUITE: TBlobField;
    sSosa: TLabel;
    IBEnfantsPHOTO: TBlobField;
    IBEnfantsVILLE_NAISS: TIBStringField;
    IBEnfantsVILLE_DECES: TIBStringField;
    IBEnfantsANNEE: TIntegerField;
    IBEnfantsAGE_DECES: TIntegerField;
    dxDBGEveColumn4: TdxDBGridImageColumn;
    imageEvent: TImageList;
    IBQEveQUID_SOURCES: TIntegerField;
    dxDBGEveColumn5: TdxDBGridImageColumn;
    IBQEveQUID_NOTES: TIntegerField;
    dxDBGEveColumn6: TdxDBGridImageColumn;
    IBQEveEV_IND_ACTE: TIntegerField;
    IBQEveQUID_IMAGE: TIntegerField;
    IBMultimedia: TIBQuery;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    IBQEveEV_LIBELLE: TIBStringField;
    IBQEveEV_IND_INSEE: TIBStringField;
    IBParentsCLE_FICHE: TIntegerField;
    IBParentsNOM_PERE: TIBStringField;
    IBParentsPRENOM_PERE: TIBStringField;
    IBParentsPERE_CLE_FICHE: TIntegerField;
    IBParentsPERE_NAISSANCE: TIBStringField;
    IBParentsPERE_DECES: TIBStringField;
    IBParentsPERE_SOSA: TFloatField;
    IBParentsNOM_MERE: TIBStringField;
    IBParentsPRENOM_MERE: TIBStringField;
    IBParentsMERE_CLE_FICHE: TIntegerField;
    IBParentsMERE_NAISSANCE: TIBStringField;
    IBParentsMERE_DECES: TIBStringField;
    IBParentsMERE_SOSA: TFloatField;
    IBParentsPERE_ANNEE: TIntegerField;
    IBParentsMERE_ANNEE: TIntegerField;
    lNIP: TLabel;
    lNipT: TLabel;
    lNIP1T: TLabel;
    lNIP1: TLabel;
    btnCarto: TGoodBtn;
    mtri: TMenuItem;
    N1: TMenuItem;
    mdel: TMenuItem;
    mAjout: TMenuItem;
    IBEnfantsANNEE_DECES: TIntegerField;
    IBQEveEV_IND_HEURE: TTimeField;
    IBUEve: TIBUpdateSQL;
    procedure btnAjoutPereClick(Sender: TObject);
    procedure fsbDelPereClick(Sender: TObject);
    procedure btnAjoutMereClick(Sender: TObject);
    procedure fsbDelMereClick(Sender: TObject);
    procedure IBConjointsCalcFields(DataSet: TDataSet);
    procedure tvChangeNode(Sender: TObject; OldNode,
      Node: TdxTreeListNode);
    procedure tvDeletion(Sender: TObject; Node: TdxTreeListNode);
    procedure IBEnfantsCalcFields(DataSet: TDataSet);
    procedure btnAjoutEnfantClick(Sender: TObject);
    procedure btnRetirerEnfantClick(Sender: TObject);
    procedure chbTousClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure lbNomPereClick(Sender: TObject);
    procedure lbNomMereClick(Sender: TObject);
    procedure SuperFormResize(Sender: TObject);
    procedure lTitreClick(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure IdentiteChange(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBRSexeChange(Sender: TObject);
    procedure sDBENomInitPopup(Sender: TObject);
    procedure sDBEPrenomInitPopup(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure dxDBGrid2DblClick(Sender: TObject);
    procedure sDBENomKeyPress(Sender: TObject; var Key: Char);
    procedure sDBEPrenomKeyPress(Sender: TObject; var Key: Char);
    procedure DataSourceIndividuDataChange(Sender: TObject; Field: TField);
    procedure SuperFormDestroy(Sender: TObject);
    procedure IBQEveNewRecord(DataSet: TDataSet);
    procedure IBQEveBeforePost(DataSet: TDataSet);
    procedure IBQEveAfterScroll(DataSet: TDataSet);
    procedure btnRetirerConjointClick(Sender: TObject);
    procedure btnAjoutConjointClick(Sender: TObject);
    procedure up_OpenEvent(Sender: TObject);
    procedure IBQEveCalcFields(DataSet: TDataSet);
    procedure btnNewEventClick(Sender: TObject);
    procedure btnDeleteEventClick(Sender: TObject);
    procedure sDBENomKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sDBEPrenomKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mOuvrirEnfantClick(Sender: TObject);
    procedure dxDBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dxDBGrid2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edCiviliteKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tvCustomDrawCell(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; ANode: TdxTreeListNode; AColumn: TdxTreeListColumn;
      ASelected, AFocused, ANewItemRow: Boolean; var AText: string;
      var AColor: TColor; AFont: TFont; var AAlignment: TAlignment;
      var ADone: Boolean);
    procedure tvMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tvClick(Sender: TObject);
    procedure tvEnfantsDeletion(Sender: TObject; Node: TdxTreeListNode);
    procedure tvEnfantsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tvEnfantsCustomDrawCell(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; ANode: TdxTreeListNode; AColumn: TdxTreeListColumn;
      ASelected, AFocused, ANewItemRow: Boolean; var AText: string;
      var AColor: TColor; AFont: TFont; var AAlignment: TAlignment;
      var ADone: Boolean);
    procedure tvEnfantsClick(Sender: TObject);
    procedure PCM_TDBJPEGImage1GetGraphicClass(Sender: TObject;
      var GraphicClass: TGraphicClass);
    procedure dxDBGraphicEdit1GetGraphicClass(Sender: TObject;
      var GraphicClass: TGraphicClass);
    procedure pIdentiteCompleteClick(Sender: TObject);
    procedure sDBEPrenomExit(Sender: TObject);
    procedure btnCartoClick(Sender: TObject);
    procedure mtriClick(Sender: TObject);

  private
    fFormIndividu: TForm;
    fCanScrollEv: boolean;

    CurNodeC: TdxTreeListNode;
    CurColumnC: TdxTreeListColumn;

    CurNodeE: TdxTreeListNode;
    CurColumnE: TdxTreeListColumn;

    fFill: boolean;

    procedure SetFormIndividu(const Value: TForm);
    procedure PaintPointille(sender: TObject);
    procedure RefreshTitle;
    function GetCleEventSelected: integer;

  public
    aFIndividuEditEventLife: TFIndividuEditEventLife;

    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;

    procedure RefreshPhoto;
    procedure doInitialize;
    function doOpenQuerys: boolean;
    procedure RempliConjoints;
    procedure RempliEnfants;
    procedure SetColorFromContext;
  end;

implementation

uses u_dm, u_form_individu, u_form_individu_par_prenom, u_common_func,
  u_common_var, u_objet_TContext, u_form_Evements_Ajout, u_common_const,
  u_objet_TGedcomDate, u_form_individu_Affecte_Enfant, U_Form_Cartographie,
  u_form_TriEvent;

{$R *.DFM}

{ TFIndividuIdentite }

procedure TFIndividuIdentite.doInitialize;
begin
  fCanScrollEv := false;

  IBQEve.Close;
  IBQPhoto.Close;
  ibConjoints.Close;
  IBQDetailConjoint.Close;
  ibEnfants.Close;
  IBParents.Close;

  lbNomPere.Caption := '';
  lbNeLeDecesLePere.Caption := '';

  lbNomMere.Caption := '';
  lbNeLeDecesLeMere.Caption := '';

  pIdentiteReduite.Hide;
  pIdentiteComplete.Hide;

  tv.ClearNodes;

  PCM_TDBJPEGImage1.visible := false;
end;

function TFIndividuIdentite.doOpenQuerys: boolean;
var
  s, sn, sd: string;
begin
  RefreshTitle;

  if TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger = 1 then
    lConjoints.Font.Color := _Context.ColorFemme
  else
    lConjoints.Font.Color := _Context.ColorHomme;

  //on cherche les parents
  IBParents.DisableControls;
  IBParents.Close;
  IBParents.Params[0].AsInteger := TFIndividu(fFormindividu).CleFiche;
  IBParents.Params[1].AsInteger := dm.NumDossier;
  IBParents.prepare;
  IBParents.Open;
  IBParents.last;
  IBParents.First;

  if IBParents.RecordCount = 1 then
    begin
      pIdentiteReduite.Show;
      pIdentiteComplete.Hide;

      // On fabrique le nom du pere
      if Length(IBParents.FieldByName('NOM_PERE').AsString) > 0 then
        begin
          //SBZapPere.Enabled := True;
          lbNomPere.Caption := AssembleString([IBParents.FieldByName('NOM_PERE').AsString, IBParents.FieldByName('PRENOM_PERE').AsString]);
          //CoupeChaine(AssembleString([IBParents.FieldByName('NOM_PERE').AsString, IBParents.FieldByName('PRENOM_PERE').AsString]), 25);

          sn := trim(IBParents.FieldByName('PERE_NAISSANCE').AsString);
          if sn <> '' then sn := 'n le : ' + sn;
          //			lbNeLePere.Caption := s;

          sd := trim(IBParents.FieldByName('PERE_DECES').AsString);
          if sd <> '' then sd := 'dcs le : ' + sd;
          //			lbMortLePere.Caption := s;

          s := sn;
          if sd <> '' then
            begin
              if s <> '' then s := s + '  /  ';
              s := s + sd;
            end;
          lbNeLeDecesLePere.Caption := s;
        end
      else
        begin
          lbNomPere.Caption := '';
          lbNeLeDecesLePere.Caption := '';
        end;

      // On fabrique le nom de la mre
      if Length(IBParents.FieldByName('NOM_MERE').AsString) > 0 then
        begin
          lbNomMere.Caption := AssembleString([IBParents.FieldByName('NOM_MERE').AsString, IBParents.FieldByName('PRENOM_MERE').AsString]);

          sn := trim(IBParents.FieldByName('MERE_NAISSANCE').AsString);
          if sn <> '' then sn := 'ne le : ' + sn;

          sd := trim(IBParents.FieldByName('MERE_DECES').AsString);
          if sd <> '' then sd := 'dcs le : ' + sd;

          s := sn;
          if sd <> '' then
            begin
              if s <> '' then s := s + '  /  ';
              s := s + sd;
            end;
          lbNeLeDecesLeMere.Caption := s;

        end
      else
        begin
          lbNomMere.Caption := '';
          lbNeLeDecesLeMere.Caption := '';
        end;
    end;
  IBParents.EnableControls;

  fCanScrollEv := false;
  IBQEve.DisableControls;
  try
    IBQEve.Close;
    IBQEve.Params[0].AsInteger := TFIndividu(fFormindividu).CleFiche;
    IBQEve.Open;
    IBQEve.Last;
    IBQEve.First;
  finally
    fCanScrollEv := true;
    IBQEve.EnableControls;
  end;

  IBQEveAfterScroll(IBQEve);

  IBConjoints.Close;
  IBEnfants.Close;

  ibConjoints.DisableControls;
  ibConjoints.Params[0].AsInteger := dm.NumDossier;
  ibConjoints.Open;

  RempliConjoints;

  ibConjoints.EnableControls;
  chbTous.Enabled := tv.Count > 0;

  RempliEnfants;
  RefreshPhoto;

  Result := True;
end;

procedure TFIndividuIdentite.RefreshPhoto;
begin
  IBQPhoto.Close;
  IBQPhoto.Open;
  IBQPhoto.last;
  IBQPhoto.first;
  PCM_TDBJPEGImage1.visible := IBQPhoto.RecordCount > 0;
end;

procedure TFIndividuIdentite.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;

  DataSourceIndividu.DataSet := TFIndividu(fFormIndividu).QueryIndividu;

  aFIndividuEditEventLife.FormIndividu := fFormIndividu;
end;

procedure TFIndividuIdentite.btnAjoutPereClick(Sender: TObject);
var
  aFIndividuPrenom: TFIndividuPrenom;
  aLettre: string;
  s, sn, sd: string;
begin
  //Cration de la boite de recherche d'un individu par le prnom
  aFIndividuPrenom := TFIndividuPrenom.create(self);

  try
    aFIndividuPrenom.NomIndi := TFIndividu(fFormindividu).QueryIndividuNOM.AsString;
    aFIndividuPrenom.Position := poMainFormCenter;

    aLettre := Copy(TFIndividu(fFormindividu).QueryIndividuNOM.AsString, 1, 1);
    aFIndividuPrenom.up_InitIndividuPrenom(aLettre, '', 1, 2);

    if aFIndividuPrenom.ShowModal = mrOk then
      if aFIndividuPrenom.SexeIndividuSelected = 2 then
        ShowMessage('Le pre d''un individu ne peut pas tre une femme....')
      else
        if aFIndividuPrenom.ClefIndividuSelected = TFIndividu(fFormindividu).Clefiche then
          ShowMessage('L''individu ne peux pas tre  la fois, lui mme et son pre')
        else
          begin
            if (not (TFIndividu(fFormindividu).QueryIndividu.State in [dsEdit, dsInsert]))
              then TFIndividu(fFormindividu).QueryIndividu.Edit;

            TFIndividu(fFormindividu).QueryIndividuCLE_PERE.AsInteger := aFIndividuPrenom.ClefIndividuSelected;

            lbNomPere.Caption := aFIndividuPrenom.NomPrenomIndividuSelected;
            sn := trim(aFIndividuPrenom.NaissanceIndividuSelected);
            sd := trim(aFIndividuPrenom.DecesIndividuSelected);

            s := sn;
            if sd <> '' then
              begin
                if s <> '' then s := s + '  /  ';
                s := s + sd;
              end;
            lbNeLeDecesLePere.Caption := s;
          end;

  finally
    aFIndividuPrenom.Free;
  end;

  doRefreshControls;
end;

procedure TFIndividuIdentite.fsbDelPereClick(Sender: TObject);
begin
  if (not (TFIndividu(fFormindividu).QueryIndividu.State in [dsEdit, dsInsert]))
    then TFIndividu(fFormindividu).QueryIndividu.Edit;

  TFIndividu(fFormindividu).QueryIndividuCLE_PERE.Clear;

  lbNomPere.Caption := '';
  lbNeLeDecesLePere.Caption := '';
  lbNomPere.Hint := '';
  lbNomPere.ShowHint := False;

  doRefreshControls;
end;

procedure TFIndividuIdentite.btnAjoutMereClick(Sender: TObject);
var
  aFIndividuPrenom: TFIndividuPrenom;
  s, sn, sd: string;
begin
  //Cration de la boite de recherche d'un individu par le prnom
  aFIndividuPrenom := TFIndividuPrenom.create(self);

  try
    aFIndividuPrenom.Position := poMainFormCenter;

    aFIndividuPrenom.up_InitIndividuPrenom('A', '', 2, 2);

    if aFIndividuPrenom.ShowModal = mrOk then
      if aFIndividuPrenom.SexeIndividuSelected = 1 then
        ShowMessage('La mre d''un individu ne peut pas tre un homme....')
      else
        if aFIndividuPrenom.ClefIndividuSelected = TFIndividu(fFormindividu).Clefiche then
          ShowMessage('L''individu ne peux pas tre  la fois, lui mme et sa mre')
        else
          begin
            if (not (TFIndividu(fFormindividu).QueryIndividu.State in [dsEdit, dsInsert]))
              then TFIndividu(fFormindividu).QueryIndividu.Edit;

            TFIndividu(fFormindividu).QueryIndividuCLE_MERE.AsInteger := aFIndividuPrenom.ClefIndividuSelected;

            lbNomMere.Caption := aFIndividuPrenom.NomPrenomIndividuSelected;

            sn := trim(aFIndividuPrenom.NaissanceIndividuSelected);
            sd := trim(aFIndividuPrenom.DecesIndividuSelected);

            s := sn;
            if sd <> '' then
              begin
                if s <> '' then s := s + '  /  ';
                s := s + sd;
              end;
            lbNeLeDecesLeMere.Caption := s;

          end;

  finally
    aFIndividuPrenom.Free;
  end;

  doRefreshControls;
end;

procedure TFIndividuIdentite.fsbDelMereClick(Sender: TObject);
begin
  if (not (TFIndividu(fFormindividu).QueryIndividu.State in [dsEdit, dsInsert]))
    then TFIndividu(fFormindividu).QueryIndividu.Edit;

  TFIndividu(fFormindividu).QueryIndividuCLE_MERE.Clear;

  lbNomMere.Caption := '';
  lbNeLeDecesLeMere.Caption := '';
  lbNomMere.Hint := '';
  lbNomMere.ShowHint := False;

  doRefreshControls;
end;

procedure TFIndividuIdentite.IBConjointsCalcFields(DataSet: TDataSet);
begin
  IBConjointsKLE_DOSSIER.AsInteger := dm.NumDossier;

  // On fabrique le nom des conjoints
  IBConjointsNOM_PRENOM.asString := AssembleString([IBConjointsNOM.AsString,
    IBConjointsPRENOM.asString]);
end;

procedure TFIndividuIdentite.tvChangeNode(Sender: TObject; OldNode, Node: TdxTreeListNode);
begin
  tvClick(Sender);
end;

procedure TFIndividuIdentite.tvDeletion(Sender: TObject;
  Node: TdxTreeListNode);
begin
  if Node.data <> nil then
    begin
      TNodeIndividu(Node.data).free;
      Node.data := nil;
    end;
end;

procedure TFIndividuIdentite.RempliEnfants;
var
  //     n: integer;
  i_Conjoint: integer;
  NodeIndi: TNodeIndividu;
  Node: TdxTreeListNode;
  sEnfant: string;
begin
  // Pour chaque conjoints, on recherche les enfants
  IBEnfants.DisableControls;
  tvEnfants.BeginUpdate;
  try
    tvEnfants.ClearNodes;
    IBEnfants.Close;
    i_Conjoint := 0;

    { ---------------------------------------------------------------------
      Le passage des paramatres est invers en fonction du sexe de
      l'individu central.
      Les parametres de la procedure sont
      1 - Le code du pere
      2 - Le code de la mere
      3 - Le code du dossier courant
     --------------------------------------------------------------------}

    if chbTous.Checked then
      i_conjoint := 0
    else
      if tv.FocusedNode <> nil then
        begin
          if tv.FocusedNode.level = 0 then i_Conjoint := TNodeIndividu(tv.FocusedNode.Data).CleFiche
          else if tv.FocusedNode.level = 1 then
            begin
              i_Conjoint := TNodeIndividu(tv.FocusedNode.Parent).CleFiche
            end;
        end
      else
        i_conjoint := 0;

    //soit c'est un homme
    if TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger = 1 then
      // if TFIndividu(fFormindividu).aFIndividuIdentite.DBRSexe.ItemIndex = 0 then
      begin
        IBEnfants.Params[0].AsInteger := IBParents.FieldByName('CLE_FICHE').AsInteger;
        IBEnfants.Params[1].AsInteger := i_Conjoint;
      end
    else
      begin
        IBEnfants.Params[0].AsInteger := i_Conjoint;
        IBEnfants.Params[1].AsInteger := IBParents.FieldByName('CLE_FICHE').AsInteger;
      end;

    IBEnfants.Params[2].AsInteger := dm.NumDossier;
    IBEnfants.Open;

    //On remplis le TreeView des enfants
    IBEnfants.Last;

    if IBEnfants.RecordCount > 1 then
      lEnfants.Caption := 'Ses ' + IntToStr(IBEnfants.RecordCount) + ' enfants'
    else if IBEnfants.RecordCount = 1 then
      lEnfants.Caption := 'Son enfant'
    else
      lEnfants.Caption := 'Pas d''enfant';

    IBEnfants.First;

    while (not IBEnfants.EOF) do
      begin
        NodeIndi := TNodeIndividu.create;
        NodeIndi.CleFiche := IBEnfants.FieldByName('CLE_FICHE').AsInteger;
        sEnfant := AssembleString([IBEnfants.FieldByName('NOM').AsString,
          IBEnfants.FieldByName('PRENOM').AsString]);

        if Length(sEnfant) > 33 then
          sEnfant := Copy(AssembleString([IBEnfants.FieldByName('NOM').AsString,
            IBEnfants.FieldByName('PRENOM').AsString]), 0, 33) + '...';

        NodeIndi.Caption := sEnfant;

        if Length(IBEnfants.FieldByName('ANNEE_DECES').AsString) > 0 then
          begin
            if Length(NodeIndi.Caption) > 24 then
              NodeIndi.Caption := Copy(NodeIndi.Caption, 0, 24) + '...';
          end
        else
          begin
            if Length(NodeIndi.Caption) > 33 then
              NodeIndi.Caption := Copy(NodeIndi.Caption, 0, 33) + '...';
          end;

        NodeIndi.Caption := NodeIndi.Caption + GetStringNaissanceDeces(IBEnfants.FieldByName('ANNEE').AsString, IBEnfants.FieldByName('ANNEE_DECES').AsString);

        NodeIndi.Nom := IBEnfants.FieldByName('NOM').AsString;
        NodeIndi.Sexe := IBEnfants.FieldByName('SEXE').AsInteger;
        NodeIndi.Sosa := 0;

        if IBEnfants.FieldByName('SOSA').AsFloat > 0 then
          NodeIndi.Sosa := Trunc(IBEnfants.FieldByName('SOSA').AsFloat);

        Node := tvEnfants.Add;
        Node.Values[0] := NodeIndi.Caption;
        Node.Data := NodeIndi;

        case NodeIndi.Sexe of
          1: Node.ImageIndex := 1;
          2: Node.ImageIndex := 0;
          else
            Node.ImageIndex := 2;
        end;

        Node.SelectedIndex := Node.ImageIndex;

        IBEnfants.Next;
      end;


  finally
    tvEnfants.EndUpdate;
    IBEnfants.EnableControls;
  end;
end;

procedure TFIndividuIdentite.IBEnfantsCalcFields(DataSet: TDataSet);
begin

  // On fabrique le nom des enfants
  IBEnfantsNOM_PRENOM.asString := AssembleString([IBEnfantsNOM.AsString,
    IBEnfantsPRENOM.asString]);

end;

procedure TFIndividuIdentite.btnAjoutEnfantClick(Sender: TObject);
var
  aFIndividuPrenom: TFIndividuPrenom;
  aFAffecte_Enfant: TFAffecte_Enfant;
  i_Node: Integer;
  aLettre: string;
  i_Conjoint: integer;
begin
  i_Node := 0;
  aLettre := 'A';
  //i_conjoint := -1;

  if tv.FocusedNode <> nil then
    begin
      if tv.FocusedNode.level = 0 then
        begin
          i_Node := TNodeIndividu(tv.FocusedNode.data).CleFiche;
          aLettre := copy(TNodeIndividu(tv.FocusedNode.data).Nom, 1, 1);
        end
      else
        if tv.FocusedNode.level = 1 then
          begin
            i_Node := TNodeIndividu(tv.FocusedNode.Parent.data).CleFiche;
            aLettre := copy(TNodeIndividu(tv.FocusedNode.Parent.data).Nom, 1, 1);
          end;
    end;

  //Cration de la boite de recherche d'un individu par le prnom
  aFIndividuPrenom := TFIndividuPrenom.create(self);

  try
    aFIndividuPrenom.Position := poMainFormCenter;

    if TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger = 1
      then aLettre := Copy(TFIndividu(fFormindividu).QueryIndividuNOM.AsString, 1, 1);

    aFIndividuPrenom.up_InitIndividuPrenom(aLettre, '', 0, 2);

    if aFIndividuPrenom.ShowModal = mrOk then

      if aFIndividuPrenom.ClefIndividuSelected = TFIndividu(fFormindividu).Clefiche then
        ShowMessage('L''individu ne peux pas tre  la fois, lui mme et son enfant')
      else
        begin
          IBQAjoutEnfant.Close;
          IBQAjoutEnfant.Params[0].AsInteger := aFIndividuPrenom.ClefIndividuSelected;
          IBQAjoutEnfant.Open;
          IBQAjoutEnfant.Edit;

          if TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger = 1 then
            begin
              IBQAjoutEnfantCLE_PERE.AsInteger := TFIndividu(fFormindividu).CleFiche;
              IBQAjoutEnfantCLE_MERE.AsInteger := i_Node;
            end
          else
            if TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger = 2 then
              begin
                IBQAjoutEnfantCLE_PERE.AsInteger := i_Node;
                IBQAjoutEnfantCLE_MERE.AsInteger := TFIndividu(fFormindividu).CleFiche;
              end
            else
              begin
                IBQAjoutEnfantCLE_PERE.Clear;
                IBQAjoutEnfantCLE_MERE.Clear
              end;

          //  Affrection de l'enfant aux parents --------------------------------------------------------
          if tv.FocusedNode <> nil then
            begin
              if tv.FocusedNode.level = 0 then i_Conjoint := TNodeIndividu(tv.FocusedNode.Data).CleFiche
              else if tv.FocusedNode.level = 1 then
                begin
                  i_Conjoint := TNodeIndividu(tv.FocusedNode.Parent).CleFiche
                end;
            end
          else
            i_conjoint := 0;

          if i_conjoint > 0 then
            begin
              aFAffecte_Enfant := tFAffecte_Enfant.Create(Self);
              aFAffecte_Enfant.DoInit(TFIndividu(fFormindividu).CleFiche, i_conjoint, aFIndividuPrenom.ClefIndividuSelected);
              if aFAffecte_Enfant.ShowModal = mrOk then
                begin
                  if aFAffecte_Enfant.ClefPere > 0 then IBQAjoutEnfantCLE_PERE.AsInteger := aFAffecte_Enfant.ClefPere;
                  if aFAffecte_Enfant.ClefMere > 0 then IBQAjoutEnfantCLE_MERE.AsInteger := aFAffecte_Enfant.ClefMere;
                end
              else
                begin
                  //
                end;
              aFAffecte_Enfant.Free;
            end;
          //---------------------------------------------------------------------------------------------

          IBQAjoutEnfant.Post;
          IBQAjoutEnfant.Close;

          TFIndividu(fFormindividu).Modified := True;
          TFIndividu(fFormindividu).DoRefreshControls;

          RempliEnfants;

          TFIndividu(fFormindividu).LoadCoherenceDates;
          TFIndividu(fFormindividu).CoherenceDate.Test; ;
          TFIndividu(fFormindividu).DoRefreshControls;
        end;

  finally
    aFIndividuPrenom.Free;
  end;

  DoRefreshControls;
end;


procedure TFIndividuIdentite.btnRetirerEnfantClick(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la supression de cet enfant ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      try
        {
                  IBDeleteEnfant.Close;
                  IBDeleteEnfant.ParamByName('CLE_FICHE').AsInteger := IBEnfants.FieldByName('CLE_FICHE').AsInteger;
                  IBDeleteEnfant.ExecSQL;
                  IBDeleteEnfant.Close;
         }

        IBQAjoutEnfant.Close;
        IBQAjoutEnfant.Params[0].AsInteger := IBEnfants.FieldByName('CLE_FICHE').AsInteger;
        IBQAjoutEnfant.Open;
        IBQAjoutEnfant.Edit;

        IBQAjoutEnfantCLE_PERE.AsInteger := 0;
        IBQAjoutEnfantCLE_MERE.AsInteger := 0;

        IBQAjoutEnfant.Post;
        TFIndividu(fFormindividu).Modified := True;
        TFIndividu(fFormindividu).DoRefreshControls;

        TFIndividu(fFormindividu).LoadCoherenceDates;
        TFIndividu(fFormindividu).CoherenceDate.Test; ;
        TFIndividu(fFormindividu).DoRefreshControls;
      except
      end;

      RempliEnfants;
      //  RempliConjoints;
    end;

  doRefreshControls;
end;

procedure TFIndividuIdentite.chbTousClick(Sender: TObject);
begin
  if fFill then exit;

  RempliEnfants;
  doRefreshControls;

  {
  if chbTous.Checked then
       chbTous.Caption := 'Enfants du conjoint slectionn'
  else
       chbTous.Caption := 'Enfants de tous les conjoints';
   }
end;


{ TNodeIndividu }

constructor TNodeIndividu.Create;
begin
  Sexe := 0;
  fNom := '';
  fCleFiche := -1;
  fCaption := '';
  fUnionClef := -1;
end;


procedure TFIndividuIdentite.RempliConjoints;
var
  n: integer;
  //SubItem: TTreeNode;
  s: string;
  //aNodeIndi: TNodeIndividu;

  NodeConj, Node: TdxTreeListNode;
  NodeIndi: TNodeIndividu;
begin
  tv.BeginUpdate;

  try
    tv.ClearNodes;

    ibConjoints.DisableControls;
    try
      ibConjoints.Close;
      ibConjoints.Params[0].AsInteger := dm.NumDossier;
      ibConjoints.Params[1].AsInteger := TFIndividu(fFormindividu).CleFiche;
      ibConjoints.Open;

      ibConjoints.last;

      if ibConjoints.RecordCount > 1 then
        lConjoints.Caption := 'Ses ' + IntToStr(ibConjoints.RecordCount) + ' conjoints'
      else if ibConjoints.RecordCount = 1 then
        lConjoints.Caption := 'Son conjoint'
      else
        lConjoints.Caption := 'Pas de conjoint';

      ibConjoints.first;

      chbTous.Checked := ibConjoints.RecordCount > 1;

      for n := 1 to ibConjoints.RecordCount do
        begin

          s := AssembleString([ibConjoints.FieldByName('NOM').AsString, ibConjoints.FieldByName('PRENOM').AsString]);

          if Length(ibConjoints.FieldByName('ANNEE_DECES').AsString) > 0 then
            begin
              if Length(s) > 19 then
                s := Copy(s, 0, 19) + '...';
            end
          else
            begin
              if Length(s) > 28 then
                s := Copy(s, 0, 28) + '...';
            end;

          s := s + GetStringNaissanceDeces(ibConjoints.FieldByName('ANNEE_NAISSANCE').AsString, ibConjoints.FieldByName('ANNEE_DECES').AsString);

          NodeIndi := TNodeIndividu.create;
          NodeIndi.CleFiche := ibConjoints.FieldByName('CLE_FICHE').AsInteger;
          NodeIndi.Caption := AssembleString([ibConjoints.FieldByName('NOM').AsString, ibConjoints.FieldByName('PRENOM').AsString]);
          NodeIndi.UnionClef := ibConjoints.FieldByName('UNION_CLEF').AsInteger;
          NodeIndi.Nom := ibConjoints.FieldByName('NOM').AsString;
          NodeIndi.Sexe := ibConjoints.FieldByName('SEXE').AsInteger;
          NodeIndi.Sosa := 0;

          if ibConjoints.FieldByName('NUM_SOSA').AsFloat > 0 then
            NodeIndi.Sosa := Trunc(ibConjoints.FieldByName('NUM_SOSA').AsFloat);

          NodeConj := tv.Add;

          NodeConj.Values[0] := s;
          NodeConj.Values[1] := '1';
          NodeConj.Data := NodeIndi;


          case IBConjointsSEXE.AsInteger of
            1: NodeConj.ImageIndex := 1;
            2: NodeConj.ImageIndex := 0;
            else
              NodeConj.ImageIndex := 2;
          end;

          NodeConj.SelectedIndex := NodeConj.ImageIndex;

          IBQDetailConjoint.DisableControls;
          IBQDetailConjoint.close;
          IBQDetailConjoint.open;

          if IBQDetailConjoint.FieldByName('NOM_PERE').AsString <> '' then
            begin
              s := AssembleString([IBQDetailConjoint.FieldByName('NOM_PERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_PERE').AsString]);
              if IBQDetailConjoint.FieldByName('PERE_ANNEE_NAISSANCE').AsString <> '' then
                s := s + ' (  ' + IBQDetailConjoint.FieldByName('PERE_ANNEE_NAISSANCE').AsString + ')';

              NodeIndi := TNodeIndividu.create;
              NodeIndi.CleFiche := IBQDetailConjoint.FieldByName('PERE_CLE_FICHE').AsInteger;
              NodeIndi.Caption := AssembleString([IBQDetailConjoint.FieldByName('NOM_PERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_PERE').AsString]);
              NodeIndi.Nom := IBQDetailConjoint.FieldByName('NOM_PERE').AsString;
              NodeIndi.Sexe := 1;
              //if IBQDetailConjoint.FieldByName('PERE_NUM_SOSA').AsFloat > 0 then
              //     NodeIndi.Sosa := Trunc(IBQDetailConjoint.FieldByName('PERE_NUM_SOSA').AsFloat);

              Node := NodeConj.AddChild;
              Node.Values[0] := 'son pre : ' + s;
              Node.Values[1] := '0';
              Node.Data := NodeIndi;
              Node.ImageIndex := 1;
              Node.SelectedIndex := 1;

            end;

          if IBQDetailConjoint.FieldByName('NOM_MERE').AsString <> '' then
            begin
              s := AssembleString([IBQDetailConjoint.FieldByName('NOM_MERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_MERE').AsString]);
              if IBQDetailConjoint.FieldByName('MERE_ANNEE_NAISSANCE').AsString <> '' then
                s := s + ' (  ' + IBQDetailConjoint.FieldByName('MERE_ANNEE_NAISSANCE').AsString + ')';

              NodeIndi := TNodeIndividu.create;
              NodeIndi.CleFiche := IBQDetailConjoint.FieldByName('MERE_CLE_FICHE').AsInteger;
              NodeIndi.Caption := AssembleString([IBQDetailConjoint.FieldByName('NOM_MERE').AsString, IBQDetailConjoint.FieldByName('PRENOM_MERE').AsString]);
              NodeIndi.Nom := IBQDetailConjoint.FieldByName('NOM_MERE').AsString;
              NodeIndi.Sexe := 2;

              //if IBQDetailConjoint.FieldByName('MERE_NUM_SOSA').AsFloat > 0 then
              //     NodeIndi.Sosa := Trunc(IBQDetailConjoint.FieldByName('MERE_NUM_SOSA').AsFloat);

              Node := NodeConj.AddChild;
              Node.Values[0] := 'sa mre : ' + s;
              Node.Values[1] := '0';
              Node.Data := NodeIndi;

              Node.ImageIndex := 0;
              Node.SelectedIndex := 0;
            end;

          ibConjoints.next;
          IBQDetailConjoint.EnableControls;
        end;

      {
      if tvConj.items.count > 0 then
       tvConj.Selected := tvConj.Items[0]
      else
       chbTous.Checked := True;
       }

    finally
      ibConjoints.EnableControls;
    end;

  finally
    tv.EndUpdate;
  end;
end;

procedure TFIndividuIdentite.SuperFormRefreshControls(Sender: TObject);
begin
  // PCM -- le 25/04/02 -- afin de rafraichir les icones -----------------------
  //IBQEve.Close;
  //IBQEve.Open;
  //----------------------------------------------------------------------------

  btnCarto.Visible := DirectoryExists(ExtractFilePath(Application.ExeName) + 'Cartographie');

  Panel15.Visible := (_Context.Photos); //and (IBQPhoto.RecordCount >0);

  if Panel15.Visible then
    pIdentiteComplete.Width := Panel15.Left - 18
  else
    pIdentiteComplete.Width := Panel8.Width - 18;

  btnNewEvent.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
  btnDeleteEvent.enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
    and (IBQEve.Active)
    and (IBQEve.RecordCount > 0)
    and (TFIndividu(fFormindividu).DialogMode = false);

  if (TFIndividu(fFormindividu).DialogMode = True) then pIdentiteComplete.Cursor := crArrow;

  btnAjoutPere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and
    (TFIndividu(fFormindividu).QueryIndividuCLE_PERE.IsNull = true) and
    (TFIndividu(fFormindividu).DialogMode = false);

  fsbDelPere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
    and (TFIndividu(fFormindividu).QueryIndividu.Active)
    and (TFIndividu(fFormindividu).QueryIndividuCLE_PERE.IsNull = false)
    and (TFIndividu(fFormindividu).DialogMode = false);

  btnAjoutMere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and
    (TFIndividu(fFormindividu).QueryIndividuCLE_MERE.IsNull = true) and
    (TFIndividu(fFormindividu).DialogMode = false);

  fsbDelMere.enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
    and (TFIndividu(fFormindividu).QueryIndividu.Active)
    and (TFIndividu(fFormindividu).QueryIndividuCLE_MERE.IsNull = false)
    and (TFIndividu(fFormindividu).DialogMode = false);

  tv.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
  chbTous.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);

  //Conjoints
  btnAjoutConjoint.Enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
    and (IBConjoints.Active)
    and (TFIndividu(fFormindividu).DialogMode = false);
  btnRetirerConjoint.Enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
    and (IBConjoints.Active)
    and (IBConjoints.RecordCount > 0)
    and (TFIndividu(fFormindividu).DialogMode = false)
    and (tv.FocusedNode <> nil)
    and (tv.FocusedNode.Level = 0);

  //Enfants
  btnAjoutEnfant.Enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
    and (IBEnfants.Active)
    and (TFIndividu(fFormindividu).DialogMode = false);
  btnRetirerEnfant.Enabled := (TFIndividu(fFormindividu).CleFiche <> -1)
    and (IBEnfants.Active)
    and (ibEnfants.RecordCount > 0)
    and (TFIndividu(fFormindividu).DialogMode = false);

  dsEve.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);

  aFIndividuEditEventLife.doRefreshControls;

  RefreshTitle;
end;

procedure TFIndividuIdentite.PaintPointille(sender: TObject);
var
  pb: TPaintBox;
  k: integer;
begin
  pb := TPaintBox(sender);
  pb.Canvas.Pen.Color := clGray;
  pb.Canvas.Pen.Width := 1;

  k := 0;
  if pb.width > pb.Height then
    begin
      while k < pb.width do
        begin
          pb.Canvas.MoveTo(k, 0);
          pb.Canvas.LineTo(k + 3, 0);
          k := k + 6;
        end;
    end
  else
    begin
      while k < pb.height do
        begin
          pb.Canvas.MoveTo(0, k);
          pb.Canvas.LineTo(0, k + 3);
          k := k + 6;
        end;
    end;
end;



procedure TFIndividuIdentite.PaintBox1Paint(Sender: TObject);
begin
  PaintPointille(Sender);
end;

procedure TFIndividuIdentite.lbNomPereClick(Sender: TObject);
begin

  // TFIndividu(fFormindividu).ChangeFicheActive(IBParentsPERE_CLE_FICHE.AsInteger);
  TFIndividu(fFormindividu).ChangeFicheActive(TFIndividu(fFormindividu).QueryIndividuCLE_PERE.AsInteger);
end;

procedure TFIndividuIdentite.lbNomMereClick(Sender: TObject);
begin
  // TFIndividu(fFormindividu).ChangeFicheActive(IBParentsMERE_CLE_FICHE.AsInteger);
  TFIndividu(fFormindividu).ChangeFicheActive(TFIndividu(fFormindividu).QueryIndividuCLE_MERE.AsInteger);
end;

procedure TFIndividuIdentite.SuperFormResize(Sender: TObject);
var k: integer;
begin
  k := width div 2;
  // panParents.width := k;
 //     panAllEnfants.width := k;

  panPere.Width := k;

  panInfoCoutRow.visible := (IBQEve.Active) and ((IBQEve.RecordCount * ((dxDBGEve.RowHeight - 1) * (dxDBGEve.PreviewLines + 1))) > (dxDBGEve.Height));


  dxDBGEve.Align := alNone;
  dxDBGEve.Align := alClient;
  Panel23.Align := alNone;
  Panel23.Align := alClient;

end;

procedure TFIndividuIdentite.RefreshTitle;
var
  s, s1, s2, s3: string;
  iSosa: int64;
begin
  imgSexeHomme.Hide;
  imgSexeFemme.Hide;
  imgSexeInconnu.Hide;

  //Civilite
  s1 := trim(TFIndividu(fFormindividu).QueryIndividuS_PREFIXE.AsString);

  //Nom, Prnom, Suffixe
  s := AssembleString([s1 + ' ' + TFIndividu(fFormindividu).QueryIndividuNOM.AsString,
    TFIndividu(fFormindividu).QueryIndividuPRENOM.AsString,
      TFIndividu(fFormindividu).QueryIndividuSUFFIXE.AsString]);

  //surnom
  s1 := trim(TFIndividu(fFormindividu).QueryIndividuSURNOM.AsString);
  if s1 <> '' then s1 := '  (' + s1 + ')';

  s := s + s1;

  //     if Length(s) >= 67 then          s := Copy(s, 0, 67) + ' ...';

  lTitre.Caption := CoupeChaine(s, lTitre);

  lSosa.Visible := TFIndividu(fFormindividu).QueryIndividuNUM_SOSA.AsFloat > 0;
  sSosa.Visible := lSosa.Visible;

  if _Context.Nip = 1 then
    begin
      if TFIndividu(fFormindividu).QueryIndividuSexe.AsInteger = 1 then
        begin
          lNIP.Font.Color := _Context.ColorHomme;
          lNIP1.Font.Color := _Context.ColorHomme;
          lNIP.Caption := '1-' + TFIndividu(fFormindividu).QueryIndividuCLE_FICHE.AsString
        end
      else if TFIndividu(fFormindividu).QueryIndividuSexe.AsInteger = 2 then
        begin
          lNIP.Font.Color := _Context.ColorFemme;
          lNIP1.Font.Color := _Context.ColorFemme;
          lNIP.Caption := '2-' + TFIndividu(fFormindividu).QueryIndividuCLE_FICHE.AsString
        end
      else
        begin
          lNIP.Font.Color := clGreen;
          lNIP1.Font.Color := clGreen;
          lNIP.Caption := '0-' + TFIndividu(fFormindividu).QueryIndividuCLE_FICHE.AsString;
        end;

      lNIP1.Caption := lNIP.Caption;

    end;

  lNIP.Visible := _Context.Nip = 1;
  lNIP1.Visible := _Context.Nip = 1;
  lNIPt.Visible := _Context.Nip = 1;
  lNIP1t.Visible := _Context.Nip = 1;

  if (lSosa.Visible) then
    begin
      // On calcule la gnration par rapport au sosa

      if TFIndividu(fFormindividu).QueryIndividuNUM_SOSA.AsFloat > 1 then
        if TFIndividu(fFormindividu).QueryIndividuSexe.AsInteger = 1 then
          iSosa := Trunc((Log2(TFIndividu(fFormindividu).QueryIndividuNUM_SOSA.AsFloat) / Log2(2))) + 1
        else
          iSosa := Trunc((Log2(TFIndividu(fFormindividu).QueryIndividuNUM_SOSA.AsFloat - 1) / Log2(2))) + 1
      else
        iSosa := 1;

      sSosa.Font.Color := _COLOR_SOSA;
      sSosa.Caption := TFIndividu(fFormindividu).QueryIndividuNUM_SOSA.AsString;

      if TFIndividu(fFormindividu).QueryIndividuNUM_SOSA.AsFloat >= 1 then
        sSosa.Caption := TFIndividu(fFormindividu).QueryIndividuNUM_SOSA.AsString +
          ' - Gnration : ' + floattostr(iSosa);

    end;

  s2 := trim(TFIndividu(fFormindividu).QueryIndividuDATE_NAISSANCE.AsString);
  if s2 <> '' then
    begin
      case TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger of
        1: s2 := 'N le : ' + s2;
        2: s2 := 'Ne le : ' + s2;
        else
          s2 := 'N(e) le : ' + s2;
      end;
    end;
  lNaissance.Caption := s2;

  s3 := trim(TFIndividu(fFormindividu).QueryIndividuDATE_DECES.AsString);
  if s3 <> '' then
    begin
      case TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger of
        1: s3 := 'Dcd le : ' + s3;
        2: s3 := 'Dcde le : ' + s3;
        else
          s3 := 'Dcd(e) le : ' + s3;
      end;

      if GetAge(TFIndividu(fFormindividu).CleFiche) > 0 then
        s3 := s3 + '  l''age de ' + IntTostr(GetAge(TFIndividu(fFormindividu).CleFiche)) + ' ans';

    end;

  lDeces.Caption := s3;

  try
    case TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger of
      1:
        begin
          imgSexeHomme.Show;
          lTitre.Font.Color := _Context.ColorHomme;
          lTitre.FocusFont.Color := _Context.ColorHomme;

          //lTitre.Font.Color := clNavy;
          //lTitre.FocusFont.Color := clNavy;
        end;
      2:
        begin
          imgSexeFemme.Show;
          //lTitre.Font.Color := clMaroon;
          //lTitre.FocusFont.Color := clMaroon;

          lTitre.Font.Color := _Context.ColorFemme;
          lTitre.FocusFont.Color := _Context.ColorFemme;
        end

      else
        begin
          lTitre.Font.Color := clBlack;
          lTitre.FocusFont.Color := clBlack;

          imgSexeInconnu.Show;
        end;
    end;
  except
    //  lTitre.Caption := 'Fiche individu';
  end;

  application.ProcessMessages;
end;

procedure TFIndividuIdentite.lTitreClick(Sender: TObject);
begin
  if (TFIndividu(fFormindividu).DialogMode = false) then
    begin
      pIdentiteReduite.Hide;
      pIdentiteComplete.Show;
      pIdentiteComplete.Height := 105;
      if edCivilite.CanFocus then edCivilite.SetFocus;
    end;
end;

procedure TFIndividuIdentite.SuperFormCreate(Sender: TObject);
var
  s_Hint: string;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  s_Hint := #13#10#13#10 + 'N''oubliez pas des que des raccourcis de saisie sont l pour vous aider. ' +
    'Il vous suffit de taper ce raccourcis suivit de la touche espace, pour que le nom complet s''affiche.' +
    #13#10#13#10 + 'Pour crer des raccourcis, allez dans le menu configuration';
  sDBENom.Hint := sDBENom.Hint + s_Hint;
  sDBEPrenom.Hint := sDBEPrenom.Hint + s_Hint;

  CurNodeC := nil;
  CurColumnC := nil;

  CurNodeE := nil;
  CurColumnE := nil;

  fFill := false;
  Panel8.Height := 127;
  Panel9.Height := 128;
  pIdentiteReduite.Hide;
  pIdentiteComplete.Hide;

  aFIndividuEditEventLife := TFIndividuEditEventLife.create(self);
  aFIndividuEditEventLife.DataSource.DataSet := IBQEve;

  SetColorFromContext;
end;

procedure TFIndividuIdentite.IdentiteChange(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  TFIndividu(fFormindividu).RefreshNomIndividu;
end;

procedure TFIndividuIdentite.DBRSexeChange(Sender: TObject);
begin
  TFIndividu(fFormindividu).RefreshNomIndividu;
end;


procedure TFIndividuIdentite.sDBENomInitPopup(Sender: TObject);
begin
  pPatronymes.Width := 400;
  pPatronymes.Height := 250;

  IBQPatronymes.Close;
  IBQPatronymes.Params[0].AsInteger := dm.NumDossier;
  IBQPatronymes.Open;
end;

procedure TFIndividuIdentite.sDBEPrenomInitPopup(Sender: TObject);
begin
  pPrenom.Width := 400;
  pPrenom.Height := 250;

  IBQPrenoms.Close;
  IBQPrenoms.Params[0].AsInteger := dm.NumDossier;
  IBQPrenoms.Open;
end;

procedure TFIndividuIdentite.dxDBGrid1DblClick(Sender: TObject);
begin
  TFIndividu(fFormindividu).QueryIndividu.Edit;
  TFIndividu(fFormindividu).QueryIndividuNOM.AsString := IBQPatronymesNOM.AsString;
  (GetParentForm(dxDBGrid1) as TdxPopupEditForm).ClosePopup(True);
end;

procedure TFIndividuIdentite.dxDBGrid2DblClick(Sender: TObject);
begin
  TFIndividu(fFormindividu).QueryIndividu.Edit;

  if Length(TFIndividu(fFormindividu).QueryIndividuPreNOM.AsString) > 0 then
    TFIndividu(fFormindividu).QueryIndividuPreNOM.AsString := TFIndividu(fFormindividu).QueryIndividuPreNOM.AsString + ', ' + IBQPrenomsPrenom.AsString
  else
    TFIndividu(fFormindividu).QueryIndividuPRENOM.AsString := IBQPrenomsPrenom.AsString;

  (GetParentForm(dxDBGrid2) as TdxPopupEditForm).ClosePopup(True);
end;

procedure TFIndividuIdentite.sDBENomKeyPress(Sender: TObject; var Key: Char);
begin
  if _Context.ModeSaisieNom = msAllUpper then Key := UpCase(Key)
  else
    if _Context.ModeSaisieNom = msJustFirstLetterUpper then
      begin
        if sDBENom.Text = '' then Key := UpCase(Key);
      end;
end;

procedure TFIndividuIdentite.sDBEPrenomKeyPress(Sender: TObject; var Key: Char);
begin
  if _Context.ModeSaisiePrenom = msAllUpper then Key := UpCase(Key)
  else
    if _Context.ModeSaisiePrenom = msJustFirstLetterUpper then
      begin
        if sDBEPrenom.Text = '' then Key := UpCase(Key);
      end;

  RefreshTitle;
end;

procedure TFIndividuIdentite.DataSourceIndividuDataChange(Sender: TObject;
  Field: TField);
begin
  TFIndividu(fFormindividu).DoRefreshControls;
end;

procedure TFIndividuIdentite.SuperFormDestroy(Sender: TObject);
begin
  aFIndividuEditEventLife.Free;
end;

procedure TFIndividuIdentite.IBQEveNewRecord(DataSet: TDataSet);
begin
  ibqEveEV_IND_CLEF.AsInteger := dm.uf_GetClefUnique('EVENEMENTS_IND');
  ibqEveEV_IND_KLE_FICHE.AsInteger := TFIndividu(fFormindividu).CleFiche;
  ibqEveEV_IND_KLE_DOSSIER.AsInteger := dm.NumDossier;
  panInfoCoutRow.visible := ((DataSet.RecordCount * ((dxDBGEve.RowHeight - 1) * (dxDBGEve.PreviewLines + 1))) > (dxDBGEve.Height));
end;

procedure TFIndividuIdentite.IBQEveBeforePost(DataSet: TDataSet);
var s, s2, s3: string;
  Year1, Year2: Integer;
  s_Proc: TIBStoredProc;
begin

  {- Ici on va verifier que le lieu existe, sinon on le creer dans la base -----------------------------}

  Application.ProcessMessages;
  Screen.Cursor := crHourGlass;
  s_Proc := TIBStoredProc.Create(Application);

  try
    try
      with s_Proc do begin
          DataBase := dm.ibd_BASE;
          StoredProcName := 'PROC_AJOUT_VILLE';
          Prepare;
          ParamByName('S_CP').AsString := IBQEveEV_IND_CP.AsString;
          ParamByName('S_VILLE').AsString := IBQEveEV_IND_VILLE.AsString;
          ParamByName('S_DEPT').AsString := IBQEveEV_IND_DEPT.AsString;
          ParamByName('S_REGION').AsString := IBQEveEV_IND_REGION.AsString;
          ParamByName('S_PAYS').AsString := IBQEveEV_IND_PAYS.AsString;

          ExecProc;
        end;
    except
    end;
  finally
    begin
      s_Proc.UnPrepare;
      s_Proc.free;
    end;
  end;

  Screen.Cursor := crDefault;
  {-----------------------------------------------------------------------------------------------------}

  //on prpare les champs d'accueil de la date
  DataSet.FieldByName('EV_IND_DATE_YEAR').Clear;
  DataSet.FieldByName('EV_IND_DATE').Clear;
  s := DataSet.FieldByName('EV_IND_TYPE').AsString;

  if s = 'BIRT' then
    begin
      if (not (TFIndividu(fFormindividu).QueryIndividu.State in [dsEdit, dsInsert]))
        then TFIndividu(fFormindividu).QueryIndividu.Edit;

      TFIndividu(fFormindividu).QueryIndividuDATE_NAISSANCE.Clear;
      TFIndividu(fFormindividu).QueryIndividuANNEE_NAISSANCE.Clear;
    end
  else
    if s = 'DEAT' then
      begin
        if (not (TFIndividu(fFormindividu).QueryIndividu.State in [dsEdit, dsInsert]))
          then TFIndividu(fFormindividu).QueryIndividu.Edit;

        TFIndividu(fFormindividu).QueryIndividuDATE_DECES.Clear;
        TFIndividu(fFormindividu).QueryIndividuANNEE_DECES.Clear;
      end;

  if _GDate.DecodeHumanDate(DataSet.FieldByName('EV_IND_DATE_WRITEN').AsString) then
    begin
      if s = 'BIRT' then
        begin
          TFIndividu(fFormindividu).QueryIndividuDATE_NAISSANCE.AsString := DataSet.FieldByName('EV_IND_DATE_WRITEN').AsString;
          s2 := trim(TFIndividu(fFormindividu).QueryIndividuDATE_NAISSANCE.AsString);

          if _GDate.DecodeHumanDate(s2) then
            begin
              Year1 := _GDate.GDate.Year1;
              DataSet.FieldByName('EV_IND_DATE_YEAR').AsInteger := Year1;
              DataSet.FieldByName('EV_IND_DATE').AsDateTime := _GDate.GDate.DateTime1;
            end;

          if s2 <> '' then
            begin
              case TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger of
                1: s2 := 'N le : ' + s2;
                2: s2 := 'Ne le : ' + s2;
                else
                  s2 := 'N(e) le : ' + s2;
              end;
            end;
          lNaissance.Caption := s2;
        end
      else
        if s = 'DEAT' then
          begin
            TFIndividu(fFormindividu).QueryIndividuDATE_DECES.AsString := DataSet.FieldByName('EV_IND_DATE_WRITEN').AsString;
            s3 := trim(TFIndividu(fFormindividu).QueryIndividuDATE_DECES.AsString);

            if _GDate.DecodeHumanDate(s3) then
              begin
                Year2 := _GDate.GDate.Year1;
                DataSet.FieldByName('EV_IND_DATE_YEAR').AsInteger := Year2;
                DataSet.FieldByName('EV_IND_DATE').AsDateTime := _GDate.GDate.DateTime2;
              end;

            if s3 <> '' then
              begin
                case TFIndividu(fFormindividu).QueryIndividuSEXE.AsInteger of
                  1: s3 := 'Dcd le : ' + s3;
                  2: s3 := 'Dcde le : ' + s3;
                  else
                    s3 := 'Dcd(e) le : ' + s3;
                end;
              end;

            lDeces.Caption := s3;

          end;

      //l'anne
      if (_GDate.KnowYear) then
        begin
          DataSet.FieldByName('EV_IND_DATE_YEAR').AsInteger := _GDate.GDate.Year1;

          if s = 'BIRT'
            then TFIndividu(fFormindividu).QueryIndividuANNEE_NAISSANCE.AsInteger := _GDate.GDate.Year1
          else
            if s = 'DEAT'
              then TFIndividu(fFormindividu).QueryIndividuANNEE_DECES.AsInteger := _GDate.GDate.Year1;
        end
      else
        begin
          if Year1 > 0 then TFIndividu(fFormindividu).QueryIndividuANNEE_NAISSANCE.AsInteger := Year1;
          if Year2 > 0 then TFIndividu(fFormindividu).QueryIndividuANNEE_DECES.AsInteger := Year2;
        end;


      //la date entire
      if (_GDate.KnowDate) then
        DataSet.FieldByName('EV_IND_DATE').AsDateTime := _GDate.GDate.DateTime1;
    end;
end;



procedure TFIndividuIdentite.IBQEveAfterScroll(DataSet: TDataSet);
var
  CleEvent: integer;
begin
  if fCanScrollEv then
    begin
      //  panInfoCoutRow.visible := (DataSet.RecordCount > TMydxDBGrid(dxDBGEve).VisibleRowCount);
      panInfoCoutRow.visible := ((DataSet.RecordCount * ((dxDBGEve.RowHeight - 1) * (dxDBGEve.PreviewLines + 1))) > (dxDBGEve.Height));

      CleEvent := GetCleEventSelected;

      if CleEvent <> -1 then
        begin
          aFIndividuEditEventLife.OpenTemoins;
          Caption := AssembleString([TFIndividu(fFormindividu).QueryIndividuNOM.AsString,
            TFIndividu(fFormindividu).QueryIndividuPRENOM.AsString]);

          aFIndividuEditEventLife.doShowDay;
        end;
    end;

  aFIndividuEditEventLife.doRefreshControls;

end;

function TFIndividuIdentite.GetCleEventSelected: integer;
begin
  //on rcupre la clef de de l'evenement slectionn
  result := -1;
  try
    if IBQEve.Active then
      if IBQEve.IsEmpty = false then result := IBQEve.FieldByName('EV_IND_CLEF').AsInteger;
  except
  end;
end;

procedure TFIndividuIdentite.btnRetirerConjointClick(
  Sender: TObject);
var
  aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
  QUpdateTypeUnion: TIBQuery;
begin
  if tv.FocusedNode <> nil then
    begin
      aNode := tv.FocusedNode;
      if (aNode.Data <> nil) and (aNode.Level = 0) then
        begin
          //on rcupre l'objet de stockage de l'individu
          aNodeIndividu := TNodeIndividu(aNode.Data);

          if aNodeIndividu.fCleFiche <> -1 then
            begin
              if MyMessageDlg('Confirmez-vous la suppression de cette union avec : ' +
                aNodeIndividu.fCaption + ' ?',
                mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                begin
                  QUpdateTypeUnion := TIBQuery.create(self);
                  try
                    QUpdateTypeUnion.Database := dm.ibd_BASE;
                    QUpdateTypeUnion.SQL.Add('EXECUTE PROCEDURE PROC_DELETE_UNION(:CLEF)');
                    // QUpdateTypeUnion.SQL.Add('delete from T_UNION where UNION_CLEF=' + inttostr(aNodeIndividu.UnionClef));
                    QUpdateTypeUnion.Params[0].AsInteger := aNodeIndividu.UnionClef;
                    QUpdateTypeUnion.ExecSQL;
                    QUpdateTypeUnion.Close;

                    //on indique qu'on a fait une modification
                    TFIndividu(fFormindividu).Modified := true;
                  finally
                    QUpdateTypeUnion.Free;
                  end;

                  tv.FocusedNode.Free;

                  TFIndividu(fFormindividu).LoadCoherenceDates;
                  TFIndividu(fFormindividu).CoherenceDate.Test;

                  RempliConjoints;
                  RempliEnfants;

                  TFIndividu(fFormindividu).DoRefreshControls;

                  //On rafraichit dans l'onglet Conjoints
                  if TFIndividu(fFormindividu).OngletSesConjointsIsLoaded then
                    begin
                      TFIndividu(fFormindividu).aFIndividuUnion.doOpenQuerys;
                      TFIndividu(fFormindividu).DoRefreshControls;
                    end;
                end;
            end;
        end;
    end;
end;

procedure TFIndividuIdentite.btnAjoutConjointClick(Sender: TObject);
begin
  TFIndividu(fFormindividu).doActiveOnglet(_ONGLET_SES_CONJOINTS);
  TFIndividu(fFormindividu).aFIndividuUnion.bsfbAjoutClick(Self);
end;

procedure TFIndividuIdentite.up_OpenEvent(Sender: TObject);
begin
  if (IBQEve.Active) and (IBQEve.RecordCount > 0) then aFIndividuEditEventLife.Show;
end;

procedure TFIndividuIdentite.IBQEveCalcFields(DataSet: TDataSet);
var
  s, sa, s_Jour: string;
  mDate: TGedcomDate;
const
  marge = '     ';
begin
  IBMultimedia.Params[0].AsInteger := dm.NumDossier;
  IBMultimedia.Params[1].AsInteger := IBQEveEV_IND_CLEF.AsInteger;
  IBMultimedia.Params[2].AsString := 'I';
  IBMultimedia.Open;

  if IBMultimedia.RecordCount > 0 then
    IBQEveQUID_IMAGE.AsInteger := 1;

  IBMultimedia.Close;

  mDate := TgedcomDate.Create;
  try
    mDate.AssignTokens;

    if Length(IBQEveEV_IND_COMMENT.AsString) > 0 then IBQEveQUID_NOTES.AsInteger := 1;
    if Length(IBQEveEV_IND_SOURCE.AsString) > 0 then IBQEveQUID_SOURCES.AsInteger := 1;

    //    Date
    s_Jour := '';
    if mDate.DecodeHumanDate(IBQEveEV_IND_DATE_WRITEN.AsString) then
      begin
        if mDate.KnowDate then s_Jour := LongDayNames[DayOfWeek(mDate.GDate.DateTime1)];
      end;

    if s_Jour <> '' then
      s := s_Jour + ' ' + IBQEveEV_IND_DATE_WRITEN.AsString
    else
      s := IBQEveEV_IND_DATE_WRITEN.AsString;

    if (Length(s) > 0) then s := s + #13#10;

    //Adresse
    if _Context.AfficheInsee then
      sa := AssembleString([IBQEveEV_IND_INSEE.AsString,
        IBQEveEV_IND_VILLE.AsString,
          IBQEveEV_IND_DEPT.AsString,
          IBQEveEV_IND_PAYS.AsString])
    else
      sa := AssembleString([IBQEveEV_IND_CP.AsString,
        IBQEveEV_IND_VILLE.AsString,
          IBQEveEV_IND_DEPT.AsString,
          IBQEveEV_IND_PAYS.AsString]);

    if (Length(sa) <= 0) then
      if (Length(s) <= 0) then
        if length(IBQEveEV_IND_DESCRIPTION.AsString) <= 0 then
          IBQEve_DETAIL.AsString := marge + 'Cet vnement ne contient aucune information !!!!'
        else
          IBQEve_DETAIL.AsString := marge + IBQEveEV_IND_DESCRIPTION.AsString
      else
        begin
          IBQEve_DETAIL.AsString := marge + s + marge; // + IBQEveEV_IND_DESCRIPTION.AsString
          if length(IBQEveEV_IND_DESCRIPTION.AsString) > 0 then
            IBQEve_DETAIL.AsString := marge + IBQEveEV_IND_DESCRIPTION.AsString + #13#10 + IBQEve_DETAIL.AsString;
        end
    else
      begin
        IBQEve_DETAIL.AsString := marge + s + marge + sa;

        if length(IBQEveEV_IND_DESCRIPTION.AsString) > 0 then
          IBQEve_DETAIL.AsString := marge + IBQEveEV_IND_DESCRIPTION.AsString + #13#10 + IBQEve_DETAIL.AsString;
      end;

  finally
    mDate.Free
  end;
end;

procedure TFIndividuIdentite.btnNewEventClick(Sender: TObject);
var
  aFEvenement_Ajout: TFEvenement_Ajout;
begin
  aFEvenement_Ajout := TFEvenement_Ajout.create(self);
  try
    aFEvenement_Ajout.up_Init(TFIndividu(fFormindividu).CleFiche, 'I');
    if aFEvenement_Ajout.ShowModal = mrOk then
      begin
        IBQEve.Insert;
        IBQEve.FieldByName('EV_IND_TYPE').AsString := aFEvenement_Ajout.Ref_Eve_Lib_Court;
        IBQEve.Post;
        TFIndividu(fFormindividu).Modified := true;

        aFIndividuEditEventLife.doRefreshControls;
        aFIndividuEditEventLife.Show;

        SendFocus(aFIndividuEditEventLife.edDate);
      end;

  finally
    aFEvenement_Ajout.Free;
  end;

  TFIndividu(fFormindividu).doRefreshControls;
end;

procedure TFIndividuIdentite.btnDeleteEventClick(Sender: TObject);
var
  s: string;
begin

  s := IBQEve.FieldByName('EV_IND_TYPE').AsString;

  TFIndividu(fFormIndividu).QueryIndividu.edit;

  if s = 'BIRT' then
    begin
      TFIndividu(fFormIndividu).QueryIndividuDATE_NAISSANCE.Clear;
      TFIndividu(fFormIndividu).QueryIndividuANNEE_NAISSANCE.Clear;
    end
  else if s = 'DEAT' then
    begin
      TFIndividu(fFormIndividu).QueryIndividuDATE_DECES.Clear;
      TFIndividu(fFormIndividu).QueryIndividuANNEE_DECES.Clear;
    end;

  IBQEve.delete;
  TFIndividu(fFormindividu).Modified := true;

  if (IBQEve.Active) and (IBQEve.RecordCount = 0) then
    begin
      aFIndividuEditEventLife.Hide;
    end;

  TFIndividu(fFormindividu).doRefreshControls;
end;

procedure TFIndividuIdentite.sDBENomKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  s: string;
  k: integer;
begin
  //     TFIndividu(fFormindividu).TestIfHelp(Key);

  if (Key = _KEY_OPEN_LIST) then TMydxDBPopupEdit(sDBENom).DropDown
  else
    begin
      try
        if dm.EngineRaccourcis_TdxDBPopupEdit2(sDBENom, Key, Shift, s, k) then
          begin
            if not (TFIndividu(fFormindividu).QueryIndividu.state in [dsEdit, dsInsert]) then TFIndividu(fFormindividu).QueryIndividu.Edit;
            TFIndividu(fFormindividu).QueryIndividu.FieldByName('NOM').AsString := ApplyModeSaisie(_Context.ModeSaisieNom, s);
            sDBENom.SelStart := k + 1;
          end;
      except
      end;
    end;
end;

procedure TFIndividuIdentite.sDBEPrenomKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  s: string;
  k: integer;
begin
  //     TFIndividu(fFormindividu).TestIfHelp(Key);

  if (Key = _KEY_OPEN_LIST) then TMydxDBPopupEdit(sDBEPrenom).DropDown
  else
    begin
      try
        if dm.EngineRaccourcis_TdxDBPopupEdit2(sDBEPrenom, Key, Shift, s, k) then
          begin
            if not (TFIndividu(fFormindividu).QueryIndividu.state in [dsEdit, dsInsert]) then TFIndividu(fFormindividu).QueryIndividu.Edit;
            TFIndividu(fFormindividu).QueryIndividu.FieldByName('PRENOM').AsString := ApplyModeSaisie(_Context.ModeSaisiePrenom, s);
            sDBEPrenom.SelStart := k + 1;
          end;
      except
      end;
    end;
end;

procedure TFIndividuIdentite.mOuvrirEnfantClick(Sender: TObject);
begin
  TFIndividu(fFormindividu).ChangeFicheActive(IBEnfantsCLE_FICHE.AsInteger);
end;


{ TMydxDBPopupEdit }

procedure TMydxDBPopupEdit.DropDown;
begin
  inherited;
end;

procedure TFIndividuIdentite.dxDBGrid1KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then (GetParentForm(dxDBGrid1) as TdxPopupEditForm).ClosePopup(True)
  else
    if (Key = VK_RETURN) then dxDBGrid1DblClick(Sender);
end;

procedure TFIndividuIdentite.dxDBGrid2KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then (GetParentForm(dxDBGrid2) as TdxPopupEditForm).ClosePopup(True)
  else
    if (Key = VK_RETURN) then dxDBGrid2DblClick(Sender);
end;

procedure TFIndividuIdentite.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  //     if key = _KEY_HELP then dm.ShowHelp(_HELP_INDI_IDENTITE);
end;

procedure TFIndividuIdentite.edCiviliteKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  //     TFIndividu(fFormindividu).TestIfHelp(Key);
end;

procedure TFIndividuIdentite.tvCustomDrawCell(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
  AColumn: TdxTreeListColumn; ASelected, AFocused, ANewItemRow: Boolean;
  var AText: string; var AColor: TColor; AFont: TFont;
  var AAlignment: TAlignment; var ADone: Boolean);
begin
  if ASelected then AColor := tv.HighlightColor else AColor := $00DAF0F8;

  if (ANode = CurNodeC) and (AColumn = CurColumnC) then
    begin
      AFont.Style := [fsUnderline];

    end
  else
    begin
      AFont.Style := [];
    end;

  case TNodeIndividu(aNode.data).Sexe of
    1: aFont.Color := _Context.ColorHomme;
    2: aFont.Color := _Context.ColorFemme;
    else
      aFont.Color := clBlack
  end;

  if TNodeIndividu(aNode.data).Sosa > 0 then
    begin
      AFont.Color := _COLOR_SOSA;
    end;
end;

procedure TFIndividuIdentite.tvMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  ARect: TRect;
  AColumn: TdxTreeListColumn;
  ANode: TdxTreeListNode;
begin
  ANode := tv.GetNodeAt(X, Y);
  AColumn := tv.GetColumnAt(X, Y);

  if (ANode <> nil) and (AColumn <> nil) then
    begin
      ARect := tv.GetEditRect(ANode, AColumn.Index);
      if PtInRect(ARect, Point(X, Y)) then
        begin
          tv.Cursor := crHandPoint;
          CurNodeC := ANode;
          CurColumnC := AColumn;
          tv.Invalidate;
        end
      else
        begin
          tv.Cursor := crDefault;
          if (CurNodeC <> nil) or (CurColumnC <> nil) then
            begin
              CurNodeC := nil;
              CurColumnC := nil;
              tv.Invalidate;
            end;

        end;
    end
  else
    begin
      tv.Cursor := crDefault;
      if (CurNodeC <> nil) or (CurColumnC <> nil) then
        begin
          CurNodeC := nil;
          CurColumnC := nil;
          tv.Invalidate;
        end;
    end;
end;


procedure TFIndividuIdentite.tvClick(Sender: TObject);
var
  aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
begin
  if (Tv.FocusedNode <> nil) and (Tv.FocusedNode.Data <> nil) and (Tv.FocusedNode.Level >= 0) then
    begin
      if Tv.FocusedNode <> nil then
        begin
          aNode := Tv.FocusedNode;
          //Soit on a cliqu sur l'image des enfants
          if (CurColumnC = tvColumnEnfants) and (aNode.Level = 0) then
            begin
              fFill := true;
              try
                chbTous.checked := false;
                RempliEnfants;
                doRefreshControls;
              finally
                fFill := false;
              end;
            end
          else
            begin
              if (aNode.Data <> nil) and (aNode.Level >= 0) then
                begin
                  //on rcupre l'objet de stockage de l'individu
                  aNodeIndividu := TNodeIndividu(aNode.Data);

                  TFIndividu(fFormindividu).ChangeFicheActive(aNodeIndividu.CleFiche);
                end;
            end;
        end;
    end;
end;

procedure TFIndividuIdentite.SetColorFromContext;
begin
  lbNomPere.Font.Color := _Context.ColorHomme;
  lbNomPere.FocusFont.Color := _Context.ColorHomme;
  lbNomMere.Font.Color := _Context.ColorFemme;
  lbNomMere.FocusFont.Color := _Context.ColorFemme;

  tv.Refresh;
  tvEnfants.Refresh;
end;

procedure TFIndividuIdentite.tvEnfantsDeletion(Sender: TObject;
  Node: TdxTreeListNode);
begin
  if Node.data <> nil then
    begin
      TNodeIndividu(Node.data).free;
      Node.data := nil;
    end;
end;

procedure TFIndividuIdentite.tvEnfantsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  ARect: TRect;
  AColumn: TdxTreeListColumn;
  ANode: TdxTreeListNode;
begin
  ANode := tvEnfants.GetNodeAt(X, Y);
  AColumn := tvEnfants.GetColumnAt(X, Y);

  if (ANode <> nil) and (AColumn <> nil) then
    begin
      ARect := tvEnfants.GetEditRect(ANode, AColumn.Index);
      if PtInRect(ARect, Point(X, Y)) then
        begin
          tvEnfants.Cursor := crHandPoint;
          CurNodeE := ANode;
          CurColumnE := AColumn;
          tvEnfants.Invalidate;
        end
      else
        begin
          tvEnfants.Cursor := crDefault;
          if (CurNodeE <> nil) or (CurColumnE <> nil) then
            begin
              CurNodeE := nil;
              CurColumnE := nil;
              tvEnfants.Invalidate;
            end;

        end;
    end
  else
    begin
      tvEnfants.Cursor := crDefault;
      if (CurNodeE <> nil) or (CurColumnE <> nil) then
        begin
          CurNodeE := nil;
          CurColumnE := nil;
          tvEnfants.Invalidate;
        end;
    end;
end;

procedure TFIndividuIdentite.tvEnfantsCustomDrawCell(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
  AColumn: TdxTreeListColumn; ASelected, AFocused, ANewItemRow: Boolean;
  var AText: string; var AColor: TColor; AFont: TFont;
  var AAlignment: TAlignment; var ADone: Boolean);
begin
  if ASelected then AColor := tvEnfants.HighlightColor else AColor := $00DAF0F8;

  if (ANode = CurNodeE) and (AColumn = CurColumnE) then
    begin
      AFont.Style := [fsUnderline];

    end
  else
    begin
      AFont.Style := [];
    end;

  case TNodeIndividu(aNode.data).Sexe of
    1: aFont.Color := _Context.ColorHomme;
    2: aFont.Color := _Context.ColorFemme;
    else
      aFont.Color := clBlack
  end;

  if TNodeIndividu(aNode.data).Sosa > 0 then
    begin
      AFont.Color := _COLOR_SOSA;
    end;
end;

procedure TFIndividuIdentite.tvEnfantsClick(Sender: TObject);
var
  aNodeIndividu: TNodeIndividu;
  aNode: TdxTreeListNode;
begin
  if (tvEnfants.FocusedNode <> nil) and (tvEnfants.FocusedNode.Data <> nil) and (tvEnfants.FocusedNode.Level >= 0) then
    begin
      if tvEnfants.FocusedNode <> nil then
        begin
          aNode := tvEnfants.FocusedNode;
          if (aNode.Data <> nil) and (aNode.Level >= 0) then
            begin
              //on rcupre l'objet de stockage de l'individu
              aNodeIndividu := TNodeIndividu(aNode.Data);

              TFIndividu(fFormindividu).ChangeFicheActive(aNodeIndividu.CleFiche);
            end;
        end;
    end;
end;

procedure TFIndividuIdentite.PCM_TDBJPEGImage1GetGraphicClass(
  Sender: TObject; var GraphicClass: TGraphicClass);
begin
  GraphicClass := tjpegimage;
end;

procedure TFIndividuIdentite.dxDBGraphicEdit1GetGraphicClass(
  Sender: TObject; var GraphicClass: TGraphicClass);
begin
  GraphicClass := tjpegimage;
end;

procedure TFIndividuIdentite.pIdentiteCompleteClick(Sender: TObject);
begin
  if (TFIndividu(fFormindividu).DialogMode = false) then
    begin
      pIdentiteReduite.Show;
      pIdentiteComplete.Hide;
    end;
end;

procedure TFIndividuIdentite.sDBEPrenomExit(Sender: TObject);
begin
  if DataSourceIndividu.State in [dsEdit, dsInsert] then
    TFIndividu(fFormindividu).QueryIndividuPRENOM.AsString := doFormatePrenoms(sDBEPrenom.Text)
end;

procedure TFIndividuIdentite.btnCartoClick(Sender: TObject);
var aFCartoGraphie: TFCartoGraphie;
begin
  aFCartoGraphie := TFCartoGraphie.create(self);
  try
    aFCartoGraphie.Caption := 'Points de repre de : ' + lTitre.Caption;
    aFCartoGraphie.ShowModal;
  finally
    aFCartoGraphie.Free;
  end;
end;

procedure TFIndividuIdentite.mtriClick(Sender: TObject);
var aFTriEvent: TFTriEvent;
begin
  aFTriEvent := TFTriEvent.create(self);
  try
    aFTriEvent.doInit(TFIndividu(fFormindividu).CleFiche);
    aFTriEvent.ShowModal;
  finally
    if aFTriEvent.Modif then
      begin
        IBQEve.Close;
        IBQEve.Open;

        TFIndividu(FormIndividu).Modified := True;
        TFIndividu(FormIndividu).DoRefreshControls;
      end;

    aFTriEvent.Free;
  end;

end;

end.

