{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_photos_et_docs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, Grids, DBGrids, JPeg, dxExEdtr, IBStoredProc,
  Menus, IBCustomDataSet, IBUpdateSQL, DB, IBQuery, StdCtrls, ComCtrls,
  DBCtrls, dxCntner, dxEdLib, dxDBELib, MPlayer, TFlatPanelUnit, dxDBTLCl,
  dxGrClms, dxGrClEx, dxTL, dxDBCtrl, dxDBGrid,
  u_comp_TYLanguage,
  u_objet_TState,
  u_comp_TGoodBtn;

type
  TydxDBGraphicEdit = class(TdxDBGraphicEdit)
  public
    property AutoSize;
    property Center;
  end;


  TFIndividuPhotosEtDocs = class(TSuperForm)
    DSMultimedia: TDataSource;
    IBMultimedia: TIBQuery;
    IBUMultimedia: TIBUpdateSQL;
    Panel10: TPanel;
    Panel13: TPanel;
    lNom: TLabel;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_INDIVIDU: TIntegerField;
    IBMultimediaMULTI_INFOS: TIBStringField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    IBMultimediaMULTI_DATE_MODIF: TDateTimeField;
    IBMultimediaMULTI_MEMO: TMemoField;
    PopupPhoto: TPopupMenu;
    PopupPhotoRadio_Charger: TMenuItem;
    N1: TMenuItem;
    N8: TMenuItem;
    PopupPhotoRadio_Stretch: TMenuItem;
    N12: TMenuItem;
    PopupPhotoRadio_Enlever: TMenuItem;
    IBMultimediablobsize: TStringField;
    N2: TMenuItem;
    PopupPhoto_SetIdentite: TMenuItem;
    IBStoredProcIdentite: TIBStoredProc;
    Label8: TLabel;
    IBMultimediaMULTI_DOSSIER: TIntegerField;
    IBMultimediaMULTI_STRETCH: TIntegerField;
    IBMultimediaMULTI_IDENTITE: TIntegerField;
    IBMultimediaMULTI_TYPE: TIBStringField;
    pTypeImage: TPanel;
    rgTypeImage: TRadioGroup;
    PopupPhoto_Enregistrer: TMenuItem;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    btnAjout: TGoodBtn;
    IBMultimediaMULTI_REDUITE: TBlobField;
    N3: TMenuItem;
    PopupPhoto_Editer: TMenuItem;
    IBMultimediaMULTI_DEVISE: TBlobField;
    IBMultimediaMULTI_CRI: TBlobField;
    IBMultimediaMULTI_DOCRTF: TBlobField;
    IBMultimediaMULTI_IMAGE_RTF: TIntegerField;
    pmRTF: TPopupMenu;
    mPrint: TMenuItem;
    mChargeTexte: TMenuItem;
    N4: TMenuItem;
    IBMultimediaMULTI_NUM_ACTE: TIntegerField;
    IBMultimediaMULTI_TYPE_ACTE: TIBStringField;
    IBMultimediaMULTI_SONS_VIDEOS: TBlobField;
    IBMultimediaMULTI_PATH: TIBStringField;
    IBMultimediaMULTI_NOM: TIBStringField;
    dxDBGrid: TdxDBGrid;
    colMemo: TdxDBGridMemoColumn;
    colDate: TdxDBGridColumn;
    colInfos: TdxDBGridColumn;
    colCri: TdxDBGridMemoColumn;
    colDevise: TdxDBGridMemoColumn;
    colIdent: TdxDBGridImageColumn;
    colType: TdxDBGridPopupColumn;
    colImage: TdxDBGridGraphicColumn;
    fp1: TFlatPanel;
    MediaPlayer: TMediaPlayer;
    pPhoto: TFlatPanel;
    Image1: TImage;
    FlatPanel1: TFlatPanel;
    DBGraphic: TdxDBGraphicEdit;
    pTexte: TFlatPanel;
    iTexte: TImage;
    dbRe: TDBRichEdit;
    IBMultimediaMP_IDENTITE: TIntegerField;
    IBMultimediaMP_CLEF: TIntegerField;
    IBQDelPointeur: TIBQuery;
    btnDel: TGoodBtn;
    procedure btnAjoutClick(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure IBMultimediaCalcFields(DataSet: TDataSet);
    procedure IBMultimediaAfterScroll(DataSet: TDataSet);
    procedure PopupPhoto_SetIdentiteClick(Sender: TObject);
    procedure rgTypeImageClick(Sender: TObject);
    procedure gridListDocsColumn5InitPopup(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure mPrintClick(Sender: TObject);
    procedure pmRTFPopup(Sender: TObject);
    procedure MediaPlayerClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure colTypeInitPopup(Sender: TObject);
    procedure colImageGetGraphicClass(Sender: TObject;
      Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
    procedure DBGraphicGetGraphicClass(Sender: TObject;
      var GraphicClass: TGraphicClass);
    procedure DSMultimediaStateChange(Sender: TObject);
    procedure PopupPhoto_EnregistrerClick(Sender: TObject);
    procedure PopupPhotoPopup(Sender: TObject);
    procedure PopupPhoto_EditerClick(Sender: TObject);
  private
    fFill: TState;
    fFormIndividu: TForm;
    //iType: Integer;
    sTempWavAvi: string;

    procedure SetFormIndividu(const Value: TForm);


  public
    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;

    procedure doInitialize;
    function doOpenQuerys: boolean;

  end;

implementation

uses u_dm, u_form_main, u_form_individu, u_common_var, u_common_func, clipbrd,
  u_common_const, u_form_biblio_Multimedia_Edit, u_Form_Bibliotheque_Multimedia;

{$R *.DFM}

procedure TFIndividuPhotosEtDocs.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;
end;
//-- Gestion de la fenetre ------------------------------------------------------------------------------

procedure TFIndividuPhotosEtDocs.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  pPhoto.Align := AlClient;
  pTexte.Align := AlClient;

  fFill := TState.create(false);

  fFormIndividu := nil;

end;

procedure TFIndividuPhotosEtDocs.SuperFormDestroy(Sender: TObject);
begin
  fFill.free;
end;

procedure TFIndividuPhotosEtDocs.SuperFormRefreshControls(Sender: TObject);
begin
  DBGraphic.visible := ((TFIndividu(fFormindividu).CleFiche <> -1) and (IBMultimedia.Active) and (IBMultimedia.IsEmpty = false));
  DBGraphic.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (IBMultimedia.Active) and (TFIndividu(fFormindividu).DialogMode = false);
  DBGraphic.enabled := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);

  DSMultimedia.AutoEdit := (TFIndividu(fFormindividu).DialogMode = false);
end;
//-------------------------------------------------------------------------------------------------------
// -- Gestion des JPEG ----------------------------------------------------------------------------------

procedure TFIndividuPhotosEtDocs.colImageGetGraphicClass(Sender: TObject;
  Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
begin
  GraphicClass := TJPEGImage;
end;

procedure TFIndividuPhotosEtDocs.DBGraphicGetGraphicClass(Sender: TObject;
  var GraphicClass: TGraphicClass);
begin
  GraphicClass := TJPEGImage;
end;
//-------------------------------------------------------------------------------------------------------

// -- Initialisation des querys -------------------------------------------------------------------------

procedure TFIndividuPhotosEtDocs.doInitialize;
begin
  IBMultimedia.Close;
end;

function TFIndividuPhotosEtDocs.doOpenQuerys: boolean;
begin
  IBMultimedia.DisableControls;
  try
    IBMultimedia.Close;
    IBMultimedia.Params[0].AsInteger := TFIndividu(fFormindividu).CleFiche; {Cle de l'individu}
    IBMultimedia.Open;
    // IBMultimedia.Last;
    // IBMultimedia.First;
    // IBMultimedia.Locate('MULTI_IDENTITE', 1, [loPartialKey]);

  finally
    IBMultimedia.EnableControls;
  end;

  result := true;
end;
//-------------------------------------------------------------------------------------------------------
// -- Gestion des querys --------------------------------------------------------------------------------

procedure TFIndividuPhotosEtDocs.IBMultimediaCalcFields(DataSet: TDataSet);
//var
//  k: integer;
//  s: string;
begin
  {
    k := TBlobField(DataSet.FieldByName('MULTI_MEDIA')).BlobSize;
    if k < 1024
      then s := inttostr(k) + ' oct.'
    else s := inttostr(k div 1024) + ' ko';
    IBMultimediablobsize.AsString := s;
   }
end;

procedure TFIndividuPhotosEtDocs.IBMultimediaAfterScroll(
  DataSet: TDataSet);

begin
  IBMultimedia.DisableControls;
  MediaPlayer.Close;
  MediaPlayer.Visible := False;
  DBGraphic.Hint := IBMultimediaMULTI_INFOS.AsString;

  pPhoto.Visible := IBMultimediaMULTI_IMAGE_RTF.AsInteger = 0;
  pTexte.Visible := IBMultimediaMULTI_IMAGE_RTF.AsInteger = 1;
  MediaPlayer.Visible := IBMultimediaMULTI_IMAGE_RTF.AsInteger >= 2;

  if MediaPlayer.Visible then
    begin
      if IBMultimediaMULTI_IMAGE_RTF.AsInteger = 2 then
        MediaPlayer.DeviceType := dtWaveAudio
      else
        MediaPlayer.DeviceType := dtAviVideo;

      MediaPlayer.Open;
    end
  else
    MediaPlayer.Close;

  IBMultimedia.EnableControls;
end;

procedure TFIndividuPhotosEtDocs.rgTypeImageClick(Sender: TObject);
begin
  if fFill.Value = false then
    begin
      fFill.Value := true;
      try
        IBMultimedia.Edit;

        case rgTypeImage.ItemIndex of
          0: IBMultimediaMULTI_TYPE.AsString := 'P';
          1: IBMultimediaMULTI_TYPE.AsString := 'F';
          2: IBMultimediaMULTI_TYPE.AsString := 'I';
        end;

        TFIndividu(FormIndividu).Modified := true;

        TFIndividu(FormIndividu).DoRefreshControls;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFIndividuPhotosEtDocs.gridListDocsColumn5InitPopup(
  Sender: TObject);
begin
  fFill.Value := true;
  try
    if IBMultimedia.FieldByName('MULTI_TYPE').AsString = 'P' then
      rgTypeImage.ItemIndex := 0
    else if IBMultimedia.FieldByName('MULTI_TYPE').AsString = 'F' then
      rgTypeImage.ItemIndex := 1
    else if IBMultimedia.FieldByName('MULTI_TYPE').AsString = 'I' then
      rgTypeImage.ItemIndex := 2;
  finally
    fFill.Value := false;
  end;
end;

procedure TFIndividuPhotosEtDocs.DSMultimediaStateChange(Sender: TObject);
begin
  TFIndividu(FormIndividu).DoRefreshControls;
end;
//-------------------------------------------------------------------------------------------------------
// -- gestion des medias --------------------------------------------------------------------------------

procedure TFIndividuPhotosEtDocs.MediaPlayerClick(Sender: TObject;
  Button: TMPBtnType; var DoDefault: Boolean);
var MS: TMemoryStream;
  iMode: Integer;
  bJoue: Boolean;
begin
  bJoue := False;
  case Button of
    btPlay:
      with MediaPlayer do
        begin
          Filename := '';
          //Close;

          iMode := IBMultimediaMULTI_IMAGE_RTF.AsInteger;
          DeviceType := dtAutoSelect;

          if iMode = 2 then
            sTempWavAvi := TempPath + IBMultimediaMULTI_NOM.AsString + '.WAV'
          else if iMode = 3 then
            begin
              sTempWavAvi := TempPath + IBMultimediaMULTI_NOM.AsString + '.AVI';
              MediaPlayer.Display := nil
            end;

          if ((_Context.SonsBase = 1) and (iMode = 2)) or ((_Context.VideosBase = 1) and (iMode = 3)) then
            begin
              MS := TMemoryStream.Create;
              try

                IBMultimediaMULTI_SONS_VIDEOS.SaveToStream(MS);
                MS.Position := 0;

                if not FileExists(sTempWavAvi) then
                  MS.SaveToFile(sTempWavAvi);
                bJoue := True;
              finally
                FreeAndNil(MS);
              end;
            end
          else
            if FileExists(IBMultimediaMULTI_PATH.AsString) then
              begin
                sTempWavAvi := IBMultimediaMULTI_PATH.AsString;
                bJoue := True;
              end
            else
              MyMessageDlg('Le fichier que vous essayez de jouer, n''existe plus  l''endroit spcifi...',
                mtInformation, [mbOK], 0);

          if bJoue then
            begin
              Filename := sTempWavAvi;
              Open;
              visible := True;
            end;

        end;
    btStop:
      begin
        MediaPlayer.close;
        Application.ProcessMessages;
        {
        if FileExists(TempPath + IBMultimediaMULTI_NOM.AsString + '.WAV') then
          DeleteFile(TempPath + IBMultimediaMULTI_NOM.AsString + '.WAV');
        }
        sTempWavAvi := '';
        MediaPlayer.Open;
      end;
  end;
end;
//-------------------------------------------------------------------------------------------------------
// -- gestion du pop up menu ----------------------------------------------------------------------------

procedure TFIndividuPhotosEtDocs.PopupPhoto_EnregistrerClick(
  Sender: TObject);
begin
  DBGraphic.SaveToFile;
end;

procedure TFIndividuPhotosEtDocs.PopupPhotoPopup(Sender: TObject);
var
  ok: boolean;
  //clp: boolean;
begin
  ok := (IBMultimedia.Active);
  // clp := (Clipboard.HasFormat(CF_PICTURE)) or (Clipboard.HasFormat(CF_METAFILEPICT)) or (Clipboard.HasFormat(CF_BITMAP));

  PopupPhoto_Enregistrer.enabled := ok and (IBMultimedia.IsEmpty = false) and (IBMultimedia.FieldByName('MULTI_MEDIA').IsNull = false);
  PopupPhotoRadio_Charger.enabled := ok and (IBMultimedia.IsEmpty = false);
  PopupPhoto_SetIdentite.enabled := ok and (IBMultimedia.IsEmpty = false) and (IBMultimedia.FieldByName('MULTI_MEDIA').IsNull = false);
  PopupPhoto_Editer.enabled := ok and (IBMultimedia.IsEmpty = false) and (IBMultimedia.FieldByName('MULTI_MEDIA').IsNull = false);
end;

procedure TFIndividuPhotosEtDocs.colTypeInitPopup(Sender: TObject);
begin
  fFill.Value := true;
  try
    if IBMultimedia.FieldByName('MULTI_TYPE').AsString = 'P' then
      rgTypeImage.ItemIndex := 0
    else if IBMultimedia.FieldByName('MULTI_TYPE').AsString = 'F' then
      rgTypeImage.ItemIndex := 1
    else if IBMultimedia.FieldByName('MULTI_TYPE').AsString = 'I' then
      rgTypeImage.ItemIndex := 2;
  finally
    fFill.Value := false;
  end;
end;

procedure TFIndividuPhotosEtDocs.PopupPhoto_SetIdentiteClick(Sender: TObject);
var SavePlace: TBookmark;
begin
  IBMultimedia.DisableControls;
  SavePlace := IBMultimedia.GetBookmark;
  //on post l'enregistrement en cours, si il est en dition
  if (IBMultimedia.State in [dsEdit, dsInsert]) then IBMultimedia.Post;

  //on indique quelle photo correspond  la vignette dans l'identit
  IBStoredProcIdentite.Close;
  IBStoredProcIdentite.Params[0].AsInteger := IBMultimedia.FieldByName('MULTI_CLEF').AsInteger;
  IBStoredProcIdentite.Params[1].AsInteger := dm.FicheActive;
  IBStoredProcIdentite.Params[2].AsInteger := dm.NumDossier;

  IBStoredProcIdentite.Prepare;
  IBStoredProcIdentite.ExecProc;
  IBStoredProcIdentite.Close;

  //rafraichissement
  IBMultimedia.Close;
  IBMultimedia.Open;

  IBMultimedia.GotoBookmark(SavePlace);

  TFIndividu(fFormindividu).Modified := true;
  TFIndividu(fFormindividu).dorefreshControls;
  TFIndividu(fFormindividu).RefreshPhoto;

  IBMultimedia.EnableControls;
end;

procedure TFIndividuPhotosEtDocs.mPrintClick(Sender: TObject);
begin
  dbRe.Print(IBMultimediaMULTI_INFOS.AsString);
end;

procedure TFIndividuPhotosEtDocs.pmRTFPopup(Sender: TObject);
var
  ok: boolean;
begin
  ok := (IBMultimedia.Active);
  mPrint.enabled := ok and (IBMultimedia.IsEmpty = false) and (IBMultimedia.FieldByName('MULTI_DOCRTF').IsNull = false);
  // mChargeTexte.Enabled :=   mPrint.enabled;
end;

procedure TFIndividuPhotosEtDocs.PopupPhoto_EditerClick(Sender: TObject);
var
  aFMultimediEdit: TFBiblio_Multimedia_Edit;
begin
  aFMultimediEdit := TFBiblio_Multimedia_Edit.create(self);
  try

    aFMultimediEdit.doInitialise(IBMultimediaMULTI_CLEF.AsInteger, lNom.Caption);

    Application.ProcessMessages;
    aFMultimediEdit.ShowModal;
  finally
    aFMultimediEdit.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------
// -- gestion des boutons -------------------------------------------------------------------------------

procedure TFIndividuPhotosEtDocs.btnDelClick(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la suppression de ce document ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      IBMultimedia.DisableControls;
      //IBMultimedia.Delete;

      IBQDelPointeur.Close;
      IBQDelPointeur.params[0].AsInteger := IBMultimediaMP_CLEF.AsInteger;
      IBQDelPointeur.ExecSQL;
      IBQDelPointeur.Close;

      TFIndividu(fFormindividu).Modified := true;
      TFIndividu(FormIndividu).DoRefreshControls;
      TFIndividu(fFormindividu).RefreshPhoto;

      IBMultimedia.Close;
      IBMultimedia.Open;
      IBMultimedia.EnableControls;
    end;
  Application.ProcessMessages;
  doRefreshControls;
end;

procedure TFIndividuPhotosEtDocs.btnAjoutClick(Sender: TObject);
var aFBibliothequeMultimedia: TFBibliothequeMultimedia;
begin

  if MediaPlayer.DeviceID <> 0 then
    begin
      MediaPlayer.Stop;
      MediaPlayer.Close;
    end;

  aFBibliothequeMultimedia := TFBibliothequeMultimedia.create(self);
  try

    aFBibliothequeMultimedia.doInit(True, dm.FicheActive, 'I', 'I');
    aFBibliothequeMultimedia.ShowModal;

    IBMultimedia.DisableControls;

    if aFBibliothequeMultimedia.Clef > 0 then
      begin
        TFIndividu(fFormindividu).Modified := true;
        TFIndividu(FormIndividu).DoRefreshControls;
      end;


    IBMultimedia.Close;
    IBMultimedia.Open;
    IBMultimedia.EnableControls;

  finally
    aFBibliothequeMultimedia.Free;
  end;
  Application.ProcessMessages;
end;
//-------------------------------------------------------------------------------------------------------

end.
