unit U_Microsoft_Agent;

interface

uses Types, SysUtils, Forms, AgentObjects_TLB;

type
  TMSAgent = class
  private
    MSAgent: TAgent;
    bAgent: boolean;
  public
    sAgent: string;
     bAgentShow: boolean;

    procedure doAgent(sAgent, sTexte: string; LeftPos, TopPos: Integer);

    procedure doCreate(bLoadAgent: Boolean);
    procedure doDestroy;
  end;

implementation

uses u_form_main, u_common_func, u_common_var;

var
  Character: IAgentCtlCharacterEx;
  //  Personnage: IAgentCtlCharacterEx;
  FRequest: IAgentCtlRequest;

procedure TMSAgent.doCreate(bLoadAgent: Boolean);
begin

  if bLoadAgent then
    begin
      FRequest := nil;

      sAgent := _Context.NomAgent;
      if Length(sAgent) <= 0 then sAgent := 'Merlin';

      if FileExists(GetWindowsDir + '\msagent\chars\' + sAgent + '.acs') then
        begin

          try
            begin
              MSAgent := TAgent.Create(Application);
              bAgent := true;
            end
          except
            bAgent := false;
          end;

          if bAgent then
            begin
              MSAgent.Connected := True;
              MSAgent.Characters.Load(sAgent, sAgent + '.acs');
              Character := MSAgent.Characters.Character(sAgent);
              Character.AutoPopupMenu := False;
              Character.LanguageID := $409; // Choix du langage
            end;
        end;
    end;
end;

procedure TMSAgent.doDestroy;
begin
  if bAgent then
    begin
      Character.Hide(0);

      doAgent('Hide', '', 0, 0);

      MSAgent.Characters.Unload(sAgent);
      MSAgent.Connected := False;

      FRequest := nil;
      bAgent := False;
      FreeAndNil(MSAgent);

      Application.ProcessMessages;
    end;

end;

procedure TMSAgent.doAgent(sAgent, sTexte: string; LeftPos, TopPos: Integer);
var
  bMove: boolean;
begin

  if bAgent then
    begin
      bMove := (TopPos + LeftPos) > 0;

      if Length(sAgent) = 0 then sAgent := 'Announce';

      if FRequest <> nil
        then Character.Stop(FRequest);

      if sAgent = 'Hide' then
        begin
          if bAgentShow then
            begin
              if Length(sTexte) > 0 then Character.Speak(sTexte, '');
              Character.Hide(0);
              bAgentShow := False;
            end;
        end
      else
        begin
          if bMove then
            begin
              Character.Show(0);
              bAgentShow := True;

              try
                character.MoveTo(LeftPos, TopPos, 10);
                FRequest := character.Play(sAgent);
                if Length(sTexte) > 0 then Character.Speak(sTexte, '');
              except
              end;

            end
          else
            begin
              Character.Show(0);
              bAgentShow := True;

              try
                FRequest := character.Play(sAgent);
                if Length(sTexte) > 0 then Character.Speak(sTexte, '');
              except
              end;
            end;
        end;

      Application.ProcessMessages;
    end;
end;


end.

