{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_common_const;

interface

uses
  Controls, Graphics, windows;

const
  //Version du programme : doit tre la mme dans la base de donne
  //voir PROC_GET_VERSION_DATABASE
     //	_VERSION_ANCESTROLOGIE = '2001.0.2.0';


      //Les curseurs
  _CURPOPUP = 5;
  _CURHAND = 6;
  _CURSOR_ZOOM_MOINS = 6;
  _CURSOR_ZOOM_PLUS = 7;
  _CURSOR_MAIN = 8;
  _CURSOR_SELECT = crDefault;

  _KEY_HELP = VK_F1;
  _KEY_OPEN_LIST = VK_F4;


  //Les modules
  _ID_INDIVIDU = 1;
  _ID_REPERTOIRE = 2;
  _ID_ARBRE = 3;
  _ID_RECHERCHER = 4;
  _ID_ANNIVERSAIRE = 5;
  _ID_VILLES = 6;
  _ID_ASSISTANT_CONFIG = 8;
  _ID_QUI_SUIS_JE = 9;
  _ID_IMPORTATION_GEDCOM = 10;
  _ID_EXPORTATION_GEDCOM = 11;
  _ID_EXPORTATION_GENEANET = 12;
  _ID_INDIVIDU_PAR_PRENOM = 20;
  _ID_PARAMETRES = 98;
  _ID_QUITTER = 99;
  _ID_DOSSIER = 30;
  _ID_NO_DOSSIER = 92;
  _ID_PRINT_ARBRE = 31;
  _ID_PRINT_ROUE = 32;
  _ID_PRINT = 33;
  _ID_POSTIT = 34;
  _ID_EDIT_TABLE_REF_PARTICULES = 35;
  _ID_EDIT_TABLE_REF_PREFIXES = 36;
  _ID_EDIT_TABLE_REF_RELIGIONS = 37;
  _ID_EDIT_RACCOURCIS_SAISIE = 38;
  _ID_CONNECTOR = 39;
  _ID_EMPLACEMENT_BDD = 40;
  _ID_RESTORE_BDD = 42;
  _ID_WEB = 43;
  _ID_EDIT_TOKEN_DATE = 44;
  _ID_SAISIE_RAPIDE = 45;
  _ID_INFOS_DOSSIER = 46;
  _ID_NOUVEAUX_INDI = 47;
  _ID_NAVIGATEUR_INDI = 48;
  _ID_LANGUAGE = 49;
  _ID_PARTENAIRES = 50;
  _ID_OPENSOURCES = 65;
  _ID_NAISSVILLES = 66;
  _ID_VILLES_FAVORIS = 70;


  _HELP_BIEVENUE = 1000;
  _HELP_INDI_IDENTITE = 1001;
  _HELP_INDI_UNIONS = 1002;
  _HELP_INDI_ARBRE = 1003;
  _HELP_INDI_PHOTO_DOC = 1004;
  _HELP_INDI_INFOS = 1005;
  _HELP_INDI_DOMICILES = 1006;
  _HELP_INDI_START = 1007;
  _HELP_FAVORIS = 1008;
  _HELP_PB_BDD = 1009;

  //les noms des rpertoire par dfaut
  _REL_PATH_DATABASE = 'Database\';
  _REL_PATH_IMPORT_EXPORT = 'ImportExport\';
  _REL_PATH_DOC = 'Documents\';
  _REL_PATH_IMAGE = 'Images\';
  _REL_PATH_BACKUP = 'Backup\';
  _REL_PATH_REPORT = 'Reports\';
  _REL_PATH_HELP = 'Help\';
  _REL_PATH_TRADUCTIONS = 'Traductions\';
  _REL_PATH_GOODIES = 'Goodies\';
  _REL_PATH_PLUGINS = 'PlugIns\';

  _EXT_TRADUC = '.traduc';

  _MAX_REP_PATH = 28;

  _REP_ASCENDANCE_COMPLET = 0;
  _REP_ASCENDANCE_PAR_HOMMES = 1;
  _REP_ASCENDANCE_PAR_FEMMES = 2;

  _REP_DESCENDANCE_COMPLET = 3;
  _REP_DESCENDANCE_PATRONYMIQUE = 4;

  _REP_LISTE_ALPHA_TOUS = 15;
  _REP_LISTE_ALPHA_HOMME = 16;
  _REP_LISTE_ALPHA_FEMME = 17;

  _REP_LISTE_DIVERS_UNION = 18;
  _REP_LISTE_DIVERS_ECLAIR = 19;
  _REP_LISTE_DIVERS_EVENEMENT = 20;
  _REP_LISTE_DIVERS_ANNIVERSAIRE = 21;

  _REP_LISTE_DIVERS_ENFANTS = 27;
  _REP_LISTE_DIVERS_FRATRIE = 25;
  _REP_LISTE_DIVERS_ONCLES_TANTES = 26;
  _REP_LISTE_DIVERS_COUSINAGE = 22;

  _REP_FICHE_INDIVIDUELLE = 23;
  _REP_FICHE_FAMILIALE = 24;

  _REP_STAT_GRAPH_NAISS_DEPT = 28;

  _REP_STAT_PATRONYME = 5;
  _REP_STAT_PRENOM = 6;
  _REP_STAT_AGE_PREMIERE_UNION = 9;
  _REP_STAT_LONGEVITE = 10;
  _REP_STAT_NB_ENFANT_UNION = 11;
  _REP_STAT_RECENSEMENT = 12;
  _REP_STAT_DENOMBREMENT_ASCENDANCE = 13;
  _REP_STAT_DENOMBREMENT_DESCENDANCE = 14;


  //mode menu
  _SHOW_MENU_PRINCIPAL = 1;
  _SHOW_MENU_GRAPH = 2;

  _COLOR_SOSA = clGreen;

var
  _REP_PATH_REPORT: array[0.._MAX_REP_PATH] of string;

implementation

initialization

  _REP_PATH_REPORT[_REP_ASCENDANCE_COMPLET] := '_REP_ASCENDANCE\';
  _REP_PATH_REPORT[_REP_ASCENDANCE_PAR_HOMMES] := '_REP_ASCENDANCE\';
  _REP_PATH_REPORT[_REP_ASCENDANCE_PAR_FEMMES] := '_REP_ASCENDANCE\';

  _REP_PATH_REPORT[_REP_DESCENDANCE_COMPLET] := '_REP_DESCENDANCE_COMPLET\';
  _REP_PATH_REPORT[_REP_DESCENDANCE_PATRONYMIQUE] := '_REP_DESCENDANCE_PATRONYMIQUE\';

  _REP_PATH_REPORT[_REP_LISTE_ALPHA_TOUS] := '_REP_LISTE_ALPHA\';
  _REP_PATH_REPORT[_REP_LISTE_ALPHA_HOMME] := '_REP_LISTE_ALPHA\';
  _REP_PATH_REPORT[_REP_LISTE_ALPHA_FEMME] := '_REP_LISTE_ALPHA\';

  _REP_PATH_REPORT[_REP_LISTE_DIVERS_UNION] := '_REP_LISTE_DIVERS_UNION\';
  _REP_PATH_REPORT[_REP_LISTE_DIVERS_ECLAIR] := '_REP_LISTE_DIVERS_ECLAIR\';
  _REP_PATH_REPORT[_REP_LISTE_DIVERS_EVENEMENT] := '_REP_LISTE_DIVERS_EVENEMENT\';
  _REP_PATH_REPORT[_REP_LISTE_DIVERS_ANNIVERSAIRE] := '_REP_LISTE_DIVERS_ANNIVERSAIRE\';

  _REP_PATH_REPORT[_REP_LISTE_DIVERS_ENFANTS] := '_REP_LISTE_DIVERS_ENFANTS\';
  _REP_PATH_REPORT[_REP_LISTE_DIVERS_FRATRIE] := '_REP_LISTE_DIVERS_FRATRIE\';
  _REP_PATH_REPORT[_REP_LISTE_DIVERS_ONCLES_TANTES] := '_REP_LISTE_DIVERS_ONCLES_TANTES\';
  _REP_PATH_REPORT[_REP_LISTE_DIVERS_COUSINAGE] := '_REP_LISTE_DIVERS_COUSINAGE\';

  _REP_PATH_REPORT[_REP_FICHE_INDIVIDUELLE] := '_REP_FICHE_INDIVIDUELLE\';
  _REP_PATH_REPORT[_REP_FICHE_FAMILIALE] := '_REP_FICHE_FAMILIALE\';

  _REP_PATH_REPORT[_REP_STAT_PATRONYME] := '_REP_STAT_PATRONYME\';
  _REP_PATH_REPORT[_REP_STAT_PRENOM] := '_REP_STAT_PRENOM\';
  _REP_PATH_REPORT[_REP_STAT_AGE_PREMIERE_UNION] := '_REP_STAT_AGE_PREMIERE_UNION\';
  _REP_PATH_REPORT[_REP_STAT_LONGEVITE] := '_REP_STAT_LONGEVITE\';
  _REP_PATH_REPORT[_REP_STAT_NB_ENFANT_UNION] := '_REP_STAT_NB_ENFANT_UNION\';
  _REP_PATH_REPORT[_REP_STAT_RECENSEMENT] := '_REP_STAT_RECENSEMENT\';
  _REP_PATH_REPORT[_REP_STAT_DENOMBREMENT_ASCENDANCE] := '_REP_STAT_DENOMBREMENT_ASCENDANCE\';
  _REP_PATH_REPORT[_REP_STAT_DENOMBREMENT_DESCENDANCE] := '_REP_STAT_DENOMBREMENT_DESCENDANCE\';

  _REP_PATH_REPORT[_REP_STAT_GRAPH_NAISS_DEPT] := '_REP_STAT_GRAPH_NAISS_DEPT\';

end.
