{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_common_func;

interface


uses
  Classes, Windows, SysUtils, Forms, MmSystem, Dialogs, Controls,
  graphics,
  FileCtrl,
  Stdctrls,
  extctrls,
  Tlhelp32,
  u_objet_TContext,
  IBStoredProc;

//- PCM pour import des sources -------------------------------------------------------------------------
function get_ABBR: string;
function get_TEXT: string;
function get_TITL: string;
function get_REPO: string;
function get_AUTH: string;
function get_PUBL: string;
function get_EVEN: string;

procedure GotoThisURL(URL: string);
function AssembleString(s: array of string): string;
function AssembleStringWithSep(s: array of string; sep: string): string;
function GetStringNaissanceDeces(sn, sd: string): string;
function TempPath: string;
function GetWindowsVersion: string;
function fu_ProgEnCours(NomProg: string): boolean;
function FontToString(Font: TFont): string;
procedure StringToFont(Str: string; Font: TFont);
procedure swapInteger(var a, b: integer);
function DirExists(const Dir: string): boolean;
function coupechaine(str: string; aLabel: TLabel): string;
function GetAge(Clef: Integer): Integer;
function LoadStringListWithFichier(path: string; SL: TStringList): integer;
function GetBDDPath: string;

procedure PaintOnglet(
  PaintBox: TPaintBox;
  CountOnglet, idxOngletSelected, WidthOnglet, HeightOnglet: integer;
  CouleurTrait, CouleurOngletSelect, CouleurOngletNotSelect: TColor;
  List: TStrings);
procedure GetDirContent(InThisDir: string; aList: TStrings; What: string);

function MyMessageDlg(const Msg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons; HelpCtx: Longint): Word;

procedure OpenFicheIndividuInBox(aCleFiche: integer);

//Test si Date1 <= Date2
function DateInOrder(GDate1, GDate2: string; Strict: boolean; var ImpossibleToCompare: boolean): boolean;

//Test si l'cart entre 2 date est <= Nb jours
function EcartDatesRespected(GDate1, GDate2: string; NbJours: integer; var ImpossibleToCompare: boolean): boolean;


function EcartDatesD1D2SuperieurOuEgalA(GDate1, GDate2: string; NbJours: integer; var ImpossibleToCompare: boolean): boolean;
function EcartDatesD1D2InferieurOuEgalA(GDate1, GDate2: string; NbJours: integer; var ImpossibleToCompare: boolean): boolean;

//Rcupre le premier fichier rtm qui se prsente dans le rpertoire relatif
function GetFirstFileNameReport(aRelPathNameReport: string): string;

function SetValidPathString(Dir: string): string;

procedure PaintPointille(sender: TObject);

procedure SendFocus(aWinControl: TWinControl);

function ApplyModeSaisie(aModeSaisie: TModeSaisie; s: string): string;

function RemoveCharFromString(s: string; c: char): string;
function RemoveStrFromString(s, c: string): string;

function CorrectFileName(s: string): string;

function extractFileNameWithoutExt(s: string): string;
function ConvertionImageToJPeg(aPathFileName: string; var NewPathFileName: string; TauxCompression: integer): boolean;
function ConvertionPictureToJPeg(FOriginalPicture: TPicture; var NewPathFileName: string; TauxCompression: integer): boolean;
function MakeVignette(aPathFileName: string;
  var NewPathFileVignette: string;
  imageForVignette: TImage;
  MS: TMemoryStream): boolean;
function doFormatePrenoms(sChaine: string): string;
function doTestTailleImage(sImage: string): integer;
function GetWindowsDir: string;

implementation

uses
  u_dm, ShellAPI, u_form_msg, u_form_individu, u_objet_TGedcomDate, u_common_const, jpeg,
  u_common_var, ComObj;

function GetWindowsDir: string;
begin
  SetLength(result, MAX_PATH);
  SetLength(result, GetWindowsDirectory(PChar(result), MAX_PATH));
end;


function LoadStringListWithFichier(path: string; SL: TStringList): integer;
// Remplissage d une string list
var
  F: TSearchRec;
  R: integer;
begin
  SL.Clear;
  r := FindFirst(path, faAnyFile, F);
  while r = 0 do begin
      SL.Add(F.Name);
      r := FindNext(F);
    end;
  FindClose(F);
  SL.Sort;
  Result := r;
end;

procedure GotoThisURL(URL: string);
var
  tmp, para: string;

const nbr_extension = 4;
  extension: array[0..nbr_extension - 1] of string = ('.HTM', '.HTML', '.SHTML', '.SHTM');


  function FindBrowser: string;
  var c: byte;
    hkey1, hkey2: hkey;
    typ, taille: integer;
    tmp: array[0..1024] of char;
    tmpstr: string;
    procedure Arrange;
    var u: word;
    begin
      tmpstr := strpas(tmp);
      u := 1;
      repeat
        if tmpstr[u] <> '%' then inc(u) else delete(tmpstr, u, 2);
      until u >= length(tmpstr);
      RegCloseKey(hkey2);
      FindBrowser := tmpstr;
    end;
  begin
    c := 0;
    repeat
      if regopenkeyex(hkey_classes_root, pchar(extension[c]), 0, key_all_access, hkey1) = 0 then
        begin
          if regqueryvalueex(hkey1, nil, nil, @typ, nil, @taille) = error_success then
            begin
              regqueryvalueex(hkey1, nil, nil, nil, @tmp, @taille);
              if tmp <> '' then
                if regopenkeyex(hkey_classes_root, pchar(tmp + '\shell\open\command'), 0, key_all_access, hkey2) = error_success then
                  begin
                    if regqueryvalueex(hkey2, nil, nil, @typ, nil, @taille) = error_success then
                      begin
                        regqueryvalueex(hkey2, nil, nil, nil, @tmp, @taille);
                        if tmp <> '' then
                          begin
                            Arrange;
                            Exit;
                          end;
                      end;
                    regclosekey(hkey2);
                  end;
              if regopenkeyex(hkey1, 'shell\open\command', 0, key_all_access, hkey2) = error_success then
                begin
                  if regqueryvalueex(hkey2, nil, nil, @typ, nil, @taille) = error_success then
                    begin
                      regqueryvalueex(hkey2, nil, nil, nil, @tmp, @taille);
                      if tmp <> '' then
                        begin
                          Arrange;
                          Exit;
                        end;
                    end;
                end;
            end;
          regclosekey(hkey1);
        end;
      inc(c);
    until c = nbr_extension;
    FindBrowser := '';
  end;

  function BrowserPath: string;
  var tmp: string;
    c: word;
  begin
    tmp := findbrowser;
    if tmp <> '' then
      begin
        tmp := uppercase(tmp);
        c := length(tmp) + 1;
        repeat
          dec(c);
          para := copy(tmp, c - 3, 4);
        until (para = '.EXE') or (para = '.BAT') or (para = '.COM');
        if c < length(tmp) then
          begin
            para := trim(copy(tmp, c + 1, length(tmp) - (c)));
            while (para <> '') and (para[1] = '"') do delete(para, 1, 1);
            delete(tmp, c + 1, length(tmp) - (c));
          end else para := '';
        if tmp[1] = '"' then delete(tmp, 1, 1);
      end;
    BrowserPath := tmp;
  end;

begin
  tmp := BrowserPath;
  if tmp <> '' then
    begin
      shellexecute(application.handle, nil, pchar(tmp), pchar(para + ' ' + Url), nil, SW_SHOWNORMAL);
    end;
end;


function AssembleString(s: array of string): string;
var
  i: Integer;
  sub: string;
begin
  result := '';
  for i := 0 to High(s) do
    begin
      sub := trim(s[i]);
      if sub <> '' then
        begin
          if (result <> '') and (i > 0) then result := result + ', ';
          result := result + sub;
        end;
    end;
end;

function AssembleStringWithSep(s: array of string; sep: string): string;
var
  i: Integer;
  sub: string;
begin
  result := '';
  for i := 0 to High(s) do
    begin
      sub := trim(s[i]);
      if sub <> '' then
        begin
          if (result <> '') and (i > 0) then result := result + sep;
          result := result + sub;
        end;
    end;
end;


function TempPath: string;
var
  TmpDir: array[0..MAX_PATH] of char;
begin
  GetTempPath(MAX_PATH, TmpDir);
  result := TmpDir;
end;


function GetWindowsVersion: string;
var
  VersionInfo: TOsVersionInfo;
begin
  VersionInfo.dwOSVersionInfoSize := sizeof(VersionInfo); //  mettre avant un appel  GetVersionEx
  GetVersionEx(VersionInfo);
  case
    VersionInfo.dwPlatformId of
    VER_PLATFORM_WIN32_WINDOWS: Result := 'Win 95';
    VER_PLATFORM_WIN32s: Result := 'Win 3.1';
    VER_PLATFORM_WIN32_NT: Result := 'Windows NT';
  end;

  Result := IntToStr(VersionInfo.dwMajorVersion);
end;


function fu_ProgEnCours(NomProg: string): boolean;
var
  LPPE: TProcessEntry32;
  H: Thandle;

begin
  result := false;
  h := CreateToolhelp32Snapshot(TH32CS_SNAPALL, 0);
  Lppe.DwSize := Sizeof(TProcessEntry32);
  if Process32First(h, lppe)
    then
    begin;
      if AnsiUpperCase(ExtractFileName(LPPE.szexefile)) = AnsiUpperCase(NomProg) then result := true;
      while Process32next(h, lppe) do
        begin
          if AnsiUpperCase(ExtractFileName(LPPE.szexefile)) = AnsiUpperCase(NomProg) then result := true;
        end;
    end;
  Closehandle(h);
end;


function FontToString(Font: TFont): string;
begin
  Result := Format('%s,%d,%d%d%d%d,%s', [Font.Name, Font.Size,
    Integer(fsBold in Font.Style), Integer(fsItalic in Font.Style),
      Integer(fsUnderline in Font.Style), Integer(fsStrikeOut in Font.Style),
      ColorToString(Font.Color)]);
end;

procedure StringToFont(Str: string; Font: TFont);
const
  SEP = ',';
  EXCEPT_MSG = 'Invalid string to font conversion.';
var
  i: Integer;
  tmpFont: TFont;
begin
  try
    // name
    i := Pos(SEP, Str);
    if i = 0 then raise EConvertError.Create(EXCEPT_MSG);
    Font.Name := Copy(Str, 1, i - 1);
    Delete(Str, 1, i);

    // size
    i := Pos(SEP, Str);
    if i = 0 then raise EConvertError.Create(EXCEPT_MSG);
    Font.Size := StrToInt(Copy(Str, 1, i - 1));
    Delete(Str, 1, i);

    // bold, italic, underline, strikethrough
    if Pos(SEP, Str) <> 5 then raise EConvertError.Create(EXCEPT_MSG);
    Font.Style := [];
    if Boolean(StrToInt(Copy(Str, 1, 1))) then Font.Style := Font.Style + [fsBold];
    if Boolean(StrToInt(Copy(Str, 2, 1))) then Font.Style := Font.Style + [fsItalic];
    if Boolean(StrToInt(Copy(Str, 3, 1))) then Font.Style := Font.Style + [fsUnderline];
    if Boolean(StrToInt(Copy(Str, 4, 1))) then Font.Style := Font.Style + [fsStrikeOut];

    Delete(Str, 1, 5);

    // colour
    Font.Color := StringToColor(Str);
  except
    tmpFont := TFont.Create;
    try
      Font.Assign(tmpFont);
    finally
      tmpFont.Free;
    end;
  end;
end;

procedure swapInteger(var a, b: integer);
var
  c: integer;
begin
  c := a;
  a := b;
  b := c;
end;


function DirExists(const Dir: string): boolean;

  function StripTrailingBackslash(const Dir: string): string;
  begin
    Result := Dir;
    // Make sure we have a string, and if so, see if the last char is a \
    if (Result <> '') and (Result[Length(Result)] = '\') then
      SetLength(Result, Length(Result) - 1); // Shorten the length by one to remove
  end;

var
  Tmp: string;
  DriveBits: set of 0..25;
  SR: TSearchRec;
  Found: boolean;
  OldMode: Word;
begin
  OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    if (Length(Dir) = 3) and (Dir[2] = ':') and (Dir[3] = '\') then begin
        Integer(DriveBits) := GetLogicalDrives;
        Tmp := UpperCase(Dir[1]);
        Result := (ord(Tmp[1]) - ord('A')) in DriveBits;
      end else begin
        Found := FindFirst(StripTrailingBackslash(Dir), faDirectory, SR) = 0;
        Result := Found and (Dir <> '');
        if Result then
          Result := (SR.Attr and faDirectory) = faDirectory;
        if Found then
          // only call FinClose if FindFirst succeeds.  Can lock NT up if it didn't
          FindClose(SR);
      end;
  finally
    SetErrorMode(OldMode);
  end;
end; // DirExists

function coupechaine(str: string; aLabel: TLabel): string;
var
  s: string;
  w, n, k: integer;
  //     s_Chaine: string;
begin
  result := '';
  //On assigne la font du label,  son canvas
  aLabel.Canvas.Font.Assign(aLabel.Font);
  w := aLabel.Canvas.TextWidth(str);
  if w < aLabel.width then result := str
  else
    begin
      k := 0;
      s := '';
      for n := 1 to length(str) do
        begin
          s := s + str[n];
          if aLabel.Canvas.TextWidth(s + '...') < aLabel.Width then inc(k) else break;
        end;

      result := copy(str, 1, k) + '...';
    end;
end;
{
procedure PaintOnglet(
     PaintBox: TPaintBox;
     CountOnglet, idxOngletSelected, WidthOnglet, HeightOnglet: integer;
     CouleurTrait, CouleurOngletSelect, CouleurOngletNotSelect: TColor;
     List: TStrings);
var
     n, k, b: integer;
     c: TCanvas;
     R: TRect;
begin
     c := PaintBox.Canvas;
     b := PaintBox.Height;

     k := (CountOnglet * WidthOnglet) - (4 * (CountOnglet - 1));
     for n := 0 to CountOnglet - 1 do
     begin
          c.Pen.Color := CouleurTrait;
          c.Brush.Color := CouleurOngletNotSelect;
          c.Brush.Style := bsSolid;
          c.Polygon([Point(k, b),
               Point(k, b - HeightOnglet + 7),
                    Point(k - 7, b - HeightOnglet),
                    Point(k - WidthOnglet + 3, b - HeightOnglet),
                    Point(k - WidthOnglet, b - HeightOnglet + 3),
                    Point(k - WidthOnglet, b)]);
          k := k - WidthOnglet + 4;
     end;


     //on dessine l'onglet slectionn
     k := ((idxOngletSelected + 1) * WidthOnglet) - (4 * (idxOngletSelected + 1 - 1));
     c.Pen.Color := CouleurTrait;
     c.Brush.Color := CouleurOngletSelect;
     c.Brush.Style := bsSolid;
     c.Polygon([Point(k, b),
          Point(k, b - HeightOnglet + 7),
               Point(k - 7, b - HeightOnglet),
               Point(k - WidthOnglet + 3, b - HeightOnglet),
               Point(k - WidthOnglet, b - HeightOnglet + 3),
               Point(k - WidthOnglet, b)]);

     //trait du bas
     k := ((idxOngletSelected + 1) * WidthOnglet) - (4 * (idxOngletSelected + 1 - 1));
     c.Pen.Color := CouleurTrait;

     c.MoveTo(k, b - 1);
     c.LineTo(PaintBox.width, b - 1);
     //     (CountOnglet * WidthOnglet) - (4 * (CountOnglet - 1)), b - 1);

     c.MoveTo(k - WidthOnglet, b - 1);
     c.LineTo(0, b - 1);


     if list <> nil then
     begin
          //          c.font.color := clblue;
          c.brush.style := bsclear;
          for n := 0 to CountOnglet - 1 do
          begin
               if n < List.count then
               begin
                    k := ((n) * WidthOnglet) - (4 * (n));
                    R := rect(k, b - HeightOnglet + 2, k + WidthOnglet, b - 1);
                    DrawText(c.handle, PChar(List[n]), length(List[n]), R, DT_CENTER);
               end;
          end;
     end;
end;
}

procedure PaintOnglet(
  PaintBox: TPaintBox;
  CountOnglet, idxOngletSelected, WidthOnglet, HeightOnglet: integer;
  CouleurTrait, CouleurOngletSelect, CouleurOngletNotSelect: TColor;
  List: TStrings);
var
  n, k, b: integer;
  c: TCanvas;
  R: TRect;
begin
  c := PaintBox.Canvas;
  b := PaintBox.Height;

  k := (CountOnglet * WidthOnglet) - (4 * (CountOnglet - 1));
  for n := 0 to CountOnglet - 1 do
    begin
      c.Pen.Color := CouleurTrait;
      c.Brush.Color := CouleurOngletNotSelect;
      c.Brush.Style := bsSolid;

      c.Polygon([Point(k, b),
        Point(k, b - HeightOnglet + 7),
          Point(k - 7, b - HeightOnglet),
          Point(k - WidthOnglet + 3, b - HeightOnglet),
          Point(k - WidthOnglet, b - HeightOnglet + 3),
          Point(k - WidthOnglet, b)]);

      {
  c.Pen.Color := clRed;
  c.PolyLine([Point(k - 1, b),
      Point(k - 1, b - HeightOnglet + 7),
           Point(k - 7, b - HeightOnglet + 1),
           Point(k - WidthOnglet + 3, b - HeightOnglet+1),
           Point(k - WidthOnglet + 1, b - HeightOnglet + 3),
           Point(k - WidthOnglet + 1, b)]);
           }

      c.Pen.Color := clSilver;
      c.PolyLine([Point(k - 1, b),
        Point(k - 1, b - HeightOnglet + 7),
          Point(k - 7, b - HeightOnglet + 1)]);

      c.Pen.Color := clWhite;
      c.PolyLine([Point(k - 7, b - HeightOnglet + 1),
        Point(k - WidthOnglet + 3, b - HeightOnglet + 1),
          Point(k - WidthOnglet + 1, b - HeightOnglet + 3),
          Point(k - WidthOnglet + 1, b)]);


      k := k - WidthOnglet + 4;
    end;


  //on dessine l'onglet slectionn
  k := ((idxOngletSelected + 1) * WidthOnglet) - (4 * (idxOngletSelected + 1 - 1));
  c.Pen.Color := CouleurTrait;
  c.Brush.Color := CouleurOngletSelect;
  c.Brush.Style := bsSolid;
  c.Polygon([Point(k, b),
    Point(k, b - HeightOnglet + 7),
      Point(k - 7, b - HeightOnglet),
      Point(k - WidthOnglet + 3, b - HeightOnglet),
      Point(k - WidthOnglet, b - HeightOnglet + 3),
      Point(k - WidthOnglet, b)]);

  c.Pen.Color := clSilver;
  c.PolyLine([Point(k - 1, b),
    Point(k - 1, b - HeightOnglet + 7),
      Point(k - 7, b - HeightOnglet + 1)]);

  c.Pen.Color := clWhite;
  c.PolyLine([Point(k - 7, b - HeightOnglet + 1),
    Point(k - WidthOnglet + 3, b - HeightOnglet + 1),
      Point(k - WidthOnglet + 1, b - HeightOnglet + 3),
      Point(k - WidthOnglet + 1, b)]);




  //trait du bas
  k := ((idxOngletSelected + 1) * WidthOnglet) - (4 * (idxOngletSelected + 1 - 1));
  c.Pen.Color := CouleurTrait;

  c.MoveTo(k, b - 1);
  c.LineTo(PaintBox.width, b - 1);
  //     (CountOnglet * WidthOnglet) - (4 * (CountOnglet - 1)), b - 1);

  c.MoveTo(k - WidthOnglet, b - 1);
  c.LineTo(0, b - 1);


  if list <> nil then
    begin
      //          c.font.color := clblue;
      c.brush.style := bsclear;
      for n := 0 to CountOnglet - 1 do
        begin
          if n < List.count then
            begin
              k := ((n) * WidthOnglet) - (4 * (n));
              R := rect(k, b - HeightOnglet + 2, k + WidthOnglet, b - 1);
              DrawText(c.handle, PChar(List[n]), length(List[n]), R, DT_CENTER);
            end;
        end;
    end;
end;


procedure GetDirContent(InThisDir: string; aList: TStrings; What: string);
var
  SearchRec: TSearchRec;
  found: word;
begin
  InThisDir := InThisDir + What;
  aList.Clear;
  try
    found := findfirst(InThisDir, faArchive, searchrec);
    while found = 0 do
      begin
        aList.Add(searchrec.Name);

        found := findnext(searchrec);
      end;
  finally
    findclose(searchrec);
  end;
end;


function MyMessageDlg(const Msg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons; HelpCtx: Longint): Word;
var
  aFMsg: TFMsg;
begin
  aFMsg := TFMsg.create(nil);
  try
    aFMsg.lbMsg.Caption := Msg;
    aFMsg.Buttons := Buttons;
    aFMsg.DlgType := DlgType;
    result := aFMsg.ShowModal;
  finally
    aFMsg.Free;
  end;
end;


procedure OpenFicheIndividuInBox(aCleFiche: integer);
var
  aFIndividu: TFIndividu;
begin
  aFIndividu := TFIndividu.create(Application);
  try
    aFIndividu.DialogMode := true;
    if aFIndividu.doOpenFiche(aCleFiche) then aFIndividu.ShowModal;
    //else aFIndividu.Close;
  finally
    aFIndividu.Free;
  end;
end;

function DateInOrder(GDate1, GDate2: string; Strict: boolean; var ImpossibleToCompare: boolean): boolean;
var
  G1, G2: TGedcomDate;
begin
  result := false;
  ImpossibleToCompare := true;

  G1 := TGedcomDate.Create;
  G2 := TGedcomDate.Create;
  try
    G1.AssignTokens;
    G2.AssignTokens;

    if G1.DecodeHumanDate(GDate1) and G2.DecodeHumanDate(GDate2) then
      begin
        if (G1.KnowDate) and (G2.KnowDate) then
          begin
            ImpossibleToCompare := false;
            if Strict
              then result := G1.GDate.DateTime1 < G2.GDate.DateTime1
            else result := G1.GDate.DateTime1 <= G2.GDate.DateTime1;
          end;
      end;
  finally
    G1.free;
    G2.free;
  end;
end;


function EcartDatesRespected(GDate1, GDate2: string; NbJours: integer; var ImpossibleToCompare: boolean): boolean;
var
  G1, G2: TGedcomDate;
begin
  result := false;
  ImpossibleToCompare := true;

  G1 := TGedcomDate.Create;
  G2 := TGedcomDate.Create;
  try
    G1.AssignTokens;
    G2.AssignTokens;

    if G1.DecodeHumanDate(GDate1) and G2.DecodeHumanDate(GDate2) then
      begin
        if (G1.KnowDate) and (G2.KnowDate) then
          begin
            ImpossibleToCompare := false;
            result := ((trunc(G2.GDate.DateTime1) - trunc(G1.GDate.DateTime1)) <= NbJours);
          end;
      end;
  finally
    G1.free;
    G2.free;
  end;
end;

function GetFirstFileNameReport(aRelPathNameReport: string): string;
var
  List: TStringlist;
begin
  result := '';
  List := TStringlist.create;
  try
    GetDirContent(ExtractFilePath(Application.exeName) + _REL_PATH_REPORT + aRelPathNameReport, List, '*.rtm');
    if List.Count > 0 then result := List[0];
  finally
    List.Free;
  end;
end;

function SetValidPathString(Dir: string): string;
begin
  if (Dir <> '') and (Dir[Length(Dir)] <> '\') then result := Dir + '\' else result := Dir;
end;


procedure PaintPointille(sender: TObject);
var
  pb: TPaintBox;
  k: integer;
begin
  pb := TPaintBox(sender);
  pb.Canvas.Pen.Color := clGray;
  pb.Canvas.Pen.Width := 1;

  k := 0;
  if pb.width > pb.Height then
    begin
      while k < pb.width do
        begin
          pb.Canvas.MoveTo(k, 0);
          pb.Canvas.LineTo(k + 3, 0);
          k := k + 6;
        end;
    end
  else
    begin
      while k < pb.height do
        begin
          pb.Canvas.MoveTo(0, k);
          pb.Canvas.LineTo(0, k + 3);
          k := k + 6;
        end;
    end;
end;


procedure SendFocus(aWinControl: TWinControl);
begin
  if aWinControl.CanFocus then aWinControl.SetFocus;
end;


function ApplyModeSaisie(aModeSaisie: TModeSaisie; s: string): string;
begin
  if aModeSaisie = msAllUpper then
    begin
      result := AnsiUpperCase(s);
    end
  else
    if aModeSaisie = msJustFirstLetterUpper then
      begin
        if length(s) > 0 then result := AnsiUpperCase(s[1]) + copy(s, 2, length(s) - 1) else result := s;
      end
    else
      begin
        result := s;
      end;
end;


function EcartDatesD1D2SuperieurOuEgalA(GDate1, GDate2: string; NbJours: integer; var ImpossibleToCompare: boolean): boolean;
var
  G1, G2: TGedcomDate;
begin
  result := false;
  ImpossibleToCompare := true;

  G1 := TGedcomDate.Create;
  G2 := TGedcomDate.Create;
  try
    G1.AssignTokens;
    G2.AssignTokens;

    if G1.DecodeHumanDate(GDate1) and G2.DecodeHumanDate(GDate2) then
      begin
        if (G1.KnowDate) and (G2.KnowDate) then
          begin
            ImpossibleToCompare := false;
            result := ((trunc(G2.GDate.DateTime1) - trunc(G1.GDate.DateTime1)) >= NbJours);
          end;
      end;
  finally
    G1.free;
    G2.free;
  end;
end;

function EcartDatesD1D2InferieurOuEgalA(GDate1, GDate2: string; NbJours: integer; var ImpossibleToCompare: boolean): boolean;
var
  G1, G2: TGedcomDate;
begin
  result := false;
  ImpossibleToCompare := true;

  G1 := TGedcomDate.Create;
  G2 := TGedcomDate.Create;
  try
    G1.AssignTokens;
    G2.AssignTokens;

    if G1.DecodeHumanDate(GDate1) and G2.DecodeHumanDate(GDate2) then
      begin
        if (G1.KnowDate) and (G2.KnowDate) then
          begin
            ImpossibleToCompare := false;
            result := ((trunc(G2.GDate.DateTime1) - trunc(G1.GDate.DateTime1)) <= NbJours);
          end;
      end;
  finally
    G1.free;
    G2.free;
  end;
end;

function RemoveCharFromString(s: string; c: char): string;
var
  p: integer;
begin
  repeat
    p := pos(c, s);
    if p > 0 then delete(s, p, 1);
  until p = 0;
  result := s;
end;

function RemoveStrFromString(s, c: string): string;
var
  p: integer;
begin
  repeat
    p := pos(c, s);
    if p > 0 then delete(s, p, length(c));
  until p = 0;
  result := s;
end;


function CorrectFileName(s: string): string;
var
  ok: string;
  n, k: integer;
begin
  ok := 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_ -.:\';
  s := trim(s);
  for n := length(s) downto 1 do
    begin
      k := pos(s[n], ok);
      if k = 0 then delete(s, n, 1);
    end;

  if s = '' then s := 'a';
  result := s;
end;

function extractFileNameWithoutExt(s: string): string;
var
  s1: string;
begin
  s := ExtractFileName(s);
  s1 := ExtractFileExt(s);
  if s1 <> '' then delete(s, length(s) - length(s1) + 1, length(s1));
  result := s;
end;


function ConvertionImageToJPeg(aPathFileName: string; var NewPathFileName: string; TauxCompression: integer): boolean;

var
  FOriginalPicture: TPicture;
  FJpegImage: TJPEGImage;
  //	MemStream: TMemoryStream;

begin
  //	result := false;

  _Mulot.Cursor := crHourGlass;
  try
    //Cration des objets image pour la convertion
    FJpegImage := TJPEGImage.Create;
    FOriginalPicture := TPicture.Create;
    try
      //Nouveau nom pour l'image jpeg temporaire
      NewPathFileName := SetValidPathString(TempPath) + CreateClassID + '.jpeg';

      //On charge l'image d'origine
      FOriginalPicture.LoadFromFile(aPathFileName);


      //Compression
      FJpegImage.Grayscale := false;
      FJpegImage.CompressionQuality := TauxCompression;
      FJpegImage.Assign(FOriginalPicture.Graphic);

      {

      MemStream := TMemoryStream.Create;
      try
       FJpegImage.SaveToStream(MemStream);
StatusBar1.Panels[0].Text := Format(RsJpegSize, [IntToExtended(MemStream.Size)]);
       MemStream.Position := 0;
       FJpegImage.LoadFromStream(MemStream);
       Image1.Picture.Assign(FJpegImage);
       Image1.Update;
      finally
       MemStream.Free;
      end;
      }

      //Sauvegarde
      FJpegImage.SaveToFile(NewPathFileName);
      result := true;

    finally
      FreeAndNil(FOriginalPicture);
      FreeAndNil(FJpegImage);
    end;
  finally
    _Mulot.RollBack;
  end;

end;


function ConvertionPictureToJPeg(FOriginalPicture: TPicture; var NewPathFileName: string; TauxCompression: integer): boolean;
var
  FJpegImage: TJPEGImage;
  //     MemStream: TMemoryStream;
begin
  //     result := false;

  _Mulot.Cursor := crHourGlass;
  try
    //Cration des objets image pour la convertion
    FJpegImage := TJPEGImage.Create;
    try
      //Nouveau nom pour l'image jpeg temporaire
      NewPathFileName := SetValidPathString(TempPath) + CreateClassID + '.jpeg';


      //Compression
      FJpegImage.Grayscale := false;
      FJpegImage.CompressionQuality := TauxCompression;
      FJpegImage.Assign(FOriginalPicture.Graphic);

      //Sauvegarde
      FJpegImage.SaveToFile(NewPathFileName);
      result := true;

    finally
      FreeAndNil(FJpegImage);
    end;
  finally
    _Mulot.RollBack;
  end;

end;


function GetStringNaissanceDeces(sn, sd: string): string;
begin
  result := '';

  if sn <> '' then sn := '' + sn;
  if sd <> '' then sd := '' + sd;

  if (sn <> '') or (sd <> '') then
    begin
      result := ' ' + AssembleStringWithSep(['(', sn, sd, ')'], ' ');
    end;
end;

function GetAge(Clef: Integer): Integer;
var ibqAge: TIBStoredProc;
  i_Age: Integer;
begin
  ibqAge := TIBStoredProc.Create(Application);

  ibqAge.DataBase := dm.ibd_BASE;
  ibqAge.StoredProcName := 'PROC_AGE_INDIVIDU';
  ibqAge.Prepare;
  ibqAge.ParamByName('I_CLEF').AsInteger := Clef;
  ibqAge.ExecProc;
  i_Age := ibqAge.Params[2].AsInteger;

  ibqAge.Close;
  ibqAge.Free;

  Result := i_Age;
end;

function MakeVignette(aPathFileName: string;
  var NewPathFileVignette: string;
  imageForVignette: TImage;
  MS: TMemoryStream): boolean;
var
  FJpegImage: TJPEGImage;
  FJpegVignette: TJPEGImage;

begin

  _Mulot.Cursor := crHourGlass;
  try
    FJpegImage := TJPEGImage.Create;
    try
      FJpegImage.LoadFromFile(aPathFileName);
      Application.ProcessMessages;
      //transfert en vignette
      if imageForVignette <> nil then
        begin
          imageForVignette.Canvas.StretchDraw(imageForVignette.ClientRect, FJpegImage);
          FJpegVignette := TJPEGImage.Create;

          try
            //            NewPathFileVignette := TempPath + CreateClassID + '.jpeg';

                        //Compression
            FJpegVignette.Grayscale := false;
            FJpegVignette.CompressionQuality := 100;
            FJpegVignette.Scale := jsEighth;

            FJpegVignette.Assign(imageForVignette.Picture.Graphic);

            //Sauvegarde
            FJpegVignette.SaveToStream(MS);
          finally
            FreeAndNil(FJpegVignette);
          end;
        end;

      result := true;

    finally
      FreeAndNil(FJpegImage);
    end;
  finally
    _Mulot.RollBack;
  end;
end;

function GetBDDPath: string;
var sChaine: string;
begin
  sChaine := Copy(_Context.PathFileNameBdd,
    1,
    AnsiPos(dm.sNombase + '.' + dm.sExtentionBase, UpperCase(_Context.PathFileNameBdd)) - 1);

  Result := sChaine;
end;

const Alphas = ['a'..'z', 'A'..'Z',
  '',
    '', '', '', '',
    '', '', '',
    '', '',
    '', '',
    '', '',
    ''];

function doFormatePrenoms(sChaine: string): string;
var
  sRetour: string;
  c, d: PChar;
  Separed: Boolean;
  Composed: Boolean;
begin

  sRetour := '';
  Separed := True;
  Composed := True;
  c := PChar(sChaine);

  while (c^ <> #0) do
    begin
      while (c^ in [' ', #9]) or (Separed and (c^ = ',')) or
        (Composed and (c^ = '-')) do
        Inc(c);
      if (c^ in Alphas) then
        begin
          if not (Separed or Composed) then
            sRetour := sRetour + ' '
          else
            begin
              Separed := False;
              Composed := False;
            end;

          sRetour := sRetour + AnsiUpperCase(c^);
          Inc(c);
          d := c;
          while (c^ in Alphas) do
            Inc(c);
          sRetour := sRetour + AnsiLowerCase(Copy(d, 1, c - d));
        end
      else
        begin
          if (c^ = '-') then
            begin
              sRetour := sRetour + '-';
              Separed := False;
              Composed := True;
            end
          else
            if (c^ = ',') or (c^ = ';') then
              begin
                sRetour := sRetour + ', ';
                Separed := True;
                Composed := False;
              end;
          if (c^ <> #0) then
            Inc(c);
        end;
    end;

  Result := sRetour;
end;

function doTestTailleImage(sImage: string): integer;
var Picture: TPicture;
  iHeight, iWidth,
    iResult: Integer;
begin
  iResult := 1;

  Picture := TPicture.Create;
  try
    Picture.LoadFromFile(sImage);
  finally
    iHeight := Picture.Height;
    iWidth := Picture.Width;

    if ((iHeight > 1100) or (iWidth > 777)) then
      begin
        ShowMessage('Cette Image est trop grande, il est fortement conseill de la rduire pour amliorer les performances' + #10#13 +
          'Taille recommande : 1100 * 777');
        //iResult := -1;
      end;
  end;

  Result := iResult;
end;

//- PCM pour import des sources -------------------------------------------------------------------------

function get_ABBR: string;
begin
  result := s_ABBR;
end;

function get_TEXT: string;
begin
  result := s_TEXT;
end;

function get_TITL: string;
begin
  result := s_TITL;
end;

function get_REPO: string;
begin
  result := s_REPO;
end;

function get_AUTH: string;
begin
  result := s_AUTH;
end;

function get_PUBL: string;
begin
  result := s_PUBL;
end;

function get_EVEN: string;
begin
  result := s_EVEN;
end;



end.

