{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_common_var;

interface

uses
  windows,
  classes,
  u_form_navigation,
  u_objet_TContext,
  u_objet_TGedcomDate,
  //     u_form_edit_calendrier,
  u_objet_TMulot,
  u_form_Occupe,
  U_Microsoft_Agent;

var
  bAgent: boolean;

  _Path_Appli: string;
  _FormNavigation: TFNavigation;
  _Context: TContext;
  _Mulot: TMulot;
  _GDate: TGedcomDate;
  _FOccupe: TFOccupe;
  _LastPosMiniature: TPoint;
  _FileNameHelp: string;
  _FileNameOptimisationRtf: string;
  _FileNameTraduction: string;
  _FileNamePartenaires: string;
  _Agent: TMSAgent;

  //- PCM import des sources ----------------------------------------------------------------------------
  s_ABBR: string;
  s_TEXT: string;
  s_TITL: string;
  s_REPO: string;
  S_AUTH: string;
  S_PUBL: string;
  S_EVEN: string;

procedure doInitAgent(bUseAgent: boolean);
implementation

uses
  SysUtils, Forms, u_common_const, u_common_func;

var
  k: integer;

procedure doInitAgent(bUseAgent: boolean);
begin
  _Agent := TMSAgent.Create;

  if bUseAgent then
    begin
      _Agent.doCreate(bUseAgent);

      bAgent := True;
    end;
end;

initialization

  _Context := TContext.create;
  _Context.Load;

  _Mulot := TMulot.create;

  _GDate := TGedcomDate.create;
  _GDate.AssignTokens;

  _FOccupe := TFOccupe.create(nil);

  _LastPosMiniature := Point(maxint, maxint);

  //     _PathHelp := ExtractFilePath(Application.ExeName) + _REL_PATH_HELP;

  _Path_Appli := ExtractFilePath(Application.ExeName);

  //chemin vers le rpertoire de la base de donne
  if not DirExists(_Path_Appli + _REL_PATH_DATABASE) then
    begin
      CreateDir(_Path_Appli + _REL_PATH_DATABASE);
    end;

  //chemin vers le rpertoire d'import/Export
  if not DirExists(_Path_Appli + _REL_PATH_IMPORT_EXPORT) then
    begin
      CreateDir(_Path_Appli + _REL_PATH_IMPORT_EXPORT);
    end;

  //chemin vers le rpertoire des documents
  if not DirExists(_Path_Appli + _REL_PATH_DOC) then
    begin
      CreateDir(_Path_Appli + _REL_PATH_DOC);
    end;

  //chemin vers le rpertoire des images
  if not DirExists(_Path_Appli + _REL_PATH_IMAGE) then
    begin
      CreateDir(_Path_Appli + _REL_PATH_IMAGE);
    end;

  //Chemin vers les traductions
  if not DirExists(_Path_Appli + _REL_PATH_TRADUCTIONS) then
    begin
      CreateDir(_Path_Appli + _REL_PATH_TRADUCTIONS);
    end;

  //Chemin vers les Plugins
  if not DirExists(_Path_Appli + _REL_PATH_PLUGINS) then
    begin
      CreateDir(_Path_Appli + _REL_PATH_PLUGINS);
    end;

  //chemin vers les rapports
  if not DirExists(_Path_Appli + _REL_PATH_REPORT) then
    begin
      CreateDir(_Path_Appli + _REL_PATH_REPORT);
    end;

  //chemins vers les rapports par fonction
  for k := 0 to _MAX_REP_PATH do
    begin
      if not DirExists(_Path_Appli + _REL_PATH_REPORT + _REP_PATH_REPORT[k]) then
        begin
          CreateDir(_Path_Appli + _REL_PATH_REPORT + _REP_PATH_REPORT[k]);
        end;
    end;


  //Nom du fichier de traduction  utiliser
  _FileNameTraduction := '';
  _FileNameHelp := 'HelpAncestrologie_Franais.chm';
  _FileNameOptimisationRtf := 'HelpOptimisation_Franais.rtf';
  _FileNamePartenaires := 'Partners_Franais.htm';

  if FileExists(_Path_Appli + _REL_PATH_TRADUCTIONS + _Context.Language + _EXT_TRADUC) then
    begin
      _FileNameTraduction := _Context.Language + _EXT_TRADUC;
      _FileNameHelp := 'HelpAncestrologie_' + _Context.Language + '.chm';
      _FileNameOptimisationRtf := 'HelpOptimisation_' + _Context.Language + '.rtf';
      _FileNamePartenaires := 'Partners_' + _Context.Language + '.htm';
    end;


finalization
  if _Context.ShouldSave then _Context.Save;

  _GDate.free;
  _Context.free;

  _Agent.Free;

  _FOccupe.Free;
  _Mulot.Free;
  //   _FEditCalendrier.Free;
end.

