{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_dm;

interface

uses
  Windows, Forms, Classes, ImgList, Controls, IBDatabase, Dialogs, Db, Graphics,
  Sysutils, IBCustomDataSet, IBStoredProc, Ibquery, menus, dxEdLib, dxDBELib,
  dxCntner, IBUpdateSQL, contnrs, IB, extctrls, JPEG, ShellAPI, IBServices, dxBar,
  IBScript, StdCtrls, idGlobal, ComObj, IBSQL;

type
  TFicheOpenInfo = class
  private
    fCleFiche: integer;
    fSexe: integer;
    fTitreNomPrenom: string;

  public
    constructor Create;
    property CleFiche: integer read fCleFiche write fCleFiche;
    property TitreNomPrenom: string read fTitreNomPrenom write fTitreNomPrenom;
    property Sexe: integer read fSexe write fSexe;

  end;

  Tdm = class(TDataModule)


    ImageListMenu: TImageList;
    ImageTreeview: TImageList;
    ibd_BASE: TIBDatabase;
    IBT_BASE: TIBTransaction;
    ImageSexe: TImageList;
    IBSpClefUnique: TIBStoredProc;
    ImageEve: TImageList;
    StyleController: TdxEditStyleController;
    dsPrefixes: TDataSource;
    IBQPrefixes: TIBQuery;
    IBUPrefixes: TIBUpdateSQL;
    DSTypeTemoin: TDataSource;
    IBQTypeTemoin: TIBQuery;
    IBUTypeTemoin: TIBUpdateSQL;
    IBQTypeUnion: TIBQuery;
    IBQueryRefEvInd: TIBQuery;
    ImgCatEvent: TImageList;
    IBQPrefixesLIBELLE: TIBStringField;
    IBQTypeTemoinLIBELLE: TIBStringField;
    IBQTypeUnionLIBELLE: TIBStringField;
    IBQFiliation: TIBQuery;
    IBQFiliationLIBELLE: TIBStringField;
    QueryGetFavoris: TIBQuery;
    QueryAddFavoris: TIBQuery;
    SPInsertFavoris: TIBStoredProc;
    ImagCat: TImageList;
    IBQueryRaccourcis: TIBQuery;
    IBTrans_Secondaire: TIBTransaction;
    IBQPays: TIBQuery;
    dsPays: TDataSource;
    QueryGetMotClefsDate: TIBQuery;
    IBQPrefixesI_TYPE: TIntegerField;
    IBQTypeTemoinI_TYPE: TIntegerField;
    IBQTypeUnionI_TYPE: TIntegerField;
    IBQFiliationI_TYPE: TIntegerField;
    IBStoredProcGetUnion: TIBStoredProc;
    IBBackup: TIBBackupService;
    IBRestore: TIBRestoreService;
    QTotalIndiDossier: TIBQuery;
    IBStoredDelFavoris: TIBStoredProc;
    IBQUpdateDLL: TIBQuery;
    DSSources_Record: TDataSource;
    IBQSources_Record: TIBQuery;
    IBQSources_RecordID: TIntegerField;
    IBQSources_RecordSOURCE_PAGE: TIBStringField;
    IBQSources_RecordEVEN: TIBStringField;
    IBQSources_RecordEVEN_ROLE: TIBStringField;
    IBQSources_RecordDATA_ID: TIntegerField;
    IBQSources_RecordDATA_EVEN: TIBStringField;
    IBQSources_RecordDATA_EVEN_PERIOD: TIBStringField;
    IBQSources_RecordDATA_EVEN_PLAC: TIBStringField;
    IBQSources_RecordDATA_AGNC: TIBStringField;
    IBQSources_RecordQUAY: TIntegerField;
    IBQSources_RecordAUTH: TBlobField;
    IBQSources_RecordTITL: TBlobField;
    IBQSources_RecordABR: TIBStringField;
    IBQSources_RecordPUBL: TBlobField;
    IBQSources_RecordTEXTE: TBlobField;
    IBQSources_RecordUSER_REF: TBlobField;
    IBQSources_RecordRIN: TIBStringField;
    IBQSources_RecordCHANGE_DATE: TDateTimeField;
    IBQSources_RecordCHANGE_NOTE: TBlobField;
    IBQSources_RecordKLE_DOSSIER: TIntegerField;
    IBUSources_Record: TIBUpdateSQL;
    IBQSources_RecordTYPE_TABLE: TIBStringField;
    IBQVersionBase: TIBQuery;
    IBQVersionBaseVER_VERSION: TIBStringField;
    IBUpdateNOM: TIBQuery;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);

  private
    fNumDossier: integer;
    fVersionBase: string;
    fVersionMAJBase: string;
    fNomDossier: string;
    fFicheActive: integer;
    fNbInd: Integer;
    fListFicheOpenInfos: TObjectList;
    fFicheOpenIndex: integer;
    fCanAddFicheOpenInList: boolean;

    fRaccourcisRac: TStringList;
    fRaccourcisLibelle: TStringList;

    procedure InitContolerStyleWithContext;
    procedure SetFicheActive(const Value: integer);
    procedure SetNumDossier(const Value: integer);
    procedure doInitialiseVariables;

  public
    bFirstime: Boolean;
    s_User_Name, s_PassWord: string;
    sNomBase: string;
    sExtentionBase: string;

    property NbInd: integer read fNbInd write fNbInd;

    property NumDossier: integer read fNumDossier write SetNumDossier;
    property NomDossier: string read fNomDossier write fNomDossier;
    property FicheActive: integer read fFicheActive write SetFicheActive;
    property VersionBase: string read fVersionBase write fVersionBase;
    property VersionMAJBase: string read fVersionMAJBase write fVersionMAJBase;

    property ListFicheOpenInfos: TObjectList read fListFicheOpenInfos write fListFicheOpenInfos;
    property FicheOpenIndex: integer read fFicheOpenIndex write fFicheOpenIndex;
    property CanAddFicheOpenInList: boolean read fCanAddFicheOpenInList write fCanAddFicheOpenInList;

    procedure doSaveLastFicheActiveOfDossier;
    procedure doOpenDossier(i_dossier: smallint);
    function DoClearDatabase: boolean;
    function DoClearDossier: boolean;
    procedure up_Comptage(a_Mode: integer);
    function uf_GetClefUnique(a_Mode: string): integer; // Remonte une clef unique
    function uf_MaxIndividu: Integer;
    procedure up_RenumSosa(a_Cle: integer);
    function up_DateControl(a_Cle: Integer; a_Date: TDate; a_Year: SmallInt; a_Table: string; a_Cle_Conjoint: Integer): SmallInt;

    procedure DelFavoris;
    procedure LoadFavoris(menu: TdxBarSubItem);
    procedure AddToFavoris(cle: integer);

    procedure LoadMotClefDate;

    function doRecupMaxSosa(var fMaxSosa: string): Int64;

    procedure AddFicheOpen(CleFiche, Sexe: integer; TitreNomPrenom: string);
    procedure VerifyInfosInListFicheOpen(CleFiche, Sexe: integer; TitreNomPrenom: string);

    procedure LoadRaccourcis;
    procedure EngineRaccourcis_TdxDBPopupEdit(adxEdit: TdxDBPopupEdit; Key: Word; Shift: TShiftState);

    function EngineRaccourcis_TdxDBPopupEdit2(adxEdit: TdxDBPopupEdit; Key: Word; Shift: TShiftState; var aText: string; var aSelStart: integer): boolean;

    function GetCleUnion(cle_mari, cle_femme: integer): integer;

    procedure doOpenDatabase;
    procedure doCloseDatabase;

    procedure doExportImages;
    function doNouveaux: integer;
    procedure doBackup;

    procedure ShowHelp(ID: integer);

    function GetTotalIndividuDossier: integer;

    procedure DoUpdateDLL;
    procedure doMajInsee;
    procedure doChangeInsee;
    procedure doCLoseAbout;

    function GetUrlInfos: string;
    function GetUrlAncestrologie: string;
    function GetUrlMajAuto: string;
    function GetUrlSite: string;
    function GetUrlInfosMaj: string;
    function GetEmail: string;
    function GeturlListeDiffusion: string;

  end;

var
  dm: Tdm;
const
  urlInfos: string = 'http://www.ancestrologie.com/france/infosjour.php';
  urlAncestrologie: string = 'http://www.ancestrologie.com';
  urlSite: string = 'www.ancestrologie.com';
  urlMajAuto: string = 'http://www.ancestrologie.com/france/majauto/';
  urlInfosMaj: string = 'http://www.ancestrologie.com/france/majauto/InfosMaj.htm';
  urlListeDiffusion: string = 'http://fr.groups.yahoo.com/group/ancestrologie/';
  sEmail: string = 'ph.cazaux-moutou@wanadoo.fr';
implementation

uses u_form_main,
  u_common_const, u_common_var, u_common_func,
  u_gedcom_func, u_gedcom_const, u_gedcom_var,
  u_rm, hh, hh_funcs, u_form_list_villes_Doublons, u_Form_About;

{$R *.DFM}

{$R CURHAND.res}
{$R CURVETO.RES}
{$R curseur_ZoomPlus.res}
{$R curseur_ZoomMoins.res}
{$R curseur_Main.res}

var aFAbout: TFAbout;

procedure Tdm.doCLoseAbout;
begin
  afAbout.Close;
  aFAbout.Free;
end;

procedure Tdm.DataModuleCreate(Sender: TObject);
begin

  aFAbout := TFAbout.create(self);
  try
    aFAbout.bInitTimer := False;
    bFirstime := True;
    aFAbout.FormStyle := fsStayOnTop;
    aFAbout.Show;
    Application.ProcessMessages;
  finally
  end;

  if ibd_BASE.Connected then ibd_BASE.Connected := False;
  ibd_BASE.DatabaseName := '';

  VersionMAJBase := '1.564';

  sNomBase := Application.Title;
  sExtentionBase := '';

  s_User_Name := 'SYSDBA';
  s_PassWord := 'masterkey';

  //Curseurs de souris
  Screen.Cursors[_CURHAND] := LoadCursor(HInstance, 'CURHAND');
  Screen.Cursors[_CURPOPUP] := LoadCursor(HInstance, 'CURPOPUP');
  Screen.Cursors[_CURSOR_ZOOM_MOINS] := LoadCursor(HInstance, 'ZOOM_MOINS');
  Screen.Cursors[_CURSOR_ZOOM_PLUS] := LoadCursor(HInstance, 'ZOOM_PLUS');
  Screen.Cursors[_CURSOR_MAIN] := LoadCursor(HInstance, 'MAIN');

  //Cration de quelques objets globaux
  fListFicheOpenInfos := TObjectList.create(true);
  fRaccourcisRac := TStringList.create;
  fRaccourcisLibelle := TStringList.create;

end;

procedure Tdm.doInitialiseVariables;
begin
  fNumDossier := -1;
  fNomDossier := '';
  fFicheActive := -1;
  fFicheOpenIndex := -1;
  fCanAddFicheOpenInList := true;

  fListFicheOpenInfos.Clear;
  fRaccourcisRac.Clear;
  fRaccourcisLibelle.Clear;

end;

procedure Tdm.doOpenDatabase;
var sVersion: string;
begin

  //initialisation des variables
  doInitialiseVariables;

  if _Context.PathFileNameBdd = '' then
    begin
      if FileExists(ExtractFilePath(Application.ExeName) + _REL_PATH_DATABASE + sNomBase + '.' + sExtentionBase) then
        begin
          _Context.PathFileNameBdd := ExtractFilePath(Application.ExeName) + _REL_PATH_DATABASE + sNomBase + '.' + sExtentionBase;
          _Context.ShouldSave := true;
        end;
    end;

  if FileExists(_Context.PathFileNameBdd) then
    begin
      sExtentionBase := Copy(_Context.PathFileNameBdd, AnsiPos('.', _Context.PathFileNameBdd) + 1, 3);
      //Ouverture de la Base (tentative...)
      if not bFirstime then _FOccupe.doActive;
      try
        try
          ibd_BASE.Connected := False;
          ibd_BASE.DatabaseName := _Context.PathFileNameBdd;

          ibd_BASE.Params.Clear;
          ibd_BASE.Params.Add('user_name=' + s_User_Name);
          ibd_BASE.Params.Add('password=' + s_PassWord);

          try
            ibd_BASE.Connected := True;
          except
            on E: EIBError do
              begin
                ShowMessage('Erreur BASE : Impossible de se connecter  la base...');
              end;
          end;

          //- Activation des transactions ---------------------------------------------------------------
          IBT_Base.Active := True;
          IBTrans_Secondaire.Active := True;

          // On fait une sauvegarde de la base
          if _Context.Backup then
            doBackup;

          //ouvre le dossier, et en cr un par dfaut si problme
          doOpenDossier(_Context.LastNumDossier);

          //Ouverture des tables de rfrence
          IBQPrefixes.Params[0].ASstring := _Context.Langue;
          IBQPrefixes.open;

          IBQTypeUnion.Params[0].ASstring := _Context.Langue;
          IBQTypeUnion.open;

          IBQTypeTemoin.Params[0].ASstring := _Context.Langue;
          IBQTypeTemoin.Open;

          IBQFiliation.Params[0].ASstring := _Context.Langue;
          IBQFiliation.Open;

          IBQueryRefEvInd.Open;

          IBQVersionBase.Open;
          sVersion := Trim(IBQVersionBaseVER_VERSION.AsString);
          IBQVersionBase.CLose;

          fVersionBase := sVersion;

          IBQVersionBase.Close;

          if (VersionBase < '1.045') or (VersionBase < VersionMAJBase) then
            begin
              if not bFirstime then _FOccupe.doDesactive;
              ShowMessage('Votre base de donne est trop ancienne, allez sur le site' + #10#13 + #10#13 +
                'www.ancestrologie.com' + #10#13 + #10#13 +
                'pour tlcharger, soit l''utilitaire de migration, soit une nouvelle base');

              doCloseDatabase;
              Application.ProcessMessages;

              Application.terminate;
              exit;
              Halt(1);
            end;

        except
          {On ferme Transaction, tables et base ---------------}
          IBQPrefixes.Close;
          IBQTypeTemoin.Close;
          IBQFiliation.Close;
          IBT_Base.Active := False;
          IBTrans_Secondaire.Active := False;
          ibd_BASE.Connected := False;
          ibd_BASE.Close;
        end;

      finally
        if not bFirstime then _FOccupe.doDesactive;
      end;
    end;

  //initialisation du ControllerStyle
  InitContolerStyleWithContext;


end;

procedure Tdm.doCloseDatabase;
begin
  if ibd_BASE.Connected then
    begin
      doSaveLastFicheActiveOfDossier;

      {On ferme Transaction, tables et base ---------------}
      IBQPrefixes.Close;
      IBQTypeTemoin.Close;
      IBQFiliation.Close;

      IBT_Base.CommitRetaining;

      IBT_Base.Active := False;
      IBTrans_Secondaire.Active := False;

      ibd_BASE.Connected := False;
      ibd_BASE.Close;
    end;
end;

procedure Tdm.doSaveLastFicheActiveOfDossier;
var s_Proc: TIBStoredProc;
begin
  s_Proc := TIBStoredProc.Create(Application);

  try
    try
      with s_Proc do begin
          DataBase := ibd_BASE;
          StoredProcName := 'PROC_FERME_DOSSIER';
          Prepare;
          ParamByName('I_CLE').AsInteger := fFicheActive;
          ParamByName('I_DOSSIER').AsInteger := fNumDossier;
          ExecProc;
          Close;
        end;
    except
    end;
  finally
    s_Proc.free;
  end;
end;

function Tdm.doRecupMaxSosa(var fMaxSosa: string): Int64;
var s_Proc: TIBStoredProc;
  i_Cle: Integer;
begin
  s_Proc := TIBStoredProc.Create(Application);

  try
    with s_Proc do begin
        DataBase := ibd_BASE;
        StoredProcName := 'PROC_EXTREME_SOSA';
        Prepare;
        ParamByName('I_DOSSIER').AsInteger := fNumDossier;
        ExecProc;

        if Params[0].AsFloat > 0 then
          fMaxSosa := FormatFloat('0,', Params[0].AsFloat)
        else
          fMaxSosa := '';

        i_Cle := Params[1].AsInteger;

        Close;
      end;
  finally
    s_Proc.free;
  end;

  result := i_Cle;
end;

procedure Tdm.DataModuleDestroy(Sender: TObject);
begin
  fListFicheOpenInfos.Free;
  fRaccourcisRac.free;
  fRaccourcisLibelle.free;
  // DeleteFile(TempPath + '*.WAV');
  // DeleteFile(TempPath + '*.AVI');
  Application.ProcessMessages;
end;

{ Procedure de gestion de la base de donnes -------------------------------------------------------}

procedure Tdm.up_Comptage(a_Mode: integer);
var s_Proc: TIBQuery;
  s_Ind, s_Familles, s_Union, s_Hommes, s_Femmes, s_Indeter, s_Lieux, s_Chaine: string;
  s_MaxSosa: string;
begin
  s_Proc := TIBQuery.Create(Application);

  s_Ind := '0';
  s_Familles := '0';
  s_Union := '0';
  s_Hommes := '0';
  s_Femmes := '0';
  s_Indeter := '0';

  with s_Proc do begin
      DisableControls;
      DataBase := ibd_BASE;
      SQL.ADD('SELECT * FROM PROC_COMPTAGE(:DOSSIER, :I_MODE)');
      Params[0].AsInteger := fNumDossier;
      Params[1].AsInteger := a_Mode;
      Open;

      while not Eof do begin
          if FieldByName('LIBELLE').AsString = 'PATRONY' then
            s_Familles := IntToStr(FieldByName('COMPTAGE').AsInteger)
          else if FieldByName('LIBELLE').AsString = 'INDIVID' then
            begin
              s_Ind := IntToStr(FieldByName('COMPTAGE').AsInteger);
              fNbInd := FieldByName('COMPTAGE').AsInteger;
            end
          else if FieldByName('LIBELLE').AsString = 'TUNIONS' then
            s_Union := IntToStr(FieldByName('COMPTAGE').AsInteger)
          else if FieldByName('LIBELLE').AsString = '_HOMMES' then
            s_Hommes := IntToStr(FieldByName('COMPTAGE').AsInteger)
          else if FieldByName('LIBELLE').AsString = '_FEMMES' then
            s_Femmes := ', ' + IntToStr(FieldByName('COMPTAGE').AsInteger)
          else if FieldByName('LIBELLE').AsString = 'INDETER' then
            s_Indeter := IntToStr(FieldByName('COMPTAGE').AsInteger)
          else if FieldByName('LIBELLE').AsString = '__LIEUX' then
            s_Lieux := IntToStr(FieldByName('COMPTAGE').AsInteger);

          next;
        end;
      EnableControls;
      Close;
    end;

  if StrToInt(s_Indeter) <= 0 then
    s_Indeter := ' )'
  else
    s_Indeter := ', ' + s_Indeter + ' ?)';

  doRecupMaxSosa(s_MaxSosa);

  s_Chaine := s_Ind + ' Individus ' +
    Chr(13) + Chr(10) + '(' + s_Hommes + ' hommes' + s_Femmes + ' femmes' + s_Indeter +
    Chr(13) + Chr(10) + Chr(13) + Chr(10) + s_Familles + ' patronymes' +
    Chr(13) + Chr(10) + s_Union + ' unions' +
    Chr(13) + Chr(10) + Chr(13) + Chr(10) + s_Lieux + ' Lieux favoris';

  if Length(s_MaxSosa) > 0 then
    s_Chaine := s_Chaine +
      Chr(13) + Chr(10) +
      Chr(13) + Chr(10) + 'Plus grand N SOSA : ' + s_MaxSosa;

  ////////////////$$$$$$$$$$     FMain.lbNomDossier.Hint := s_Chaine;
  s_Proc.Free;
end;

function Tdm.uf_GetClefUnique(a_Mode: string): integer;
{
Permet de recuperer une clef unique
}
begin
  with IBSpClefUnique do begin
      Close;
      Params[1].AsString := a_Mode;
      Prepare;
      ExecProc;
      result := Params[0].AsInteger;
      Close;
    end;
end;

function Tdm.DoClearDatabase: boolean;
{
Permet de vider la base
}
var s_Proc: TIBStoredProc;
begin

  s_Proc := TIBStoredProc.Create(Application);

  with s_Proc do begin
      DataBase := ibd_BASE;
      StoredProcName := 'PROC_VIDE_BASE';
      Prepare;
      ParamByName('I_CLEF').AsInteger := 0;
      ExecProc;
      Close;
    end;

  s_Proc.Free;

  result := True;
end;

function Tdm.DoClearDossier: boolean;
{
Permet de vider le dossier selectionner
}
var s_Proc: TIBStoredProc;
begin

  s_Proc := TIBStoredProc.Create(Application);

  with s_Proc do begin
      DataBase := ibd_BASE;
      StoredProcName := 'PROC_VIDE_DOSSIER';
      Prepare;
      ParamByName('I_CLEF').AsInteger := NumDossier;
      ExecProc;
      Close;
    end;

  s_Proc.Free;

  result := True;
end;

procedure Tdm.doOpenDossier(i_dossier: smallint);
{
Permet de connaitre le nom du dossier slectionn
}
var s_Proc: TIBStoredProc;

begin
  fFicheActive := -1;
  fListFicheOpenInfos.Clear;
  fFicheOpenIndex := -1;

  s_Proc := TIBStoredProc.Create(Application);

  try
    with s_Proc do
      begin
        DataBase := ibd_BASE;
        StoredProcName := 'PROC_TROUVE_DOSSIER';
        Prepare;
        ParamByName('I_CLE').AsInteger := i_dossier;
        ParamByName('I_NOM').AsString := 'Mon premier dossier';
        ParamByName('I_INFOS').AsString := 'Ce dossier, est le dossier cr par dfaut, vous pouvez changer son nom et ses informations';
        ExecProc;
        fNumDossier := Params[0].AsInteger;
        fNomDossier := Params[1].AsString;
        fFicheActive := Params[2].AsInteger;
      end;

  finally
    s_Proc.Free;
  end;

  LoadRaccourcis;
  LoadMotClefDate;
end;

function Tdm.uf_MaxIndividu: Integer;
{
Permet de connaitre le plus grand N individu
ou -1 si base vide
}
var s_Proc: TIBStoredProc;
  i_Max: Integer;
begin

  s_Proc := TIBStoredProc.Create(Application);

  with s_Proc do begin
      DataBase := ibd_BASE;
      StoredProcName := 'PROC_MAX_CLE_INDIVIDU';
      Prepare;
      ParamByName('I_DOSSIER').AsInteger := fNumDossier;
      ExecProc;
      i_Max := Params[0].AsInteger;
    end;

  s_Proc.Free;
  result := i_Max;
end;


procedure Tdm.up_RenumSosa(a_Cle: integer);
{
Lance la renumerotation SOSA a partir d un individu
}
var s_Proc: TIBStoredProc;
begin
  s_Proc := TIBStoredProc.Create(Application);

  with s_Proc do begin
      DataBase := ibd_BASE;
      StoredProcName := 'PROC_RENUM_SOSA';
      Prepare;
      ParamByName('I_CLEF').AsInteger := a_Cle;
      ParamByName('I_NIVEAU').AsInteger := 0;
      ParamByName('I_DOSSIER').AsInteger := fNumDossier;
      ExecProc;

      IBT_BASE.CommitRetaining;
    end;

  s_Proc.Free;

end;
{ --------------------------------------------------------------------------------------------------}

procedure Tdm.InitContolerStyleWithContext;
begin
  StyleController.BorderColor := _Context.SC_BorderColor;

  if _Context.SC_BorderStyle = 'xbsSingle' then StyleController.BorderStyle := xbsSingle
  else
    if _Context.SC_BorderStyle = 'xbsThick' then StyleController.BorderStyle := xbsThick
    else
      if _Context.SC_BorderStyle = 'xbsFlat' then StyleController.BorderStyle := xbsFlat
      else
        if _Context.SC_BorderStyle = 'xbs3D' then StyleController.BorderStyle := xbs3D
        else
          StyleController.BorderStyle := xbsNone;


  if _Context.SC_ButtonStyle = 'bts3D' then StyleController.ButtonStyle := bts3D
  else
    if _Context.SC_ButtonStyle = 'btsFlat' then StyleController.ButtonStyle := btsFlat
    else
      if _Context.SC_ButtonStyle = 'btsSimple' then StyleController.ButtonStyle := btsSimple
      else
        if _Context.SC_ButtonStyle = 'btsHotFlat' then StyleController.ButtonStyle := btsHotFlat
        else
          StyleController.ButtonStyle := btsDefault;

  if _Context.SC_Transparence = 'ebtInactive' then StyleController.ButtonTransparence := ebtInactive
  else
    if _Context.SC_Transparence = 'ebtAlways' then StyleController.ButtonTransparence := ebtAlways
    else
      if _Context.SC_Transparence = 'ebtHideInactive' then StyleController.ButtonTransparence := ebtHideInactive
      else
        StyleController.ButtonTransparence := ebtNone;

  if _Context.SC_EdgesLeft then StyleController.Edges := StyleController.Edges + [edgLeft] else StyleController.Edges := StyleController.Edges - [edgLeft];
  if _Context.SC_EdgesTop then StyleController.Edges := StyleController.Edges + [edgTop] else StyleController.Edges := StyleController.Edges - [edgTop];
  if _Context.SC_EdgesRight then StyleController.Edges := StyleController.Edges + [edgRight] else StyleController.Edges := StyleController.Edges - [edgRight];
  if _Context.SC_EdgesBottom then StyleController.Edges := StyleController.Edges + [edgBottom] else StyleController.Edges := StyleController.Edges - [edgBottom];

  StyleController.HotTrack := _Context.SC_HotTrack;
  StyleController.Shadow := _Context.SC_Shadow;
end;

procedure Tdm.SetFicheActive(const Value: integer);
begin
  fFicheActive := Value;
  //     _Context.LastCleFiche := Value;
  //     _Context.ShouldSave := true;
end;

procedure Tdm.SetNumDossier(const Value: integer);
begin
  fNumDossier := Value;
  _Context.LastNumDossier := Value;
  _Context.ShouldSave := true;
end;

procedure Tdm.LoadFavoris(menu: TdxBarSubItem);
var
  n, sex: integer;
  s: string;
  item: TdxBarButton;
  ok: boolean;
begin
  FMain.dxBarManager.LockUpdate := true;
  try
    ok := false;

    //destruction des options anciennes
    for n := menu.ItemLinks.count - 1 downto 0 do
      begin
        if TdxBarButton(menu.itemLinks[n].item).Tag >= 0 then
          menu.itemLinks.Delete(n);
      end;

    //chargement
    try
      QueryGetFavoris.Close;
      QueryGetFavoris.ParamByName('I_DOSSIER').AsInteger := fNumDossier;
      QueryGetFavoris.Open;
      QueryGetFavoris.last;
      QueryGetFavoris.first;

      for n := 1 to QueryGetFavoris.RecordCount do
        begin
          s := u_common_func.AssembleString([
            { QueryGetFavoris.FieldByName('PREFIXE').AsString,}
            QueryGetFavoris.FieldByName('NOM').AsString,
              QueryGetFavoris.FieldByName('PRENOM').AsString]);
          if s <> '' then
            begin

              item := TdxBarButton.Create(Self);
              item.caption := s;

              sex := QueryGetFavoris.FieldByName('SEXE').AsInteger;
              if sex = 1 then item.ImageIndex := 39
              else if sex = 2 then item.ImageIndex := 38;
              item.tag := QueryGetFavoris.FieldByName('CLE_FICHE').AsInteger;
              item.OnClick := FMain.OnClickOnFavoris;

              menu.ItemLinks.Add.Item := item;

              if n = 1 then Menu.ItemLinks.Items[Menu.ItemLinks.Count - 1].BeginGroup := True;

              Ok := true;
            end;

          QueryGetFavoris.Next;
        end;
    finally
      QueryGetFavoris.Close;
    end;

  finally
    fmain.dxbDelFavoris.Enabled := Ok;
    FMain.dxBarManager.LockUpdate := false;
  end;
end;

procedure Tdm.DelFavoris;
begin
  with IBStoredDelFavoris do begin
      Close;
      ParamByName('I_DOSSIER').AsInteger := fNumDossier;
      Prepare;
      ExecProc;

      Close;
    end;

  LoadFavoris(FMain.menu_Favoris)
end;

procedure Tdm.AddToFavoris(cle: integer);
begin
  SPInsertFavoris.Close;
  SPInsertFavoris.Params[0].AsInteger := fNumDossier;
  SPInsertFavoris.Params[1].AsInteger := cle;
  SPInsertFavoris.Params[2].AsInteger := _Context.MaxFavoris;
  SPInsertFavoris.Prepare;
  SPInsertFavoris.ExecProc;
  SPInsertFavoris.Close;
end;

function Tdm.up_DateControl(a_Cle: Integer; a_Date: TDate; a_Year: SmallInt; a_Table: string; a_Cle_Conjoint: Integer): SmallInt;
var s_Query: TIBQuery;
  i_Retour: SmallInt;
  s_Chaine: string;
begin
  s_Query := TIBQuery.Create(Application);

  with s_Query do begin
      DataBase := ibd_BASE;
      SQL.ADD('SELECT RETOUR FROM PROC_DATE_CONTROLE(:ICLE, :A_DATE, :A_YEAR, :A_TABLE, :A_CLE_CONJOINT)');
      Prepare;
      Params[0].AsInteger := a_Cle;
      Params[1].AsDate := a_Date;
      Params[2].AsInteger := a_Year;
      Params[3].AsString := a_Table;
      Params[4].AsInteger := a_Cle_Conjoint;
      Open;

      i_Retour := FieldByName('RETOUR').AsInteger;
      IBT_BASE.CommitRetaining;
    end;

  s_Query.Free;

  case i_Retour of
    0: s_Chaine := '';
    -1: s_Chaine := 'La date est infrieure  la date de naissance...';
    1: s_Chaine := 'La date est suprieure  la date de dcs...';
    -2: s_Chaine := 'La date est infrieure  la date de mariage...';
    2: s_Chaine := 'La date est suprieure  la date de divorce';
  end;

  ShowMessage(s_Chaine);

  Result := i_Retour;
end;

procedure Tdm.AddFicheOpen(CleFiche, Sexe: integer; TitreNomPrenom: string);
var
  suite: boolean;
  aFicheOpenInfo: TFicheOpenInfo;
begin
  if fCanAddFicheOpenInList then
    begin
      suite := true;

      if (fFicheOpenIndex >= 0) and (fFicheOpenIndex < fListFicheOpenInfos.Count) then
        begin
          suite := TFicheOpenInfo(fListFicheOpenInfos[fFicheOpenIndex]).CleFiche <> CleFiche;
        end;

      if suite then
        begin
          aFicheOpenInfo := TFicheOpenInfo.create;
          aFicheOpenInfo.CleFiche := CleFiche;
          aFicheOpenInfo.Sexe := Sexe;
          aFicheOpenInfo.TitreNomPrenom := TitreNomPrenom;

          //O insrer ?
          if (fListFicheOpenInfos.Count = 0) or (fFicheOpenIndex < 0) or (fFicheOpenIndex >= fListFicheOpenInfos.Count) or (fFicheOpenIndex = fListFicheOpenInfos.Count - 1) then
            begin
              if fListFicheOpenInfos.Count > 20 then fListFicheOpenInfos.Delete(0);
              fFicheOpenIndex := fListFicheOpenInfos.Add(aFicheOpenInfo);
            end
          else
            begin
              fListFicheOpenInfos.Insert(fFicheOpenIndex + 1, aFicheOpenInfo);
              fFicheOpenIndex := fFicheOpenIndex + 1;

              if fListFicheOpenInfos.Count > 20 then
                begin
                  //soit on vire au dbut
                  if fFicheOpenIndex >= 10 then
                    begin
                      fListFicheOpenInfos.Delete(0);
                      dec(fFicheOpenIndex);
                    end
                  else
                    //on vire  la fin
                    begin
                      fListFicheOpenInfos.Delete(fListFicheOpenInfos.count - 1);
                      dec(fFicheOpenIndex);
                    end;
                end;
            end;
        end;
    end;
end;

{ TFicheOpenInfo }

constructor TFicheOpenInfo.Create;
begin
  fCleFiche := -1;
  fSexe := -1;
  fTitreNomPrenom := '';
end;

procedure Tdm.VerifyInfosInListFicheOpen(CleFiche, Sexe: integer; TitreNomPrenom: string);
var
  n: integer;
begin
  for n := 0 to fListFicheOpenInfos.Count - 1 do
    begin
      if TFicheOpenInfo(fListFicheOpenInfos[n]).CleFiche = CleFiche then
        begin
          TFicheOpenInfo(fListFicheOpenInfos[n]).Sexe := Sexe;
          TFicheOpenInfo(fListFicheOpenInfos[n]).TitreNomPrenom := TitreNomPrenom;
        end;
    end;
end;


procedure Tdm.EngineRaccourcis_TdxDBPopupEdit(adxEdit: TdxDBPopupEdit; Key: Word; Shift: TShiftState);
var
  s, m: string;
  k: integer;
begin
  if (Key = VK_SPACE) {and (ssCtrl in Shift)} then
    begin
      s := 'TRUC';
      m := adxEdit.Text;
      k := adxEdit.SelStart;
      adxEdit.Text := copy(m, 1, k) + s + copy(m, k + 1, length(m) - k);
      adxEdit.SelStart := k + length(s);
    end;
end;

function Tdm.EngineRaccourcis_TdxDBPopupEdit2(adxEdit: TdxDBPopupEdit; Key: Word; Shift: TShiftState; var aText: string; var aSelStart: integer): boolean;
var
  s, m, r: string;
  k: integer;
  w: integer;
  deb, fin: integer;
begin
  result := false;

  if (Key = VK_SPACE) { and (ssCtrl in Shift) } then
    begin
      //       	p:=fRaccourcisRac

      s := adxEdit.Text;
      w := adxEdit.SelStart;
      for k := adxEdit.SelStart downto 1 do
        if s[k] = ' ' then
          begin
            w := k;
            break;

          end;
      if w = adxEdit.SelStart then
        begin
          deb := 1;
          fin := w;
        end
      else
        begin
          deb := w + 1;
          fin := adxEdit.SelStart;
        end;

      r := copy(s, deb, fin - deb + 1);

      w := fRaccourcisRac.IndexOf(r);
      if w <> -1 then
        begin
          if (w >= 0) and (w < fRaccourcisLibelle.Count) then
            begin
              m := adxEdit.Text;
              aText := copy(m, 1, deb - 1) + fRaccourcisLibelle[w] + copy(m, fin + 1, length(m) - fin);
              aSelStart := fin + length(fRaccourcisLibelle[w]) - 2;

              result := true;
            end;
        end;
    end;
end;


procedure Tdm.LoadRaccourcis;
var
  n: integer;
begin
  fRaccourcisRac.clear;
  fRaccourcisLibelle.clear;

  IBQueryRaccourcis.Close;
  try
    IBQueryRaccourcis.ParamByName('RAC_DOSSIER').AsInteger := fNumDossier;
    IBQueryRaccourcis.ParamByName('RAC_LANGUE').AsString := _Context.Langue;
    IBQueryRaccourcis.Open;
    IBQueryRaccourcis.Last;
    IBQueryRaccourcis.First;

    for n := 1 to IBQueryRaccourcis.RecordCount do
      begin

        fRaccourcisRac.Add(IBQueryRaccourcis.FieldByName('RAC_RAC').AsString);
        fRaccourcisLibelle.Add(IBQueryRaccourcis.FieldByName('RAC_LIBELLE').AsString);
        IBQueryRaccourcis.Next;
      end;
  finally
    IBQueryRaccourcis.Close;
  end;
end;

procedure Tdm.LoadMotClefDate;
var
  s: string;
  n: integer;
begin
  QueryGetMotClefsDate.Close;
  try
    try
      ClearListToken;

      QueryGetMotClefsDate.ParamByName('LANGUE').AsString := _Context.Langue;
      QueryGetMotClefsDate.Open;
      QueryGetMotClefsDate.Last;
      QueryGetMotClefsDate.First;
      for n := 1 to QueryGetMotClefsDate.RecordCount do
        begin
          s := QueryGetMotClefsDate.FieldByName('TOKEN').AsString;
          if s <> '' then
            begin
              case QueryGetMotClefsDate.FieldByName('TYPE_TOKEN').AsInteger of

                _TYPE_TOKEN_JANVIER: Token_Human_Month_01.Add(s);
                _TYPE_TOKEN_FEVRIER: Token_Human_Month_02.Add(s);
                _TYPE_TOKEN_MARS: Token_Human_Month_03.Add(s);
                _TYPE_TOKEN_AVRIL: Token_Human_Month_04.Add(s);
                _TYPE_TOKEN_MAI: Token_Human_Month_05.Add(s);
                _TYPE_TOKEN_JUIN: Token_Human_Month_06.Add(s);
                _TYPE_TOKEN_JUILLET: Token_Human_Month_07.Add(s);
                _TYPE_TOKEN_AOUT: Token_Human_Month_08.Add(s);
                _TYPE_TOKEN_SEPTEMBRE: Token_Human_Month_09.Add(s);
                _TYPE_TOKEN_OCTOBRE: Token_Human_Month_10.Add(s);
                _TYPE_TOKEN_NOVEMBRE: Token_Human_Month_11.Add(s);
                _TYPE_TOKEN_DECEMBRE: Token_Human_Month_12.Add(s);
                _TYPE_TOKEN_DU: Token_Du.Add(s);
                _TYPE_TOKEN_AU: Token_Au.Add(s);
                _TYPE_TOKEN_AVANT: Token_Avant.Add(s);
                _TYPE_TOKEN_APRES: Token_Apres.Add(s);
                _TYPE_TOKEN_ENTRE: Token_Entre.Add(s);
                _TYPE_TOKEN_ET: Token_Et.Add(s);
                _TYPE_TOKEN_CALCULEE: Token_Calculee.Add(s);
                _TYPE_TOKEN_ESTIMEE: Token_Estimee.Add(s);
                _TYPE_TOKEN_VERS: Token_Vers.Add(s);
                _TYPE_TOKEN_SEPARATEUR_DATE: Separator_Human_Date.Add(s);
              end;
            end;

          QueryGetMotClefsDate.Next;
        end;
    except
    end;
  finally
    QueryGetMotClefsDate.Close;
    _GDate.AssignTokens;
  end;
end;

function Tdm.GetCleUnion(cle_mari, cle_femme: integer): integer;
begin
  try
    IBStoredProcGetUnion.Close;
    IBStoredProcGetUnion.Params[1].AsInteger := fNumDossier;

    if cle_mari <= 0 then IBStoredProcGetUnion.Params[2].AsInteger := 0
    else IBStoredProcGetUnion.Params[2].AsInteger := cle_mari;

    if cle_femme <= 0 then IBStoredProcGetUnion.Params[3].AsInteger := 0
    else IBStoredProcGetUnion.Params[3].AsInteger := cle_femme;

    IBStoredProcGetUnion.Prepare;
    IBStoredProcGetUnion.ExecProc;
    result := IBStoredProcGetUnion.Params[0].AsInteger;
    IBStoredProcGetUnion.Close;
  except
    result := -1;
  end;
end;

procedure Tdm.doExportImages;
var s_Query: TIBQuery;
  s_Chaine: string;
  i: integer;
  MS: TMemoryStream;
  J1: TJPEGImage;
  Save_Cursor: TCursor;
  ok: boolean;
begin

  Ok := MyMessageDlg('L''exportation des images et des documents va se faire dans le rpertoire' +
    ' choisis dans les prfrences. Les images portant le mme nom seront crases. '#13#10#13#10' Voulez-vous continuer ?', mtWarning, [mbYes, mbNo], 0) = mrYes;
  if ok then
    begin
      Application.ProcessMessages;

      if DirExists(_Context.PathImages) then
        begin

          Application.ProcessMessages;
          Save_Cursor := Screen.Cursor;
          Screen.Cursor := crHourglass;

          s_Query := TIBQuery.Create(Application);

          with s_Query do begin
              DataBase := ibd_BASE;
              SQL.ADD('SELECT * FROM PROC_EXPORT_IMAGES (:IDOSSIER)');
              Prepare;
              Params[0].AsInteger := fNumDossier;
              Open;
              Last;
              First;

              i := 0;

              while not eof do
                begin

                  MS := TMemoryStream.Create;
                  J1 := TJPEGImage.Create;

                  s_Chaine := FieldByName('NOM').AsString;
                  TBlobField(FieldByName('MULTI_MEDIA')).SaveToStream(MS);
                  MS.Seek(soFromBeginning, 0);
                  J1.LoadFromStream(MS);

                  j1.SaveToFile(_Context.PathImages + '\' + s_Chaine + '.JPG');
                  next;
                  MS.Free;
                  j1.Free;

                  Inc(i);
                end;

            end;

          s_Query.Free;
          Screen.Cursor := Save_Cursor;

          if i > 0 then
            begin
              MyMessageDlg('L''exportation de ' + IntToStr(i) + ' image(s) s''est bien passe.'#13#10#13#10'Celles ci se trouvent dans le rpertoire : '#13#10 + _Context.PathImages, mtInformation, [mbOK], 0);

              shellexecute(application.handle, nil, pchar('EXPLORER'), pchar(_Context.PathImages), nil, SW_SHOWNORMAL);
            end
          else
            begin
              MyMessageDlg('Il n''y avait aucune image  exporter.', mtInformation, [mbOK], 0);
            end;
        end
      else
        MyMessageDlg('Le rpertoire d''exportation des images est incorrect.'#13#10#13#10'Merci de choisir un rpertoire valide depuis les prfrences gnrales.', mtInformation, [mbOK], 0);
    end;
end;

function Tdm.doNouveaux: integer;
var s_Query: TIBQuery;
  i: integer;
begin
  s_Query := TIBQuery.Create(Application);

  with s_Query do begin
      DataBase := ibd_BASE;
      SQL.ADD('SELECT Count(*) COMBIEN FROM PROC_NOUVEAUX_IND (:D_DATE,:IDOSSIER, 1)');
      Prepare;
      Params[0].AsDate := Date - 7;
      Params[1].AsInteger := fNumDossier;
      Open;
      i := FieldByName('COMBIEN').AsInteger;

      Close;
      Free;
    end;

  result := i;
end;

procedure Tdm.ShowHelp(ID: integer);
var
  s: string;
begin
  if not _hhInstalled then MessageDlg('Vous n' + #39 + 'avez pas install Microsoft HTML Help. Veuillez l' + #39 + 'installer pour ' + #13 + #10 + 'avoir accs  l' + #39 + 'aide.', mtWarning, [], 0)
  else
    begin
      case ID of
        _HELP_BIEVENUE: s := 'A-0';
        _HELP_INDI_START: s := 'E-0';
        _HELP_INDI_IDENTITE: s := 'E-1';
        _HELP_INDI_UNIONS: s := 'E-2';
        _HELP_INDI_ARBRE: s := 'E-3';
        _HELP_INDI_PHOTO_DOC: s := 'E-4';
        _HELP_INDI_INFOS: s := 'E-5';
        _HELP_INDI_DOMICILES: s := 'E-6';
        _HELP_FAVORIS: s := 'H-4';
        _ID_REPERTOIRE: s := 'H-1';
        _ID_ARBRE: s := 'E-3';
        _ID_RECHERCHER: s := 'H-2';
        _ID_ANNIVERSAIRE: s := 'N-0';
        _ID_VILLES: s := 'G-4';
        _ID_IMPORTATION_GEDCOM: s := 'T-2';
        _ID_EXPORTATION_GEDCOM: s := 'T-1';
        _ID_EXPORTATION_GENEANET: s := 'T-3';
        _ID_INDIVIDU_PAR_PRENOM: s := 'H-2';
        _ID_PARAMETRES: s := 'WP-0';
        _ID_DOSSIER: s := 'S-0';
        _ID_NO_DOSSIER: s := 'S-0';
        _ID_PRINT_ARBRE: s := 'U-1';
        _ID_PRINT_ROUE: s := 'U-2';
        _ID_PRINT: s := 'U-3';
        _ID_POSTIT: s := 'Q-0';
        _ID_EDIT_TABLE_REF_PARTICULES: s := 'G-2';
        _ID_EDIT_TABLE_REF_PREFIXES: s := 'G-2';
        _ID_EDIT_RACCOURCIS_SAISIE: s := 'G-3';
        _ID_CONNECTOR: s := 'J-0';
        _ID_EMPLACEMENT_BDD: s := 'R-0';
        _HELP_PB_BDD: s := 'YA-2';
        _ID_RESTORE_BDD: s := 'X-0';
        _ID_EDIT_TOKEN_DATE: s := 'YA-1';
        _ID_SAISIE_RAPIDE: s := 'F-0';
        _ID_INFOS_DOSSIER: s := 'P-0';
        _ID_NOUVEAUX_INDI: s := '';
        _ID_NAVIGATEUR_INDI: s := 'H-3';
        _ID_LANGUAGE: s := 'D-2';
        _ID_VILLES_FAVORIS: s := 'F-1';

        else s := '';
      end;

      if s <> '' then
        begin
          HtmlHelp(GetDesktopWindow, PChar(_Path_Appli + _REL_PATH_HELP + _FileNameHelp + '::/' + s + '.htm'), HH_DISPLAY_TOPIC, 0);
        end;
    end;
end;

function Tdm.GetTotalIndividuDossier: integer;
begin
  Result := -1;
  try
    QTotalIndiDossier.Close;
    QTotalIndiDossier.ParamByName('I_DOSSIER').AsInteger := fNumDossier;
    QTotalIndiDossier.Open;
    QTotalIndiDossier.Last;
    QTotalIndiDossier.First;
    if QTotalIndiDossier.RecordCount = 1 then result := QTotalIndiDossier.FieldByName('total').AsInteger;
    QTotalIndiDossier.Close;
  except
  end;
end;

procedure Tdm.doBackup;
var
  IBBackup: TIBBackupService;
  FileNameGBK, PathNameGBK: string;
begin

  IBT_BASE.CommitRetaining;
  IBTrans_Secondaire.CommitRetaining;

  try
    FileNameGBK := ExtractFileName(_Context.PathFileNameBdd);
    FileNameGBK := ChangeFileExt(FileNameGBK, '.GBK');
    PathNameGBK := ExtractFilePath(_Context.PathFileNameBdd) + _REL_PATH_BACKUP;
    if not DirExists(PathNameGBK) then
      begin
        MkDir(PChar(PathNameGBK));
        if not DirExists(PathNameGBK) then Exit;
      end;

    IBBackup := TIBBackupService.Create(Self);
    with IBBackup do
      begin
        LoginPrompt := False;
        Params.Add('user_name=' + s_User_Name);
        Params.Add('password=' + s_PassWord);

        Active := True;

        try
          Verbose := True;
          Options := [NonTransportable, IgnoreLimbo];
          DatabaseName := _Context.PathFileNameBdd;
          BackupFile.Add(PathNameGBK + FileNameGBK);
          ServiceStart;

        finally
          Active := False;
        end;
      end;
  finally
  end;
  IBBackup.Free;

end;

procedure Tdm.DoUpdateDLL;
begin
  with IBQUpdateDLL do
    begin
      Params[0].AsInteger := fNumDossier;
      Params[1].AsInteger := fFicheActive;
      Open;
      IBT_BASE.CommitRetaining;
      close;
    end;

end;



procedure Tdm.doMajInsee;
var s_Proc: TIBStoredProc;
begin
  if MessageDlg('Attention : Cette action peut durer plusieurs minutes - Voulez-vous continuer ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      Application.ProcessMessages;
      Screen.Cursor := crHourGlass;
      s_Proc := TIBStoredProc.Create(Application);

      try
        try
          with s_Proc do begin
              DataBase := ibd_BASE;
              StoredProcName := 'PROC_MAJ_LIEUX_FAVORIS';
              Prepare;
              ParamByName('I_DOSSIER').AsInteger := fNumDossier;
              ExecProc;
            end;
        except
        end;
      finally
        begin
          s_Proc.UnPrepare;
          s_Proc.free;
        end;
      end;

      Screen.Cursor := crDefault;
    end;
end;

procedure Tdm.doChangeInsee;
var s_Proc: TIBStoredProc;
begin

  Application.ProcessMessages;
  Screen.Cursor := crHourGlass;
  if not bFirstime then _FOccupe.doActive;

  s_Proc := TIBStoredProc.Create(Application);
  try
    try

      with s_Proc do begin
          DataBase := ibd_BASE;
          StoredProcName := 'PROC_PERMUTATION_INSEE';
          Prepare;
          ParamByName('I_DOSSIER').AsInteger := fNumDossier;
          ExecProc;
          IBT_BASE.CommitRetaining;
        end;
    except
      IBT_BASE.RollbackRetaining;
    end;
  finally
    begin
      s_Proc.UnPrepare;
      s_Proc.free;
    end;
  end;

  s_Proc := TIBStoredProc.Create(Application);
  try
    try

      with s_Proc do begin
          DataBase := ibd_BASE;
          StoredProcName := 'PROC_PERMUTATION_INSEE_SUITE';
          Prepare;
          ParamByName('I_DOSSIER').AsInteger := fNumDossier;
          ExecProc;
        end;
    except
      begin
        MessageDlg('Impossible de mettre  jour automatiquement les codes Insee,' + #10#13 +
          'car des codes Insee sont en doubles.' + #10#13#10#13 +
          'Allez dans le menu Confuration et Liste des villes Franaise en doublons...', mtConfirmation, [mbOk], 0);
        IBT_BASE.RollbackRetaining;
      end;
    end;
  finally
    begin
      s_Proc.UnPrepare;
      s_Proc.free;
    end;
  end;

  if not bFirstime then _FOccupe.doDesactive;
  Screen.Cursor := crDefault;

end;

function Tdm.GetUrlInfos: string;
begin
  Result := urlInfos;
end;

function Tdm.GetUrlAncestrologie: string;
begin
  Result := urlAncestrologie;
end;

function Tdm.GetUrlMajAuto: string;
begin
  Result := urlMajAuto;
end;

function Tdm.GetUrlSite: string;
begin
  Result := urlSite;
end;

function Tdm.GetEmail: string;
begin
  Result := sEmail;
end;

function Tdm.GetUrlInfosMaj: string;
begin
  Result := urlInfosMaj;
end;

function Tdm.GeturlListeDiffusion: string;
begin
  Result := urlListeDiffusion;
end;

end.

