{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit dede;

interface

uses
  Windows, CompSuperForm, Forms, TFlatTabControlUnit, dxExEdtr, DB,
  IBCustomDataSet, IBQuery, dxTL, dxDBCtrl, dxDBTLCl, dxGrClms, dxCntner,
  dxDBGrid, u_comp_TYLanguage, StdCtrls, u_comp_TGoodBtn, TFlatPanelUnit,
  Controls, Buttons, Classes, ExtCtrls, Graphics, Messages, Jpeg;

type
  TFdede = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pTop: TPanel;
    sbClose: TSpeedButton;
    lTitre: TLabel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    ftMedias: TFlatTabControl;
    dxDBGrid1: TdxDBGrid;
    dxDBGrid1Column2: TdxDBGridGraphicColumn;
    IBMultimedia: TIBQuery;
    IBMultimediaMULTI_REDUITE: TBlobField;
    DSMultimedia: TDataSource;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnFermerClick(Sender: TObject);
    procedure ftMediasTabChanged(Sender: TObject);
    procedure dxDBGrid1Column2GetGraphicClass(Sender: TObject;
      Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
  private
    fDialogMode: boolean;

     procedure SetDialogMode(const Value: boolean);

  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
  end;

implementation

uses u_dm, u_common_const, u_common_var;

{$R *.DFM}

procedure TFdede.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
     IBMultimedia.Open;
end;

procedure TFdede.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFdede.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;


procedure TFdede.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of

    VK_ESCAPE: ModalResult := mrCancel;

  end;
end;

procedure TFdede.btnFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFdede.ftMediasTabChanged(Sender: TObject);
var sSQL: string;
begin
  case ftMedias.ActiveTab of

    0: begin
        sSQL := 'select MULTI_REDUITE from MULTIMEDIA';
      end;

    1: begin
        sSQL := 'select MULTI_REDUITE from MULTIMEDIA WHERE MULTI_TYPE = ''P''';
      end;

    2: begin
        sSQL := 'select MULTI_REDUITE from MULTIMEDIA WHERE MULTI_TYPE = ''U''';
      end;

    3: begin
        sSQL := 'select MULTI_REDUITE from MULTIMEDIA WHERE MULTI_NUM_ACTE > 0';
      end;

    4: begin
        sSQL := 'select MULTI_REDUITE from MULTIMEDIA WHERE MULTI_TYPE = ''E''';
      end;

    5: begin
        sSQL := 'select MULTI_REDUITE from MULTIMEDIA WHERE MULTI_INDIVIDU <= 0';
      end;
  end;

  IBMultimedia.Close;
  IBMultimedia.SQL.Clear;
  IBMultimedia.SQL.Add(sSQL);
  IBMultimedia.Open;
end;

procedure TFdede.dxDBGrid1Column2GetGraphicClass(Sender: TObject;
  Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
begin
  GraphicClass := TJPEGImage;
end;

end.

