{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_Bibliotheque_Multimedia;

interface

uses
  Windows, CompSuperForm, IBCustomDataSet, IBUpdateSQL, Dialogs, ExtDlgs,
  u_comp_TScanner, DB, IBQuery, u_comp_TYLanguage, TFlatTabControlUnit,
  StdCtrls, u_comp_TGoodBtn, TFlatPanelUnit, Controls, Buttons, Classes,
  ExtCtrls, Forms, Jpeg, Messages, dxExEdtr, dxDBTLCl, dxGrClms, dxGrClEx,
  dxTL, dxDBCtrl, dxDBGrid, dxCntner, Graphics, Menus, SysUtils, dxDBedtr,
  GraphicEx, MPlayer, DynamicSkinForm;

type

  TFBibliothequeMultimedia = class(TSuperForm)
    pBorder: TPanel;
    pGeneral: TPanel;
    pGlobal: TPanel;
    fpBoutons: TFlatPanel;
    pBottom: TPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    ftMedias: TFlatTabControl;
    IBMultimedia: TIBQuery;
    DSMultimedia: TDataSource;
    btnAjoutImage: TGoodBtn;
    btnScanner: TGoodBtn;
    btnAjoutSons: TGoodBtn;
    btnAjoutVideos: TGoodBtn;
    Scanner: TScanner;
    OpenPictureDialog: TOpenPictureDialog;
    OpenDialog: TOpenDialog;
    OpenDialogSons: TOpenDialog;
    OpenDialogVideo: TOpenDialog;
    IBUMultimedia: TIBUpdateSQL;
    dxDBGrid: TdxDBGrid;
    colInfos: TdxDBGridColumn;
    colMemo: TdxDBGridMemoColumn;
    colImage: TdxDBGridGraphicColumn;
    Panel3: TPanel;
    Image1: TImage;
    FlatPanel1: TFlatPanel;
    btnSelection: TGoodBtn;
    pmImage: TPopupMenu;
    IBQQui: TIBQuery;
    IBQQuiCLE_FICHE: TIntegerField;
    IBQQuiSEXE: TIntegerField;
    IBQQuiNOM: TIBStringField;
    IBQQuiPRENOM: TIBStringField;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_INDIVIDU: TIntegerField;
    IBMultimediaMULTI_INFOS: TIBStringField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    IBMultimediaMULTI_DOSSIER: TIntegerField;
    IBMultimediaMULTI_DATE_MODIF: TDateTimeField;
    IBMultimediaMULTI_MEMO: TMemoField;
    IBMultimediaMULTI_STRETCH: TIntegerField;
    IBMultimediaMULTI_IDENTITE: TIntegerField;
    IBMultimediaMULTI_TYPE: TIBStringField;
    IBMultimediaMULTI_REDUITE: TBlobField;
    IBMultimediaMULTI_DEVISE: TBlobField;
    IBMultimediaMULTI_CRI: TBlobField;
    IBMultimediaMULTI_DOCRTF: TBlobField;
    IBMultimediaMULTI_IMAGE_RTF: TIntegerField;
    IBMultimediaMULTI_NUM_ACTE: TIntegerField;
    IBMultimediaMULTI_TYPE_ACTE: TIBStringField;
    IBMultimediaMULTI_SONS_VIDEOS: TBlobField;
    IBMultimediaMULTI_PATH: TIBStringField;
    IBMultimediaMULTI_NOM: TIBStringField;
    btnDelete: TGoodBtn;
    Scanner1: TScanner;
    MediaPlayer: TMediaPlayer;
    iVideo: TImage;
    iSons: TImage;
    coPath: TdxDBGridColumn;
    IBQDelPointeur: TIBQuery;
    IBMpointeur: TIBQuery;
    IBMpointeurMP_CLEF: TIntegerField;
    IBMpointeurMP_MEDIA: TIntegerField;
    IBMpointeurMP_POINTE_SUR: TIntegerField;
    IBMpointeurMP_TABLE: TIBStringField;
    IBMpointeurMP_IDENTITE: TIntegerField;
    IBMpointeurMP_KLE_DOSSIER: TIntegerField;
    IBUPointeur: TIBUpdateSQL;
    IBQDelPointeurActes: TIBQuery;
    IBMpointeurMP_TYPE_IMAGE: TIBStringField;
    IBMpointeurMP_CLE_INDIVIDU: TIntegerField;
    spDynamicSkinForm1: TspDynamicSkinForm;

    procedure SuperFormCreate(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnFermerClick(Sender: TObject);
    procedure ftMediasTabChanged(Sender: TObject);
    procedure colImageGetGraphicClass(Sender: TObject;
      Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
    procedure btnSelectionClick(Sender: TObject);
    procedure pmImagePopup(Sender: TObject);
    procedure btnAjoutImageClick(Sender: TObject);
    procedure btnAjoutSonsClick(Sender: TObject);
    procedure btnAjoutVideosClick(Sender: TObject);
    procedure btnScannerClick(Sender: TObject);
    procedure IBMultimediaNewRecord(DataSet: TDataSet);
    procedure btnDeleteClick(Sender: TObject);
    procedure IBMultimediaAfterScroll(DataSet: TDataSet);
    procedure MediaPlayerClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure sbCloseClick(Sender: TObject);

  private
    fDialogMode: boolean;
    fClef, fID: integer;
    fTable, fType: string;
    iType: Integer;

    procedure SetDialogMode(const Value: boolean);
    procedure OnSelectIndividu(Sender: TObject);
    procedure OnVoirImageClick(Sender: TObject);

    procedure doScanner;
    procedure doAjoutImage;
    procedure doAjoutSons;
    procedure doAjoutVideos;
    procedure doAjoutImageInBase(TempPathFileNameJPEG: string);

    function PutInEdition: boolean;
    procedure doAddPointeur(clef: Integer);
  public
    property DialogMode: boolean read fDialogMode write SetDialogMode;
    property Clef: Integer read fClef write fClef;

    procedure doInit(bSelection: boolean; ID: integer; sTable, sType: string);
  end;

implementation

uses u_dm, u_common_const, u_common_var, u_common_func,
  u_form_biblio_Multimedia_Edit, u_form_Actes_Affectation, u_form_main;

{$R *.DFM}

//-- Gestion de la fenetre ------------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
  if _Context.Skin then
    begin
      ClientHeight := 511;
      ClientWidth := 690;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  OpenPictureDialog.InitialDir := _Context.PathImages;
  OpenPictureDialog.Filter := FileFormatList.GetGraphicFilter([], fstBoth, [foCompact, foIncludeAll, foIncludeExtension], nil);

  Scanner.TempPathName := TempPath;

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  ftMediasTabChanged(Sender);

end;

procedure TFBibliothequeMultimedia.doInit(bSelection: boolean; ID: integer; sTable, sType: string);
begin
  btnSelection.Visible := bSelection;
  fTable := sTable;
  fType := sType;
  fID := ID;
end;

procedure TFBibliothequeMultimedia.SetDialogMode(const Value: boolean);
begin
  fDialogMode := Value;
end;

procedure TFBibliothequeMultimedia.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFBibliothequeMultimedia.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
  end;
end;
//-------------------------------------------------------------------------------------------------------
// -- Gestion des JPEG ----------------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.colImageGetGraphicClass(Sender: TObject;
  Node: TdxTreeListNode; var GraphicClass: TGraphicClass);
begin
  GraphicClass := TJPEGImage;
end;
//-------------------------------------------------------------------------------------------------------
// -- Gestion des TABS ----------------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.ftMediasTabChanged(Sender: TObject);
var sSQL: string;
begin
  IBMultimedia.DisableControls;

  case ftMedias.ActiveTab of

    0: begin // Tous
        sSQL := 'select * from MULTIMEDIA WHERE MULTI_DOSSIER = :DOSSIER ORDER BY MULTI_CLEF';
      end;

    1: begin // Evenements
        sSQL := 'select * FROM PROC_CHARGE_MEDIA(''I'', :DOSSIER) ORDER BY MULTI_CLEF';
      end;

    2: begin // Unions
        sSQL := 'select * FROM PROC_CHARGE_MEDIA(''F'', :DOSSIER) ORDER BY MULTI_CLEF';
      end;

    3: begin
        sSQL := 'select * from MULTIMEDIA WHERE MULTI_IMAGE_RTF = 2 AND ' +
          'MULTI_DOSSIER = :DOSSIER ORDER BY MULTI_CLEF';
      end;

    4: begin
        sSQL := 'select * from MULTIMEDIA WHERE MULTI_IMAGE_RTF = 3 AND ' +
          'MULTI_DOSSIER = :DOSSIER ORDER BY MULTI_CLEF';
      end;

    5: begin
        sSQL := 'select * FROM MULTIMEDIA WHERE ' +
          'MULTI_CLEF NOT IN (SELECT MP_MEDIA FROM MEDIA_POINTEURS) AND ' +
          'MULTI_DOSSIER = :DOSSIER ORDER BY MULTI_CLEF';
      end;
  end;

  IBMultimedia.Close;
  IBMultimedia.SQL.Clear;
  IBMultimedia.SQL.Add(sSQL);
  IBMultimedia.Params[0].AsInteger := dm.NumDossier;
  IBMultimedia.Open;
  IBMultimedia.First;
  IBMultimedia.Last;

  btnSelection.Enabled := IBMultimedia.RecordCount > 0;
  btnDelete.Enabled := IBMultimedia.RecordCount > 0;

  IBMultimedia.EnableControls;
end;
//-------------------------------------------------------------------------------------------------------
// -- Gestion du popup menu -----------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.pmImagePopup(Sender: TObject);
var
  NewItem: TMenuItem;
  n, i_Count: Integer;
  sNom: string;
begin
  pmImage.Items.Clear;

  if IBMultimediaMULTI_IMAGE_RTF.AsInteger = 0 then
    begin
      NewItem := TMenuItem.create(self);
      pmImage.Items.Add(NewItem);
      NewItem.Name := 'OnVoirImage';
      NewItem.Caption := 'Visualiser cette image...';
      NewItem.Onclick := OnVoirImageClick;
      NewItem.ImageIndex := 56;

      NewItem := TMenuItem.create(self);
      pmImage.Items.Add(NewItem);
      NewItem.Caption := '-';
    end;

  begin
    with IBQQui do
      begin
        DisableControls;
        Close;
        //passage des parametres ---
        Params[0].AsInteger := IBMultimediaMULTI_CLEF.AsInteger;
        Params[1].AsInteger := dm.NumDossier;
        Open;

        //{oblig de faire ca pour compter les enregs ---
        Last;
        //{----------------------------------------------

        i_Count := RecordCount;

        //si rien , on sort -------
        if i_Count <= 0 then
          begin
            close;
            exit;
          end;

        First;

        for n := 1 to i_Count do
          begin
            if n = 1 then
              begin
                NewItem := TMenuItem.create(self);
                pmImage.Items.Add(NewItem);
                NewItem.Caption := '-';
              end;

            sNom := AssembleString([
              FieldByName('NOM').AsString,
                FieldByName('PRENOM').AsString]);

            NewItem := TMenuItem.create(self);
            pmImage.Items.Add(NewItem);
            NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
            NewItem.Caption := sNom;
            NewItem.Onclick := OnSelectIndividu;

            if FieldByName('SEXE').AsInteger = 1 then
              NewItem.ImageIndex := 39
            else
              NewItem.ImageIndex := 38;

            Next
          end;
        Close;
        EnableControls; ;
      end;
  end;

end;

procedure TFBibliothequeMultimedia.OnVoirImageClick(Sender: TObject);
var
  aFMultimediEdit: TFBiblio_Multimedia_Edit;
begin
  aFMultimediEdit := TFBiblio_Multimedia_Edit.create(self);
  try

    aFMultimediEdit.doInitialise(IBMultimediaMULTI_CLEF.AsInteger, '');

    Application.ProcessMessages;
    aFMultimediEdit.ShowModal;
  finally
    aFMultimediEdit.Free;
  end;
end;

procedure TFBibliothequeMultimedia.OnSelectIndividu(Sender: TObject);
{
Action a faire lors d'un click sur un des
boutons ou menu popup
}
begin
  OpenFicheIndividuInBox(TMenuItem(Sender).Tag);
end;
//-------------------------------------------------------------------------------------------------------

// -- Gestion des querys --------------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.IBMultimediaNewRecord(
  DataSet: TDataSet);
begin
  DataSet.FieldByName('MULTI_INDIVIDU').AsInteger := 0;
  DataSet.FieldByName('MULTI_INFOS').AsString := 'Photo/Document enregistr le : ' + DateToStr(Date) + '  ' + TimeToStr(Time);
  DataSet.FieldByName('MULTI_DOSSIER').AsInteger := dm.NumDossier;
  DataSet.FieldByName('MULTI_DATE_MODIF').AsDateTime := Now;
  DataSet.FieldByName('MULTI_STRETCH').AsInteger := 0;
  DataSet.FieldByName('MULTI_IDENTITE').AsInteger := 0;
  DataSet.FieldByName('MULTI_TYPE').AsString := 'P';
  DataSet.FieldByName('MULTI_IMAGE_RTF').AsInteger := iType;
  //DataSet.FieldByName('MULTI_NOM').AsString := CreateClassID;
  if iType = 0 then
    DataSet.FieldByName('MULTI_INFOS').AsString := 'Image enregistre le : ' + DateToStr(Date) + '  ' + TimeToStr(Time)
  else if iType = 1 then
    DataSet.FieldByName('MULTI_INFOS').AsString := 'Document texte enregistr le : ' + DateToStr(Date) + '  ' + TimeToStr(Time)
  else if iType = 2 then
    DataSet.FieldByName('MULTI_INFOS').AsString := 'Document son enregistr le : ' + DateToStr(Date) + '  ' + TimeToStr(Time)
  else if iType = 3 then
    DataSet.FieldByName('MULTI_INFOS').AsString := 'Document vido enregistr le : ' + DateToStr(Date) + '  ' + TimeToStr(Time);

end;

procedure TFBibliothequeMultimedia.IBMultimediaAfterScroll(
  DataSet: TDataSet);
begin
  MediaPlayer.Close;
  MediaPlayer.FileName := '';

  MediaPlayer.Visible := IBMultimediaMULTI_IMAGE_RTF.AsInteger >= 2;

  if MediaPlayer.Visible then
    begin
      if IBMultimediaMULTI_IMAGE_RTF.AsInteger = 2 then
        MediaPlayer.DeviceType := dtWaveAudio
      else
        MediaPlayer.DeviceType := dtAviVideo;

      MediaPlayer.Open;
    end
  else
    MediaPlayer.Close;

  // if IBMultimediaMULTI_IMAGE_RTF.AsInteger = 2 then colImage.Stretch := False

end;
//-------------------------------------------------------------------------------------------------------
  // -- Gestion des Ajouts -------------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.doAddPointeur(clef: Integer);
begin
  if fType = 'A' then
    begin
      IBQDelPointeurActes.Close;
      IBQDelPointeurActes.params[0].AsInteger := fID;
      IBQDelPointeurActes.params[1].AsString := fTable;
      IBQDelPointeurActes.params[2].AsString := fType;
      IBQDelPointeurActes.params[3].AsInteger := dm.FicheActive;
      IBQDelPointeurActes.ExecSQL;
      IBQDelPointeurActes.Close;
    end;

  IBMpointeur.Open;
  IBMpointeur.Insert;

  IBMpointeurMP_CLEF.AsInteger := dm.uf_GetClefUnique('MEDIA_POINTEURS');
  IBMpointeurMP_MEDIA.AsInteger := Clef;
  IBMpointeurMP_POINTE_SUR.AsInteger := fID;
  IBMpointeurMP_TABLE.AsString := fTable;
  IBMpointeurMP_TYPE_IMAGE.AsString := fType;
  IBMpointeurMP_IDENTITE.AsInteger := 0;
  IBMpointeurMP_KLE_DOSSIER.AsInteger := dm.NumDossier;
  IBMpointeurMP_CLE_INDIVIDU.AsInteger := dm.FicheActive;

  IBMpointeur.Post;
  IBMpointeur.Close;
end;
//-------------------------------------------------------------------------------------------------------

// -- Gestion des Boutons -------------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.btnFermerClick(Sender: TObject);
begin
  if MediaPlayer.DeviceID <> 0 then
    begin
      MediaPlayer.Stop;
      MediaPlayer.Close;
    end;
  Close;
end;

procedure TFBibliothequeMultimedia.btnSelectionClick(Sender: TObject);
begin
  if MediaPlayer.DeviceID <> 0 then
    begin
      MediaPlayer.Stop;
      MediaPlayer.Close;
    end;

  fClef := IBMultimediaMULTI_CLEF.AsInteger;
  doAddPointeur(fClef);

  Close;
end;

procedure TFBibliothequeMultimedia.btnDeleteClick(Sender: TObject);
begin
  if MyMessageDlg('La suppression de ce mdia, supprimera aussi' + #10#13 +
    'tous les liens de ce media, vers les individus, vnements, etc...' + #10#13 + #10#13 +
    'Confirmez-vous ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      IBQDelPointeur.Close;
      IBQDelPointeur.Params[0].AsInteger := IBMultimediaMULTI_CLEF.AsInteger;
      IBQDelPointeur.Params[1].AsInteger := dm.NumDossier;
      IBQDelPointeur.ExecSQL;
      IBQDelPointeur.Close;

      IBMultimedia.Delete;
    end;
end;

procedure TFBibliothequeMultimedia.btnAjoutImageClick(Sender: TObject);
begin
  doAjoutImage;
end;

procedure TFBibliothequeMultimedia.btnAjoutSonsClick(Sender: TObject);
begin
  doAjoutSons;
end;

procedure TFBibliothequeMultimedia.btnAjoutVideosClick(Sender: TObject);
begin
  doAjoutVideos;
end;

procedure TFBibliothequeMultimedia.btnScannerClick(Sender: TObject);
begin
  doScanner;
end;

procedure TFBibliothequeMultimedia.MediaPlayerClick(Sender: TObject;
  Button: TMPBtnType; var DoDefault: Boolean);
var
  iMode: Integer;
  bJoue: Boolean;
  sTempWavAvi: string;
begin
  bJoue := False;
  case Button of
    btPlay:
      with MediaPlayer do
        begin
          Filename := '';

          iMode := IBMultimediaMULTI_IMAGE_RTF.AsInteger;
          DeviceType := dtAutoSelect;

          if iMode = 2 then
            sTempWavAvi := TempPath + IBMultimediaMULTI_NOM.AsString + '.WAV'
          else if iMode = 3 then
            begin
              sTempWavAvi := TempPath + IBMultimediaMULTI_NOM.AsString + '.AVI';
              MediaPlayer.Display := nil
            end;

          if FileExists(IBMultimediaMULTI_PATH.AsString) then
            begin
              sTempWavAvi := IBMultimediaMULTI_PATH.AsString;
              bJoue := True;
            end
          else
            MyMessageDlg('Le fichier que vous essayez de jouer, n''existe plus  l''endroit spcifi...',
              mtInformation, [mbOK], 0);

          if bJoue then
            begin
              Filename := sTempWavAvi;
              Open;
              visible := True;
            end;

        end;
    btStop:
      begin
        MediaPlayer.close;
        Application.ProcessMessages;
        sTempWavAvi := '';
        MediaPlayer.Open;
      end;
  end;
end;
//-------------------------------------------------------------------------------------------------------

//-- Routines d'ajout d 'images--------------------------------------------------------------------------

function TFBibliothequeMultimedia.PutInEdition: boolean;
begin
  //result := false;
  if (not (IBMultimedia.State in [dsEdit, dsInsert])) then
    begin
      IBMultimedia.Edit;
      result := true;
    end
  else
    result := true;
end;

procedure TFBibliothequeMultimedia.doAjoutImage;
var
  TempPathFileNameJPEG: string;
begin
  if OpenPictureDialog.Execute then
    begin
      if doTestTailleImage(OpenPictureDialog.FileName) = -1 then Exit;

      if ConvertionImageToJPeg(OpenPictureDialog.FileName, TempPathFileNameJPEG, _Context.TauxCompressionJPeg) then
        begin
          IBMultimedia.DisableControls;
          //Cration d'un record
          IBMultimedia.Insert;
          IBMultimedia.FieldByName('MULTI_PATH').AsString := OpenPictureDialog.FileName;

          //On ajoute l'image dans la base
          doAjoutImageInBase(TempPathFileNameJPEG);
          // TFIndividu(fFormindividu).Modified := true;

          btnSelection.Enabled := True;
          btnDelete.Enabled := True;

          IBMultimedia.EnableControls;
        end;
    end;

end;

procedure TFBibliothequeMultimedia.doScanner;
var
  TempPathFileNameJPEG: string;
begin
  if Scanner.execute then
    begin
      if doTestTailleImage(Scanner.ResultImageFileName) = -1 then Exit;

      if ConvertionImageToJPeg(Scanner.ResultImageFileName, TempPathFileNameJPEG, _Context.TauxCompressionJPeg) then
        begin
          IBMultimedia.DisableControls;
          //Cration d'un record
          IBMultimedia.Insert;

          //On ajoute l'image dans la base
          doAjoutImageInBase(TempPathFileNameJPEG);
          IBMultimedia.EnableControls;
        end;
    end;
end;

procedure TFBibliothequeMultimedia.doAjoutImageInBase(
  TempPathFileNameJPEG: string);
var
  ImageField: TField;
  Picture: TPicture;
  imageForVignette: TImage;
  MS: TMemoryStream;
begin
  if PutInEdition then
    begin
      IBMultimedia.FieldByName('MULTI_DATE_MODIF').AsDateTime := Now;

      ImageField := IBMultimediaMULTI_MEDIA;
      if ImageField <> nil then
        begin
          //DBGraphic.Visible := true;
         // TydxDBGraphicEdit(DBGraphic).AutoSize := true;

          //On ajoute l'image JPeg dans le blob
          Picture := TPicture.Create;
          try
            Picture.LoadFromFile(TempPathFileNameJPEG);
            SaveGraphicToBlobField(Picture.Graphic, ImageField);

          finally
            Picture.Free;
          end;

          {- Creation de la vignette -------------------------------------------------------------------}
          MS := TMemoryStream.Create;
          imageForVignette := TImage.Create(Self);

          imageForVignette.Width := 90;
          imageForVignette.Height := 106;

          try
            MakeVignette(TempPathFileNameJPEG, TempPathFileNameJPEG, imageForVignette, MS);
            MS.Position := 0;
            TBlobField(IBMultimediaMULTI_REDUITE).LoadFromStream(MS);

          finally
            FreeAndNil(imageForVignette);
            FreeAndNil(MS);
          end;
          {---------------------------------------------------------------------------------------------}

          IBMultimedia.Post;
        end;
    end;
end;

procedure TFBibliothequeMultimedia.doAjoutSons;
var MS: TMemoryStream;
begin
  iType := -1;
  if OpenDialogSons.Execute then

    begin
      IBMultimedia.DisableControls;
      iType := 2;
      IBMultimedia.Insert;
      IBMultimedia.FieldByName('MULTI_PATH').AsString := OpenDialogSons.FileName;

      MS := TMemoryStream.Create;

      try
        iSons.Picture.Graphic.SaveToStream(MS);
        MS.Position := 0;
        TBlobField(IBMultimediaMULTI_REDUITE).LoadFromStream(MS);

      finally
        FreeAndNil(MS);
      end;
      {---------------------------------------------------------------------------------------------}

      IBMultimedia.Post;
      IBMultimedia.EnableControls;
    end;
end;

procedure TFBibliothequeMultimedia.doAjoutVideos;
var MS: TMemoryStream;
begin
  iType := -1;
  if OpenDialogVideo.Execute then

    begin
      IBMultimedia.DisableControls;
      iType := 3;
      IBMultimedia.Insert;

      IBMultimedia.FieldByName('MULTI_PATH').AsString := OpenDialogVideo.FileName;

      MS := TMemoryStream.Create;

      try
        iVideo.Picture.Graphic.SaveToStream(MS);
        MS.Position := 0;
        TBlobField(IBMultimediaMULTI_REDUITE).LoadFromStream(MS);

      finally
        FreeAndNil(MS);
      end;
      {---------------------------------------------------------------------------------------------}

      IBMultimedia.Post;
      IBMultimedia.EnableControls;
    end;
end;
//-------------------------------------------------------------------------------------------------------

procedure TFBibliothequeMultimedia.sbCloseClick(Sender: TObject);
begin
  Close;
end;

end.
