{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Union_events_details;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, Buttons,
  u_comp_TBlueFlatSpeedButton, Db, IBCustomDataSet, IBQuery,
  IBUpdateSQL, IBStoredProc, dxCntner, dxEditor, dxEdLib, dxDBELib,
  dxExEdtr, TFlatButtonUnit, TFlatSpeedButtonUnit,
  u_objet_TGedcomDate, u_comp_TGoodBtn, Menus, u_comp_TYLanguage;

type
  TFUnionEventsDetails = class(TSuperForm)
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edDate: TdxDBEdit;
    edDept: TdxDBEdit;
    edCP: TdxDBEdit;
    edLieu: TdxDBEdit;
    edVille: TdxDBPickEdit;
    edPays: TdxDBEdit;
    edRegion: TdxDBEdit;
    edSubdi: TdxDBEdit;
    lbDay: TLabel;
    btnSearchVille: TGoodBtn;
    fbInfosDate: TGoodBtn;
    fbInfosVilles: TGoodBtn;
    fbPays: TGoodBtn;
    Label1: TLabel;
    btnVillesFavoris: TGoodBtn;
    pmDate: TPopupMenu;
    ibqToken: TIBQuery;
    ibqTokenTOKEN: TIBStringField;
    Language: TYLanguage;
    btnActe: TBlueFlatSpeedButton;
    IBMultimedia: TIBQuery;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    procedure btnSearchVilleClick(Sender: TObject);
    procedure edCPChange(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure edDateChange(Sender: TObject);
    procedure fbInfosVillesClick(Sender: TObject);
    procedure edVilleChange(Sender: TObject);
    procedure edDateExit(Sender: TObject);
    procedure btnVillesFavorisClick(Sender: TObject);
    procedure fbPaysClick(Sender: TObject);
    procedure fbInfosDateClick(Sender: TObject);
    procedure OnKeyDownHelp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnActeClick(Sender: TObject);
  private
    l_Dept, l_Pays, l_Region, l_Villes: TStringList;
    fFormIndividuUnion: TForm;
    procedure SetFormIndividuUnion(const Value: TForm);
    procedure doTestCoherence;
    procedure doShowDay;
    procedure up_SubMenu(Sender: TObject);

  public
    property FormIndividuUnion: TForm read fFormIndividuUnion write SetFormIndividuUnion;
    procedure DoRefresh(Mode: boolean);

    procedure doOnDateChange;
  end;

implementation

uses
  u_form_individu,
  u_dm,
  u_common_var, u_form_individu_Union, u_form_list_villes,
  u_form_Ville_Favoris, u_form_Pays, u_common_func, u_common_const,
  u_form_biblio_Multimedia_Edit;

{$R *.DFM}

{ TFIndividuIdentiteEventsDetails }


procedure TFUnionEventsDetails.SuperFormCreate(Sender: TObject);
var
  NewItem: TMenuItem;
  I: integer;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  lbDay.Caption := '';
  fFormIndividuUnion := nil;
  l_Dept := TStringList.Create;
  l_Pays := TStringList.Create;
  l_Villes := TStringList.Create;
  l_Region := TStringList.Create;

  ibqToken.Params[0].AsString := _Context.Langue;
  ibqToken.Open;
  i := 0;
  while not ibqToken.Eof do
    begin
      //pmDate.Items.Add (ibqToken.ParamByName('TOKEN').AsString);
      NewItem := TMenuItem.Create(Self);
      NewItem.Caption := ibqTokenTOKEN.AsString;
      pmDate.Items.Add(NewItem);
      pmDate.Items[i].OnClick := up_SubMenu;
      ibqToken.next;
      inc(i);
    end;

  ibqToken.Close;
end;

procedure TFUnionEventsDetails.up_SubMenu(Sender: TObject);
var sToken: string;
begin
  sToken := (sender as TMenuItem).Caption;

  if (not (TFIndividuUnion(fFormIndividuUnion).ibqEve.State in [dsEdit, dsInsert])) then
    TFIndividuUnion(fFormIndividuUnion).ibqEve.Edit;

  if edDate.text = '' then
    TFIndividuUnion(fFormIndividuUnion).ibqEve.FieldByName('EV_FAM_DATE_WRITEN').AsString := sToken
  else
    TFIndividuUnion(fFormIndividuUnion).ibqEve.FieldByName('EV_FAM_DATE_WRITEN').AsString := edDate.text + ' ' + sToken;

  edDate.SelStart := Length(edDate.text) + 1
end;

procedure TFUnionEventsDetails.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  l_Dept.Free;
  l_Pays.Free;
  l_Villes.Free;
  l_Region.free;
end;

procedure TFUnionEventsDetails.DoRefresh(Mode: boolean);
begin
  edDate.enabled := Mode;
  edCP.enabled := Mode;
  edVille.enabled := Mode;
  edDept.enabled := Mode;
  edPays.enabled := Mode;
  edSubdi.enabled := Mode;
  edLieu.enabled := Mode;
  edRegion.enabled := Mode;

  Label7.enabled := Mode;
  Label8.enabled := Mode;
  Label1.enabled := Mode;
  Label9.enabled := Mode;
  Label10.enabled := Mode;
  Label2.enabled := Mode;
  Label3.enabled := Mode;
  Label4.enabled := Mode;

  fbInfosDate.enabled := Mode;
  fbInfosVilles.enabled := Mode;
  btnVillesFavoris.enabled := Mode;
  fbPays.enabled := Mode;

  btnSearchVille.enabled := Mode;
end;

procedure TFUnionEventsDetails.SetFormIndividuUnion(const Value: TForm);
var
  PtrForm: TFIndividuUnion;
begin
  fFormIndividuUnion := Value;

  if Value <> nil then PtrForm := TFIndividuUnion(Value) else PtrForm := nil;

  edDate.DataSource := PtrForm.dsEve;
  edCP.DataSource := PtrForm.dsEve;
  edVille.DataSource := PtrForm.dsEve;
  edDept.DataSource := PtrForm.dsEve;
  edPays.DataSource := PtrForm.dsEve;

  edRegion.DataSource := PtrForm.dsEve;
  edSubdi.DataSource := PtrForm.dsEve;
  edLieu.DataSource := PtrForm.dsEve;
end;

procedure TFUnionEventsDetails.btnSearchVilleClick(
  Sender: TObject);
var aProc: TIBQuery;
begin
  aProc := TIBQuery.create(self);

  if (not (TFIndividuUnion(fFormIndividuUnion).ibqEve.State in [dsEdit, dsInsert])) then
    TFIndividuUnion(fFormIndividuUnion).ibqEve.Edit;

  try
    aProc.Database := dm.ibd_BASE;
    aProc.Transaction := dm.IBTrans_Secondaire;

    aProc.SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_CP(:I_CODE)');
    aProc.Params[0].AsString := edCP.Text;
    aProc.Open;

    edVille.Items.Clear;
    l_Dept.Clear;
    l_Pays.Clear;
    l_Villes.Clear;

    while not aProc.eof do begin
        edVille.Items.Add(aProc.FieldByName('VILLE').AsString);

        l_Villes.Add(aProc.FieldByName('VILLE').AsString);
        l_Dept.Add(aProc.FieldByName('DEPARTEMENT').AsString);
        l_Pays.Add(aProc.FieldByName('PAYS').AsString);
        l_Region.Add(aProc.FieldByName('REGION').AsString);

        aProc.next;
      end;

    if edVille.Items.Count > 0 then
      begin
        edVille.Text := edVille.Items.Strings[0];
      end;

    if edVille.Items.Count > 1 then
      begin
        edVille.DroppedDown := True;
      end;


    if l_Villes.Count > 0 then
      begin
        if (not (TFIndividuUnion(fFormIndividuUnion).dsEve.State in [dsEdit, dsInsert]))
          then TFIndividuUnion(fFormIndividuUnion).IBQEve.Edit;

        TFIndividuUnion(fFormIndividuUnion).IBQEveEV_FAM_VILLE.AsString := l_Villes[0];
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_DEPT.asString := l_Dept[0];
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString := l_Pays[0];
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_REGION.asString := l_Region[0];
      end;

    if edVille.Items.Count > 1 then
      begin
        edVille.DroppedDown := True;
      end;

  finally
    aProc.Free;
  end;

end;

procedure TFUnionEventsDetails.edCPChange(Sender: TObject);
begin
  edVille.items.Clear;
  l_Dept.Clear;
  l_Pays.Clear;
  l_Villes.Clear;
  l_Region.Clear;
  edDept.Text := '';
  edVille.Text := '';
  edPays.Text := '';
end;

procedure TFUnionEventsDetails.edDateChange(Sender: TObject);
begin
  doOnDateChange;
end;

procedure TFUnionEventsDetails.doOnDateChange;
begin
  if _GDate.DecodeHumanDate(TdxDbEdit(edDate).Text)
    then edDate.Font.color := clWindowText
  else edDate.Font.color := clRed;

  doShowDay;

  //  IBMultimedia.Params[0].AsInteger := dm.NumDossier;
  IBMultimedia.Params[0].AsInteger := TFIndividuUnion(fFormIndividuUnion).IBQEveEV_FAM_CLEF.AsInteger;
  //  IBMultimedia.Params[2].AsString := 'F';
  IBMultimedia.Open;

  btnActe.Visible := IBMultimedia.RecordCount > 0;

  IBMultimedia.Close;
end;


procedure TFUnionEventsDetails.doShowDay;
begin
  if _GDate.DecodeHumanDate(TdxDbEdit(edDate).Text) then
    begin
      if _GDate.KnowDate then
        begin
          lbDay.Caption := '(' + LongDayNames[DayOfWeek(_GDate.GDate.DateTime1)] + ')';
          lbDay.visible := true;
        end
      else lbDay.visible := false;
    end
  else
    begin
      lbDay.visible := false;
    end;
end;

procedure TFUnionEventsDetails.fbInfosVillesClick(Sender: TObject);
var
  aFListVilles: TFListVilles;
begin
  aFListVilles := TFListVilles.create(self);
  try

    if aFListVilles.ShowModal = mrOk then
      begin
        if not (TFIndividuUnion(fFormIndividuUnion).ibqEve.State in [dsEdit, dsInsert]) then
          TFIndividuUnion(fFormIndividuUnion).ibqEve.Edit;

        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_CP.asString := aFListVilles.Code;
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_VILLE.asString := aFListVilles.Ville;
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString := aFListVilles.Pays;
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_DEPT.asString := aFListVilles.Dept;
        TFIndividuUnion(fFormIndividuUnion).IBQEveEV_FAM_REGION.asString := aFListVilles.Region;
      end;
  finally
    aFListVilles.Free;
  end;
end;

procedure TFUnionEventsDetails.edVilleChange(Sender: TObject);

var
  k: integer;
begin
  //on recherche la ville dans la liste
  k := l_Villes.IndexOf(AnsiUpperCase(TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_VILLE.AsString));
  if k <> -1 then
    begin
      TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_DEPT.asString := l_Dept[k];
      TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString := l_Pays[k];
    end;
end;

procedure TFUnionEventsDetails.edDateExit(Sender: TObject);
begin
  doTestCoherence;
end;

procedure TFUnionEventsDetails.doTestCoherence;
var
  s: string;
  n: integer;
  SavePlace: TBookmark;
  FInd: TFIndividu;
begin
  if TFIndividuUnion(fFormIndividuUnion).IBQEve.Active then
    begin
      FInd := TFIndividu(TFIndividuUnion(fFormIndividuUnion).FormIndividu);

      FInd.CoherenceDate.Mariages.Clear;
      FInd.CoherenceDate.AutresEventUnion.Clear;

      //On reparcours tous les vnement famille
      SavePlace := TFIndividuUnion(fFormIndividuUnion).IBQEve.GetBookmark;
      try
        TFIndividuUnion(fFormIndividuUnion).IBQEve.FindFirst;
        for n := 1 to TFIndividuUnion(fFormIndividuUnion).IBQEve.RecordCount do
          begin
            s := TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('EV_FAM_TYPE').AsString;
            if s = 'MARR' then
              begin
                FInd.CoherenceDate.AddInfoDateWriten(
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('EV_FAM_DATE_WRITEN').AsString,
                  '',
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('EV_FAM_CLEF').AsInteger,
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('EV_FAM_KLE_FAMILLE').AsInteger,
                  FInd.CoherenceDate.Mariages,
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('_LONG_NAME_EVENT').AsString
                  );
              end
            else
              begin
                FInd.CoherenceDate.AddInfoDateWriten(
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('EV_FAM_DATE_WRITEN').AsString,
                  '',
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('EV_FAM_CLEF').AsInteger,
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('EV_FAM_KLE_FAMILLE').AsInteger,
                  FInd.CoherenceDate.AutresEventUnion,
                  TFIndividuUnion(fFormIndividuUnion).IBQEve.FieldByName('_LONG_NAME_EVENT').AsString
                  );
              end;

            TFIndividuUnion(fFormIndividuUnion).IBQEve.Next;
          end;

      finally
        TFIndividuUnion(fFormIndividuUnion).IBQEve.GotoBookmark(SavePlace);
        TFIndividuUnion(fFormIndividuUnion).IBQEve.FreeBookmark(SavePlace);
      end;

      FInd.CoherenceDate.Test;
    end;
end;

procedure TFUnionEventsDetails.btnVillesFavorisClick(Sender: TObject);
var
  aFVillesFavoris: TFVillesFavoris;
begin
  aFVillesFavoris := TFVillesFavoris.create(self);
  try
    aFVillesFavoris.Mode := True;
    if aFVillesFavoris.ShowModal = mrOk then
      begin

        if not (TFIndividuUnion(fFormIndividuUnion).ibqEve.State in [dsEdit, dsInsert]) then
          TFIndividuUnion(fFormIndividuUnion).ibqEve.Edit;

        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_CP.asString := aFVillesFavoris.Code;
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_VILLE.asString := aFVillesFavoris.Ville;
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString := aFVillesFavoris.Pays;
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_DEPT.asString := aFVillesFavoris.Dept;
        TFIndividuUnion(fFormIndividuUnion).IBQEveEV_FAM_REGION.asString := aFVillesFavoris.Region;

      end;
  finally
    aFVillesFavoris.Free;
  end;
end;

procedure TFUnionEventsDetails.fbPaysClick(Sender: TObject);
var
  aFPays: TFPays;
begin
  aFPays := TFPays.create(self);
  try
    if aFPays.ShowModal = mrOk then
      begin
        TFIndividuUnion(fFormIndividuUnion).ibqEve.Edit;
        TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString := aFPays.Pays;
      end;
  finally
    aFPays.Free;
  end
end;

procedure TFUnionEventsDetails.fbInfosDateClick(Sender: TObject);
var sPays: string;
begin
  if (TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString = 'DEPARTEMENT OUTREMER') or
    (TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString = 'TERRITOIRE OUTREMER') then
    sPays := TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_REGION.asString
  else
    sPays := TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_PAYS.asString;

  //  showmessage(spays);
  GotoThisURL('http://' + _Context.ChoixCartesInternet + '/pub/agent.dll?qscr=mmfn&plce1=' +
    TFIndividuUnion(fFormIndividuUnion).ibqEveEV_FAM_VILLE.asString + '%2C' + sPays + '&wpst1=1&rtbl=0&regn1=2&cnty1=4&subm=1&fmap=1&tpid=1&dchg=&zz=992108484196');

end;

procedure TFUnionEventsDetails.OnKeyDownHelp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  //     TFIndividu(TFIndividuUnion(fFormIndividuUnion).FormIndividu).TestIfHelp(Key);
end;

procedure TFUnionEventsDetails.btnActeClick(Sender: TObject);
var
  aFMultimediEdit: TFBiblio_Multimedia_Edit;

begin
  aFMultimediEdit := TFBiblio_Multimedia_Edit.create(self);
  try
    //    IBMultimedia.Params[0].AsInteger := dm.NumDossier;
    IBMultimedia.Params[0].AsInteger := TFIndividuUnion(fFormIndividuUnion).IBQEveEV_FAM_CLEF.AsInteger;
    //    IBMultimedia.Params[2].AsString := 'F';
    IBMultimedia.Open;

    aFMultimediEdit.doInitialise(IBMultimediaMULTI_CLEF.AsInteger,
      TFIndividu(TFIndividuUnion(fFormIndividuUnion).FormIndividu).aFIndividuIdentite.lTitre.Caption);

    Application.ProcessMessages;
    aFMultimediEdit.ShowModal;
    IBMultimedia.Close;
  finally
    aFMultimediEdit.Free;
  end;
end;

end.
